       ABS 
       ORG 0
       TITLE 'krexe'
* ********************************************************************
*  __________________________________________________________________
* |KREXE 168 04/02/82 - 4/20/1982 7:26PM                             |
* |==================================================================|
* ||                                                                ||
* ||   @@     @@@  @@@@@@@@    @@@@@@@@@@  @@      @@  @@@@@@@@@@   ||
* ||   @@    @@@   @@@@@@@@@   @@@@@@@@@@  @@      @@  @@@@@@@@@@   ||
* ||   @@   @@@    @@     @@@  @@          @@@    @@@  @@           ||
* ||   @@  @@@     @@      @@  @@           @@@  @@@   @@           ||
* ||   @@ @@@      @@     @@   @@             @@@@     @@           ||
* ||   @@@@@       @@@@@@@     @@@@@@@@@       @@      @@@@@@@@@    ||
* ||   @@@@@       @@@@@@@     @@@@@@@@@       @@      @@@@@@@@@    ||
* ||   @@ @@@      @@    @@@   @@             @@@@     @@           ||
* ||   @@  @@@     @@     @@@  @@           @@@  @@@   @@           ||
* ||   @@   @@@    @@      @@  @@          @@@    @@@  @@           ||
* ||   @@    @@@   @@      @@  @@@@@@@@@@  @@      @@  @@@@@@@@@@   ||
* ||   @@     @@@  @@      @@  @@@@@@@@@@  @@      @@  @@@@@@@@@@   ||
* ||                                                                ||
* ||                    Last edited: 82098.1349                     ||
* |==================================================================|
* |__________________________________________________________________|
*
         DEF  START+          ; power on interrupt vector
* set KANGA interrupt vector in case Kangaroo's in light
* sleep and KANGA can't write in the interrupt vector to
* the whole shebang.
         DEF  G.A125           ; where KANGA likes to go to.
         DEF  KEYSRV           ; keyboard interrupt vector
         DEF  PILTRP           ; PIL interrupt vector
         DEF  CMPSRV           ; comparator service routine
         DEF  SPAR0            ; barcode reader (unused)
         DEF  PWRSRV           ; Power detect service routine
         DEF  SPAR1            ; first spare (??)
         DEF  SPAR2            ; second spare (??)
* ***********************************************************
* *                                                         ;
* * Check for Diagnostic ROM (DINGO).                       ;
* *                                                         ;
* * Dingo must go in slot FF48, which is the rightmost slot *
* * on Kangaroo.  Fortunately, this is the slot that the    ;
* * development system has implemented.                     ;
* ***********************************************************
DIRG     ADDR  0FF38H          ; diagnostic rom slot
START+   BIN                   ;
         LDM  R30,=0,' '       ; clear lcd -- FAST!
         STMD R30,=LCD         ; (by mangy directive)
*
* ** invoke the diagnostic rom if it's there.
*
         STBD R30,=(ROM3EN)+1  ; disable system rom
         STBD R30,=DIAG        ; enable diagnostic slot
         LDMD R30,=R60K        ; get header
         CMM  R30,=RMHEAD      ; is it a header?
         IFEQ
           LDMD R30,=(ROM)+2+(DRENSZ)+2+(RM.ID) ; get id code
           ICM  R30            ; push FFFF to zero
           IFZR
             LDMD R30,=(ROM)+2+(DRENSZ)+2+(RM.INI) ; get init addr
             DCM  R30          ; go back one cause CPU increment
             STM  R30,R4       ; got there (store to CPU's instruction pointer register)
           ENDIF
         ENDIF
         STBD R#,=(DIAG)+1     ; disable diagnostic slot
         STBD R#,=ROM3EN       ; enable the system rom
         GTO START?            ; now do warm or colstart stuff
*
* ******************************************************
* CLRVA. the clear vars token
* ******************************************************
         DATA 241              ; CLEAR VARS attributes
CLRVA.   
         JSB  =DALLAL          ; deallocate everything (does BIN
         LDM  R40,=            ; name of calculator program
CALNAM   DATA  "calcprog"      ;
         JSB  =FPURGE          ; destroy the little critter!
         LDMD R12,=FWUSER      ; preapre to clear out the envs
         JSB  =RSETEN          ; reset environment pointers
         JSB  =SETCAL          ; setup new calculator env
         JSB  =STALLS          ; STALL out
UPSET    LDMD R0,=LWAMEM       ; reset high memory pointer
         STMD R0,=NXTRTN       ; GOSUB/RETURN stack pointer
         STMD R0,=LAVAIL       ;
         RTN                   ;
*
* ******************************************************
* SETCAL: creates the calculator program and
*         initializes the environment stack.
* ******************************************************
SETCAL   LDMD R40,=CALNAM      ; get the calcname
         LDM  R20,=TYCALC      ; set the type to basic
         JSB  =FCRNUL          ; create its replacement
         LDM  R76,=LEWYSZ      ; reset LEEWAY to initial
         STMD R76,=LEEWAY      ;   value
         CLB  R76              ;
         STBD R76,=XTNDLW      ;
*
* ** recreate the idle environment
*
         CLM  R76              ; start execute at line zero
         CLB  R15              ; set the system to idle
         JSB  =SYCALL          ; set up for execution of calc pr
         CLM  R20              ; prepare to zero out previous length to mark as bottom of sta
         STMD R20,X34,E.PREV   ; this should set the prev environment length in the current env to zero
         RTN                   ;
*
* ******************************************************
*         EXEC LOOP
* R17 = stall byte (if upper bit is set then kangaroo interpret loop will stall!
* R16 - Kangaroo status
*        0 IDLSTS Idle mode
*        1 CLCSTS Calculator mode
*        2 RUNSTS Running a program
*        3 DRCSTS deactivated environment
*
       TITLE 'krexe'
* BIT 0 = the key in KEYHIT is valid and uneaten.
* BIT 1 = I/O INTERRUPT     (Nope!)
* BIT 2 = TIMER 1 INTERRUPT (Not in Kangaroo!)
* BIT 3 = TIMER 2 INTERRUPT (NO)
* BIT 4 = TIMER 3 INTERRUPT (NO)
* BIT 5 = "other"
* BIT 6 = Power supply?
*
* ******************************************************
*
* ******************************************************
*    "This is the EXEC loop.  The main loop to acquire and
* execute commands.  There are millions of people out
* there and a half million programmers.  I am one of
* them.  I carry a manual.  My name is Roo-man."
*    "WOW that was dramatic, Roo-man," Joey said admiringly.
*    "Been taking lessons, Joey."
* ******************************************************
EXEC
         JSB  =BLIMP           ; blank out IMput buffer
         LOOP
           CLM  R16            ; start out fresh!
           JSB  =GETCMD        ;
           REN                 ; exit if it's a mode switcher
*          IF  B16#0
           TSB  R16              ; anything to do?
           JZR  nocrunch         ; jif no
           JSB  =CRUNCH          ; go crunch that code
nocrunch 
         WHMP       ; loop
*
CRUNCH   TSB  R17              ; errors already?
         JNG  CLBR16           ; if so return (r16<-0)
*
         JSB  =HANDI0          ; give the roms a chance
         VAL  V.CRUN           ; this is a CRUNCH event
*
         JSB  =SAVEME          ; save us from rom switching
* setup R10 and PCR, possibly enable a ROM that the BASIC program's in
* (that's why we did the SAVEME!)
         JSB  =RESTEN          ; setup
         JMP  INTRP            ; go run it
*
         LOOP
           LOOP
             CLM  R20            ; just to be safe
             POBD R20,+R10         ; fetch next instruction
             STBD R20,=TOKEN       ; save token for handi tests
             BIN                   ;
             LLM  R20              ; double the token
             LDMD R20,X20,BTAB.R   ; get address of routine
*
* note that many tokens assume a DRP of 20 and BCD mode!
*
             BCD                   ;
             JSB  X20,ZRO          ; call the ROOtine ??
INTRP        TSB  R17              ; is the stop bit set?
            WHPS
            JSB  =REPRT+          ; report error, set R17 as need
*
* R17_out = R17_in if no error
* R17_out = set if error but n
* R17_out = clear if error and
*
           JSB  =SPY             ; test for abort conditions
           TSB  R17              ; abort?
         WHPS
         JSB  =SAVENV          ; save cur state of cur environment
CLBR16   
         JSB  =TMRSS           ; suspend the timers
*
         JSB  =HANDI0          ; tell ROMs that we're STALLing
         VAL  V.STAL           ;
*
* That is the ROM hook for STOP, END and anything that might
* "stall-out" a program (calc included). ROM must ask if there
* were errors to distinguish from an aborted run.
*
         JSB  =REMDAC          ; remove "useless" environments
         CLM  R16              ; set idle, kill stop bit
         STBD R16,=RUNING      ; store in the RUNING flag
         JSB  =ANN.P-          ; clear annunciators, etc.
SETR12   LDMD R12,=TOS         ; reset R12 (if stuff left on stack!)
         RTN                   ;
*
* ******************************************************
* GETALN
* This is where BASIC goes (always!) to get input from the keyboard.
* Various parameters to GETREP are stored in a block in RAM and may
* be altered during a program's execution.
* Examples of such altering are:
*   Inserting line #s for automatic line numbering.
*   Getting a line via FETCH or up/down arrow.
*   Syntax error correction.
* The routine GETREP reports errors (if any) and then gets input
* by calling GETLN
* ******************************************************
GETALN   LDMD R20,=GL.LIN      ; get line position
         LDMD R22,=GL.CUR      ; cursor position
         LDBD R24,=GL.LEN      ; initial line length
         JSB  =GETREP          ; report errors, read the line
*
* Initialize the GETLN parameters
*
INITGL   LDM  R2,=INPBUF       ; address of input buffer
         STMD R2,=GL.LIN       ; line position
         STMD R2,=GL.CUR       ; cursor position
         CLB  R2               ;
         STBD R2,=GL.LEN       ; initial line length
         RTN                   ;
*
* ******************************************************
* GETCMD - Get BASIC command input
* This is where we come to get a BASIC command line or a program line.
* Upon return:
*     E=1 if a mode switching key was seen
*     E=0 if no such key seen
* NOTE: "In the following code we were swayed by the dark side of the
*  force to do its bidding!  Yes, Joey, we upstanding examples of
*  programmers, the epitome of program artists, have sunk so low that
*  in the next few lines we will be decentralizing the values for the
*  filetype.  And this for the measly price of one lousey byte, Joey!"
*
*  Joey looked up, tears welling up in his eyes.  "But, Roo-man, how
*  could we?
*
*  "There comes a time when we must do things that we don't like for the
*  good of the whole.  We will continue to strive for the good of ALL
*  mankind.  This is not just our lot in life, this is our destiny!"
*
*  Suddenly, a strange haze, a twirl of twinkling lights, is seen
*  descending upon our heroes.  The very indentation style changes.
*  For several moments, all is quiet.  Then:
*
*  "G-g-gosh, Roo-man, I feel strange!"
*
*  "What's happened to us, Joey?  It's as if something had taken control
*  of our minds!"
*
*  "I seem to remember something about d-decentralizing, but... I don't
*  remember anything about it now!  What IS it, Roo-man?"
*
*  "I don't know, son; I just don't know..."
*
*  Far away, a chuckle is heard emerging from the twisted lips of a
*  shadowy figure.  "The fools!  I'll destroy what little mind that
*  Roo-man has left!  And his mangy little kid, too!"
*  "Ha ha ha ha ha ha ha ha ha ha ha ha ha ha ha!!!"
* ******************************************************
GETCMD   JSB  =REPORT          ; report them errors
         JSB  =HANG            ; wait for previous output
         LDB  R32,=76          ; ')' assume basic prompt
         LDBD R3,=EDTYPE       ; what is workspace type?
         ANM  R3,=TYRUN?       ; get the type name
         IFZR                  ; if basic
           LDB  R32,=72          ; ':' get text mode prompt
         ENDIF
         JSB  =OUTCHR          ; spit out prompt
         JSB  =DOAUTO          ; handle auto line numbering
         JSB  =GETALN          ; get an input line
*
* ** handle terminating key for command input
*
DOCMD
         JSB  =MODE?           ; a mode switcher?
         REN                   ; jif yes, exit
         DRP  R25              ; search for the character in R25
         JSB  =LOOKUP          ; search for R25 in KEYS
         DEF  KEYS             ; search here
         JSB  X0,ZRO           ; call the subroutine
         CLE                   ; indicate not a mode switcher
         RTN                   ;
*
* ** table of terminators
*
KEYS     VAL  ATTNKY           ; ATTNKY
         DEF  UNAUTO           ; attention key
         VAL  DOWNKY           ; DOWNKY
         DEF  DWNARR           ; down arrow
         VAL  (DOWNKY)+(SHIFT) ; DOWNKY+SHIFT
         DEF  ALLDWN           ; shift-down arrow
         VAL  UPKEY            ; UPKEY
         DEF  ONE_UP           ; up arrow
         VAL  (UPKEY)+(SHIFT)  ; UPKEY+SHIFT
         DEF  ALLUP            ; shift-up arrow
         VAL  RUNKEY           ; RUNKEY
         DEF  RUNKEE           ; run key
         VAL  FTCHKY           ; FTCHKY
         DEF  FETXY            ; fetch key
         VAL  STEPKY           ; STEPKY
         DEF  DOSTEP           ; step key
         DATA  0               ; end of table
         DEF  OTHER            ; anything else (such as CR)
*
*
OTHER    JSB  =PARSER          ; parse the statement
         IFEN
           JSB  =REPORP        ; report parsing error
           CLM  R16            ; put us in idle
           RTN                 ;
         ENDIF
         CMB  R16,=CLCSTS      ; in calculator mode?
         IFEQ
           STB  R16,R15          ; set up for allocation
           CLB  R16              ; set failure status
           LDMD R40,=CALNAM      ; filename = calc program
           CLM  R76              ; start line zero
           JSB  =SYCALL          ; setup for run, go to it
                                 ; the end statement in calc pro
                                 ; should restore the current pr
         ENDIF
         RTN                   ;
*
* ******************************************************
* HANG: If the flag LETSEE is set, then there's some output on the LCD
* that we should wait to let the user see it.
* ******************************************************
HANG     LDBD R2,=LETSEE       ; anything to see?
         IFNZ                  ; if so:
           JSB  =UNSEE           ; nothing to see now!
           JSB  =SIGNIF          ; wait for a key
         ENDIF
         RTN                   ;
*
* ******************************************************
* DOAUTO: auto line number prefixing
* Put a line number into the input buffer if auto line numbering is active.
* AUTOI:  increment for automatic line numbering.
*         If AUTOI is zero, then line numbering is not currently active.
* CURLN#: the current line number.
* ******************************************************
DOAUTO   LDBD R76,=GL.LEN      ; is something already there?
         RNZ                   ; if so, don't do auto
         LDMD R76,=AUTOI       ; line numbering active?
         RZR                   ; abort if not active
         BCD                   ; for the add
         ADMD R76,=CURLN#      ; new = old + increment
         JSB  =EDLIN-          ;
         RTN                   ;
*
* ******************************************************
* CONBIN: convert binary to floating
* entry: binary number in R36/37
* exit:  floating point number in R40/47
* registers used: R32,33,34,35
* Upon exit, might be BIN or BCD, who knows!?
* ******************************************************
CONBIN   BIN                   ;
         CLE                   ;
         CLM  R40              ; clear output
         TSM  R36              ; check input
         RZR                   ; trap zero (would die in NLOOP)
         JPS  POSTIV           ; check for negative (jif positive)
         LDB  R41,=9C          ; set sign digit
         TCM  R36              ; make positive except for 32768
         TSM  R36              ; must test to clear carry/overflow
         JPS  POSTIV           ; jump if not 32768
         LDM  R45,=80C,76C,32C ; create answer
         LDB  R40,=4           ; add exponent
         RTN                   ; done
*
POSTIV   LDM  R32,=(DIV10_EXE).2   ; get address of constants
* ** the following lines save 170 cycles if n<100
         CMM  R36,=(100D).2    ; is R36 < 100?
         IFPS
           LDM  R32,=(DIV10K).2 ; use big divisor
         ENDIF
CONLOP   POMD R34,+R32         ; get next constant
         DRP  R36              ; save code
         JOD  ONES_EXE         ; jump out if odd: end of table
         BIN                   ;
         DCE                   ; preset E=-1 (ELM makes E=0)
         ARP  R34              ;
         LOOP
           SBM  R#,R#          ; subtract out 10^N
           ICE                 ; count up
         WHPS                  ; while we can still substract
         ADM  R#,R#            ; subtracted one too far, put it back
         BCD                   ; need for the E shifts
         ELM  R45              ; push into R45/47(BCD)
         JMP  CONLOP           ; get next
*
ONES_EXE DRP  !36
         ERB  R36               ; DRP=36, get remainder to 3
* ** must be bcd so we need >=1 pass thru divide
         ELM  R45              ; shift into result
         LDB  R40,=5           ; maximum exponent+1
         LOOP
           DCB  R40            ; decrement exponent for each LZ
           LLM  R45            ; shift out leading zeros
                   ; go back if more leading zeros
         WHLZ
         RTN                   ;
*
DIV10K   DEF  TENTHOUS         ;
         DEF  ONETHOUS         ;
         DEF  ONEHUND          ;
DIV10_EXE
         DEF  RM.INI           ;
         DATA 1                ; an odd number for end of table
*
* ******************************************************
* The philosophy that is used here (dictated by managerial directive)
* is for the FETch key to act as a typing aid, printing the word FETCH
* and waiting for the user to type in a line# and a CR.  If he just
* types CR, then the current line will be fetched.
* ******************************************************
FETXY    LDM  R2,=INPBUF       ; address of input buffer
         LDM  R42,="FETCH "
         PUMD R42,+R2          ; place str in input bufr
         STMD R2,=GL.CUR       ; input cursor position
         LDB  R2,=6D           ; length of "FETCH "
         STBD R2,=GL.LEN       ; input initial length
*
* UNAUTO: Turn off auto line numbering by setting AUTOI:=0
*
UNAUTO   CLM  R2               ;
         STMD R2,=AUTOI        ; zero out AUTOI
URTN     RTN                   ;
*
* ******************************************************
* Move one program line down (forward) and display that line.
* The end of the program is marked by a special flag linenumber ENDLIN.
* ******************************************************
DWNARR   JSB  =UNAUTO          ; disable auto line #ing
         BCD                   ; for the increment
         LDMD R76,=CURLN#      ; current line number
         ICM  R76              ; next line!
         JSB  =FNDLED          ; get that (or next) line
         JSB  =CHKEND          ; end-of-program line?
         JZR  ALLDWN           ; jif yes
         JMP  OUTLIN           ;
*
* ******************************************************
* The shift-up arrow moves us to the beginning of the
* current program and displays it.
* ******************************************************
ALLUP    JSB  =UNAUTO          ; disable auto line #s
         LDMD R36,=EDFILE      ; program control block
         ADM  R36,=(PCBLEN).2  ; point to 1st line
         JMP  OUTLIN           ; out she goes!
*
* ******************************************************
* The shift-down arrow moves us to the *end* of the
* current program and displays the line.
* ******************************************************
ALLDWN   LDM  R76,=ENDLIN      ; get special flag line#
         JMP  F1               ;
*
ONE_UP   LDMD R76,=CURLN#      ; the current line number
F1       JSB  =UNAUTO          ; disable auto line nums
         JSB  =PREFND          ; find line before us
         STM  R24,R36          ; setup last line for output
*
* WARNING: falls through!
*
* ******************************************************
* The routine OUTLIN prints out the line pointed to by
* R36/37 unless it is the special last line flag ENDLIN.
* ******************************************************
OUTLIN   LDM  R24,R36          ; get ointer into R24
         POMD R45,+R24         ; get line number & length
         CMMD R45,=BASEND      ; ending line?
         REQ
         LDM  R36,R45          ; get line# into R36
         STMD R36,=CURLN#      ; save current line#
         LDM  R30,=INPBUF      ; decompile in INPBUF
         LDBD R67,=EDTYPE      ; how shall we decompile it
         JSB  =DECOPR          ; this will return with R17 tested for errors
         RNG                   ; abort if errors
         LDM  R26,=INPBUF      ; address of input buffer
         SBM  R30,R26          ; put line's length in R30
         STBD R30,=GL.LEN      ; assume length <= 255
*
* ** let's position the cursor just after the line number
*
         LOOP
           POBD R20,+R26       ; get the byte there
           JSB  =DIGIT         ; is it a digit? (DRP/ARP unchanged)
         WHEN                  ; yes, get another character
         POBD R#,-R#           ; get back to the non-digit
         STMD R26,=GL.CUR      ; cursor := location of the blank
         RTN                   ;
*
* ******************************************************
* REPORP: report parsing errors
* This entails re-displaying the input line with the cursor
* over the point at which the parsing failed.
*
* To recover the error message, the shift-FETCH key must be pressed.
*
* The actual reporting of the parsing error will occur when a call
* to getlin is done.  All this routine has done is setup up the
* parameters for the display of the offending line.
*
* INPUT:
*   R10 points one past the error.
*   LASTCH is still set from GETLN
* ******************************************************
REPORP   DRP  R10              ;
REPRP#   BIN                   ;
         CMM  R#,=INPBUF       ; already at the start?
         IFNE                  ; if not at start
            DCM  R#               ; R10 was a stack, so it pointed 1 too far
         ENDIF
         STMD R#,=GL.CUR       ; place cursor there
         LDMD R2,=OLDLST       ; get old line length
         SBM  R2,=((INPBUF)-1).2 ; get length
         STBD R2,=GL.LEN       ; save it
         RTN                   ; done
       TITLE 'krkey'
*  __________________________________________________________________
* |IVKEY 253 05/10/82 - 5/13/1982 3:46PM                             |
* |==================================================================|
* ||                                                                ||
* ||   @@@@@@@@@@  @@      @@  @@     @@@  @@@@@@@@@@  @@      @@   ||
* ||   @@@@@@@@@@  @@      @@  @@    @@@   @@@@@@@@@@  @@      @@   ||
* ||       @@      @@      @@  @@   @@@    @@          @@      @@   ||
* ||       @@      @@      @@  @@  @@@     @@          @@@    @@@   ||
* ||       @@       @@    @@   @@ @@@      @@           @@@  @@@    ||
* ||       @@       @@    @@   @@@@@       @@@@@@@@@      @@@@      ||
* ||       @@       @@    @@   @@@@@       @@@@@@@@@       @@       ||
* ||       @@        @@  @@    @@ @@@      @@              @@       ||
* ||       @@         @@@@     @@  @@@     @@              @@       ||
* ||       @@         @@@@     @@   @@@    @@              @@       ||
* ||   @@@@@@@@@@      @@      @@    @@@   @@@@@@@@@@      @@       ||
* ||   @@@@@@@@@@      @@      @@     @@@  @@@@@@@@@@      @@       ||
* ||                                                                ||
* ||                    Last edited: 82098.1329                     ||
* |==================================================================|
* |__________________________________________________________________|
*
* ******************************************************
* KEYBOARD INTERRUPT SERVICE ROUTINE - last edit 820908.1329
* This file contains the keyboard interrupt service routine.
*
* It is entered when the keyboard interrupts.  It gets the key
* and puts the ASCII into KEYHIT for the char editor to examine.
*
* The character editor does all the real work of echoing and
* backspacing and CAP LOCK and all that.
*
* Register useage in the keyboard routines:
* R20    : keyboard status byte (contains SHIFT/CONTROL info)
* R21    : raw keycode and later ASCII
* R30/31 : temporary useage
* R2/3   : temporary useage
* ******************************************************
* R30/31 : temporary useage
* R2/3   : temporary useage
* ******************************************************
KEYSRV   SAD                   ; save decimal/bin status
         BIN                   ; we really do need it
         PUMD R2,+R6           ;
         JSB  =AWAKE!          ; get us fully awake!
         PUMD R20,+R6          ; save R20/21
         LDMD R20,=KEYSTS      ; get the keycode
         JSB  =INTBGN          ; call intercept
         PUMD R30,+R6          ; save R30/31
* ** We now stop continuous alarms when a key is pressed.
* ** See CNTRIG (Pocked Secretary) for details.
         CLB  R30              ; get a zero
         STBD R30,=CNALRM      ; stop continuous alarms
         JSB  =TRKEY           ; translate R20/21 to ASCII
         LDB  R2,R21           ; get key here for PUTKEY
         JSB  =PUTKEY          ; make R2 the current key
         POMD R30,-R6          ; restore R30/R31
         POMD R20,-R6          ; restore R20/R21
         LDB  R2,=2            ; get an end-of-job code
         STBD R2,=KEYSTS       ; send EOJ to the hardware
         POMD R2,-R6           ; had to even save R2/3!
         PAD                   ; and the deimal mode???!
         RTN                   ;
*
* ******************************************************
* TRKEY - Translate the raw keycode to ASCII
* The table RAWNUM (indexed by hardware code) yields 3 types of keys:
*
* NONASC: These keys are >=128, (hence non-ASCII) and are things
*    like ATTN, LOCK, TIME, etc.  We later apply SHIFT/CNTL to their
*    bits 5 & 6.
* ISALFA:  These are the alphatbetic keys.  RAWNUM yields their
*    lowercase value.  We later apply SHIFT/CNTL to get shifted
*    and controlled values.
* REGASC: These are the rest of the ASCII keys, such as *,&,",etc.
*    RAWNUM yields an index into the KEYTAB which tells us about them.
*
* Input:  R20 = keyboard status byte
*         R21 = raw keycode as given by hardware
* Output: R21 = ASCII key
* ******************************************************
TRKEY    LDB  R30,R21          ; low bits of offset
         LRB  R30              ; knock out bit 0
         CLB  R31              ; high bits of offset
         LDBD R21,X30,RAWNUM   ; get a key number for it
         JNG  NONASC           ; non-asciis are negative
         CMB  R21,='a'         ; ('a') within alphabetics?
         JNC  REGASC           ; no
         JMP  ISALFA           ; it's an alphabetic
*
* ******************************************************
* Just two little routines that determine if the SHIFT or CONTROL
* keys were pressed.  Upon exit, ZeRo means the key was down,
* NotZero means the key was up.  OUTPUT: DRP=3
* ******************************************************
SHIFT?   LDB  R3,=BIT#2        ; bit 2 <-> SHIFT status
         JMP  ONEF             ;
CNTL?    LDB  R3,=BIT#3        ; bit 3 <-> CNTL status
ONEF     ANM  R#,R20           ; check the bit of status
         RTN                   ;
*
* ******************************************************
* The non-ASCII keys have the following code:
*   BIT  76543210
*        1CSnnnnn
* The high bit indicates a non-ASCII key, bit6 indicates CONTROL,
* bit5 indicates SHIFT, and bits 4-0 indicate a key number.
*
* NOTE: We do this tedious ORing jazz instead of an RDB to set
* the CNTL/SHIFT flags so that the NO-OP (377) won't screw up
* if CNTL/SHIFT is added to it.
* ******************************************************
NONASC   JSB  =CNTL?           ; control key down?
         IFZR
           LDB  R#,=100          ; get CNTL bit
           ORB  R21,R3           ; set control bit
         ENDIF
         JSB  =SHIFT?          ; is shift down?
         IFZR
           LDB  R#,=SHIFT        ; get SHIFT bit
           ORB  R21,R3           ; set the SHIFT bit
         ENDIF
         RTN                   ;
*
* ISALFA: process an alphabetic key
*
ISALFA   LDBD R2,=CAPLOK       ; get keyboard status
         DCB  R2               ; was it 1? (CAPS LOCK?)
         IFZR                  ; if it was caps lock
           SBB  R21,=40        ; clear lower case bit.
         ENDIF
         JSB  =SHIFT?          ; shift key down?
         IFZR                  ; if it is
           LDB  R#,=BIT#5      ;
           XRB  R21,R3         ; flip the shift bit
         ENDIF
         JSB  =CNTL?           ; CNTL key down?
         IFZR                  ; if it is
           ANM  R21,=00011111B ; strip high bits to indicate CNTL key
         ENDIF
* ******************************************************
* Numeric pad processing
* Now, if we've got a lower case alphabetic and we're in numeric pad
* mode, translate the appropriate keys into numbers.  Make all other
* alphabetics into beeping NOPs.
* ******************************************************
         LDBD R2,=CAPLOK       ; get keyboard status
         CMB  R2,=KY.PAD       ; pad mode?
         RNE                   ; no, exit.
* ** if JUSTSO is set, ignore the numeric pad conversion
         JSB  =LIT?            ; should we ignore functions?
         ROD                   ; exit if we should
         CMB  R21,='a'         ; 'a' check for lower case alphas
         RLO                   ; too small?
         CMB  R21,='z'+1       ; ('z'+1) too big?
         RHS                   ; exit if so.
* ** It's a lowercase alphabetic.  Now translate it.
         LDM  R2,=(PADTBL).2   ; get address of table
         STM  R20,R30          ; save the target in R31
         LOOP
           DRP !20
           POMD R20,+R2        ; get next match, translation
           RNG                 ; exit if end of table (377 or 375)
           CMB  R20,R31        ; a match?
         WHNE
         RTN                   ;
*
PADTBL   DATA  "m0j1k2l3u4i5o6" ;
         DATA  0FFH             ; end of the table
         DATA  375              ; the reject value
*
* ******************************************************
* The non-alpha ASCIIs such as +-=@*$ are gotten by a look-up
* table of the form:
*   byte1, byte2, byte3      for each key
* where:
*   byte1 is the normal entry
*   byte2 is the shifted entry
*   byte3 is the control entry
* If both SHIFT & CONTROL are pressed, it is as if only
* CONTROL was pressed.
* ******************************************************
REGASC   STB  R21,R2           ; save R21 here.
         ADB  R21,R2           ; R21=R21*2
         ADB  R21,R2           ; R21=R21*3
         JSB  =CNTL?           ; control key hit?
         IFZR                  ; if it is
           ICB  R21            ; look at the 3rd
           ICB  R21            ;    entry in the table
         ELSE
           JSB  =SHIFT?        ; is the shift key down?
           IFZR
              ICB  R21         ; get byte2, not byte1
           ENDIF
         ENDIF
         CLM  R30              ; clear R31
         LDB  R30,R21          ; form a 2-byte offset
         LDBD R21,X30,KEYTAB   ; get the key
         RTN                   ; that's it!
*
* ******************************************************
* If a value in RAWNUM:
*   is FF then it's a dummy no-op entry.
*   has the high bit set then it's a non-ascii key.
*   is between 'a'<=x<='z' then it's an alphabetic.
*   is anyting else it's a regular ascii key like %
*     and we give an index into KEYTAB
* ******************************************************
RAWNUM   DATA  0FFH,0FFH,0FFH,17D,0FFH,0FFH,0FFH,20D       ; column 7
         DATA  16D,0FFH,0FFH,RUNKEY,0FFH,0FFH,0FFH,0FFH 
         DATA  0FFH,0FFH,0FFH,13D,0FFH,0FFH,0FFH,19D       ; column 6
         DATA  'l',0FFH,0FFH,14D,0FFH,0FFH,0FFH,0FFH
         DATA  0FFH,10D,0FFH,12D,0FFH,CLRKEY,0FFH,22       ; column 5
         DATA  'p',9D,0FFH,TABKEY,0FFH,DELKEY,0FFH,11D 
         DATA  0FFH,'b',0FFH,'z',0FFH,'m',0FFH,'c'         ; column 4
         DATA  0FFH,'n',0FFH,'x',0FFH,15D,0FFH,'v'
         DATA  0FFH,'g',0FFH,'a',0FFH,'j',0FFH,'d'         ; column 3
         DATA  LOCKKY,'h',0FFH,'s',0FFH,'k',0FFH,'f'
         DATA  0FFH,'y',0FFH,'w',0FFH,'i',0FFH,'r'         ; column 2
         DATA  'q','u',0FFH,'e',0FFH,'o',0FFH,'t' 
         DATA  0FFH,5,0FFH,1,0FFH,7,0FFH,3                 ;column 1
         DATA  0,6,0FFH,2,0FFH,8D,0FFH,4 
         DATA  ATTNKY,LEFTKY,0FFH,APPTKY,0FFH,I/RKEY,0FFH,UPKEY ; column 0
         DATA  TIMEKY,RGHTKY,0FFH,EDITKY,0FFH,FTCHKY,0FFH,DOWNKY 
*
* ******************************************************
* KEYTAB: translate non-alpha ASCIIs
* ******************************************************
KEYTAB   DATA  '1','!',`1`      ; key 0 1 ! 1
         DATA  '2','"',`2`      ; key 1 2 " 2
         DATA  '3','#',`3`      ; key 2 3 # 3
         DATA  '4','$',`4`      ; key 3 4 $ 4
         DATA  '5','%',`5`      ; key 4 5 % 5
         DATA  '6','&',`6`      ; key 5 6 & 6
         DATA  '7',"'",'`'      ; key 6 7 ' `
         DATA  '8','(',1FH      ; key 7 8 ( 37=checkboard
         DATA  '9',')',7FH      ; key 8 9 ) 177=lazy-T
         DATA  '0','[',`0`      ; key 9 0 [ 0
         DATA  '-',']','_'      ; key 10 - ] _
         DATA  '+','@',1CH      ; key 11 + @ 34=SIGMA
         DATA  '*','^','~'      ; key 12 * ^ ~
         DATA  ';',':',1EH      ; key 13 ; : 36=pound sterling
         DATA  '=','|',1DH      ; key 14 = | 35=not-equal
         DATA  ',','<','{'      ; key 15 , < {
         DATA  '.','>','}'      ; key 16 . > }
         DATA  '/','?','\'      ; key 17 / ? \
         DATA  BS,BS,ESC        ; key 18 back
         DATA  CR,CR,CR         ; key 19 return
         DATA  ' ',' ',0        ; key 20 SP,SP,NUL
       TITLE 'krcmp'
*  __________________________________________________________________
* |KRCMP 77 06/24/82 - 7/12/1982 4:55PM                              |
* |==================================================================|
* ||                                                                ||
* ||   @@     @@@  @@@@@@@@       @@@@     @@      @@  @@@@@@@@     ||
* ||   @@    @@@   @@@@@@@@@    @@@@@@@@   @@@    @@@  @@@@@@@@@    ||
* ||   @@   @@@    @@     @@@  @@@    @@@  @@@@  @@@@  @@     @@@   ||
* ||   @@  @@@     @@      @@  @@      @@  @@@@@@@@@@  @@      @@   ||
* ||   @@ @@@      @@     @@   @@          @@  @@  @@  @@     @@@   ||
* ||   @@@@@       @@@@@@@     @@          @@  @@  @@  @@@@@@@@@    ||
* ||   @@@@@       @@@@@@@     @@          @@      @@  @@@@@@@@     ||
* ||   @@ @@@      @@    @@@   @@          @@      @@  @@           ||
* ||   @@  @@@     @@     @@@  @@      @@  @@      @@  @@           ||
* ||   @@   @@@    @@      @@  @@@    @@@  @@      @@  @@           ||
* ||   @@    @@@   @@      @@   @@@@@@@@   @@      @@  @@           ||
* ||   @@     @@@  @@      @@     @@@@     @@      @@  @@           ||
* ||                                                                ||
* ||       Finished on: 12/16/81 Raan Last edited: 82098.1356       ||
* |==================================================================|
* |__________________________________________________________________|
*
* ******************************************************
* ENTRY POINTS:
*    (Note: "comparator" means the actual compartor and teh associated table of values.)
*
* 	CMPCHK	Check and service comparator device
* 	CMPDSA	Disable compartor interrupt
* 	CMPENA	Enable compartor interrupt
* 	CMPENT	Insert entry in comparator table
* 	CMPSET	Initialize comparator on power up
* 	CMPSRV	Comparator interrtup service routine
*
* ******************************************************
* SUBROUTINE CMPSRV:
* This routine will process the comparator interrupt by determining
* the source of the value in the comparator (ie. appt. timer, rollover,
* timeset, etc.).  It will then set the appropriate flags to indicate
* the necessary action by the background routines, load the next value
* into the comparator, reenable interrupt, and return.  In the case of
* rollover, the table values and TMBASE are ajusted to reflect the clock.
*
* OUTPUT: BIN or BCD
* 	[CMPFLG]  updated comparator device service flags
* 	[SVCWRD]  comparator needs service flag
*
* REGISTERS:
* 	R02/03  scratch
* 	R06/07	stack pointer
* 	R20/21	comparator table pointer
* 	R40		scratch
* 	R41/47	table value
* 	R50		scratch
* 	R51/57	table increment and flag values
*
* ROUTINES USED:
* 	CMPDSA, *AWAKE, CMPINT, SVCSET, TMRRLV, CMPLD, CMPENA	
*
* ******************************************************
* 	CMPDSA, *AWAKE, CMPINT, SVCSET, TMRRLV, CMPLD, CMPENA	
*
* ******************************************************
CMPSRV   SAD                   ; Save status
         PUMD R2,+R6           ; save R02/03
         JSB  =CMPDSA          ; Disable interrupt
         JSB  =AWAKE!          ; Wake up, machine
         JSB  =CMPINT          ; Compartor intercept (will normally return unless someone has grabbed it)
         BIN                   ; Ensure binary mode
         PUMD R40,+R6          ; Save R40/47
         PUMD R50,+R6          ; Save R50/57
         CLM  R50              ; Clear increment
         PUMD R20,+R6          ; Save R20/21
         CLM  R20              ; Clear table pointer
         LDBD R20,=CMPPNT      ; Get comparator id
         IFNZ                  ; if not rollover
           LDB  R2,=(80H).2    ; bit mask to set
  i        JSB  =SVCSET        ; set comparator bit
           LDMD R51,X20,ROLOVR ; get device flag, inc
           CMB  R20,=CT.ADJ    ; time adjust?
           IFZR                ; yes
             LDMD R51,=TMEINC  ; get time adjust inc
             LDB  R57,=ADJFLG  ; get adjust flag
           ENDIF
           LDBD R3,=CMPFLG       ; get comparator flags
           ORB  R3,R57           ; set device flag
           STBD R3,=CMPFLG       ; return comparator flags
           CLB  R57              ; clear flag
           TSM  R51              ; test for increment
           IFNZ                  ; yes
             LDMD R41,X20,CMPTBL   ; get last comp value
             ADM  R51,R41          ; add to increment
           ENDIF
         ELSE
           LDMD R50,=RTC         ; get current time
           LDB  R50,=CLRCLK      ; get clear clock flag
           STBD R50,=RTC         ; clear RTC
           CLM  R56              ; clear clock garbage
           LDMD R43,=WDBRIC      ; get wait+ stop time
           SBM  R43,R51          ; adjust for rollover
           STMD R43,=WDBRIC      ; save new stop  time
           LDMD R41,=TMBASE      ; get current time base
           ADM  R41,R51          ; add RTC to time base
           STMD R41,=TMBASE      ; return rew time base
           LOOP
             ADM  R20,=(TBLINC).2 ; start with appointment
             LDMD R41,X20,CMPTBL ; get table entry value
             IFNZ                ; if need to adjust entry
               CMM  R41,R51      ; rollover >= entry?
               IFCY              ; yes
                 CLM  R41        ;
                 ICM  R41        ; build minimum table value
               ELSE
                 SBM  R41,R51    ; adjust for rollover
               ENDIF
               STMD R41,X20,CMPTBL ; return new value
             ENDIF
             CMM  R20,=(TBLEND).2  ; last entry?
           WHNC                ; no do next one
           JSB  =TMRRLV          ; adjust timers for rolovr
           CLM  R20              ; restore table pointer
           LDMD R51,=ROLOVR      ; load rollover
         ENDIF
         DRP !51
         JSB  =LDCMP           ; Load comparator
         POMD R20,-R6          ; Restore R20/21
         POMD R50,-R6          ; Restore R50/57
         POMD R40,-R6          ; Restore R40/47
         JSB  =CMPENA          ; Enable interrupt
         POMD R2,-R6           ; Restore R02/03
         PAD                   ; Restore status
         RTN                   ;
*
* ******************************************************
* NOTE: Address 'ROLOVR' is also known in the original source code as 'SRVTBL'.
*
ROLOVR   DATA  0,0,370,141,170,0,0 ; Clock rollover entry (170,0,0=1yr)
         DATA  0,0,0,0,0,0  ; Appointment inc
         VAL   APTFLG
         DATA  0,300,3,0,0,0 ; Repeat appt inc (=15 sec)
         VAL   APRFLG
         DATA  0,100,0,0,0,0 ; Clk/stp inc (=1 sec)
         VAL   C/SFLG
         DATA  0,0,0,0,0,0    ; Timer inc
         DATA  1              ; VAL   TMRFLG
         DATA  0,0,0,0,0,0    ; Dummy 1 inc
         VAL   DM1FLG
         DATA  0,0,0,0,0,0    ; Time adj inc
         VAL   ADJFLG
         DATA  0,0,0,0,0,0    ; Dummy 2 inc
         VAL   DM2FLG
         DATA  0,0,0,0,0,00   ; Dummy 3 inc
         VAL   DM3FLG
*
* *******************************************************
* SUBROUTINE CMPENA
* This routine enables the comparator interrupt.
* INPUT:	BIN
* OUTPUT:	BIN
* REGISTERS:
* 	R02/03	scratch
* VOLATILE:
* 	Status, R02/03
* *******************************************************
CMPENA   LDB  R3,=ENAINT       ; Get interrupt enable
         LDBD R2,=CMPSB        ; Get comparator status
         ORB  R2,R3            ; Set enable bit
         STBD R2,=CMPSB        ; Enable interrupt
         RTN                   ;
*
* *******************************************************
* SUBROUTINE CMPDSA
* This routine disables the comparator interrupt.
* INPUT:	BIN
* OUTPUT:	BIN
* REGISTERS:
* 	R03		scratch
* VOLATILE:
* 	Status, R03
* *******************************************************
CMPDSA   LDB  R3,=DSAINT       ; Get interrupt disable
         ANMD R3,=CMPSB        ; Get and clear status
         STBD R3,=CMPSB        ; Disable interrupt
         RTN                   ;
*
* ********************************************************************
* SUBROUTINE CMPENT
* This routine will take an entry from whomever and insert it in the
* table at the appropriate point.  It will update the comparator
* value as necessary.
*
* TMEADJ takes an interval in multiples of 61 uSec.  This interval
* is automatically repeated whenthe current setting is reached by
* adding the interval to the current value in the clock. A flag is set
* to indicate the setting was reached. This process will continue
* until a 0 is entered into the table.
*
* CLKSTP takes a starting value relative to clock = 0, in 61 uSec
* multiples.  This value should be adjusted to sync the comparator to
* the next second.  Thereafter, when the current setting is reached,
* the comparator will be reset by adding 1 second to the current
* clock. This will continue until a 0 entry is sent to the comparator.
* Since stopwatch and clock are mutually exclusive, the same bit and
* storage space is used for both.
*
* RPTALR is handled in the same way as CLKSTP except the repeat
* interval is 15 seconds.
*
* TIMER takes the time relative to clock = 0, in 61 uSec multiples.
* A flag is set when this setting is reached.  The TIMER does not
* repeat, this is the responsibility of BASIC.
*
* APTMNT takes the time relative to clock = 0, in 61 uSec multiples.
* A flag is set when this setting is reached. The APTMNT is not
* repeated, this is the responsibility of POCKET SEC.
*
* ROLOVR uses a fixed value (= 1 yr).  When this setting is reached,
* rollover is processed, and the value is reloaded.
*
* Three unused table locations are provided for plugin roms.  DUMMY1
* functions like TIMER and APTMNT.  DUMMY2 & DUMMY3 take an interval
* in 61 uSec units, add the current clock to get the settings.  When
* these settings are reached, a flag is set.  No auto incrementing
* is done.
*
* INPUT:	BIN or BCD
* 	R40	   code for who sent the entry		EQU:
* 			 0 = rollover entry (ROLOVR)	CT.RLV
* 			 7 = appointment entry (APTMNT)	CT.APT
* 			14 = repeating alarm (RTPALR)	CT.RPA
* 			21 = clock/stopwatch (CLKSTP)	CT.C/S
* 			28 = timer (TIMER)				CT.TMR
* 			35 = dummy 1 (DUMMY1)			CT.DM1
* 			42 = time adjust (TMEADJ)		CT.ADJ
* 			49 = dummy 2 (DUMMY2)			CT.DM2
* 			56 = dummy 3 (DUMMY3)			CT.DM3
* 	R41/47	time (in 1/16384 seconds)
*
* OUTPUT:	BIN or BCD
*
* REGISTERS:
* 	R06/07	stack pointer
* 	R20/21	table pointer
* 	R40		device code
* 	R41/47	incremental or absolute input value
* 	R50/57	clock value
*
* VOLATILE:
* 	Status, R40/47
*
* ROUTINES USED:
* 	CMPLD
* ********************************************************************
CMPENT   SAD                   ; Save status
         BIN                   ; Ensure binary
         PUMD R50,+R6          ; Save R50/57
         PUMD R20,+R6          ; Save R20/21
         CLM  R20              ; Clear table pointer
         LDB  R20,R40          ; Get pointer (device code)
         CMB  R40,=CT.ADJ      ; Incremental entry?
         DRP  R41              ; Save code
         IFCY                  ; yes
           IFZR                ; if time adjust
             STMD R41,=TMEINC  ; save increment
           ENDIF
           TSM  R41            ; entry = 0?
           IFNZ                ; no
             LDMD R50,=RTC         ; get clock value
             CLM  R56              ; clear garbage
             ADM  R41,R51          ; compute table value
           ENDIF
         ENDIF
         DRP  !41
         JSB  =LDCMP           ; Load comparator
         POMD R20,-R6          ; Restore R20/21
         POMD R50,-R6          ; Restore R50/57
         PAD                   ; Restore status
         RTN                   ;
*
* ********************************************************************
* SUBROUTINE CMPCHK
* This routine is calle dby the EXEC loop to determine device(s)
* causing the comparator to interrupt.  After determining the device,
* this routine will clear the b... and call the appropriate service
* routine.  When all of... have been serviced, it returns to the EXEC
* loop.  All registers R22/77 are saved before the device service
* routine is executed, external triggers are handled through a HANDI
* call.
*
* INPUT:	BIN or BCD
*
* OUTPUT:	BIN or BCD
*
* REGISTERS:
* 	R02/03	scratch
* 	R04/05	program counter
* 	R06/07	stack pointer
* 	R20/21	device service index
*
* VOLATILE:
* 	Status, E reg., R02/03
*
* ROUTINES USED:
* 	SVCCLR, STOP?, SYSJSB, EVIL, HANDI, TMTRIG, AJTRIG, CSTRIG,
* 	CNTRIG, APTRIG, KEY?
*
* ********************************************************************
CMPCHK   SAD                   ; Save status
         BIN                   ; Ensure binary
         PUMD R20,+R6          ; Save R20/21
         LDBD R20,=NOCHEK      ; Sould CMPCHK be doing anything?
         JNZ  CHKEND_CMP          ; If not, exit.
         LOOP
           LDB  R2,=1            ; set device flag
           LDM  R20,=(DVCTBL).2  ; init device index
           LOOP
             LDBD R3,=CMPFLG       ; get comparator flags
             JZR  CHKEND_CMP       ; all devices serviced
             ANM  R3,R2            ; test device flag
             JNZ  CMPDVC           ; go service device
             LLB  R2               ; next device flag
             ICM  R20              ; next
             ICM  R20              ; device count
           WHMP                  ; check next flag
CMPDVC     NCB  R2               ; mask device flag
           STBD R2,=GINTDS       ; disable interrupts
           LDBD R3,=CMPFLG       ; get comparator flags
           ANM  R3,R2            ; clear device flag
           STBD R3,=CMPFLG       ; save comparator flags
           IFZR                  ; no more to do
             LDB  R3,=177          ; clear comp bit in
             JSB  =SVCCLR          ; 	SVCWRD
           ENDIF
           STBD R#,=GINTEN       ; enable interrupts
           LDMD R20,R20          ; get srevice addr
           JSB  =SYSJSB          ; do a ROMJSB to
             DEF  DOTRIG         ; save R22/77, do trig rout in the BASe ROM
           JSB  =STOP?           ; abort condition?
           IFEZ                  ; no
             JSB  =KEY?            ; how about a key?
           ENDIF
         WHEZ                     ; no restart check
CHKEND_CMP
         POMD R20,-R6          ; restore R20/21
         PAD                   ; restore status
         RTN                   ;
*
DOTRIG   JSB  =EVIL            ; Save R22/77
           DEF  S22-77           ; 	EVIL parameter
         DCM  R20              ; adjust for "GTO"
         STM  R20,R4           ; Do a GOTO (ich, ich, ich)
*
* When routine, that R20 points to, does a RTN, it will restore
* regs and return to line after the call to DOTRIG.
*
D1TRIG
D2TRIG
D3TRIG   JSB  =HANDI           ; give roms a chance
           VAL  V.ETRG         ; to handle this trigger
           DATA  18D           ; (rom should have been there, 
                               ; R20+1-DVCTBL=TRIGGER DEVICE
         RTN                   ;
*
DVCTBL   DEF  TMTRIG           ; service TIMER
         DEF  D1TRIG         ; service EXTERNAL1
         DEF  D2TRIG         ; service EXTERNAL2
         DEF  D3TRIG         ; service EXTERNAL3
         DEF  CSTRIG           ; service CLK/STPWCH
         DEF  AJTRIG           ; service TMEADJ
         DEF  CNTRIG           ; service CNTALRM
         DEF  APTRIG           ; service APTMNT
*
* ********************************************************************
* SUBROUTINE AJTRIG
* This routine increments or decrements the RTC by 1/4 second whenever
* the adjust interrupt from the comparator is processed.  It is called
* by CMPCHK.
*
* INPUT:	BIN
* OUTPUT:	BIN
* REGISTERS:
* 	R02/03	scratch
* VOLATILE:
* 	Status, R02/03
* ********************************************************************
AJTRIG   LDB  R2,=DECRMT       ; get decrement bit
         LDBD R3,=PSSTAT       ; get time status
         ANM  R3,=DECFLG       ; test decrement flag
         IFZR
            LRB  R2               ; make increment bit
         ENDIF
         LDBD R3,=RTC          ; get clock status
         ANM  R3,=RTCMSK       ; clear garbage bits
         ORB  R3,R2            ; set inc/dec bit
         STBD R3,=RTC          ; tell clock
         RTN                   ;
*
* ********************************************************************
* SUBROUTINE CMPSET
* CMPSET loads the rollover value into the comp table for coldstart
* initialization.
*
* LDCMP loads the drp into CMPTBL and falls into CMPLD.
*
* INPUT:	BIN
* OUTPUT:	BIN
* REGISTERS:
* 	R41/47	table value
* VOLATILE:
* 	Status, R41/47
* ROUTINES USED:
* 	CMPLD (fall into)
* ********************************************************************
CMPSET   CLM  R20              ; point to rollover entry
         LDMD R41,=ROLOVR      ; get rollover value
LDCMP    STMD R#,X20,CMPTBL    ; put in table, fall into CMPLD
*
* ********************************************************************
* SUBROUTINE CMPLD
* This routine searches the comparator table for the lowest (next)
* entry, and enters it into the comparator.  It also saves the table
* pointer for the service routine to use in identifying the interrupt.
*
* INPUT:	BIN
* OUTPUT:	BIN
* REGISTERS:
* 	R20/21	table pointer
* 	R41/47	table value
* 	R50		entry identifier
* 	R51/57	comparator value
* VOLATILE:
* 	Status, all registers used
* ********************************************************************
CMPLD    CLM  R50              ; clear test value
         LDMD R51,=CMPTBL      ; get rollover for test
         LDM  R20,=(CT.APT).2  ; get appointment pointer
         LOOP
           LDMD R41,X20,CMPTBL   ; get table value
           TSM  R41              ; check for entry
           IFNZ
             CMM  R51,R41          ; which one smaller (next)?
             IFCY
               LDM  R51,R41          ; get lowest one
               LDB  R50,R20          ; get corresponding id
             ENDIF
           ENDIF
           ADM  R20,=(TBLINC).2    ; inc table pointer
           CMM  R20,=(TBLEND).2    ; last entry?
         WHNC
         STBD R50,=CMPPNT      ; save id for later service
         LDBD R50,=CMPSB       ; get comparator status
         STMD R50,=CMPSB       ; place value in comparator
*
* NOTE: This will write 8 bytes to the comparator but it will ignore the extra bytes
         RTN                   ;
       TITLE 'krlow'
*  __________________________________________________________________
* |MJLOW 270 06/09/82 - 6/11/1982 12:23PM                            |
* |==================================================================|
* ||                                                                ||
* ||   @@      @@    @@@@@@@@  @@            @@@@@@    @@      @@   ||
* ||   @@@    @@@    @@@@@@@@  @@           @@@@@@@@   @@      @@   ||
* ||   @@@@  @@@@        @@    @@          @@@    @@@  @@      @@   ||
* ||   @@@@@@@@@@        @@    @@          @@      @@  @@      @@   ||
* ||   @@  @@  @@        @@    @@          @@      @@  @@      @@   ||
* ||   @@  @@  @@        @@    @@          @@      @@  @@      @@   ||
* ||   @@      @@        @@    @@          @@      @@  @@  @@  @@   ||
* ||   @@      @@        @@    @@          @@      @@  @@  @@  @@   ||
* ||   @@      @@  @@    @@    @@          @@      @@  @@@@@@@@@@   ||
* ||   @@      @@  @@@  @@@    @@          @@@    @@@  @@@@  @@@@   ||
* ||   @@      @@   @@@@@@     @@@@@@@@@@   @@@@@@@@   @@@    @@@   ||
* ||   @@      @@    @@@@      @@@@@@@@@@    @@@@@@    @@      @@   ||
* ||                                                                ||
* ||                    Last edited: 82098.1334                     ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* LOW BATTERY ROUTINES
* ********************************************************************
*
* ********************************************************************
* POWER DETECT SERVICE ROUTINE
*
* Interrupt service routine for low battery interrupts.
*
* 	Expects: nothing
* 	Returns: ALKFLG set if BDR interrupt
* 	Changes: none, not even R0-R3 or status
*
* We get an interrupt whenever the BDK line drops to the level
* corresponding to a value we havbe written into the power supply
* comparator.  The first level is set up by B.init (both at coldstart
* and also at each warmstart).
*
* We'll use the following equation to find the reference numbers:
*
* 	{(256)(voltage to interrupt)}
* 	{ ------------------------- } -1 = ref#
* 	{        V+ (=5.4v)         }
*
* We have 2 interrupt levels.  At the first interrupt, we set bit#6 in
* SVCWRD so Spy will turn on the battery annunciator.  At the second,
* we set PWRFLG, so the next time we pass through WAITKY or the Mode
* switcher, those routines will send us to sleep with the low power
* message.  PWRFLG also causes some other routines (card reader, pil,
* delay, beep) to abort.
*
* The hardware will reset Kangaroo if the power drops below the level
* needed to keep the system alive.
*
* 	Battery levels			Alkalines		Nicads
* ....................................................................
* Battery annunciator on    3.10v(146D)		3.55v(167D)
* Low Battery message		2.70v(127D)		3.30v(155D)
* Hardware reset			----somewhere below 2.5v----
* ********************************************************************
*
* Hardware reset			----somewhere below 2.5v----
* ********************************************************************
*
PWRSRV   SAD                   ; save status
         BIN                   ;
         PUMD R2,+R6           ; save R2/3
         JSB  =AWAKE!          ; by managerial directive
         JSB  =PSTRAP          ; for the diagnostic ROM
         LDB  R2,=BIT#6          ; set bit#6 in SVCWRD so
         JSB  =SVCSET          ; 	we turn on the annun later
         LDMD R2,=PSSB         ; which interrupt?
*        ANM  R2,=2,377        ; look at PSSB bit#1, mask others, don't harm R3!
         ANM  R2,=BIT#1,0ffH
         TSB  R2               ; if bit#1=0, BDR selected
         IFZR                  ; if looking at BDR
           ICB  R2               ; set ALKFLG (this interrupt
           STBD R2,=ALKFLG       ; 	only occurs if we have
           JMP  DONE_LOW         ; 	alkaline batteries)
         ENDIF
         LDBD R2,=(BATTRY)+1   ; second interrupt level
         CMB  R2,R3            ; second level?
         IFNE                  ; if no (1st interrupt)
           STB  R2,R3            ; set up 2nd interrtup
           JSB  =SETINT          ; enable next interrupt
         ELSE
           LDB  R2,=1            ; set low power flag
           STBD R2,=PWRFLG       ; leave interrupt disabled (no more chances)
*
* ********************************************************************
* "...bbbbut Roo-man!!!  We can't just let them die!  Not without even
*  trying to save them!"
*
* "I'm sorry, Joey, but there's nothing more we can do.  It's up to
*  the Great Roo now."
*
* The venerated master reached over and quietly dimmed the lamp by the
* side of the gasping kangaroo.  Taking Joey's trembling hand in his,
* he gently led him away.
* ********************************************************************
*
         ENDIF
DONE_LOW POMD R2,-R6           ; restore registers
         PAD                   ; 	and status
         RTN                   ;
*
* ********************************************************************
* STOP? tells you if either the ATTN key has been hit or the low power
* flag has been set.
*
* 	Expects: nothing
* 	Changes: R2-3, E
* 	Returns: E=0 if ok
* 			 E=1 if ATTN key or low power seen
*
* PWROK? checks if the low power flag has been set.
*
* 	Expects: nothing
* 	Changes: R2, E
* 	Returns: E=0 if ok
* 			 E=1 if low power
*
* Do not change R0 as Beep relies on it.
* ********************************************************************
STOP?    JSB  =ATTN?           ; ATTN key hit?
         REN                   ; rtn if yes
PWROK?   CLE                   ;
         LDBD R2,=PWRFLG       ; low power flag set?
         RZR                   ; quit if ok
         ICE                   ; else set E
         RTN                   ;
*
* ********************************************************************
* SVCSET	SVCCLR
* Routines to set or clear bits in SVCWRD
*
* 	Expects: R2 =bits to set (for SVCSET)
* 			 R2 =bits to clear (for SVCCLR)
* 	Returns: nothing
* 	Changes: R2-3
*
* DRP=2 or 3 upon exit
* ********************************************************************
SVCSET   STBD R#,=GINTDS       ; disable interrupts
         LDBD R3,=SVCWRD       ; get SVCWRD
         ORB  R3,R2            ; set them bits
         JMP  krlow1           ; store SVCWRD, enable interrupts
*
SVCCLR   STBD R#,=GINTDS       ; disable interrupts
         ANMD R#,=SVCWRD       ; clear those bits
krlow1   STBD R#,=SVCWRD       ; store the result in SVCWRD
         STBD R#,=GINTEN       ; enable interrupts
         RTN                   ;
*
* ********************************************************************
* B.init
*
* Called at wakeup to turn off the annunciator, clear the low power
* flag, clear bit#6 in SVCWRD, and set the interrupt level to 3.55
* volts for nicads, 3.10 volts for alkalines.
*
* 	Expects: nothing
* 	Returns: nothing
* 	Changes: R0-3
*
* The battery interrupt is (hardware) disabled when we awaken from
* deep sleep.  We'll leave it that way while figuring out which
* batteries we have in, and only enable it when we put in an actual
* level.
*
* We decide which batteries we have by the value of BDR.  If BDR is
* >.375v, we assume nicads, else alkalines.
*
* This will not change POR
*
* At exit, the global interrupts are enabled.
* ********************************************************************
B.INIT   BIN                   ;
         JSB  =ANN.B-          ; turn off the annunciator
         CLM  R2               ;
         STMD R2,=PWRFLG       ; clear the power flag, ALKFLG
* ** check R batt level to see if we have nicads or alkalines
*        LDM  R2,=0,375        ; clear bit#1 for R batt
         LDM  R2,=0,NOT#1
         JSB  =SETPSB          ; select it
* ** if R batt vbalue >.630v, then nicads, else alkalines
         LDB  R3,=29D          ; 29D =((256)(.630v)/5.4v)-1
         JSB  =SETINT          ; set up int between alks and nic
* ** enable global interrupts and see if we get an interrupt
* ** (R2 = first byte of PSSB from SETINT)
         STBD R0,=GINTEN       ; enable global interrupts
         LDB  R0,=21D          ; wait about 300 microsecs
         LOOP
           DRP  !0
           DCB  R0               ; (9 cycles)(1.6 usecs/cycle)(21 loops)
         WHNZ
* ** if we got an interrupt, alkflg will be set to nonzero
         LDBD R0,=ALKFLG       ; did we get an interrupt?
         IFNZ                  ; if int (nicad)
           LDM  R0,=ALKLN1,ALKLN2  ; get alk levels (ALKLN1, ALKLN2)
         ELSE
           LDM  R0,=NICAD1,NICAD2 ; get nic levels (NICAD1, NICAD2)
         ENDIF
         STMD R0,=BATTRY       ; set up 1st and 2nd levels
         STB  R0,R3            ; save first int value in R3
* ** change back to K battery
* ** (R2 = first byte of PSSB from SETINT)
         ADB  R2,=BIT#1           ;
         STBD R2,=PSSB         ; int is still disabled...
* ** set up first interrupt level, clear bit#6 in SVCWRD
* ** (also enables the global interrupts again)
         JSB  =SETINT          ; set up the int value in R3
         LDB  R2,=NOT#6        ; clear bit#6
         JSB  =SVCCLR          ; 	in SVCWRD
         RTN                   ;
*
* ********************************************************************
* SETINT
* Sets up low power interrupt.  Restarts interrupt checking loop.
*
* 	Expects: R3 =new interrupt value
* 	Returns: nothing
* 	Changes: R2-3
*
* At exit, DRP=2
*
* NOTE: simply writing a 1 to bit#3 will not restart the interrupt
* loop.  The bit must be written to a 0 first.
* ********************************************************************
SETINT   LDBD R2,=PSSB         ;
         ANM  R2,=0FFF7H
         STMD R2,=PSSB         ; must clear bit#3 first
         ADB  R2,=BIT#3        ;
         STBD R2,=PSSB         ; then set it
         RTN                   ;
       TITLE 'krvro'
*  __________________________________________________________________
* |KXVR0 NA                                                          |
* |==================================================================|
* ||                                                                ||
* ||   @@     @@@  @@      @@  @@      @@  @@@@@@@@       @@@@      ||
* ||   @@    @@@   @@      @@  @@      @@  @@@@@@@@@    @@@@@@@@    ||
* ||   @@   @@@    @@@    @@@  @@      @@  @@     @@@  @@      @@   ||
* ||   @@  @@@      @@@  @@@   @@      @@  @@      @@  @@     @@@   ||
* ||   @@ @@@         @@@@      @@    @@   @@     @@   @@    @@@@   ||
* ||   @@@@@           @@       @@    @@   @@@@@@@     @@   @@ @@   ||
* ||   @@@@@           @@       @@    @@   @@@@@@@     @@  @@  @@   ||
* ||   @@ @@@         @@@@       @@  @@    @@    @@@   @@ @@   @@   ||
* ||   @@  @@@      @@@  @@@      @@@@     @@     @@@  @@@@    @@   ||
* ||   @@   @@@    @@@    @@@     @@@@     @@      @@  @@@     @@   ||
* ||   @@    @@@   @@      @@      @@      @@      @@   @@@@@@@@    ||
* ||   @@     @@@  @@      @@      @@      @@      @@     @@@@      ||
* ||                                                                ||
* ||                                                                ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* The following byte is the ROM VERSION# for the first system ROM.
* ********************************************************************
VERMN0   DATA  'd'
       TITLE 'krbrt'
*  __________________________________________________________________
* |KRBRT 60 04/30/82 - 5/ 4/1982 5:11PM                              |
* |==================================================================|
* ||                                                                ||
* ||   @@     @@@  @@@@@@@@    @@@@@@@@    @@@@@@@@    @@@@@@@@@@   ||
* ||   @@    @@@   @@@@@@@@@   @@@@@@@@@   @@@@@@@@@   @@@@@@@@@@   ||
* ||   @@   @@@    @@     @@@  @@     @@@  @@     @@@      @@       ||
* ||   @@  @@@     @@      @@  @@      @@  @@      @@      @@       ||
* ||   @@ @@@      @@     @@   @@     @@@  @@     @@       @@       ||
* ||   @@@@@       @@@@@@@     @@@@@@@@    @@@@@@@         @@       ||
* ||   @@@@@       @@@@@@@     @@@@@@@@    @@@@@@@         @@       ||
* ||   @@ @@@      @@    @@@   @@     @@@  @@    @@@       @@       ||
* ||   @@  @@@     @@     @@@  @@      @@  @@     @@@      @@       ||
* ||   @@   @@@    @@      @@  @@     @@@  @@      @@      @@       ||
* ||   @@    @@@   @@      @@  @@@@@@@@@   @@      @@      @@       ||
* ||   @@     @@@  @@      @@  @@@@@@@@    @@      @@      @@       ||
* ||                                                                ||
* ||                    Last edited: 82098.1349                     ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* A very small math subroutine used too many times to be switching ROM
* (BRT routines).  I'm not sure what it does.  See KR&TEG for related
* documentation.
* ********************************************************************
BRTS30   LRM  R47            ; shift mantissa right
BRTS35   ICM  R36            ; increment exponent
BRTS40   TSB  R37            ; has exponent reached 0 yet?
         JNG  BRTS30         ; jmp(loop) if exp not yet 0
         CLM  R36            ; clear register
         RTN                 ;
       TITLE 'krmak'
*
*  __________________________________________________________________
* |MJMAK 273                                                         |
* |==================================================================|
* ||                                                                ||
* ||   @@      @@    @@@@@@@@  @@      @@    @@@@@@    @@     @@@   ||
* ||   @@@    @@@    @@@@@@@@  @@@    @@@   @@@@@@@@   @@    @@@    ||
* ||   @@@@  @@@@        @@    @@@@  @@@@  @@@    @@@  @@   @@@     ||
* ||   @@@@@@@@@@        @@    @@@@@@@@@@  @@      @@  @@  @@@      ||
* ||   @@  @@  @@        @@    @@  @@  @@  @@      @@  @@ @@@       ||
* ||   @@  @@  @@        @@    @@  @@  @@  @@@@@@@@@@  @@@@@        ||
* ||   @@      @@        @@    @@      @@  @@@@@@@@@@  @@@@@        ||
* ||   @@      @@        @@    @@      @@  @@      @@  @@ @@@       ||
* ||   @@      @@  @@    @@    @@      @@  @@      @@  @@  @@@      ||
* ||   @@      @@  @@@  @@@    @@      @@  @@      @@  @@   @@@     ||
* ||   @@      @@   @@@@@@     @@      @@  @@      @@  @@    @@@    ||
* ||   @@      @@    @@@@      @@      @@  @@      @@  @@     @@@   ||
* ||                                                                ||
* ||                    Last edited: 82098.1334                     ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
MAKEIT   LDM  R20,=ZRO         ; get system type for file
         JSB  =FCRNUL          ; R30=directory file
         JSB  =MOVEUP          ; R36=first usable line of file
         RTN                   
       TITLE 'krlit'
*
*  __________________________________________________________________
* |IVLIT 267 05/10/82 - 5/13/1982 3:50PM                             |
* |==================================================================|
* ||                                                                ||
* ||   @@@@@@@@@@  @@      @@  @@          @@@@@@@@@@  @@@@@@@@@@   ||
* ||   @@@@@@@@@@  @@      @@  @@          @@@@@@@@@@  @@@@@@@@@@   ||
* ||       @@      @@      @@  @@              @@          @@       ||
* ||       @@      @@      @@  @@              @@          @@       ||
* ||       @@       @@    @@   @@              @@          @@       ||
* ||       @@       @@    @@   @@              @@          @@       ||
* ||       @@       @@    @@   @@              @@          @@       ||
* ||       @@        @@  @@    @@              @@          @@       ||
* ||       @@         @@@@     @@              @@          @@       ||
* ||       @@         @@@@     @@              @@          @@       ||
* ||   @@@@@@@@@@      @@      @@@@@@@@@@  @@@@@@@@@@      @@       ||
* ||   @@@@@@@@@@      @@      @@@@@@@@@@  @@@@@@@@@@      @@       ||
* ||                                                                ||
* ||                    Last edited: 82098.1352                     ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
LIT?     LDBD R2,=JUSTSO       ; get current status
         SAD                   ; save current status
         CLB  R2               ; clear out all the bits
         STBD R2,=JUSTSO       ; store it in the flag
         PAD                   ; restore status
         RTN
       TITLE 'krsum0'
*
*  __________________________________________________________________
* |KRSUM NA                                                          |
* |==================================================================|
* ||                                                                ||
* ||   @@     @@@  @@@@@@@@      @@@@@@    @@      @@  @@      @@   ||
* ||   @@    @@@   @@@@@@@@@    @@@@@@@@   @@      @@  @@@    @@@   ||
* ||   @@   @@@    @@     @@@  @@@    @@@  @@      @@  @@@@  @@@@   ||
* ||   @@  @@@     @@      @@  @@      @@  @@      @@  @@@@@@@@@@   ||
* ||   @@ @@@      @@     @@   @@@         @@      @@  @@  @@  @@   ||
* ||   @@@@@       @@@@@@@      @@@@@@@    @@      @@  @@  @@  @@   ||
* ||   @@@@@       @@@@@@@       @@@@@@@   @@      @@  @@      @@   ||
* ||   @@ @@@      @@    @@@          @@@  @@      @@  @@      @@   ||
* ||   @@  @@@     @@     @@@  @@      @@  @@      @@  @@      @@   ||
* ||   @@   @@@    @@      @@  @@@     @@  @@@    @@@  @@      @@   ||
* ||   @@    @@@   @@      @@   @@@@@@@@    @@@@@@@@   @@      @@   ||
* ||   @@     @@@  @@      @@    @@@@@@      @@@@@@    @@      @@   ||
* ||                                                                ||
* ||                    Last edited: 82098.1352                     ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* This is the CHECKSUM byte for the first system ROM.
* ********************************************************************
*        DATA 0F6H          
         DATA 0ACH
       TITLE 'krio'
*  __________________________________________________________________
* |KXIO 239 09/27/82 - 9/30/1982 3:50PM                              |
* |==================================================================|
* ||                                                                ||
* ||         @@     @@@  @@      @@  @@@@@@@@@@    @@@@@@           ||
* ||         @@    @@@   @@      @@  @@@@@@@@@@   @@@@@@@@          ||
* ||         @@   @@@    @@@    @@@      @@      @@@    @@@         ||
* ||         @@  @@@      @@@  @@@       @@      @@      @@         ||
* ||         @@ @@@         @@@@         @@      @@      @@         ||
* ||         @@@@@           @@          @@      @@      @@         ||
* ||         @@@@@           @@          @@      @@      @@         ||
* ||         @@ @@@         @@@@         @@      @@      @@         ||
* ||         @@  @@@      @@@  @@@       @@      @@      @@         ||
* ||         @@   @@@    @@@    @@@      @@      @@@    @@@         ||
* ||         @@    @@@   @@      @@  @@@@@@@@@@   @@@@@@@@          ||
* ||         @@     @@@  @@      @@  @@@@@@@@@@    @@@@@@           ||
* ||                                                                ||
* ||                    Last edited: 82098.1548                     ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* This file contains the Kangaroo middle-level output routines.
* ********************************************************************
* CURSE+ Turn the cursor on by sending ESC>
* Input:		none
* Output:		BIN
* Internals:	none
* Volatile:		R0/3, E, status
* Routines:		OUTESC
* ********************************************************************
CURSE+   JSB  =OUTESC          ; write out ESC >
         DATA  '>'             ; '>' turn cursor on
         RTN                   ;
*
* ********************************************************************
* CURSE- Turn the cursor off by sending ESC <
* Input:		none
* Output:		BIN
* Internals:	none
* Volatile:		R0/3, E, status
* Routines:		OUTESC
* ********************************************************************
CURSE-   JSB  =OUTESC          ; write out ESC <
         DATA  '<'             ; '<' turn cursor off
         RTN                   ;
*
* ********************************************************************
* GETLN Read a line from the keyboard.
* Input:		R20/21	Initial line position in INPBUF
* 						(absolute address, i.e., INPBUF+2)
* 				R22/23	Initial cursor position in INPBUF
* 						(absolute address)
* 				R24		Length of stuff in INPBUF
* 				INPBUF	Initial input characters
* Output:		R24		Length of input line
* 				R25		Terminating character (usually CR)
* Internals:	R40		Character input
* 				R2/3	scratch
* Volatile:		R0/3, E
* 				status remains the same
* Routines:		SETLIN, CURSE+, GETCHR, CURSE-, SYSJSB, CHEDIT, ANN.E-
* ********************************************************************
GETLN    SAD                   ; save BIN/BCD
         BIN                   ; smart people choose BIN
         JSB  =SETLIN          ; set up line
* ** read characters until an ending character
         LOOP
           JSB  =CURSE+          ; turn on the cursor
           PUBD R40,+R6          ; save R40
           JSB  =GETCHR          ; get a character (might be the terminator)
           STB  R2,R40           ; parameter for CHEDIT
           JSB  =CURSE-          ; turn off the cursor
           JSB  =SYSJSB          ; do a rom switch
           DEF  CHEDIT           ; edit that key.
           STB  R40,R25          ; might be terminating key
           POBD R40,-R6          ; get R40 back
         WHEZ                  ; do more if not a terminator
* ** display length is now zero
GETLN+   CLM  R2               ;
         STMD R2,=DISPTR       ; current display length
* ** save line length
         LDMD R2,=LASTCH       ; pointer to last char
         STMD R2,=OLDLST       ; save input length
* ** calculate line length
         SBM  R2,=((INPBUF)-1).2 ; get length, not pointer
         STB  R2,R24           ; input line length
* ** set LASTCH:=INPBUF+95   ; so LCD deletions will work
         LDM  R2,=((INPBUF)+95D).2       ; last possible char position
         STMD R2,=LASTCH       ; current last character
* ** theoretically, he has seen all previous output.
         JSB  =ANN.E-          ; disable error annunciator
         PAD                   ;
         RTN                   ;
*
* ********************************************************************
* SETLIN Display the line the user has given us in his call to GETLN.
* Input:		BIN
* 				R20/21	Initial line position (absolute address)
* 				R22/23	Initial cursor position (ABS address)
* 				R24		Initial line length
* 				INPBUF	bunch of characters to display
* Output:		BIN
* Internals:	R26/27	address to HLFLIN
* 				R36/37	length to HLFLIN
* 				R24/25	current position
* Volatile:		R20/21, R22, R2/3
* Routines:		IO.OFF, HLFLIN, OUT1CH, SYSJSB, IO.ON
* Notes:
* 	Here's the strategy:
* 1. Disable LCD I/O for speed
* 2. Write out the line with HLFLIN (no end-of-line)
* 3. Backspace to the cursor position
* 4. Set LCDWIN to the line position
* 5. Enable LCD I/O, write out LCD display
*
* Within this routine, R24=where we are now.
* ********************************************************************
* ** (1): Disable LCD I/O
SETLIN   JSB  =IO.OFF          ; disable LCD I/O
* ** (2): Print out the specified line
         PUMD R26,+R6          ;
         LDM  R26,=INPBUF      ; where to start at
         PUMD R36,+R6          ;
         CLM  R36              ; MSB of string length
         LDB  R36,R24          ; get LSB string length
         STM  R36,R24          ; save length in R24/25
         JSB  =HLFLIN          ; put out the line
         POMD R36,-R6          ;
         POMD R26,-R6          ;
         ADM  R24,=((INPBUF)-1).2    ; R24:=cursor position-1
         STMD R24,=LASTCH      ; remember that!
         ICM  R24              ; back to cursor position
* ** (3): Move cursor to the desired cursor position.
* ** R24=where we are.  R22=where we want to be.
PSNCUR   CMM  R22,R24          ; at cursor position?
         JCY  PSN.OK           ; jif there or further, satisfied.
         DCM  R24              ; cursor gonna move left
         JSB  =OUT1CH          ; send out BS
         DATA  BS               ; (8=^H) to go backward
         JMP  PSNCUR           ;
* ** (4): set LCDWIN to appropriate line position
* ** translate offset in INPBUF into offset in LCDBUF
* ** add LCDSIZ for the next computation
PSN.OK   ADMD R20,=SIZSIZ      ; add for future compare
* ** now, this might be incompatible with the cursor position
* ** in R22, let's move it up if we must
         CMM  R20,R22          ; is the window up far enough?
         IFNC                  ; jif yes
           LDM  R20,R22          ; else make it up far enough
         ENDIF
         SBM  R20,=((INPBUF)-(LCDBUF)).2 ; put into LCDBUF
         SBMD R20,=SIZSIZ       ; put into LCDBUF
         STMD R20,=LCDWIN       ; put LCD window HERE
* ** (5): re-enable LCD I/O
         STMD R22,=INPTR       ; input pointer:=cursor
         CLB  R22              ;
         JSB  =SYSJSB          ; call routine in system rom
         DEF  I/ROFF           ; set replace mode
         JSB  =IO.ON           ; enable(write out) LCD I/O
         RTN                   ;
*
* ********************************************************************
* Get a single character into KEYHIT.  Also put it into R2.
* ********************************************************************
GETCHR   JSB  =WAITKY          ; wait for key, put into R2
         JMP  DEQUE            ; kill "got a key" bit in SVCWRD
*
* ********************************************************************
* This monster sits here until it gets a key.
*
* OUTPUT: R2=key hit or fake NAPKEY
*
* We go into light sleep quite quickly, and go into deep sleep after
* a while by faking the NAPKEY key.
*
* In all cases we exit fully awake.
* During this routine:
*
* R45/47=timeout count.
* when R45/47<LIGHT? we go into light sleep.
* when R45/47 hits zero, we fake a NAPKEY to deep sleep.
*
* Tmout? keeps track of whether or not we should time out to deep sleep.
* If bit#0 =1, no deep sleep timeout
* ********************************************************************
WAITKY   JSB  =UNSEE           ; don't wait for previous output
         JSB  =HANDI0          ; give roms a shot at us
         VAL  V.WAIT           ; this is the WAITKY event
         PUMD R40,+R6          ; save temporaries
         LDMD R44,=TMOUT?      ; get time out count and flag
WTLOOP   LOOP 
           JSB  =SVCCHK          ; service other interrupts
           LDBD R2,=PWRFLG       ; check power flag
           JNZ  FAKEIT           ; jif flag<>0 (power below minimum
           JSB  =KEY?            ; has a key been hit?
           JEN  IDIDIT           ; skip out if we got a key.
* ** shall we go to light sleep yet?
           CMMD R45,=LIGHT?      ;
           IFNC                  ; if yes
             LDM  R2,=040H,0FFH  ; go to light sleep
             JSB  =SETPSB          ; tell the hardware
           ENDIF
           DCM  R45              ; count down
         WHNZ
         ICM  R45              ; set R45=1
         TSB  R44              ; timeout allowed?
         JOD  WTLOOP           ; jif no timeout, keep waiting
* ** go to deep sleep by faking NAPKEY timeout key.
FAKEIT   LDB  R2,=NAPKEY       ; get phoney timeout key
         JSB  =PUTKEY          ; fake it
IDIDIT   JSB  =AWAKE!          ; fully awake hardware code
         POMD R40,-R6          ; restore temporaries
         JSB  =UNSEE           ; we have seeen the output!
         DRP !2
         LDBD R2,=KEYHIT       ; DRP 2 from UNSEE, get the key of consideration
         RTN                   ;
*
* ********************************************************************
* LETGO Wait for the user to take his finger off the keyboard.
* INPUT: none
* OUTPUT: none
* INTERNALS: R2/3, status from keyboard
* VOLATILE: Status, R2/3
* ROUTINES: DEQUE
* ********************************************************************
LETGO    LOOP
           LDMD R2,=KEYSTS       ; get status & keycode
           ANM  R2,=00100000B,0  ; get bit 5 of status
         WHNZ
* ********************************************************************
* DEQUE: Kill any pending keys by clearing bit zero in SVCWRD
* INPUT: SVCWRD, bit zero is set if a key is pending in KEYHIT
* OUTPUT: SVCWRD, bit zero is cleared.
* INTERNALS: R2 scratch
* VOLATILE: Status
* ROUTINES: SVCCLR
* Notes: Does not even destroy R2!!! Other routines depend on this.
* ********************************************************************
DEQUE    PUMD R2,+R6           ; save R2/3
         LDB  R2,=NOT#0        ; clear the "KEYHIT is valid" bit
         JSB  =SVCCLR          ; gonna clear a bit in SVCWRD
         POMD R2,-R6           ; restore them suckers
         RTN                   ; and awwwaaaaaay we go!
* ********************************************************************
* PUT. Make <string> (length=1) the current key.
* ********************************************************************
         DATA  241              ; attributes for PUT.
PUT.     DRP  R0               ; (GETAD# does bin)
         JSB  =GETAD#          ; get string address
         LDBD R2,R0            ; get character
         POMD R0,-R12          ; get length
         DCM  R0               ; was the length one?
         IFNZ
           JSBN  =ERROR+          ; give us an error
           DATA  89D              ; BAD PARAMETER!
         ENDIF
*
* ********************************************************************
* PUTKEY: Make the key in R2 pending by putting it into KEYHIT and
* setting bit zero in SVCWRD.  It might not get in if another key is
* in KEYHIT already.
*
* INPUT:	BIN
* 			R2		the key to be made pending
* 			SVCWRD	bit zero says if a key is pending
*
* OUTPUT:	BIN
* 			KEYHIT	possibly updated place to put a key
* 			SVCWRD	possibly bit zero set to mean a key
* INTERNALS: R3 used for testing SVCWRD
* VOLATILE: R2/3, status
* ROUTINES: SVCSET
* Notes: Only the first key in counts, except for the ATTN key, which
* has priority over all other keys.
* ********************************************************************
PUTKEY   CMB  R2,=ATTNKY       ; attention key?
         IFNZ                  ; jif yes, put it in!
           LDBD R3,=SVCWRD       ; is there already a key?
           ROD                 ; jif yes, exit
         ENDIF
         STBD R2,=KEYHIT       ; store it in the key buffer
         LDB  R2,=BIT#0        ; gonna set bit#0
         JSB  =SVCSET          ; set the "valid key" bit
         RTN                   ;
* ********************************************************************
* HLFOUT: Write a string of characters, no EOL sent.
* Usage:
* 			LDM R26,=MESSAG		! get add of len/str
* 			JSB =HLFOUT			! write it
* 			...
*   MESSAG	DATA	14D				! length of string
* 			ASC	"Hi there folks"
*
* INPUT:	R26/27 address of length/string
* OUTPUT:	BIN
* INTERNALS: R36/37 length of the string for HLFLIN
* VOLATILE: R26/27, R0/3, status, E
* ROUTINES: HLFLIN
* Notes: Beware calling this from a plug-in ROM if the ROM isn't
* enabled when HLFLIN reads the string!
* ********************************************************************
HLFOUT   PUMD R36,+R6          ;
         CLM  R36              ;
         POBD R36,+R26         ;
         JSB  =HLFLIN          ;
         POMD R36,-R6          ; restore temporaries
         RTN                   ;
* ********************************************************************
* MSGOUT: Write a string of characters to the DISPLAY IS devices and
* send EOL.
*
* Usage:
* 			LDM R26,=MESSAG		! get add of len/str
* 			JSB =MSGOUT			! write it
* 			...
*   MESSAG	DATA	17D				! length of string
* 			ASC	"Roo Crew Forever!"
*
* INPUT:	R26/27 address of length/string
* OUTPUT:	BIN
* INTERNALS: none
* VOLATILE: R26, R0/3, status, E
* ROUTINES: HLFOUT, OUTEOL
* Notes: Beware calling this from a plug-in ROM if the ROM isn't
* enabled when HLFLIN reads the string!
* ********************************************************************
MSGOUT   JSB  =HLFOUT          ; print out message, no EOL
         JSB  =OUTEOL          ; do end of line sequence
         RTN                   ;
* ********************************************************************
* OUTSTR: Write out a string of characters and then write out CR/LF.
*
* INPUT: R26/27 address of string
* 		 R36/37 length of string
* OUTPUT: BIN
* INTERNALS: none
* VOLATILE: R0/3, status, E
* ROUTINES: HLFLIN, OUTEOL
* ********************************************************************
OUTSTR   JSB  =HLFLIN          ; send out all but CR
         JSB  =OUTEOL          ; put out a carriage return
         RTN                   ;
* ********************************************************************
* HLFLIN: Write a string of characters to the LCD and the DISPLAY IS
* devices with no EOL sent.
*
* INPUT:	R26/27	address of characters
* 			R36/37	length of characters
* OUTPUT:	BIN
* INTERNALS:R32		a character to write out
* VOLATILE: R0/3, status, E
* ROUTINES: OUTCHR
* ********************************************************************
HLFLIN   BIN                   ;
         PUBD R32,+R6          ;
         PUMD R26,+R6          ; save R26/27
         PUMD R36,+R6          ; save R36/37
krio_l1  DCM  R36              ; count down characters
         IFCY                  ; if we didn't decrement zero
           POBD R32,+R26         ; pop char from buffer
           JSB  =OUTCHR          ; output 1 character
           JMP  krio_l1          ; loop until all N chars
         ENDIF
         POMD R#,-R6           ; restore
         POMD R26,-R6          ; 	the registers
         POBD R32,-R6          ;
         RTN                   ;
* ********************************************************************
* OUTCHR: Write out the char in R32 to LCD and the DISPLAY IS devices
* INPUT:	R32	the character to write
* OUTPUT: 	BIN
* INTERNALS:	none
* VOLATILE: R0/3, status, E
* ROUTINES: KEYDSP, LCDOUT
* ********************************************************************
OUTCHR   BIN                   ;
         JSB  =KEYDSP          ; display checks now in here
         JSB  =LCDOUT          ; send to LCD (will this work?)
         RTN                   ;
* ********************************************************************
* OUTC40: Write R40 char to LCD and DISPLAY IS devices (see OUTCHR)
* INPUT:	RE40	the char to write
* OUTPUT: 	BIN
* INTERNALS: R2	parameter to DOOUT
* VOLATILE: R0/3, status, E
* ROUTINES: DOOUT
* ********************************************************************
OUTC40   LDB  R2,R40           ;
         JMP  DOOUT            ;
* ********************************************************************
* OUT1CH: Write out a char like OUTCHR
* OUTESC: Write out ESC-char like OUTCHR
* Usage:	JSB =OUT1CH		! write out )
* 			DATA	')'
*
* 			JSB =OUTESC		! write out ESC )
* 			DATA	')'
*
* INPUT: static parameter after the call
* OUTPUT: BIN
* INTERNALS: R32	parameter to OUTCHR
* VOLATILE:	R0/3, status, E
* ROUTINES: PAR1, OUTCHR
* ********************************************************************
OUTESC   JSB  =OUT1CH          ;
         VAL  ESC              ;
OUT1CH   JSB  =PAR1            ; R2:=the character
DOOUT    PUBD R32,+R6          ; save temporary
         LDB  R32,R2           ; R32:=the character
         JSB  =OUTCHR          ; send the character
         POBD R32,-R6          ; restore R32
         RTN                   ;
* ********************************************************************
* OUTEOL: Write end-of-line sequence (CR/LF)
* INPUT: none
* OUTPUT: BIN
* INTERNALS: none
* VOLATILE: R0/3, status, E
* ROUTINES: OUT1CH
* Notes: The sequence is CRLF instead of LFCR because some slow
* physical devices (printers, TTYs) might take too long to handle a
* CR (return carriage) and print the next character in the middle of
* it.  If a LF gets in the middle of returning a carriage, though,
* it doesn't hurt things.
* ********************************************************************
OUTEOL   JSB  =OUT1CH          ; output 1 character
         VAL  CR               ; that's me!
         JSB  =OUT1CH          ; output another character
         VAL  LF               ; that's me!
         RTN                   ;
* ********************************************************************
* EOLND: Write end-of-line sequence (CR/LF) with no delay, ie. with
* DELAY 0 temporarily.
* INPUT: none
* OUTPUT: BIN
* INTERNALS: R73/77 temporary holding of DELAY
* VOLATILE: R0/3, status, E
* Routines: OUTEOL
* Notes: This is useful for writing EOL after user CR
* ********************************************************************
EOLND    PUMD R73,+R6          ; save thos babies
         LDMD R73,=DELAY       ; get current delay value
         PUMD R73,+R6          ; save it
         CLM  R73              ; get a zero delay value
         STMD R73,=DELAY       ; make it the cvurrent delay
         JSB  =OUTEOL          ; do end of line
         POMD R73,-R6          ; get old delay back
         STMD R73,=DELAY       ; and put it back in DELAY
         POMD R73,-R6          ; get those babies back
         RTN                   ; that's all folks!
* ********************************************************************
* ATTN?: See if the ATTN key is pending.
* INPUT: BIN
* OUTPUT: BIN
* 		E	=1 if ATTN is pending
* 			=0 if it's not
* INTERNALS: none
* VOLATILE: R2/2, status
* ROUTINES: KEY?
* Notes: Do not change R0 as Beep relies on it.
* ********************************************************************
ATTN?    JSB  =KEY?            ; has a key been hit?
         CMB  R#,=ATTNKY
         IFNE
           CLE                   ; indicate failure
         ENDIF
         RTN                   ;
* ********************************************************************
* KEY?: See if a key is pending.
* INPUT: BIN
* 		SVCWRD	bit zero says if a key is pending
* 		KEYHIT	the pending key, if any
* OUTPUT:	BIN
* 			DRP 2
* 			R2		the pending key, if any
* 			E		=0 if no key is pending
* 					=1 if a key is pending
* INTERNALS: R2/2	scratch
* VOLATILE: status R2/2
* ROUTINES: none
* Notes: This routine must take a constant amount of time no matter
* whether or not a key is pending (BEEP requires this)
* ********************************************************************
*
* ********************************************************************
* The night is dark and windy.  Roo-man, defender of truth
*   just coding, has been called away on a mysterious assi
*   Suddenly a dark, sinister shape is seen creeping along
*   hedge, dragging a heavy burlap bag.  The shape pauses,
*   listens intently, then starts to chuckle.
*
* "He,he,he!  Nobody is looking!  This looks like as good
*   as any to ditch this load!"
*
* He drops the burlap bag gleefully and scampers away.
* ********************************************************************
KEY?     LDBD R2,=SVCWRD       ; bit 0 indicates a key
         CLE                   ;
         JEV  krio_l2           ; 5:EV 4OD
         ICE                   ; 0:EV 2OD
* ** This generates a warning for null jump!  That's OK
krio_l2  JEV  krio_l3          ; 5:EV 4:OD
krio_l3  LDBD R#,=KEYHIT       ; get something (valid if E=1)
         RTN
       TITLE 'krzzz'
*
*  __________________________________________________________________
* |IVZZZ 600 05/10/82 - 5/14/1982 10:50AM                            |
* |==================================================================|
* ||                                                                ||
* ||   @@@@@@@@@@  @@      @@  @@@@@@@@@@  @@@@@@@@@@  @@@@@@@@@@   ||
* ||   @@@@@@@@@@  @@      @@  @@@@@@@@@@  @@@@@@@@@@  @@@@@@@@@@   ||
* ||       @@      @@      @@         @@@         @@@         @@@   ||
* ||       @@      @@      @@        @@@         @@@         @@@    ||
* ||       @@       @@    @@        @@@         @@@         @@@     ||
* ||       @@       @@    @@       @@@         @@@         @@@      ||
* ||       @@       @@    @@      @@@         @@@         @@@       ||
* ||       @@        @@  @@      @@@         @@@         @@@        ||
* ||       @@         @@@@      @@@         @@@         @@@         ||
* ||       @@         @@@@     @@@         @@@         @@@          ||
* ||   @@@@@@@@@@      @@      @@@@@@@@@@  @@@@@@@@@@  @@@@@@@@@@   ||
* ||   @@@@@@@@@@      @@      @@@@@@@@@@  @@@@@@@@@@  @@@@@@@@@@   ||
* ||                                                                ||
* ||                    Last edited: 82098.1352                     ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* This file contains the BYE code.
* This is where the machine goes to deep sleep.
* ********************************************************************
*
* ********************************************************************
* Routine to find RAM bounds.  Returns new bound in R34.
* ********************************************************************
BOUND    LDM  R34,=32K         ; start point
         LOOP
           LDMD R36,R34          ; save ram value
           NCB  R36              ; complement for test
           STMD R36,R34          ; put out pattern
           CMMD R36,R34          ; read it back
           RNE                   ; jif no, give up
           NCB  R36              ; complement back
           STMD R36,R34          ; restore ram value
           ADM  R34,=2K          ; skip to next ram chip
           CMM  R34,=TOPROM      ; up to max ram?
         WHNC                  ;  no, keep going
         RTN                   ;
*
* ********************************************************************
* Routine to find RAM checksum
* Ending point in ROO, start point = R6+10D
* Sum in R46/47 (1 byte in 2 byte accumulator)
* ********************************************************************
CHECK    LDMD R0,=LWAMEM       ; get end point
         LDM  R14,R6           ; get stack location
         ADM  R14,=(10D).2        ;   + some safety stuff
         JSB  =SUMIT+          ; computer checksum
         RTN                   ;
*
* ********************************************************************
*    BYE
* "Going somewhere, Roo-man?"
* "Ahem."
* ********************************************************************
*    BYE
* The BYE token does sort of a back-door exit if it's being executed
* from the calculator program.  if it is, we stall the program and
* fake a nap key so we can go to sleep.  This way, appointments can
* wake up a BYE cause it's not really running a program. (sob)
* ********************************************************************
         DATA  241              ; normal attributes
BYE.     BIN                   ;
         CMB  R16,=1           ; in the calc program?
         IFEQ
           JSB  =STALL           ; else halt this program
           LDB  R2,=BYEKEY       ; let's go to sleep
           JSB  =PUTKEY          ; throw out the nap key
           RTN                   ;
         ENDIF
*
* ********************************************************************
* ZZZZZZ goes to sleep and returns to you when we're validly woken up.
* If woken up invalidly, we go back to sleep.
* ********************************************************************
* **
* ** Test for fixing; sleep in BASIC in ROM
* **
ZZZZZZ   BIN                   ;
         JSB  =UNLRP?          ; set timeout & unlisten if necessary
         LDBD R#,=PWRFLG       ; r# =r55 here
         IFZR                  
           JSB  =CMPCHK          ; give comparator a chance
           LDBD R25,=TMRFLG      ; Check for pending timers
           IFNZ
             LDB  R25,=EDITKY      ; set BASIC mode key
             RTN                   ; go process
           ENDIF
           TSB  R16              ; are we running something?
           IFZR
             JSB  =SYSJSB          ;
               DEF  APPROC           ; go process an appointment
             LDB  R36,=NAPKEY      ; get return mode (so we will go to sleep later)
             REZ               ; skip out if an appointment there
           ENDIF
         ENDIF
* ** R25 was set to a mode key
*
* ** disable comparator interrupt here to minimize window f...
* ** interrupt (which will mess up timers and appts)
*
         JSB  =CMPDSA          ;
*
* ** roms yanking control away from us via a handi call wil...
* ** have to reenable the comparator.  They can tell if thi...
* ** is necessary by doing so for all handi calls between
* ** SLEE and WARM
*
* ** OK boys, we're going to go to deep sleep!
*
         JSB  =HANDI0          ; give roms a chance
         VAL  V.SLEE           ; the sleep event
*
* ** check if low power warning is needed
*
         LDBD R2,=PWRFLG       ; test for low power
         IFNZ                  ; jif batteries NOT low
*
           JSB  =WARN            ;
           DATA  14D              ; low batteries message
         ENDIF
*
* ** unlisten loop and turn off pil oscillators
*
         JSB  =UNLRP?          ; turn off pil devices if needed
         JSB  =PILOF!          ; make sure pil oscs are off
*
* ** The following rouine is necessary for equality of
* ** checksums when there is something in the LCD
* ** the flag LETSEE was FF before sleep and 0 after!
* **
* ** I disagree with that.
* **
* ** We merely clear out the LETSEE flag so that
* ** we don't erroneously wait to see previous output
* ** after we wake up (the output's long gone.)
*
         JSB  =UNSEE           ;
         STBD R#,=GINTDS       ; Make sure no one changes RAM
         JSB  =CMPENA          ; reenable the comparator
*
* ** Clear the "key waiting" bit in SVCWRD
* ** in case some cornball hit a key after the BYE
* ** so that key that he hit won't appear
* ** after we wake up.
* ** We've effectivly (sp?) neutralized that key.
*
         LDB  R2,=NOT#0        ; get "KEYHIT is valid" flag
         ANMD R2,=SVCWRD       ; clear bit#0 (ignore R3 result)
         STBD R2,=SVCWRD       ; replace SVCWRD (note 1-byte store, sickening ain't it)
         PUMD R2,+R6           ; make hole checksum
         LDM  R2,=(WAKEUP_ZZZ).2    ; where to return to
         PUMD R2,+R6           ; save for a later return
         LDM  R70,R6           ; R70=R6,10,12,14
         LDM  R76,R16          ; R70=R6,10,12,16
         STMD R70,=TMPMM2      ; save those registers
         JSB  =CHECK           ; compute ram checksum
         STMD R46,X6,(-4D).2    ; sve checksum (in front of return to wakeup)
         LDM  R2,=040H,0DFH    ; deep sleep + light sleep code
         GTO SETPSB            ; put us to sleep
*
* ********************************************************************
* When something wakes us up (ATTN, comparator) we go through the wake
* up vector which will send us to the startup stuff in KR&EXE.
*
* After that stuff determines that this is a warmstart (by checking
* POR) it will restore the registers from TMPMM2 and RTN, which will
* put us at WAKEUP.
*
* Now that we know we don't need to coldstart, all we need to do is
* enable the battery low level detect, enable the global interrupt
* enable, and send a CRLF to the LCD.
*
* Then we're back to where we were!  (notice the pleasing combination
* of alternating e's...)
* ********************************************************************
WAKEUP_ZZZ
         JSB  =UNROM           ; turn off all roms
         STBD R#,=ROM3EN       ; force system rom
         LDB  R25,=EDITKY      ; go to editing when done
         LDMD R2,=KEYSTS       ; who woke us up?
         ANM  R2,=(0010H).2    ; test wake up bit
         IFNZ
           LDB  R25,=NAPKEY      ; COMPAR wakeup
         ENDIF
         JSB  =BOUND           ;
         CMMD R34,=LWAMEM      ;
         JLO  KILLIT           ; jif ram removed, coldstart
         PUMD R34,+R6          ; make R6 = sleep point
         JSB  =CHECK           ; get checksum in R46
         POMD R2,-R6           ; pop junk (sleep rtn)
         POMD R2,-R6           ; get old checksum
         CMM  R2,R46           ; compare old and new
         IFNE                  ; if checksum different
KILLIT     JSB  =ERRREP          ; generate error, report it
           DATA  17D              ; checksum error
           GTO START             ; coldstart
         ENDIF
*
         LDM  R30,R34          ; save for COPY
         LDM  R20,R34          ; get new upper bound
         SBMD R20,=LWAMEM      ; get difference of new and old
         IFNZ
           LDMD R34,=LAVAIL      ; location to copy from
           LDMD R32,=LWAMEM      ; old bounds
           SBM  R32,R34          ; amount for copy to move
           SBM  R30,R32          ; calculate plce to move to
* ** R34=from R30=to R32=length
           JSB  =COPY            ; move lavail to lwamem
           LDM  R60,R20          ; move size to R60 (ignore garb
           STM  R60,R62          ;  and propagate (ignore R70/7
           ADMD R60,=LAVAIL      ;
           STMD R60,=LAVAIL      ;
         ENDIF
         CLM  R36              ;
         STMD R36,=CRDRDR      ; make sure card reader is off
         LDB  R36,=2           ; clear any
         STBD R36,=KEYSTS      ;   pending key interrupt
         LDBD R36,=STAND?      ; do we need to turn pil oscs on?
         IFOD                  ; if yes
           JSB  =PILON!          ; turn on pil oscillators
         ENDIF
         JSB  =CLRINT          ; reinitialize intercepts
         JSB  =CLRLCD          ; clear lcd & re-display annuns
         JSB  =B.INIT          ; do low battery stuff
*
* ** B.init enables global interrupts
*
* ** Remember the previous rom # that ROMSET will trash
*
         LDMD R22,=ROMNUM      ; get the ROM #
*
* ** we're really waking up now!
*
         JSB  =ROMSET          ; set up that rom table!
*
* ** re-enable the previous rom
*
         JSB  =GETRM2          ; enable ROM R22
         IFNZ                  ; we could not find it
*
           JSB  =ERROR           ; else report
           DATA  18D              ; missing ROM
         ENDIF
*
         CMB  R25,=NAPKEY      ; Processing comp wakeup?
         JZR  GTOZZZ           ; jif yes, try to go back to sleep
*
         JSB  =SYSJSB          ; Check the lock
           DEF  LOCK?            ;   password
*
         JNZ  GTOZZZ           ; jif no good, go back to sleep
         LDBD R3,=PLSTAT       ; clear iorom bit in plstat
         ANM  R3,=NOT#7        ;   in case iorom pulled out
         STBD R3,=PLSTAT       ;   while we were asleep
         JSB  =UNLRP?          ; set up timeout flag if needed
*
         JSB  =HANDI0          ; tell roms
         VAL  V.WARM           ; the warmstart event
*
* ** is bin already set?...
*
         BIN                   ;
         LDM  R66,=DIRECT      ; start of directory
krzzz_l1 LDMD R0,R66           ; if done, this =0
         RZR                   ; done with wakeup routine
         LDMD R40,X66,DR.NAM   ; check file name
         CMB  R40,='.'         ; '.'
         IFEQ                  ; if  starts with a '.'
           JSB  =HANDI0          ;
           VAL  V.VOLT           ; volatile file! whoopie
           IFEN                ; if not handled
             JSB  =EDPURG          ;
             JMP  krzzz_l1         ; stay on this entry
           ENDIF
         ENDIF
*DIFF    ADM  R66,=START+      ; move to next file
         ADM  R66,=(DRENSZ).2      ; move to next file
         JMP  krzzz_l1         ;
*
GTOZZZ   GTO ZZZZZZ            ; go back and sleep again!!!
*
* ********************************************************************
* AWAKE! Routine to set power supply status to full awake.
* SETPSB Routine to change the bits in the Power Supply Status Byte.
* SETPSB Expects R2=Bit(s) to set (=0 if only want to clea...
*                R3=Bit(s) to clear
*                             bit=0 to clear, bit=1 to sav...
*        clear bits are done before set bits
* ********************************************************************
AWAKE!   LDM  R2,=020H,0BFH    ; fully awake hardware code
SETPSB   ANMD R3,=PSSB         ; get and set status bits
         ORB  R3,R2            ; set other status bits
         STBD R3,=PSSB         ; put it back
         RTN                   ;
       TITLE 'krut1'
*
*  __________________________________________________________________
* |IVUT1 538 05/10/82 - 5/13/1982 4:13PM                             |
* |==================================================================|
* ||                                                                ||
* ||   @@@@@@@@@@  @@      @@  @@      @@  @@@@@@@@@@      @@       ||
* ||   @@@@@@@@@@  @@      @@  @@      @@  @@@@@@@@@@     @@@       ||
* ||       @@      @@      @@  @@      @@      @@        @@@@       ||
* ||       @@      @@      @@  @@      @@      @@       @@@@@       ||
* ||       @@       @@    @@   @@      @@      @@          @@       ||
* ||       @@       @@    @@   @@      @@      @@          @@       ||
* ||       @@       @@    @@   @@      @@      @@          @@       ||
* ||       @@        @@  @@    @@      @@      @@          @@       ||
* ||       @@         @@@@     @@      @@      @@          @@       ||
* ||       @@         @@@@     @@@    @@@      @@          @@       ||
* ||   @@@@@@@@@@      @@       @@@@@@@@       @@      @@@@@@@@@@   ||
* ||   @@@@@@@@@@      @@        @@@@@@        @@      @@@@@@@@@@   ||
* ||                                                                ||
* ||                    Last edited: 82098.1333                     ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* UTILITY ROUTINES
* ********************************************************************
* PAR1
* OUTPUT:
* 		R2=1 byte that R6 pointed to when you called PAR1.
* 		R6:=R6+1
* CHANGES: PROTEM
* ********************************************************************
PAR1     STMD R44,=PROTEM      ; save these suckers
         POMD R44,-R6          ; R44/45=his return address
* 								R46/47=our return address
         POBD R2,+R44          ; get that byte
         PUMD R44,+R6          ; put those addresses back
         LDMD R44,=PROTEM      ; restore those suckers
RETURN   RTN                   ; see note below
*
* ********************************************************************
* RETURN (above)
* Occasionally the address of a RTN instruction is required.  (for
* initializing intercepts, say.)  One such return is above.
*
* Don't forget the global equate RTN if you just want the value 9E.
* ********************************************************************
*
* ********************************************************************
* APFILE: Regular filename for appointment file
* APFILO: Temporary filename for appointment stuff
* IOFILE: Name of the io file
* ********************************************************************
IOFILE   DATA  "iofile  "       ;
APFILO   DATA  "appt0   "       ;
APFILE   DATA "appt"           ; we will use the four blanks below
* ********************************************************************
* BLANKS
* Eight blanks for public consumption.
* If you want a single blank, the global equate BLANK is available.
* Note that these blanks are used by the above constant
* ********************************************************************
BLANKS   DATA "        "       ;
* ********************************************************************
* NULERT This is an error message table that contains no error messages.
* ********************************************************************
NULERT   DATA  0                ; start at error zero
         DATA  0FFH             ; end of table
*
* ********************************************************************
* SEARCH This will search TABLE for the contents of R#, which is one
* byte.  Call it like this:
*
* 	DRP R<whatever has the byte in it>
* 	JSB =SEARCH
* 	DEF TABLE		of bytes to look at
*
* Upon return:
* 	E=0  -> if the byte was found.
* 	E=1  -> if the byte was not found.
* 	R0/1 -> the two byte index into TABLE if the byte was found.
* ********************************************************************
SEARCH   BIN                   ;
         STB  R#,R3            ; save search byte
         POMD R0,-R6           ; get return address
         PUMD R0,+R6           ; put it back on...
         LDMD R0,R0            ; get table address
         CLE                   ; assume failure
         ICE
         LOOP
* ** loop through the table looking for R3
           POBD R2,+R0           ; get an entry
           JZR  krut1_l1         ; jif end of table
           CMB  R2,R3            ; a match?
         WHNE
* ** success!
         CLE                   ; indicate sucess
krut1_l1 POMD R#,-R6           ; get return address (into R2)
         SBMD R0,R2            ; make address to index
         DCM  R0               ; compensate for POBD
         ICM  R2               ; skip past 1st byte
         ICM  R2               ; pas 2nd byte of addr
         PUMD R2,+R6           ; put addr back on stack
         RTN                   ;
*
* ********************************************************************
* LOOKUP This will search TABLE for the contents of R#, which is one
* byte.  Call it like this:
*
* 	DRP R<whatever has the byte in it>
* 	JSB =LOOKUP
* 	DEF TABLE         of bytes & addresses
*
* Upon return:
* 	E=0  -> if the byte was found.
* 	E=1  -> if the byte was not found.
* 	R0/1 -> the corresponding address
* 	R2/3 -> the corresponding address-1
* ********************************************************************
LOOKUP   BIN                   ;
         STB  R#,R3            ; save search byte
         POMD R0,-R6           ; get return address
         PUMD R0,+R6           ; put it back on...
         LDMD R0,R0            ; get table address
         CLE                   ; assume success
* ** loop through the table looking for R3
         LOOP
           POBD R2,+R0           ; get an entry
           JZR  krut1_l2         ; jif end of table
           CMB  R2,R3            ; a match?
           JZR  krut1_l3         ; jif yes
           POBD R2,+R0           ; kill byte 1 of address
           POBD R2,+R0           ; kill byte 2 of address
         WHMP
*
krut1_l2 ICE                   ; indicate failure
krut1_l3 POMD R#,-R6           ; get return address (R2)
         ICM  R#               ; skip past 1st byte
         ICM  R#               ; past 2nd byte of addr
         PUMD R#,+R6           ; put addr back on stack
         POMD R0,+R0           ; get corresponding address from table
         LDM  R2,R0            ; copy address
         DCM  R2               ; point at the byte value in front of it
         RTN                   ;
       TITLE 'krut2'
*
*  __________________________________________________________________
* |IVUT2 541 05/10/82 - 5/13/1982 4:15PM                             |
* |==================================================================|
* ||                                                                ||
* ||   @@@@@@@@@@  @@      @@  @@      @@  @@@@@@@@@@     @@@@      ||
* ||   @@@@@@@@@@  @@      @@  @@      @@  @@@@@@@@@@   @@@@@@@@    ||
* ||       @@      @@      @@  @@      @@      @@      @@@    @@@   ||
* ||       @@      @@      @@  @@      @@      @@              @@   ||
* ||       @@       @@    @@   @@      @@      @@             @@@   ||
* ||       @@       @@    @@   @@      @@      @@            @@@    ||
* ||       @@       @@    @@   @@      @@      @@          @@@      ||
* ||       @@        @@  @@    @@      @@      @@        @@@        ||
* ||       @@         @@@@     @@      @@      @@       @@@         ||
* ||       @@         @@@@     @@@    @@@      @@      @@@          ||
* ||   @@@@@@@@@@      @@       @@@@@@@@       @@      @@@@@@@@@@   ||
* ||   @@@@@@@@@@      @@        @@@@@@        @@      @@@@@@@@@@   ||
* ||                                                                ||
* ||                    Last edited: 82098.1330                     ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* This file contains some utility routines.
* ********************************************************************
*
* ********************************************************************
* DaysInMonth and SecondInDays data
* ********************************************************************
DTAB-1   DATA  31C              ; Default max #days =31
DTAB0    DATA  220              ; NOP dummy place holder
         DATA  31C,29C,31C      ; Table of days in month for
         DATA  30C,31C,30C      ; 	leap years (BCD)
         DATA  31C,31C,30C      ; 	continued 6 bytes down
DAYSEC   DATA  200,121,1,0,0    ; # of seconds in a day
         DATA  0                ; Place holder to align table
         DATA  31C,30C,31C      ; Day table continuation
*
* ********************************************************************
* KOPY Byte Copy Routine - To copy bytes from a source address to a
* desitination address.
* FUNCTIONS:
* 	(1) Copies a number of bytes (specified by R73) from a source
* 		address (specified by R74/75) to a destination address
* 		(specified by R76/77) one at a time in a forward direction.
*
* ENTRY:
* 	BIN
* 	R73		Number of bytes to be copied (1 to 256)
* 	R74/75	Source address
* 	R76/77	Destination address
* EXIT:
* 	R73		0
* 	R74/75	One past end of source bytes
* 	R76/77	One past end of destination bytes
* VOLATILE:	status, R72/77
* Maximum stack depth := 2
* REFERENCES:                  REGISTERS:   0 1 2 3 4 5 6 7
*   <NONE>                               0:
*                                        1:
*                                        2:
*                                        3:
*                                        4:
*                                        5:
*                                        6:
*                                        7:     X I I I I I
* ********************************************************************
*
* ********************************************************************
* The first instruction loads R72 with a byte from the source address
* (R74/75) and then increments this address.  The following instruction
* stores this byte (R72 at the destination address (R76/77)( and then
* increments this address. The susequent instruction decrements the
* byte count index (R73).  The following instruction will repeatedly
* loop back to KOPY until R73 is decremented to zero (done) at which
* point it drops through to the return instruction.
* ********************************************************************
KOPY     POBD R72,+R74         ; R72 := byte from source
         PUBD R72,+R76         ; Store byte to destination
         DCB  R73              ; Decrement byte count
         JNZ  KOPY             ; Loop until done
         RTN                   ; Return
*
* ********************************************************************
* NUMCHK Numeric Check & Encode Routine - To test for an ASCII numeric
* string in a two byte register and return its BCD value (or an error
* flag as appropriate).
* FUNCTIONS:
* 	(1) Eliminate a leading or trailing blank in R20/21 if one exists
* 		(supplying a leading zero)
* 	(2) Check the contents of R20/21 for an ASCII numeric string
* 		(returning E=1 if its not a umeric string.
* 	(3) Convert the string to its BCD value and return this value in
* 		R21 with R20 equal to zero. (E=0)
*
* ENTRY: (BIN or BCD)
* 	R20/21	Two byte ASCII numeric string or one numeric byte with
* 		leading or trailing blank (or erroneous garbage that will be
* 		detected)
* EXIT:	(BIN)
* 	R20		Zero
* 	R21		BCD equivalent of the ASCII string
* 	E = 0 if the string was ASCII numeric and converted as described.
* 	E = 1 if the string was not ASCII numeric (R20/21 contain garbage)
* VOLATILE:	status, E reg., R20/21
* Maximum stack depth := 2
* REFERENCES:                  REGISTERS:   0 1 2 3 4 5 6 7
*   <NONE>                               0:
*                                        1:
*                                        2: P P
*                                        3:
*                                        4:
*                                        5:
*                                        6:
*                                        7:
* ********************************************************************
* 	The first instruction sets up BCD mode in order to implement 4 bit
* shifts through the E register.  The next instruction clears the E
* register.  The next two instrucitons test for a trailing blank (blank
* in R21) and jump to the ncnotblk label if not found.  If R21 is a
* blank then next two instructions (LDBs) will move the first byte (R20)
* to the second byte (R21) and replace R20 with a leading zero.
* 	At the ncnotblk label the CMB instrucion tests for a leading blank
* (a blank in R20), jumping back to the nc1blnk label if a blank is
* found where the leading blank (R20) is set to a zero and the test is
* repeated where it will fail (after being set to a zero it won't be a
* blank) and the code drops through to the following instruction.
* 	The next instruction (LLB) will shift the lower byte (R21) left
* four bits (into the E register). If this byte is an ASCII digit then
* it is of the form 3n (hexidecimal) where n is 0 through 9 (n is also
* the BCD value of the ASCII byte).  The LLB instruction will therefore
* shift the BCD value to the left 4 bits of R21 and set the E register
* to 3.
* 	The next CMB instruction compares R21 to A0 (hex) and the following
* instruction jmps to the ncste label (error exit on the next page) if
* there is a carry which indicates that R21 => A0 (hex) in which case
* the BCD value is of the byte > 9 and hence is not an ASCII digit.
* ********************************************************************
NUMCHK   BCD                   ; Set BCD mode
         CLE                   ; Clear E register
         CMB  R21,=BLANK       ; Test 2nd byte
         JNZ  krut2_l2         ; Jump if not blank
         LDB  R21,R20          ; 2nd byte := 1st byte
krut2_l1 LDB  R20,='0'         ; Set leading zero
krut2_l2 CMB  R20,=BLANK       ; Test 1st byte
         JZR  krut2_l1         ; Jump if blank
         LLB  R21              ; Shift up lower byte
         CMB  R21,=240         ; Test lower digit
         JCY  krut2_l3         ; Jump if > 9
* ********************************************************************
* 	At the first instruction (ERB R20), the 4 leftmost bits of R21
* contain the low order BCD digit of the result and the E register
* should contain a 3.  The first instruction shifts the high order byte
* (R20) 4 bits to the right.  This will move the 4 low order bits of
* R20 (which contains the BCD value of the high order numeric digit)
* into the E register and should leave R20 with 3 in the high order
* digit and also a 3 in the low order digit (if R20/21 contained two
* ASCII digits to begin with).
* 	The following instruction (ERB R21) will shift the 4 leftmost bit
* of R21 (the low order BCD digit) into the right 4 bits and shift the
* E register (the high order BCD digit) into the left 4 bits.  This
* leaves R21 with the proper BCD value (if the input was ASCII numeric
* characters).
* 	The following two instructions (CMB & JCY) will jump to the ncste
* label (error exit) if R21 is greater than or equal to A0 (hex)
* indicating that the high order digit in R21 is greater than 9 and is
* therefore not an ASCII digit.  The following two instructions (SBB &
* JZR) check for a 3 in both digits of R20.  If both digits are 3 then
* both bytes were ASCII digits and R20 is set to zero which results in
* ajump to the ncbin label (success exit).  If one of the digits is not
* 3 then one of the bytes was not an ASCII digit, the result in R20 is
* not zero, and the code drops to the ncste label for an error return.
* 	At the ncste label, the two instructions set the E register to 1
* to indicate non-numeric input.  At the ncbin label, the binary mode
* is set and the routine returns.
* ********************************************************************
         ERB  R20              ; E := upper digit
         ERB  R21              ; R21 := number
         CMB  R21,=240         ; Test upper digit
         JCY  krut2_l3         ; Jump if > 9
         SBB  R20,=63          ; Test ASCII bits
         JZR  krut2_l4         ; Jump if numeric
krut2_l3 CLE                   ; E := 1
         ICE                   ;
krut2_l4 BIN                   ; Restore binary mode
         RTN                   ; Return
*
* ********************************************************************
* TOASC2 Two Digit BCD to ASCII Routine - To convert a two digit BCD
* value to a two byte ASCII numeric string.
* FUNCTIONS:
* 	(1) To set R20/21 to the ASCII numeric string of the BCD value
* 		originally contaned in R20.
*
* ENTRY: (BIN or BCD)
* 	R20		Two digit BCD value to be converted
* EXIT: (BIN)
* 	R20/21	Two byte ASCII string result
* 	E reg.	Cleared (0)
* VOLATILE:	status, E reg., R20/21, BCD mode
* Maximum stack depth := 2
* REFERENCES:                  REGISTERS:   0 1 2 3 4 5 6 7
*   <NONE>                               0:
*                                        1:
*                                        2: P O
*                                        3:
*                                        4:
*                                        5:
*                                        6:
*                                        7:
* ********************************************************************
*
* ********************************************************************
* 	The first instruction sets up BCD mode in instruction clears the E
* register.  The next instruction shifts the BCD data (R20) 4 bits to
* the right (this fills the E register with the least significant BCD
* digit and leaves in R20 the most significant BCD digit).
* 	The following instruction clears R21.  The next instruction shifts
* R21 (with the E reg.) 4 bits to the left (this zeros the E register
* and sets R21 with the least significant BCD digit. The following
* instruction sets bits 4 & 5 in each of the two bytes (R20/21) thus
* converting them to ASCII digits. The next instruction sets up binary
* mode, and the last instruction returns.
* ********************************************************************
TOASC2   BCD                   ; Set decimal mode
         CLE                   ; E:=0
         ERB  R20              ; R20 := MSD (BCD)
         CLB  R21              ; R21 := 0
         ELB  R21              ; R21 := LSD (BCD)
         ADM  R20,=60,60       ; Add in ASCII bits
         BIN                   ; Set binary mode
         RTN                   ; Return
*
* ********************************************************************
* TOBCD2 Two Byte Binary to BCD Conversion Routine - To convert an
* 8 bit register from binary to BCD.
* FUNCTIONS:
* 	(1) Convert R20 from binary to BCD.
*
* ENTRY: (BIN)
* 	R20		8 bit binary value that is to be converted to 3 digits of BCD
* EXIT:
* 	R20		2 low order digits of the BCD result
* 	R21		high order digit of the BCD result
* 	
* VOLATILE:	status, R2/3, R21
* Maximum stack depth := 2
* REFERENCES:                  REGISTERS:   0 1 2 3 4 5 6 7
*   <NONE>                               0:     X X
*                                        1:
*                                        2: P O
*                                        3:
*                                        4:
*                                        5:
*                                        6:
*                                        7:
* ********************************************************************
*
* ********************************************************************
* 	The first instruction loads R2 with 372 (octal) which initializes
* the ten's digit (4 left bits) to -1 and initializes the one's digit
* (4 right bits) to 10 (note that adding this value to a register will
* in effect subtract 1 from the ten's digit and add ten to the one's
* digit).  The next instruction loads R21 with -1.
* 	The following three instructions increment R21 and subtract 100
* from R20 until R20 is negative thus yield R21 with the hundreds digit
* of the BCD result and leaving R20 equal to the binary result mod 100
* when 100 is added to it (next instruction).
* 	Starting at the tobcdlp2 label are three instructions that increment
* the ten's digit of R2 (initially -1) and subtract 10 from R20 until
* it is negative.  The following instruction adds R2 to R20 leaving R20
* with the 2 low order digits of the BCD result.  The last instruction
* returns.
* ********************************************************************
TOBCD2   LDB  R2,=372          ; R2 := Ten's digit+10
         LDB  R21,=377         ; R21 := -1
         LOOP
           ICB  R21              ; Increment hundreds digit
           SBB  R20,=100D        ; Subtract 100 from input
         WHCY                  ; Loop until negative
         ADB  R20,=100D        ; R20 := input mod 100
         LOOP
           ADB  R2,=10C          ; Increment ten's digit
           SBB  R20,=10D          ; Subtract 10 from data
         WHPS
         ADB  R20,R2           ; Add ten's digit+10
         RTN                   ; Return
*
* ********************************************************************
* TOBCD8 Eight Byte Binary to BCD Routine - To convert each byte of an
* eight byte register from binary to BCD.  This is not the same as
* converting an eight byte register to BCD since in this routine each
* byte is converted independently.
* FUNCTIONS:
* 	(1) Perform a binary to BCD conversion on each 8-bit register
* 		from R40 to R47.
*
* ENTRY: (BIN)
* 	R40/47	Values to be converted to BCD.
* EXIT:
* 	R40/47	Eight BCD results
* Note: No error checking is done.  Result will be meaningful only if
* 	each byte <=99.
* VOLATILE:	status, R0/1, R20/21
* Maximum stack depth := 4
* REFERENCES:                  REGISTERS:   0 1 2 3 4 5 6 7
*   TOBCD2                               0: X X
*                                        1:
*                                        2: X X
*                                        3:
*                                        4: P P P P P P P P
*                                        5:
*                                        6:
*                                        7:
* ********************************************************************
*
* ********************************************************************
* 	The first instruction initializes R0/1.  R0 is a pointer to the
* byte currently being converted (initially R47). R1 is an index
* (initially 7) that is decremented after each byte is converted
* (8 decrements will make it negative).
* 	The conversion loop begins at the tobcd8lp label where the first
* instruction puts the value to be converted (pointed at by R0) into
* R20.  The following instruction calls TOBCD2 which converts R20 from
* binary to BCD.  The next instruction upst the converted value back
* in the register from which it came (pointed at by R0).
* 	The next instruction decrements the two byte value R0/1 by one in
* each byte (257).  The result of this is that R0 will step from R47
* to R40 while R1 steps from 7 down to 0. Each of these steps results
* in R0/1 having a positive value such that the next instruction (JPS)
* will loop back and repeat the binary to BCD conversion on a new
* byte.  It should be noted that the routine does no error checking
* and therefore the result is meaningful only if each of the 8 bytes
* initially contained a binary value less than or equal to 99.
* 	After the eighth iteration (R0=40 octal & R1=0) the SBM instruction
* will decrement the two byte quantity to a negative value.  The JPS
* instruction will then drop through to the following instruction
* which returns.
* ********************************************************************
TOBCD8   LDM  R0,=47,7         ; R0 at R40; Index:=7
krut2_l5 STB  R*,R20           ; R20 := data
         JSB  =TOBCD2          ; Convert R20 to BCD
         LDB  R*,R20           ; Store BCD data
         SBM  R0,=1,1          ; Update ptr. & index
         JPS  krut2_l5         ; Loop through 8 bytes
         RTN                   ; Return
*
* ********************************************************************
* TOBIN2 Two Digit BCD to Binary Rouine - To convert an 8 bit
* 	register from BCD to binary.
* FUNCTIONS:
* 	(1) Convert R20 from BCD to binary.
*
* ENTRY: (BIN)
* 	R20		BCD value to be converted to binary.
* EXIT:
* 	R20		Binary result.
* VOLATILE:	status, R21
* Maximum stack depth := 2
* REFERENCES:                  REGISTERS:   0 1 2 3 4 5 6 7
*   <NONE>                               0:
*                                        1:
*                                        2: P X
*                                        3:
*                                        4:
*                                        5:
*                                        6:
*                                        7:
* ********************************************************************
*
* ********************************************************************
* 	The first instruction stores the BCD data into R21.  The following
* instruction masks off the lower four bits in R21 isolating the most
* significant BCD digit four places to the left (digit*16 in binary).
* The following two instructions shift the most significant digit (R21)
* two places to the right (digit*4).  The next instruction subtracts
* the digit*4 from the BCD data (R20).
* 	R209 originally contained BCD data which can be represented as
* 16*MSD+LSD (MSD it the most significant digit and LSD is the least
* significant digit). After subtracting 4*MSD R20 contains 12*MSD+LSD.
* 	The following instruction shifts the MSD (R21) another place to
* the right leaving it with 2*MSD.  The next instruction subtracts R21
* (2*MSD) from R20 (12*MSD+LSD) leaving R20 with 10*MSD+LSD which is
* the desired binary equivalent of the BCD data.  The following
* instruction returns from the subroutine.
* ********************************************************************
TOBIN2   LDB  R21,R20          ; R21 := BCD data
         ANM  R21,=360         ; R21 := upper digit
         LRB  R21              ; R21[3:6] := upper digit
         LRB  R21              ; R21[2:5] := upper digit
         SBB  R20,R21          ; R20 := data-4*MSD
         LRB  R21              ; R21[1:4] := upper digit
         SBB  R20,R21          ; R20 := data-6*MSD
         RTN                   ; Return
*
* ********************************************************************
* TOBIN8 Eight Byte BCD to Binary Routine - To convert each byte of an
* eight byte register from BCD to Binary.  This is not the same as
* converting an eight byte register to binary in that in this routine
* each byte is converted independently.
* FUNCTIONS:
* 	(1) Perform a BCD to Binary conversion on each register from
* 		R40 to R47.
*
* ENTRY: (BIN)
* 	R40/47	Values to be converted to binary
* EXIT:
* 	R40/47	Eight binary results
* VOLATILE:	status, R0/1, R20/21
* Maximum stack depth := 4
* REFERENCES:                  REGISTERS:   0 1 2 3 4 5 6 7
*   TOBIN2                               0: X X
*                                        1:
*                                        2: X X
*                                        3:
*                                        4: P P P P P P P P
*                                        5:
*                                        6:
*                                        7:
* ********************************************************************
*
* ********************************************************************
* 	The first instruction initializes R0/1.  R0 is a pointer fo the
* byte currently being converted (initially R47).  R1 is an index
* (initially 7) that is decremented after each byte is converted
* (8 decrements will make it negative).
* 	The conversion loop begins at the tobin8lp label where the first
* instruction puts the value to be converted (pointed at by R0) into
* R20.  The following instruction calls TOBIN2 which converts R20
* from BCD to binary.  The next instruction puts the converted value
* back in the register from which it came (pointed at by R0).
* 	The next instruction decrements the two byte value R0/1 by one in
* each byte (257).  The result of this is that R0 will step from R47
* to R40 while R1 steps from 7 down to 0. Each of these steps results
* in R0/1 having a postive value such that the next instruction (JPS)
* will loop back and repeat the BCD to binary conversion on a new byte.
* 	After the eighth iteration (R0=40 octal & R1=0) the SBM
* instruction will decrement the two byte quantify to a negative value.
* The JPS instruction will then drop through to the following
* instruction which returns.
* ********************************************************************
TOBIN8   LDM  R0,=47,7         ; R0 at R40; Index := 7
krut2_l6 STB  R*,R20           ; R20 := data
         JSB  =TOBIN2          ; Convert R20 to binary
         LDB  R*,R20           ; Store binary data
         SBM  R0,=1,1          ; Update ptr. & index
         JPS  krut2_l6         ; Loop through 8 bytes
         RTN
ALTROM#  EQU 01H        
       TITLE 'krpar'
*
*  __________________________________________________________________
* |KXPAR 335 06/24/82 - 7/ 6/1982 11:58AM                            |
* |==================================================================|
* ||                                                                ||
* ||   @@     @@@  @@      @@  @@@@@@@@      @@@@@@    @@@@@@@@     ||
* ||   @@    @@@   @@      @@  @@@@@@@@@    @@@@@@@@   @@@@@@@@@    ||
* ||   @@   @@@    @@@    @@@  @@     @@@  @@@    @@@  @@     @@@   ||
* ||   @@  @@@      @@@  @@@   @@      @@  @@      @@  @@      @@   ||
* ||   @@ @@@         @@@@     @@     @@@  @@      @@  @@     @@    ||
* ||   @@@@@           @@      @@@@@@@@@   @@@@@@@@@@  @@@@@@@      ||
* ||   @@@@@           @@      @@@@@@@@    @@@@@@@@@@  @@@@@@@      ||
* ||   @@ @@@         @@@@     @@          @@      @@  @@    @@@    ||
* ||   @@  @@@      @@@  @@@   @@          @@      @@  @@     @@@   ||
* ||   @@   @@@    @@@    @@@  @@          @@      @@  @@      @@   ||
* ||   @@    @@@   @@      @@  @@          @@      @@  @@      @@   ||
* ||   @@     @@@  @@      @@  @@          @@      @@  @@      @@   ||
* ||                                                                ||
* ||                    Last edited: 82098.1354                     ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* Contains fix for DATA 1.1X but (#954)
* Bug was in ver$=aaaaaa
* Fix in routine DATA
* Zero-byte fix.  tr
* ********************************************************************
*
* ********************************************************************
* Contains fix for CONT 10,20 but (#960)
* Bug was in ver$=aaaaaa
* Fix in routine G01N
* Zero-byte fix.  tr
* ********************************************************************
*
* ********************************************************************
* 	examples of statements and how they are interpreted by the parser
* can most easily be shown by these two tables.
* NOTE: order of attempted parse is:
* 	1. program statements
* 	2. calculator statements
* 	3. calculator expressions
* 	4. program expressions
*
* when editing a BASIC file:
*
*        program        calculator
*
*  +----------------+----------------+
*  |                |                |
*  |  10 X          |    X           |
*  |  10X+1         |    10E+1       | expressions
*  |              <-|--- 10+2        |
*  |                |    (x=5)    ^  |
*  |                |             |  |
*  +----------------+----------------+
*  |                |             |  |
*  |  10 BEEP       |    X=5      |  |
*  |  20<null>  ----|->  BEEP        | statements
*  |                |    <null>      |
*  |                |                |
*  +----------------+----------------+
*
* The <null> statement will delete the line# given.
* 20<null> will delete statement 20.
*
* 	"Computational consistency, Roo-man, that's great!"
* 	"All in a days work, Joey."
* 	"Admit it, you vulcanized imitation of an outback marsupial!  You
* didn't plan that!  You were lucky!!!"
* 	"Who is that?  What does he mean, Roo-man?"
* 	"Uh, ehr, just some nut, Joey.  Ignore him."
*
* ********************************************************************
*
* ********************************************************************
*
* When editing a text file:
*
*        program        calculator
*
*  +----------------+----------------+
*  |                |                |
*  |                |    (10+2)      |
*  |  never here  <-|--- X           | expressions
*  |                |             ^  |
*  |                |             |  |
*  +----------------+----------------+
*  |  10 BEEP       |             |  |
*  |  10E+1         |    X=5      |  |
*  |  10+2      ----|->  BEEP        | statements
*  |  10<null>      |    <null>      |
*  |  10Sky king    |                |
*  +----------------+----------------+
*
* 	There can be no program expressions in a text file because
* anything with a line number gets sucked into being a program
* statement (that is, program text.)
*
* ********************************************************************
*
* ********************************************************************
* INIT PARSER POINTERS
*
* EDSETI/CLSETI:
* 	set R16 to run/calc status,
* 	set PRFILE to edit/calc name,
* 	initialize parsing pointers with INIPRS.
* INIPRS: initialize the pointers for the parser.
*
* OUTPUT:
* 	R10: pointer into input buffer
* 	R20: first non-blank character
* ********************************************************************
EDSETI   LDB  R16,=RUNSTS      ; set up run status
         LDMD R40,=EDNAME      ; get edit file name
         JMP  SETINI           ; go set PRFILE=editname
*
CLSETI   LDB  R16,=CLCSTS      ; set up calculator status
         LDMD R40,=CALNAM      ; get calculator file name
SETINI   JSB  =SETPR           ; set parameter file name
INIPRS   LDM  R10,=INPBUF      ; reset input pointer
INIPR-   JSB  =GCHAR           ; get first char to R20
SETR12b  LDMD R12,=TOS         ; reset R12 to top-of-stack
         RTN                   ;
*
* ** is it program, statement, expression?
*
PARSER   JSB  =HANDI0          ; give the roms achance
         VAL  V.PAR            ; this is the parsing event
*
* ** since parse errors compete based on SAVR10,
* ** set SAVR10=0 so anybody can beat it.
*
         CLM  R2               ;
         STMD R2,=SAVR10       ; anybody can beat this!
         LDMD R45,=ERLIN#      ; save the old last errors
         STMD R45,=PERRSV      ; save them away
*
* ** try program statement with line number
*
         JSB  =EDSETI          ; R16=run, PRNAME=editfile, init
         JSB  =INTEGR          ; try to get a line number
         BIN                   ; return to binary mode
         IFEN                  ; if  have a line number
           JSB  =STPARS          ; try the statement parse
           CLB  R16              ; back to idle (don't execute it)
           JEZ  EDITIT_PAR       ; go edit if successful
           JSB  =SAVERR          ; save and clear the error
         ELSE
* ** don't have to try calculator statement if and only if
* ** there was a line number
*
* ** try calculator statement
*
           JSB  =CLSETI          ; R16=calc, PRFILE=calcfile, init
           CLM  R40              ; set line number to 0000
           JSB  =STPARS          ; try a statement
           JEZ  EDITIT_PAR        ; go put it in if it's good
*
* ** PLEASE NOTE THAT IF WE WERE TO DELETE THE 0TH LINE OF THE
* ** CALCULATOR FILE THAT WE CAN STILL EXECUTE BECAUSE WE'LL
* ** HIT THE END STATEMENT IN THE CALC FILE.
*
* "Cataclysmic case-folding, Roo-man!  Upper case?"
* "Must be a relic from ancient times, lad.  Don't touch it."
*
           JSB  =SAVERR          ; save and clear the error
         ENDIF
*
* ** try a calculator expression
*
         JSB  =CLSETI          ; R16=calc, PRFILE=calcFile, init
         CLM  R40              ; set line number back to 0000
         JSB  =EXPARS          ; try an expression
         JEZ  EDITIT_PAR       ;
         JSB  =SAVERR          ; save and clear the error
*
* ** try program expression with line number
*
         JSB  =EDSETI          ; R16=run, PRNAME=editfile, init
         JSB  =INTEGR          ; try to get an integer
         BIN                   ;
         IFEN                  ; if  get one
           JSB  =EXPARS          ; parse an expression
           CLB  R16              ; back to idle
           JEZ  EDITIT_PAR           ;
           JSB  =SAVERR          ; save and clear the error
         ENDIF
*
* ** we got a parse time error
*
         CLB  R16              ; don't execute nothing!
         JSB  =STALL           ; set the stall bit
         LDMD R41,=ERRTMP      ; get error stuff
         STMD R41,=ERLIN#      ; restore the error stuff
         LDMD R10,=SAVR10      ; get R10 for error messages
PAREX    JSB  =ANYER?          ; set E if we had any errors
         JMP  SETR12b          ; reset R12 to top of stack
*
* EDITIT does the line editing for the parser
*
EDITIT_PAR
         BIN                   ; for the addition
         JSB  =CLRERR          ; clear any pending errors
         LDMD R45,=PERRSV      ; get previous ERRN and ERRL
         STMD R45,=ERLIN#      ; restore them
         LDMD R32,=STSIZE      ; calculate (-) size
         SBM  R32,R12          ; 	of statement
         NCM  R32              ; make that size positive
         JSB  =LINEDR          ; edit in the line in PRFILE
         JMP  PAREX            ; clean up stack
*
* ********************************************************************
* SAVERR - We've gotten a parsing error, is this a "better" error than
* the previous one? It is better if ERRR10 (R10 at errortime) is
* > any previous ERRR10.  This implies that we got further, you see.
* ********************************************************************
SAVERR   LDMD R46,=ERRR10      ; get R10 at time of error
         CMMD R46,=SAVR10      ; is it better?
         IFNE
           IFCY
             STMD R46,=SAVR10      ; save parsing pointer
             LDMD R41,=ERLIN#      ; get error stuff
             STMD R41,=ERRTMP      ; save it
           ENDIF
         ENDIF
         JSB  =CLRERR          ; clear the error
         RTN                   ;
*
* ********************************************************************
* PARSIT - main parse inner loop
*
* 	"Roo-man, what is this strange test about after THEN or not after
* THEN and what are attributes and why is the sky blue and what are
* Labiatae and ... "
* 	"Slow down youngster," chuckled prolific producer of procedures.
* "With each token there is an attribute, which is at least a byte,
* the first two bits of which have the following meaning to the parser.
*
* 	  value in		meaning
* 	   binary
* 		00			a token not to appear at the start of a statement
* 					(can be at the start of an expression)
* 		01			not to be in a user's basic program
* 		10			legal after a THEN
* 		11			illegal after a THEN
*
* 	"Really, Roo-man!? Gosh."
* 	"Yep.  And by the way, the sky is blue due to selective scattering
* of the sun's light and Labiartae is the scientific name for the
* mint family."
* ********************************************************************
PARSE@   PUBD R#,+R12          ; for line continuation
PARSIT   JSB  =SCAN            ; get a BASIC statement
PARSE!   CMB  R14,=4           ; is it a variable?
         IFNC                  ; yes
           LDB  R14,=LETTOK      ; implied LET token
           LDB  R47,=200         ; attribute of BASIC statement
         ELSE
           LDB  R14,R43           ; kill tokens 370 and 371
         ENDIF
         LDMD R36,=THENFL      ; need to check THEN? (see THEN f
         DRP  R47              ; save a DRP
         IFNZ                  ; if we are after then
           CMB  R47,=300         ; legal after a "THEN"?
           JCY  THENER           ; jif no, error
         ENDIF
         TSB  R47              ; >200?
         JNG  TYPEOK           ; jif yes, don't check R16
         CMB  R#,=100          ; BASIC system call?
         JNC  PRSERR           ; jif no, not BASIC
         TSB  R16              ; sys must be calc mode
         JEV  PRSERR           ; jif not calc, error
TYPEOK   LDMD R36,=ROMPTR      ; get pointer to roms
         LDMD R36,X36,RM.PAR   ; ~addr of parse table
         ADMD R36,=ROMOFF      ; address of parse table
         ADM  R36,R14          ; add the offset for token
         ADM  R36,R14          ; 	*2
         LDMD R36,R36          ; ~parse routine address
         ADMD R36,=ROMOFF      ;
*
* ** save input rom number
         PUBD R41,+R6          ; 1st byte of rom number
         PUBD R42,+R6          ; 2nd byte of rom number
         JSB  X36,ZRO          ; call the ROOtine
         POMD R2,-R6           ; get rom number back
         TSB  R17              ; see if error found
         RNG                   ; jif error found
         DCM  R2               ; was that rom one?
         IFZR                  ; yes
           LDM  R54,=EROMTK,(ALTROM#).2,0   ; load VAL EROMTK, DEF ALTROM, BYT 0
                                 ; EROMTK is 00B4H, ALTROM is 01H DAD
           POBD R57,-R12         ; get token off stack
           PUMD R54,+R12         ; put <switch>,<rom#>,<token>
         ENDIF
         JSB  =ROMRTN          ; enable system rom
         CMB  R14,=BANGTK      ; in line comment?
         JEQ  PARSE!           ; jif yes
         CMB  R14,='@'         ; line continuation? ('@')
         JZR  PARSE@           ; jif yes, continue
         RTN                   ;
*
PRSERR   JSBN  =ERROR+          ;
         DATA 88D              ; ERROR 88: BAD STMT
*
THENER   JSBN  =ERROR+          ;
         DATA 86D              ; ERROR 86: ILLEGAL AFTER THEN
*
* ********************************************************************
* LINHED - pushes header for lines
* STATUS: E=1 if error
* ********************************************************************
LINHED   LDM  R2,R40           ; get line number
         PUMD R2,+R12          ; push to output
         STMD R12,=STSIZE      ; save position
         ICM  R12              ; save space for statement size
         TSM  R42              ; line number>4 digits?
         JNZ  ERR90            ; error if >4 digits
         CLE                   ; set flag NO error
stprtn   RTN                   ;
*
* ********************************************************************
* STPARS - program statement parsing.  This routine is called if an
* integer (possible line#) has been seen.
*
* INPUT: R40/41 - the line number seen
* 		 PRNAME - the target file
* ********************************************************************
STPARS   JSB  =LINHED          ; push the line head stuff
         REN
*
* ** basic or text?
         LDMD R40,=PRNAME      ; name of file which we are editting
         LDB  R14,=TYRUN?      ; mask for access byte
         JSB  =FOPAC?          ; zero flag is set based on mask
         IFEQ                  
*
* ** do program parse
           CMB  R20,=CR          ; a null line?
           IFNE                  ; if nothing to parse
             JSB  =SAVEME        ; save us from SCAN's rom switching
             JSB  =PARSIT        ; parse the statement
             JSB  =EOL_KRPAR     ; insist on end of line.
           ENDIF     
         ELSE
*
* ** parse a text mode statement (easy as -ln(-1)/i)
* ** just copy the bytes!
*
* ** first, retract those blanks after the line number.
* ** Since we got the line number with INTEGR, R20 now has the 1st
* ** non-blank (or CR) and R10 points one past that (or at CR).
*
* ** for instance:
* **
* ** 10 x=1
* **     |
* **     R10   R20='x'
* **
* ** 10
* **   |
* **   R10   R20=CR
* **
           JSB  =BACK10          ; go back if R20#CR
           LOOP
              DRP !20
              ARP !10
              POBD R20,-R10           ; get the previous byte
              CMB  R20,=BLANK        ;
           WHEQ
           POBD R20,+R10           ; pop that non-blank off
           LOOP
             DRP !20
             POBD R20,+R10          ; get a byte of statement
             PUBD R20,+R12          ; push to output
             CMB  R20,=CR           ; end of input line?
           WHNE
           POBD R20,-R12          ; pop off that CR we didn't want
         ENDIF
         JSB  =ANYER?          ; return E flag if any errors
         RTN                   ;
*
* ********************************************************************
* EXPARS - Expression parse
* ********************************************************************
EXPARS   JSB  =LINHED          ; push line number and size
         REN                   ; return if error
*
* ** assume a display statement, fake a scan of DISP:
         CLM  R40              ; clear out rom#, etc.
         CLM  R14              ; clar R15 (like SCAN does)
         LDB  R14,=DISPTK      ; get DISPlay token
         STB  R14,R43          ; duplicate that token
         LDB  R47,=241         ; get proper DISP attributes
         JSB  =ROMRTN          ; scanner leaves the right rom enabled
         JSB  =SAVEME          ; save us from SCAN's rom switching
         JSB  =PARSE!          ; go parse a normal statement
         JSB  =EOL_KRPAR       ; do end of line token
         JSB  =ANYER?          ; set E if any errors
         RTN                   ;
*
* ********************************************************************
* EOL - does clean up at the end of the line to be parsed.
* ********************************************************************
EOL_KRPAR
         BIN                   ; for repeat parses
         JSB  =DMDCR-          ; demand a carriage return
         JSB  =INRTN?          ; put in an invisible return?
         ARP  !12
         DRP  !2
         LDB  R2,=EOLTOK       ; push line terminator
         PUBD R2,+R12          ; to output stack
         RTN                   ; done!
*
* ********************************************************************
* INRTN? - Push out an invisible return token (and clear the RTNFLG)
* if we need to.
*
* OUTPUT:
* 	DRP=2
* 	ARP=12
* ********************************************************************
INRTN?   LDBD R2,=RTNFLG       ; Need invisible return?
         ARP  R12              ; we promise this for output
         IFNZ                  ;
           LDB  R2,=10H          ; get INVRTN token
           PUBD R2,+R12          ; push to stack
           CLB  R2               ; clear
           STBD R2,=RTNFLG       ; 	return flag
         ENDIF
         RTN                   ;
*
ERR90    JSB  =ERR1+           ; illegal line#
         DATA  90D              ; ERROR 90: BAD LINE NUMBER
*
* ********************************************************************
* SFSCAN - a rom-safe call to SCAN.
* 	You see, if SCAN scans something in an external rom, it returns
* with that rom enabled.  While this is usually cool, occasionally we
* must use SYSJSB to get around this because the caller of SCAN is
* himself in an external rom.
* 	Hence, the creation of SFSCAN, the "safe SCAN," which is guaranteed
* to return with the same rom enabled as was enabled when you called it.
* ********************************************************************
SFSCAN   JSB  =SYSJSB          ; call a routine, remember rom
         DEF  SCAN             ; call routine scan
         RTN                   ; enable previous rom (from SYSJSB)
*
* ********************************************************************
* SCANNER - The scanner saves R21/37 and R50/57.  It uses R50-57.
*
* IF THE INPUT IS:			SCANNER DOES:
*
* numeric digit				forms integer or float
* period					forms floating number
* single quote				returns ', no GCHAR
* double quote				returns ", no GCHAR
* word in table				returns token number
* variable not in tables	returns variable type
* other						returns the character
*
* output:
* 	R40					first character searched
* 	R41/42				two byte rom id number (the system rom's id=0)
* 	R43					rom token# (if R14=370)
* 		or...			type if variable
* 	R44,45,46			name if variable (R46=undef)
* 		or...			3 byte integer
* 		or...			2ndary attributes for functions
* 	R47					primary attributes
*
* 	R14					token # (370 for rom stuff)
* 	R15					0 (for multibyte adds)
*
* Floating point numbers leave results on R12 stack.
*
* ********************************************************************
SCAN+    JSB  =GCHAR           ; for some folks
SCAN     JSB  =SAVREG          ; save R21/37 and R50/77
         IFEZ
           JSB  =SCAN++          ; do the scan
           JSB  =RSTREG          ; restore R21/37, R50/77
         ENDIF
         BIN                   ;
         CLB  R15              ; for ADM's
         DRP  R14              ; for most parsing
         ARP  R36              ; 	"
         CLE                   ; 	"
         RTN                   ;
*
SCAN++   JSB  =ROMRTN          ; enable system rom
* ********************************************************************
*
* Check for numbers of the form:
* 	NNN.FF E +/- NN
* or   .FF E +/- NN
*
* ********************************************************************
         JSB  =NUMBER          ; is it a number?
         REN                   ; jif yes (done!)
* ********************************************************************
*
* Number not found, call table search, which will find any legal word
* or character except variables.
*
* ********************************************************************
         STB  R20,R40          ; save unshifted input
* ** For quotes, primes and CR, just push that character.
* ** For all other "special characters" just bomb.
         CMB  R20,=CR          ; save time if CR
         JZR  QUOTCR           ; skip this all if so
         CMB  R20,=QUOTE       ; is it a quote?
         JZR  QUOTCR           ; skip all this if so
         CMB  R20,=PRIME       ; is it a prime?
         IFEQ        
           LDB  R14,=PRITOK      ; get token for a prime
           RTN                 ; ttttttthat's all.
         ENDIF
*
         JSB  =ALFA            ; Is it a variable?
         JEZ  GOSALT           ; jif not.
         LDB  R21,=BLANK       ; <letter><blank>?
         CMBD R21,R10          ; Check the <blank>
         JZR  GETVAR           ; jif yes, skip SALT
GOSALT   JSB  =SALT            ; search all tables
         REN                   ; jif found, done
* ** Note that all special chars assume R41-R47=0,
* **	and that CR and " must do this also.
         JSB  =ALFA            ; a variable?
         JEZ  BADSCN           ; jif no
* ********************************************************************
* If the byte is a special character, and was not found in the tables,
* it must be garbage.  This used to set R14 to R20, and caused a
* problem with apostrophe looking like semicolon.
* Changed August 18, 1978 [HP-85 project]
* Form a variable out of one alpha char and optional number, $, and (
* ********************************************************************
GETVAR   STB  R20,R45          ; move shifted character
         LDB  R14,=1           ; R14<-1
         LDB  R44,=BLANK       ; blank out R44
         ICB  R47              ; class=1 (R47 was 0!)
         JSB  =GCDIG           ; does it have a digit?
         IFEN                  ; jif no
           STB  R20,R44          ; move digit to char2 (R44)
           JSB  =GCHAR           ; get next character
         ENDIF
         CMB  R20,='('         ; IF B20#'('
         IFNZ
           CMB  R20,=44          ; '$'? string variable?
           JNZ  FNDVBL           ; jif no, simple arith variable R14=1
           ICB  R14              ; string, increment twice R14=2
         ENDIF
         ICB  R14              ; R14=2 or 3
         JSB  =GCHAR           ; step over the garbage
* ** R14=1 if simple numeric (not an array)
* ** R14=2 if numeric array
* ** R14=3 if simple string (not an array)
FNDVBL   LDB  R43,R14          ; type to R43
         RTN                   ; all done
*
* ********************************************************************
* Don't want GCHAR for QUOTES, don't need for CR
* ********************************************************************
BADSCN   LDB  R14,=17          ; illegal token
QUOTCR   STB  R#,R14           ; no GCHAR after a "
         RTN                   ;
*
* ** class=0 for CR and "'s
*
* ********************************************************************
* INTEGR - get an integer.
* On return R40 contains right justified integer if(!!) R36 = 15C
* Otherwise it contains integer with an exponent of (R36)-15C.
*
* INEGR is intended to be used by parser and any other parties wanting
* to ignore decimal points and exponents, such as line numbers.
* ********************************************************************
INTEGR   LDM  R36,=15C,0       ; set up exponent
         CLM  R40              ; for non-SCAN calls
         BCD                   ; for shifts & increments
         CLB  R22              ; initialize count
* ** R22 is used to tell if any digits have been seen
MLOOP_PAR
         JSB  =DIGIT           ; we have a digit?
         JEZ  INTFND           ; jif not a digit
         ICB  R22              ; count up
         TSB  R47              ; have 16 already?
         IFLN
           ICM  R36              ; step exponent
         ELSE
           ERB  R20              ; put digit into E
           ELM  R40              ; shift into result
         ENDIF
         JSB  =GCHARB          ; get next character
         JMP  MLOOP_PAR            ; get more
*
INTFND   JSB  =EATBL           ; eat any blanks
         TSB  R22              ; any digits found?
         IFNZ
            ICE                   ; flag "we got an integer"
         ENDIF
         RTN                   ; (E was 0 from DIGIT)
*
* ********************************************************************
* NUMBER - get a floating number.
* NUMBER creates a full floating point number in R40, with exponent in
* R36.  By calling SHRONF, this number is packed, normalized, and rounded.
* ********************************************************************
NUMBER   CLB  R0               ; set integer flag
         JSB  =INTEGR          ; do we have a number?
         BIN                   ;
         CMB  R20,='.'          ; a decimal point '.'?
         JEQ  DP1ST            ; jif it's a point.
         JEN  EXPON            ; jif digits and no .
         RTN                   ; no digits & no .
*
DP1ST    BCD                   ;
         ICB  R0               ; kill integer flag
* ********************************************************************
* Decimal point has been seen, shove remaining numbers into R40,
* counting down the exponent.  We are shifting the number left so the
* exponent must be compensated for positional change.  If R40 fills up,
* just throw away digits.
* ********************************************************************
FLOOP    JSB  =GCDIG           ; throw away point
         JEZ  EXPON+           ; jif no more digits
         ICB  R22              ; bump up the count
         TSB  R47              ; we have 16 now?
         JLN  FLOOP            ; jif yes
         DCM  R36              ; count down exponent
         ERB  R20              ; put digit into E
         ELM  R40              ; shift into result
         JMP  FLOOP            ; loop it
*
* ********************************************************************
* Get exponent, if any.
*
* One problem with exponents (AMONG THE VAST NUMBER OF PARSING
* PROBLEMS WHEN YOU DON'T USE A TABLE-DRIVEN SYSTEM!!!) is that the
* calculator mode statement:
*   100E3 = 100000 (boolean expression with a vlue of TRUE)
* is indistinguishable from the program mode statement:
*   100 E3=100000
* The solution is to decide arbitrarily in favor of program mode.
* The logic to accomplish this is in the test for exponents.  An
* exponent is an "E" followed by + or - or digit.  Anything else
* terminates the scan.
* ********************************************************************
EXPON+   BIN                   ; NUMBER left BCD
         TSB  R22              ; test digits
         IFZR
           LDB  R14,=PERIOD          ; '.' we skipped a decimal
           ICE                   ;
           RTN                   ;
         ENDIF

EXPON    JSB  =ALFA            ; set upper case
         CMB  R#,='E'          ; we have an 'E'?
         JNZ  COMBINE          ; jif no
* ** save position in case E is part of something like ELSE
         LDM  R30,R10          ; save R10 pointer
         LDB  R26,R20          ; save input char
         JSB  =GCHAR           ; get past E
         CLB  R34              ; reset sign flag
         CLM  R22              ; clear exponent
         CMB  R20,='+'          ; '+' leading sign on exponent?
         JZR  FNDE+            ; jif yes
         CMB  R20,='-'          ; '-' leading sign on exponent?
         JZR  FNDE-            ; jif yes
         JSB  =DIGIT           ; a digit perhaps?
         JEN  FNDE             ; jmp if valid exponent
* ** this is a case of IF X=1 THEN y=2ELSE y=3
* ** where the E of ELSE looks like an exponent on 2
FALSEE   LDM  R10,R30          ; restore R10
         LDB  R20,R26          ; restore R20
         JMP  COMBINE          ; now it's an integer
*
FNDE-    DCB  R34              ; set sign flag
FNDE+    JSB  =GCDIG           ; get past + or -
* ** If we don't see + or -, it isn't an exponent
* ** This allows SCAN not to flag errors.
         JEZ  FALSEE           ; It ain't an EXP
FNDE     ICB  R0               ; kill integer flag
         BCD                   ; shifts are BCD
         LOOP
           TSB  R23              ; have 3 digits now?
           IFNZ
             LDB  R23,=1           ; Set over(under)flow
           ENDIF
* ** Let SHRONF find over or underflow, not SCAN
           ERB  R20              ; put digit into E
           ELM  R22              ; shift digits to R22
           JSB  =GCDIG           ; get next character
         WHEN
         TSB  R34              ; is sign -?
         IFNZ
           TCM  R22              ; else complement exponent
         ENDIF
         ADM  R36,R22          ; combine exponents
COMBINE  BCD                   ; for no exp case
         CLE                   ; flag number found
         ICE                   ;
         TSB  R0               ; possible integer?
         JNZ  FIXFP#           ; jif no, . or exp
         TSM  R43              ; enough zeroes?
         JNZ  FIXFP#           ; jif no
         TSB  R42              ; only 5 digits?
         JLZ  INTEG!           ; jif yes, ok integer
FIXFP#   CLB  R32              ; set sign to positive
         JSB  =SHRONF          ; shift out 0's, round, push
         LDB  R14,=4           ; floating constant token
         JMP  SETCL4           ; set class 4
*
INTEG!   LDM  R55,R40          ; move up
         STM  R55,R44          ; save in R44/46
         LDB  R14,=INTTK          ; integer token
SETCL4   LDB  R47,=4           ; class = 4
*        DIFFERENCES
*        STE                   ; flag number found
         CLE                   ;
         ICE                   ; 
         RTN                   ;
*
* ********************************************************************
* GCHAR - Get a non-blank character into R20.
* If we get a CR, set the pointer back so we'll get it next time too.
* OUTPUT:
* 	R20 = next character.
* 	R10 = updated pointer to the line.
* ********************************************************************
EATBL    SAD                   ;
         BIN                   ;
         ARP  R10              ; for GCHAR+
         CMB  R20,=BLANK       ; is it a blank?
         JZR  GCHAR+           ; do GCHAR+ if it is
         PAD                   ;
         RTN                   ;
*
GCHAR    DRP  R20              ;
         ARP  R10              ;
GCHAR#   SAD                   ; must respect BIN/BCD
         BIN                   ; need binary for comparisions
GCHAR+   LOOP
           POBD R#,+R#           ; get character
           CMB  R#,=BLANK        ; refuse a blank
         WHEQ                  ; loop, skipping blanks
         JMP  CRBACK           ;
*
* ********************************************************************
* GCHARB - Like GCHAR, except accept a blank.
* ********************************************************************
GCHARB   SAD                   ;
         BIN                   ;
         POBD R20,+R10         ; get a character (possibly blank)
* ** if we hit a CR,
* ** position us so that we hit it next time also
CRBACK   CMB  R#,=15           ; a carriage return?
         IFEQ                  ; jif no
           POBD R#,-R#           ; pull back to carriage return
         ENDIF
         PAD                   ; restore status
         RTN                   ;
*
* ********************************************************************
* ALFA - Is R20 an alphabetic character?
* OUTPUT:
* 	E=0 if R20 not alphabetic
* 	E=1 if R20 is alphabetic (we uppercase R20)
* 	R20: uppercased alphabetic R20
* ********************************************************************
ALFA     DRP  R20              ; process register 20
ALPHA#   BIN                   ; for the compares
         CLE                   ; assume "not found"
         CMB  R#,='A'          ; 'A' too small for upper case?
         RLO                   ; jif too small, not alphabetic
         CMB  R#,='z'+1        ; ('z'+1) too big for lower case?
         RHS                   ; jif too big, not alphabetic
         CMB  R#,='Z'+1        ; ('Z'+1) is it upper case?
         JLO  YEP              ; jif yes
         CMB  R#,='a'          ; 'a' within lower case?
         RLO                   ; jif nope!
         ADB  R#,='A'-'a'      ; ('A'-'a') change lowercase to uppercase
YEP      ICE                   ; fount it
         RTN                   ; all done
* ********************************************************************
* DIGIT - is R20 a digit?
* INPUT: R20 contains a character
* OUTPUT: E=1 if it's a digit
* 	ARP, DRP, DCM unchanged!
* ********************************************************************
GCDIG    JSB  =GCHAR           ; get a character
DIGIT    SAD                   ; save status
         BIN                   ; need binary for comparisons
         CLE                   ; preset "not found"
         CMB  R20,='0'         ; >='0'?
         JNC  NO               ; nope
         CMB  R20,='9'+1       ; <='9'
         JHS  NO               ; nope
         ICE                   ; signal that we found a numeric
NO       PAD                   ; reture in either case
         RTN                   ;
*
* ********************************************************************
* BACK10 - pull R10 back if R20#CR
* If R20#CR, R10:=R10-1
* Use this if you parsed too far.
* OUTPUT: DRP=20 ARP=10
* ********************************************************************
BACK10   ARP  R10              ; we promise this in all cases
         CMB  R20,=15          ; CR?
         IFNE                  ; j
           PUBD R20,-R10         ; pull R10 back
         ENDIF
         RTN                   ;
*
* ********************************************************************
* SAVREG/RSTREG - This routine saves R21-37, R60/67
* SAVRG+ does the same but it doesn't check for space on the R6 stack.
* SAVRG+ is used in the error code when we've already GOT an error.
* ********************************************************************
SAVREG   CMM  R6,=R6LIM1       ; are there 30 bytes left?
         JCY  ERR85            ; jif no
SAVRG+   POMD R2,-R6           ; get return address
         STMD R50,=PROTEM      ; save R50
         LDM  R50,R21          ; save R21-30
         PUMD R50,+R6          ;
         LDM  R50,R30          ; save R30-37
         PUMD R50,+R6          ;
         LDMD R50,=PROTEM      ; restore R50
         PUMD R60,+R6          ; save R60 too
         PUMD R2,+R6           ; restore return address
         CLE                   ;
         RTN                   ;
*
RSTREG   POMD R2,-R6           ; get return address
         POMD R60,-R6          ; restore R60
         STMD R50,=PROTEM      ; save R50
         POMD R50,-R6          ; get R30/37
         STM  R50,R30          ;
         POMD R50,-R6          ; get R21/30
         STM  R50,R21          ; restore 21,30
         PUMD R2,+R6           ; restore return address
         LDMD R50,=PROTEM      ; restore R50
         RTN                   ;
*
ERR85    JSB  =ERR1+           ;
         DATA  85D             ; expression too big
*
* ********************************************************************
* NUMERIC VALUE
* Rules for parsing expressions:
* 1. If you will accept either a numeric value or a string, call
* 	NUMVAL first.  You are guaranteed that:
* 	A. If a NUMVAL is found, E#0
* 	B. If a NUMVAL is not found, and some partial numeric value is
* 		found which is an obvious error (e.g. SIN(X) AND nothing), an
* 		error will be flagged and E=0.
* 	C. If a NUMVAL is not found, and nothing has been chewed up, the
* 		state will be restored and E=0, no errors flagged.
* 		R10, 12, 14, 20, 32-47 are restored.  You are then free
* 		to call STREXP.
* 2. When you call STREXP, no backup is done on the assumption that
* 		you will not accept the "not found" condition.
* NUMVAL RESOURCES: R0 TEMP
*
* <numeric-value> ::= <logical-exp>
* <log-exp>=<log-factor> (or <log-factor>)*
* ********************************************************************
NUMVA+   JSB  =SCAN            ; adds scan to numval
NUMVAL   JSB  =LOGFAC          ; get <log-factor>
         REZ                   ; jif none found
LOGEX-   CMM  R46,=2,51        ; binary prec 2?
         RNE                   ; jif no, done
         PUBD R14,+R6          ; save token
         JSB  =SCAN            ; scan over OR
         JSB  =LOGFAC          ; get 2nd <log-fac>
         POBD R0,-R6           ; get token
         PUBD R0,+R12          ; send OR to output
         JEN  LOGEX-           ; jif found, iterate
         JMP  ERR81            ; must find second one
*
* ** <log-factor> ::= <log-prim> (and <log-prim>)*
LOGFAC   JSB  =LOGPRIM         ; get <log-prim>
         REZ                   ; jif none found
LOGFA-   CMM  R46,=4,51        ; binary prec 4?
         RNE                   ; jif no, done
         PUBD R14,+R6          ; save token
         JSB  =SCAN            ; yes, scan over and
         JSB  =LOGPRIM         ; 	get 2nd <log-primary>
         POBD R0,-R6           ; restore token
         PUBD R0,+R12          ; to output
         JEN  LOGFA-           ; jif found, iterate
         JMP  ERR81            ; bad expression
*
* ********************************************************************
* LOGICAL PRIMARY
* <logical-prim> ::=<numexp>
* 				|	<numexp><rel-op><numexp>
* 				|	<string-relation>
*
* <string-relation> ::= <str-exp><relop><str-exp>
*
* R36 temp
*
* This is another place where backup is required if this string
* expression is not followed by a relop.
* ********************************************************************
LOGPRIM  CMM  R6,=R6LIM1       ; enough room available?
         JCY  ERR85X           ; jif no
         PUMD R10,+R6          ; save input pointer
         PUMD R12,+R6          ; save output pointer
         PUBD R14,+R6          ; save token
         PUBD R20,+R6          ; save input character
         PUMD R40,+R6          ; save token register
         JSB  =STREXP          ; good string expression?
         JEZ  NUMREL           ; jif none found, try numeric
         CMM  R46,=6,53        ; binary string relop?
         JNZ  NUMREL           ; jif no, restore and try numeric
         PUBD R14,+R6          ; save operator
         JSB  =STREX+          ; get second expression
         POBD R0,-R6           ; restore R6
         PUBD R0,+R12          ; send it out postfix
         JEZ  NUMREL           ; guessed wrong, num
         POMD R71,-R6          ; remove 7 bytes from stack
         POMD R71,-R6          ; 	"	"
         RTN                   ;
*
ERR85X   JSBN  =ERROR+          ;
         DATA 85D              ; expression too big
*
* ********************************************************************
* NUMREL - Now do numeric relation.
* Note that NUMEX is called, to avoid confusion with string relation.
* (NUMVAL allows strings).  NUMREL is a special purpose routine which
* backs up over characters clobbered by STREXP if necessary.
* ********************************************************************
NUMREL   POMD R40,-R6          ; RESTORE TOKEN REGISTER
         POBD R20,-R6          ; RESTORE INPUT CHARACTER
         POMD R53,-R6          ; restore R10-R14
         STM  R53,R10          ; NOTE: NUMEXP kills R52
* ** get the proper rom enabled:
         LDM  R0,R41           ; rom# is in there
         JSB  =GETROM          ; enable that rom.
         JSB  =NUMEXP          ; get first comparand
         REZ                   ; Rtn E=0 (bomb later)
         CMM  R46,=6,53        ; binary rel operator?
         RNE                   ; jif no ops
         ADB  R14,=10          ; change to numeric op
         PUBD R14,+R6          ; Save the operator
         JSB  =NUMEX+          ; scan, get next <num-exp>
         POBD R0,-R6           ; Restore R6
         PUBD R0,+R12          ; Push token
         REN                   ; jif found
*
ERR81    JSBN  =ERROR+          ;
         DATA 87D              ; bad expression
*
* ********************************************************************
* NUMERIC EXPRESSION
* <numeric-expr> ::= <sign>?<terms>
*
* This is to solve backup problem in the case of PRINT -"HI".  This
* MUST be an error.
* NUMEXP, NUMVAL RESOURCES: NONE (RESTORED)
* IN SUBROUTINES: R35 NUMEXP, R34 TERMS, R33 TERM, R32 FACTOR
* ********************************************************************
NUMEX+   JSB  =SCAN            ; adds SCAN to NUMEXP
NUMEXP   LDM  R52,R32          ; save R32/37
         PUMD R52,+R6          ; 	on stack
         CLB  R35              ; preset "no sign"
* ** change for p26 11/10/80. tr
         CMM  R46,=7,50        ; NOT?
         JZR  MONTRM           ; jif yes, found NOT
         CMB  R14,=MINUS       ; monadic minus?
         JZR  MONAD-           ; jif yes
* ** <terms> ::= <term> ( +/- <terms> )*
         CMB  R14,=PLUS        ; monadic plus?
         JZR  MONAD+           ; jif yes
         JSB  =TERM            ; get <term>
         JEZ  NUMRST           ; jif not found, done
TERMS-   CMM  R46,=7,51        ; binary op prec 7?
         JNZ  NUMRST           ; jif no
MONTRM   STB  R14,R34          ; save operator
         JSB  =SCAN            ; Get next token
         JSB  =TERM            ; Get <term>
         TSB  R34              ; monadic plus?
         JZR  MONTR1           ; jif yes
         PUBD R34,+R12         ; push token to output
MONTR1   JEN  TERMS-           ; jif found
*
         JSB  =ERROR           ; bad expression
         DATA 87D              ; fall thru to NUMRST
*
NUMRST   POMD R52,-R6          ; restore R32/37
         STM  R52,R32          ; for recursion
         RTN                   ;
*
MONAD+   LDB  R#,=365          ; THEN 365+13=400 (0)
MONAD-   ADB  R#,=13           ; change to monadic -
         JMP  MONTRM           ; get monadic term
*
* <term ::= <factor> (<multiplier> <factor>)*
TERM     JSB  =FACTOR          ;
         REZ                   ; jif not found
* ** changed for p26 11/10/80 tr
TERM-    CMM  R46,=12,51       ; binary op prec 12?
         RNE                   ; jif no, return
         STB  R14,R33          ; save operator
         JSB  =SCAN            ; get next
         JSB  =FACTOR          ; get factor
         PUBD R33,+R12         ; push to output
         JEN  TERM-            ; jif found
ERR81J   JMP  ERR81            ; must find
*
* ********************************************************************
* <factor> ::= <primary> (<involution> <factor>)*
* ********************************************************************
FACTOR   JSB  =PRIMARY         ;
         REZ                   ; jif not found
FACTO-   CMM  R46,=14,51       ; power or similar op?
         RNE                   ; jif no, return
         STB  R14,R32          ; save the OP
* ** fix for p26: FN wipes out R32, so use R33 intead
         JSB  =SCAN            ; get next
         JSB  =PRIMARY         ; get next primary
         PUBD R32,+R12         ; onto output
* ** FIX NOT  IN AS OF 4/22/81 TONY
* the rest of that fix in 4/15/81 is to push R33 instead of R32
         JEN  FACTO-           ; iterate if found
         JMP  ERR81J           ; Must find
*
* ** <numeric-prim> ::= <numeric-variable>|<numeric-rep>
* ** |<numeric-function-ref>|<open><numeric-expr><close>
* ** PRIMARY RESOURCES: R36 TEMP
PRIMARY  CMB  R14,=3           ; NUMERIC SAV OR SNV?
         JNC  NUMVRB           ; JIF YES (3-3 CY, 1 OR 2-3 NC)
         JSB  =NUMREP          ; NUMERIC-REP?
* ** NOW CHECK FOR NUMERIC RESPRESENTATION
         REN                   ; JIF YES
* ** <numeric-function-ref>	::=<num-def-func>
* **						::=<num-supplied-func>
         CMB  R14,=FNSYM       ; FN?
         JZR  JFNCAL           ; JIF YES
         CMB  R47,=55          ; <numeric supplied-func>?
         JZR  FUN1             ; JIF YES
         CMB  R14,=OPEN        ; (NUM-EXP)?
         RNZ                   ; NOPE, NONE FOUND, E=0
         JSB  =NUMVA+          ; SCAN, GET VALUE
         JEZ  ERR81J           ; JIF bad open/close
         JSB  =GETRPAR         ; GET CLOSE
         RTN                   ;
*
* ** the push and pop below are a fix for
* **	X=10^FNA bug   tr. 7/22/81
*
JFNCAL   PUBD R32,+R6          ; save the ^ token
         JSB  =FNCALL          ; GET THE CALL
         POBD R32,-R6          ; get it back
         RTN                   ;
*
NUMVRB   PUBD R#,+R6           ; SAVE THAT TOKEN
         JSB  =PUSH45          ; PUSH TOK, NAM
         POBD R36,-R6          ; WAS IT SAV OR SNV?
         ROD                   ; JIF SNV
         JSB  =SBSCR           ; GET SUBSCRIPTS
         PUBD R36,+R12         ; PUSH TO OUTPUT
         RTN                   ;
*
FUN1     TSB  R46              ; attributes say paramters?
         JNZ  GETPRM           ; if we do, get them.
         PUBD R14,+R12         ; push incoming token (might be 3
         CMB  R14,=264         ; EROMTK
         IFEQ                  ; external function
           PUMD R41,+R12         ; push rom#, incoming token
           POMD R44,-R12         ; leave R41/43 on stack
         ENDIF
         JSB  =SCANE1          ; get next thing
         RTN                   ; done with no parameters
*
GETPRM   BIN                   ; FOR ADDS
         PUMD R32,+R6          ; SAVE R32
         PUMD R34,+R6          ; SAVE R34
         PUMD R40,+R6          ; SAVE COPY OF R40
* ** R40 CONTAINS ROM#, AMONG OTHER THINGS
         LDB  R32,R14          ; SAVE INCOMING TOKEN
* ** R44 CONTAINS THE DOUBLED TOKEN
         JSB  =GETRUN          ; get runtime address
         DRP !36
         ARP !36
         DCM  R36              ; (DRP 36) skip class part of attributes
         POMD R50,-R36         ; (ARP 36) get attributes (# parameters)
* ** IV>> but that's already in R46/47!
*
* ** Not necessarily true! The function maybe of three or
* ** more parameters, in which case we have at least THREE
* ** bytes of attributes! GC 1-14-82
         BCD                   ; FOR SHIFTING BYTE
         LLM  R50              ; GET COUNT INTO E
         CLB  R33              ; GET COUNT INTO R33
         ELB  R33              ; R40-47 NOW THE TYPES
         BIN                   ; BACK TO BINARY
         PUMD R50,+R6          ; SAVE THE FLAGS
         JSB  =SCAN            ; GET OPENING REMARKS
         CMB  R#,=OPEN         ; (?
         JNZ  POPFUN           ; JIF NO
         JSB  =SCAN            ; GET PAST IT
* ** ----- NOW COMES THE MAIN LOOP ----- **
PRMLOP   POMD R50,-R6          ; RESTORE FLAGS
         PUMD R50,+R6          ; SHOVE THEM BACK
         CLM  R34              ; CLEAR R35
         LDB  R34,R57          ; GET PARAM TYPE
         LLM  R34              ; MOVE TWO BITS
         LLM  R34              ; 	INTO R35
         LDB  R34,R35          ; MOVE BACK TO R34
         LLB  R34              ; DOUBLE FOR TABLE OFFSET
         CLB  R35              ; AND CLEAR R35
         LDMD R34,X34,PTYPES   ; GET ROUTINE ADDR
         JSB  X34,ZRO          ; GET THE PARAMETER
         JEZ  POPFUN           ; JIF NOT FOUND
         POMD R50,-R6          ; GET BACK PARAMETERS
         LLM  R50              ; SHIFT OUT 2 BITS
         LLM  R50              ; 	BIT 2
         PUMD R50,+R6          ; SHOVE THEM BACK
         DCB  R33              ; COUNT DOWN
         JZR  NMPARS           ; JIF NO MORE PARAMS
         JSB  =GETCMA          ; GET COMMA
         JMP  PRMLOP           ; CONTINUE
*
PTYPES   DEF  NUMVAL           ; numeric parameter
         DEF  ARRAY            ; array parameter
         DEF  STREXP           ; string parameter
         DEF  BOFFO            ; STRANGE parameter
* ********************************************************************
* We got something with STRANGE attributes
* ********************************************************************
BOFFO    JSB  =HANDI0          ; give the roms a chance
         VAL  V.PARA           ; this is the STRANGE event
         RTN                   ;
*
NMPARS   LDB  R36,R32          ; MOVE TOKEN
         POMD R50,-R6          ; RESTORE R6, KILL R50
         POMD R50,-R6          ; RCL OLD R40
* ** REMEMBER THAT OLD R40 CONTAINS ROM#
         POMD R34,-R6          ; RESTORE R34
         POMD R32,-R6          ; RESTORE R32
         PUBD R36,+R12         ; PUSH THE FUNC NAME
         CMB  R36,=EROMTK      ; A ROM FUNCTION?
         IFEQ
           PUMD R51,+R12         ; save R#
           POMD R54,-R12         ; leave R51/53
         ENDIF
         JMP  GETRPAR             ; DONE
*
POPFUN   POMD R50,-R6          ; RESTORE R50
         POMD R40,-R6          ; RESTORE R40
         POMD R34,-R6          ; RESTORE R34
         POMD R32,-R6          ; RESTORE R32
*
ERR89    JSBN  =ERROR+          ;
         DATA 89D              ; Bad parameters
*
GETRPAR  CMB  R14,=CLOSE          ; END ) FOUND?
         JEQ  FNDCM?           ;
         JSBN  =ERROR+          ;
         DATA  80D              ; ) EXPECTED
*
ARRAY    CLE                   ; Entry for FUN1 loop
         CMB  R14,=1           ;
         JNZ  ERR89            ; LOG ERROR AND CLEAR E
         ICB  R14              ; MAKE IT AN ARRAY
         JSB  =PUSH45          ;
         RTN                   ;
*
GETCMA   JSB  =ISCMA!          ; assert that R14=comma
         JMP  FNDCM?           ; do SCAN, set E=1
*
GETCM?   CLE                   ; RESET FLAG
         CMB  R14,=COMMA       ; Find ,?
         RNE                   ; JIF NO
FNDCM?   JSB  =SCANE1          ; scan past it
         RTN                   ; RETURN WITH FOUND=E
*
ISCMA!   CMB  R14,=COMMA          ; is R14 a comma?
         IFNE
            JSB  =ERROR           ;
            DATA  81D              ; missing comma
         ENDIF
         RTN                   ;
*
* ********************************************************************
* Is R14 a CR or a comma?
* OUTPUT: EQ if it does
* ********************************************************************
CRCOM?   CMB  R14,=','          ; comma?
         RZR                   ; jif yes
         CMB  R14,=CR          ; otherwise, is it a CR?
         RTN                   ;
*
* ********************************************************************
* SBSCR resources: R36 TEMP
* ********************************************************************
SBSCR    JSB  =NUMVAL          ; ( WAS CHEWED UP
         JEZ  ERR89            ; JIF not found
         LDB  R36,=13          ; SET UP 1 SUBS
         CMB  R14,=COMMA       ; TWO?
         JNZ  GETRPAR          ; Get close, RTN
         JSB  =NUMVA+          ;
         JEZ  ERR91            ; JIF not found
         ICB  R36              ; TOKEN DOUBLE INDEX
         JMP  GETRPAR          ; Get close
*
* ** RETURN INDEX1 OR 2 IN R36
*
* ********************************************************************
* <numeric-rep> = <sign> <small-integer>
* <numeric-const> = <signif> & <sign>? <integer>
* <signif> = <integer> . / <integer>? . <integer>
* NUMREP RESOURCES: R36 TEMP
* ********************************************************************
NUMCON   CLE                   ; FOR EXTERNAL CALLS
         CMB  R14,=4           ; INTEGER?
         JZR  FLTGPT           ; JIF FLOATING CONST FOUND
SMLINT   CLE                   ; FOR SMLINT CALLS
         CMB  R14,=32          ; INTEGER?
         RNE                   ; jif no, exit with E=0 if none found
         JSB  =PUSH32          ; PUSH R14, R44, R45, R46
         RTN                   ;
*
FLTGPT   POMD R40,-R12         ; THE NUMBER IS ON R12
         PUBD R14,+R12         ; PUSH OUT TOKEN
         JSB  =PUSH40          ; PUSH NUMBER AND SCAN
         RTN                   ; RETURN BYE BYTE
*
* ********************************************************************
* NUMREP CHEWS UP LEADING + OR - AND PRODUCE A SIGNED NUMERIC CONSTANT
* ********************************************************************
NUMREP   CLM  R36              ;
         CMM  R46,=7,51        ; SIGN?
         JZR  GETSGN           ; JIF YES, DEMAND NUMNUM
         JSB  =NUMCON          ; GET OPTIONAL NUM
         JEN  GETNMM           ; JIF FOUND
numrrtn  RTN                   ; OTHERWISE DONE
*
GETSGN   CMB  R14,=ADDTOK      ; +?
         JZR  SGN?1            ; JIF YES
         CMB  R14,=SUBTK2      ; -?
         JNZ  SGNNU1           ; JIF NO
         ICB  R37              ; INCR NEG COUNT
SGN?1    JSB  =SCAN            ; NEXT TOKEN
         JMP  GETSGN           ; LOOP TO CHECK NEXT
*
SGNNU1   STB  R14,R36          ; SAVE TOKEN
         JSB  =NUMCON          ; GO PROCESS NUMBER
* ** chewed up +/-'s will be chucked by LOGPRI if nec.
         JEN  GETNMM           ; JIF FOUND
*
ERR91    JSBN  =ERROR+          ;
         DATA 91D              ; MISSING PARAM
*
GETNMM   TSB  R37              ; NEG?
         REV                   ; JIF NO
         CMB  R36,=INTTK       ; BCD INT
         JNZ  SGNFLT           ; JIF NOT
         POMD R55,-R12         ; POP VALUE
         BCD                   ;
         TCM  R55              ; MAKE IT NEG
         BIN                   ;
         PUMD R55,+R12         ; PUSH IT BACK
         RTN                   ;
*
SGNFLT   POMD R50,-R12         ; POP VALUE
         ADB  R51,=9C          ; MAKE IT NEG
         PUMD R50,+R12         ; PUSH IT BACK
         RTN                   ;
*
* ********************************************************************
* <string-expr>	::= <source-string>
* 				::= <string-expr> <binop$> <source-string>
* STREXP RESOURCES: R34,R36
* There are three possible return conditions for STREXP:
* 	Successful return - E # 0
* 	Error return      - E = 0, ERRORS set
* 	No string found   - E = 0, input restored
* ********************************************************************
STREX+   JSB  =SCAN            ; FOR SOME FOLKS
STREXP   JSB  =SAVREG          ; SAVE REGISTERS
         JEZ  DOSTR            ; JIF THERE WAS ROOM
         CLE                   ; BAG IT, NO ROOM
         RTN                   ;
*
DOSTR    PUMD R10,+R6          ;
         PUBD R20,+R6          ;
         JSB  =SOURCE          ;
         JEN  GET&             ;
         POBD R20,-R6          ;
         POMD R10,-R6          ;
         JMP  STR.R+           ;
*
GET&     CMM  R46,=7,53        ;
         JNZ  STR.RN           ;
         PUBD R14,+R6          ;
         JSB  =SCAN            ;
         JSB  =SOURCE          ;
         POBD R36,-R6          ;
         PUBD R36,+R12         ;
         JEN  GET&             ;
         JSB  =ERROR           ;
         DATA 82D              ;
*
STR.RN   POMD R75,-R6          ;
STR.R+   JSB  =RSTREG          ;
         RTN                   ;
* SOURCE get a source string
SOURCE   CLE                   ;
         CMB  R14,=QUOTE       ;
         JEQ  STRCON           ;
         CMB  R14,=PRITOK      ;
         JEQ  STRCON           ; 
         CMB  R14,=3           ;
         JEQ  STVRBL           ;
         CMB  R47,=56          ;
         JNE  USER$?           ;
         GTO FUN1              ;
*
USER$?   CMB  R14,=FNSYM       ;
         RNE
         JSB  =FN$CAL          ;
         RTN                   ;
* STRREF get a string reference
STRREF   CLE                   ;
         CMB  R14,=3           ;
         RNE
         ADB  R14,=20          ;
STVRBL   JSB  =PUSH45          ;
         DRP  !14
         CLE                   ;
         CMB  R14,=LBRACK          ;
         JNZ  NOSTR            ;
         JSB  =NUMVA+          ;
         JEZ  ERR82Z           ;
         LDB  R36,=35          ;
         CMB  R14,=RBRACT        ;
         JZR  SUBDUN           ;
         JSB  =GETCMA          ;
         JSB  =NUMVAL          ;
         JEZ  ERR82Z           ;
         CMB  R14,=RBRACT      ;
         JNE  ERR82Z           ;
         LDB  R36,=36          ;

SUBDUN   JSB  =PU368C          ;
         ICE                   ;
         RTN                   ;
*
NOSTR
         JSB  =HANDIO          ;
         DATA V.STRA           ;
*        STE                   ;
         CLE                   ;
         ICE                   ; 
         RTN                   ;
* Remark and String Constant
CR.ERR
ERR82Z   JSBN  =ERROR+          ;
         DATA  82D              ;
STRCN+   JSB  =SCAN            ;
STRCON   CLE                   ;
         CMB  R14,=QUOTE       ;
         IFEQ
           LDB  R36,=5           ;
           ARP  R2               ;
         ELSE
           CMB  R14,=PRITOK      ;
           RNE
           LDB  R2,=PRIME        ;
           ARP  R36
         ENDIF
         STB  R14,R#           ;
         JMP  STRCN2           ;
* REM: parse a REM,!, or IMAGE statement
REM      JSB  =INRTN?          ;
         ARP  !12
         PUBD R14,+R12          ;
         LDB  R2,=CR           ;
         CMB  R2,R20           ;
         JEQ  CRT014
         DCM  R10              ;
         CMB  R14,=IMAGTK
         JEQ  UNQUO-           ;
         LOOP
           POBD R20,-R10         ;
           CMB  R20,=40          ;
         WHEQ
         POBD R20,+R10         ;
         POBD R20,+R10         ;
         CMB  R20,=BLANK       ;
         JEQ  STRCN1           ;
         POBD R20,-R10         ;
STRCN1   LDB  R36,=6           ;
STRCN2   CLE                   ;
         PUBD R36,+R12         ;
         LDM  R34,R12          ;
         PUBD R34,+R12         ;
CHLOOP   POBD R20,+R10         ;
         CMB  R20,R2           ;
         JEQ  FDELIM           ;
         CMB  R20,=CR          ;
         JEQ  FNDCR            ;
         PUBD R20,+R12         ;
         JMP  CHLOOP           ;
*
FDELIM
         JSB  =QUIP?           ;
         JZR  ENDQUO           ;
FNDCR    DCM  R10              ;
         DRP  R2               ;
         JSB  =QUIP?           ;
         JZR  CR.ERR           ;

ENDQUO   LDM  R36,R12          ;
         SBM  R36,R34          ;
         DCM  R36              ;
         STBD R36,R34          ;
CRT014   JSB  =SCAN+           ;
         ICE                   ;
         RTN                   ;
*
REMS-    CMB  R20,=CR          ;
         IFEQ
           CMB  R77,=COMMA       ;
           IFEQ                 
             JSB  =UNQUO+
           ENDIF
           JMP  CRT014           ;
         ENDIF
*
UNQUO+   DCM  R10              ;
UNQUOT   LDB  R2,=COMMA        ;
UNQUO-   JSB  =STRCN1          ;
         LOOP
           TSB  R36              ;
           JZR  UNQUO2           ;
           POBD R32,-R12         ;
           CMB  R32,=BLANK       ;
           JNZ  UNQUO1           ;
           DCB  R36              ;
         WHMP
*
UNQUO1   PUBD R#,+R#         ;
UNQUO2   STBD R36,R34          ;
         RTN                   ;
* parse time common routines
P1ANC!   JSB  =NOCLC!          ;
PUSH1A   DRP  R14     
PUSH1#   PUBD R#,+R12         ;
SCANE1   JSB  =SCAN            ;
         ICE                   ;
         RTN                   ;
*
PUSH45   PUBD R14,+R12         ;
PUSH44   PUBD R44,+R12         ;
         DRP  R45              ;
         JMP  PUSH1#           ;
*
PUSH32   PUBD R14,+R12         ;
         PUMD R44,+R12         ;
         POBD R44,-R12         ;
         JMP  SCANE1           ;
*
PU36SC   DRP  R36              ;
         JMP  PUSH1#           ;
*
PUSH40   PUMD R40,+R12         ;
         JMP  SCANE1           ;
*
GO1$     STB  R14,R36          ;
         JSB  =STREX+          ;
         JMP  PUSH36           ;
*
GET2N    LDB  R35,=2           ;
         JMP  GETPAR           ;
*
GETPA?   CLB  R35              ;
         JMP  GETPAR           ;
*
GET1N    LDB  R35,=1           ;
GETPAR   STB  R14,R36          ;
         CLB  R34              ;
         JSB  =NUMVA+          ;
         JEZ  PDONE            ;
GETCNT   ICB  R34              ;
         CMB  R14,=COMMA       ;
         JNE  PDONE            ;
         JSB  =NUMVA+          ;
         JEZ  ERR91Y           ;
         JMP  GETCNT           ;
*
PDONE    PUBD R36,+R12         ;
         TSB  R35              ;
         JZR  OKPAR            ;
         CMB  R35,R34          ;
         JNE  ERR89Y           ;
OKPAR    DRP  R34              ;
         RTN                   ;
*
GXX3     CMB  R#,=3           ;
JCYE89   JCY  ERR89Y           ;
         RTN                   ;
*
GET1$    JSB  =GETSTP          ;
PUSH36   PUBD R36,+R12         ;
         DRP  R14              ;
         RTN                   ;
*
GETSTP   STB  R14,R36          ;
STREX!   JSB  =SCAN            ;
STRX-!   JSB  =STREXP          ;
         CMB  R14,=COMMA       ;
         ARP  R36              ;
         REN                   ;
*
         JSBN  =ERROR+          ;
         DATA 82D              ;
* get filename and optional numeric parameters
CN?      CLE                   ;
         CMB  R14,=','         ;
         RNE
         JSB  =SEQ#            ;
         JEN  CN?1             ; IF E=0
*
           JSBN  =ERROR+          ;
           DATA  89D              ;
*
CN?1     RTN                   ;
*
GO1N$    STB  R14,R36          ;
         JSB  =STREX+          ;
         JEN  GET1?            ;
         JSB  =SEQ#-           ;
         JMP  PUSH36           ;
*
G$012N   JSB  =FILNM+          ;
         JEZ  GET2?            ;
         JSB  =SEQ#-           ;
         JMP  GET1?            ;
*
G$!012   JSB  =FILNM+          ;
         JEN  ERR91Y           ;
         JMP  GET2?            ;
*
GO1N     JSB  =SEQ#+           ;
*        JMP  GET1?            ; This is the destination in ROM Rev a
         JMP  PUSH36           ; FIX REV D
*
GO12N    JSB  =SEQ#+           ;
         JMP  GET1?            ;
*
GOTO4N   JSB  =SEQ#+           ;
GET3?    JSB  =CN?             ;
GET2?    JSB  =CN?             ;
GET1?    JSB  =CN?
         JMP  PUSH36           ;
*
ERR89Y   JSBN  =ERROR+          ;
         DATA  89D              ;
*
G10R2N   JSB  =GETPA?          ;
         JEN  GXX3             ;
*
ERR91Y   JSBN  =ERROR+          ;
         DATA 91D              ;
*
TRY1N    JSB  =GETPA?          ;
         CMB  R#,=2            ;
         JMP  JCYE89           ; addr is 079C
* ASSIGN
ASSIGN   STB  R14,R36          ;
         JSB  =NUMVA+          ;
         JEZ  ERR91Y           ;
         CMB  R14,=TOTOK       ;
         JNZ  ERR89Y           ;
         JSB  =SCAN            ;
         JSB  =STR?*?          ;
         LDB  R2,=TOTOK2       ;
         PUBD R2,+R12          ;
         JSB  =ASNPAR          ;
         RTN                   ;
* OPTION BASE parsing
OPTION   JSB  =NOCLC!          ;
         JSB  =PUSH1A          ;
         CMB  R#,=INTTK        ;
         JNE  ERR51            ;
         CLB  R47              ;
         TSM  R45              ;
         JNZ  ERR51            ;
         CMB  R44,=2           ;
         JNC  PUPU32           ;
*
ERR51    JSBN  =ERROR+          ;
         DATA 30D              ;
*
ERR89Z   JSBN  =ERROR+          ;
         DATA 89D              ;
*
PUPU32   JSB  =PUSH32          ;
         RTN                   ;
* parse for ON ERROR statement
ONERRO   JSB  =P1ANC!          ;
PRSE!!   CLM  R2               ;
         ICM  R2               ;
         STMD R2,=THENFL       ;
         STBD R2,=RTNFLG       ;
         JSB  =PARSE!          ;
         CLM  R2               ;
         STMD R2,=THENFL       ;
         JSB  =DMNDCR          ;
         RTN                   ;
* dimension and type statements
DIM      JSB  =PUSH1A          ;
         LOOP
           JSB  =DIMITE          ;
           JEZ  ERR89Z           ;
           JSB  =GETCM?          ;
         WHEN                  ;
DMNDCR   CMB  R14,=BANGTK      ;
         REQ
DMNDCR-  CMB  R14,=CR          ;
         REQ
*
         JSBN  =ERROR+          ;
         DATA 84D              ;
*
DIMITE   CLE                   ;
         CMB  R#,=3            ;
         JNE TYPITM            ;
         JSB  =PUSH45          ;
         CMB  R#,=LBRACK       ;
         JNZ  RHEAD            ;
         JSB  =SCAN            ;
         JSB  =SMLINT          ;
         JEZ  ERR89U           ;
         DRP  !14
         CMB  R14,=RBRACT       ;
         JNE  ERR89U           ;
         LDB  R#,=35           ;
         JSB  =PUSH1A          ;
         RTN                   ;
*
NMVREL   CMB  R#,=1            ;
         JNE  TYPITM           ;
         JSB  =PUSH45          ;
         RTN                   ;
*
RHEAD    JSB  =HANDI0          ;
         VAL  V.DIM
*        STE
         CLE                   ;
         ICE                   ; flag number found
         RTN
         
*
TYPITM   CLE                   ;
         CMB  R#,=2            ;
         RNE
         JSB  =PUSH45          ;
         JSB  =SMLINT          ;
         JEZ  ERR89U           ;
         LDB  R36,=13          ;
         JSB  =GETCM?          ;
         JEZ  ONEDIM           ;
         JSB  =SMLINT          ;
         JEZ  ERR89U           ;
         ICB  R36              ;
ONEDIM   PUBD R36,+R12         ;
         JSB  =GETRPAR         ;
         RTN                   ;
*
ERR91Z   JSBN  =ERROR+          ;
         DATA 91D              ;
*
TYPSTM   JSB  =PUSH1A          ;
         JMP  GTAPAR           ;
NMORE?   JSB  =GETCM?          ;
         JEZ  DMNDCR           ;
GTAPAR   JSB  =NMVREL          ; addr is 08A2
         JEN  NMORE?           ;
         JMP  ERR91Z           ;
*
ERR89U   JSBN  =ERROR+          ;
         DATA  89D              ;
* DEF FN statement
ERR89F   POMD R66,-R6          ;
         JMP  ERR89U           ;
*
DEF      JSB  =P1ANC!          ;
         LDMD R2,=STSIZE       ;
         ICM  R2               ;
         ICM  R2               ;
         CMM  R2,R12           ;
         IFNE
*
           JSBN  =ERROR+          ;
           DATA  84D              ;
         ENDIF
         JSB  =FNNAME          ;

JEZE89   JEZ  ERR89U           ;
         CMB  R30,=2           ;
         IFCY
           DCM  R12              ;
           PUMD R12,+R6          ;
           ICM  R12              ;
           LOOP
             CMB  R14,=1           ;
             IFEQ
               JSB  =PUSHNM          ;
             ELSE
               CMB  R#,=3            ;
               JNZ  ERR89F           ;
               JSB  =PUSHNM          ;
               LDM  R32,=(STRLEN).2   ;
               CMB  R14,=LBRACK         ;
               IFEQ
                 JSB  =SCAN            ;
                 CMB  R#,=INTTK        ;
                 JNZ  ERR89F           ;
                 LDM  R65,R44          ;
                 JSB  =BCDINT          ;
                 LDM  R32,R76          ;
                 CMB  R20,=']'         ;
                 JNZ  ERR89F           ;
                 JSB  =SCAN+           ;
               ENDIF
               PUMD R32,+R12         ;
             ENDIF
             CLM  R36              ;
             PUMD R36,+R12         ;
             JSB  =GETCM?          ;
             IFEN
               ADB  R30,=2           ;
             ENDIF
           WHEN
           POMD R66,-R6          ;
           STBD R30,R66          ;
           JSB  =GETRPAR         ;
         ENDIF
         CLM  R36              ;
         PUMD R36,+R12         ;
         CMB  R14,=EQUALS      ;
         IFEQ
           TSB  R30              ;
           IFEV
             JSB  =NUMVA+          ;
           ELSE
             JSB  =STREX+          ;
           ENDIF
           JEZ  JEZE89           ;
           LDM  R65,=IFNDTK,0,0     ;
           PUMD R65,+R12         ;
         ENDIF
DFEND    JSB  =DMNDCR          ;
         RTN                   ;
*
FNEND    CLM  R44              ;
         JSB  =NOCLC!          ;
         JSB  =PUSH45          ;
         JMP  DFEND           ;
*
PUSHNM   SBB  R45,='A'-1
         CMB  R44,=' '          ;
         IFEQ
           LDB  R44,=72          ;
         ENDIF
         SBB  R44,='0'         ;
         CMB  R14,=3           ;
         IFEQ
           ADB  R44,=80H         ;
         ENDIF
         JSB  =PUSH44          ;
         RTN                   ;
*
FNNAM+   JSB  =SCAN            ;
FNNAME   CLB  R30              ;
         LDB  R35,R14          ;
         JSB  =PUSH44          ;
         CMB  R#,=4            ;
         IFEQ
           POMD R50,-R12         ;
         ENDIF
         CLM  R36              ;
         PUMD R36,+R12         ;
         CLE                   ;
         DCB  R35              ;
         IFNZ
           DCB  R35              ;
           IFNZ
             DCB  R35              ;
             RNZ
             ICB  R30              ;
             CMB  R14,=OPEN        ;
             JNE  NOPRAM           ;
             JSB  =SCAN            ;
             CMB  R#,=4            ;
             IFEQ
               POMD R50,-R12         ;
             ENDIF
           ENDIF
           ICB  R30              ;
           ICB  R30              ;
         ENDIF
    
NOPRAM   PUBD R30,+R12         ;
         ICE                   ;
         RTN                   ;
*
FNCALL   LDB  R32,=26          ;
         JMP  DOFUNC           ;
*
FN$CAL   LDB  R32,=17H         ;
DOFUNC   JSB  =NOCLC!          ;
         PUMD R40,+R6          ;
         LDM  R63,R10          ;
         STB  R20,R62          ;
         JSB  =FNNAM+          ;
         IFEN
           LDB  R2,R30           ;
           XRB  R2,R32           ;
           IFEV
             POBD R2,-R12          ;
             POMD R64,-R12         ;
             CLM  R66              ;
             LDB  R63,R32          ;
             CMB  R30,=2           ;
             IFCY
               CMB  R14,=4           ;
               IFEQ
                 PUMD R50,+R12         ;
               ENDIF
               LOOP
                 LDB  R62,=080H        ;
                 PUMD R60,+R6          ;
                 JSB  =NUMVAL          ;
                 POMD R60,-R6          ;
                 IFEZ
                   PUMD R60,+R6          ;
                   JSB  =STREXP          ;
                   POMD R60,-R6          ;
                   IFEZ
                     JSB  =ERROR           ;
                     DATA 91D
                     SBM  R6,R66           ;
                     JMP  FNERR            ;
                   ENDIF
                   ICB  R62              ;
                 ENDIF
                 ICM  R66              ;
                 PUBD R62,+R6         ; 
                 JSB  =GETCM?          ;
               WHEN
               JSB  =GETRPAR         ;
             ENDIF
             PUMD R63,+R12         ;
             DCM  R12              ;
             ADM  R12,R66          ;
             STM  R12,R64          ;
PRMLP        DCM  R66              ;
             IFPS
               POBD R63,-R6          ;
               PUBD R63,-R12         ;
               JMP  PRMLP
             ENDIF
             LDM  R12,R64          ;
*            STE                   ;
             CLE                   ;
             ICE                   ; 
             POMD R60,-R6          ;
             RTN                   ;
           ENDIF
         ENDIF
*
         CLE                   ;
         LDB  R20,R62          ;
         STM  R63,R10          ;
FNERR    POMD R40,-R6          ;
         RTN                   ;
*
INPUT    JSB  =STRCN+          ;
         IFEN                   ;  IF E#0
           JSB  =GETCM?          ;
           IFEN                   ; 
             JSB  =STREXP          ;
             IFEZ                   ;
               JSBN  =ERROR+          ;
               DATA  82D              ;
             ENDIF
           ENDIF 
           CMB  R14,=SEMI
           JNZ  ERR93D           ;
           JSB  =SCAN            ;
         ENDIF
         LDB  R2,=INPTOK          ;
         PUBD R2,+R12          ;
         LOOP
           JSB  =STRREF          ;
           LDB  R36,=INP$TK         ;
           IFEZ
             JSB  =REFNUM          ;
             IFEZ
               GTO ERR89             ;
             ENDIF
             LDB  R36,=335         ;
           ENDIF 
           PUBD R36,+R12         ;
           JSB  =GETCM?          ;
         WHEN
         LDB  R2,=TAILTK           ;
         PUBD R2,+R12          ;
         RTN                   ;
*
ERR93D   JSBN  =ERROR+          ;
         DATA  79D              ;
*
DATA     JSB  =NOCLC!          ;
         PUBD R14,+R12         ;
DATLST   LDB  R77,R14          ;
         PUMD R10,+R6          ;
         PUBD R20,+R6          ;
         LDM  R66,R12          ;
         JSB  =STRCN+          ;
         JEN  DATCOM           ;
*        LDM  R66,R12          ; FIX: statement moved before JSB =STRCN+
         JSB  =NUMREP          ;
         IFEN
           JSB  =CRCOM?          ;
           JZR  DATCOM
         ENDIF
         LDM  R12,R66          ;
         POBD R20,-R6          ;
         POMD R10,-R6          ;
         JSB  =REMS-           ;
         JMP  DATCM1           ;
*
DATCOM   POMD R75,-R6          ;
DATCM1   CMB  R14,=COMMA       ;
         JEQ  DATLST           ;
         JSB  =DMDCR-          ;
         RTN                   ;
*
RESTOR   JSB  =NOCLC!          ;
         PUBD R14,+R12         ;
         LDB  R14,=RSTL#       ; unknown!!
GETLIN   JSB  =SEQNO+          ;
         REN
         DCM  R12              ;
         RTN                   ;
*
READ#    JSB  =G10R2N          ;
         CMB  R14,=SEMI        ;
         JZR  GOTSMI           ;
         CMB  R34,=2           ;
         JNZ  ERR89K           ; 
         RTN                   ;
*
READ     JSB  =NOCLC!          ;
GOTSMI
GETLUP   JSB  =PUSH1A          ;
RD#LST
         JSB  =FORMAR          ;
         LDB  R34,=RDARRY     ;
         JEN  PUSHRD           ;
REDITM   JSB  =STRREF          ;
         LDB  R22,=RDSTK.      ;
         JEN  PUSHRD           ;
         JSB  =REFNUM          ;
         JEZ  READ1            ;
         LDB  R22,=RDNTK.         ;
PUSHRD   PUBD R#,+R12         ;
READ1
         JEZ  ERR89K           ;
         JSB  =GETCM?          ;
         JEN  RD#LST           ;
         RTN                   ;
*
FORMAR   CLE                   ;
         CMB  R14,=2           ;
         RNE
         CMB  R20,=CLOSE       ;
         JNZ  AWITH2           ;
         LDB  R14,=ARY1TK         ;
PUSHR#   JSB  =GCHAR           ;
         JSB  =PUSH45          ;
         RTN                   ;
*
AWITH2   CMB  R20,=COMMA       ;
         RNE
         JSB  =GCHAR           ;
         LDB  R14,=ARY2TK      ;
         CMB  R20,=CLOSE       ;
         JZR  PUSHR#             ;
*
ERR89K   JSBN  =ERROR+          ;
         DATA  89D              ;
*
ILET     LDB  R14,R43          ;
         JMP  ILET++           ;
*
LET      JSB  =PUSH1A          ;
ILET++   JSB  =STRREF          ;
         LDB  R34,=7           ;
         JEN  STRLET           ;
         JSB  =REFNUM          ;
         LDB  R34,=10          ;
         JEZ  ERR92Z           ;
NUMLET   CMB  R14,=COMMA       ;
         JNZ  RTHLF#           ;
         LDB  R34,=24          ;
         JSB  =SCAN            ;
         JSB  =REFNUM          ;
         JEZ  ERR92Z           ;
         JSB  =NUMLET          ;
ENDSNV   PUBD R34,+R12         ;
         RTN                   ;
*
RTHLF#   CMB  R14,=EQUALS      ;
         JNZ  ERR92Z           ;
         JSB  =NUMVA+          ;
         JEN  ENDSNV           ;
         JMP  ERR92Z           ;
*
STRLET   CMB  R14,=COMMA       ;
         JNZ  RTHLF$           ;
         LDB  R34,=25          ;
         JSB  =SCAN            ;
         JSB  =STRREF          ;
         JEZ  ERR92Z           ;
         JSB  =STRLET          ;
ENDSTR   PUBD R34,+R12         ;
         RTN                   ;
*
FNLET    JSB  =P1ANC!          ;
         LDB  R34,=STOTOK      ;
         CMB  R14,=1           ;
         IFNE
           CMB  R14,=3           ;
           JNE  ERR92Z
           DCB  R34              ;
         ENDIF
         JSB  =PUSH45          ;
         TSB  R34              ;
         JEV  RTHLF#           ;
RTHLF$   CMB  R14,=EQUALS      ;
         JNZ  ERR92Z           ;
         JSB  =STREX+          ;
         JEN  ENDSTR           ;
*
ERR92Z   JSBN  =ERROR+          ;
         DATA  78D              ;
*
REFNUM   CMB  R14,=3           ;
         RCY
         ADB  R14,=20          ;
         JOD  PSSH45           ; addr is 08E2
         JSB  =PUSH45          ;
         JSB  =SBSCR           ;
         DCB  R36              ;
         DCB  R36              ;
         PUBD R36,+R12         ;
         RTN                   ;
*
PSSH45   JSB  =PUSH45          ;
         RTN                   ;
*
IF       JSB  =NUMVA+          ;
         JEZ  ERR92X           ; addr is 0C55
         CMB  R14,=THENTO      ;
         JNE  ERR92X           ;
ITHEN    JSB  =DIGIT           ;
         JEN  THENSN           ;
         LDB  R36,=JPSTOK      ;
         PUBD R36,+R12         ;
         STMD R12,=THENFL      ;
         ICM  R12              ;
         ICM  R12              ;
         JSB  =PARSIT          ;
         CMB  R14,=ELSTOK      ;
         IFEQ
           LDB  R36,=34          ;
           PUBD R36,+R12         ;
           LDMD R34,=THENFL      ;
           STMD R12,=THENFL      ;
           ICM  R12              ;
           ICM  R12              ;
           JSB  =FIXUPJ          ;
           JSB  =DIGIT           ;
           JEN  ELSESN           ;
           JSB  =PARSIT          ;
         ENDIF
ENDTHN   LDMD R34,=THENFL      ;
         JSB  =FIXUPJ          ;
CLTHNF   CLM  R36              ;
         STMD R36,=THENFL      ;
IFRTN    JSB  =DMNDCR          ;
         RTN                   ;
*
FIXUPJ   LDM  R36,R34          ;
         SBM  R36,R12          ;
         TCM  R36              ;
         STMD R36,R34          ;
         RTN                   ;
*
THENSN   LDB  R36,=30          ;
         PUBD R36,+R12         ;
         JSB  =SEQNO           ;
         CMB  R14,=ELSTOK      ;
         JNE  IFRTN            ;
         JSB  =DIGIT           ;
         JEZ  SNELST           ;
         LDB  R14,=37          ;
         JSB  =GOTOSU          ;
         JMP  CLTHNF           ;
*
ERR92X   JSBN  =ERROR+          ;
         DATA  78D              ;
*
SNELST   LDM  R75,=34,2,0      ;
         PUMD R75,+R12         ;
         STMD R12,=THENFL      ;
         JSB  =PARSIT          ;
         JMP  CLTHNF           ;
*
ELSESN   LDB  R14,=37          ;
         JSB  =GOTOSU          ;
         JMP  ENDTHN           ;
*
FOR      JSB  =PUSH1A          ;
         CMB  R#,=1            ;
         JNZ  ERR92X           ;
         JSB  =REFNUM          ;
         CMB  R#,=EQUALS       ;
         JNZ  ERR92X           ;
         LDB  R14,=STOTOK      ;
         JSB  =GET1N           ;
         CMB  R14,=TOTOK       ;
         JNZ  ERR92X           ;
         JSB  =GET1N           ;
         CMB  R14,=316         ;
         RNE
         JSB  =GET1N           ;
         RTN                   ;
*
NEXT     STB  R14,R36          ;
         JSB  =SCAN            ;
         CMB  R#,=1            ;
         JNZ  ERR92X           ;
         JSB  =REFNUM          ;
         PUBD R36,+R12         ;
         RTN                   ;
*
ON       STB  R14,R36          ;
         JSB  =NUMVA+          ;
         JEZ  ERR92X           ;
         CMB  R14,=GOSTOK      ;
         IFNE
           CMB  R14,=GOTOK       ;
           JNE  ERR92X           ;
           JSB  =POPCHK          ;
         ENDIF
         PUBD R36,+R12         ;
         STB  R14,R36          ;
         LOOP
           DRP !14
           LDB  R14,R36          ;
           JSB  =GOTOSU          ;
           CMB  R14,=COMMA       ;
         WHEQ
         RTN                   ;
*
GOTOPT   JSB  =POPCHK          ;
GOTOSU   JSB  =NOCLC!          ;
         JSB  =SEQNO+          ;
         REN
         GTO ERR92X
*
POPCHK   LDBD R77,=RTNFLG      ;
         IFNZ
           LDB  R77,=IPOPTK         ;
           PUBD R77,+R12         ;
         ENDIF
         RTN                   ;
*
SEQNO+   PUBD R14,+R12         ;
SEQNO    JSB  =SEQ#            ;
         REZ
         POBD R55,-R12         ;
         POMD R55,-R12         ;
         PUMD R56,+R12         ;
         RTN                   ;
*
SEQ#+    STB  R14,R36          ;
SEQ#     JSB  =SCAN            ;
SEQ#-    CLE                   ;
         CMB  R14,=INTTK       ;
         RNE
         TSB  R46              ;
         IFNZ
*
           JSBN  =ERROR+          ;
           DATA  90D              ;
         ENDIF
*
         JSB  =PUSH32          ;
         RTN                   ;
*
NOCLC!   TSB  R16              ;
         REV
         POMD R2,-R6           ;
*
         JSBN  =ERROR+          ;
         DATA  88D              ;

*        CMB  R#,=42           ;
*        JZR  17FB             ;
*        CMB  R#,=47           ;
*        RTN                   ;
QUIP?    CMB  R#,=QUOTE
         REQ
         CMB  R#,=PRIME
         RTN
       TITLE 'krkcl'
*
*  __________________________________________________________________
* |IVKCL 249 05/10/82 - 5/13/1982 3:45PM                             |
* |==================================================================|
* ||                                                                ||
* ||   @@@@@@@@@@  @@      @@  @@     @@@     @@@@     @@           ||
* ||   @@@@@@@@@@  @@      @@  @@    @@@    @@@@@@@@   @@           ||
* ||       @@      @@      @@  @@   @@@    @@@    @@@  @@           ||
* ||       @@      @@      @@  @@  @@@     @@      @@  @@           ||
* ||       @@       @@    @@   @@ @@@      @@          @@           ||
* ||       @@       @@    @@   @@@@@       @@          @@           ||
* ||       @@       @@    @@   @@@@@       @@          @@           ||
* ||       @@        @@  @@    @@ @@@      @@          @@           ||
* ||       @@         @@@@     @@  @@@     @@      @@  @@           ||
* ||       @@         @@@@     @@   @@@    @@@    @@@  @@           ||
* ||   @@@@@@@@@@      @@      @@    @@@    @@@@@@@@   @@@@@@@@@@   ||
* ||   @@@@@@@@@@      @@      @@     @@@     @@@@     @@@@@@@@@@   ||
* ||                                                                ||
* ||                    Last edited: 82098.1329                     ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
WILD     EQU  '.'
SALT     JSB  =CYCLE           ;
         DEF  LOOKER
         RTN                   ;

LOOKER   LDMI R14,=ROMPTR      ;
         STM  R14,R41          ;
         CLM  R14              ;
         LDMD R22,=ROMPTR      ;
         LDMD R22,X22,RM.ASC   ;
         ADMD R22,=ROMOFF      ;
         STM  R10,R30          ;

OUTERL   ICB  R14              ;
         JSB  =RS1020          ;

INNERL   LDB  R47,R20          ;
         JSB  =ALFA#          ;
         DRP  R46              ;
         ARP  R22              ;
         JSB  =GCHAR#          ;
         DRP !46
         ARP !22
         CMB  R46,=FF           ;
         JEQ  NOGOOD_KCL         ;
         CLE                   ;
         TSB  R46              ;
         IFNG
           ICE                   ;
           SBB  R#,=BIT#7        ;
           CMB  R#,=BLANK        ;
           JEQ  BCKVRB
         ENDIF
         CMB  R47,=WILD        ;
         IFEQ
           LDM  R2,R41           ;
           CMM  R2,=(THREE).2        ;
           IFLO
             IFEZ
               LDBD R2,X10,-2      ;
               CMB  R2,=BLANK           ;
               IFNE
                 LOOP
                   POBD R46,+R22         ;
                   CMB  R46,=BLANK          ;
                   JZR  NEXTCH           ;
                   TSB  R46              ;
                 WHPS
                 JMP  GOTVRB           ;
               ENDIF
             ENDIF
           ENDIF
         ENDIF

         CMB  R46,R47          ;
         IFNE                  ; the relative jump is computed incorrectly here
           IFEZ
             ARP R22
             LOOP
               POBD R#,+R#         ;
             WHPS
           ENDIF
           JMP  OUTERL             ; this is an unconditional JUMP
         ELSE                      ; therefore this ELSE generates n o t h i n g
           JEN  GOTVRB
         ENDIF

NEXTCH   JSB  =GCHAR           ;
         JMP  INNERL           ;

BCKVRB   JSB  =BACK10          ;

GOTVRB   CLE                   ;
         ICE                   ;
         CLB  R2               ;
         STBD R2,=HANDLD       ;
         LDM  R2,R41           ;
         DRP  R14              ;
         ARP  R43              ;
         IFNZ
           STM  R14,R43          ;
           LDB  R14,=EROMTK      ;
         ELSE
           ADB  R14,=44          ;
           STM  R14,R43          ;
         ENDIF
         JSB  =GETRUN          ;
         ARP  !36
         POMD R46,-R36          ;
         JSB  =GCHAR           ;
         RTN                   ;

NOGOOD_KCL
         CLM  R41              ;
         CLE                   ;

RS1020   LDB  R20,R40          ;
         LDM  R10,R30          ;
         RTN                   ;

GETRUN   LDMD R36,=ROMPTR      ;
         LDMD R36,X36,RM.RUN   ;
         ADMD R36,=ROMOFF      ;
         ADM  R36,R43          ;
         ADM  R36,R43          ;
         LDMD R36,R36          ;
         ADMD R36,=ROMOFF      ;
         RTN                   ;
       TITLE 'krpp'
*
*  __________________________________________________________________
* |IVPP 370 05/10/82 - 5/13/1982 4:03PM                              |
* |==================================================================|
* ||                                                                ||
* ||         @@@@@@@@@@  @@      @@  @@@@@@@@    @@@@@@@@           ||
* ||         @@@@@@@@@@  @@      @@  @@@@@@@@@   @@@@@@@@@          ||
* ||             @@      @@      @@  @@     @@@  @@     @@@         ||
* ||             @@      @@      @@  @@      @@  @@      @@         ||
* ||             @@       @@    @@   @@     @@@  @@     @@@         ||
* ||             @@       @@    @@   @@@@@@@@@   @@@@@@@@@          ||
* ||             @@       @@    @@   @@@@@@@@    @@@@@@@@           ||
* ||             @@        @@  @@    @@          @@                 ||
* ||             @@         @@@@     @@          @@                 ||
* ||             @@         @@@@     @@          @@                 ||
* ||         @@@@@@@@@@      @@      @@          @@                 ||
* ||         @@@@@@@@@@      @@      @@          @@                 ||
* ||                                                                ||
* ||                    Last edited: 82098.1352                     ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
PRINT    JSB  =PUSH1A          ;
PRINT+   CLB  R32              ;
         CMB  R14,=USTOK       ;
         IFEQ
           STB  R14,R36          ;
           LDB  R14,=ULNTOK      ;
           JSB  =GETLIN          ;
           IFEZ
             JSB  =STREXP          ;
             JEZ  ERR89_PP            ;
             PUBD R36,+R12         ;
           ENDIF
           ICB  R32              ;
           CMB  R14,=SEMI        ;
           JNE  PUTEOL           ;
           JSB  =PUSH1A          ;
         ENDIF
         JMP  PLIST            ;

PRINT#   JSB  =G10R2N          ;
PRINT#+  CLB  R32              ;
         STBD R32,=USING?      ;
         LDB  R32,=80H         ;
         JSB  =EOL14?          ;
         DRP  !14
         IFEZ
           CMB  R34,=2           ;
           IFNE
ERR89_PP   JSBN =ERROR+
             DATA  89D
           ENDIF
           JMP  PUTEOL           ;
         ENDIF
         CMB  R14,=SEMI        ;
         JNE  ERR89_PP            ;
         JSB  =PUSH1A          ;

PLIST    CLB  R35              ;
PLIST+   TSB  R32              ;
         JZR  GETFUN           ;
         JPS  NOARRY           ;
         JSB  =EOL14?          ;
         JEZ  ERR89_PP            ;

         JSB  =FORMAR          ;
         JEZ  NOARRY           ;
         LDB  R36,=PRARRY      ;
         PUBD R36,+R12         ;
         LDB  R36,=PRC#TK      ;
         JMP  PRSEM?           ;

GETFUN   CMB  R47,=45          ;
         IFEQ
           JSB  =FUN1            ;
           LDB  R36,=PRC$TK         ;
           CLE                   ;
           ICE                   ;
         ELSE
NOARRY     JSB  =NUMVAL          ;
           LDB  R36,=PRC#TK         ;
           IFEZ
             LDB  R36,=PRC$TK         ;
             JSB  =STREXP          ;
           ENDIF
         ENDIF

PRSEM?   TSB  R32              ;
         IFNG
           LDB  R36,=COM#TK      ;
         ENDIF

         CMB  R14,=COMMA       ;
         JZR  CDELIM           ;
         DCB  R36              ;
         CMB  R14,=SEMI        ;
         JEQ  SDELIM           ;
         IFEN
           PUBD R36,+R12         ;
         ELSE
           TSB  R35              ;
           RNZ
         ENDIF

PUTEOL   LDB  R36,=CRTOK       ;
         TSB  R32              ;
         IFNG
           LDB  R36,=CR#TOK      ;
         ENDIF
         PUBD R36,+R12         ;
         RTN                   ;

SDELIM   TSB  R32              ;
         JNG  ERR89_PP            ;

CDELIM   IFEZ
           LDM  R30,=6,0
           PUMD R30,+R12         ;
         ENDIF
         JSB  =PU368C          ;
         LDB  R35,=1           ;
         JMP  PLIST+           ;
       TITLE 'krcmd'
* JSI: LCL GETINT renamed to GETINTCMD to aviod conflicts with global symbol
*
*  __________________________________________________________________
* |KXCMD 70 06/24/82 - 7/ 6/1982 5:53PM                              |
* |==================================================================|
* ||                                                                ||
* ||   @@     @@@  @@      @@     @@@@     @@      @@  @@@@@@       ||
* ||   @@    @@@   @@      @@   @@@@@@@@   @@@    @@@  @@@@@@@@     ||
* ||   @@   @@@    @@@    @@@  @@@    @@@  @@@@  @@@@  @@    @@@    ||
* ||   @@  @@@      @@@  @@@   @@      @@  @@@@@@@@@@  @@      @@   ||
* ||   @@ @@@         @@@@     @@          @@  @@  @@  @@      @@   ||
* ||   @@@@@           @@      @@          @@  @@  @@  @@      @@   ||
* ||   @@@@@           @@      @@          @@      @@  @@      @@   ||
* ||   @@ @@@         @@@@     @@          @@      @@  @@      @@   ||
* ||   @@  @@@      @@@  @@@   @@      @@  @@      @@  @@      @@   ||
* ||   @@   @@@    @@@    @@@  @@@    @@@  @@      @@  @@    @@@    ||
* ||   @@    @@@   @@      @@   @@@@@@@@   @@      @@  @@@@@@@@     ||
* ||   @@     @@@  @@      @@     @@@@     @@      @@  @@@@@@       ||
* ||                                                                ||
* ||                    Last edited: 82098.1355                     ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
         DATA  PGMRSW           ;
PURGE.   LDB  R14,=(TYRAM?)|(TYPUR?)         ;
         JSB  =FLORDT          ;
         JEN  FILHAN           ;

EDPURG   JSB  =SAFE!           ;
         JSB  =FPURGE          ;
         JEN  JMPFNF           ;
         CMMD R40,=APFILE      ;
         IFEQ
           JSB  =ANN.A-          ;
         ENDIF
         CMMD R40,=EDNAME      ;
         RNZ
         LDMD R40,=DFNAME      ;
         LDMD R20,=EDTYPE      ;
         JSB  =SETED           ;
         RTN                   ;

         VAL  PGMRSW
RENAM.
         LDB  R14,=(TYCOP?)|(TYRAM?)
         JSB  =HELPUS          ;
         REN
         LDBD R2,=FLSPEC       ;

         RNG
         JZR  DORENM           ;
FILHAN   JSB  =HANDI           ;
         VAL V.FILE
         DATA 63D
         RTN                   ;

FLODTH   JSB  =FLORDT          ;
         REZ
         JMP  FILHAN           ;

DORENM
         CMMD R50,=APFILE      ;
         IFEQ
           JSB  =ANN.A-          ;
         ENDIF
         STM  R60,R50          ;
         JSB  =FRENAM          ;

         IFEZ
           CMMD R50,=APFILE      ;
           IFEQ
             JSB  =STALRM          ;
           ENDIF
           RTN                   ;
         ENDIF
         DCE                   ;
         JEN  ERRFXX           ;
JMPFNF   JMP  ERRFNF           ;

HELPUS
         PUBD R14,+R6          ;
         CLB  R2               ;
         STBD R2,=FLSPEC       ;
         JSB  =FLORD           ;

         STM  R54,R34          ;
         STM  R40,R60          ;
         STM  R74,R70          ;
         POBD R14,-R6          ;
         CLB  R53              ;
         JSB  =HANDI?          ;

         STBD R51,=(TMPMM2)+9D
         JSB  =FLORDT          ;
         LDBD R51,=(TMPMM2)+9D
         LDB  R53,=-1
         JSB  =HANDI?          ;

CKTYP
         CLE                   ;
         TSM  R54              ;
         IFZR
           ICB  R51              ;
           IFNZ
             DCB  R51              ;
             JSB  =GOPEN!          ;
             LDBD R0,X30,DR.TNM    ;
             IFEZ
               CMB  R0,R51           ;
               IFNE
                 JSB  =ERROR           ;
                 DATA 68D
                 DCE                   ;
               ENDIF
             ENDIF
           ENDIF
         ENDIF

         STB  R51,R33          ;
         STM  R54,R24          ;
         STM  R40,R50          ;
         RTN                   ;

ERRFNF   JSB  =ERR1+           ;
         DATA  62D

ERRFXX   JSB  =ERR1+           ;
         DATA  64D

         VAL  PGMRSW
COPY.
         LDB  R14,=TYCOP?          ;
         JSB  =HELPUS          ;
         REN
         LDBD R2,=FLSPEC       ;
         RNG

         CMMD R60,=APFILE      ;
         IFEQ
           LDMD R60,=APFIL0      ;
         ENDIF
         TSB  R2               ;
         JNZ  TRYCRD

         LDM  R50,R60          ;
         JSB  =SAFE!           ;
         JSB  =FCOPY           ;
JDEFNF   DCE                   ;
         JEZ  ERRFNF           ;
         DCE                   ;
         JEZ  ERRFXX           ;
         DCE                   ;
         JEZ  ERRSZ2           ;
         GTO  CODONE            ;

ERRSZ2   JSBN  =ERROR+          ;
         DATA 16D

TRYCRD   CLM  R20              ;
         CMMD R60,=BLANKS      ;
         IFEQ
           LDM  R60,R50          ;
         ENDIF
         TSM  R34              ;
         IFZR
           LDM  R40,R60          ;
           JSB  =FCREAT          ;
           DCE                   ;
           JEZ  ERRFXX           ;
           DCE                   ;
           JEZ  ERRSZ2           ;
           ICB  R20              ;
           STMD R60,=PROTEM      ;
           LDM  R66,R30          ;
         ELSE
           STMD R60,=PROTEM      ;
           CMB  R60,='.'         ;
           JEQ  ERRVLT           ;
           LDM R0,=60,370
           JSB  =UPRC*           ;
           ARP  R34              ;
           JSB  =CDPC?           ;
         ENDIF
         TSM  R24              ;
         IFZR
           ICB  R20              ;
           LDM  R40,R50          ;
           JSB  =SAFE!           ;
           JSB  =FOPEN           ;
           CLM  R26              ;
           JEN  JDEFNF           ;
           LDM  R56,R30          ;
         ELSE
           ARP  R24              ;
           JSB  =CDPC?           ;
           IFEZ
             CMMD R50,=BLANKS      ;
             IFEQ
               LDMD R50,=PROTEM      ;
               CMMD R50,=APFIL0      ;
               IFEQ
                 LDMD R50,=APFILE      ;
               ENDIF
               LDM  R0,=50,370       ;
               JSB  =UPRC*           ;
             ENDIF
           ENDIF
         ENDIF
         CMM  R20,=MONITR      ;
         IFEQ
           JSB  =CRDCPY          ;
         ELSE
           JSB  =FILHAN          ;
         ENDIF

CODONE   LDM  R66,='  '        ;
         CMMD R60,=APFIL0      ;
         IFEQ
           JSB  =SYSJSB          ;
           DEF APTMRG
         ENDIF
         RTN                   ;

ERRVLT   JSBN  =ERROR+          ;
         DATA 63D

CDPC?    CLE                   ;
         LDM  R44,R#
         CMM  R44,="CARD"
         IFNZ
           CMM  R44,="PCRD"
           JNZ  NOPCCD
         ENDIF
         ICE                   ;
         ICB  R21              ;
NOPCCD   RTN                   ;


HANDI?   LDB  R52,=1           ;
         DCE                   ;
         JEZ  SVEFLG           ;
         DCE                   ;
         REN
         LDB  R52,=-2
         JSB  =HANDI           ;
           VAL V.SPEC
           DATA 63D

SVEFLG   ADBD R52,=FLSPEC      ;
         STBD R52,=FLSPEC      ;
         RTN                   ;

UPRC*    LOOP
           DRP R*
           JSB  =ALFA#          ;
           ADM  R0,=1,1
         WHNC
         RTN                   ;

         VAL PGMRSW
PLIST.   BIN                   ;
         JSB  =PRINT.          ;
         JMP  GOLIST

         VAL PGMRSW
LIST.    BIN                   ;
         JSB  =DISP.           ;

GOLIST
         LDB  R14,=(TYLST?)|(TYRAM?)
         JSB  =GF2LN#          ;
         REN
         LDB  R67,R15          ;

LSTLUP   JSB  =HALT?           ;
         IFEN
           JSB  =BLIMP           ;
           RTN                   ;
         ENDIF
         ANM  R67,=TYRUN?      ;

         IFZR
           LDBD R2,=ROUTE        ;
           CMB  R2,=2            ;
           IFEQ
krcmd_l1     LDBD R20,R26          ;
             JSB  =DIGIT           ;
             JEZ  READY            ;
             ICM  R26              ;
             DCB  R54              ;
             JNZ  krcmd_l1         ;
           ENDIF
         ENDIF

READY    LDB  R20,=1           ;
         LDM  R36,R54          ;
         JSB  =PRNFMT          ;
         JSB  =LINEND          ;
         JMP  LSTLUP           ;


HALT?    JSB  =STOP?           ;
         JEN  STOPEX           ;
         POMD R45,+R24         ;
         BIN                   ;
         CMMD R45,=BASEND      ;
         JZR  STOPEX           ;
         LDMD R36,=ENLIN#     ;
         BCD                   ;
         CMM  R36,R45          ;
         BIN                   ;
         JNC  STOPEX           ;
         LDM  R36,R45          ;
         STM  R36,R64          ;
         LDM  R30,=INPBUF      ;
         JSB  =DECOM           ;
         JNG  STOPEX           ;
         LDM  R26,=INPBUF      ;
         LDM  R54,R30          ;
         SBM  R54,R26          ;
         CLE                   ;
         RTN                   ;

STOPEX   CLE                   ;
         ICE                   ;
         RTN                   ;

GF2LN#
         JSB  =GRANGE          ;
         REN
         JSB  =FLDDTH          ;
         JEN  EPLUS1           ;
         JSB  =SETPR           ;
         REN
         LDMD R76,=STLIN#      ;
         JSB  =FNDLPR          ;
         LDM  R24,R36          ;
         CLE                   ;
         RTN                   ;

EPLUS1   ICE                   ;
         RTN                   ;

GRANGE
         BCD                   ;
         CLM  R26              ;
         STMD R26,=STLIN#      ;
         DCM  R26              ;
         STMD R26,=ENLIN#    ;
         JSB  =TO?I            ;
         BIN                   ;
         REZ
         LDM  R26,R45          ;
         STMD R26,=STLIN#      ;
         STMD R26,=ENLIN#     ;
         DCE                   ;
         REZ

         CLE                   ;
         LDM  R2,R55           ;
         STMD R2,=ENLIN#      ;
         CMM  R2,R26           ;
         JNC  BADNUM           ;
         RTN                   ;

         VAL PGMRSW
DELET.
         LDMD R40,=EDNAME      ;
         JSB  =SAFE!           ;
         LDMD R26,=TOS         ;
         JSB  =GETINTCMD          ; CE D8 1C
         LDMD R30,=CURLN#      ;
         IFEZ
           LDM  R30,R45          ;
         ENDIF
         JSB  =GETINTCMD          ; CE D8 1C
         LDM  R32,R30          ;
         IFEZ
            LDM  R32,R45          ;
         ENDIF
         CMM  R32,R30          ;
         IFNC
BADNUM     JSB  =ERR1+           ;
           DATA 90D
         ENDIF
         JSB  =DELLNS          ;
         RTN                   ;

         VAL  PGMRSW
RENUM.
         LDMD R26,=TOS         ;
         JSB  =GETINTCMD          ;
         LDM  R30,=(10C).2
         STM  R30,R32          ;
         IFEZ
           LDM  R30,R45          ;
         ENDIF
         JSB  =GETINTCMD
         IFEZ
           LDM  R32,R45          ;
         ENDIF
         JSB  =GETINTCMD          ;
         CLM  R34              ;
         IFEZ
           LDM  R34,R45          ;
         ENDIF
         JSB  =GETINTCMD          ;
         LDM  R36,=9999H
         IFEZ
           LDM  R36,R45          ;
         ENDIF
         LDMD R40,=EDNAME      ;


FRENUM
         BCD                   ;
         TSM  R32              ;
         JZR  BADNUM           ;
         CMM  R36,R34          ;
         JNC  BADNUM           ;

         LDMD R76,=PCR         ;
         JSB  =FXRENU          ;
         STMD R76,=PCR         ;
         REN
         LDM  R76,R36          ;
         JSB  =FNDLPR          ;
         LDMD R26,R36          ;
         CMM  R26,R76          ;
         IFEQ
           JSB  =SKPLN           ;
           LDMD R26,R36          ;
         ENDIF
         LDM  R76,R34          ;
         JSB  =PFNDPR          ;

         LDM R34,R26
          *
         STM R36,R26
         LDMD R2,R26           ;
         STM R2,R22
         CMM  R36,R24
         IFNE
           LDMD R2,R24           ;
           CMM  R2,R30           ;
           JCY  FRESET
         ENDIF

RESTAR
         LOOP
           LDMD R2,R36           ;
           CMM  R2,R34           ;
           RCY
           CMM  R30,R34          ;
           JCY  FRESET           ;
           CMMD R2,=CURLN#       ;
           DRP R30
           IFEQ
             STMD R30,=CURLN#      ;
           ENDIF
           STMD R30,R36          ;
           JSB  =SKPLN           ;
           BCD                   ;
           ADM  R30,R32          ;
         WHNC
         LDMD R30,R36
         CMM  R30,R34
         RCY

FRESET
         JSB  =WARN            ;
         DATA  90D
         CLM  R32              ;
         ICM  R32              ;

*        LDMD R36,=STARAD      ;
*        LDMD R30,=STLIN#      ;
         LDM  R36,R26
         LDM  R30,R22
         JMP  RESTAR
GAP000   NOP

GETINTCMD
         BIN                   ;
         CLE                   ;
         POMD R40,+R26         ;
         CMM  R26,R12          ;
         IFCY
           IFNE
             ICE                   ;
           ENDIF
           LDMD R12,=TOS         ;
         ENDIF
         RTN                   ;
       TITLE 'krutv'
*
*  __________________________________________________________________
* |RHUTV 549 04/02/82 - 4/20/1982 7:51PM                             |
* |==================================================================|
* ||                                                                ||
* ||   @@@@@@@@    @@      @@  @@      @@  @@@@@@@@@@  @@      @@   ||
* ||   @@@@@@@@@   @@      @@  @@      @@  @@@@@@@@@@  @@      @@   ||
* ||   @@     @@@  @@      @@  @@      @@      @@      @@      @@   ||
* ||   @@      @@  @@      @@  @@      @@      @@      @@      @@   ||
* ||   @@     @@   @@      @@  @@      @@      @@       @@    @@    ||
* ||   @@@@@@@     @@@@@@@@@@  @@      @@      @@       @@    @@    ||
* ||   @@@@@@@     @@@@@@@@@@  @@      @@      @@       @@    @@    ||
* ||   @@    @@@   @@      @@  @@      @@      @@        @@  @@     ||
* ||   @@     @@@  @@      @@  @@      @@      @@         @@@@      ||
* ||   @@      @@  @@      @@  @@@    @@@      @@         @@@@      ||
* ||   @@      @@  @@      @@   @@@@@@@@       @@          @@       ||
* ||   @@      @@  @@      @@    @@@@@@        @@          @@       ||
* ||                                                                ||
* ||                    Last edited: 82098.1341                     ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
RTOIN    STM  R60,R70          ;
RTOIN1   BCD                   ;
         CLE                   ;
         CMB  R64,=377         ;
         RCY
         STM  R60,R40          ;
         JSB  =INFR3           ;
         CLM  R60              ;
         ICM  R36              ;
         JZR  RNDIT            ;
         JLN  TSTBIG           ;
         TSM  R50              ;
         JZR  BIG1-            ;
RNDSHF   LLM  R50              ;
         JZR  BIG2             ;
         DCM  R36              ;
         JNZ  RNDSHF           ;
         JMP  TSTBIG           ;

BIG2     LDB  R53,=1           ;
         JMP  TSTBIG           ;

RNDIT    ADB  R47,=50C         ;
         JNC  TSTBIG           ;
         ICM  R50              ;

TSTBIG   CLE                   ;
         ICE                   ;
         LDM  R65,=99C,99C,9C
         TSM  R53              ;
         JNZ  BIG1             ;
         CMB  R52,=10C         ;
         JCY  BIG1             ;
         LDM  R65,R50          ;

BIG1-    CLE                   ;
BIG1     TSB  R32              ;
         RRZ
         TCM  R65              ;
         RTN                   ;

CONINT
         SAD                   ;
         BCD                   ;
         CLM  R76              ;
         CLE                   ;
         ELB  R67              ;
         TSM  R60              ;
         JNZ  CONIN1           ;
         ELB  R76              ;
         PAD                   ;
         RTN                   ;

CONIN1   ERB  R67              ;
         PUMD R32,+R6          ;
         PUMD R40,+R6          ;
         JSB  =RTOIN1          ;
         CLM  R76              ;
         TSB  R67              ;
         JLZ  CONINI2          ;
         TCM  R65              ;
CONINI2  LDM  R36,=0,20
         LDM  R34,=4,0
NXTVAL   BIN                   ;
         LLB  R#              ;
         BCD                   ;
         LDMD R56,X34,TABD     ;
         STM  R56,R55          ;
         CLB  R57              ;

VALLOP   SBM  R65,R55          ;
         JNC  NXTCON           ;
         BIN                   ;
         ADM  R76,R36          ;
         BCD                   ;
         JNO  VALLOP           ;
BIGNUM   LDM  R76,=377,177
SMLNUM   CLE                   ;
         DCE                   ;
NGTST    TSB  R32              ;
         JRZ  CONOUT           ;
         BIN                   ;
         TCM  R76              ;
CONOUT   POMD R40,-R6          ;
         POMD R32,-R6          ;
         PAD                   ;
         RTN                   ;

NXTCON   ADM  R65,R55          ;
         BIN                   ;
         LRM  R37              ;
         LRM  R37              ;
         LRM  R37              ;
         LRB  R34              ;
         DCB  R34              ;
         JPS  NXTVAL           ;
         CLE                   ;
         JMP  NGTST            ;

TABD     DATA (1C).2
         DATA (8C).2
         DATA (64C).2
         DATA (512C).2
         DATA (4096C).2

FETSVA
         JSB  =FETCHA          ;
         STM  R36,R34          ;
         RTN                   ;
FETAV
         JSB  =FETAVA          ;
         JMP  FETNUM           ;

FETSV    JSB  =FETSVA          ;
FETNUM   JSB  =FNUM            ;
FETIND   CMB  R67,=377         ;
         RNC
         CLM  R60              ;
         JSBN  =ERROR+          ;
         DATA 7D              ;

FETSET
         POMD R66,-R12         ;
FETCHA   BIN                   ;
         LDMD R34,=RNFILE      ;
         ADM  R34,R66          ;
         POMD R46,+R34         ;

FETRVA
         BIN                   ;
         LDM  R36,R34          ;
         TSB  R46              ;
         JNG  STRVAR           ;
         CMB  R46,=100         ;
         JCY  ARRVAR           ;

INDRCT   LDMD R36,R36          ;
         LDB  R3,R47           ;
         IFNG
           ADMD R36,=FWVARS      ;
           LDMD R36,R36          ;
         ENDIF
         ADMD R36,=FWVARS      ;
         RTN                   ;

ARRVAR   ADM  R36,=(4).2
STRVAR   ICM  R36              ;
         ICM  R36              ;
         JMP  INDRCT           ;

FNUM     LDB  R0,=60           ;
         LDB  R36,R46          ;
         BCD                   ;
         LRB  R36              ;
         BIN                   ;
         ANM  R36,=3,0
         JZR  FREAL            ;
         LDB  R0,=65           ;
         DCB  R36              ;
         JZR  FINT             ;

         DCB  R0               ;
         LDMD R*,R34           ;
         CLM  R36              ;
         STM  R36,R60          ;
         STM  R36,R62          ;
         LDB  R36,R64          ;
         STB  R37,R64          ;
         BCD                   ;
         CMB  R67,=377         ;
         RCY
         LLM  R60              ;
         ELB  R32              ;
         TSB  R32              ;
         IFOD
           TCM  R36              ;
         ENDIF
         LLB  R37              ;
         BIN                   ;
         LRB  R32              ;
         BCD                   ;
         TSB  R32              ;
         IFOD
           ADB  R37,=11          ;
         ENDIF
         STM  R36,R60          ;
         BIN                   ;
         RTN                   ;

FINT     LDB  R64,=377         ;
FREAL    LDMD R*,R34           ;
         RTN                   ;

FETAVA
         BIN                   ;
         POBD R22,-R12         ;
         PUBD R22,+R6          ;
         CLM  R26              ;
krutv_l1 JSB  =ONEB            ;
         STM  R46,R74          ;
         TSB  R22              ;
         JNZ  krutv_l2
         ICB  R22              ;
         LDM  R26,R74          ;
         JMP  krutv_l1

krutv_l2 STM  R26,R76          ;
         JSB  =FETBET          ;
         STM  R74,R40          ;
         POBD R44,-R6          ;
         CLM  R32              ;
         POMD R66,+R34         ;
         IFNG
           ICM  R32              ;
         ENDIF
         STM  R32,R30          ;
         DCM  R32              ;
         TCM  R32              ;
         POMD R66,+R34         ;
         LDM  R26,R74          ;
         JSB  =TSTDIM         ;
         POMD R66,+R34         ;
         JPS  TWODIM           ;
         TSB  R44              ;
         JEV  DIMERR           ;
         LDM  R66,R74          ;
         SBM  R66,R32          ;
         JMP  VCTOR

TWODIM   LDM  R26,R76          ;
         TSB  R44              ;
         JOD  DIMERR           ;
         JSB  =TSTDIM          ;
         LDM  R76,R74          ;
         SBM  R76,R32          ;
         SBM  R26,R32          ;
         ADM  R66,R30          ;
         CLM  R54              ;
         JSB  =INTMUL          ;
         LDM  R66,R54          ;
         ADM  R66,R26          ;

VCTOR    BCD                   ;
         LDB  R57,R46          ;
         LRB  R57              ;
         ANM  R57,=3           ;
         BIN                   ;
         STM  R66,R76          ;
         LLM  R66              ;
         DCB  R57              ;
         JNZ  VCTOR1           ;
         ADM  R66,R76          ;
         JMP  VCTOR2           ;

VCTOR1   LLM  R66              ;
         DCB  R57              ;
         JZR  VCTOR2           ;
         LLM  R66              ;
VCTOR2   ADM  R36,R66          ;
         STM  R36,R34          ;
         RTN                   ;

TSTDIM   CMM  R66,R26          ;
         JNG  DIMERR           ;
         CMM  R26,R32          ;
         JNG  DIMERR           ;
         RTN                   ;

DIMERR   DCM  R6               ;
         DCM  R6               ;
         JSB  =ERR1+           ;
         DATA 27D

FETST
         PUMD R36,+R6          ;
         JSB  =FETSET          ;
         POMD R56,+R34         ;
         STM  R56,R54          ;
         STM  R36,R34          ;
         POMD R36,-R6          ;
         POMD R56,+R34         ;
         IFEN
           LDM  R56,R54          ;
         ELSE
STRIND     CMM  R56,=377,377
           IFEQ
             CLM  R56              ;
             JSB  =ERROR           ;
             DATA 7D
           ENDIF
         ENDIF
         PUMD R56,+R12         ;

PUTREL
         DRP  R34
PUTADR
         CMM  R#,R12          ;
         JZR  PUTRL#           ;
         JCY  NOCODE           ;
PUTRL#
         ARP  !12
         SBM  R#,R12          ;
         TCM  R#             ;
NOCODE   
         ARP  !12
         PUMD R#,+R12         ;
         RTN                   ;

GETADR
         DRP  R34
GETAD#
         POMD R#,-R12         ;
GETAD+   BIN                   ;
         RNG
         TCM  R#              ;
         ADM  R#,R12          ;
         RTN                   ;
       TITLE 'krmem'
*
*  __________________________________________________________________
* |KXMEM 273 09/27/82 - 12/15/1982 3:33PM                            |
* |==================================================================|
* ||                                                                ||
* ||   @@     @@@  @@      @@  @@      @@  @@@@@@@@@@  @@      @@   ||
* ||   @@    @@@   @@      @@  @@@    @@@  @@@@@@@@@@  @@@    @@@   ||
* ||   @@   @@@    @@@    @@@  @@@@  @@@@  @@          @@@@  @@@@   ||
* ||   @@  @@@      @@@  @@@   @@@@@@@@@@  @@          @@@@@@@@@@   ||
* ||   @@ @@@         @@@@     @@  @@  @@  @@          @@  @@  @@   ||
* ||   @@@@@           @@      @@  @@  @@  @@@@@@@@@   @@  @@  @@   ||
* ||   @@@@@           @@      @@      @@  @@@@@@@@@   @@      @@   ||
* ||   @@ @@@         @@@@     @@      @@  @@          @@      @@   ||
* ||   @@  @@@      @@@  @@@   @@      @@  @@          @@      @@   ||
* ||   @@   @@@    @@@    @@@  @@      @@  @@          @@      @@   ||
* ||   @@    @@@   @@      @@  @@      @@  @@@@@@@@@@  @@      @@   ||
* ||   @@     @@@  @@      @@  @@      @@  @@@@@@@@@@  @@      @@   ||
* ||                                                                ||
* ||                    Last edited: 821207.0731                    ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
FLINIT   LDM  R12,=LEWYSZ      ;
         STMD R12,=LEEWAY      ;
         LDM  R12,=TABEND      ;
         CLM  R44              ;
         PUMD R44,+R12         ;
         STMD R12,=FWUSER      ;
RSETEN   STMD R#,=FWVARS       ;
SETTOS   STMD R#,=NXTMEM       ;
         STMD R#,=TOS          ;
         STMD R#,=STSIZE       ;
         RTN                   ;
*
ONR12?   BIN                   ;
         CLE                   ;
         LDMD R2,=TOS          ;
         SBM  R2,R12           ;
         IFNC
           ICE                   ;
         ENDIF
         TCM  R2               ;
         RTN                   ;
*
SETRN    JSB  =GOPEN          ;
         REN
         STMD R15,=RNTYPE      ;
         LDMD R26,=FILLOC      ;
         STMD R26,=RNFILE      ;
         STMD R40,=RNNAME      ;
         RTN                   ;
*
SETPR    JSB  =GOPEN!          ;
         REN
         LDMD R26,=FILLOC      ;
         STMD R26,=PRFILE      ;
         STMD R40,=PRNAME      ;
         RTN                   ;
*
ROOM?    CLE                   ;
         TSM  R32              ;
         RNG
         LDMD R2,=LEEWAY       ;
         DCM  R2               ;
         ADMD R2,=TOS          ;
         ADM  R2,R32           ;
         JCY  NOROOM_MEM       ;
         CMMD R2,=LAVAIL       ;
         RNC
NOROOM_MEM
         ICE                   ;
         RTN                   ;
*
UROOM!   CLE                   ;
         TSM  R32              ;
         JNG  OUTROM           ;
ROOM!    JSB  =ROOM?           ;
         REZ
OUTROM   JSB  =ERR1+           ;
         DATA  16D              ;

ALCALL   LDMD R32,=LAVAIL      ;
         SBMD R32,=TOS         ;
         SBMD R32,=LEEWAY      ;
         JNG  OUTROM           ;
*
ALLOC    PUMD R30,+R6          ;
         PUMD R32,+R6          ;
         PUMD R34,+R6          ;
         JSB  =ADJUST          ;
         JEN  RESTIT           ;
         LDM  R34,R30          ;
         ADM  R30,R32          ;
         JMP  COPYIT           ;
*
DELETE   PUMD R30,+R6          ;
         PUMD R32,+R6          ;
         PUMD R34,+R6          ;
         TCM  R32              ;
         JSB  =ADJUST          ;
         TCM  R32              ;
         LDM  R34,R30          ;
         ADM  R34,R32          ;
COPYIT   LDM  R32,R12          ;
         SBM  R32,R30          ;
         JSB  =COPY            ;
RESTIT   POMD R34,-R6          ;
         POMD R32,-R6          ;
         POMD R30,-R6          ;
         RTN                   ;
*
FPURGE   PUMD R30,+R6          ;
         PUMD R32,+R6          ;
         PUMD R34,+R6          ;
         JSB  =FOPEN           ;
         JEN  RESTIT           ;
         LDM  R34,R30          ;
         LDMD R30,R34          ;
         LDMD R32,X34,DR.SIZ
         ICM  R32              ;
         JSB  =DELETE          ;
         LDM  R30,R34          ;
         LDM  R32,=(DRENSZ).2    ;
         JSB  =DELETE          ;
         JMP  RESTIT           ;
*
INSERT   JSB  =ALLOC           ;
*
* ********************************************************************
* [EVERETT KASER: Note: this code file (KXMEM) is split across two
* physical ROMs.  The following instruction is in the last two bytes
* of the first system ROM, and the rest of the routine contines in
* the second system ROM at address 0x2000.
* ********************************************************************
*
         REN
*
         CMM  R30,R34          ;
         JCY  krmem_l1         ;
         CMM  R34,R12          ;
         JCY  krmem_l1         ;
         ADM  R34,R32          ;
krmem_l1 JSB  =COPY            ;
         RTN                   ;
*
FCRALO   PUMD R32,+R6          ;
         JSB  =FOPEN           ;
         JEN  krmem_l20         ;
krmem_l2 ICE                   ;
         JMP  FCRRTN           ;
krmem_l20
         ADM  R32,=((DRENSZ)+1).2
         JSB  =ROOM!           ;
         JEN  krmem_l2         ;

         LDMD R30,=FWUSER      ;
         DCM  R30              ;
         SBM  R32,=(DRENSZ).2      ;
         JSB  =ALLOC           ;
         LDM  R30,=DIRECT      ;
         LDM  R32,=(DRENSZ).2     ;
         JSB  =ALLOC           ;
         POMD R2,-R6           ;
         PUMD R2,+R6           ;
         LDMD R32,=FWUSER      ;
         DCM  R32              ;
         DCM  R32              ;
         SBM  R32,R2           ;
         PUMD R32,+R30         ;
         PUMD R2,+R30          ;
         CLM  R2               ;
         STMD R2,R30           ;
         PUMD R40,+R6          ;
         JSB  =SYSJSB          ;

         DEF  CRTMDT
         LDM  R2,=(TYRAM?).2       ;
         ORM  R2,R20           ;
         PUMD R2,+R30          ;
         PUMD R44,+R30         ;
         POMD R40,-R6          ;
         PUMD R40,+R30         ;
         SBM  R30,=(DRENSZ).2      ;
FCRRTN   POMD R32,-R6          ;
         RTN                   ;
* FCREAT is LCL 0152H
* FCREAT is GLOBAL 206D
* 
FCREAT   PUMD R32,+R6          ;
         CLM  R32              ;
         JSB  =FCRALO          ;
         POMD R32,-R6          ;
         RTN                   ;

FCRNUK   PUMD R32,+R6          ;
         LDM  R32,=((PCBLEN)+(ENDSIZ)).2
         JSB  =FCRALO          ;
         JEN  FNCRTN          ;
         PUMD R30,+R6          ;
         LDMD R30,R30          ;
         JSB  =PGMSET          ;
         POMD R30,-R6          ;

FNCRTN   POMD R32,-R6          ;
         RTN                   ;

PGMSET   PUMD R43,+R6          ;
         CLM  R43              ;
         PUMD R43,+R30         ;
         PUMD R43,+R30         ;
         LDM  R43,=
BASEND     DEF ENDLIN
           DATA 2,8AH,0EH
dummy0   PUMD R43,+R30         ; dummy label used to be compatible with the
                               ; karma code. Karma does not recognize that
                               ; BASEND does not label an executable opcode
         POMD R43,-R6          ;
         RTN                   ;

FEMPT?   PUMD R30,+R6          ;
         JSB  =CHKR50          ;
         LDMD R30,X30,DR.SIZ
         CMM  R30,=((PCBLEN)+(ENDSIZ)).2
         IFZR
           ICE                   ;
         ENDIF
         POMD R30,-R6          ;
         RTN                   ;

CHKR50   PUMD R40,+R#          ;
         LDM  R40,R50          ;
         JSB  =FOPEN           ;
         POMD R40,-R6          ;
         RTN                   ;

FRENAM
         JSB  =SAFE!           ;
         PUMD R30,+R6          ;
         JSB  =CHKR50          ;
         JEZ  RENFND           ;
gap111   NOP
         NOP
         NOP
         NOP
         NOP
      
         JSB  =FOPEN           ;
         JEN  RENRTN           ;

         CMMD R40,=EDNAME      ;
         IFEQ
           STMD R50,=EDNAME      ;
         ENDIF
         CMMD R40,=RNNAME      ;
         IFEQ
           STMD R50,=RNNAME      ;
         ENDIF
         CMMD R40,=PRNAME      ;
         IFEQ
           STMD R50,=PRNAME      ;
         ENDIF
         STMD R50,X30,DR.NAM

RENRTN   POMD R30,-R6          ;
         RTN                   ;

RENFND   ICE                   ;
         ICE                   ;
         JMP  RENRTN           ;

FCOPY    JSB  =SAVEME          ;
         PUMD R20,+R6          ;
         PUMD R34,+R6          ;
         JSB  =GOPEN           ;
         JEN  FCRTN            ;
         JSB  =GETRM2          ;

FCOPYG   POMD R34,+R30         ;
         STMD R34,=KLUDGE      ;
         POMD R32,+R30         ;
         POMD R20,+R30         ;
         LDM  R40,R50          ;
         JSB  =FCRALO
         JEN  FCCANT           ;

         LDMD R34,=KLUDGE      ;
         LDMD R30,R30          ;
         JSB  =COPY
         JMP  FCRTN            ;
gap007
         NOP
         NOP
         NOP
         NOP
         NOP
         NOP
         NOP

FCCANT   ICE

FCRTN    POMD R34,-R6          ;
         POMD R20,-R6          ;
         RTN                   ;

FNDLPR   LDMD R36,=PRFILE      ;
         JMP  krmem_l3         ;

FNDLRN   LDMD R36,=RNFILE      ;
         JMP  krmem_l3         ;

FNDLED
FNDLIN
         LDMD R36,=EDFILE      ;
krmem_l3 BIN                   ;
         ADM  R#,=(PCBLEN).2

FSEEK    CLE                   ;
         BIN                   ;
krmem_l4 CMMD R76,R36          ; JUMP??
         JZR  YESFND           ;
         JNC  NOTFND           ;
         JSB  =SKPHBH          ;
         JMP  krmem_l4         ;

NOTFND   ICE                   ;
YESFND   RTN                   ;

PFNDPR
         LDMD R36,=PRFILE      ;
         JMP  krmem_l5         ;
PREFND
         LDMD R36,=EDFILE      ;
krmem_l5 BIN                   ;
         ADM  R36,=(PCBLEN).2      ;
         STM  R36,R24          ;
         LOOP
           LDMD R2,R36           ;
           CMM  R2,R76           ;
           JCY  GOT_IT           ;
           STM  R36,R24          ;
           JSB  =SKPLN#          ;
         WHMP
GOT_IT
         RTN                   ;

SKPLN    BIN                   ;
SKPHBH   DRP  R36
SKPLN#   STM  R#,R2           ;
         POMD R#,+R2          ;
         CLM  R#              ;
         POBD R#,+R2          ;
         ADM  R#,R2           ;
         RTN                   ;

IOPEN    CLM  R32              ;
         LDBD R32,=RAMLEN      ;
         LDM  R34,=TMPMM2      ;
         CLM  R44              ;
IZOPEN   DRP  !44
         STMD R44,=(TMPMM2)+(DATA#)-3
         STMD R60,=(TMPMM2)+(NAME#)-3
         STMD R20,=(TMPMM2)+(ROM#)-3

FSREPL   JSB  =FSEEK           ;

REPLIN
         TSB  R33              
         IFNZ
           JSB  =ERR1+           ;
           DATA 67D
         ENDIF
         PUMD R30,+R6          ;
         PUMD R32,+R6          ;
         PUMD R36,+R6          ;
         STM  R32,R0           ;
         CLM  R32              ;
         CMMD R76,R36          ;
         JNE  krmem_l6         ;
         JSB  =LINLEN          ;
krmem_l6 STM  R36,R30          ;
         LDM  R36,R0           ;
         ADM  R36,=3D,0
         SBM  R34,=3D,0
         JSB  =REPLAC          ;
         ADM  R34,=3D,0
         POMD R36,-R6          ;
         POMD R32,-R6          ;
         IFEZ
           PUMD R76,+R30         ;
           PUBD R32,+R30         ;
         ENDIF
         POMD R30,-R6          ;
         RTN                   ;

LINLEN   LDM  R2,R36           ;
         ADM  R2,=2D,0
         CLM  R32              ;
         LDBD R32,R2           ;
         ADM  R32,=3D,0
         RTN                   ;

DELLIN   PUMD R30,+R6          ;
         LDM  R30,R36          ;
         PUMD R32,+R6          ;
         JSB  =LINLEN          ;
         JSB  =DELETE          ;
         POMD R32,-R6          ;
         POMD R30,-R6          ;
         RTN                   ;

PTALO?   LDMD R56,=PRFILE      ;
         LDMD R56,R56          ;
         CLE                   ;
         RZR
         ICE                   ;
         RTN                   ;

FLOPEN   BIN                   ;
         JSB  =FOPEN           ;
         REN

MOVEUP   LDMD R36,R30          ;
         ADM  R36,=(PCBLEN).2
         RTN                   ;

FDELLN   JSB  =FLOPEN          ;
         REN
         JSB  =FSEEK           ;
         REN
         JSB  =DELLIN          ;
         RTN                   ;

DELLHS   BIN                   ;
         LDM  R76,R30          ;
         JSB  =FNDLPR          ;
         STM  R36,R30          ;
         LDM  R76,R32          ;
         JSB  =FNDLPR          ;
         IFEZ
           JSB  =SKPLN         ;
         ENDIF
         STM  R36,R32          ;
         SBM  R32,R30          ;
         JSB  =DELETE          ;
         RTN                   ;

FREPLS   PUMD R20,+R6          ;
         LDM  R20,=TYSYSM      ;
         JSB  =FREPLN          ;
         POMD R20,-R6          ;
         RTN                   ;

FREPLN   STMD R34,=KLUDGE      ;
         JSB  =FCRNUL          ;
         LDMD R34,=KLUDGE      ;
         IFEN
           DCE                   ;
           REN
         ENDIF

         JSB  =MOVEUP          ;
         JSB  =FSREPL          ;
         RTN                   ;

MOVE     PUMD R40,+R6          ;
         LDM  R40,R20          ;
         PUMD R40,+R6          ;
         LDM  R40,R30          ;
         PUMD R40,+R6          ;
         STM  R40,R20          ;
         LDM  R26,=(TMPLEN).2      ;
         CMM  R20,R24          ;
         JNC  TLTS             ;
         LDM  R2,R20           ;
         SBM  R2,R24           ;
         SBM  R2,R22           ;
         LDM  R20,R24          ;
         ADM  R24,R22          ;
         LDM  R22,R2           ;
TLTS     CMM  R26,R22          ;
         JNC  krmem_l7         ;
         LDM  R26,R22          ;
         JZR  MOVRTN           ;
krmem_l7
         LDM  R30,=TMPMM2      ;
         LDM  R32,R26          ;
         LDM  R34,R24          ;
         JSB  =COPY            ;
         LDM  R32,R24          ;
         SBM  R32,R20          ;
         LDM  R34,R20          ;
         LDM  R30,R20          ;
         ADM  R30,R26          ;
         JSB  =COPY            ;
         LDM  R30,R20          ;
         LDM  R32,R26          ;
         LDM  R34,=TMPMM2      ;
         JSB  =COPY            ;
         ADM  R20,R26          ;
         SBM  R22,R26          ;
         ADM  R24,R26          ;
         JMP  TLTS             ;

MOVRTN   POMD R40,-R6          ;
         STM  R40,R30          ;
         POMD R40,-R6          ;
         STM  R40,R20          ;
         POMD R40,-R6          ;
         CMM  R30,R34          ;
         IFCY
           SBM  R30,R32          ;
         ELSE
           ADM  R34,R32          ;
         ENDIF
         RTN                   ;

COPY     PUMD R40,+R6          ;
         LDM  R40,R30          ;
         PUMD R40,+R6          ;
         LDM  R36,R32          ;
         LRM  R37              ;
         LRM  R37              ;
         CMM  R34,R30          ;
         JZR  CPYRTN           ;
         JCY  CPYINC           ;
         ADM  R30,R32          ;
         ADM  R34,R32          ;
         LRM  R37              ;
         JZR  krmem_l8         ;

krmem_l9 POMD R40,-R34         ;
         PUMD R40,-R30         ;
         DCM  R36              ;
         JNZ  krmem_l9         ;

krmem_l8 ANM  R32,=7,0
         JZR  CPYRTN           ;
         SBM  R30,R32          ;
         SBM  R34,R32          ;

CPRMDR   LDB  R0,=50           ;
         SBM  R0,R32           ;
         POMD R*,+R34          ;
         PUMD R*,+R30          ;

CPYRTN   POMD R40,-R6          ;
         STM  R40,R30          ;
         POMD R40,-R6          ;
         RTN                   ;

CPYINC   LRM  R37              ;
         JZR  krmem_l10

krmem_l11 POMD R40,+R34         ;
         PUMD R40,+R30         ;
         DCM  R36              ;
         JNZ  krmem_l11

krmem_l10 ANM  R32,=7,0
         JZR  CPYRTN           ;
         JMP  CPRMDR           ;

ADJUST   PUMD R26,+R6          ;
         PUMD R34,+R6          ;
         PUMD R36,+R6          ;
         JSB  =ROOM!           ;
         JEN  ADJRTN           ;
         LDM  R34,=DIRECT
         CMM  R30,R34          ;
         JNC  ADJRTN           ;
         CMM  R12,R30          ;
         JNC  ADJRTN           ;
ADJLOC
         LDMD R26,R34          ;
         JZR  ADJPNT           ;
         CMMD R30,R34          ;
         JCY  ADJSIZ           ;
         ADM  R26,R32          ;
         STMD R26,R34          ;
         ADM  R34,=(DRENSZ).2
         JMP  ADJLOC

ADJRTN   POMD R36,-R6          ;
         POMD R34,-R6          ;
         POMD R26,-R6          ;
         RTN                   ;

ADJSIZ   LDMD R2,=FWUSER       ;
         DCM  R2               ;
         CMM  R30,R2           ;
         IFNC
           LDMD R26,X34,DR.SIZ
           ADM  R26,R32          ;
           STMD R26,R2           ;
         ENDIF
ADJPNT   LDM  R34,=PRFILE      ;
         LOOP
           POMD R2,+R34          ;
           CMM  R30,R2           ;
           JCY  DONE?
           CMM  R12,R2           ;
           JNC  DONE?
           ADM  R2,R32           ;
           PUMD R2,-R34          ;
           POMD R2,+R34          ;
DONE?      CMM  R34,=NXTMEM      ;
         WHNE

         CMM  R10,R30          ;
         JNC  krmem_l12
         ADM  R10,R32          ;
krmem_l12
         CMMD R30,=STSIZE      ;
         JCY  krmem_l13
         LDMD R26,=STSIZE      ;
         ADM  R26,R32          ;
         STMD R26,=STSIZE      ;

krmem_l13
         LDMD R26,=NXTMEM      ;
         ADM  R26,R32          ;
         STMD R26,=NXTMEM      ;
         LDMD R26,=TOS         ;
         ADM  R26,R32          ;
         STMD R26,=TOS         ;
         ADM  R12,R32          ;
         JMP  ADJRTN

INSRTM   PUMD R30,+R6          ;
         STMD R30,=KLUDGE      ;
         LDM  R30,R34          ;
         TCM  R32              ;
         JSB  =ADJUST          ;
         TCM  R32              ;
         LDMD R30,=KLUDGE      ;
         JSB  =ADJUST          ;
         POMD R30,-R6          ;
         JSB  =MOVE            ;
         RTN                   ;

REOLAC   PUMD R32,+R6          ;
         SBM  R32,R36          ;
         TCM  R32              ;
         JSB  =ROOM!           ;
         JEN  REPRTN           ;
         TCM  R32              ;
         ADM  R32,R36          ;
         PUMD R12,+R6          ;
         JSB  =DELETE          ;
         POMD R2,-R6           ;
         CMM  R2,R34           ;
         JNC  krmem_l14        ;
         CMM  R34,R30          ;
         JNC  krmem_l14        ;
         SBM  R34,R32          ;
krmem_l14 
         LDM  R32,R36          ;
         JSB  =INSERT          ;

REPRTN   POMD R32,-R6          ;
         RTN                   ;

RESCON   JSB  =PAR1            ;
         CLM  R56              ;
         LDB  R56,R2           ;

RSMEM-   CLE                   ;
RSMEM=   SAD                   ;
         BIN                   ;

         LDMD R26,=LAVAIL      ;
         SBM  R26,R56          ;
         SBMD R26,=LEEWAY      ;
         LDMD R0,=TOS          ;
         CMM  R0,R26           ;
         JCY  OUTMEM           ;
         ADMD R26,=LEEWAY      ;
         STMD R26,=LAVAIL      ;
         IFEZ
           LDMD R34,=FWVARS      ;
           LDMD R32,X34,E.RMEM
           ADM  R32,R56          ;
           STMD R32,R2           ;
         ENDIF
         PAD                   ;
         CLE                   ;
         RTN                   ;

OUTMEM   CLM  R26              ;

ERRMEM
         PAD                   ;
         JSB  =ERR1+           ;
         DATA 16D


RELMEM   LDMD R34,=FWVARS      ;
         LDMD R56,X34,E.RMEM
         RZR
         SAD                   ;
         BIN                   ;
         LDMD R36,=LAVAIL      ;
         ADM  R36,R56          ;
         CMMD R36,=NXTRTN      ;
         IFCY
           JNZ  ERRMEM
         ENDIF
         STMD R36,=LAVAIL      ;
         CLM  R56              ;
         STMD R56,X34,E.RMEM
         PAD                   ;
         RTN                   ;

TYPOK?   LDBD R15,X30,DR.TYP   ;
         JMP  krmem_l15
FOPAC?
         LDB  R15,=ONES        ;
         PUMD R22,+R6          ;
         JSB  =GOPEN           ;
         POMD R22,-R6          ;
krmem_l15
         LDM  R3,R15           ;
         ANM  R3,R14           ;
         CMM  R3,R14           ;
         RTN                   ;

FOPEN!
         JSB  =FOPEN           ;
         JMP  krmem_l16
GOPEN!
         JSB  =GOPEN           ;
krmem_l16
         REZ
         JSB  =ERR1+           ;
         DATA 62D

FOPEN    LDM  R30,=TABEND      ;
FOPENG   STE                   ; STE is CLE, ICE
         BIN                   ;
         ARP  R30              ;
         JMP  START            ;

         LOOP
           ADM  R30,=(NAMLEN).2
START      LDMD R2,R#
           JZR  OPENER
           ADM  R30,=DR.NAM
           CMMD R40,R#
         WHNE
         CLE                   ;
         LDBD R15,X30,(DR.TYP)-(DR.NAM)
         LDMD R0,X30,(DR.LOC)-(DR.NAM)
         STMD R0,=FILLOC       ;
OPENER   SBM  R30,=DR.NAM      ;
         RTN                   ;

GOPEN
         JSB  =FOPEN           ;
         JEZ  GETNUM           ;

ROPEN    JSB  =SAVEME          ;
         PUMD R20,+R6          ;
         CLM  R20              ;
         STE                   ; CLE , ICE
         LOOP
           JSB  =NXTROM          ;
           JNZ  EXIT
           DRP  !2
           TSM  R2               ;
           DRP  R30              ;
           IFZR
             LDM  R30,=BASLOC      ;
           ELSE
             LDM  R30,=((ROM)+2).2
           ENDIF
           JSB  =FOPENG          ;
         WHEN

EXIT     POMD R20,-R6          ;

GETNUM   DRP R22
GETID#   LDMI R#,=ROMPTR      ;
         RTN                   ;
*

GETRID   DRP  R2               ;
         JMP  GETID#
       TITLE 'krsig'
*  __________________________________________________________________
* |IVSIG 479 05/10/82 - 5/13/1982 5:12PM                             |
* |==================================================================|
* ||                                                                ||
* ||   @@@@@@@@@@  @@      @@    @@@@@@    @@@@@@@@@@     @@@@      ||
* ||   @@@@@@@@@@  @@      @@   @@@@@@@@   @@@@@@@@@@   @@@@@@@@    ||
* ||       @@      @@      @@  @@@    @@@      @@      @@@    @@@   ||
* ||       @@      @@      @@  @@      @@      @@      @@      @@   ||
* ||       @@       @@    @@   @@@             @@      @@           ||
* ||       @@       @@    @@    @@@@@@@        @@      @@           ||
* ||       @@       @@    @@     @@@@@@@       @@      @@   @@@@@   ||
* ||       @@        @@  @@           @@@      @@      @@   @@@@@   ||
* ||       @@         @@@@     @@      @@      @@      @@      @@   ||
* ||       @@         @@@@     @@@     @@      @@      @@@    @@@   ||
* ||   @@@@@@@@@@      @@       @@@@@@@@   @@@@@@@@@@   @@@@@@@@    ||
* ||   @@@@@@@@@@      @@        @@@@@@    @@@@@@@@@@     @@@@      ||
* ||                                                                ||
* ||                    Last edited: 820908.1333                    ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
ZERO     ADDR 0H
SIGNIF   JSB  =DECURS          ;
SIGNF-   
         LOOP
           JSB  =WAITKY          ;
           DRP  R2               ;
           JSB  =LOOKUP          ;
           DEF  KEYS_SIG
           JEN  BADKEY           ;
           JSB  =DEQUE           ;
           DRP  R0               ; 40H
           JSB  X0,ZERO          ; 00 C6 00 00
         WHMP
BADKEY
         JSB  =KEY?            ;
         RTN                   ;

KEYS_SIG DATA ((FTCHKY)+(SHIFT)).1
         DATA (SF).2
         DATA LEFTKY
         DATA (LK).2
         DATA RGHTKY
         DATA (RK).2
         DATA ((LEFTKY)+(CNTL)).1
         DATA (CLLK).2
         DATA ((RGHTKY)+(CNTL)).1
         DATA (CLRK).2
         DATA ((LEFTKY)+(SHIFT)).1
         DATA (SHLK).2
         DATA ((RGHTKY)+(SHIFT)).1
         DATA (SHRK).2
         DATA 0

CLLK     LDMD R#,=LCDWIN      ;
         SBMD R#,=SIZSIZ      ;
         JMP  krsig_l1         ;

LK       LDMD R#,=LCDWIN      ;
         DCM  R#              ;
krsig_l1 CMM  R#,=LCDBUF      ;
         IFLO
           LDM  R#,=LCDBUF      ;
         ENDIF
         JMP  PUT

CLRK     LDMD R#,=LCDWIN      ;
         ADMD R#,=SIZSIZ      ;
         JMP  krsig_l2

RK       LDMD R#,=LCDWIN      ;
         ICM  R#             ;
krsig_l2 CMM  R#,=((LCDBUF)+65D).2
         IFHS
           LDM  R#,=((LCDBUF)+64D).2
         ENDIF
         JMP  PUT

SHLK     LDM  R#,=LCDBUF      ;
         JMP  PUT

SHRK     LDM  R#,=((LCDBUF)+64D).2

PUT      STMD R#,=LCDWIN      ;
         JSB  =PUTWIN          ;
         RTN                   ;

SF       LDM  R#,=((INPBUF)-1).2
         STMD R#,=LASTCH       ;
         JSB  =SYSJSB          ;
         DATA (SHFET).2
         RTN                   ;
       TITLE 'krpal'
*
*  __________________________________________________________________
* |KXPAL 321 09/27/82 - 12/14/1982 7:47AM                            |
* |==================================================================|
* ||                                                                ||
* ||   @@     @@@  @@      @@  @@@@@@@@      @@@@@@    @@           ||
* ||   @@    @@@   @@      @@  @@@@@@@@@    @@@@@@@@   @@           ||
* ||   @@   @@@    @@@    @@@  @@     @@@  @@@    @@@  @@           ||
* ||   @@  @@@      @@@  @@@   @@      @@  @@      @@  @@           ||
* ||   @@ @@@         @@@@     @@     @@@  @@      @@  @@           ||
* ||   @@@@@           @@      @@@@@@@@@   @@@@@@@@@@  @@           ||
* ||   @@@@@           @@      @@@@@@@@    @@@@@@@@@@  @@           ||
* ||   @@ @@@         @@@@     @@          @@      @@  @@           ||
* ||   @@  @@@      @@@  @@@   @@          @@      @@  @@           ||
* ||   @@   @@@    @@@    @@@  @@          @@      @@  @@           ||
* ||   @@    @@@   @@      @@  @@          @@      @@  @@@@@@@@@@   ||
* ||   @@     @@@  @@      @@  @@          @@      @@  @@@@@@@@@@   ||
* ||                                                                ||
* ||                    Last edited: 821214.0743                    ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
EROM

ROMCLA   LDM  R36,=GETNXT      ;
         JSB  =EXTRJM          ;

ROMCL-   CMB  R36,=57          ;
         RNC
         CLM  R36              ;
         DCM  R36              ;
         RTN                   ;
*
PTRALO
         JSB  =EVIL            ;
         DEF  (S20-77)
         JSB  =SETPR           ;
         LDB  R14,=(TYRUN?)|(TYLIN?)
         JSB  =TYPOK?          ;
         JNE  ALFINE           ;

         LDMD R0,X26,P.PLEN
         STMD R0,=LSTPLN       ;
         LDMD R0,X26,P.ELEN
         STMD R0,=LSTELN       ;
         JSB  =PTALO?          ;
         CMMD R40,=CALNAM      ;
         IFNE
           CLM  R74              ;
           STMD R74,=LSTPLN      ;
           JEN  ALFINE
         ENDIF
         LDMD R0,X30,DR.SIZ
         LDMD R2,X26,P.PLEN
         SBM  R0,R2            ;
         STMD R0,R26           ;
         JSB  =ALINI           ;
         JSB  =ALCALL          ;
         REN
         LDM  R2,R30           ;
         ADM  R2,R32           ;
         STMD R2,=FILEND       ;
         JSB  =SAVEME          ;
         JSB  =ROMRTN          ;

NXTONE
         JSB  =GTNXT1          ;
         STMD R24,=ERRSTP      ;
         TSB  R17
         JNG  NXTBAD
         CMB  R36,=30          ;
         JPS  NXTONE

         LLM  R36              ;
         LDMD R36,X36,JATAB
         JSB  X36,ZRO          ;
         TSB  R17              ;
         JPS  NXTONE
         JMP  NXTBAD

ALFINE   JMP  ALGOOD

SKPNXT
         JSB  =SKIPL           ;
XALL1
         POMD R36,-R6          ;
         JSB  =NXTLIN          ;
         JEN  NXTONE
         LDMD R2,=DFPAR1       ;
         IFNZ
           SBM  R2,=(9D).2
           STMD R2,=PCR          ;
           JSB  =ERROR           ;
           DATA 38D
         ENDIF

NXTBAD
ENDALO
         LDMD R32,=FILEND      ;
         SBM  R32,R30          ;
         JSB  =DELETE          ;
         LDMD R56,=PRFILE      ;
         LDMD R36,=VARPTR      ;
         SBM  R36,=(ECBLEN).2
         STMD R36,X56,P.ELEN
         SBM  R30,R26          ;
         STMD R30,X56,P.PLEN
ALGOOD
         CLE                   ;
         TSB  R17              ;
         IFNG
           LDMD R40,=PRNAME      ;
           JSB  =SETCL#          ;
           JSB  =DALLOC          ;
           JSB  =SETR12
           ICE                   ;
         ENDIF
ALDONE
         CLM  R20
         STMD R20,=ERRSTP
         RTN

         DEF  INIROM
JATAB    DEF  XALL1
         DEF  VALOC
         DEF  BININT
         DEF  SVAL
         DEF  SKPCON
         DEF  SKPCON
         DEF  FUNCAL
         DEF  LINEAL
         DEF  LINEAL
         DEF  RELJMP
         DEF  DEFFN
         DEF  DEFEND
         DEF  EROM
         DEF  OPTION_PAL
         DEF  DEFEND
         DEF  FNASN
         DEF  SKPNXT
         DEF  DIM_PAL
         DEF  SHORT_PAL
         DEF  INT
         DEF  INIROM
         DEF  LINEAL
         DEF  RELJMP
         DEF  LINEAL

INIROM
         JSB  =HANDI0          ;
         VAL V.ALLO
         RTN                   ;
FNASN
         POBD R23,+R24         ;
         ADB  R23,=80H         ;
         LDMD R36,=DFPAR1      ;
         JZR  DFERR
         LDMD R36,R24          ;
         JSB  =FRMNA#          ;

         ARP  !56
         LDMD R56,=PRFILE
         ADMD R56,=CURFUN
         CMMD R36,R56
         JNE  DFERR
FNR3
         LDMD R66,=CURFUN      ;
         PUMD R66,+R24         ;
         RTN                   ;
FRET
RELJMP
         ICM  R24              ;
         ICM  R24              ;
         RTN                   ;
DFERR
         JSBN  =ERROR+          ;
         DATA 39D

DEFEND
         LDMD R66,=DFPAR1      ;
         JZR  DFERR
         DCM  R66              ;
         LDM  R76,R24          ;
         ICM  R76              ;
         ICM  R76              ;
         SBMD R76,=PRFILE      ;
         PUMD R76,-R66         ;
         JSB  =FNR3
         CLM  R#               ;
         STMD R#,=DFPAR1       ;
         RTN                   ;

SVAL     SBB  R23,=VTKDIF      ;

VALOC    PUBD R23,+R6          ;
         CMB  R23,=ATKLIM
         IFCY
           LDB  R23,=SAVTOK      ;
         ENDIF
         JSB  =FRMNAM          ;
         POBD R23,-R6          ;

         LDM  R52,R24          ;
         PUMD R52,+R6          ;

         LDMD R56,=DFPAR1      ;
         IFNZ
           STM  R56,R26          ;
           LDMD R30,=DFPAR2      ;
           JSB  =VSRCH           ;
           JEN  FNDIT2           ;
         ENDIF

         CMB  R16,=CLCSTS
         IFEQ
           LDMD R66,=FWVARS      ;
           LDMD R40,X66,E.MOM
           LDMD R15,X66,E.STAT
           CMM  R15,=RUNSTS
           JNE  TRYPGM            ;
           LDB  R14,=(TYLST?).2
           JSB  =FOPAC?          ;
           IFEQ
             LDMD R56,R66          ;
             JSB  =ROMVPA          ;
             JEZ  TRYPGM
             STM  R32,R34          ;
             JSB  =ENTSIZ          ;
             POMD R30,-R6          ;
             POMD R26,-R6          ;
             LDM  R36,R30          ;
             ADM  R36,R32          ;
             JSB  =TSTEND          ;
             JEN  ERROUT
             JSB  =ROMCPY          ;
             LDM  R32,R30          ;
             STM  R36,R30          ;
             POMD R36,-R30         ;
             SBM  R36,R56          ;
             PUMD R36,+R30         ;
ERROUT       JMP  FOUND
           ENDIF
         ENDIF

TRYPGM   POMD R74,-R6          ;
         PUMD R74,+R6          ;
         STM  R74,R26          ;
         JSB  =VSRCH           ;
         JEZ  NOPE

TSTDUP   TSB  R22              ;
         JNZ  FNDIT

         JSB  =ERROR           ;
         DATA 35D
FNDIT2   JMP  FNDIT

ENTSIZ   LDM  R32,=(6).2
         TSB  R36              ;
         JNG krpal_l1
         LDM  R32,=(4).2
krpal_l1 LDB  R3,R36           ;
         ANM  R3,=1000000B
         RZR
         ADM  R32,=(6).2
         RTN                   ;
NOPE
         JSB  =VSTOR           ;
         POMD R56,-R6          ;
         PUMD R30,+R6          ;
FNDIT
         POMD R30,-R6          ;
         POMD R26,-R6          ;
FOUND
         POMD R34,-R6          ;
         SBMD R32,=PRFILE      ;
         TSB  R17              ;
         IFPS
           PUMD R32,-R34         ;
         ENDIF
         RTN                   ;

ROMCPY
         JSB  =SAVEME          ;
         JSB  =RUNROM          ;
         JSB  =COPY            ;
         RTN                   ;

ROMVPA   JSB  =SAVEME          ;
         JSB  =RUNROM          ;
         LDMD R26,=RNFILE      ;
         LDMD R0,R26           ;
         LDMD R2,X26,P.PLEN
         ADM  R26,R0           ;
         STM  R26,R30          ;
         ADM  R30,R2           ;

VSRCH
         LDM  R32,R26          ;
         ANM  R36,=317,377

VLOOP    CLE                   ;
         CMM  R32,R30          ;
         JCY  VSRTN
         ICE                   ;
         LDMD R66,R32          ;
         ANM  R66,=317,77
         CMM  R66,R36          ;
         JZR  VSRTN
         JSB  =SKPVR           ;
         JMP  VLOOP

VSRTN    ADBD R36,=DIMFLG      ;
         RTN                   ;

SKPVR
         POMD R74,+R32         ;
gap001   NOP
         NOP
         NOP
         DRP  R75
         LLB  R75              ;
         LLB  R75              ;
         TSB  R75              ;
         IFNG
           ICM  R32              ;
           ICM  R32              ;
         ENDIF
         TSB  R74              ;
         JPS  krpal_l2
         ICM  R32              ;
         ICM  R32              ;
krpal_l2 LLB  R74              ;
         TSB  R74              ;
         RPS
         ADM  R32,=(6).2
         RTN                   ;

VSTOR
         LDM  R56,=(8D).2
         LDB  R76,R36          ;
         JNG  STRR

         BCD                   ;
         LRB  R76              ;
         BIN                   ;
         CMB  R76,=4           ;
         JCY  STARR
         TSB  R76              ;
         JZR  ALOSNV           ;
         ICB  R76              ;
         ICB  R76              ;
         STB  R76,R56          ;

ALOWNV
         LDM  R76,R36          ;
         LDB  R0,=76           ;
         LDM  R20,=(2).2
AVCALL   JSB  =ALVENT          ;
         RTN                   ;

STRR
         DRP  !76
         ARP  !36
         LDM  R76,R36
         STM  R76,R74
         LDM  R76,=(STRLEN).2
         LDB  R0,=74
         LDM  R20,=(4d).2
         TSB  R22
         JNZ  krpal_l3
         JSB  =GETINT
krpal_l3 LDM  R56,R76
         ICM  R56
         ICM  R56
         TSM  R56
         JNG  krpal_l4
         JNC  AVCALL
krpal_l4 JMP  ILLDIM

STARR    DRP  !76
         LDMD R76,=OPTBAS      ;
         IFNG
           CLM  R76              ;
           ICM  R76              ;
           STMD R76,=OPTBAS      ;
         ENDIF
         LDB  R0,=70           ;
         STM  R36,R70          ;
         CLM  R72              ;
         STMD R75,=RSTAR       ;
         LDB  R74,=(10D)
         LDM  R20,R56          ;
         TSB  R22              ;
         JNZ  NARDIM
         JSB  =GETINT          ;
         STM  R76,R74          ;
         CLM  R76              ;
         DCM  R76              ;
         JSB  =GETINT          ;
         JMP  STARZE

SAVIT
         LDMD R66,=RSTAR       ;
         DRP  R24              ;
         IFZR
           STMD R24,=RSTAR       ;
         ENDIF
         ICM  R24              ;
         ICM  R24              ;
         CMB  R36,=6           ;
         IFEQ
           CLM  R36              ;
           LDBD R36,R24          ;
           ICM  R36              ;
           ADM R36,R24
           STM R36,R24
         ENDIF

         CMB  R23,=2           ;
         JNZ  NARD1            ;

NARDIM   CMB  R23,=ATKLIM      ;
         JCY  STOR()           ;
         LDBD R23,=CSTAR       ;
         ICB  R23              ;
         STBD R23,=CSTAR       ;

NARD1    JSB  =GETNXT          ;
         TSM  R36              ;
         JZR  ILLDIM           ;
         CMB  R36,=32          ;
         JZR  TSTINX
         CMB  R36,=2           ;
         JNZ  NOTIN
         JSB  =BININT          ;
         JMP  NARD1

NOTIN
         CMB  R#,=6            ;
         JZR  SAVIT            ;
         CMB  R#,=4            ;
         JNG  SAVIT
         JNZ  NARD1            ;
         JSB  =SKPCON          ;
         JMP  NARD1
ILLDIM
         JSBN  =ERROR+          ;
         DATA  36D

TSTINX
         LDBD R67,=CSTAR       ;
         DCB  R67              ;
         STBD R67,=CSTAR       ;
         JNZ  NARD1            ;

STOR()
         LDB  R76,=10D          ;
         TSB  R23              ;
         IFOD
           CLM  R76              ;
           DCM  R76              ;
         ENDIF
         LDMD R66,=RSTAR       ;
         JZR  STARZE
         DCM  R66              ;
         STM  R66,R24          ;

STARZE
         LDMD R66,=OPTBAS      ;
         TCM  R66              ;
         CMM  R66,R74          ;
         JZR  ILLDIM
         TSM  R76              ;
         IFPS
           CMM  R76,R66
           JEQ  ILLDIM
         ENDIF
         JSB  =CALCSZ          ;
         TSM  R56              ;
         IFNG
           JSB  =ERROR           ;
           DATA 27D
         ENDIF
         LDMD R66,=OPTBAS      ;
         DRP  R56              ;
         IFNZ
           ADM  R56,=8000H
         ENDIF
         STM  R56,R72          ;

ALVENT
         JSB  =STOHED
         TSB  R17              ;
         RNG
         LDMD R76,=VARPTR      ;
         STMD R76,R36          ;
         ADM  R76,R56          ;
         STMD R76,=VARPTR      ;
         RTN                   ;

STOHED
         STM  R56,R66          ;
         LDM  R56,=(2).2
         JSB  =TSTRM           ;
         REN
         STMD R*,R30           ;
         LDM  R36,R30          ;
         ADM  R36,R20          ;
         ADM  R20,R56          ;
         ANM  R66,=7FFFH        ;
         STM  R66,R56          ;
         ADM  R30,R20          ;
         RTN                   ;

TSTRM    CLE                   ;
         TSM  R56              ;
         JNG  NOROOM
         LDM  R36,R30          ;
         ADM  R36,R56          ;
         ADM  R36,R20          ;
TSEND
         CLE                   ;
         LDMD R2,=FILEND       ;
         DCM  R2               ;
         CMM  R2,R36           ;
         JNC  NOROOM           ;
         RTN                   ;
NOROOM
         JSB  =ERR1+           ;
         DATA 16D
LINEAL
         LDMD R76,R24          ;
         JSB  =FNDLPR          ;
         JEZ  FNDLN
         JSBN  =ERROR+          ;
         DATA 32D

FNDLN
         SBMD R36,=PRFILE      ;
         PUMD R36,+R24         ;
         RTN                   ;
DEFFN
         LDMD R34,=DFPAR1      ;
         JNZ  DEFDEF
         LDM  R34,R24          ;
         LDMD R73,R24          ;
         LDB  R23,R77          ;
         ANM  R23,=1H           ;
         LLB  R23              ;
         ADB  R23,=81H        ;
         JSB  =CRDF?
         TSB  R17              ;
         RNG
         IFEN
           LDB  R0,=72           ;
           CMB  R23,=81H
           IFNE
             LDB  R0,=70           ;
           ENDIF
           LDMD R*,R32           ;
           TSM  R76              ;
           JNZ  DUPDEF
           JSB  =GTADR           ;
           STMD R*,R32           ;
         ENDIF
         STM  R24,R34          ;
         SBMD R32,=PRFILE      ;
         PUMD R32,-R34         ;
         STMD R32,=CURFUN      ;
         POMD R75,+R24         ;
         STMD R24,=DFPAR1      ;
         LRB  R77              ;
         IFNZ
           LDMD R36,=VARPTR      ;
           LOOP
             LDM  R56,=(8H).2
             POMD R66,+R24         ;
             TSB  R66              ;
             IFNG
               POMD R56,+R24         ;
               ADM  R56,=MELROM      ;
             ENDIF
             PUMD R36,+R24         ;
             ADM  R36,R56          ;
             DCB  R77              ;
           WHNZ
           STMD R36,=VARPTR      ;
         ENDIF
         STMD R24,=DFPAR2      ;
         LDMD R34,=PCR         ;
         SBMD R34,=PRFILE      ;
         PUMD R34,+R24         ;
         RTN                   ;
DUPDEF
         JSBN  =ERROR+          ;
         DATA 37D

DEFDEF  
         JSBN  =ERROR+          ;
         DATA 38D
GTADR
         LDM  R76,R34          ;
         RZR
         SBMD R76,=PRFILE      ;
         ADM  R76,=(4).2
         RTN                   ;
CRDF?
         JSB  =FRMNAM          ;
         JSB  =VSRCH           ;
         REN
         STM  R36,R74          ;
         JSB  =GTADR
         LDM  R56,=(8D+9D).2
         LDM  R20,=(4D).2
         LDB  R0,=74           ;
         CMB  R23,=81H
         IFEQ
           JSB  =ALVENT          ;
           TSB  R17              ;
           RNG
         ELSE
           STM  R36,R72          ;
           LDB  R74,=32D
           CLB  R75              ;
           LDM  R56,=(34D+9D).2
           LDM  R20,=(6D).2
           LDB  R0,=72           ;
           JSB  =ALVENT          ;
           TSB  R17              ;
           RNG
         ENDIF
         LDMD R76,R36          ;
         ADM  R76,=(9D).2
         STM  R76,R74          ;
         POMD R76,-R36         ;
         PUMD R74,+R36         ;
         CLE                   ;
         RTN                   ;
FUNCAL
         SBB  R23,=FTKDIF
         IFEV
           ICB  R23              ;
         ENDIF
         ADB  R23,=80H
         CLM  R34              ;
         JSB  =CRDF?           ;
         TSB  R17              ;
         RNG
         LDM  R34,R24          ;
         CLM  R66              ;
         POBD R66,+R24         ;
         SBMD R32,=PRFILE      ;
         PUMD R32,-R34         ;
         ADM  R24,R66          ;
         RTN                   ;
DIM_PAL
         CLB  R76              ;
         JMP  DIMCOM
INT
         LDB  R76,=20          ;
         JMP  DIMCOM
SHORT_PAL
         LDB  R76,=40          ;
DIMCOM
         STBD R#,=DIMFLG      ;
         CLB  R22              ;
         RTN                   ;
OPTION_PAL
         LDMD R76,=OPTBAS      ;
         JPS OPTERR
         LDMD R75,R24          ;
         DCM  R76              ;
         TCM  R76              ;
         STMD R76,=OPTBAS      ;
         RTN                   ;
OPTERR
         JSBN  =ERROR+          ;
         DATA 30D              ;
       TITLE 'kreal'
*ALLOC  ADDR 1F9FH
*
*  __________________________________________________________________
* |KXEAL 139 09/27/82 - 9/30/1982 3:23PM                             |
* |==================================================================|
* ||                                                                ||
* ||   @@     @@@  @@      @@  @@@@@@@@@@    @@@@@@    @@           ||
* ||   @@    @@@   @@      @@  @@@@@@@@@@   @@@@@@@@   @@           ||
* ||   @@   @@@    @@@    @@@  @@          @@@    @@@  @@           ||
* ||   @@  @@@      @@@  @@@   @@          @@      @@  @@           ||
* ||   @@ @@@         @@@@     @@          @@      @@  @@           ||
* ||   @@@@@           @@      @@@@@@@@@   @@@@@@@@@@  @@           ||
* ||   @@@@@           @@      @@@@@@@@@   @@@@@@@@@@  @@           ||
* ||   @@ @@@         @@@@     @@          @@      @@  @@           ||
* ||   @@  @@@      @@@  @@@   @@          @@      @@  @@           ||
* ||   @@   @@@    @@@    @@@  @@          @@      @@  @@           ||
* ||   @@    @@@   @@      @@  @@@@@@@@@@  @@      @@  @@@@@@@@@@   ||
* ||   @@     @@@  @@      @@  @@@@@@@@@@  @@      @@  @@@@@@@@@@   ||
* ||                                                                ||
* ||                    Last edited: 820930.1521                    ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
Z36.56   SBM  R56,R36          ;
         CLB  R23              ;

ZROMEM   LDB  R60,=BLANK       ;
         LDM  R61,R60          ;
         CMB  R23,=3           ;
         JZR  ZROM1-           ;
         CLM  R60              ;

ZROM1-   JSB  =ZERO11          ;
         ADM  R56,=8D,0
         TSM  R56              ;
         RZR

kreal_l1 PUBD R60,+R36         ; 1H
         DCM  R56              ;
         JNZ  kreal_l1         ; 1B
         RTN                   ;

ZERO11   LDB  R0,=60           ;
         LDM  R76,=(8D).2

ZERO1-   SBM  R56,R76          ;
         RNC
         PUMD R*,+R36          ;
         JMP  ZERO1-

FNDVPA
         LDMD R36,=PRFILE      ;
         LDMD R34,R36          ;
         ADM  R34,R36          ;
         LDMD R32,X36,P.PLEN
         ADM  R32,R34          ;
         RTN                   ;
ENVALO
         BIN                   ;
         JSB  =PUSHEN
         REN
         STM  R2,R20           ;
         JSB  =FNDVPA          ;
         ADMD R34,=LSTPLN      ;
         CMM  R34,R32          ;
         REQ
INIVLP
         POMD R54,+R34         ;
         LDB  R3,R55           ;
         ANM  R3,=11000000B
         JNZ  INVRMT
         STB  R54,R23          ;
         ANM  R23,=11110000B
         LLB  R55              ;
         LLB  R55              ;
         TSB  R54              ;
         JPS  INVNUM
         LLB  R54              ;
         TSB  R54              ;
         JNG  INVRMT

INVSTR
         POMD R36,+R34         ;
         JNG  INVRTN
         ADM  R36,R20          ;
         TSB  R55              ;
         IFNG
           JSB  =INVFN
         ENDIF
         CLM  R66              ;
         DCM  R66              ;
         PUMD R66,+R36         ;
         LDB  R23,=3           ;
         JSB  =ZROMEM          ;

INVRTN   CMM  R34,R32          ;
         JNZ  INIVLP
         CLE                   ;
         RTN                   ;

INVRMT
         JSB  =HANDI0          ;
         DATA V.EALO
         JMP  INVRTN

INVNUM
         STM  R56,R36          ;
         LDM  R56,=(8D).2
         CLM  R60              ;
         LDB  R67,=377         ;
         LDB  R0,=60           ;
         STB  R54,R77          ;
         LLB  R54              ;
         BCD                   ;
         LRB  R77              ;
         BIN                   ;
         ANM  R77,=3           ;
         JZR  ARRAY?
         LDB  R0,=65           ;
         LDB  R56,=3           ;
         DCB  R77              ;
         JZR  ARRAY?
         DCB  R0               ;
         ICB  R56              ;

ARRAY?
         STM  R56,R76          ;
         TSB  R54              ;
         JPS  INSNV
         LDM  R56,R36          ;
         ANM  R56,=7FFFH        ;
         POMD R36,+R34         ;
         POMD R36,+R34         ;
         POMD R36,+R34         ;
INSNV
         TSM  R36              ;
         JNG  INVRTN
         ADM  R36,R20          ;
         TSB  R55              ;
         IFNG
           JSB  =INVFN
         ENDIF
         JSB  =ZERO1-
         JMP  INVRTN
INVFN
         PUMD R76,+R6          ;
         CLM  R70              ;
         PUMD R70,-R36         ;
         PUBD R77,-R36         ;
         ADM  R36,=(9D).2
         ICM  R34              ;
         ICM  R34              ;
         POMD R76,-R6          ;
         RTN                   ;
PUSHEN
         LDMD R30,=PRFILE      ;
         LDMD R56,X30,P.ELEN
         SBMD R56,=LSTELN      ;
         LDM  R32,R56          ;
         ADM  R32,=((ECBLEN)+1).2
         JSB  =UROOM!          ;
         IFEN
           CMB  R16,=CLCSTS          ;
           IFEQ
             JSB  =CLRERR          ;
             LDMD R0,=LEEWAY       ;
             SBM  R0,=((ECBLEN)+1).2
             STMD R0,=LEEWAY       ;
             CLB  R0               ;
             ICB  R0               ;
             STBD R0,=XTNDLW       ;
             JSB  =UROOM!          ;
           ENDIF
           JEN  ENVERR           ;
         ENDIF
         LDMD R30,=NXTMEM      ;
         LDM  R32,=((ECBLEN)+1).2
         STM  R32,R26          ;
         JSB  =ALLOC           ;
         JSB  =CALNM?
         IFEQ
           TSB  R16              ;
           IFNZ
             PUMD R66,+R6          ;
             JSB  =GETCAL
             POMD R66,-R6          ;
           ENDIF
         ENDIF    
         LDM  R32,R56          ;
         ADM  R30,R26          ;
         JSB  =ALLOC           ;
         SBM  R30,R26          ;
         ADM  R56,R26          ;
         PUMD R56,+R30         ;
         LDMI R2,=FWVARS       ;
         PUMD R2,+R30          ;
         CLM  R40              ;
         PUMD R40,+R30         ;
         LDMI R46,=ROMPTR      ;
         PUMD R46,+R30         ;
         PUMD R60,+R30         ;
         CLM  R43              ;
         PUMD R43,+R30         ;
         LDMD R2,=NXTMEM       ;
         SBM  R2,R56           ;
         STMD R2,=FWVARS       ;
         JMP  PUSHEX
CALNM?
         LDMD R60,=PRNAME      ;
         CMMD R60,=CALNAM      ;
         RTN                   ;
ENVERR
         JSB  =CALNM?
         IFEQ
           LDMD R60,R30          ;
           LDM  R76,R30          ;
           ADMD R30,R30          ;
           ADMD R30,=LSTPLN      ;
           LDM  R32,R62          ;
           SBMD R32,=LSTPLN      ;
           JSB  =DELETE          ;
           LDMD R62,=LSTPLN      ;
           LDMD R66,=LSTELN      ;
           STMD R60,R76          ;
           ICE                   ;
         ENDIF
PUSHEX
         RTN                   ;
GETCAL
GAP04
         LDMD R40,=CALNAM      ;
         JSB  =INENV?          ;
         DRP  R34
PUTCAL
         LDM  R#,R66          ;
MOVENV
         LDM  R36,=(ECBLEN).2
         LDMD R32,R34          ;
         SBM  R32,=((ECBLEN)+1).2
         IFNZ
           ADM  R34,R36          ;
           ADM  R30,R36          ;
           JSB  =INSRTM          ;
           SBM  R30,R36          ;
           SBM  R34,R36          ;
           ICM  R36              ;
           STMD R36,R34          ;
           LDM  R26,R34          ;
           JSB  =ADJENV
           ADM  R32,R36          ;
           STMD R32,R30          ;
           LDM  R26,R30          ;
           JSB  =ADJENV
           STM  R32,R26          ;
         ENDIF
         RTN                   ;
ADJENV
         LDMD R0,R26           ;
         ADM  R26,R0           ;
         CMMD R26,=NXTMEM      ;
         REQ
         STMD R0,X26,E.PREV
         RTN                   ;
CLNCAL
         LDMD R40,=CALNAM      ;
         JSB  =SETPR           ;
         JSB  =FNDVPA          ;
         LDM  R30,R34          ;
         STM  R32,R34          ;
         LOOP
           CMM  R34,R30          ;
           REQ
           LDMD R36,R30          ;
           JSB  =ENTSIZ          ;
           LDM  R56,R30          ;
           ADM  R56,R32          ;
           POMD R56,-R56         ;
           IFNG
             JSB  =DELETE          ;
             SBM  R34,R32          ;
             LDMD R0,=PRFILE       ;
             LDMD R36,X0,MELROM    ;
             SBM  R36,R32          ;
             STMD R36,R2           ;
           ELSE
             ADM  R30,R32          ;
           ENDIF
         WHMP
       TITLE 'krdal'
*
*  __________________________________________________________________
* |RHDAL 107 04/02/82 - 4/20/1982 8:03PM                             |
* |==================================================================|
* ||                                                                ||
* ||   @@@@@@@@    @@      @@  @@@@@@        @@@@@@    @@           ||
* ||   @@@@@@@@@   @@      @@  @@@@@@@@     @@@@@@@@   @@           ||
* ||   @@     @@@  @@      @@  @@    @@@   @@@    @@@  @@           ||
* ||   @@      @@  @@      @@  @@      @@  @@      @@  @@           ||
* ||   @@     @@   @@      @@  @@      @@  @@      @@  @@           ||
* ||   @@@@@@@     @@@@@@@@@@  @@      @@  @@@@@@@@@@  @@           ||
* ||   @@@@@@@     @@@@@@@@@@  @@      @@  @@@@@@@@@@  @@           ||
* ||   @@    @@@   @@      @@  @@      @@  @@      @@  @@           ||
* ||   @@     @@@  @@      @@  @@      @@  @@      @@  @@           ||
* ||   @@      @@  @@      @@  @@    @@@   @@      @@  @@           ||
* ||   @@      @@  @@      @@  @@@@@@@@    @@      @@  @@@@@@@@@@   ||
* ||   @@      @@  @@      @@  @@@@@@      @@      @@  @@@@@@@@@@   ||
* ||                                                                ||
* ||                    Last edited: 820908.1331                    ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
DALLAL   BIN                   ;
         JSB  =EVIL            ;
         DEF  S17-77
         LDMD R41,=ERLIN#       ;
         STMD R41,=ERRTMP       ;
         LDMD R40,=PRNAME      ;
         PUMD R40,+R6          ;
         LDM  R76,=DIRECT
         LOOP
           LDMD R40,X76,DR.NAM
           LDBD R0,X76,DR.TNM    ;
           CMMD R40,=CALNAM      ;
           IFNE
             JSB  =DALLOC          ;
             CLB  R17              ;
           ENDIF
           ADM  R76,=(DRENSZ).2
           LDMD R2,R76           ;
         WHNZ
         JSB  =TMRKIL          ;
         JSB  =CLRENV          ;
         POMD R40,-R6          ;
         JSB  =SETPR           ;
         LDMD R41,=ERRTMP      ;
         STMD R41,=ERLIN#      ;
         CLE                   ;
         RTN                   ;
DALLOC
         JSB  =EVIL            ;
         DEF  S20-77
         BIN
         JSB  =SETPR
         LDB  R14,=(TYRAM?)|(TYRUN?)|(TYLIN?)
         JSB  =TYPOK?          ;
         RNE
         JSB  =PTALO?          ;
         REZ
         JSB  =ALINI           ;
         JSB  =SAVEME          ;
         JSB  =ROMRTN          ;
         PUBD R17,+R6          ;
         CLB  R17              ;
NEXT_DAL JSB  =GTNXT1          ;
         CMMD R24,=ERRSTP
         JEQ  XDALL2
         TSB  R17
         JNG  krdal_l1
         CMB  R36,=30          ;
         JPS  NEXT_DAL
         LLM  R36              ;
         LDMD R36,X36,JDTAB
         JSB  X36,ZRO          ;
         TSB  R17              ;
         JPS  NEXT_DAL
krdal_l1 LDMD R26,=ERRSTP      ;
         JNZ  NEXT_DAL
         JSB  =CLRERR          ;
         LDMD R20,=PCR         ;
         LDB  R24,=MISTOK
         STBD R24,X20,THREE
         LDM  R24,R20          ;
         JSB  =SKPLN#          ;
         DCM  R#               ;
         JMP  NEXT_DAL

SKPNX1   JSB  =SKIPL           ;
XDALL1   POMD R36,-R6          ;
         JSB  =NXTLIN          ;
         JEN  NEXT_DAL
XDALL2
         LDMD R40,=PRNAME      ;
         JSB  =FOPEN           ;
         LDMD R32,X30,DR.SIZ
         LDMD R30,R30          ;
         LDM  R20,R30          ;
         ADM  R20,=(PCBLEN).2
         LDMD R0,R30           ;
         CMMD R40,=CALNAM      ;
         IFEQ
           JSB  =ENVERR          ;
         ELSE
           CLM  R50              ;
           STMD R50,R30          ;
           SBM  R32,R0           ;
           ADM  R30,R0           ;
           JSB  =DELETE          ;
           DRP  !30
           LDM  R30,R20

NXLINE     POMD R32,+R30         ;
           CMM  R32,=ENDLIN      ;
           JZR  DALLEX
           LDMD R32,R30          ;
           CMB  R33,=MISTOK
           IFNE
             CLB  R33              ;
             ADM  R30,R32          ;
NXLN-
             DRP  !30
             ICM  R30              ;
             JMP  NXLINE
           ELSE
             DRP  !33
             ARP  !30
             LDB  R33,=TWO          ;
             PUBD R33,+R30         ;
             CLB  R33              ;
             DCM  R32              ;
             DCM  R32              ;
             IFNZ
               JSB  =ERROR           ;
               DATA 18D
             ENDIF   
             ICM  R30              ;
             JSB  =DELETE          ;
             JMP  NXLN-
           ENDIF
         ENDIF
DALLEX
         POBD R17,-R6          ;
         RTN                   ;
*
* DEALLOC JUMP Table
         DEF  INIROM_DAL
JDTAB    DEF  XDALL1
         DEF  VDALOC
         DEF  BININT
         DEF  SVALD
         DEF  SKPCON
         DEF  SKPCON
         DEF  DALFNC
         DEF  LINEDA
         DEF  LINEDA
         DEF  RELJMP
         DEF  DALFN
         DEF  FRET

         DEF  ROMCLA
         DEF  FRRET
         DEF  FRET
         DEF  FRRET
         DEF  SKPNX1
         DEF  DIMD
         DEF  SHORTD
         DEF  INTD
         DEF  COMMD
         DEF  LINEDA
         DEF  RELJMP
         DEF  LINEDA


INIROM_DAL
         JSB  =HANDI0          ;
         VAL  V.DALO
         RTN                   ;

SKIPL    CLM  R24              ;
         LDB  R24,R47          ;
         ADMD R24,=PCR         ;
         ADM  R24,=(3).2
         RTN                   ;

LINEDA   LDMD R36,R24          ;
         ADMD R36,=PRFILE      ;
         POMD R34,+R36         ;
         PUMD R34,+R24         ;
FRRET
DIMD
COMMD
INTD
SHORTD
         RTN                   ;

DALFN    JSB  =VDALOC          ;
         POMD R75,+R24         ;
         LRB  R77              ;
         TSB  R77              ;
         IFNZ
           LOOP
             POMD R66,+R24         ;
             TSB  R66              ;
             IFNG
               POMD R66,+R24         ;
             ENDIF
             POMD R66,+R24         ;
             DCB  R77              ;
           WHNZ
         ENDIF
         POMD R66,+R24         ;
         RTN                   ;

DALFNC   JSB  =VDALOC          ;
         STM  R24,R36          ;
         CLM  R24              ;
         POBD R24,+R36         ;
         ADM  R24,R36          ;
         RTN                   ;

SVALD    SBB  R23,=VTKDIF
VDALOC   CMB  R23,=ATKLIM
         JNC  VDALO1
         LDB  R23,=2           ;
VDALO1   JSB  =ASCNAM          ;
         PUMD R36,+R24         ;
         RTN                   ;

ASCNAM   LDMD R34,R24          ;
         ADMD R34,=PRFILE      ;
         LDMD R36,R34          ;
ASCNM1   ANM  R36,=17,37
         CMB  R36,=10D         ; IF B36=10D
         IFZR
           LDB  R36,=360         ;
         ENDIF
         ADB  R36,='0'
         ADB  R37,='A'-1
         RTN                   ;

ALINI    LDM  R24,R26          ;
         ADM  R24,=(PCBLEN).2
         LDMD R0,X26,P.ELEN
         LDM  R22,=(ECBLEN).2
         ADM  R22,R0           ;
         STMD R22,=VARPTR      ;
         LDMD R22,X26,P.PLEN
         LDMD R0,R26           ;
         ADM  R26,R0           ;
         STM  R26,R30          ;
         ADM  R30,R22          ;
         CLM  R70              ;
         STMD R70,=DFPAR1      ;
         STBD R70,=DIMFLG      ;
         LDM  R56,=1,80H
         STMD R56,=OPTBAS      ;
         CLM  R45              ;
         JSB  =NXTLIN          ;
         RTN                   ;

GETINT   LDBD R64,R24          ;
         CMB  R64,=INTTK
         JNZ  GETIR
         POMD R64,+R24         ;
BCDINT   PUMD R75,+R6          ;
         JSB  =INTORL          ;
         POMD R75,-R6          ;
         BIN                   ;
         JSB  =CONINT          ;
GETIR    RTN                   ;

GETNXT   CLM  R56              ;
         POBD R56,+R24         ;
GETATR   STB  R56,R23          ;
         LDMD R36,=ROMPTR      ;
         LDMD R36,X36,RM.RUN
         ADMD R36,=ROMOFF      ;
         LLM  R56              ;
         ADM  R56,R36          ;
         LDMD R56,R56          ;
         ADMD R56,=ROMOFF      ;
         POBD R36,-R56         ;
         ANM  R36,=77,0
         RTN                   ;

GTNXT1   JSB  =GETNXT          ;
         DRP  !36
         CMB  R36,=14           ;
         JNE  krdal_l2
         JSB  =ROMCLA          ;
krdal_l2 TSB  R17              ;
         RTN                   ;

NXTLIN   CLE                   ;
         BIN                   ;
         LDM  R22,R45          ;
         CMM  R22,=ENDLIN      ;
         REQ
         ICE                   ;
         CLB  R22              ;
         STBD R22,=DIMFLG      ;
         ICB  R22              ;
         STMD R24,=PCR         ;
         POMD R45,+R24         ;
         RTN                   ;

SKPCON   LDM  R56,=(EIGHT).2
         CMB  R23,=4           ; IF B23#4
         IFNZ
           POBD R56,+R24         ;
         ENDIF
SKPC1    ADM  R24,R56          ;
         RTN                   ;

BININT   LDM  R56,=3,0
         JMP  SKPC1


FRMNAM   POMD R36,+R24         ;
FRMKA#   CLM  R56              ;
         LDB  R56,R23          ;
         DCB  R56              ;
         BCD                   ;
         LLM  R56              ;
         BIN                   ;
         LLM  R56              ;
         LLM  R56              ;
         ADBD R56,=DIMFLG      ;
         SBB  R37,='A'-1
         CMB  R36,=' '         ; IF B36=' '
         IFEQ
           LDB  R36,=72          ;
         ENDIF
         SBB  R36,='0'
         ORM  R36,R56          ;
         RTN                   ;

CALCSZ   LDBD R2,=DIMFLG       ;
         BCD                   ;
         LRB  R2               ;
         BIN                   ;
         STM  R74,R60          ;
         LDM  R54,R60          ;
         ADMD R54,=OPTBAS      ;
         CLM  R56              ;
         STM  R54,R64          ;
         LLM  R54              ;
         DCB  R2               ;
         JNZ  CALSZ1
         ADM  R54,R64          ;
         JMP  CALSZ2

CALSZ1   LLM  R54              ;
         DCB  R2               ;
         JZR  CALSZ2
         LLM  R54              ;
CALSZ2   TSB  R63              ;
         JNG  VECTOR
         LDM  R66,R62          ;
         ADMD R66,=OPTBAS      ;
         TSM  R56              ;
         JNZ  VECTR1
         LDM  R76,R54          ;
         JSB  =INTMUL          ;
VECTOR   TSM  R56              ;
         JZR  VECTR2
VECTR1   LDB  R55,=377         ;
VECTR2   LDM  R56,R54          ;
         LDM  R74,R60          ;
         RTN                   ;
       TITLE 'krdec'
*
*  __________________________________________________________________
* |KRDEC 116 04/30/82 - 5/ 4/1982 1:59PM                             |
* |==================================================================|
* ||                                                                ||
* ||   @@     @@@  @@@@@@@@    @@@@@@      @@@@@@@@@@     @@@@      ||
* ||   @@    @@@   @@@@@@@@@   @@@@@@@@    @@@@@@@@@@   @@@@@@@@    ||
* ||   @@   @@@    @@     @@@  @@    @@@   @@          @@@    @@@   ||
* ||   @@  @@@     @@      @@  @@      @@  @@          @@      @@   ||
* ||   @@ @@@      @@     @@   @@      @@  @@          @@           ||
* ||   @@@@@       @@@@@@@     @@      @@  @@@@@@@@@   @@           ||
* ||   @@@@@       @@@@@@@     @@      @@  @@@@@@@@@   @@           ||
* ||   @@ @@@      @@    @@@   @@      @@  @@          @@           ||
* ||   @@  @@@     @@     @@@  @@      @@  @@          @@      @@   ||
* ||   @@   @@@    @@      @@  @@    @@@   @@          @@@    @@@   ||
* ||   @@    @@@   @@      @@  @@@@@@@@    @@@@@@@@@@   @@@@@@@@    ||
* ||   @@     @@@  @@      @@  @@@@@@      @@@@@@@@@@     @@@@      ||
* ||                                                                ||
* ||                    Last edited: 820908.1335                    ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
DECOPR   LDMD R0,=EDFILE       ;
         STMD R0,=PRFILE       ;
DECOM    SAD                   ;
         JSB  =UGLY
         PAD                   ;
         TSB  R17              ;
         RTN                   ;

UGLY     JSB  =SAVEME          ;
         JSB  =ROMRTN          ;
         PUMD R64,+R6          ;
         LDM  R2,R30           ;
         ADM  R2,=(94D).2
         STMD R2,=DCMLEN       ;
         CLB  R36              ;
         STBD R36,=DCOVFL      ;
         STBD R36,=PRECNT      ;
         STBD R36,=ONFLG       ;
         LDM  R36,R45          ;
         JSB  =DCLIN#          ;
         LDB  R3,R67           ;
         ANM  R3,=TYRUN?
         JNZ  BASCLN

         DCM  R30              ;
krdec_l1 DCB  R47              ;
         JNC  DECRTN           ;
         POBD R36,+R24         ;
         PUBD R36,+R30         ;
         JSB  =DCOVF?
         JMP  krdec_l1

EOL_DEC 
         JSB  =UNSTAK          ;
         LDMD R12,=TOS         ;
         POMD R74,-R6          ;
         POBD R74,-R30         ;
         CMB  R74,=BLANK
         IFNE
           PUBD R74,+R30         ;
         ENDIF
         JMP  DECRTN

BASCLN   STMD R12,=TOS         ;
krdec_l2 JSB  =DECTOK
         TSB  R17              ;
         JZR  krdec_l2

DECRTN   JSB  =DCOVF?
         LDBD R2,=DCOVFL       ;
         IFNZ
           JSB  =WARN            ;
           DATA 67D
         ENDIF
         POMD R64,-R6          ;
         RTN                   ;

DECTOK   BIN                   ;
         JSB  =GETNXT          ;
         JSB  =ROMCL-          ;
         LLM  R36              ;
         LDMD R36,X36,DCTAB
         JSB  X36,ZRO          ;

DCOVF?   BIN                   ;
         LDMD R2,=DCMLEN       ;
         CMM  R2,R30           ;
         RCY
         STM  R2,R30           ;
         STBD R3,=DCOVFL       ;
         RTN                   ;
*
*  decompile table
*
         DEF  INIROM_DEC
DCTAB    DEF  EOL_DEC
         DEF  FETVAR
         DEF  BINCON
         DEF  STOVAR
         DEF  CONST
         DEF  SCNST
         DEF  UFNCAL
         DEF  JMPL#
         DEF  GOLINE
         DEF  JMPREL
         DEF  UFNDEF
         DEF  FNEND_DEC
         DEF  EXTROM
         DEF  RESWD
         DEF  FNRTN
         DEF  FNASGN
         DEF  RESWD
         DEF  RESWD+
         DEF  RESWD+
         DEF  RESWD+
         DEF  INIROM_DEC
         DEF  EJMP#
         DEF  EJMPR
         DEF  ULIN#
         DEF  ON_DEC
         DEF  PU=
         DEF  SUBSCR
         DEF  DEFKY
         DEF  DIMSUB
         DEF  PRNEOP
         DEF  PRINTS
         DEF  INPUT_DEC
         DEF  RETURN
         DEF  RESWD
         DEF  MISC
         DEF  MSTOR
         DEF  RETURN
         DEF  PRTFUN
         DEF  SYSFUN
         DEF  SYSFUN
         DEF  UNOP
         DEF  BINOP
         DEF  UNOP$
         DEF  BINOP$
         DEF  RETURN
         DEF  SYSFUN
         DEF  SYSFN$

INIROM_DEC
         JSB  =HANDI0          ;
         DATA V.DEC
         RTN                   ;

CONST    POMD R60,+R24         ;
CONST1   LDB  R0,=60           ;
CONST-   LDB  R22,=16          ;
         PUMD R22,+R12         ;
         PUMD R*,+R12          ;
         RTN                   ;

SCNST    LDM  R34,R24          ;
         CMB  R34,=16          ;
         JEQ  FSADR
         CMB  R34,=17          ;
         JNE  SCNST1
FSADR    TCM  R#
SCNST1   JSB  =SKPCON          ;
         LDB  R0,=34           ;
         JMP  CONST-

BINCON   POMD R65,+R24         ;
         JSB  =INTORL          ;
         LDB  R23,=4           ;
         JMP  CONST1           ;

STOVAR   SBB  R23,=VTKDIF
FETVAR   JSB  =GETNM           ;
         LDB  R22,=16          ;
         PUMD R22,+R12         ;
         PUMD R36,+R12         ;
         CMB  R23,=ATKLIM
         RNC
         LDB  R36,='('
         PUBD R36,+R12         ;
         LDM  R36,=',)'
         TSB  R23              ;
         IFEV
           DRP  R36              ;
         ELSE
           DRP  R37
         ENDIF
         PUMD R#,+R12         ;
         RTN                   ;

FNASGN   JSB  =MVWRD           ;
         POBD R23,+R24         ;
         JMP  FETVAR

FNEND_DEC
         JSB  =MVWRD           ;
FNRTN    POMD R34,+R24         ;
         RTN                   ;

MVWRD    CLM  R36              ;
         LDB  R36,R23          ;
         DCB  R36              ;
         LDMD R26,=ROMPTR      ;
         LDMD R26,X26,RM.ASC   ;
         ADMD R26,=ROMOFF      ;
         JSB  =GETRID          ;
         IFZR
           LDB  R37,=44          ;
         ENDIF
         LDB  R2,=1            ;
         JSB  =BATS            ;
         RTN                   ;

RESWD+
RESWD    CMB  R23,=BANGTK
         IFEQ
           JSB  =UNSTAK          ;
           JSB  =ASUREB
           LDB  R23,=BANGTK
         ENDIF
         JSB  =MVWRD           ;
         JSB  =TRAILB

FIXON    CLB  R36              ;
RWRTN    STBD R#,=ONFLG       ;
         JSB  =UNSTAK          ;
         RTN                   ;

ON_DEC   JSB  =MVWRD           ;
         JSB  =TRAILB
         LDB  R36,R23          ;
         JMP  RWRTN
MISC     CMB  R23,='@'
         IFEQ
           JSB  =ASUREB
           JSB  =UNSTAK          ;
           LDB  R23,='@'
           JMP  RESWD
         ENDIF
         PUBD R23,+R30         ;
         RTN                   ;

GOLINE   LDBD R37,=ONFLG       ;
         JZR  GOL1
         JNG  DOCOMA
         TCB  R37              ;
         STBD R37,=ONFLG       ;
GOL1     JSB  =MVWRD           ;
         JSB  =TRAILB
         JMP  DOLINE

DOCOMA   POBD R37,-R30         ;
         LDB  R37,=COMMA
         PUBD R37,+R30         ;
DOLINE   JSB  =GET2
         JSB  =DCLIN#          ;
         LDBD R36,R24          ;
         CMB  R36,=16          ;
         RNE
         DCM  R30              ;
         RTN                   ;

GET2     POMD R36,+R24         ;
         JSB  =TSTALO
         REZ
         ADMD R36,=PRFILE      ;
         LDMD R36,R36          ;
         RTN                   ;

GETNM    JSB  =GET2
         REZ
         JSB  =ASCNM1          ;
         RTN                   ;

JMPREL   LDM  R75,='IF '
         PUMD R75,+R30         ;
         JSB  =UNSTAK          ;
         LDM  R73,='THEN '
         PUMD R73,+R30         ;
JMPEXX   JSB  =GET2
         RTN                   ;

JMPL#    JSB  =JMPREL
JMPEX    JSB  =DCLIN#          ;
         RTN                   ;

EJMPR    LDMD R75,R24          ;
         CMB  R77,=37          ;
         JEQ  JMPEXX

         JSB  =FIXON
         LDM  R73,='ELSE '
         PUMD R73,+R30         ;
         JMP  JMPEXX

EJMP#    JSB  =EJMPR           ;
         JMP  JMPEX            ;
ULIN#    CMB  R23,=RSTL#
         JZR  ULIN#-
         LDB  R23,=USTOK
         JSB  =RESWD           ;
ULIN#-   JSB  =GET2            ;
         JMP  JMPEX
UNOP$
UNOP
         POBD R55,-R56         ;
         STB  R55,R54          ;
         JSB  =STAKB+
         JSB  =PRETS1
         JMP  PRETS3
BINOP$
BINOP    POBD R55,-R56         ;
         STB  R55,R54          ;
         JSB  =STAKB
         JSB  =PRETS1     ;
         JMP  PRETS2
PRETS1   ICB  R54              ;
         LDBD R75,=PRECNT      ;
         LDMD R76,=LAVAIL      ;
         STM  R36,R56          ;
         LDM  R34,R12          ;
         DCM  R36              ;
         JSB  =OPTST
         RTN                   ;
PRETS2   CMB  R55,=6           ;
         JZR  PRTS2-
         DCB  R54              ;
PRTS2-   LDM  R34,R2           ;
         JSB  =POSIT
         JSB  =OPTST
PRETS3   ICB  R#               ;
         STBD R#,=PRECNT       ;
         PUMD R55,-R76         ;
         STMD R76,=LAVAIL      ;
         RTN                   ;

OPTST    PUMD R75,+R6          ;
OPTLOP   TSB  R75              ;
         JZR  OPTRTN
         DCB  R75              ;
         POMD R65,+R76         ;
         CMB  R23,=NOTTOK
         DRP  R66              ;
         DRP  !66
         IFCY
           CMM  R66,R2           ;
           JCY  NOTFIX
         ENDIF
         CMM  R66,R36          ;
         JNC  OPTLOP

NOTFIX   DRP  !66
         CMM  R66,R34
         JCY  OPTLOP
         CMB  R65,R54          ;
         JCY  OPTLOP
         JSB  =EXPER
         JSB  =CLEAN
OPTRTN   POMD R75,-R6          ;
         RTN                   ;

EXPER    LDB  R70,='('
         JSB  =PUTIN
         DRP  !70
         ICB  R70             ;
         PUMD R36,+R6          ;
         LDM  R36,R34          ;
         JSB  =PUTIN
         POMD R36,-R6          ;
         RTN                   ;

PUTIN    CLM  R32              ;
         ICM  R32              ;
         JSB  =EXPAND_DEC
         ICM  R36              ;
         PUBD R70,+R36         ;
         RTN                   ;

CLEAN    LDMD R76,=LAVAIL      ;
         LDBD R75,=PRECNT      ;
         RZR
         LOOP
           LDMD R65,R76          ;
           CMM  R66,R36          ;
           JNC  CLNEX
           CMM  R66,R34          ;
           JCY  CLNEX
           LDB  R65,=100         ;
 CLNEX     PUMD R65,+R76         ;
           DCB  R75              ;
         WHNZ
         RTN                   ;

STAKB+   JSB  =POSIT
         CLM  R32              ;
         ICM  R32              ;
         JSB  =EXPAND_DEC
         ICM  R36              ;
         JMP  STAKB1

STAKB    JSB  =POSIT
STAKB1
         PUMD R36,+R6          ;
         PUMD R30,+R6          ;
         JSB  =MVWRD           ;
         STM  R30,R32          ;
         POMD R30,-R6          ;
         POMD R36,-R6          ;
         SBM  R32,R30          ;
         DCM  R32              ;
         IFNZ
           JSB  =EXPAND_DEC
         ENDIF
         STM  R36,R2           ;
         LDM  R34,R30          ;
         LOOP
           POBD R77,+R34         ;
           PUBD R77,+R36         ;
           DCM  R32              ;
         WHPS
         RTN                   ;

EXPAND_DEC
         PUMD R30,+R6          ;
         PUMD R0,+R6           ;
         LDMD R0,=NXTMEM       ;
         PUMD R0,+R6           ;
         LDMD R0,=TOS          ;
         PUMD R0,+R6           ;
         CLM  R0               ;
         STMD R0,=TOS          ;
         PUMD R2,+R6           ;
         LDM  R30,R36          ;
         JSB  =ALLOC           ;
         POMD R2,-R6           ;
         POMD R0,-R6           ;
         STMD R0,=TOS          ;
         POMD R0,-R6           ;
         STMD R0,=NXTMEM       ;
         POMD R0,-R6           ;
         POMD R30,-R6          ;
         RTN                   ;

STKMKR   EQU  0EH

POSIT    BIN                   ;
         STM  R12,R36          ;
         DRP  R0
         LOOP
           POBD R#,-R#
           CMB  R#,=STKMKR          ;
         WHNE
         RTN                   ;

DCLIN#   BCD                   ;
         LDB  R57,=3           ;
krdec_l3 TSM  R36              ;
         JLN  NORM
         LLM  R36              ;
         DCB  R57              ;
         JNZ  krdec_l3

NORM     ELM  R36              ;
ROTATE   ELM  R36              ;
         ANM  R36,=1111B,377
         ADB  R36,='0'
         PUBD R36,+R30         ;
         DCB  R57              ;
         JCY  ROTATE
TRAILB   LDB  R2,=BLANK
         PUBD R2,+R30          ;
         BIN                   ;
         RTN                   ;

ASUREB   POBD R2,-R30          ;
         PUBD R2,+R30          ;
         CMB  R2,=BLANK
         JNZ  TRAILB
         RTN                   ;

UNSTAK
         BIN                   ;
         CLM  R34              ;
         LDBD R34,=PRECNT      ;
         LDMD R36,=LAVAIL      ;
         ADM  R36,R34          ;
         ADM  R36,R34          ;
         ADM  R36,R34          ;
         STMD R36,=LAVAIL      ;
         STBD R35,=PRECNT      ;
         CMMD R12,=TOS         ;
         REQ

         LDB  R36,=17          ;
         PUBD R36,+R12         ;
         LDMD R12,=TOS         ;
         POBD R23,+R12         ;
         CMB  R23,=16          ;
         JNE  UNSL1
UNSLOP   POBD R23,+R12         ;
UNSL1    JSB  =DCOVF?
         CMB  R23,=17          ;
         IFEQ
           LDMD R12,=TOS         ;
           JSB  =TRAILB
           RTN                   ;
         ENDIF

         CMB  R23,=ARY1TK
         JZR  SPVAR
         CMB  R23,=ARY2TK
         JZR  SPVAR
         CMB  R23,=4            ;
         IFNC
SPVAR      JSB  =DCVAR
           JMP  UNSLOP
         ENDIF
         IFEQ
           JSB  =DCNCON
           JMP  UNSLOP
         ENDIF 

         CMB  R23,=PRITOK
         JEQ  DOSTR_PAL
         CMB  R23,=7            ;
         IFNC
DOSTR_PAL  JSB  =DCSCON
           JMP  UNSLOP
         ENDIF
         CMB  R#,='!'
         IFEQ
           JSB  =ASUREB
           ARP  !30
           PUBD R23,+R30          ;
           JMP  DCSCON
         ENDIF

         CMB  R23,=16          ;
         IFEQ
           LDB  R23,=COMMA
         ENDIF
         PUBD R23,+R30         ;
         JMP  UNSLOP

DCVAR    POMD R36,+R12         ;
         PUBD R37,+R30         ;
         CMB  R36,=BLANK
         IFNE
           PUBD R36,+R30         ;
         ENDIF
         CMB  R23,=3           ;
         IFEQ
           LDB  R36,='$'
           PUBD R36,+R30         ;
         ENDIF
         RTN                   ;

DCNCON   POMD R40,+R12         ;
         JSB  =CVNUM           ;
         BIN                   ;
         RTN                   ;

DCSCON   POMD R36,+R12         ;
         IFPS
           TCM  R36              ;
         ENDIF
         LDB  R40,=QUOTE
         CMB  R23,=5           ;
         JZR  krdec_l4        ; 2F
         CMB  R23,=PRITOK
         JNE  SHLOP+
         LDB  R40,=PRIME
krdec_l4 PUBD R40,+R30         ; 2H
         JSB  =SHLOP+
         PUBD R40,+R30         ;
         RTN                   ;

SHLOP+   POBD R22,+R36         ;
krdec_l5 DCB  R22              ; 3H
         RNC
         POBD R34,+R36         ;
         PUBD R34,+R30         ;
         JSB  =DCOVF?
         JMP  krdec_l5         ; jmp 3B
         RTN                   ;

SUBSCR   LDM  R76,='()'
         JMP  krdec_l6

DIMSUB   LDM  R76,='[]'
krdec_l6 TSB  R23              ;
         IFEV
           JSB  =TWODIM_DEC
         ELSE
           JSB  =ONEDIM_DEC
         ENDIF
         ARP  !12
         LDM  R34,R12           ;
         JSB  =CLEAN
         RTN                   ;

TWODIM_DEC
         JSB  =POSIT
         LDB  R32,=COMMA
         PUBD R32,+R36         ;
ONEDIM_DEC
         JSB  =POSIT
         PUBD R76,+R36         ;
         PUBD R77,+R12         ;
         RTN                   ;

MSTOR    LDB  R77,=COMMA
         CMBD R23,R24          ;
         IFNE
PU=        LDB  R77,="="
           JSB  =MSTOR-
           JSB  =UNSTAK          ;
           RTN                   ;
         ENDIF

MSTOR-   LDMD R36,=TOS         ;
         LOOP
           POBD R76,+R36         ;
           CMB  R76,=16          ;
         WHEQ
         LOOP
           ARP  !36
           POBD R#,+R36         ;
           CMB  R#,=16          ;
         WHNE
         PUBD R77,-R36         ;
         RTN                   ;

PRNEOP   LDB  R34,=BLANK
         JMP  ITSCOM

PRINTS   PUBD R23,+R6          ;
         JSB  =UNSTAK          ;
         BIN                   ;
         LDB  R34,=COMMA
         POBD R23,-R6          ;
         IFOD
PUTSEM     LDB  R34,=';'
         ENDIF
ITSCOM   DCM  R30              ;
         PUBD R34,+R30         ;
         RTN                   ;

INPUT_DEC
         CMMD R12,=TOS         ;
         SAD                   ;
         JSB  =RESWD
         PAD                   ;
         JNE  PUTSEM           ;
         RTN                   ;

DEFKY    JSB  =RESWD
         DCM  R30              ;
         RTN                   ;

SYSFN$
SYSFUN   LDB  R32,=COMMA
         POBD R77,-R56         ;
         BCD                   ;
         LRB  R77              ;
         BIN                   ;
SISFUN   DRP  !77
         DCB  R77              ;
         IFNG
           LDB  R32,=16          ;
           PUBD R32,+R12         ;
           STM  R12,R36          ;
           ICM  R12              ;
           JSB  =STAKB1
           RTN                   ;
         ENDIF
SYFN1    DCB  R77              ;
         JNG  SYFN2
         JSB  =POSIT
         PUBD R32,+R36         ;
         JMP  SYFN1

SYFN2    JSB  =POSIT
         LDM  R34,R12          ;
         JSB  =CLEAN
         JSB  =STAKB+
         LDM  R34,R12          ;
         DCM  R36              ;
         JSB  =EXPER
         RTN                   ;

PRTFUN   JSB  =SYSFUN
         POMD R36,+R24         ;
         CMM  R36,=6,0
         IFNE
           PUMD R36,-R24         ;
         ENDIF
         RTN                   ;

UFNCAL   JSB  =GETNM           ;
         PUMD R36,+R6          ;
         POBD R77,+R24         ;
         IFNZ
           LOOP
             POBD R36,+R24         ;
             DCB  R77              ;
             IFNZ
               JSB  =POSIT
               LDB  R34,=COMMA
               PUBD R34,+R36         ;
             ENDIF
           WHNZ
           JSB  =POSIT
           LDB  R77,=OPEN
           LDB  R0,=76           ;
           POMD R34,-R6          ;
           JSB  =FNNAM
           JSB  =EXPAND_DEC
           ICM  R36              ;
           PUMD R*,+R36          ;
           LDB  R77,=CLOSE
           LDM  R34,R12          ;
           PUBD R77,+R12         ;
           JSB  =CLEAN
         ELSE
           LDB  R36,=STKMKR
           PUBD R36,+R12         ;
           LDB  R0,=
QMARK      DATA 77           ;
           POMD R34,-R6          ;
           JSB  =FNNAM
           PUMD R*,+R12          ;
         ENDIF
         RTN                   ;

FNNAM    TSB  R23              ;
         IFOD
           LDB  R*,='$'
           DCB  R0               ;
         ENDIF
         CMB  R34,=BLANK
         IFNE
           LDB  R*,R34           ;
           DCB  R0               ;
         ENDIF
         LDB  R*,R35           ;
         DCB  R0               ;
         LDB  R*,='N'
         DCB  R0               ;
         LDB  R*,='F'
         LDB  R32,=100         ;
         SBB  R32,R0           ;
         CLB  R33              ;
         RTN                   ;

UFNDEF   LDM  R72,='DEF FN'
         PUMD R72,+R30         ;
         JSB  =GETNM           ;
         POMD R34,+R24         ;
         POBD R34,+R24         ;
         JSB  =FNNAMN
         LRB  R34              ;
         IFNZ
           LDB  R35,='('
           PUBD R35,+R30         ;
           LDB  R74,=STKMKR
           LOOP
             LDB  R75,=1           ;
             POMD R36,+R24         ;
             TSB  R36              ;
             IFNG
               LDB  R75,=3           ;
               POMD R56,+R24         ;
             ENDIF
             JSB  =ASCNM1          ;
             STM  R36,R76          ;
             PUMD R74,+R12         ;
             POMD R76,+R24         ;
             CMB  R75,=3           ;
             IFEQ
               LDM  R75,=']','[',4
               CMM  R56,=(STRLEN).2
               IFNE
                 STM  R56,R36          ;
                 PUMD R34,+R6          ;
                 JSB  =CONBIN          ;
                 BIN                   ;
                 PUMD R76,+R12         ;
                 PUMD R40,+R12         ;
                 PUBD R75,+R12         ;
                 POMD R34,-R6          ;
               ENDIF
             ENDIF
             DCB  R34              ;
           WHNZ
           LDB  R35,=CLOSE
           PUBD R35,+R12         ;
           JSB  =UNSTAK          ;
           DCM  R30              ;
         ENDIF

         POMD R36,+R24         ;
         LDM  R75,=' = '
         LDBD R36,R24          ;
         CMB  R36,=0EH
         IFNE
           CMB  R36,=BANGTK
           IFEQ
             DRP  R77              ;
           ELSE
             DRP  R75
           ENDIF
           PUMD R#,+R30         ;
         ENDIF
         RTN                   ;
FNNAMN   PUBD R37,+R30         ;
         CMB  R36,=BLANK
         IFNE
           PUBD R36,+R30         ;
         ENDIF
         TSB  R34              ;
         IFOD
           LDB  R37,=44          ;
           PUBD R37,+R30         ;
         ENDIF
         RTN                   ;

EXTROM   LDM  R36,=DECTOK

EXTRJM   JSB  =SAVEME          ;
         POMD R0,+R24          ;
         JSB  =GETROM          ;
         JNZ  ERROM
         JSB  X36,ZRO          ;
         RTN                   ;

ERROM    JSBN  =ERROR+          ;
         DATA 18D              ;
       TITLE 'krvr1'
*
*  __________________________________________________________________
* |KXVR1 NA                                                          |
* |==================================================================|
* ||                                                                ||
* ||   @@     @@@  @@      @@  @@      @@  @@@@@@@@        @@       ||
* ||   @@    @@@   @@      @@  @@      @@  @@@@@@@@@      @@@       ||
* ||   @@   @@@    @@@    @@@  @@      @@  @@     @@@    @@@@       ||
* ||   @@  @@@      @@@  @@@   @@      @@  @@      @@   @@@@@       ||
* ||   @@ @@@         @@@@      @@    @@   @@     @@       @@       ||
* ||   @@@@@           @@       @@    @@   @@@@@@@         @@       ||
* ||   @@@@@           @@       @@    @@   @@@@@@@         @@       ||
* ||   @@ @@@         @@@@       @@  @@    @@    @@@       @@       ||
* ||   @@  @@@      @@@  @@@      @@@@     @@     @@@      @@       ||
* ||   @@   @@@    @@@    @@@     @@@@     @@      @@      @@       ||
* ||   @@    @@@   @@      @@      @@      @@      @@  @@@@@@@@@@   ||
* ||   @@     @@@  @@      @@      @@      @@      @@  @@@@@@@@@@   ||
* ||                                                                ||
* ||                                                                ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ROM version code for the second system ROM
* ********************************************************************
VERMN1   DATA  'd'              ; version letter ('a') for this 8K ROM
       TITLE 'krsum1'
*
*  __________________________________________________________________
* |KXSUM NA                                                          |
* |==================================================================|
* ||                                                                ||
* ||   @@     @@@  @@      @@    @@@@@@    @@      @@  @@      @@   ||
* ||   @@    @@@   @@      @@   @@@@@@@@   @@      @@  @@@    @@@   ||
* ||   @@   @@@    @@@    @@@  @@@    @@@  @@      @@  @@@@  @@@@   ||
* ||   @@  @@@      @@@  @@@   @@      @@  @@      @@  @@@@@@@@@@   ||
* ||   @@ @@@         @@@@     @@@         @@      @@  @@  @@  @@   ||
* ||   @@@@@           @@       @@@@@@@    @@      @@  @@  @@  @@   ||
* ||   @@@@@           @@        @@@@@@@   @@      @@  @@      @@   ||
* ||   @@ @@@         @@@@            @@@  @@      @@  @@      @@   ||
* ||   @@  @@@      @@@  @@@   @@      @@  @@      @@  @@      @@   ||
* ||   @@   @@@    @@@    @@@  @@@     @@  @@@    @@@  @@      @@   ||
* ||   @@    @@@   @@      @@   @@@@@@@@    @@@@@@@@   @@      @@   ||
* ||   @@     @@@  @@      @@    @@@@@@      @@@@@@    @@      @@   ||
* ||                                                                ||
* ||                                                                ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* CHECKSUM byte for the 2nd system ROM
* ********************************************************************
*        DATA  78H              ; checksum byte for this 8K ROM
         DATA  0B6H              ; checksum byte for this 8K ROM
       TITLE 'krbat'
*
*  __________________________________________________________________
* |IVBAT 54 05/10/82 - 5/13/1982 2:55PM                              |
* |==================================================================|
* ||                                                                ||
* ||   @@@@@@@@@@  @@      @@  @@@@@@@@      @@@@@@    @@@@@@@@@@   ||
* ||   @@@@@@@@@@  @@      @@  @@@@@@@@@    @@@@@@@@   @@@@@@@@@@   ||
* ||       @@      @@      @@  @@     @@@  @@@    @@@      @@       ||
* ||       @@      @@      @@  @@      @@  @@      @@      @@       ||
* ||       @@       @@    @@   @@     @@@  @@      @@      @@       ||
* ||       @@       @@    @@   @@@@@@@@    @@@@@@@@@@      @@       ||
* ||       @@       @@    @@   @@@@@@@@    @@@@@@@@@@      @@       ||
* ||       @@        @@  @@    @@     @@@  @@      @@      @@       ||
* ||       @@         @@@@     @@      @@  @@      @@      @@       ||
* ||       @@         @@@@     @@     @@@  @@      @@      @@       ||
* ||   @@@@@@@@@@      @@      @@@@@@@@@   @@      @@      @@       ||
* ||   @@@@@@@@@@      @@      @@@@@@@@    @@      @@      @@       ||
* ||                                                                ||
* ||                    Last edited: 820908.1349                    ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
BATS     BIN                   ;
         STMD R26,=PROTEM      ;
FINDWD   CLE                   ;
         SBB  R36,R37          ;
         RLO

WORDS    LDBD R3,R26           ;
         ICB  R3               ;
         TSM  R2               ;
         RZR

         DCB  R36              ;
         JNC  CHARS_BAT
         JSB  =SKIP
         JMP  WORDS

CHARS_BAT
         ICE                   ;
         LOOP
           POBD R3,+R26          ;
           IFZR
             JSB  =EXPAND
             JMP  CHARS_BAT
           ENDIF
           CMB  R3,=1            ;
           IFEQ
             JSB  =EXPAND
             LDB  R3,=BLANK
             PUBD R3,+R30          ;
             JMP  CHARS_BAT
           ENDIF
           CMB  R3,=2            ;
           JZR  EXPAND
           PUBD R3,+R30          ;
         WHPS

         POBD R3,-R30          ;
         ANM  R3,=NOT#7
         PUBD R3,+R30          ;
         RTN                   ;

EXPAND   POBD R36,+R26         ;
         PUMD R26,+R6          ;
         LDMD R26,=PROTEM      ;
         ICB  R2               ;
         JSB  =FINDWD          ;
         POMD R26,-R6          ;
         RTN                   ;

SKIP
         DRP  R3
         ARP  R26
SKIP#
         DRP  !3
         ARP  !26
         POBD R3,+R26          ;
         RNG
         CMB  R3,=2            ;
         IFLT
           POBD R3,+R26          ;
         ELSE
           IFEQ
             POBD R3,+R26          ;
             RTN                   ;
           ENDIF
         ENDIF
         JMP  SKIP#            ;
       TITLE 'krapt'
*
*  __________________________________________________________________
* |IVAPT 50 05/10/82 - 5/13/1982 2:54PM                              |
* |==================================================================|
* ||                                                                ||
* ||   @@@@@@@@@@  @@      @@    @@@@@@    @@@@@@@@    @@@@@@@@@@   ||
* ||   @@@@@@@@@@  @@      @@   @@@@@@@@   @@@@@@@@@   @@@@@@@@@@   ||
* ||       @@      @@      @@  @@@    @@@  @@     @@@      @@       ||
* ||       @@      @@      @@  @@      @@  @@      @@      @@       ||
* ||       @@       @@    @@   @@      @@  @@     @@@      @@       ||
* ||       @@       @@    @@   @@@@@@@@@@  @@@@@@@@@       @@       ||
* ||       @@       @@    @@   @@@@@@@@@@  @@@@@@@@        @@       ||
* ||       @@        @@  @@    @@      @@  @@              @@       ||
* ||       @@         @@@@     @@      @@  @@              @@       ||
* ||       @@         @@@@     @@      @@  @@              @@       ||
* ||   @@@@@@@@@@      @@      @@      @@  @@              @@       ||
* ||   @@@@@@@@@@      @@      @@      @@  @@              @@       ||
* ||                                                                ||
* ||                    Last edited: 820908.1333                    ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
ACMND    PUBD R36,+R6          ;
         JSB  =OTHER           ;
         JSB  =INITGL          ;
         JSB  =REPORT          ;
         TSB  R16              ;  IF B16#0
         IFNZ
           JSB  =CRUNCH          ;
         ENDIF
         JMP  AEND

ANOTE    PUBD R36,+R6          ;
         CLM  R36              ;
         LDB  R36,R24          ;
         LDM  R26,=INPBUF      ;
         LDMD R43,=DELAY       ;
         LDM  R53,=0,100,1,0,0 ;
         STMD R53,=DELAY       ;
         JSB  =OUTSTR          ;
         STMD R43,=DELAY       ;
AEND     POBD R25,-R6          ;
         RTN                   ;
       TITLE 'krmth'
MPYR_APO ADDR 7F9AH
YTX5_APO ADDR 778BH
X_K-1_   ADDR 101225
*
*  __________________________________________________________________
* |KXMTH 293 08/31/82 - 9/ 9/1982 7:09AM                             |
* |==================================================================|
* ||                                                                ||
* ||   @@     @@@  @@      @@  @@      @@  @@@@@@@@@@  @@      @@   ||
* ||   @@    @@@   @@      @@  @@@    @@@  @@@@@@@@@@  @@      @@   ||
* ||   @@   @@@    @@@    @@@  @@@@  @@@@      @@      @@      @@   ||
* ||   @@  @@@      @@@  @@@   @@@@@@@@@@      @@      @@      @@   ||
* ||   @@ @@@         @@@@     @@  @@  @@      @@      @@      @@   ||
* ||   @@@@@           @@      @@  @@  @@      @@      @@@@@@@@@@   ||
* ||   @@@@@           @@      @@      @@      @@      @@@@@@@@@@   ||
* ||   @@ @@@         @@@@     @@      @@      @@      @@      @@   ||
* ||   @@  @@@      @@@  @@@   @@      @@      @@      @@      @@   ||
* ||   @@   @@@    @@@    @@@  @@      @@      @@      @@      @@   ||
* ||   @@    @@@   @@      @@  @@      @@      @@      @@      @@   ||
* ||   @@     @@@  @@      @@  @@      @@      @@      @@      @@   ||
* ||                                                                ||
* ||                    Last edited: 820909.0705                    ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
LN20     JSB  =ONER            ;
         JSB  =SEP10           ;
         TSM  R40              ;
         JNZ  LN24
         JSBN  =ERROR+          ;
         DATA  12D

LN24     TSB  R32              ;
         JRZ  LN30             ;
         JSBN  =ERROR+          ;
         DATA 13D

LN36     STM  R40,R50          ;
         SBB  R47,=10C
         JSB  =SHF10           ;
         STM  R36,R34          ;
         CLM  R36              ;
         TSM  R40              ;
         RZR
         JSB  =UT210           ;
LN38     JSB  =DIV20           ;
         ICM  R36              ;
LN40     STM  R36,R34          ;
         CLM  R70              ;
         TCM  R34              ;
         CMM  R34,=8C,0
         JLZ  LN80             ;
         CLE                   ;
         JMP  LN50
j
LN30     TSM  R36              ;
         JZR  LN36
         TCM  R40              ;
         ICM  R36              ;
         STM  R36,R26          ;
         CLM  R36              ;
         JSB  =SHF10           ;

LN77     JSB  =LN40
         PUMD R40,+R12         ;
         CLM  R40              ;
         CLB  R33              ;
         LDM  R46,R26          ;
         JPS  LN33
         TCM  R46              ;
         NCB  R32              ;

LN33     STM  R36,R14          ;
         LDM  R36,=3C,0
         JSB  =SHF10           ;
         CLM  R34              ;
         LDMD R50,=TBL2
         JSB  =MPY30           ;
         LDM  R34,R14          ;
         POMD R50,-R12         ;
         NCB  R33              ;
         JSB  =ADD20           ;
         RTN                   ;

LN62     DCE                   ;
         ICB  R70              ;
LN50     STM  R40,R60          ;
         TSM  R36              ;
         JZR  LN58
         ERM  R67              ;
LN52     STB  R67,R0           ;
         LDB  R31,R36          ;
         JMP  LN56             ;
LN54     LRM  R67              ;
LN56     ICB  R31              ;
         JNZ  LN54             ;
         LLB  R0               ;
LN58     ADM  R40,R60          ;
         JNC  LN60             ;
         ICE                   ;
LN60     JEN  LN62             ;
         SBM  R40,R60          ;
         STM  R40,R60          ;
         LLM  R70              ;
         CMB  R36,=93C
         JZR  LN80
         DCM  R36              ;
         LLM  R40              ;
         JMP  LN52             ;

LN80     DCM  R36              ;
         JSB  =NEWR
         CLB  R32              ;
         LDM  R34,=(TBL1).2
         LLM  R40              ;
         DCM  R36              ;
         JMP  LN96

LN92     DCB  R#
         ADM  R40,R#           ;
         JNC  LN94
         ICE                   ;
LN94     TSB  R70              ;
         JRN  LN92
LN96     TSM  R70              ;
         JZR  LN98             ;
         ERM  R47              ;
         LRM  R74              ;
         POMD R60,+R34         ;
         ICM  R36              ;
         CLE                   ;
         ARP  R60              ;
         JMP  LN94

NEWR     TSM  R40
         RZR
         PUMD R40,+R12         ;
         STM  R36,R34          ;
         LRM  R47              ;
         STM  R40,R50          ;
         ADM  R40,R40          ;
         ADM  R40,R40          ;
         ADM  R40,R50          ;
         JSB  =BRTS35          ;
         POMD R50,-R12         ;
         TCM  R40              ;
         JNZ  LN84
         LDM  R40,R50          ;
         LDM  R36,R34          ;
         RTN                   ;

LN98     JEZ  LN99             ;
         ERM  R47              ;
         ICM  R36              ;
LN99     JMP  SHF10            ;

         DATA  20,55

LN5      JSB  =LN20            ;
         JMP  DIV11

LN84     DCM  R36              ; fall into DIV17

DIV17    TCM  R36              ;
         CLE                   ;
         CMM  R50,R40          ;
         JCY  DIV77            ;
         LLM  R50              ;
         DCM  R34              ;
DIV77    LDB  R30,=15C
         CLB  R31              ;
         ELB  R31              ;
         JSB  =UT110           ;
         JMP  DIV79            ;

DIV39    DCB  R31              ;
         DRP  R50              ;
DIV40    ICE                   ;
DIV50    SBM  R#,R#           ;
         JCY  DIV40
         TSB  R31              ;
         JNZ  DIV39            ;
         ADM  R50,R#           ;
         ELM  R40              ;
         DCB  R30              ;
         RNG
DIV30    LLM  R50              ;
         ELB  R31              ;
DIV79    DRP  R50              ;
         JMP  DIV50            ;

         DATA 12,51
DIV2     JSB  =TWOR            ;
DIV10    JSB  =SEP15           ;
DIV14    JSB  =DIV88
DIV11    GTO RONF              ;

DIV88    TSM  R40              ;
         JNZ  DIV20            ;
         JSB  =ERROR           ;
         DATA 8D
         LRB  R33              ;
         GTO FTR88             ;

DIV20    JSB  =DIV17
SHF10    TSM  R40              ;
         JNZ  SHF30
         GTO LCOM1

SHF20    DCM  R36              ;
         LLM  R40              ;
SHF30    JLZ  SHF20
         RTN                   ;

         DATA 20,55
LOGT5    JSB  =LN20            ;
         JSB  =LOGCOM          ;
         LDMD R40,=TBL2
         JMP  DIV14            ;

         DATA 20,55
CEIL10   JSB  =CHSROI          ;
         JSB  =INT5            ;

         DATA  7,50
CHSROI   POMD R40,-R12         ;
         CMB  R44,=377         ;
         JCY  CHS10X
         TSM  R40              ;
         JZR  CHS11
         LLB  R41              ;
         NCB  R41              ;
         ERB  R41              ;
CHS11    PUMD R40,+R12         ;
         RTN                   ;

CHS10X   TCM  R45              ;
         JMP  CHS11

         DATA 7,51
SUBROI   JSB  =TWOSEP
         JSB  =SUBIL
         JMP  ADSUEX

         DATA 7,51
ADDROI   JSB  =TWOSEP
         JSB  =ADSU
ADSUEX   GTO  MPYEX

SUBIL    NCB  R32              ;
         JEZ  ADD20            ;
         TCM  R45              ;
ADSU     JEZ  ADD20            ;
         ADM  R45,R55          ;
         RLZ
         CMB  R47,=220         ;
         RLZ
         CLB  R32              ;
         CMB  R47,=120         ;
         JNC  POSGN
         TCM  R45              ;
         NCB  R32              ;
POSGN    CLM  R53              ;
         STM  R53,R40          ;
         LDM  R36,=5C,0
         RTN                   ;

ADD9     JSB  =TWOR            ;
         JSB  =SEP15           ;
ADD15    JSB  =ADD20           ;
         JMP  EXP11

ADD20    TSM  R50              ;
         RZR
         TSM  R40              ;
         JNZ  A&B#0
         LDM  R40,R50          ;
         LDM  R36,R34          ;
         LDB  R32,R33          ;
         RTN                   ;

A&B#0    SBM  R34,R36          ;
         JZR  EXP=
         JPS  SWAP+-
         TCM  R34              ;
         JMP  ADDNOW

EXP=     CMM  R40,R50          ;
         JCY  ADDNOW
SWAP+-   LDM  R60,R40          ;
         STM  R50,R40          ;
         LDM  R50,R60          ;
         STB  R32,R60          ;
         LDB  R32,R33          ;
         STB  R60,R33          ;
         ADM  R36,R34          ;
ADDNOW   XRB  R33,R32          ;
         LLB  R33              ;
         JZR  ADD40
         TCM  R50              ;
ADD40    CMM  R34,=16C,0
         ARP  R33              ;
         JNC  ADD50
ADD95    GTO SHF10             ;

ADD52    LRM  R57              ;
         ADB  R57,R#           ;
ADD50    DCB  R34              ;
         JCY  ADD52
         ADM  R40,R50          ;
         JNC  ADD95
         TSB  R33              ;
         JNZ  ADD95
         CLE                   ;
         ICE                   ;
         ERM  R47              ;
         ICM  R36              ;
         RTN                   ;

         DATA 20,55
EXP5     JSB  =ONER            ;
         JSB  =EXP18
EXP11    GTO RONF              ;

SQR65    ADM  R40,R70          ;
SQR45    SBM  R50,R40          ;
         JCY  SQR65
         ADM  R50,R40          ;
         LLM  R50              ;
         SBM  R40,R60          ;
         LRM  R77              ;
         LRM  R67              ;
         DCB  R30              ;
         JCY  SQR40
         LLM  R40              ;
         JMP  ADD95

         DATA 20,55
SQR5     JSB  =ONER            ;
         TSB  R41              ;
         JRZ  SQR15
         JSBN  =ERROR+          ;
         DATA 10D

SQR15    JSB  =SEP10           ;
         JSB  =SQR30           ;
SQR11    GTO RONF              ;

SQR30    LRM  R47              ;
         STM  R40,R50          ;
         ADM  R50,R50          ;
         ADM  R50,R50          ;
         ADM  R50,R40          ;
         LDM  R34,R36          ;
         JOD  SQR35
         LRM  R57              ;
SQR35    TSM  R50              ;
         JNZ  SQR36
         CLM  R40              ;
         RTN                   ;

SQR36    ADM  R36,R36          ;
         ADM  R36,R36          ;
         ADM  R36,R34          ;
         LRM  R37              ;
         CMB  R35,=50C
         JNC  SQR37
         ADB  R37,=90C
SQR37    LDB  R30,=24          ;
         CLM  R70              ;
         ICB  R77              ;
         CLM  R60              ;
         LDB  R66,=50C
         CLM  R40              ;
SQR40    ADM  R40,R60          ;
         JMP  SQR45

MPY11    JMP  EXP11

MPY28    JSB  =SEP15           ;
MPY30    JSB  =UT110F
         LDB  R0,=57           ;
         LDM  R60,R40          ;
         ORM  R60,R50          ;
         JZR  MPY36
         BIN                   ;
MPY31    ICB  R0               ;
         TSB  R*               ;
         JZR  MPY31
         STM  R50,R60          ;
         SBB  R0,=20           ;
         TSB  R*               ;
         JZR  MPY32
         STM  R40,R60          ;
         LDM  R40,R50          ;
MPY32    CLM  R50              ;
         STM  R*,R50           ;
         CLM  R40              ;
         ARP  R60              ;
         BCD                   ;
         TSM  R50              ;
         JZR  MPY36
MPY77    LRM  R57              ;
         JEZ  MPY77
         CLB  R0               ;
         DRP  R40
MPY50    ADM  R#,R#          ;
         JNC  MPY52
         ICB  R0               ;
         DRP  R40              ;
MPY52    DCE                   ;
MPY60    JEN  MPY50
         LRB  R0               ;
         TSM  R50              ;
         JNZ  MPY70
         JEZ  MPY36
         ERM  R47              ;
         ICM  R36              ;
MPY36    GTO SHF10             ;
MPY70    ERM  R47              ;
         LRM  R57              ;
         DRP  R40              ;
         JMP  MPY60

         DATA 12,51
MPYROI   JSB  =TWOSEP
         JSB  =SYSJSB          ;
         DEF  MPYR_APO

MPYEX    CMB  R44,=377         ;
         JNC  MPY11
         PUMD R40,+R12         ;
         RTN                   ;

INTMUL   SAD                   ;
         BIN                   ;
         PUMD R60,+R6          ;
         PUMD R74,+R6          ;
         CLM  R54              ;
         STM  R76,R74          ;
         CLM  R76              ;
         STM  R66,R60          ;
MLOOP    JZR  INTM2
         JEV  DONTAD
         ADM  R54,R74          ;
DONTAD   LLM  R74              ;
         LRM  R61              ;
         JMP  MLOOP

INTM2    POMD R74,-R6          ;
         POMD R60,-R6          ;
         PAD                   ;
         RTN                   ;

         DATA 14,51
YTX5     JSB  =MELJSB          ;
         DEF  YTX5_APO         
         RTN                   ;

         DATA  20,55
SGN5     JSB  =ONER            ;
         LRB  R41              ;
         TSM  R40              ;
         JZR  SGN6
         CLM  R40              ;
         ICB  R47              ;
         ELM  R41              ;
SGN6     GTO  NFR2

DRCOM    JSB  =ONER            ;
         STM  R40,R50          ;
         CLM  R40              ;
         JSB  =SEP20           ;
         JMP  LCOM1

LOGCOM   STM  R36,R34          ;
         STM  R40,R50          ;
         STB  R32,R33          ;
LCOM1    CLB  R32              ;
         CLM  R36              ;
         RTN                   ;

         DATA 20,55
SEC10    LDM  R26,=0,90C
         JSB  =FTR12           ;
         TSM  R40              ;
         JNZ  CSEC30
         JSB  =FTR78

         DATA 20,55
XSEC10   LDM  R26,=9C,90C
         JSB  =FTR12           ;
         TSM  R40              ;
         JNZ  CSEC30
         JSB  =ERROR           ;
         DATA 3D

         DATA 0,55
INF10    JSB  =FTR77
CSEC30   JSB  =FTR53           ;
CSEC11   JMP  FTR15

         DATA 20,55
COT10    LDM  R26,=9C,9C
         JMP  FTR11

         DATA 20,55
SIN10    LDM  R26,=9C,90C
         JMP  FTR11

         DATA 20,55
COS10    LDM  R26,=0,90C
         JMP  FTR11

         DATA 20,55
TAN10    CLM  R26              ;
FTR11    JSB  =FTR12           ;
FTR15    JMP  RAD11

         DATA 0,55
         LDM  R40,=0,0,59C,53C,26C,59C,41C,31C
         JMP  ABS6

OVF19    JSB  =ERROR           ;
         DATA 1D
OVF10    TSM  R40              ;
         JZR  LCOM1
         CMB  R37,=5C           ;
         RNC
         CMM  R36,=01C,95C
         RCY
         CLM  R40              ;
         CMB  R37,=50C
         JCY  OVF19
         LDM  R36,=99C,4C
         NCM  R42              ;
         JSBN  =ERROR+          ;
         DATA 2D

         DATA 20,55
RAD10.   JSB  =DRCOM
         LDB  R36,=2C           ;
         LDB  R47,=45C
         JSB  =DIV20           ;
         LDMD R50,=DCON1       ;
         CLB  R33              ;
         CLM  R34              ;
         JSB  =MPY30           ;
RAD11    JMP  RONF             ;

         DATA 20,55
ABS5     JSB  =ONER            ;
ABS5-    LRB  R41              ;
         LLB  R41              ;
ABS6     JMP  NFR2

INTFRA   JSB  =ONER            ;
INTFR3   JSB  =SEP10           ;
INTFR4   STM  R36,R34          ;
         CLM  R50              ;
         TSB  R35              ;
         RLN
INFR5    TSM  R40              ;
         RZR
         LLM  R40              ;
         ELM  R50              ;
         DCM  R36              ;
         JCY  INFR5
         RTN                   ;

         DATA 20,55
INT5     CLB  R2               ;
         ICB  R2               ;
         JMP  IP4

         DATA 12,51
INTDIV   JSB  =TWOR            ;
         JSB  =SEP15           ;
         JSB  =DIV88
         CLB  R2               ;
         JMP  IP3

INFR2    JSB  =INFR4           ;
         JSB  =UT210           ;
         TSM  R50              ;
         JZR  TRUNC
         TSB  R2               ;
         JZR  TRUNC
         TSB  R32              ;
         JRZ  TRUNC
         ICM  R40              ;
INFR9    LDM  R36,=15C,0
         GTO SHF10             ;

TRUNC    JSB  =SHF10           ;
         LDM  R36,R34          ;
         RTN                   ;

         DATA 20,55
FP5      JSB  =INTFRA
SHRONF   JSB  =SHF10           ;
RONF     JSB  =ROU10           ;
NFR      JSB  =NFR5
NFR2     DRP  R40
NFR3     PUMD R#,+R12         ;
         RTN                   ;

NFR5     JSB  =OVF10
         STM  R36,R40          ;
         LRB  R32              ;
         ELB  R41              ;
         RTN                   ;

         DATA 0,55
EPS10    JSB  =TRC01           ;
         LDB  R51,=50C
         ICB  R50              ;
         JMP  NFR3

         DATA 20,55
DEG10    JSB  =DRCOM
         ICM  R34              ;
         ICM  R34              ;
         JSB  =TRC7            ;
         JSB  =DEGCNV          ;
         JMP  SHRONF           ;

DEGCNV   LDM  R40,R70          ;
         JSB  =DIV20           ;
         STM  R40,R50          ;
         LRM  R57              ;
         SBM  R40,R50          ;
         RTN                   ;

         DATA 20,55
IP5      CLB  R2               ;
IP4      JSB  =ONEROI          ;
         JEN  NFR2
         JSB  =SEP10           ;
IP3      JSB  =INFR2           ;
         JSB  =RONF            ;
         POMD R60,-R12         ;
         JSB  =RTOIN           ;
         LDB  R64,=377         ;
         DRP  R60              ;
         JEZ  NFR3
         DRP  R70              ;
         JMP  NFR3

FTR12    JSB  =ONER            ;
         JSB  =SEP10           ;
FTR13    CLB  R22              ;
         TSB  R32              ;
         JRZ  FTR14
         CLB  R32              ;
         TSM  R26              ;
         JLZ  FTR19
         JRZ  FTR14
FTR19    NCB  R22              ;
FTR14    LDBD R25,=DRG         ;
         JPS  FTR16
FTR18    CLM  R70              ;
         LDB  R77,=45C
         DCM  R36              ;
         TSB  R37              ;
         JLN  FTR20
         DCM  R36              ;
         JCY  FTR20
         ICM  R36              ;
         LRM  R47              ;
FTR20    STM  R70,R50          ;
         TSB  R37              ;
         JLZ  FTR24
         TSB  R25              ;
         JNG  FTR32
         LRM  R47              ;
         ICM  R36              ;
         JMP  FTR32

FTR16    LDMD R70,=DCON1       ;
         JMP  FTR20

FTR24    LRM  R57              ;
         ADM  R50,R50          ;
         ADM  R50,R50          ;
         ADM  R50,R50          ;
         CLE                   ;
         ICE                   ;
FTR17    DCE                   ;
FTR25    SBM  R40,R#           ;
         JCY  FTR25
         JEN  FTR17
         ADM  R40,R#
         LLM  R40              ;
         DCM  R36              ;
         JCY  FTR25
         CLM  R36              ;
         ERM  R47              ;
         LDM  R50,R70          ;
         LRM  R57              ;
         ADM  R50,R50          ;
FTR26    SBM  R40,R50          ;
         JNC  FTR28
         NCB  R26              ;
         JRN  FTR29
         TSB  R27              ;
         JLN  FTR26
FTR29    NCB  R22              ;
         JMP  FTR26

FTR38    ADM  R40,R50          ;
         JMP  FTR34

FTR28    ADM  R40,R50          ;
         TSB  R25              ;
         JPS  FTR30
         LLM  R40              ;
FTR30    LDM  R50,R70          ;
FTR32    TSB  R37              ;
         JLN  FTR34
         TSB  R25              ;
         JNG  FTR36
         LRM  R57              ;
FTR36    SBM  R40,R50          ;
         JNC  FTR38
         SBM  R40,R50          ;
         TCM  R40              ;
         NCB  R26              ;
FTR34    JSB  =SHF10           ;
         TSB  R25              ;
         JPS  FTR42
         JSB  =UT210           ;
         STM  R36,R34          ;
         CLM  R36              ;
         ICM  R36              ;
         JSB  =DIV20           ;
         LDMD R70,=DCON1       ;
         STM  R70,R50          ;
         CLM  R34              ;
         JSB  =MPY30           ;
FTR42    LDM  R20,=7C,0C
         LDM  R30,=TBL3        ;
         LDM  R34,R36          ;
         ICM  R34              ;
         JLZ  FTR62
         LRM  R47              ;
FTR46    ICM  R34              ;
         JLZ  FTR62
         POMD R60,+R30         ;
         DCB  R20              ;
         JNZ  FTR46
         STB  R22,R32          ;
         LLM  R40              ;
         TSM  R26              ;
         JRZ  FTR60
         RLN

FTR53    JSB  =TRC01           ;
         JSB  =DIV20           ;
         RTN                   ;

FTR62    CLM  R50              ;
         LLM  R40              ;
FTR64    POMD R70,+R30         ;
         JSB  =PQO10           ;
         DCB  R20              ;
         JNZ  FTR64
         ERM  R47              ;
         LRM  R47              ;
         LRM  R57              ;
         CLM  R60              ;
         ICB  R67              ;
         LLB  R67              ;
         LDM  R36,=7C,0
         JMP  FTR66

FTR68    DCB  R31              ;
         LRM  R77              ;
         LRM  R77              ;
FTR70    TSB  R31              ;
         JNZ  FTR68
         ADM  R40,R60          ;
         SBM  R60,R70          ;
FTR66    STM  R40,R70          ;
         STB  R36,R31          ;
         TSB  R50              ;
         JRZ  FTR72
         DCB  R50              ;
         JMP  FTR70            ;

FTR72    LRM  R57              ;
         TSM  R50              ;
         JZR  FTR74
         DCB  R36              ;
         LRM  R47              ;
         JMP  FTR66

FTR60    RLZ
         CLM  R40              ;
         LDB  R47,=10C
         CLM  R36              ;
         JMP  FTR84

FTR74    LDM  R50,R60          ;
         CLM  R34              ;
         CLM  R32              ;
         TSB  R26              ;
         JRN  FTR76
         JSB  =UT210           ;
         TCM  R36              ;

FTR76    TSM  R40              ;
         JNZ  FTR79
         TSB  R27              ;
         RLN
         JRZ  FTR78
         JSB  =ERROR           ;
         DATA 3D
         JMP  FTR77

FTR78    JSB  =ERROR           ;
         DATA 4D
FTR77    CLE                   ;
         CLM  R40              ;
FTR88    NCM  R40              ;
         LDB  R41,=4C           ;
         ELB  R41              ;
         PUMD R40,+R12         ;
         POMD R0,-R6           ;
         RTN                   ;

FTR79    TCM  R36              ;
         JSB  =SHF10           ;
         JSB  =DIV20           ;
         TSB  R27              ;
         JLZ  FTR84
         STM  R36,R34          ;
         STM  R40,R50          ;
         JSB  =MPY30           ;
         JSB  =TRC01           ;
         JSB  =ADD20           ;
         JSB  =SQR30           ;
         JSB  =FTR53           ;
FTR84    STB  R22,R32          ;
         RTN                   ;

TRC7     LDMD R70,=DCON1       ;
         LRM  R77              ;
         ADM  R70,R70          ;
         RTN                   ;

TRC01    CLB  R33              ;
TRCS1    CLM  R50              ;
         LDB  R57,=10C
         CLM  R34              ;
         RTN                   ;

RNDINI   LDMD R40,=RNDS
         STMD R40,=X_K-1_      ;
         RTN                   ;

         DATA 241
RNDIZ.   JSB  =MELJSB          ;
         DEF  RNDIZ
         RTN                   ;

ROU10    STM  R40,R50          ;
         CLM  R52              ;
         ADM  R40,R50          ;
         JNC  SEP41            ;
         LDB  R47,=10C
         ICM  R36              ;
         JMP  SEP41

SEP20    LDM  R34,R50          ;
         LRB  R35              ;
         CMB  R35,=5C          ;
         IFCY
           ADB  R35,=90C
         ENDIF
         ELB  R33              ;
         CLB  R50              ;
         CLB  R51              ;
         RTN                   ;

TWOSEP   JSB  =TWOROI          ;
         REN
SEP15    BCD                   ;
         JSB  =SEP20           ;

SEP10    LDM  R36,R40          ;
         LRB  R37              ;
         CMB  R37,=5C          ;
         JNC  SEP40            ;
         ADB  R37,=90C
SEP40    ELB  R32              ;
         CLE                   ;
SEP41    CLB  R40              ;
         CLB  R41              ;
         RTN                   ;

UT110    STM  R40,R60          ;
         CLM  R40              ;
UT110F   ADM  R36,R34          ;
         XRB  R32,R33          ;
         ARP  R60              ;
         RTN                   ;

TWOR     JSB  =ONER            ;
         STM  R40,R50          ;
         JSB  =ONER            ;
UT210    STM  R50,R60          ;
         LDM  R50,R40          ;
         STM  R60,R40          ;
         RTN                   ;

PQ030    DCE                   ;
PQ020    ICB  R50              ;
PQ010    SBM  R40,R70          ;
         JCY  PQ020
         JEN  PQ030            ;
         ADM  R40,R70          ;
         LLM  R50              ;
         LLM  R40              ;
         RTN                   ;

         DATA 40,55
MIN10    JSB  =TWOR            ;
         JSB  =UT210           ;
         PUMD R40,+R12         ;
         PUMD R50,+R12         ;
         JMP  MAX11

         DATA 40,55
MAX10    JSB  =TWOR            ;
         PUMD R50,+R12         ;
         PUMD R40,+R12         ;
MAX11    JSB  =SEP15           ;
         NCB  R32              ;
         JSB  =ADD20           ;
         POMD R50,-R12         ;
         TSB  R32              ;
         RRZ
         POMD R40,-R12         ;
         PUMD R50,+R12         ;
         RTN                   ;

EXP18    JSB  =SEP10           ;
EXP20    JSB  =EXP17           ;
         JSB  =TRCS1
         JSB  =ADD20           ;
         ADM  R36,R14          ;
         TSB  R32              ;
         RRZ
         CLB  R32              ;
         JSB  =FTR53           ;
         RTN                   ;

EXP17    STB  R32,R33          ;
         LDM  R24,=(TBL2).2
         CLM  R50              ;
         CLM  R26              ;
         CLM  R14              ;
         CLE                   ;
         CMB  R37,=50C
         JCY  EXP30
         LDMD R70,R24          ;
         ARP  R70              ;
EXP66    ERB  R30              ;
         LLM  R14              ;
         LLB  R30              ;
         JMP  EXP24

EXP26    DCE                   ;
EXP25    ICM  R14              ;
EXP24    SBM  R40,R#
         JCY  EXP25
         JEN  EXP26            ;
         ADM  R40,R#
         LLM  R40              ;
         CMM  R14,=99C,9C
         JNC  EXP28
         LDM  R14,=98C,9C
         CLM  R36              ;
         CLM  R40              ;
         NCM  R42              ;
         RTN                   ;

EXP28    DCM  R36              ;
         JNC  EXP31
         JMP  EXP66            ;

EXP30    LDM  R26,R36          ;
         NCM  R26              ;
         CMM  R26,=8C,0
         JCY  EXP34            ;
         BIN                   ;
         LLM  R26              ;
         LLM  R26              ;
         LLM  R26              ;
         SBM  R24,R26          ;
         BCD                   ;
EXP31    POMD R70,-R24         ;
         JSB  =PQO10           ;
         BIN                   ;
         CMM  R24,=(TBL1).2
         BCD                   ;
         JNZ  EXP31            ;
         ERM  R47              ;
         LDM  R26,=7C,0
         LDM  R36,=92C,99C
EXP34    STM  R50,R70          ;
         JSB  =NEWR
         STB  R33,R32          ;
         JMP  EXP39

EXP38    DCM  R26              ;
EXP39    LRM  R74              ;
         TSM  R70              ;
         RZR
         LRM  R47              ;
         ICM  R36              ;
         JMP  EXP42

EXP40    LRM  R57              ;
EXP41    DCM  R24              ;
         JCY  EXP40
         ADM  R40,R50          ;
         ADM  R47,=10C
EXP42    TSB  R70              ;
         JRZ  EXP38
         DCB  R70              ;
         STM  R40,R50          ;
         LDM  R24,R26          ;
         JMP  EXP41

DCON1    DATA 7853981633974480C
TBL1     DATA 9999999500000034C
         DATA 9999995000003334C
         DATA 9999950000333331C
         DATA 9999500033330834C
RNDS     DATA 9995003330835332C
         DATA 9950330853168083C
         DATA 9531017980432487C
         DATA 6931471805599454C
TBL2     DATA 2302585092994046C
TBL3     DATA 9966865249116203C
         DATA 9999666686665238C
         DATA 9999996666668667C
         DATA 9999999966666667C
         DATA 9999999999666667C
         DATA 9999999999996667C
         DATA 9999999999999967C
TBL3B    BSS 0

ONEB     BCD                   ;
         POMD R60,-R12         ;
         CMB  R64,=377         ;
         JNC  REALB
         LRB  R65              ;
         TSM  R65              ;
         JNZ  ONEB1
         CLM  R76              ;
         ELB  R76              ;
         CLE                   ;
ONEBJ    STM  R76,R46          ;
         BIN                   ;
         RTN                   ;

ONEB1    ELB  R65              ;
         JSB  =INTORL          ;
REALB    JSB  =CONINT          ;
         JMP  ONEBJ
ONEI     JSB  =ONEROI          ;
         JEN  ONEIOK
         LDM  R60,R40          ;
         JSB  =RTOIN           ;
         LDB  R44,=377         ;
         LDM  R45,R65          ;
         RTN                   ;

TWOB     JSB  =ONEB            ;
         STM  R46,R26          ;
         JSB  =ONEB            ;
         STM  R46,R56          ;
         LDM  R46,R26          ;
         RTN                   ;

ONER     POMD R60,-R12         ;
ONER-    CMB  R64,=377         ;
         JNC  FLORTN           ;
         JSB  =INTORL          ;
FLORTN   BCD                   ;
         STM  R60,R40          ;
ONEIOK   CLE                   ;
         RTN                   ;

ONEROI   POMD R40,-R12         ;
ONERI    CLE                   ;
         CMB  R44,=377         ;
         RNC
         ICE                   ;
         RTN                   ;

TWOROI   CLE                   ;
         POMD R40,-R12         ;
         POMD R50,-R12         ;
         CMB  R54,=377         ;
         JNC  CASE34
         CMB  R44,=377         ;
         JNC  CASE2
         ICE                   ;
         RTN                   ;

CASE2    LDM  R60,R50          ;
         JSB  =INTORL          ;
         STM  R60,R50          ;
         CLE                   ;
         RTN                   ;

CASE34   CMB  R44,=377         ;
         RNC
         LDM  R60,R40          ;
         JSB  =INTORL          ;
         STM  R60,R40          ;
         CLE                   ;
         RTN                   ;

INTORL   BCD                   ;
         CLM  R36              ;
         STM  R36,R62          ;
         CLB  R64              ;
         TSB  R67              ;
         JPS  INTOR1
         TCM  R65              ;
         LDB  R37,=9C
INTOR1   TSM  R65              ;
         JZR  INTORX
         LDB  R36,=5C           ;
INTOR2   TSB  R67              ;
         JLN  INTORX
         LLM  R65              ;
         DCB  R36              ;
         JMP  INTOR2
INTORX   STM  R36,R60          ;
         RTN                   ;
       TITLE 'krtim'
LASTLN EQU 0A999H
TMRVAL EQU 0AH
TMRINT EQU 3H
TMVRLN EQU 01BH
TMRBSY EQU 11H
TMRNMB ADDR 850EH
TMRFLG ADDR 8510H
*
*  __________________________________________________________________
* |KXTIM 493 09/27/82 - 12/ 7/1982 3:45PM                            |
* |==================================================================|
* ||                                                                ||
* ||   @@     @@@  @@      @@  @@@@@@@@@@  @@@@@@@@@@  @@      @@   ||
* ||   @@    @@@   @@      @@  @@@@@@@@@@  @@@@@@@@@@  @@@    @@@   ||
* ||   @@   @@@    @@@    @@@      @@          @@      @@@@  @@@@   ||
* ||   @@  @@@      @@@  @@@       @@          @@      @@@@@@@@@@   ||
* ||   @@ @@@         @@@@         @@          @@      @@  @@  @@   ||
* ||   @@@@@           @@          @@          @@      @@  @@  @@   ||
* ||   @@@@@           @@          @@          @@      @@      @@   ||
* ||   @@ @@@         @@@@         @@          @@      @@      @@   ||
* ||   @@  @@@      @@@  @@@       @@          @@      @@      @@   ||
* ||   @@   @@@    @@@    @@@      @@          @@      @@      @@   ||
* ||   @@    @@@   @@      @@      @@      @@@@@@@@@@  @@      @@   ||
* ||   @@     @@@  @@      @@      @@      @@@@@@@@@@  @@      @@   ||
* ||                                                                ||
* ||       Finished 06/01/82  Raan  Last edited: 821207.1543        ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
TMEFAC   DATA 1638400000000004C
*
MVBYTS   POBD R24,+R20         ;
         LOOP
           POBD R25,+R20         ;
           PUBD R25,+R22         ;
           DCB  R24              ;
         WHNZ
         RTN                   ;
*
OFFTMR   JSB  =NOCLC!          ;
         JSB  =GET1N           ;
         RTN                   ;

*
ONTMR    JSB  =NOCLC!          ;
         STB  R14,R36          ;
         JSB  =NUMVA+          ;
         IFEN
           CMB  R14,=COMMA
           IFZR
             JSB  =NUMVA+          ;
             IFEN
               PUBD R36,+R12         ;
               LDB  R36,=9DH
               PUBD R36,+R12         ;
               GTO PRSE!!            ;
             ENDIF
           ENDIF
         ENDIF
         JSBN  =ERROR+          ;
         DATA  89D
*
         DATA 341              ;
TMRON.   JSB  =MELJSB          ;
           DEF ONE7+B
         TSB  R17              ;
         RNG
         CLM  R51              ;
         LDB  R52,=8H
         CMM  R51,R41          ;
         IFNC
           LDM  R51,R41          ;
         ENDIF
         STMD R51,=TMRBUF      ;
         LDMD R40,=RTC         ;
         CLM  R46              ;
         ADM  R51,R41          ;
         STMD R51,=(TMRBUF)+7D
         JSB  =TM#GET          ;
         REZ
         CLB  R46              ;
         STBD R46,=(TMRBUF)+14D
         LDMD R46,=PCR         ;
         SBMD R46,=RNFILE      ;
         STMD R46,=(TMRBUF)+15D
         LDM  R46,R10          ;
         SBMD R46,=RNFILE      ;
         STMD R46,=(TMRBUF)+17D
         LDMD R40,=RNNAME      ;
         STMD R40,=(TMRBUF)+19D
         LDM  R40,=
TMRFLE   DATA  "timers  "       ;
         LDM  R34,=TMRBUF      ;
         LDM  R32,=(TMVRLN).2
         JSB  =FREPLS          ;
         REN
         JSB  =FNDTMR
         GTO END.ON            ;

TM#GET   BCD                   ;
         JSB  =ONEI            ;
         STE
         LDM  R76,R45          ;
         CMM  R45,=1C,10C,0C
         IFNC
           BIN                   ;
           RTN                   ;
         ENDIF
         JSBN  =ERROR+          ;
           DATA 11D

TMRGO    LDMD R50,=RTC         ;
         CLM  R56              ;
         SBMD R51,=TMRRTC      ;
         JMP  ADJTMR           ;

TMRRLV   TCM  R51              ;
         LDMD R41,=TMRRTC      ;
         ADM  R41,R51          ;
         STMD R41,=TMRRTC      ;

ADJTMR   JSB  =TMROPN          ;
         REN
         LOOP
           JSB  =TMRSUB
           JCY  FNDTMR
           ADM  R41,R51          ;
           IFZR
             ICM  R41              ;
           ENDIF
           STMD R41,R26          ;
           JSB  =SKPLN           ;
         WHMP

TMRDNE   JSB  =TMROPN          ;
         JSB  =FSEEK           ;
         REN
         CLB  R30              ;
         STBD R30,X36,TMRBSY
         RTN                   ;

TMROPN   LDMD R40,=TMRFLE
         JSB  =FLOPEN          ;
         RTN                   ;

TMRSUB   LDMD R76,R36          ;
         CMM  R76,=(LASTLN).2
         IFNC
           LDM  R26,R36          ;
           ADM  R26,=(TMRVAL).2
           LDMD R41,R26          ;
         ENDIF
         RTN                   ;

         DATA  241
TMROF.   JSB  =TM#GET          ;
         REZ
         LDMD R40,=TMRFLE
         JSB  =FDELLN          ;

FNDTMR   JSB  =TMROPN          ;
         JEN  TMRKIL
         CLM  R51              ;
         NCM  R51              ;
         LOOP
           JSB  =TMRSUB
           JCY  FNDTM?
           CMM  R41,R51          ;
           IFNC
             STM  R41,R51          ;
             STMD R76,=TMRNMB
           ENDIF
           JSB  =SKPLN           ;
         WHMP
FNDTM?   ICM  R51              ;
         JZR  TMRKIL
         DCM  R51              ;
         STM  R51,R41          ;
TMRLD    LDB  R40,=34          ;
         JSB  =CMPENT          ;
         RTN                   ;

TMRKIL   LDMD R40,=TMRFLE
         JSB  =FPURGE          ;
         CLM  R40              ;
         STMD R46,=TMRNMB
         JMP  TMRLD

TMRSS    CLM  R40              ;
         JSB  =TMRLD
         LDMD R40,=RTC         ;
         CLM  R46              ;
         STMD R41,=TMRRTC      ;

         DATA 44
TMRCLR   CLB  R#               ;
         STBD R#,=TMRFLG      ;
         RTN                   ;

TMTRIG   JSB  =TMROPN          ;
         REN
         LDMD R76,=TMRNMB
         STM  R76,R34          ;
         JSB  =FSEEK           ;
         ADM  R36,=(TMRINT).2      ;
         POMD R41,+R36         ;
         ADMD R41,R36          ;
         PUMD R41,+R36         ;
         CLB  R20              ;
         POBD R21,+R36         ;
         IFZR
           LDM  R26,R36          ;
           POMD R22,+R36         ;
           POMD R24,+R36         ;
           POMD R40,+R36         ;
           CMMD R40,=RNNAME      ;
           IFZR
             LDB  R20,=1           ;
             PUBD R20,-R26         ;
           ENDIF
         ENDIF
         LDM  R64,R22          ;
         JSB  =FNDTMR
         REN
         TSB  R20              ;
         RZR
         LDM  R36,R10          ;
         JSB  =SUBSTF          ;
         REN
         JSB  =RUNROM          ;
         STM  R64,R22          ;
         ADMD R24,=RNFILE      ;
         STM  R24,R10          ;
         ADMD R22,=RNFILE      ;
         JSB  =TRJUMP          ;
         LDB  R2,=1            ;
         STBD R2,=TMRFLG       ;
         RTN                   ;
       TITLE 'krerp'
*
*  __________________________________________________________________
* |KRERP 155 06/24/82 - 7/ 6/1982 3:42PM                             |
* |==================================================================|
* ||                                                                ||
* ||   @@     @@@  @@@@@@@@    @@@@@@@@@@  @@@@@@@@    @@@@@@@@     ||
* ||   @@    @@@   @@@@@@@@@   @@@@@@@@@@  @@@@@@@@@   @@@@@@@@@    ||
* ||   @@   @@@    @@     @@@  @@          @@     @@@  @@     @@@   ||
* ||   @@  @@@     @@      @@  @@          @@      @@  @@      @@   ||
* ||   @@ @@@      @@     @@   @@          @@     @@   @@     @@@   ||
* ||   @@@@@       @@@@@@@     @@@@@@@@@   @@@@@@@     @@@@@@@@@    ||
* ||   @@@@@       @@@@@@@     @@@@@@@@@   @@@@@@@     @@@@@@@@     ||
* ||   @@ @@@      @@    @@@   @@          @@    @@@   @@           ||
* ||   @@  @@@     @@     @@@  @@          @@     @@@  @@           ||
* ||   @@   @@@    @@      @@  @@          @@      @@  @@           ||
* ||   @@    @@@   @@      @@  @@@@@@@@@@  @@      @@  @@           ||
* ||   @@     @@@  @@      @@  @@@@@@@@@@  @@      @@  @@           ||
* ||                                                                ||
* ||                  Last editon on: 820908.1355                   ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
BLIMP    JSB  =SET             ;
         VAL  BLANK            ;
         DEF  INPBUF
         DEF  (INPBUF)+95D
NULOLD   LDM  R2,=((INPBUF)-1).2     ;
         STMD R2,=OLDLST       ;
         RTN                   ;

GETTEM   LDM  R2,R44           ;
         STMD R2,=INPCHK       ;
         LDM  R2,R46           ;
         JSB  =GETTER          ;
         LDM  R2,=RETURN       ;
         STMD R2,=INPCHK       ;
         CMB  R25,=CLRKEY
         REQ
         CMB  R25,=CR
         IFNE
           DRP  R6
         ENDIF
         TSM  R#
         RTN

GETTER   BIN
         PUMD R40,+R6
         CLM  R40
         POBD R40,+R2
         IFNG
           NCM  R40
         ENDIF
         POMD R42,+R2          ;
         STMD R42,=SHIELD      ;
         POMD R42,+R2          ;
         STMD R42,=(SHIELD)+6
         LDM  R46,=SHIELD      ;
         CLM  R2               ;
         LDB  R2,R40           ;
         ADM  R46,R2           ;
         LOOP
           PUBD R41,+R46         ;
           CMM  R46,=((SHIELD)+12D).2
         WHNC
         POMD R40,-R6          ;

GETREP   JSB  =REPORT          ;
         JSB  =GETLN           ;
         JSB  =REPORT          ;
         PUMD R42,+R6          ;
         CLM  R42              ;
         STMD R42,=SHIELD      ;
         STMD R42,=(SHIELD)+6D
         POMD R42,-R6          ;
         RTN                   ;

GET.IN   LDM  R20,=INPBUF      ;
         STM  R20,R22          ;
         CLB  R24              ;
         JMP  GETREP           ;
 
EROUT-   JSB  =MSGOUT          ;
         JSB  =BLEBUF          ;
         JSB  =EVIL            ;
         DEF  S30-31
         POBD R30,-R26          ;
         POBD R2,+R26          ;
         LDM  R2,=ERRBUF       ;
krerp_l1 DCB  R30              ;
         RNC
         POBD R31,+R26         ;
         PUBD R31,+R2          ;
         JMP  krerp_l1
       TITLE 'krdss'
*
*  __________________________________________________________________
* |MJDSS 136 07/14/82 - 7/20/1982 6:18PM                             |
* |==================================================================|
* ||                                                                ||
* ||   @@      @@    @@@@@@@@  @@@@@@        @@@@@@      @@@@@@     ||
* ||   @@@    @@@    @@@@@@@@  @@@@@@@@     @@@@@@@@    @@@@@@@@    ||
* ||   @@@@  @@@@        @@    @@    @@@   @@@    @@@  @@@    @@@   ||
* ||   @@@@@@@@@@        @@    @@      @@  @@      @@  @@      @@   ||
* ||   @@  @@  @@        @@    @@      @@  @@@         @@@          ||
* ||   @@  @@  @@        @@    @@      @@   @@@@@@@     @@@@@@@     ||
* ||   @@      @@        @@    @@      @@    @@@@@@@     @@@@@@@    ||
* ||   @@      @@        @@    @@      @@         @@@         @@@   ||
* ||   @@      @@  @@    @@    @@      @@  @@      @@  @@      @@   ||
* ||   @@      @@  @@@  @@@    @@    @@@   @@@     @@  @@@     @@   ||
* ||   @@      @@   @@@@@@     @@@@@@@@     @@@@@@@@    @@@@@@@@    ||
* ||   @@      @@    @@@@      @@@@@@        @@@@@@      @@@@@@     ||
* ||                                                                ||
* ||                  Last editon on: 820908.1353                   ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
KEYTRM   LDB  R3,=0FFH        ;
         JMP  krdss_l1
KEYDSP   CLB  R3
krdss_l1 DRP  !3
         PUBD R3,+R6           ;
         LDBD R3,=PLSTAT       ;
         JOD  POP3
         ANM  R3,=((BIT#4)|(BIT#3)).1
         JZR  POP3
         CMB  R3,=(BIT#4)|(BIT#3)
         IFNE
           JSB  =DSPSET          ;
         ENDIF
         POBD R3,-R6           ;
         PUMD R50,+R6          ;
         LDM  R50,R30          ;
         PUMD R50,+R6          ;
         JSB  =DOKEYS
         POMD R50,-R6          ;
         STM  R50,R30          ;
POP3     POMD R#,-R6          ;
         RTN                   ;

DOKEYS   TSB  R3               ;
         JZR  KEY2
         LDMD R34,=LASTCH      ;
         SBMD R34,=INPTR       ;
krdss_l2 RNG
         JSB  =MOVRT
         DCB  R34              ;
         JMP  krdss_l2

KEY2     DRP  !3
         LDBD R3,=ESC?        ;
         JZR  KEY4
         CLB  R3               ;
         STBD R3,=ESC?        ;
         CMB  R32,="P"
         JNZ  DO.ESC

         LDMD R30,=INPTR       ;
         LDMD R36,=LASTCH      ;
         SBM  R36,R30          ;
         DCM  R36              ;
         JNG  BLANK1
         JSB  =FAST
         LDB  R57,=40          ;
         JSB  =DATREP          ;
         JEN  C.ON
MOVCUR   JSB  =FINDPS
C.ON     LDB  R32,='>'

DO.ESC   LDB  R57,=ESC
         JSB  =DATREP          ;
         REN
SENDAT   LDB  R57,R32          ;
SENDD    GTO DATREP            ;

SENDBS   LDB  R57,=8D
         JMP  SENDD

CURSOF   LDB  R32,="<"
         JMP  DO.ESC

MOVRT    LDB  R32,='C'
         JMP  DO.ESC

BLANK1   LDB  R57,=40          ;
         JSB  =DATREP          ;
         JEN  C.ON
         JSB  =SENDBS
         JMP  C.ON

KEY4     CMB  R32,=ESC
         JNZ  KEY6
         STBD R32,=ESC?        ;
         RTN                   ;

KEY6     DRP !32
         CMB  R32,=8D
         JZR  SENDAT

         LDBD R30,=I/RFLG      ;
         JZR  SENDAT

         LDMD R30,=INPTR       ;
         DCM  R30              ;
         LDMD R36,=LASTCH      ;
         SBM  R36,R30          ;
         JSB  =FAST
         JMP  MOVCUR

FAST     JSB  =CURSOF
FASTIO   LDB  R57,=1           ;
         STBD R57,=FAST!       ;
         POBD R57,+R30         ;
         JSB  =DATREP          ;
         CLB  R2               ;
         STBD R2,=FAST!        ;
         RTN                   ;

FINDPS   LDMD R30,=LASTCH      ;
         SBMD R30,=INPTR       ;
krdss_l3 RNG
         JSB  =SENDBS
         REN
         DCB  R30              ;
         JMP  krdss_l3
       TITLE 'krinp'
*
*  __________________________________________________________________
* |KXINP 235 08/31/82 - 9/ 9/1982 7:24AM                             |
* |==================================================================|
* ||                                                                ||
* ||   @@     @@@  @@      @@  @@@@@@@@@@  @@      @@  @@@@@@@@     ||
* ||   @@    @@@   @@      @@  @@@@@@@@@@  @@      @@  @@@@@@@@@    ||
* ||   @@   @@@    @@@    @@@      @@      @@@     @@  @@     @@@   ||
* ||   @@  @@@      @@@  @@@       @@      @@@@    @@  @@      @@   ||
* ||   @@ @@@         @@@@         @@      @@ @@   @@  @@     @@@   ||
* ||   @@@@@           @@          @@      @@  @@  @@  @@@@@@@@@    ||
* ||   @@@@@           @@          @@      @@  @@  @@  @@@@@@@@     ||
* ||   @@ @@@         @@@@         @@      @@   @@ @@  @@           ||
* ||   @@  @@@      @@@  @@@       @@      @@    @@@@  @@           ||
* ||   @@   @@@    @@@    @@@      @@      @@     @@@  @@           ||
* ||   @@    @@@   @@      @@  @@@@@@@@@@  @@      @@  @@           ||
* ||   @@     @@@  @@      @@  @@@@@@@@@@  @@      @@  @@           ||
* ||                                                                ||
* ||                  Last editon on: 820909.0723                   ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
         DATA  237
INPUT.   LDM  R26,=INPBUF      ;
         STMD R26,=INPR10      ;
         LDM  R26,=QMARK       ;
         CLM  R36              ;
         ICM  R36              ;
         CLM  R30              ;
         JSB  =ONR12?          ;
         DRP  !2
         ARP  !12
         IFNZ
           CMB  R2,=(STRSIZ)*2
           IFEQ
             DRP  R20              ;
             JSB  =GETAD#          ;
             ARP  !12
             POMD R30,-R12         ;
           ENDIF
           DRP  R26              ;
           JSB  =GETAD#          ;
           ARP  !12
           POMD R36,-R12          ;
         ENDIF
         LDBD R2,=GL.LEN       ;
         IFZR
           LDM  R2,R30           ;
           ADM  R2,R36           ;
           CMM  R2,=(95D).2
           JCY  ERR56
           STBD R30,=GL.LEN      ;
           LDM  R22,=INPBUF      ;
krinp_l1   DCB  R30              ;
           JNC  krinp_l2
           POBD R2,+R20          ;
           PUBD R2,+R22          ;
           JMP  krinp_l1
krinp_l2
         ENDIF
         JSB  =SYSJSB          ;
         DEF DISP.
         LDB  R20,=1           ;
         JSB  =PRNFMT          ;
         STBD R20,=NOCHEK      ;
         JSB  =GETALN          ;
         CLB  R2               ;
         STBD R2,=NOCHEK       ;
         CMB  R25,=ATTNKY
         IFEQ
           JSB  =RESTRT          ;
           JSB  =STALLS          ;
         ENDIF
         JSB  =MODE?           ;
         IFEN
           JSB  =RESTRT          ;
           JSB  =STALLS          ;
           LDB  R2,R25           ;
           JSB  =PUTKEY          ;
         ENDIF
         RTN                   ;
ERR56    JSB  =ERROR+          ;
         DATA  42D

CHKEOL   LDBD R2,R10           ;
         CMB  R2,=TAILTK
         DRP  R14              ;
         IFEQ
           CMB  R14,=CR          ;
           JNE  ER44
         ELSE
           CMB  R14,=','        ;
           JNE  ER81
         ENDIF
         CLE                   ;
         RTN                   ;

         DATA  44

INPUN.   PUMD R10,+R6          ;
         JSB  =ISETUP          ;
         PUMD R12,+R6          ;
         JSB  =SFSCAN          ;
         JSB  =SYSJSB          ;
         DEF  NUMREP
         POMD R40,-R12          ;
         POMD R12,-R6          ;
         JSB  =BCKSTO          ;
         DRP  !10
         ARP  !6
         POMD R10,-R6           ;
         JEZ  ER43             ;
         JSB  =CHKEOL          ;
         REN
         CMB  R44,=INTTK
         IFEQ
           LDB  R44,=377         ;
         ENDIF
         PUMD R40,+R12         ;
         JSB  =STOSV           ;
         RTN                   ;

NO.STR   POMD R12,-R6          ;
         JSB  =ERROR           ;
         DATA 82D
ER43     JSB  =ERROR           ;
         DATA 43D
ER44     JSB  =ERROR           ;
         DATA 44D
ER81     JSB  =ERROR           ;
         DATA 81D

HADERR   LDMD R0,=FWVARS       ;
         LDMD R2,X0,E.EREX
         JZR  krinp_l3
         IFNG
krinp_l3   LDMD R30,=INPR10      ;
           JSB  =REPRP#          ;
           JSB  =RESTRT          ;
           PUMD R10,+R6          ;
           JSB  =REPORT          ;
           POMD R10,-R6          ;
         ENDIF
         JSB  =REPORT          ;
         STE
         RTN                   ;

         DATA 44

INPU$.   PUMD R12,+R6          ;
         PUMD R10,+R6          ;
         JSB  =ISETUP          ;
         DRP  R20              ;
         JSB  =QUIP?           ;
         IFNE
           JSB  =BACK10          ;
           JSB  =SYSJSB          ;
           DEF UNQUOT
         ELSE
           JSB  =SYSJSB          ;
           DEF STRCN+
         ENDIF
         JSB  =BCKSTO          ;
         DRP  !10
         ARP  !6
         POMD R10,-R6
         JEZ  NO.STR
         JSB  =CHKEOL          ;
         POMD R26,-R6          ;
         REN
         PUMD R26,+R6          ;
         CLM  R70              ;
         POBD R70,+R26         ;
         POBD R70,+R26         ;
         STM  R26,R72          ;
         JSB  =CONCA-          ;
         POMD R44,-R12         ;
         POMD R12,-R6          ;
         PUMD R44,+R12         ;
         JSB  =STOST           ;
         LDBD R2,=ERRORS       ;
         JNZ  HADERR
         RTN                   ;

BCKSTO   JSB  =BACK10          ;
         STMD R10,=INPR10      ;
         ARP  R6               ;
         RTN                   ;

RESTRT   LDMD R10,=PCR         ;
         BIN                   ;
         ADM  R10,=(THREE).2
         LDMD R12,=TOS         ;
         STE
         RTN                   ;

ISETUP   BIN                   ;
         LDMD R10,=INPR10      ;
         JSB  =GCHAR           ;
         RTN                   ;

         DATA  44              ;
ITAIL.   RTN                   ;
       TITLE 'krann'
*
*  __________________________________________________________________
* |IVANN 49 05/10/82 - 5/13/1982 2:53PM                              |
* |==================================================================|
* ||                                                                ||
* ||   @@@@@@@@@@  @@      @@    @@@@@@    @@      @@  @@      @@   ||
* ||   @@@@@@@@@@  @@      @@   @@@@@@@@   @@      @@  @@      @@   ||
* ||       @@      @@      @@  @@@    @@@  @@@     @@  @@@     @@   ||
* ||       @@      @@      @@  @@      @@  @@@@    @@  @@@@    @@   ||
* ||       @@       @@    @@   @@      @@  @@ @@   @@  @@ @@   @@   ||
* ||       @@       @@    @@   @@@@@@@@@@  @@  @@  @@  @@  @@  @@   ||
* ||       @@       @@    @@   @@@@@@@@@@  @@  @@  @@  @@  @@  @@   ||
* ||       @@        @@  @@    @@      @@  @@   @@ @@  @@   @@ @@   ||
* ||       @@         @@@@     @@      @@  @@    @@@@  @@    @@@@   ||
* ||       @@         @@@@     @@      @@  @@     @@@  @@     @@@   ||
* ||   @@@@@@@@@@      @@      @@      @@  @@      @@  @@      @@   ||
* ||   @@@@@@@@@@      @@      @@      @@  @@      @@  @@      @@   ||
* ||                                                                ||
* ||                  Last editon on: 820908.1349                   ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
ANNUNS   CLB  R2               ;
         JMP  SET_ANN

ANN.B+   LDB  R2,=BIT#3
         JMP  SET_ANN

ANN.B-   LDB  R2,=NOT#3
         JMP  CLR

ANN.E+   LDB  R2,=BIT#2           ;
         JMP  SET_ANN

ANN.E-   JSB  =BLEBUF          ;
         LDB  R2,=NOT#2
         JMP  CLR

PGMANN   CMB  R16,=RUNSTS
         RNE
ANN.P+   LDB  R2,=BIT#1
         JMP  SET_ANN

ANN.P-   LDB  R2,=NOT#1
         JMP  CLR

ANN.A+   LDB  R2,=1          ;
SET_ANN  LDBD R3,=ANNFLG       ;
         ORB  R3,R2            ;
         JMP  krann_l1

ANN.A-   LDB  R2,=NOT#0
CLR      LDBD R3,=ANNFLG       ;
         ANM  R3,R2            ;
krann_l1 SAD                   ;
         BIN                   ;
         STBD R#,=ANNFLG       ;
         PUMD R20,+R6          ;
         JSB  =GANCHR
         LDB  R20,=ANN.R
         JSB  =TOLCD           ;
         LRB  R3               ;
         LRB  R3               ;
         JSB  =GANCHR
         LDB  R20,=ANN.L
         JSB  =TOLCD           ;
         POMD R#,-R6           ;
         JSB  =CURSE?          ;
         PAD                   ;
         RTN                   ;

GANCHR   LDB  R20,R3           ;
         ANM  R20,=11B,0
         PUMD R2,+R6           ;
         LDBD R21,X20,ANNCHR
         POMD R2,-R6           ;
         RTN                   ;
ANNCHR   DATA  ' qp_'
       TITLE 'krfet'
*
*  __________________________________________________________________
* |RHFET 175 04/02/82 - 4/20/1982 8:19PM                             |
* |==================================================================|
* ||                                                                ||
* ||   @@@@@@@@    @@      @@  @@@@@@@@@@  @@@@@@@@@@  @@@@@@@@@@   ||
* ||   @@@@@@@@@   @@      @@  @@@@@@@@@@  @@@@@@@@@@  @@@@@@@@@@   ||
* ||   @@     @@@  @@      @@  @@          @@              @@       ||
* ||   @@      @@  @@      @@  @@          @@              @@       ||
* ||   @@     @@   @@      @@  @@          @@              @@       ||
* ||   @@@@@@@     @@@@@@@@@@  @@@@@@@@@   @@@@@@@@@       @@       ||
* ||   @@@@@@@     @@@@@@@@@@  @@@@@@@@@   @@@@@@@@@       @@       ||
* ||   @@    @@@   @@      @@  @@          @@              @@       ||
* ||   @@     @@@  @@      @@  @@          @@              @@       ||
* ||   @@      @@  @@      @@  @@          @@              @@       ||
* ||   @@      @@  @@      @@  @@          @@@@@@@@@@      @@       ||
* ||   @@      @@  @@      @@  @@          @@@@@@@@@@      @@       ||
* ||                                                                ||
* ||                  Last editon on: 820908.1328                   ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
         VAL  PGMRSW
FETCH.   JSB  =INITGL          ;
         CLM  R76              ;
         DCM  R76              ;
         STMD R76,=ENLIN#
         LDMD R76,=CURLN#      ;
         JSB  =ONR12?          ;
         JEZ  NOPARM
         ICM  R76              ;
         CMM  R2,=(STRSIZ).2
         JEQ  FETSTR

         JSB  =ONEI            ;
         LDM  R76,R45          ;
         JSB  =ONR12?          ;
         JEN  FETSTR

NOPARM   JSB  =EDLIN#          ;
         JMP  FETRTN

EDLIN#   STMD R76,=CURLN#      ;
EDLIN-   JSB  =FNDLED          ;
         IFEZ
           JSB  =OUTLIN
           RTN                   ;
         ENDIF
         LDM  R36,R76          ;
         LDM  R30,=INPBUF      ;
         JSB  =DCLIN#          ;
         BIN                   ;
         STMD R30,=GL.CUR      ;
         SBM  R30,=INPBUF      ;
         STBD R30,=GL.LEN      ;
         RTN                   ;

FETSTR   JSB  =NULOLD          ;
         JSB  =FNDLED          ;
         LDM  R24,R36          ;
         DRP  R46              ;
         JSB  =GETAD#          ;
         ARP  !12
         POMD R0,-R12          ;
         STM  R0,R44           ;
         LDMD R0,=EDFILE       ;
         STMD R0,=PRFILE       ;
         LDBD R67,=EDTYPE      ;
POSLUP
         PUMD R44,+R6          ;
         JSB  =HALT?           ;
         POMD R44,-R6          ;
         REN

         LDM  R36,R44          ;
         LDM  R34,R46          ;
         LDM  R32,R54          ;
         LDM  R30,R26          ;
         JSB  =POSRUN          ;
         JZR  POSLUP
         LDM  R36,R64          ;
         STMD R36,=CURLN#      ;

         DCM  R2               ;
         STMD R2,=GL.CUR       ;
         STBD R54,=GL.LEN      ;

FETRTN   JSB  =UNAUTO          ;
         RTN                   ;

LINEDR   JSB  =EDIT?
         JEN  LINEX            ;

         LDMD R34,=STSIZE      ;
         POMD R76,-R34         ;
         PUMD R76,+R34         ;
         POBD R2,+R34          ;
         LDMD R2,=PRFILE       ;
         CMMD R2,=EDFILE       ;
         IFEQ
           STMD R76,=CURLN#      ;
         ENDIF
         JSB  =FNDLPR          ;
         TSM  R32              ;
         IFZR
           IFEZ
             JSB  =DELLIN          ;
             CMB  R16,=1           ;
             IFEQ
               LDM  R0,=LEWYSZ
               STMD R0,=LEEWAY       ;
             ENDIF
           ENDIF
         ELSE
           CMB  R16,=CLCSTS
           IFEQ
             LDM  R0,=LEWYSZ
             SBM  R0,R32           ;
             SBM  R0,=(3D).2
             STMD R0,=LEEWAY       ;
           ENDIF
           JSB  =REPLIN          ;
         ENDIF
LINEX    JSB  =SETR12          ;
         RTN                   ;

EDIT?    LDMD R40,=PRNAME      ;
         LDB  R14,=TYEDT?
         JSB  =FOPAC?          ;
         JNE  NOEDIT
         PUBD R16,+R6          ;
         JSB  =SAFE!           ;
         JSB  =REMDAC          ;
         POBD R16,-R6          ;
         CLB  R17              ;
         CLE                   ;
         RTN                   ;

NOEDIT   JSB  =ERR1+           ;
         DATA  68D

EOL14?   DRP  R14              ;
CREOL?   BIN                   ;
         CLE                   ;
         CMB  R#,=EOLTOK
         JZR  TSTRTN

         CMB  R#,=CRTNTK
         JZR  TSTRTN

         CMB  R#,=ATTOK
         JZR  TSTRTN

         CMB  R#,=BANGTK
         JZR  TSTRTN

         CMB  R#,=ELSTOK
         JZR  TSTRTN           ;
         ICE                   ;

TSTRTN   RTN                   ;
       TITLE 'krpdq'
*
*  __________________________________________________________________
* |MJPDQ 360 07/14/82 - 7/20/1982 11:38AM                            |
* |==================================================================|
* ||                                                                ||
* ||   @@      @@    @@@@@@@@  @@@@@@@@    @@@@@@        @@@@@@     ||
* ||   @@@    @@@    @@@@@@@@  @@@@@@@@@   @@@@@@@@     @@@@@@@@    ||
* ||   @@@@  @@@@        @@    @@     @@@  @@    @@@   @@@    @@@   ||
* ||   @@@@@@@@@@        @@    @@      @@  @@      @@  @@      @@   ||
* ||   @@  @@  @@        @@    @@     @@@  @@      @@  @@      @@   ||
* ||   @@  @@  @@        @@    @@@@@@@@@   @@      @@  @@      @@   ||
* ||   @@      @@        @@    @@@@@@@@    @@      @@  @@  @@  @@   ||
* ||   @@      @@        @@    @@          @@      @@  @@  @@  @@   ||
* ||   @@      @@  @@    @@    @@          @@      @@  @@   @@@     ||
* ||   @@      @@  @@@  @@@    @@          @@    @@@   @@    @@@    ||
* ||   @@      @@   @@@@@@     @@          @@@@@@@@     @@@@@  @@   ||
* ||   @@      @@    @@@@      @@          @@@@@@        @@@   @@   ||
* ||                                                                ||
* ||                  Last editon on: 820813.1414                   ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
PRNTCH   LDMD R3,=PLSTAT       ;
         JEV  LOOPON
TOLCD_PDQ    
         GTO OUTCHR            ;

LOOPON   LRB  R3               ;
         JOD  SENDIT
         LRB  R3               ;
         JEV  TOLCD_PDQ
         JSB  =PRSET
SENDIT   PUMD R55,+R6          ;
         LDM  R57,R32          ;
         JSB  =DATREP          ;
         POMD R55,-R6          ;
         RTN                   ;

PR.EOL   PUMD R32,+R6          ;
         PUMD R30,+R6          ;
         LDM  R30,=EOL         ;
         LDBD R33,=EOLLEN      ;
krpdq_l1 DCB  R33              ;
         JNG  krpdq_l2
         POBD R32,+R30         ;
         JSB  =PRNTCH          ;
         JMP  krpdq_l1
krpdq_l2 POMD R30,-R6          ;
         POMD R32,-R6          ;
         RTN                   ;

PRSET    JSB  =EVIL            ;
         DEF  S30-57
         LDM  R32,=
         DATA BIT#7
         DATA BIT#1
         JMP  SET_PDQ

DSPSET   JSB  =EVIL            ;
         DEF  S30-57
         LDM  R32,=
         DATA BIT#0
         DATA BIT#3

SET_PDQ  LDBD R2,=PLSTAT       ;
         ROD
         JSB  =UNLREP          ;
         REN
         JSB  =THERE!          ;
         JSB  =LADDEV          ;
         REN
         LDMD R3,=PLSTAT       ;
         ORB  R3,R33           ;
         STMD R3,=PLSTAT       ;
         RTN                   ;

PILREP   JSB  =EVIL            ;
         DEF  S20-77
         DCE
         IFEZ
           JSB  =UNLSND          ;
           JSB  =ERR1+           ;
           DATA 57D
         ENDIF
         DCE                   ;
         IFEZ
           JSB  =ERROR           ;
           DATA  58D
         ENDIF
         ICE                   ;
         ICE                   ;
         RTN                   ;

LADDEV   CLE                   ;
         JSB  =CHKEND          ;
krpqd_l3 RZR
         LDBD R3,X36,SETUP
         ANM  R3,R32           ;
         IFNZ
           JSB  =LADREP          ;
           REN
         ENDIF
         JSB  =SKPCHK          ;
         JMP  krpqd_l3
       TITLE 'krser'
*
*  __________________________________________________________________
* |IVSER 476 5/10/82 - 5/13/1982 4:09PM                              |
* |==================================================================|
* ||                                                                ||
* ||   @@@@@@@@@@  @@      @@    @@@@@@    @@@@@@@@@@  @@@@@@@@     ||
* ||   @@@@@@@@@@  @@      @@   @@@@@@@@   @@@@@@@@@@  @@@@@@@@@    ||
* ||       @@      @@      @@  @@@    @@@  @@          @@     @@@   ||
* ||       @@      @@      @@  @@      @@  @@          @@      @@   ||
* ||       @@       @@    @@   @@@         @@          @@     @@    ||
* ||       @@       @@    @@    @@@@@@@    @@@@@@@@@   @@@@@@@      ||
* ||       @@       @@    @@     @@@@@@@   @@@@@@@@@   @@@@@@@      ||
* ||       @@        @@  @@           @@@  @@          @@    @@@    ||
* ||       @@         @@@@     @@      @@  @@          @@     @@@   ||
* ||       @@         @@@@     @@@     @@  @@          @@      @@   ||
* ||   @@@@@@@@@@      @@       @@@@@@@@   @@@@@@@@@@  @@      @@   ||
* ||   @@@@@@@@@@      @@        @@@@@@    @@@@@@@@@@  @@      @@   ||
* ||                                                                ||
* ||                  Last editon on: 820908.1333                   ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
SPY      LDBD R3,=SVCWRD       ;
         RZR
         JSB  =STOP?           ;
         iFEN
           JSB  =DEQUE           ;
           JSB  =UNSEE           ;
           JSB  =STALLS          ;
         ENDIF
         LDBD R3,=SVCWRD       ;
         RZR
         JSB  =AWAKE!          ;
         LDBD R3,=SVCWRD       ;
         IFNG
           JSB  =CMPCHK          ;
         ENDIF
         LDBD R3,=SVCWRD       ;
         ANM  R3,=BIT#6
         IFNZ
           JSB  =ANN.B+          ;
           LDB  R2,=NOT#6
           JSB  =SVCCLR          ;
         ENDIF
         LDBD R3,=SVCWRD       ;
         ANM  R3,=BIT#1
         IFNZ
           JSB  =HANDI0          ;
             VAL V.SPY
           LDB  R2,=NOT#1
           JSB  =SVCCLR          ;
         ENDIF
         RTN                   ;
       TITLE 'krrsw'
*
*  __________________________________________________________________
* |KXRSW 457 09/27/82 - 9/30/1982 3:26PM                             |
* |==================================================================|
* ||                                                                ||
* ||   @@     @@@  @@      @@  @@@@@@@@      @@@@@@    @@      @@   ||
* ||   @@    @@@   @@      @@  @@@@@@@@@    @@@@@@@@   @@      @@   ||
* ||   @@   @@@    @@@    @@@  @@     @@@  @@@    @@@  @@      @@   ||
* ||   @@  @@@      @@@  @@@   @@      @@  @@      @@  @@      @@   ||
* ||   @@ @@@         @@@@     @@     @@   @@@         @@      @@   ||
* ||   @@@@@           @@      @@@@@@@      @@@@@@@    @@      @@   ||
* ||   @@@@@           @@      @@@@@@@       @@@@@@@   @@  @@  @@   ||
* ||   @@ @@@         @@@@     @@    @@@          @@@  @@  @@  @@   ||
* ||   @@  @@@      @@@  @@@   @@     @@@  @@      @@  @@@@@@@@@@   ||
* ||   @@   @@@    @@@    @@@  @@      @@  @@@     @@  @@@@  @@@@   ||
* ||   @@    @@@   @@      @@  @@      @@   @@@@@@@@   @@@    @@@   ||
* ||   @@     @@@  @@      @@  @@      @@    @@@@@@    @@      @@   ||
* ||                                                                ||
* ||                  Last editon on: 820930.1523                   ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
MELJSB   SAD                  ;
         SAD                  ;
         SAD                  ;
         BIN                  ;
         PUMD R0,+R6          ;
         LDM  R0,=MELSLT      ;
         JMP  krrsw_1

SYSJSB   SAD                  ;
         SAD                  ;
         SAD                  ;
         BIN                  ;
         PUMD R0,+R6          ;
         LDM  R0,=SYSSLT      ;
krrsw_1  DRP !0
         ARP !6
         STMD R0,=(PROTEM)+2
         PUMD R2,+R6          ;
         PUMD R44,+R6         ;
         LDM  R44,=(PROTEM).4
         LDM  R46,R6          ;
         SBM  R46,=(4+2+2+3+2+2+2+2).2
         LDMD R0,R46          ;
         POMD R2,+R0          ;
         PUMD R2,+R44         ;
         POMD R2,+R44         ;
         DRP  R0              ;
         JMP  INJSB

ROMJSB   SAD                  ;
         SAD                  ;
         SAD                  ;
         BIN                  ;
         PUMD R0,+R6          ;
         PUMD R2,+R6          ;
         PUMD R44,+R6         ;
         LDM  R46,R6          ;
         SBM  R46,=(4+2+2+3+2+2+2+2).2
         LDMD R0,R46          ;
         ADM  R0,=(2+2).2
         STM  R0,R44          ;
INJSB    DRP  !0
         SBMD R0,=ROMPTR      ;
         PUMD R0,+R46         ;
         JSB  =GETRID         ;
         DRP  !2
         ARP  !46
         PUMD R2,+R46

         LDM  R2,=(PASTCL).2
         PUMD R2,+R46          ;
         POMD R0,-R44         ;
         POMD R2,-R44         ;
         PUMD R2,+R46         ;
         CMM  R0,=0FF00H
         IFHS
           JSB  =UNROM          ;
           STBD R#,R0           ;
           STMD R0,=SLOT        ;
           JSB  =SETPTR
         ELSE
           JSB  =GETROM         ;
           DRP  R2              ;
           ARP  R46             ;
           IFNZ
             POMD R2,-R46         ;
             LDM  R2,=(ERR18).2
             PUMD R2,+R46         ;
           ENDIF
           POMD R2,-R46         ;
           IFNG
             CMM  R2,=TOPROM      ;
             IFLO
               ANM  R2,=7FFFH        ;
               ADMD R2,=ROMPTR      ;
             ENDIF
           ENDIF
           PUMD R2,+R46         ;
         ENDIF

         POMD R44,-R6         ;
         POMD R2,-R6          ;
         POMD R0,-R6          ;
         PAD                  ;
         RTN                  ;

PASTCL

FF00     ADDR  0FF00H

         SAD
         BIN                  ;
         PUMD R2,+R6          ;
         PUMD R0,+R6          ;
         LDMD R0,X6,(0-2-2-3-2).2
         JSB  =GETROM         ;
         LDM  R0,=RETURN      ;
         STMD R0,X6,(0-2-2-3-2).2
         LDMD R0,X6,(0-2-2-3-2-2).2
         ADMD R0,=ROMPTR      ;
         STMD R0,R2           ;
         POMD R0,-R6          ;
         POMD R2,-R6          ;
         PAD                  ;
         RTN                  ;

         DATA 241
RMERR.
ERR18    JSBN  =ERROR+         ;
         DATA 18D

         DATA 214
ROM:GO   JSB  =SAVEME         ;
         POMD R0,+R10         ;
         STMD R0,=((TOKEN)+1).2
         CLM  R43             ;
         POBD R43,+R10        ;
         STBD R43,=(TOKEN)+3
         JSB  =GETROM         ;
         JNZ  ERR18
         JSB  =GETRUN         ;
         LDM  R20,R36         ;
         BCD                  ;
         JSB  X20,ZRO         ;
         RTN                  ;

SAVEME   LDMI R0,=ROMPTR      ;
         POMD R2,-R6          ;
         PUMD R0,+R6          ;
         BIN                  ;
         JSB  X2,ZRO          ;
         POMD R0,-R6          ;
         JMP  GETROM          ;

RUNROM   LDMD R0,=FWVARS      ;
         LDMD R0,X0,E.ROM#
         JMP  GETROM          ;

GETRM2   LDM  R0,R22          ;

GETROM   BIN                  ;
         PUMD R20,+R6         ;
         CLM  R20             ;
LOOP     PUMD R0,+R6          ;
         JSB  =NXTKWF         ;
         JNZ  krrsw_2
         POMD R0,-R6          ;
         CMM  R0,R2           ;
         JNZ  LOOP

         POMD R20,-R6         ;
         CLB  R2              ;
         RTN                  ;

krrsw_2  POMD R0,-R6          ;
         POMD R20,-R6         ;
RTN.NZ   TSM  R6              ;
         RTN                  ;

NXTKWF   CMM  R20,=DIRECT
         JNG  NXTROM          ;
         TSM  R20             ;
         IFZR
           LDM  R20,=((DIRECT)-(DRENSZ)).2
         ENDIF
FILE?    ADM  R20,=(DRENSZ).2
         LDMD R2,R20          ;
         IFZR
           CLM  R20             ;
           JMP  NXTROM          ;
         ENDIF
         LDBD R2,X20,DR.TYP
         JEV  FILE?
         LDMD R2,R20         ;
         STMD R2,=ROMPTR     ;
         STMD R2,=ROMOFF     ;
         LDMD R2,R2          ;
         JMP  RTN.ZR

NXTROM   TSM  R20             ; IF M20=0
         IFZR
           LDM  R20,=ROMTAB     ;
         ENDIF
         JSB  =UNROM          ;
         POMD R2,+R20         ;
         IFZR
           JSB  =ROMRTN         ;
           JMP  RTN.NZ
         ENDIF
         DCM  R2              ;
         IFZR
           JSB  =ROMRTN         ;
         ELSE
           ICM  R2              ;
           STMD R2,=SLOT        ;
           STBD R2,R2           ;
 SETPTR    CLM  R2              ;
           STMD R2,=ROMOFF      ;
           LDMD R2,=((ROM)+2).2
           STMD R2,=ROMPTR      ;
           LDMD R2,R2           ;
           STMD R2,=ROMNUM      ;
         ENDIF
RTN.ZR   CMM  R2,R2           ;
         RTN                  ;

UNROM    LDM  R2,=0FF40H       ;
         ARP  R2
         LOOP 
           DRP  !2
           ARP  !2
           ICB  R2
           PUBD R2,+R2          ;
         WHRN
         RTN                  ;
GAP001   NOP

ROMSET
         LDM  R30,=ROMTAB     ;
         LDM  R20,=0FF30H
         LOOP
           JSB  =UNROM          ;
           CMB  R20,=46H
           JEQ  SKIPIT
           CMB  R20,=4EH
           JZR  SKIPIT
           JSB  =CHKADD
SKIPIT     ADB  R20,=2          ;
           CMB  R20,=60H
         WHNE
         CLM  R20             ;
         ICM  R20             ;
         JSB  =ADDROM
         LDM  R20,=SYSSLT     ;
         JSB  =ADDROM
         LDB  R20,=4EH
         JSB  =ADDROM

ROMRTN   JSB  =UNROM          ;
         DRP  !2
         LDMD R2,=BASLOC      ;
         STMD R2,=ROMPTR      ;
         LDM  R2,=SYSSLT
         STBD R2,R2           ;
         STMD R2,=SLOT        ;
         CLM  R2              ;
         STMD R2,=ROMNUM      ;
         STMD R2,=ROMOFF      ;
         RTN                  ;

CHKADD   STBD R#,R20          ;
         LDMD R2,=ROM         ;
         CMM  R2,=RMHEAD      ;
         RNE
ADDROM   PUMD R20,+R30        ;
         CLM  R2              ;
         STMD R2,R30          ;
         RTN                  ;

CYCLE    BIN                  ;
         POMD R2,-R6          ;
         POMD R0,+R2          ;
         PUMD R2,+R6          ;
         LDB  R2,=1           ;
         STBD R2,=HANDLD      ;
         CLM  R2              ;
         LOOP
           PUMD R20,+R6         ;
           LDM  R20,R2          ;
           PUMD R0,+R6          ;
           JSB  =NXTKWF         ;
           JNZ  NOMORE
           POMD R0,-R6          ;
           STM  R20,R2          ;
           POMD R20,-R6         ;
           PUMD R2,+R6          ;
           PUMD R0,+R6          ;
           JSB  X0,ZRO          ;
           LDBD R0,=HANDLD      ;
           JZR  POPPOP
           POMD R0,-R6          ;
           POMD R2,-R6          ;
         WHMP
NOMORE   DRP  R20
POPPOP   POMD R#,-R6         ;
         POMD R#,-R6         ;
         RTN                  ;
       TITLE 'krtr'
*
*  __________________________________________________________________
* |IVTR 520 05/10/82 - 5/13/1982 4:11PM                              |
* |==================================================================|
* ||                                                                ||
* ||         @@@@@@@@@@  @@      @@  @@@@@@@@@@  @@@@@@@@           ||
* ||         @@@@@@@@@@  @@      @@  @@@@@@@@@@  @@@@@@@@@          ||
* ||             @@      @@      @@      @@      @@     @@@         ||
* ||             @@      @@      @@      @@      @@      @@         ||
* ||             @@       @@    @@       @@      @@     @@          ||
* ||             @@       @@    @@       @@      @@@@@@@            ||
* ||             @@       @@    @@       @@      @@@@@@@            ||
* ||             @@        @@  @@        @@      @@    @@@          ||
* ||             @@         @@@@         @@      @@     @@@         ||
* ||             @@         @@@@         @@      @@      @@         ||
* ||         @@@@@@@@@@      @@          @@      @@      @@         ||
* ||         @@@@@@@@@@      @@          @@      @@      @@         ||
* ||                                                                ||
* ||                  Last editon on: 820908.1352                   ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
         DATA 241              ;
TRFLO.   LDB  R#,=BIT#7
         JMP  ORFLAG           ;

         DATA 241              ;
TROFF.   CLB  R#               ;
         JMP  STFLAG           ;

         DATA 241              ;
TRVAR.   LDB  R#,=1            ;
ORFLAG   LDBD R21,=TRFLAG      ;
         ORB  R21,R20          ;
STFLAG   STBD R#,=TRFLAG       ;
         RTN                   ;

TRCVBL   CMB  R16,=RUNSTS
         RNE
         JSB  =RNLST?          ;
         RZR
         PUMD R60,+R6          ;
         PUBD R46,+R6          ;
         JSB  =TRCFP           ;
         POBD R46,-R6          ;
         IFNG
           LDM  R36,R74          ;
           JSB  =BINCN
           DCB  R23              ;
           TSB  R20              ;
           IFEV
             LDM  R36,R76          ;
             JSB  =BINCN
           ENDIF
           BIN                   ;
           JSB  =SUBSCR          ;
         ENDIF
         POMD R50,-R6          ;
         PUMD R50,+R12         ;
         JSB  =ONER            ;
         BIN                   ;
         LDM  R22,=16,4
         PUMD R22,+R12         ;
         PUMD R40,+R12         ;
         JSB  =PU=             ;
TRCLP    POMD R36,-R12         ;
         STMD R36,=TOS         ;
         JMP  OUTERB           ;

TRCFP    CLB  R0               ;
         STBD R0,=PRECNT       ;
         PUMD R36,+R6          ;
         JSB  =TRCHED          ;

         LDMD R36,=TOS         ;
         PUMD R36,+R12         ;
         LDM  R36,=((ERRBUF)+(EBFLEN)+1).2
         STMD R36,=(DCMLEN).2     ;
         POMD R36,-R6          ;
         STMD R12,=TOS         ;
         LDM  R22,=16,1
         PUBD R22,+R12         ;
         LDB  R33,R37          ;
         ANM  R33,=40          ;
         IFNZ
           LDM  R32,='FN'
           PUMD R32,+R12         ;
         ENDIF
         PUBD R23,+R12         ;
         JSB  =ASCNM1          ;
         PUMD R36,+R12         ;
         RTN                   ;

RNLST?   LDBD R3,=RNTYPE       ;
         ANM  R3,=(TYLST?).1
         RTN                   ;

TRJUMP   STM  R#,R32           ;
         LDBD R2,=TRFLAG       ;
         IFNG
           JSB  =RNLST?          ;
           IFNZ
             JSB  =TRCHED          ;
             ARP  !30
             LDM  R45,='to '
             PUMD R45,+R30          ;
             LDMD R36,R32          ;
             JSB  =DCLIN#          ;
             JSB  =OUTERB          ;
           ENDIF
         ENDIF
         STMD R32,=PCR         ;
         RTN                   ;

OUTERB   LDM  R26,=ERRBUF      ;
         SBM  R30,R26          ;
         STM  R30,R36          ;
         JSB  =OUTSTR          ;
         RTN                   ;

TRCHED   JSB  =BLEBUF          ;
         LDM  R30,=ERRBUF      ;
         LDM  R42,='Trace '
         PUMD R42,+R30         ;
         LDM  R43,='line '
         PUMD R43,+R30         ;
         LDMI R36,=PCR         ;
         JSB  =DCLIN#          ;
         ARP  !30
         RTN                   ;

BINCN    IFNG
           LDB  R23,=6           ;
           LDM  R24,=A.ZERO      ;
           JSB  =SCNST           ;
           RTN                   ;
         ENDIF
         JSB  =CONBIN          ;
         LDM  R22,=16,4
         PUMD R22,+R12         ;
         PUMD R40,+R12         ;
         RTN                   ;
       TITLE 'krfil'
*
*  __________________________________________________________________
* |KXFIL 182 09/27/82 - 12/07/1982 3:25PM                            |
* |==================================================================|
* ||                                                                ||
* ||   @@     @@@  @@      @@  @@@@@@@@@@  @@@@@@@@@@  @@           ||
* ||   @@    @@@   @@      @@  @@@@@@@@@@  @@@@@@@@@@  @@           ||
* ||   @@   @@@    @@@    @@@  @@              @@      @@           ||
* ||   @@  @@@      @@@  @@@   @@              @@      @@           ||
* ||   @@ @@@         @@@@     @@              @@      @@           ||
* ||   @@@@@           @@      @@@@@@@@@       @@      @@           ||
* ||   @@@@@           @@      @@@@@@@@@       @@      @@           ||
* ||   @@ @@@         @@@@     @@              @@      @@           ||
* ||   @@  @@@      @@@  @@@   @@              @@      @@           ||
* ||   @@   @@@    @@@    @@@  @@              @@      @@           ||
* ||   @@    @@@   @@      @@  @@          @@@@@@@@@@  @@@@@@@@@@   ||
* ||   @@     @@@  @@      @@  @@          @@@@@@@@@@  @@@@@@@@@@   ||
* ||                                                                ||
* ||                  Last editon on: 821207.1524                   ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
         DATA 0,47
APPT.    LDM  R22,=(0-(TYAPPT)).2
         LDMD R40,=APFILE      ;
         JMP  PSHNAM           ;

         DATA 0,47
KEYS.    LDM  R22,=(0-(TYTEXT)).2
         LDMD R40,=KEYNAM      ;
PSHNAM   LDM  R56,=(8D).2
         JSB  =RSMEM-          ;
         REN
         STMD R40,R26          ;
         PUMD R22,+R12         ;
         PUMD R26,+R12         ;
         RTN                   ;

         DATA 0,47
CARD.    LDM  R22,=(5D).2
         LDMD R40,=(CRDNAM).2
         JMP  PSHNAM           ;

CRDNAM   DATA ":CARD"


EDIT     JSB  =FILNM+          ;
         JEN  TRYTYP

ASKPAR   CMB  R14,=COMMA
         JNE  DONE_FIL
         JSB  =SCAN            ;
         JSB  =TYPNM?
         JEZ  TYPFND
         JSB  =ERR1+           ;
         DATA 68D

TRYTYP   JSB  =TYPNM?
         IFEZ
TYPFND     PUBD R14,+R12         ;
           JSB  =SCAN            ;
         ENDIF

DONE_FIL PUBD R36,+R12         ;
         RTN                   ;

TYPNM?   CLE                   ;
         CMB  R14,=TXTTOK
         REQ
         CMB  R14,=BASTOK
         REQ
         JSB  =HANDI0          ;
         VAL  V.TYPE
         RTN                   ;

FLTOFL   STB  R14,R37          ;
         JSB  =FILNM+          ;
         CMB  R14,=TOTOK
         JNZ  ERRTO
TOOKAY   JSB  =SCAN            ;
         JSB  =FILNM!          ;
         REN
         LDB  R36,=TOTOK2
         PUMD R36,+R12         ;
         RTN                   ;

ERRTO    JSBN  =ERROR+          ;
         DATA 83D

PUSH1F   JSB  =FILNM+          ;
         PUBD R36,+R12         ;
         RTN                   ;

FILNM+   STB  R14,R36          ;
         JSB  =SCAN            ;

FILNM?   JSB  =STREXP          ;
         JEN  NAMEOK
         CMB  R47,=47          ;
         IFNE
           ICE                   ;
           RTN                   ;
         ENDIF
         PUBD R14,+R12         ;
         JSB  =SCAN            ;
NAMEOK   CLE                   ;
         RTN                   ;

FILNM!   JSB  =FILNM?          ;
         REZ
         JSB  =ERR1+           ;
         DATA 63D

FLORD    CLB  R14              ;
FLORDT
         CLM  R50              ;
         DCM  R50              ;
         JSB  =ONR12?          ;
         IFEN
           JSB  =GETNAM          ;
           IFEZ
             TSM  R54              ;
             JZR  BREAK            ;
           ENDIF
           ICE                   ;
           RTN                   ;
         ELSE
           LDMD R40,=EDNAME      ;
           LDMD R74,=BLANKS      ;
           CLM  R54              ;
         ENDIF
BREAK    JSB  =FOPAC?          ;
         CLE                   ;
         REQ

         JSB  =ERR1            ;
         DATA 65D

         LDMD R12,=TOS         ;
         POMD R2,-R6           ;
         ICE                   ;
         RTN                   ;

GETNAM   JSB  =EVIL            ;
         DEF  S20-37
         CLM  R50              ;
         DCM  R50              ;
         CLM  R54              ;
         LDMD R40,=BLANKS      ;
         LDM  R74,R40          ;
         DRP  R26              ;
         JSB  =GETAD#          ;
         ARP  !12
         POMD R36,-R12         ;
         JPS  NOTSPC
         TCM  R36              ;
         STM  R36,R50          ;
         LDMD R40,R26          ;
         JMP  GETNEX
NOTSPC   LDB  R31,=(FLNMSZ)-1  ;
         DCM  R36              ;
         JNG  ERRNAM
         POBD R20,+R26         ;
         JSB  =ALFA            ;
         DRP  !20
         IFEZ
           CMB  R20,='.'
           JNE  CHKDV
         ENDIF
         STB  R20,R40           ;
         JSB  =GETFST          ;
         IFEN
           DCE                   ;
           JEN  ERRNAM
         ENDIF
         LDMD R41,R34          ;
         TSM  R36              ;
         JZR  GETHRU
         CMB  R20,=":"
         JNE  BADCHR

CHKDV    DRP  !20
         CMB  R20,=':'
         JNE  ERRNAM

         LDB  R31,=DVNMSZ
         JSB  =GETFST          ;
         JEN  ERRNAM
         LDMD R54,R34          ;
         TSM  R36              ;
         JZR  GETHRU
         CMB  R20,='/'
         JNZ  BADCHR
         LDB  R31,=PWNMSZ     ;
         JSB  =GETFST          ;
         JEN  ERRNAM
         LDMD R74,R34          ;
         TSM  R36              ;
         JNZ  BADCHR
GETHRU   TSB  R20              ;
         JZR  GETNEX
BADCHR
         CMB  R20,=BLANK
         JZR  GETNEX
ERRNAM
         ADM  R12,=(4D).2
         JSB  =ERR1+           ;
         DATA 63D
GETNEX
         CLE
         RTN                   ;


GETFST   LDM  R34,=TMPMM2      ;
         PUMD R40,+R6          ;
         LDMD R40,=BLANKS      ;
         STMD R40,R34          ;
         POMD R40,-R6          ;
         CLM  R32              ;
CHLOOP_FIL
         POBD R20,+R26         ;
         DCM  R36              ;
         JNC  GETOUT
         JSB  =FLCHR?          ;
         JEZ  GETINV           ;
         DCM  R31              ;
         JNG  TOOBIG           ;
         PUBD R20,+R34         ;
         ICM  R32              ;
         JMP  CHLOOP_FIL       ;

GETOUT   CLM  R36              ;
         CLB  R20              ;
GETINV   CLE                   ;
         TSM  R32              ;
         JNZ  krfil_1          ;

TOOBIG   ICE                   ;

krfil_1  LDM  R34,=TMPMM2      ;
         RTN                   ;

FLCHR?   JSB  =ALFA            ;
         REN
         JSB  =DIGIT           ;
         RTN                   ;
       TITLE 'krerz'
*SAVRG+ EQU 0E39H
ERRBUF ADDR 81E1H
*
*  __________________________________________________________________
* |RHERZ 162 04/02/82 - 4/20/1982 8:25PM                             |
* |==================================================================|
* ||                                                                ||
* ||   @@@@@@@@    @@      @@  @@@@@@@@@@  @@@@@@@@    @@@@@@@@@@   ||
* ||   @@@@@@@@@   @@      @@  @@@@@@@@@@  @@@@@@@@@   @@@@@@@@@@   ||
* ||   @@     @@@  @@      @@  @@          @@     @@@         @@@   ||
* ||   @@      @@  @@      @@  @@          @@      @@        @@@    ||
* ||   @@     @@   @@      @@  @@          @@     @@        @@@     ||
* ||   @@@@@@@     @@@@@@@@@@  @@@@@@@@@   @@@@@@@         @@@      ||
* ||   @@@@@@@     @@@@@@@@@@  @@@@@@@@@   @@@@@@@        @@@       ||
* ||   @@    @@@   @@      @@  @@          @@    @@@     @@@        ||
* ||   @@     @@@  @@      @@  @@          @@     @@@   @@@         ||
* ||   @@      @@  @@      @@  @@          @@      @@  @@@          ||
* ||   @@      @@  @@      @@  @@@@@@@@@@  @@      @@  @@@@@@@@@@   ||
* ||   @@      @@  @@      @@  @@@@@@@@@@  @@      @@  @@@@@@@@@@   ||
* ||                                                                ||
* ||                                                                ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
ANYER?   TSB  R17              ;
         CLE                   ;
         IFNG
           ICE                   ;
         ENDIF
         RTN                   ;

ERRREP   JSB  =DEBUG           ;
         JSB  =PAR1            ;
         JSB  =ERR.R2          ;

REPORT   JSB  =SYSJSB          ;
         DEF  REPRT+
         RZR
         CLB  R17              ;
         RTN                   ;

REPRT+   LDBD R2,=ERRORS       ;
         RZR
         JSB  =EVIL            ;
         DEF  S20-77
         JSB  =RUNROM
         LDMD R36,=PCR         ;
         LDMD R70,R36          ;
         JSB  =SKPLN           ;
         CMB  R73,=87H
         DRP  R36              ;
         IFEQ
           LDMD R36,=RNFILE      ;
           ADM  R36,R76          ;
           DCM  R36              ;
           DCM  R36              ;
         ENDIF 
         DCM  R36              ;
         LDMD R30,=FWVARS      ;
         LDBD R34,=ERRTYP      ;
         JEV  REP_1
         LDMD R34,X30,(E.EREX).2
         JZR  REP_1
         JNG  REP_1
         ADM  R34,=8000H
         JSB  =SUBSTF          ;
         LDMD R30,=FWVARS      ;
         IFEN
           LDB  R34,=35          ;
           STBD R34,=ERRORS      ;
REP_1      GTO REP.1             ;
         ENDIF
         JSB  =CLRERR          ;
         STMD R34,X30,(E.EREX).2
         ANM  R34,=7FFFH       ;
         ADMD R34,=RNFILE      ;
         STM  R34,R10          ;
         LDMD R34,X30,E.ERPC
         ADMD R34,=RNFILE      ;
         JSB  =TRJUMP          ;
         JSB  =ATSIGN          ;
         TSM  R4               ;
         RTN                   ;

CLRERR   CLM  R2               ;
         STMD R2,=ERRORS       ;
         CLB  R17              ;
         RTN                   ;

BLEBUF   JSB  =SET             ;
         VAL  BLANK
         DEF  ERRBUF
         DEF  (ERRBUF)+31D
         RTN                   ;

WARN     STMD R36,=ERRTMP      ;
         POMD R36,-R6          ;
         SAD                   ;
         BIN                   ;
         ICM  R36              ;
         PAD                   ;
         PUMD R#,+R#           ;
         SAD                   ;
         PUMD R2,+R#           ;
         JSB  =SAVRG+          ;
         PUMD R50,+R#          ;
         PUMD R70,+R#          ;
         POBD R70,-R36         ;
         STBD R70,=NEWERR      ;

WARN+N   LDBD R2,=ERRORS       ;
         JNZ  WRNRTN

         JSB  =SETERN
         JSB  =BLEBUF          ;
         LDM  R30,=ERRBUF      ;
         PUMD R0,+R6           ;
         PUMD R14,+R6          ;
         PUBD R17,+R6          ;
         PUMD R41,+R6          ;
         LDM  R41,="WARNING"
         PUMD R41,+R30         ;
         JSB  =REPRT-          ;
         POMD R41,-R6          ;
         POBD R17,-R6          ;
         POMD R14,-R6          ;
         POMD R0,-R6           ;
WRNRTN   POMD R70,-R6          ;
         POMD R50,-R6          ;
         JSB  =RSTREG          ;
         POMD R2,-R#           ;
         LDMD R36,=ERRTMP      ;
         PAD                   ;
         RTN                   ;

DFWARN   PAD                   ;
         ICE                   ;
         STMD R36,=ERRTMP      ;
         LDB  R36,R2           ;

WARN.R   SAD                   ;
         STBD R36,=NEWERR      ;
         PUMD R2,+R6           ;
         JSB  =SAVRG+          ;
         ARP  !6
         PUMD R50,+R6          ;
         PUMD R70,+R6          ;
         JMP  WARN+N

ERR.R2   SAD                   ;
         BIN                   ;
         CMB  R2,=17           ; IF B2#150
         IFNZ
           LDBD R3,=ERRORS       ;
           JNZ  EREX
         ENDIF
         STBD R2,=NEWERR       ;
         LDMD R2,=((PROTEM)+4).2
         STMD R2,=EDEBUG       ;
         JSB  =HANDI0          ;
         VAL  V.ERR
         JEZ  EREX
         CMB  R16,=(RUNSTS).2          ;
         IFEQ
           LDMD R2,=FWVARS       ;
           ADM  R2,=(E.EREX).2
           LDMD R2,R2            ;
           JNZ  NODEFA
         ENDIF
         LDBD R2,=DEFAUL       ;
         JZR  NODEFA
         LDBD R2,=NEWERR       ;
         CMB  R2,=9H           ;
         JLO  DFWARN

NODEFA   STMD R10,=ERRR10      ;
         JSB  =SETERN
         JSB  =STALLS          ;
EREX     PAD                   ;
         CLE                   ;
         RTN                   ;

ERRORR   LDB  R2,R20           ;
         JMP  ERR.R2           ;

ERROR    JSB  =DEBUG
         JSB  =PAR1            ;
         JMP  ERR.R2           ;

ERROR+   JSB  =DEBUG
         JSB  =PAR1            ;
         PUMD R2,-R6           ;
         JMP  ERR.R2           ;

ERR1     JSB  =DEBUG           ;
         JSB  =PAR1            ;
         JMP  krerz_1

ERR1+    JSB  =DEBUG
         JSB  =PAR1            ;
         PUMD R2,-R6           ;
krerz_1  JSB  =ERR.R2          ;
         STE                   ;
         RTN                   ;

SETERN   JSB  =GETRID          ;
         DRP  !2
         STMD R#,=ERROM#       ;
         JSB  =SAVEME          ;
         JSB  =RUNROM          ;

         LDBD R2,=NEWERR       ;
         STBD R2,=ERRORS       ;
         STBD R2,=ERNUM#       ;
         CLM  R2               ;
         LDBD R2,=RUNING       ;
         CMB  R2,=(RUNSTS).2
         IFEQ
           LDB  R3,=((BIT#7)|(BIT#0))
         ENDIF
         CMB  R2,=(ALOSTS).2
         IFEQ
           CMB  R16,=(RUNSTS).2           ;
           IFEQ
             LDB  R3,=BIT#7
           ENDIF
         ENDIF
         STBD R3,=ERRTYP       ;
         IFNG
           LDMI R2,=PCR          ;
           STMD R2,=ERLIN#       ;
         ENDIF
         RTN                   ;

DEBUG    POMD R2,-R6           ;
         STMD R2,=PROTEM       ;
         POMD R2,-R6           ;
         STMD R2,=((PROTEM)+4).2
         PUMD R2,+R6           ;
         LDMD R2,=PROTEM       ;
         PUMD R2,+R6           ;
         RTN                   ;
       TITLE 'krrep'
*
*  __________________________________________________________________
* |RHREP 452 06/24/82 - 7/09/1982 2;51PM                             |
* |==================================================================|
* ||                                                                ||
* ||   @@@@@@@@    @@      @@  @@@@@@@@    @@@@@@@@@@  @@@@@@@@     ||
* ||   @@@@@@@@@   @@      @@  @@@@@@@@@   @@@@@@@@@@  @@@@@@@@@    ||
* ||   @@     @@@  @@      @@  @@     @@@  @@          @@     @@@   ||
* ||   @@      @@  @@      @@  @@      @@  @@          @@      @@   ||
* ||   @@     @@   @@      @@  @@     @@   @@          @@     @@@   ||
* ||   @@@@@@@     @@@@@@@@@@  @@@@@@@     @@@@@@@@@   @@@@@@@@@    ||
* ||   @@@@@@@     @@@@@@@@@@  @@@@@@@     @@@@@@@@@   @@@@@@@@     ||
* ||   @@    @@@   @@      @@  @@    @@@   @@          @@           ||
* ||   @@     @@@  @@      @@  @@     @@@  @@          @@           ||
* ||   @@      @@  @@      @@  @@      @@  @@          @@           ||
* ||   @@      @@  @@      @@  @@      @@  @@@@@@@@@@  @@           ||
* ||   @@      @@  @@      @@  @@      @@  @@@@@@@@@@  @@           ||
* ||                                                                ||
* ||                                                                ||
* |==================================================================|
* |__________________________________________________________________|
*
*  ;*******************************************************************
*  ;*******************************************************************
REP.1    STM  R36,R10           ;
         JSB  =ANN.E+           ;
         JSB  =BLEBUF           ;
         LDM  R30,=ERRBUF       ;
         LDM  R43,='ERROR'
         PUMD R43,+R30          ;
REPRT-   JSB  =DEQUE            ;
         JSB  =SAVEME           ;
         LDBD R2,=ERRTYP        ;
         IFNG
           LDM  R42,=' line '
           PUMD R42,+R30          ;
           LDMD R36,=ERLIN#       ;
           JSB  =DCLIN#           ;
           POBD R2,-R30           ;
         ENDIF
         LDM  R2,=': '
         PUMD R2,+R30           ;
         LDMD R0,=ERROM#        ;
         JSB  =ERRMSG           ; 
         IFEZ                   ; IF E=0
           LDM  R0,=MELROM        ;
           JSB  =ERRMSG           ;
         ENDIF
         IFEZ
           CLM  R37               ;
           LDBD R36,=ERRORS       ;
           LDM  R26,R30           ;
           JSB  =PUTBIN           ;
         ENDIF
         JSB  =STBEEP           ;
         JSB  =OUTERB           ;
         JSB  =UNSEE            ;
         JSB  =CLRERR           ;
         JSB  =STALL+           ;
         RTN                    ;
ERRMSG
         JSB  =GETROM           ;
         LDMD R26,=ROMPTR       ;
         LDMD R26,X26,RM.ERR    ;
         ADMD R26,=ROMOFF       ;
         LDBD R36,=ERRORS       ;
         POBD R37,+R26          ;
         CLB  R2                ;
         JSB  =BATS             ;
         RTN                    ;
       TITLE 'krop'
*
*  __________________________________________________________________
* |IVOP 312 05/10/82 - 5/13/1982 3:57PM                              |
* |==================================================================|
* ||                                                                ||
* ||         @@@@@@@@@@  @@      @@    @@@@@@    @@@@@@@@           ||
* ||         @@@@@@@@@@  @@      @@   @@@@@@@@   @@@@@@@@@          ||
* ||             @@      @@      @@  @@@    @@@  @@     @@@         ||
* ||             @@      @@      @@  @@      @@  @@      @@         ||
* ||             @@       @@    @@   @@      @@  @@     @@@         ||
* ||             @@       @@    @@   @@      @@  @@@@@@@@@          ||
* ||             @@       @@    @@   @@      @@  @@@@@@@@           ||
* ||             @@        @@  @@    @@      @@  @@                 ||
* ||             @@         @@@@     @@      @@  @@                 ||
* ||             @@         @@@@     @@@    @@@  @@                 ||
* ||         @@@@@@@@@@      @@       @@@@@@@@   @@                 ||
* ||         @@@@@@@@@@      @@        @@@@@@    @@                 ||
* ||                                                                ||
* ||                  Last editon on: 821027.1108                   ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
SETUP$   JSB  =GETADR          ;
         ARP  !12
         POMD R36,-R12         ;
         DRP  R30              ;
         JSB  =GETAD#          ;
         ARP  !12
         POMD R32,-R12         ;
         RTN                   ;

         JSB  =SETUP$          ;
         STM  R36,R56          ;
         CMM  R32,R56          ;
         IFNC
           STM  R32,R56          ;
         ENDIF
         JSB  =CMPSTR          ;
         RNE
         CMM  R32,R36          ;
         RTN                   ;

CMPSTR   DCM  R56              ;
         JNC  STREOL
         POBD R51,+R34         ;
         POBD R50,+R30         ;
         CMB  R50,R51          ;
         JEQ  CMPSTR           ;
         RTN                   ;
STREOL   CLB  R#
         RTN                   ;

         DATA 6,53
UNEQ$.   JSB  =SETCOM          ;
         JMP  NETRUE

         DATA 6,53
LEQ$.    JSB  =SETCOM          ;
         JNC  TRUE_OP
         JMP  EQTRUE

         DATA 6,53
GEQ$.    JSB  =SETCOM          ;
         JCY  TRUE_OP
         JMP  FALSE

         DATA 6,53
LT$.     JSB  =SETCOM          ;
         JNC  TRUE_OP
         JMP  FALSE

         DATA 6,53
EQ$.     JSB  =SETCOM          ;
         JMP  EQTRUE

         DATA 6,53
GR$.     JSB  =SETCOM          ;
         JNC  FALSE
         JMP  NETRUE

         DATA 6,51
EQ.      JSB  =TST5

EQTRUE   JZR  TRUE_OP
FALSE    CLM  R40              ;
         JMP  PUSHIT

         DATA 6,51
UNEQ.    JSB  =TST5

NETRUE   JEQ  FALSE

TRUE_OP  CLM  R40              ;
         LDB  R47,=10C
         DRP  R40
PUSHIT   PUMD R#,+R12         ;
         BCD                   ;
         RTN                   ;

         DATA 6,51
LEQ.     JSB  =SUBT
         JEN  LEQ.I
         JRN  TRUE_OP
         TSM  R40              ;
         JMP  EQTRUE
LEQ.I    JNG  TRUE_OP
         JMP  EQTRUE

         DATA 6,51
GEQ.     JSB  =SUBT
         JEZ  RZTRUE
         JMP  PSTRUE

         DATA 6,51
GR.      JSB  =SUBT
         JEN  GR.I
         TSM  R40              ;
         JZR  FALSE
         TSB  R41              ;
RZTRUE   JRZ  TRUE_OP
         JMP  FALSE

GR.I     JZR  FALSE
PSTRUE   JPS  TRUE_OP
         JMP  FALSE

         DATA 6,51
LT.      JSB  =SUBT
         JEN  LT.I
         JRN  TRUE_OP
         JMP  FALSE

LT.I     JNG  TRUE_OP
         JMP  FALSE

         DATA 2,51
OR.      JSB  =TWOROI          ;
         TSM  R55              ;
         JZR  L45ZF
         JMP  TRUE_OP

         DATA 2,51
EXOR.    JSB  =TWOROI          ;
         TSM  R55              ;
         JZR  L45ZF
         JMP  L45ZT            ;

         DATA 7,50
NOT.     JSB  =ONEROI          ;
L45ZT    TSM  R45              ;
         JMP  EQTRUE

         DATA 4,51
AND.     JSB  =TWOROI          ;
         TSM  R55              ;
         JZR  FALSE
L45ZF    TSM  R45              ;
         JMP  NETRUE
SUBT     JSB  =SUBROI          ;
         JSB  =ONEROI          ;
         JEN  SUBTI
         TSB  R41              ;
         RTN                   ;
SUBTI    TSM  R45              ;
         RTN                   ;
TST5     JSB  =TWOROI          ;
         DRP  R55              ;
         ARP  R45              ;
         IFEZ
           DRP R40
           ARP R50
         ENDIF
         XRM  R#,R#
         RTN                   ;
       TITLE 'krok'
*
*  __________________________________________________________________
* |IVOK 307 05/10/82 - 5/13/1982 3:52PM                              |
* |==================================================================|
* ||                                                                ||
* ||         @@@@@@@@@@  @@      @@    @@@@@@    @@     @@@         ||
* ||         @@@@@@@@@@  @@      @@   @@@@@@@@   @@    @@@          ||
* ||             @@      @@      @@  @@@    @@@  @@   @@@           ||
* ||             @@      @@      @@  @@      @@  @@  @@@            ||
* ||             @@       @@    @@   @@      @@  @@ @@@             ||
* ||             @@       @@    @@   @@      @@  @@@@@              ||
* ||             @@       @@    @@   @@      @@  @@@@@              ||
* ||             @@        @@  @@    @@      @@  @@ @@@             ||
* ||             @@         @@@@     @@      @@  @@  @@@            ||
* ||             @@         @@@@     @@@    @@@  @@   @@@           ||
* ||         @@@@@@@@@@      @@       @@@@@@@@   @@    @@@          ||
* ||         @@@@@@@@@@      @@        @@@@@@    @@     @@@         ||
* ||                                                                ||
* ||                  Last editon on: 820908.1352                   ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
DEFKEY   STB  R14,R36          ;
         JSB  =STREX!          ;
         JSB  =ISCMA!          ;
         JSB  =STREX!          ;
         PUBD R36,+R12         ;
         CMB  R14,=SEMI          ;
         IFEQ
           PUBD R14,+R12         ;
           JSB  =SCAN            ;
         ENDIF
         RTN                   ;

KYOPEN   PUMD R30,+R6          ;
         PUMD R40,+R6          ;
         LDM  R40,=
KEYNAM   DATA 'keys    '
         JSB  =FLOPEN          ;
         IFEZ                  ; IF E=0
           LDBD R2,X30,DR.TNM    ;
           CMB  R2,=TYNTEX          ;
           IFNE
             DCE                   ;
           ENDIF
         ENDIF
         POMD R40,-R6          ;
         POMD R30,-R6          ;
         RTN                   ;

         DATA 233
DEFKY.   JSB  =SETUP$          ;
         STM  R32,R22          ;
         LDM  R32,R36          ;
         LDM  R24,R30          ;
         LDB  R56,=';'
         POBD R2,+R10          ;
         CMB  R2,=SEMI
         IFNE
           PUBD R2,-R10          ;
           LDB  R56,=BLANK
         ENDIF
         DCM  R22              ;
         JNZ  ERR89_OK
         LDBD R55,R24          ;
         CMB  R55,=CR
         JZR  ERR89_OK
         CMB  R55,=ATTNKY
         JZR  ERR89_OK
         CMB  R55,=LITKEY
         JZR  ERR89_OK
         CMB  R55,=EDITKY
         JZR  ERR89_OK
         STB  R55,R20          ;
         JSB  =TOBCD2          ;
         STM  R20,R76          ;
         JSB  =KYOPEN          ;
         ICE                   ;
         IFEZ
           JSBN  =ERROR+          ;
           DATA  68D
         ENDIF
         LDMD R40,=KEYNAM      ;
         DCM  R32              ;
         JNZ  NOODLE
         CMBD R55,R34          ;
         JNZ  NOODLE
         CMB  R56,=';'         ;
         JNZ  NOODLE
         GTO FDELLN            ;
NOODLE   DCM  R34              ;
         POMD R20,+R32         ;
         LDM  R20,=TYTEXT      ;
         JSB  =FREPLN          ;
         REN
         STBD R56,X36,(3).2
         RTN                   ;
ERR89_OK
         JSB  =ERR1+           ;
         DATA 89D

         DATA 241
FETK.    BIN                   ;
         LDM  R30,=INPBUF      ;
         LDM  R50,='DEF KEY '
         PUMD R50,+R30         ;
         DRP  R2               ;
         JSB  =GETAD#          ;
         LDBD R40,R2           ;
         POMD R2,-R12          ;
         DCM  R2               ;
         JNZ  ERR89_OK
 
         LDM  R2,="',"
         CMB  R40,="'"
         IFEQ
           LDB  R2,='"'
         ENDIF
         PUBD R2,+R30          ;
         PUBD R40,+R30         ;
         PUMD R2,+R30          ;
         JSB  =KYADDR          ;
         POMD R44,+R36         ;
         IFEN
           LDM  R46,=2,';'
           LDM  R36,=PROTEM      ;
           STBD R40,R36          ;
         ENDIF
         LDB  R3,=PRIME
         PUBD R3,+R30          ;
         STMD R30,=GL.CUR      ;
         DCB  R46              ;
         JNC  krok_l2
krok_l1  DCB  R46              ;
         JNC  krok_l2
         POBD R2,+R36          ;
         CMB  R2,="'"           ;
         IFEQ
           LDB  R3,='"'
         ENDIF
         PUBD R2,+R30          ;
         CMM  R30,=((INPBUF)+93D).2
         IFHS
           DCM  R30              ;
           PUBD R3,+R6           ;
           JSB  =ERR1            ;
           DATA 67D
           POBD R3,-R6           ;
           JMP  krok_l2
         ENDIF
         JMP krok_l1
krok_l2  STBD R3,=(INPBUF)+12D
         PUBD R3,+R30          ;
         CMB  R47,=';'
         IFEQ
           PUBD R47,+R30         ;
         ENDIF
         SBM  R30,=INPBUF      ;
         STBD R30,=GL.LEN      ;
         RTN                   ;
       TITLE 'krrun'
*
*  __________________________________________________________________
* |KXRUN 466 09/27/82 - 12/ 1/1982 3:11PM                           |
* |==================================================================|
* ||                                                                ||
* ||   @@     @@@  @@      @@  @@@@@@@@    @@      @@  @@      @@   ||
* ||   @@    @@@   @@      @@  @@@@@@@@@   @@      @@  @@      @@   ||
* ||   @@   @@@    @@@    @@@  @@     @@@  @@      @@  @@@     @@   ||
* ||   @@  @@@      @@@  @@@   @@      @@  @@      @@  @@@@    @@   ||
* ||   @@ @@@         @@@@     @@     @@   @@      @@  @@ @@   @@   ||
* ||   @@@@@           @@      @@@@@@@     @@      @@  @@  @@  @@   ||
* ||   @@@@@           @@      @@@@@@@     @@      @@  @@  @@  @@   ||
* ||   @@ @@@         @@@@     @@    @@@   @@      @@  @@   @@ @@   ||
* ||   @@  @@@      @@@  @@@   @@     @@@  @@      @@  @@    @@@@   ||
* ||   @@   @@@    @@@    @@@  @@      @@  @@@    @@@  @@     @@@   ||
* ||   @@    @@@   @@      @@  @@      @@   @@@@@@@@   @@      @@   ||
* ||   @@     @@@  @@      @@  @@      @@    @@@@@@    @@      @@   ||
* ||                                                                ||
* ||                  Last editon on: 821201.1508                   ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
SAVENV   PUMD R40,+R6          ;
         LDMD R66,=FWVARS      ;
         LDMD R0,=PCR          ;
         SBMD R0,=RNFILE       ;
         STMD R0,X66,E.PCR
         SBMD R10,=RNFILE      ;
         STMD R10,X66,E.RTN
         ADMD R10,=RNFILE      ;
         STBD R16,X66,E.STAT
         JSB  =SYSJSB          ;
         DEF  IO?
         LDMD R75,X36,DATA#
         STMD R75,X66,E.DATA
         POMD R40,-R6          ;
         RTN                   ;

RESTEN   JSB  =RECOVR          ;
         JSB  =PGMANN          ;
VCREST   STBD R16,=RUNING      ;
         JSB  =HANDI0          ;
         VAL  V.RSTN
         RTN
RECOVR
         LDMD R66,=FWVARS      ;
         LDMD R40,X66,E.MOM
         JSB  =RUNROM          ;
         JSB  =SETRN           ;
         LDBD R16,X66,E.STAT
         LDMD R10,X66,E.PCR
         ADM  R10,R26          ;
         STMD R10,=PCR         ;
         LDMD R10,X66,E.RTN
         ADM  R10,R26          ;
         JEN  KILENV

         JSB  =SYSJSB          ;
         DEF  IO?
         LDMD R75,X66,E.DATA
         STMD R75,X36,DATA#
ENDEN?
         LDMD R2,=FWVARS       ;
         CMMD R2,=FWUSER       ;
         RTN                   ;
POPENV
         BIN                   ;
         JSB  =ENDEN?          ;
         JZR  BOTTOM
         JSB  =RELMEM          ;
         LDMD R40,X34,E.MOM
         CMMD R40,=CALNAM
         IFEQ
           STMD R34,R2
           JSB  =CALEN?
           DRP  R30
           JSB  =PUTCAL
           JSB  =CLNCAL
         ENDIF
         LOOP
           JSB  =EXNXT           ;
         WHNZ
krrun_l1 LDBD R0,X30,E.GCNT
         IFNZ
           DCB  R0               ;
           STBD R0,R2            ;
           JSB  =REMGSB          ;
           JMP  krrun_l1
         ENDIF
         LDMD R56,X30,E.PREV
         LDMD R32,R30
         JSB  =DELETE          ;
         SBM  R30,R56          ;
         STMD R30,=FWVARS      ;
GAP02A   BSS  2
BOTTOM
CLRXTN
         LDBD R0,=XTNDLW       ;
         IFNZ
           LDMD R0,=LEEWAY       ;
           ADM  R0,=((ECBLEN)+1).2
           STMD R0,=LEEWAY       ;
           CLB  R0               ;
           STBD R0,=XTNDLW       ;
         ENDIF
         RTN                   ;

GAP02B   BSS  2
KILENV
         JSB  =STALL
         LOOP
           JSB  =ENDEN?          ;
           RZR 
           JSB  =POPENV          ;
           JSB  =RECOVR          ;
         WHMP

         VAL  PGMRSW
RUN.     BIN                   ;
         JSB  =SAVENV          ;
         JSB  =RUNKEE          ;
         REN
         JSB  =RESTEN          ;
         RTN                   ;

RUNKEE   BIN                   ;
         JSB  =ON?I            ;
         LDM  R66,R45          ;
         LDB  R14,=TYRUN?
         JSB  =FLDDTH          ;
         REN
         JSB  =GOPEN!          ;
         REN
         STM  R66,R76          ;
         PUMD R40,+R6          ;
         JSB  =UNAUTO          ;
         JSB  =DALLAL          ;
         JSB  =UPSET           ;
         CLM  R44              ;
         STMD R44,=DISPTR      ;
         JSB  =RNDINI          ;
         POMD R40,-R6          ;

RUNIT    LDB  R15,=RUNSTS
         JMP  CALL             ;

SYSCALL  CLM  R22              ;
CALL
         JSB  =SAVEME          ;
         PUMD R76,+R6          ;
         PUBD R16,+R6          ;
         LDB  R16,R15          ;
         LDB  R0,=ALOSTS
         STBD R0,=RUNING       ;
         JSB  =PGMANN          ;

VCCALL   JSB  =GETRM2          ;
         JSB  =PTRALO          ;
         JEN  krrun_l2
         CMB  R16,=CLCSTS           ;
         IFNE
           LDB  R0,=EALSTS
           STBD R0,=RUNING       ;
         ENDIF
         JSB  =ENVALO          ;
krrun_l2 JSB  =ANN.P-          ;
         POBD R0,-R6           ;
         STBD R0,=RUNING       ;
         JEN  CALERR

         POMD R76,-R6          ;
         JSB  =FNDLPR          ;
         LDMD R34,=FWVARS      ;
         SBMD R36,=PRFILE      ;
         STMD R36,X34,E.PCR
         ADM  R36,=(3).2
         STMD R36,X34,E.RTN
         STBD R16,X34,E.STAT
         CLM  R75              ;
         STMD R75,X34,E.DATA
         JSB  =SPY             ;
         CLE                   ;
         RTN                   ;
CALERR
         STB  R#,R16           ;
         DCM  R6               ;
         DCM  R6               ;
         JMP  STOP.            ;

         VAL  PGMRSW
CALL.
         LDB  R14,=TYRUN?
         JSB  =FLDDTH          ;
         REN
         JSB  =SAVENV          ;
         JSB  =GOPEN!          ;
         REN
         CLM  R76              ;
         JSB  =RUNIT           ;
         REN
         JSB  =RESTEN          ;
         RTN                   ;

DOSTEP
         BIN                   ;
         JSB  =RESTEN          ;
         CMB  R16,=RUNSTS
         JNZ  CONERR
         JSB  =RNLST?          ;
         JZR  PRVERR
         DRP  !3
         LDBD R#,=RNTYPE       ;
         JPS  PRVERR
         LDMD R24,=PCR         ;
         POMD R45,+R24         ;
         CMMD R45,=BASEND      ;
         IFNE
           LDMD R30,=RNFILE      ;
           STMD R30,=PRFILE      ;
           LDM  R30,=INPBUF      ;
           LDB  R67,=TYRUN?
           JSB  =DECOM           ;
           RNG
           LDM  R26,=INPBUF      ;
           SBM  R30,R26          ;
           STM  R30,R36          ;
           JSB  =OUTSTR          ;
           JSB  =LETGO           ;
         ENDIF
         LDB  R2,=TRUE
         STBD R2,=STEP         ;
         JSB  =TMRGO
         RTN                   ;

PRVERR   JSBN  =ERROR+          ;
         DATA 65D

         DATA 241
STOP.    BIN                   ;
STALLS
         PUMD R60,+R6          ;
         JSB  =SETCLN
         POMD R60,-R6          ;
STALL
         CLB  R17              ;
         STBD R17,=STEP        ;

STALL+   DRP  !17
         LDB  R17,=80H
         RTN                   ;


         VAL  PGMRSW
CONTI.
         JSB  =REMDAC          ;
         JSB  =ON?I            ;
         IFEN
           LDM  R76,R45          ;
           JSB  =FNDLRN          ;
           STM  R36,R10          ;
           STM  R36,R32          ;
           JSB  =TRJUMP          ;
           JSB  =GORTN           ;
         ENDIF
         JSB  =TMRGO
         CMB  R16,=RUNSTS
         REQ

CONERR   JSBN  =ERROR+          ;
         DATA  31D

REMDAC
         LOOP
           LDMD R0,=FWVARS       ;
           LDBD R0,X0,E.STAT
           REV
           JSB  =POPENV          ;
           JSB  =RESTEN          ;
         WHMP

         VAL  PGMRSW
END.     BIN                   ;
         JSB  =SETCLN
         PUBD R16,+R6          ;
         LOOP 
           JSB  =POPENV          ;
           JSB  =RESTEN          ;
           CMB  R16,=DACSTS
         WHEQ
         POBD R0,-R6           ;
         CMB  R0,=RUNSTS           ;
         JNC  STALL            ;
         CMB  R0,=DACSTS
         JZR  STALL            ;
         TSB  R16              ;
         JZR  STALL            ;
         RTN                   ;

SETCLN
         LDMD R60,=RNNAME      ;
SETCL#   CMMD R#,=EDNAME      ;
         IFEQ
           LDMI R2,=PCR          ;
           CMM  R2,=ENDLIN       ;
           IFNE
             STMD R2,=CURLN#       ;
           ENDIF
         ENDIF
         RTN                   ;

         DATA 0,46
TEXT.    LDM  R#,=TYTEXT       ;
         JMP  PUSH

         DATA 0,46
BASIC.   LDM  R#,=TYBASC       ;
PUSH     PUMD R#,+R12          ;
         RTN                   ;
 
         DATA 0,46
LIF1.    LDM  R#,=TYLIF1       ;
         JMP  PUSH

         VAL  PGMRSW
NAME.    JSB  =RENAM.          ;
         JEZ  EDIT.            ;
         RTN                   ;

         VAL  PGMRSW
EDIT.
         BIN                   ;
         CLM  R50              ;
         DCM  R50              ;
         LDM  R40,="workfile"
         CLM  R20              ;
         JSB  =ONR12?          ;
         JZR  EDITCA
         CMM  R2,=(STRSIZ).2
         JZR  GSTRG
         POMD R20,-R12         ;
GSTRG    CMM  R2,=(TYPSIZ).2
         JZR  EDITCA
         LDB  R14,=(TYRAM?)|(TYEDT?)
         JSB  =FLORDT          ;
         JEZ  EDITCA
         GTO FILHAN            ;
EDITCA
         JSB  =EDITIT          ;
         REN
         JSB  =CATLIN          ;
         RTN                   ;
EDITIT
         TSM  R20              ;
         DRP  R15              ;
         IFNZ
           LDB  R15,R20          ;
           ANM  R15,=((TYRAM?)|(TYEDT?)).1
           CMB  R15,=(TYRAM?)|(TYEDT?)
           JNE  krrun_l3
         ENDIF
         LDB  R15,R50          ;
         ANM  R15,=((TYRAM?)|(TYEDT?)).1
         CMB  R15,=(TYRAM?)|(TYEDT?)
         IFNE
krrun_l3   JSB  =ERR1+           ;
           DATA 65D
         ENDIF
         ARP  !50
         LDM  R22,R50           ;
         LDMD R50,=EDNAME      ;
         JSB  =FEMPT?          ;
         IFEN
           PUMD R40,+R6          ;
           LDM  R40,R50          ;
           JSB  =FPURGE          ;
           POMD R40,-R6          ;
         ELSE
           CMMD R50,=DFNAME      ;
           IFEQ
             JSB  =ERR1+           ;
             DATA 69D
           ENDIF
         ENDIF
         JSB  =FOPEN           ;
         IFEZ
           TSM  R20              ;
           ARP  R30              ;
           IFNZ
             LDBD R0,X30,DR.TNM    ;
             CMB  R0,R21           ;
             IFNE
TYPERR         JSB  =ERROR           ;
               DATA 68D
               LDM  R40,R50          ;
               JMP  krrun_l4
             ENDIF
           ELSE
             LDMD R20,X30,DR.TYP
           ENDIF
         ELSE
           CMM  R22,=(0-1).2
           DRP  R20              ;
           IFNE
             TSM  R20              ;
             ARP  R22              ;
             IFNZ
               CMB  R20,R22          ;
               JNE  TYPERR
             ENDIF
             LDM  R20,R22          ;
           ELSE
             TSM  R20              ;
             IFZR
krrun_l4       LDMD R20,=EDTYPE      ;
             ENDIF
           ENDIF
         ENDIF

CHANGE_RUN
SETED
         JSB  =FCRNUL          ;
         DCE                   ;
         DCE                   ;
         JEZ  NOLEFT
         STMD R40,=EDNAME      ;
         LDMD R0,X30,DR.TYP
         STMD R0,=EDTYPE       ;
         LDMD R32,R30          ;
         STMD R32,=EDFILE      ;
         CLM  R76              ;
         JSB  =FNDLED          ;
         LDMD R76,R36          ;
         CMM  R76,=ENDLIN      ;
         IFEQ
           CLM  R76              ;
         ENDIF
         STMD R76,=CURLN#      ;
         JSB  =UNAUTO          ;
         CLE                   ;
         RTN                   ;

NOLEFT   ICE                   ;
         RTN                   ;

         VAL  PGMRSW
MERGE.
         LDB  R14,=(TYRAM?)|(TYCOP?)
         JSB  =GF2LN#          ;
         REN
         CMMD R40,=EDNAME      ;
         REQ
         LDMD R0,X30,DR.TYP
         CLM  R2               ;
         DCM  R2               ;
         LDBD R2,=EDTYPE       ;
         ANM  R0,R2            ;
         CMMD R0,=EDTYPE       ;
         JNZ  NOTSAM
         STM  R40,R50          ;
         JSB  =SAFE!           ;
         LDMD R40,=EDNAME      ;
         JSB  =SAFE!           ;
         LDM  R40,R50          ;
         JSB  =FLOPEN          ;
         JSB  =FSEEK           ;
         STM  R36,R34          ;
         LDMD R36,=EDFILE      ;
         LDMD R26,=ENLIN#

         ADM  R36,=(PCBLEN).2
         CLM  R32              ;
         LOOP
           POMD R76,+R34         ;
           CMM  R26,R76          ;
           RNC
           POBD R32,+R34         ;
           JSB  =FSREPL          ;
           JEN  NOLEFT 
           SBM  R34,=(3).2
           JSB  =SKPLN#          ;
         WHMP

NOTSAM   JSBN  =ERROR+          ;
         DATA 68D

SAFE!
         PUMD R50,+R6          ;
         PUMD R60,+R6          ;
         PUMD R30,+R6          ;
         LDMD R30,=PCR         ;
         STMD R30,=KLUDGE      ;
         JSB  =SETPR           ;
         JEN  krrun_l5
         CMMD R40,=CALNAM      ;
         IFEQ
           CMMD R40,=RNNAME      ;
           IFEQ
             JSB  =STALLS          ;
           ENDIF
           JSB  =INENV?          ;
           LDBD R0,X66,E.STAT
           IFNZ
             LDB  R0,=DACSTS
             STBD R0,R2            ;
           ENDIF
         ELSE
           JSB  =PTALO?          ;
           JEZ  krrun_l5
           JSB  =DALLOC          ;
           JSB  =INENV?          ;
           JEN  krrun_l5
           JSB  =DALLAL          ;
           JSB  =STALLS          ;
         ENDIF
krrun_l5
         LDMD R30,=KLUDGE      ;
         STMD R30,=PCR         ;
         POMD R30,-R6          ;
         POMD R60,-R6          ;
FINSUP
         POMD R50,-R#          ;
         RTN                   ;

INENV?
         PUMD R50,+R6          ;
         CLE                   ;
         LDMD R66,=FWVARS      ;
         LOOP
           LDMD R50,X66,E.MOM
           CMM  R50,R40          ;
           JEQ  INFND
           LDMD R0,X66,E.PREV
           JZR  INNONE
           SBM  R66,R0           ;
         WHMP
INNONE   ICE                   ;
INFND    ARP  R6
         JMP  FINSUP
CALEN?   LDMD R40,=CALNAM
         JMP  =INENV?
GAP02C   BSS  2
       TITLE 'krvr2'
*
*  __________________________________________________________________
* |KXVR2                                                             |
* |==================================================================|
* ||                                                                ||
* ||   @@     @@@  @@      @@  @@      @@  @@@@@@@@       @@@@      ||
* ||   @@    @@@   @@      @@  @@      @@  @@@@@@@@@    @@@@@@@@    ||
* ||   @@   @@@    @@@    @@@  @@      @@  @@     @@@  @@@    @@@   ||
* ||   @@  @@@      @@@  @@@   @@      @@  @@      @@          @@   ||
* ||   @@ @@@         @@@@      @@    @@   @@     @@          @@@   ||
* ||   @@@@@           @@       @@    @@   @@@@@@@           @@@    ||
* ||   @@@@@           @@       @@    @@   @@@@@@@         @@@      ||
* ||   @@ @@@         @@@@       @@  @@    @@    @@@     @@@        ||
* ||   @@  @@@      @@@  @@@      @@@@     @@     @@@   @@@         ||
* ||   @@   @@@    @@@    @@@     @@@@     @@      @@  @@@          ||
* ||   @@    @@@   @@      @@      @@      @@      @@  @@@@@@@@@@   ||
* ||   @@     @@@  @@      @@      @@      @@      @@  @@@@@@@@@@   ||
* ||                                                                ||
* ||                                                                ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
VERMN2   DATA 'd'              ; ROM version ('d')
       TITLE 'krsum2'
*
*  __________________________________________________________________
* |KRSUM                                                             |
* |==================================================================|
* ||                                                                ||
* ||   @@     @@@  @@@@@@@@      @@@@@@    @@      @@  @@      @@   ||
* ||   @@    @@@   @@@@@@@@@    @@@@@@@@   @@      @@  @@@    @@@   ||
* ||   @@   @@@    @@     @@@  @@@    @@@  @@      @@  @@@@  @@@@   ||
* ||   @@  @@@     @@      @@  @@      @@  @@      @@  @@@@@@@@@@   ||
* ||   @@ @@@      @@     @@   @@@         @@      @@  @@  @@  @@   ||
* ||   @@@@@       @@@@@@@      @@@@@@@    @@      @@  @@  @@  @@   ||
* ||   @@@@@       @@@@@@@       @@@@@@@   @@      @@  @@      @@   ||
* ||   @@ @@@      @@    @@@          @@@  @@      @@  @@      @@   ||
* ||   @@  @@@     @@     @@@  @@      @@  @@      @@  @@      @@   ||
* ||   @@   @@@    @@      @@  @@@     @@  @@@    @@@  @@      @@   ||
* ||   @@    @@@   @@      @@   @@@@@@@@    @@@@@@@@   @@      @@   ||
* ||   @@     @@@  @@      @@    @@@@@@      @@@@@@    @@      @@   ||
* ||                                                                ||
* ||                                                                ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
*        DATA 244              ;ROM checksum
         DATA 064H

       TITLE 'krhnd'
*
*  __________________________________________________________________
* |IVHND 225 05/10/82 - 5/13/1982 3:30PM                             |
* |==================================================================|
* ||                                                                ||
* ||   @@@@@@@@@@  @@      @@  @@      @@  @@      @@  @@@@@@       ||
* ||   @@@@@@@@@@  @@      @@  @@      @@  @@      @@  @@@@@@@@     ||
* ||       @@      @@      @@  @@      @@  @@@     @@  @@    @@@    ||
* ||       @@      @@      @@  @@      @@  @@@@    @@  @@      @@   ||
* ||       @@       @@    @@   @@      @@  @@ @@   @@  @@      @@   ||
* ||       @@       @@    @@   @@@@@@@@@@  @@  @@  @@  @@      @@   ||
* ||       @@       @@    @@   @@@@@@@@@@  @@  @@  @@  @@      @@   ||
* ||       @@        @@  @@    @@      @@  @@   @@ @@  @@      @@   ||
* ||       @@         @@@@     @@      @@  @@    @@@@  @@      @@   ||
* ||       @@         @@@@     @@      @@  @@     @@@  @@    @@@    ||
* ||   @@@@@@@@@@      @@      @@      @@  @@      @@  @@@@@@@@     ||
* ||   @@@@@@@@@@      @@      @@      @@  @@      @@  @@@@@@       ||
* ||                                                                ||
* ||                  Last editon on: 820908.1333                   ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
HANDI    JSB  =PAR1            ;
HANDIR   STBD R2,=ROMFL        ;
         LDBD R2,=HANDLD       ;
         PUBD R2,+R6           ;
         JSB  =ROMLUP
         POBD R2,-R6           ;
         STBD R2,=(PROTEM)+4
         JSB  =PAR1            ;
         PUBD R0,+R6           ;
         CLE                   ;
         LDBD R0,=HANDLD       ;
         LDBD R3,=(PROTEM)+4
         STBD R3,=HANDLD       ;
         TSB  R0               ;
         IFNZ
           JSB  =ERR.R2          ;
           STE
         ENDIF
         POBD R0,-R6           ;
         RTN                   ;
HANDIO
         STMD R2,=((PROTEM)+4).2
         JSB  =PAR1            ;
         STBD R2,=ROMFL        ;
         LDMD R2,=((PROTEM)+4).2
         PUMD R2,+R6           ;
         LDBD R2,=HANDLD       ;
         PUBD R2,+R6           ;
         JSB  =ROMLUP
         CLE                   ;
         LDBD R2,=HANDLD       ;
         IFNZ
           ICE                   ;
         ENDIF
         POBD R2,-R6           ;
         STBD R2,=HANDLD       ;
         POMD R2,-R6           ;
         RTN                   ;

ROMLUP   PUMD R0,+R6           ;
         LDMI R0,=ROMPTR       ;
         PUMD R0,+R6           ;
         JSB  =CYCLE           ;
         DEF  INISUB
         POMD R0,-R6           ;
         JSB  =GETROM          ;
         POMD R0,-R6           ;
         RTN                   ;

INISUB   LDMD R0,=ROMPTR       ;
         LDMD R2,X0,RM.INI     ;
         ADMD R2,=ROMOFF       ;
         LDBD R0,=ROMFL        ;
         JSB  X2,ZRO           ;
         RTN                   ;
       TITLE 'krvar'
*
*  __________________________________________________________________
* |KXVAR 554 06/09/82 -                                              |
* |==================================================================|
* ||                                                                ||
* ||   @@     @@@  @@      @@  @@      @@    @@@@@@    @@@@@@@@     ||
* ||   @@    @@@   @@      @@  @@      @@   @@@@@@@@   @@@@@@@@@    ||
* ||   @@   @@@    @@@    @@@  @@      @@  @@@    @@@  @@     @@@   ||
* ||   @@  @@@      @@@  @@@   @@      @@  @@      @@  @@      @@   ||
* ||   @@ @@@         @@@@      @@    @@   @@      @@  @@     @@    ||
* ||   @@@@@           @@       @@    @@   @@@@@@@@@@  @@@@@@@      ||
* ||   @@@@@           @@       @@    @@   @@@@@@@@@@  @@@@@@@      ||
* ||   @@ @@@         @@@@       @@  @@    @@      @@  @@    @@@    ||
* ||   @@  @@@      @@@  @@@      @@@@     @@      @@  @@     @@@   ||
* ||   @@   @@@    @@@    @@@     @@@@     @@      @@  @@      @@   ||
* ||   @@    @@@   @@      @@      @@      @@      @@  @@      @@   ||
* ||   @@     @@@  @@      @@      @@      @@      @@  @@      @@   ||
* ||                                                                ||
* ||                  Last editon on: 820908.1353                   ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
         DATA 1
FTSVL    POMD R66,+R10         ;
         JSB  =FETSV           ;
SVVAL3   PUMD R60,+R12         ;
         RTN                   ;
         DATA 3
SVADR+   DATA 1
SVADR    POMD R24,+R10         ;
         PUMD R24,+R12         ;
         RTN                   ;
         DATA 1
FTSTL    CLE                   ;
         POMD R24,+R10         ;
         PUMD R24,+R12         ;
         JMP  krvar_l1
         DATA 3
FTSTLS   STE                   ;
         POMD R66,+R10         ;
         JSB  =FETCHA          ;
         JSB  =PUTADR          ;
         PUMD R66,+R12         ;
         PUMD R66,+R12         ;
krvar_l1 JSB  =FETST           ;
         RTN                   ;
         DATA 4
ICONST   POMD R70,+R10         ;
         PUMD R70,+R12         ;
         RTN                   ;
         DATA 5
SCONST   BIN                   ;
         CLM  R70              ;
         POBD R70,+R10         ;
         STM  R10,R72          ;
         ADM  R10,R70          ;
         JSB  =CONCA-          ;
         RTN                   ;
         DATA 43
STOSTM   DATA 31

STOST
         DRP  R26              ;
         JSB  =GETAD#          ;
         ARP  !12
         POMD R24,-R12         ;
         DRP  R36              ;
         JSB  =GETAD#          ;
         ARP  !12
         POMD R32,-R12          ;
         POMD R66,-R12          ;
         LDBD R76,R10          ;
         CMB  R76,=MST$TK
         IFEQ
           JSB  =GETAD#          ;
           ARP  !12
           PUMD R24,+R12         ;
           LDM  R22,R26
           JSB  =PUTADR          ;
           DRP  R76              ;
           JSB  =PUTADR          ;
         ENDIF
         PUMD R36,+R6          ;
         JSB  =FETCHA          ;
         DRP  !36
         POMD R36,-R6
         POMD R66,+R34         ;
         JSB  =GETADR          ;

STOST-
         POMD R22,+R34         ;
         CMM  R32,R24          ;
         JCY  krvar_l2
         CMM  R36,R34          ;
         JNZ  TRUNC_VAR
         CMM  R66,R32          ;
         JZR  TOOLNG
TRUNC_VAR
         STM  R32,R24          ;
krvar_l2 LDM  R56,R36          ;
         SBM  R56,R34          ;
         ADM  R56,R32          ;
         CMM  R66,R56          ;
         IFNC
TOOLNG     JSBN  =ERROR+          ;
           DATA 42D
         ENDIF
         CMM  R66,R32           ;
         JNZ  DIFF
         CMM  R34,R36          ;
         JNZ  DIFF
         TSM  R24              ;
         JNZ  SAME
         PUMD R24,-R34         ;
         JMP  STDONE

SAME     STM  R24,R32          ;
         STM  R24,R56          ;
         JMP  CHGLEN

DIFF     CMM  R22,R56          ;
         IFNG
CHGLEN     PUMD R56,-R34         ;
         ENDIF
         TSM  R24              ;
         JZR  BLKFIL_VAR
         LOOP
           POBD R67,+R26         ;
           PUBD R67,+R36         ;
           DCM  R32              ;
           DCM  R24              ;
         WHNZ

BLKFIL_VAR
         TSM  R32              ;
         JZR  STDONE
         LDB  R67,=BLANK
         LOOP
           PUBD R67,+R36         ;
           DCM  R32              ;
         WHNZ

STDONE   LDBD R77,=TRFLAG      ;
         REV
         CMB  R16,=RUNSTS
         RNE
         STM  R46,R36          ;
         JSB  =TRCFP           ;
         LDB  R77,=DOLLAR
         PUBD R77,+R12         ;
         JSB  =UNSTAK          ;
         JSB  =TRCLP           ;
         RTN                   ;

         DATA 43
STOSVM   DATA 31
STOSV    SAD                   ;
         LDB  R0,=60           ;
         POMD R60,-R12         ;
         PUMD R60,+R6          ;
         POMD R46,-R12         ;
         PUMD R46,+R12         ;
         BCD                   ;
         LRB  R46              ;
         BIN                   ;
         ANM  R46,=3,0
         JZR  REAL
         DCB  R46              ;
         JNZ  SHORT

         JSB  =RTOIN           ;
         IFEN
           JSB  =ERROR           ;
           DATA 2D
         ENDIF
         LDB  R0,=65           ;
REAL     JMP  STORE

SHORT    CLB  R32              ;
         LDB  R0,=64           ;
         CMB  R64,=377         ;
         BCD                   ;
         JNZ  krvar_l4
         CLB  R36              ;
         TSM  R65              ;
         IFLN
           ICB  R32              ;
           ICB  R32              ;
           TCM  R65              ;
         ENDIF
         JZR  krvar_l3         ;
         LDB  R36,=5           ;
         LOOP
           DCB  R36              ;
           LLM  R65              ;
         WHLZ
krvar_l3 JMP  STSV3D

krvar_l4 LDM  R36,R60          ;
         LRB  R37              ;
         BIN                   ;
         IFEN
           ICB  R32              ;
           ICB  R32              ;
         ENDIF
         CMB  R37,=5C           ;
         IFCY
           ICB  R32              ;
         ENDIF
         BCD                   ;
         ADM  R65,=5C,0,0       ;
         IFCY
           LDB  R67,=10C          ;
           ICM  R36              ;
         ENDIF
         CMB  R37,=5C           ;
         IFCY
           TCM  R36              ;
           ANM  R37,=17          ;
         ENDIF
         TSB  R37              ;
         JZR  STSV3D

         CLM  R36              ;
         CLM  R65              ;
         TSB  R32              ;
         IFOD
           JSB  =ERROR           ;
           DATA 1D
           CLB  R32              ;
         ELSE
           JSB  =ERROR           ;
           DATA 2D
           DCB  R36              ;
           DCM  R65              ;
         ENDIF
         LDB  R0,=64           ;

STSV3D   ERM  R32              ;
         ERM  R67              ;
         STB  R36,R64          ;
STORE    BIN                   ;
         POMD R46,-R12         ;
         STM  R46,R30          ;
         LLB  R46              ;
         TSB  R46              ;
         IFNG
           POBD R20,-R12         ;
           POMD R74,-R12         ;
         ENDIF
         JSB  =GETADR          ;
         STMD R*,R34           ;
         POMD R50,-R6          ;
         LDBD R26,R10          ;
         CMB  R26,=MST#TK
         IFZR
           PUMD R50,+R12         ;
         ENDIF
         LDBD R46,=TRFLAG      ;
         IFOD
           LDM  R46,R30          ;
           JSB  =FNUM            ;
           STM  R46,R36          ;
           LLB  R46              ;
           JSB  =TRCVBL          ;
         ENDIF
SVRTN    PAD                   ;
         RTN                   ;

         DATA 32
AVADR1   DRP  !20
         CLB  R20               ;
         ICB  R20               ;
         JMP  PU20
         DATA 32
AVADR2   DRP  !20
         CLB  R20              ;
PU20     PUBD R#,+R12          ;
         JSB  =FETAVA          ;
         JSB  =PUTREL          ;
         LDM  R73,R40          ;
         PUMD R73,+R12         ;
PNAM     PUMD R46,+R12         ;
         RTN                   ;
         DATA 32
AVVAL1   DRP  !20
         CLB  R20              ;
         ICB  R20              ;
         JMP  PU20+
         DATA 32
AVVAL2   DRP  !20
         CLB  R20              ;
PU20+    PUBD R#,+R12         ;
         JSB  =FETAV           ;
         PUMD R60,+R12         ;
         RTN                   ;
         DATA 0
GORTN
         BIN                   ;
         STMD R10,=PCR         ;
         ADM  R10,=(3).2
         LDMD R12,=TOS         ;
         JSB  =SPY             ;
         JSB  =RELMEM          ;
         LDBD R2,=STEP         ;
         IFNZ
           JSB  =STALLS          ;
         ENDIF
         RTN                   ;
         DATA 1
FTADR1   DATA 3
FTADR    POMD R66,+R10         ;
         JSB  =FETSVA          ;
         JSB  =PUTREL          ;
         ARP  !12
         PUMD R46,+R12          ;
         RTN                   ;

RCURFN   CLM  R46              ;
         PUMD R46,+R34         ;
         JSBN =ERROR+          ;
         DATA 41D

BADP1    POBD R76,-R6          ;
         POMD R76,-R6          ;
BADP     POMD R76,-R6          ;
         JSBN =ERROR+          ;
         DATA 40D

         DATA 6
FNCAL.   BSS  0
FNCAL$   BIN                   ;
         POMD R34,+R10         ;
         ADMD R34,=RNFILE      ;
         STM  R34,R30          ;
         CLM  R32              ;
         JSB  =ROOM!           ;
         REN
         POMD R32,+R34         ;
         TSB  R32              ;
         IFNG
           POMD R32,+R34         ;
         ENDIF
         POMD R32,+R34         ;
         ADMD R32,=FWVARS      ;
         LDMD R24,=RNFILE      ;
         ADMD R24,R34          ;
         STM  R32,R34          ;
         SBM  R34,=(9D).2
         LDMD R46,R34          ;
         JNZ  RCURFN
         POBD R32,+R24         ;
         LRB  R32              ;
         PUMD R34,+R6          ;
         POBD R34,+R10         ;
         CMB  R34,R32          ;
         JNZ  BADP
         TSB  R34              ;
         IFZR
           GTO NOPRMS
         ENDIF
         CLB  R33              ;
         ADM  R32,R10          ;
         LOOP
           SBM  R12,=(4D).2
           POBD R77,+R10         ;
           IFEV
             SBM  R12,=(4D).2
           ENDIF
           CMM  R10,R32          ;
         WHNC
         PUMD R12,+R6          ;
         CLB  R35              ;
         SBM  R10,R34          ;
         LOOP
           PUBD R34,+R6          ;
           POBD R33,+R24         ;
           POBD R32,+R10         ;
           ERB  R32              ;
           ERB  R32              ;
           XRB  R33,R32          ;
           JNG  BADP1
           POBD R77,+R24         ;
           TSB  R32              ;
           IFNG
             LDM  R66,R24          ;
             SBMD R66,=RNFILE      ;
             DCM  R66              ;
             DCM  R66              ;
             POMD R32,+R24         ;
             POMD R36,+R24         ;
             ADMD R36,=FWVARS      ;
             ICM  R36              ;
             ICM  R36              ;
             PUMD R24,+R6          ;
             POMD R24,+R12         ;
             POMD R26,+R12         ;
             JSB  =GETAD+          ;
             IFCY
               DRP  !26
               DCM  R26              ;
               DCM  R26              ;
             ENDIF
             PUMD R36,+R6          ;
             JSB  =FETCHA          ;
             POMD R66,+R34         ;
             STM  R36,R34          ;
             POMD R36,-R6          ;
             LDBD R2,=TRFLAG       ;
             PUBD R2,+R6           ;
             CLB  R2               ;
             STBD R2,=TRFLAG       ;
             JSB  =STOST-
             POBD R2,-R6           ;
             STBD R2,=TRFLAG       ;
             POMD R24,-R6          ;
           ELSE
             POMD R60,+R12         ;
             JSB  =ONER-           ;
             BIN                   ;
             POMD R34,+R24         ;
             ADMD R34,=FWVARS      ;
             PUMD R40,+R34         ;
           ENDIF
           POBD R34,-R6          ;
           DCB  R34              ;
         WHNZ
         POMD R12,-R6          ;

NOPRMS   POMD R34,-R6          ;
         SBMD R10,=RNFILE      ;
         PUMD R10,+R34         ;
         LDMD R32,=FWVARS      ;
         LDMD R66,=PCR         ;
         SBMD R66,=RNFILE      ;
         PUMD R66,+R34         ;
         LDMD R66,=TOS         ;
         SBM  R66,R12          ;
         PUMD R66,+R34         ;
         STMD R12,=TOS         ;
         LDMD R66,X32,E.RMEM
         PUMD R66,+R34         ;
         CLM  R66              ;
         STMD R66,X32,E.RMEM
         PUBD R16,+R34         ;
         LDM  R10,R24          ;
         ICM  R10              ;
         ICM  R10              ;
         POMD R24,+R24         ;
         ADMD R24,=RNFILE      ;
         JSB  =TRJUMP          ;
         RTN                   ;

         DATA 2
INTCON   POMD R75,+R10         ;
I#PUSH   LDB  R74,=377         ;
         PUMD R70,+R12         ;
         RTN                   ;

         DATA 34
SUBST1   JSB  =ONEB            ;
         CLE                   ;
         DRP  R56              ;
         JSB  =GETAD#          ;
         ARP  !12
         POMD R76,-R#          ;
STPTR    SBM  R76,R46          ;
         ICM  R76              ;
         IFNG
           CLM  R76              ;
           ICE                   ;
         ENDIF
         DCM  R46              ;
         IFNG
           CLM  R46              ;
           ICE                   ;
         ENDIF
         PUMD R76,+R12         ;
         ADM  R56,R46          ;
         JSB  =PUTADR          ;
         REZ
BADSUB   JSBN =ERROR+          ;
         DATA  27D              ;
*
         DATA  1                ;
SVADCK   LDBD R#,=TOKEN        ;
         JSB  =SVADR           ;
         DRP  !24
         BIN                   ;
         ADMD R24,=RNFILE       ;
         LDMD R60,R24          ;
         DRP  R20              ;
         IFPS
           DCB  R20              ;
         ENDIF
         CMB  R20,=ARY1TK
         JNE  BADSUB
         RTN                   ;

         DATA 34
SUBST2   JSB  =TWOB            ;
         CLE                   ;
         STM  R46,R76          ;
         LDM  R46,R56          ;
         DRP  R56              ;
         JSB  =GETAD#          ;
         ARP  !12
         POMD R66,-R12         ;
         CMM  R66,R76          ;
         JPS  STPTR
         STM  R66,R76          ;
         ICE                   ;
         JMP  STPTR

         DATA 217
FNLET.   BIN                   ;
         POBD R24,+R10         ;
         LDMD R24,R10          ;
         ADMD R24,=RNFILE      ;
         LDMD R32,R24          ;
         TSB  R32              ;
         IFNG
           JSB  =FTSTLS          ;
           RTN                   ;
         ELSE
           POMD R34,+R10         ;
           POMD R34,+R24         ;
           LDMD R34,R24          ;
           ADMD R34,=FWVARS      ;
           JSB  =PUTREL          ;
           ARP  !12
           PUMD R32,+R12         ;
           RTN                   ;
         ENDIF

         DATA 313
FNRTN.   JSB  =FNGET
         TSB  R34              ;
         IFPS
           POMD R60,+R24         ;
           JSB  =FETIND          ;
           PUMD R60,+R12         ;
         ELSE
           POMD R56,+R24         ;
           LDM  R34,R24          ;
           JSB  =STRIND          ;
           LDM  R74,R30          ;
           PUMD R74,+R6          ;
           CLM  R74              ;
           PUMD R74,+R12         ;
           JSB  =CONCA.          ;
           POMD R74,-R6          ;
           STM  R74,R30          ;
         ENDIF
DORTN    GTO FNDRTN            ;
BADFN    POMD R32,-R6          ;
         JSBN =ERROR+          ;
         DATA 39D

         DATA 16
FNRET.   BIN                   ;
         CMMD R12,=TOS         ;
         JZR  FNRTN.           ;
         JSB  =FNGET
         JMP  DORTN

FNGET    BIN                   ;
         POMD R24,+R10         ;
         ADMD R24,=RNFILE      ;
         POMD R34,+R24         ;
         TSB  R34              ;
         IFNG
           ICM  R24              ;
           ICM  R24              ;
         ENDIF
         LDMD R24,R24          ;
         ADMD R24,=FWVARS      ;
         SBM  R24,=(9D).2
         LDMD R32,R24          ;
         CLM  R36              ;
         PUMD R36,+R24         ;
         TSM  R32              ;
         JZR  BADFN
         POMD R30,+R24         ;
         LDMD R36,=FWVARS      ;
         POMD R66,+R24         ;
         ADMD R66,=TOS         ;
         STMD R66,=TOS         ;
         LDMD R66,X36,E.RMEM
         ADMD R66,R24          ;
         STMD R66,R2           ;
         POMD R66,+R24         ;
         POBD R16,+R24         ;
         RTN                   ;
       TITLE 'krcat'
*
*  __________________________________________________________________
* |RHCAT 68 04/02/82 - 4/20/1982 8:35PM                              |
* |==================================================================|
* ||                                                                ||
* ||   @@@@@@@@    @@      @@     @@@@       @@@@@@    @@@@@@@@@@   ||
* ||   @@@@@@@@@   @@      @@   @@@@@@@@    @@@@@@@@   @@@@@@@@@@   ||
* ||   @@     @@@  @@      @@  @@@    @@@  @@@    @@@      @@       ||
* ||   @@      @@  @@      @@  @@      @@  @@      @@      @@       ||
* ||   @@     @@   @@      @@  @@          @@      @@      @@       ||
* ||   @@@@@@@     @@@@@@@@@@  @@          @@@@@@@@@@      @@       ||
* ||   @@@@@@@     @@@@@@@@@@  @@          @@@@@@@@@@      @@       ||
* ||   @@    @@@   @@      @@  @@          @@      @@      @@       ||
* ||   @@     @@@  @@      @@  @@      @@  @@      @@      @@       ||
* ||   @@      @@  @@      @@  @@@    @@@  @@      @@      @@       ||
* ||   @@      @@  @@      @@   @@@@@@@@   @@      @@      @@       ||
* ||   @@      @@  @@      @@     @@@@     @@      @@      @@       ||
* ||                                                                ||
* ||                  Last editon on: 820908.1349                   ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
         VAL  PGMRSW
CAT.     JSB  =FLORD           ;
         JEN  krcat_l1
         JSB  =FOPEN           ;
         JEN  ERRNF2
         LDBD R0,X30,DR.TNM    ;
         JZR  ERRNF2
CATLIN   JSB  =MELJSB          ;
         DEF  CATTMP
         JSB  =OUTSTR          ;
         RTN                   ;

krcat_l1 DCE                   ;
         JEN  krcat_l2
         STM  R40,R60          ;
         ARP  R54              ;
         JSB  =CDPC?           ;
         IFEZ
krcat_l2   GTO FILHAN            ;
         ENDIF
         JSB  =CRDEXM          ;
         RTN                   ;

ERRNF2   JSBN =ERROR+
         DATA 62D

         VAL  PGMRSW
CATAL.
         JSB  =MELJSB          ;
         DEF  CATALL
         RTN                   ;

UPENT    LDM  R0,=(0-(DRENSZ)).2
         JMP  krcat_l3         ;
DNENT
         LDM  R0,=(DRENSZ).2       ;
krcat_l3 CLE                   ;
         STM  R30,R20          ;
         LOOP
           ADM  R30,R0           ;
           CMM  R30,=TABEND      ;
           JNC  NXTEND
           LDMD R2,R30           ;
           JZR  NXTEND
           LDBD R2,X30,DR.TNM    ;
         WHZR
         RTN                   ;

NXTEND   ICE                   ;
         LDM  R30,R20          ;
         RTN                   ;

         DATA 20,56
CAT$.    JSB  =MELJSB          ;
         DEF  CAT$
         RTN                   ;
       TITLE 'krfmt'
*
*  __________________________________________________________________
* |KRFMT 197 04/02/82 - 4/20/1982 8:36PM                             |
* |==================================================================|
* ||                                                                ||
* ||   @@     @@@  @@@@@@@@    @@@@@@@@@@  @@      @@  @@@@@@@@@@   ||
* ||   @@    @@@   @@@@@@@@@   @@@@@@@@@@  @@@    @@@  @@@@@@@@@@   ||
* ||   @@   @@@    @@     @@@  @@          @@@@  @@@@      @@       ||
* ||   @@  @@@     @@      @@  @@          @@@@@@@@@@      @@       ||
* ||   @@ @@@      @@     @@   @@          @@  @@  @@      @@       ||
* ||   @@@@@       @@@@@@@     @@@@@@@@@   @@  @@  @@      @@       ||
* ||   @@@@@       @@@@@@@     @@@@@@@@@   @@      @@      @@       ||
* ||   @@ @@@      @@    @@@   @@          @@      @@      @@       ||
* ||   @@  @@@     @@     @@@  @@          @@      @@      @@       ||
* ||   @@   @@@    @@      @@  @@          @@      @@      @@       ||
* ||   @@    @@@   @@      @@  @@          @@      @@      @@       ||
* ||   @@     @@@  @@      @@  @@          @@      @@      @@       ||
* ||                                                                ||
* ||                  Last editon on: 820908.1349                   ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
ROUND    TSM  R40              ;
         RZR
         CLM  R50              ;
         LDB  R57,=50C
         LDM  R34,R36          ;
         ICM  R34              ;
         TSB  R73              ;
         DRP  R34              ;
         IFNZ
           LDM  R34,R76          ;
         ENDIF
         ADM  R34,R74          ;
         IFCY
           TSB  R73              ;
           RNZ        
           TSB  R37              ;
           RLZ
         ENDIF
         CMM  R34,=12C,0
         JNC  POS.5L
         RTN                   ;

         LOOP
           LRM  R57              ;
POS.5L     DCB  R34              ;
         WHCY
         ADM  R42,R52          ;
         RNC
         LRM  R47              ;
         ADB  R47,=10C
         ICM  R36              ;
         RTN                   ;

EFORM    CLB  R2               ;
         TSB  R73              ;
         RZR
         LDB  R22,='E'
         PUBD R22,+R30         ;
         LDB  R22,='+'-'0'
         ELM  R36              ;
         IFEN
           TCM  R36              ;
           LDB  R22,='-'
           PUBD R22,+R30         ;
         ELSE
           JSB  =CNDOU
         ENDIF
         BCD                   ;
         LDB  R32,=3C
         LOOP
           ELM  R36              ;
           CLB  R22              ;
           ELB  R22              ;
           IFNZ
             LDB  R73,=1           ;
           ENDIF
           JSB  =CNDOU
           BCD                   ;
           DCB  R32              ;
         WHNZ
         RTN                   ;

CNDOU    BIN                   ;
         TSB  R73              ;
         JOD  OUT2
         ICB  R2               ;
         RTN                   ;

OUT2     BIN                   ;
         ADB  R22,='0'
         PUBD R22,+R30         ;
         RTN                   ;
       TITLE 'krlcd'
*
*  __________________________________________________________________
* |KRLCD 261 07/14/82 - 7/19/1982 10:10PM                            |
* |==================================================================|
* ||                                                                ||
* ||   @@     @@@  @@@@@@@@    @@             @@@@     @@@@@@       ||
* ||   @@    @@@   @@@@@@@@@   @@           @@@@@@@@   @@@@@@@@     ||
* ||   @@   @@@    @@     @@@  @@          @@@    @@@  @@    @@@    ||
* ||   @@  @@@     @@      @@  @@          @@      @@  @@      @@   ||
* ||   @@ @@@      @@     @@   @@          @@          @@      @@   ||
* ||   @@@@@       @@@@@@@     @@          @@          @@      @@   ||
* ||   @@@@@       @@@@@@@     @@          @@          @@      @@   ||
* ||   @@ @@@      @@    @@@   @@          @@          @@      @@   ||
* ||   @@  @@@     @@     @@@  @@          @@      @@  @@      @@   ||
* ||   @@   @@@    @@      @@  @@          @@@    @@@  @@    @@@    ||
* ||   @@    @@@   @@      @@  @@@@@@@@@@   @@@@@@@@   @@@@@@@@     ||
* ||   @@     @@@  @@      @@  @@@@@@@@@@     @@@@     @@@@@@       ||
* ||                                                                ||
* ||                  Last editon on: 820813.1411                   ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
LCDOUT   SAD                   ;
         BIN                   ;
         PUMD R20,+R6          ;
         PUBD R32,+R6          ;
         LDBD R2,=CREST        ;
         IFNZ
           CMB  R2,='C'
           IFEQ
             ICB  R2               ;
             STBD R2,=CREST        ;
             LDB  R2,R32           ;
             ANM  R2,=31D,0
             ADM  R2,=LCDBUF       ;
             STMD R2,=LCDPTR       ;
             LDM  R2,=LCDBUF       ;
             CMMD R2,=LCDWIN       ;
             IFNE
               STMD R2,=LCDWIN       ;
               JSB  =PUTWIN          ;
             ENDIF
           ELSE
             CLB  R2               ;
             STBD R2,=CREST        ;
           ENDIF
           JMP  RTN...
         ENDIF

         LDBD R2,=DEAD         ;
         IFNZ
           CLB  R2               ;
           STBD R2,=DEAD         ;
           JSB  =CLRLCD          ;
         ENDIF
         LDBD R2,=LCDESC       ;
         IFNZ
           CLB  R2               ;
           STBD R2,=LCDESC       ;
           DRP  R32              ;
           JSB  =LOOKUP          ;
           DEF  ESCTAB
           JSB  X0,0H
           JMP  RTN...
         ENDIF

         DRP  R32              ;
         JSB  =LOOKUP          ;
         DEF  CHARS
         IFEZ
           JSB  X0,ZRO           ;
           JMP  RTN...
         ENDIF
         JSB  =INWIND          ;
         DRP  R32              ;
         JSB  =SEARCH          ;
         DEF  TRANS1
         IFEZ
           LDBD R32,X0,TRANS2
         ENDIF
         JSB  =DOSEE           ;
         DRP  !2
         LDBD R2,=I/RFLG       ;
         IFZR
           JSB  =CH2LCD          ;
         ELSE
           JSB  =INSCHR
         ENDIF
 
RTN...   POBD R32,-R6          ;
         POMD R20,-R6          ;
         JSB  =CURSE?          ;
         PAD                   ;
         RTN                   ;

CHARS    VAL  BS
         DEF  BSCHAR
         VAL  CR
         DEF  CRCHAR
         VAL  LF
         DEF  LFCHAR
         VAL  ESC
         DEF  ESCLCD
         DATA  0

TRANS1   VAL  127D
         VAL  127D+(BIT#7)
         VAL  126D
         VAL  126D+(BIT#7)
         DATA  0

TRANS2   VAL  LF
         VAL  (LF)+(BIT#7)
         VAL  BS
         VAL  (BS)+(BIT#7)

ESCTAB   DATA 'C'
         DEF  FORWRD
         DATA 'D'
         DEF  BSCHAR
         DATA 'E'
         DEF  CLRLCD
         DATA 'G'
         DEF  CRCHAR
         DATA 'H'
         DEF  CRCHAR
         DATA 'J'
         DEF CLREOL
         DATA 'K'
         DEF  CLREOL
         DATA 'O'
         DEF  DELCHR
         DATA 'P'
         DEF  DELCHR 
         DATA '<'
         DEF  DECURS
         DATA '>'
         DEF  CURSE
         DATA '%'
         DEF  ADDR
         DATA  0
         DEF  RETURN

ESCLCD   LDB  R#,=TRUE
         STBD R#,=LCDESC       ;
         RTN                   ;

LFCHAR   LDB  R#,=TRUE
         STBD R#,=DEAD         ;
         JSB  =ATTN?           ;
         IFEZ
           JSB  =DEQUE           ;
         ENDIF
         PUMD R40,+R6          ;
         CLB  R40              ;
         ICB  R40              ;
         LDMD R43,=DELAY       ;
         JSB  =WCKJSB          ;
         POMD R40,-R6          ;
         RTN                   ;

CRCHAR   JSB  =LCDRST
         JMP  PUTWIN           ;

CLREOL   LDMD R2,=LCDPTR       ;
         LDB  R20,=BLANK
krlcd_l1 CMM  R2,=((LCDBUF)+96D).2
         JHS  PUTWIN           ;
         PUBD R20,+R2          ;
         JMP  krlcd_l1

BSCHAR   LDMD R#,=LCDPTR      ;
         DCM  R#             ;
         CMM  R#,=LCDBUF      ;
         RLO
         STMD R#,=LCDPTR      ;
         CMMD R#,=LCDWIN      ;
         RHS
         STMD R#,=LCDWIN      ;

PUTWIN
         LDBD R2,=LCDOFF       ;
         RNZ
         PUMD R20,+R6          ;
         LDMD R20,=LCDWIN      ;
         PUMD R30,+R6          ;
         LDBD R30,=MINMIN      ;
         LOOP
           POBD R31,+R20         ;
           DRP  R30              ;
           JSB  =TOLCD           ;
           DRP  !30
           DCB  R30               ;
           CMBD R30,=MAXMAX       ;
         WHHS
         JSB  =CURSE?          ;
         POMD R30,-R6          ;
         POMD R20,-R6          ;
         RTN                   ;

CH2LCD   STBI R32,=LCDPTR      ;
         LDBD R20,=LCDOFF      ;
         IFZR
           LDMD R20,=LCDPTR      ;
           SBMD R20,=LCDWIN      ;
           SBBD R20,=MINMIN      ;
           TCB  R20              ;
           LDB  R21,R32          ;
           DRP  R20              ;
           JSB  =TOLCD           ;
         ENDIF

FORWRD   LDMD R2,=LCDPTR       ;
         CMM  R2,=((LCDBUF)+95D).2
         RHS
         ICM  R2               ;
         STMD R2,=LCDPTR       ;
         RTN                   ;

JMPPUT   JMP  PUTWIN           ;
 
DELCHR   LDMD R20,=LCDPTR      ;
         ICM  R20              ;
krlcd_2  JSB  =GETEND
         DCM  R2               ;
         CMM  R2,R20           ;
         JLO  krlcd_l3
         POBD R32,+R20         ;
         STBD R32,X20,(0-2).2
         JMP  krlcd_2

krlcd_l3 LDB  R2,=BLANK
         PUBD R2,-R20          ;
         JMP  JMPPUT

INSCHR   JSB  =GETEND
         DCM  R2               ;
         STM  R2,R20           ;
krlcd_l4 CMMD R20,=LCDPTR      ;
         JLO  BEFORE
         POBD R2,+R20          ;
         STBD R2,R20           ;
         POMD R2,-R20          ;
         JMP  krlcd_l4

BEFORE   ICM  R20              ;
         PUBD R32,+R20         ;
         STMD R20,=LCDPTR      ;
         JMP  JMPPUT

GETEND   LDMD R2,=LASTCH       ;
         SBMD R2,=INPTR        ;
         ICM  R2               ;
         ADMD R2,=LCDPTR       ;
         CMM  R2,=LCDBUF       ;
         IFLO
           LDM  R2,=LCDBUF       ;
         ENDIF
         CMM  R2,=((LCDBUF)+96D).2
         IFHS
           LDM  R2,=((LCDBUF)+96D).2
         ENDIF
         RTN                   ;
       TITLE 'krdio'
*  __________________________________________________________________
* |MJDIO 127 07/14/82 - 7/21/1982 2:22PM                             |
* |==================================================================|
* ||                                                                ||
* ||   @@      @@    @@@@@@@@  @@@@@@      @@@@@@@@@@    @@@@@@     ||
* ||   @@@    @@@    @@@@@@@@  @@@@@@@@    @@@@@@@@@@   @@@@@@@@    ||
* ||   @@@@  @@@@        @@    @@    @@@       @@      @@@    @@@   ||
* ||   @@@@@@@@@@        @@    @@      @@      @@      @@      @@   ||
* ||   @@  @@  @@        @@    @@      @@      @@      @@      @@   ||
* ||   @@  @@  @@        @@    @@      @@      @@      @@      @@   ||
* ||   @@      @@        @@    @@      @@      @@      @@      @@   ||
* ||   @@      @@        @@    @@      @@      @@      @@      @@   ||
* ||   @@      @@  @@    @@    @@      @@      @@      @@      @@   ||
* ||   @@      @@  @@@  @@@    @@    @@@       @@      @@@    @@@   ||
* ||   @@      @@   @@@@@@     @@@@@@@@    @@@@@@@@@@   @@@@@@@@    ||
* ||   @@      @@    @@@@      @@@@@@      @@@@@@@@@@    @@@@@@     ||
* ||                                                                ||
* ||                  Last editon on: 820908.1334                   ||
* |==================================================================|
* |__________________________________________________________________|
* *******************************************************************;
* *******************************************************************;
G1$OR*   STB  R14,R36          ;
         JSB  =SCAN            ;
         JMP  krdio_l1
G01$/*   STB  R14,R36          ;
         JSB  =SCAN            ;
         JSB  =EOL14?          ;
         IFEN
krdio_l1   JSB  =STR?*?          ;
         ENDIF
         PUBD R36,+R12         ;
         RTN                   ;
STR?*?   CMB  R14,=STARTK
         IFEQ
           LDM  R45,=6,1,'*'      ;
           PUMD R45,+R12         ;
           JSB  =SCAN            ;
           RTN                   ;
         ENDIF
         JSB  =STRX-!          ;
         RTN                   ;
         DATA 241
DSPIS.   LDM  R74,=
         VAL  (NOT#4)&(NOT#3)
         VAL  (BIT#4)
         VAL  (NOT#0)
         VAL  (BIT#0)
         JMP  krdio_l2

         DATA 241
PRINS.   LDM  R74,=
         VAL  (NOT#2)&(NOT#1)
         VAL  (BIT#2)
         VAL  (NOT#7)
         VAL  (BIT#7)
         
krdio_l2 JSB  =MELJSB          ;
         DEF  DEVOK            ;
         RTN                   ;

STAR?    DRP  R26              ;
         JSB  =GETAD#          ;
         ARP  !12
         POMD R24,-R12          ;
         RZR
         CMM  R24,=1,0
         RNZ
         LDB  R2,='*'
         CMBD R2,R26           ;
         RTN                   ;

         DATA 241
CONFIG   CLB  R53              ;
         LDM  R40,=
TAB      DATA 'devfile '
         JSB  =ONR12?          ;
         IFEN
           ICB  R53              ;
           JSB  =STAR?           ;
           IFZR
CLEAN+       JSB  =FPURGE          ;
CLEAN-       LDMD R2,=DEVCNT       ;
             ANM  R2,=0,301
             STMD R2,=DEVCNT       ;
DONE         JSB  =UNLSND          ;
             JSB  =UNTSND          ;
CHANGE       JSB  =HANDI0          ;
             VAL  V.ASSN
             CLE                   ;
             RTN                   ;
           ENDIF
           STMD R26,=KLUDGE      ;
         ENDIF

         JSB  =MELJSB          ;
         DEF  WAKEUP
         RZR
         JEN  CLEAN+
         JSB  =FPURGE          ;
         LDMD R2,=DEVCNT       ;
         ANM  R2,=0FFH,300
         STMD R2,=DEVCNT       ;
         STB  R2,R54           ;
         IFZR
           JSB  =ERROR           ;
           DATA 56D
           JMP  CHANGE           ;
         ENDIF
         TSB  R53              ;
         IFZR
           LDM  R20,=(ONLP).2        ;
           JSB  =NUMIN
         ENDIF
         JSB  =MAKEIT          ;
         JEN  CLEAN-           ;
         CLM  R76              ;
         LDMD R26,=KLUDGE      ;
         CLB  R50              ;
MORE?    DRP  !50
         ICB  R50              ;
MORE     JSB  =GETIT
         IFEN
           DCE                   ;
           JEZ  DO.CR
CL...      JMP  CLEAN+
         ENDIF
         JSB  =THERE?          ;
         JSB  =CHKEND          ;
krdio_l3 JZR  PUTIT
         LDMD R20,X36,DNAME
         CMM  R20,R66          ;
         IFNE
           JSB  =SKPCHK          ;
           JMP  krdio_l3
         ENDIF
         TSB  R53              ;
         IFZR
           JSB  =WARN            ;
           DATA 64D
           JMP  MORE
         ENDIF
         JSB  =ERROR           ;
         DATA 64D
CL..     JMP  CL...

PUTIT    BCD                   ;
         ICM  R76              ;
         BIN                   ;
         STMD R26,=KLUDGE      ;
         CLM  R32              ;
         STBD R32,=((TMPMM2)+(SETUP)-3).2
         LDBD R32,=DEVLEN      ;
         LDM  R34,=TMPMM2      ;
         STMD R66,=((TMPMM2)+(DNAME)-3).2
         STBD R50,=((TMPMM2)+(DADDR)-3).2
         JSB  =FSREPL          ;
         LDMD R26,=KLUDGE      ;
         JEN  CL..
         CMB  R50,R54          ;
         JNC  MORE?

         TSB  R53              ;
         IFNZ
           TSM  R24              ;
           IFNZ
             JSB  =WARN            ;
             DATA 59D
           ENDIF
         ENDIF
TURNON   STBD R50,=DEVCNT      ;
         GTO DONE              ;

DO.CR    DCB  R50              ;
         JZR  CL..
         JMP  TURNON

GETIT    CLE                   ;
         TSB  R53              ;
         JZR  FRMKBD
         JSB  =GETSTR
         IFEZ
           CMB  R32,=3           ;
           JCY  BADD
           JSB  =DIGORB
           JEN  BADD
         ENDIF
         RTN                   ;

GETSTR   CLE                   ;
         LDM  R36,R24          ;
         JZR  BADICE
         DCM  R36              ;
         POBD R31,+R26         ;
         CMB  R31,=':'
         JNZ  BADD
         LDB  R31,=8D
         JSB  =GETFST          ;
         JEN  BADD
         LDMD R66,R34          ;
         LDM  R24,R36          ;
         RZR
         CMB  R20,=','
         REQ
BADD     JSB  =ERR1            ;
         DATA 63D
BADICE   ICE                   ;
         RTN                   ;

FRMKBD   LDM  R22,=INPBUF      ;
         LDM  R20,=(DEVICE).2      ;
         JSB  =MVBYTS          ;
         STB  R50,R20          ;
         LDM  R22,=(INP+8).2       ;
         JSB  =NUMOUT          ;
NOGOOD   LDM  R20,=(INPBUF).2      ;
         LDM  R22,=(INP+13).2      ;
         LDM  R24,=20,0
         LDM  R2,=(SHIELD_DIO).2
         JSB  =GETTER          ;
         CLE                   ;
         CMB  R25,=ATTNKY
         JZR  BADICE
         CMB  R25,=CLRKEY
         JZR  FRMKBD
         LDM  R26,=(INP+13).2      ;
         LDMD R66,R26          ;
         CMM  R66,='  '
         JZR  BADICE
         LDM  R36,=2,0
         STB  R36,R31          ;
         JSB  =GETFST          ;
         LDMD R66,R34          ;
         JEN  ERR
         CMB  R32,=2           ;
         JEQ  GOTEM
         CMB  R20,=' '
         JZR  GOTEM
ERR      JSB  =WARN            ;
         DATA 63D
         JMP  NOGOOD
GOTEM    JSB  =DIGORB
         JEN  ERR
         RTN                   ;

DIGORB   LDB  R20,R66          ;
         JSB  =DIGIT           ;
         DRP  !20
         IFEZ
           CMB  R20,=' '
           RNE
         ENDIF
         LDB  R20,R67           ;
         JSB  =DIGIT           ;
         DRP  !20
         REN         
         CMB  R20,=' '
         JEQ  BADICE
         RTN                   ;

GETPAD   CMB  R32,=3           ;
         JCY  NOT.US
         JSB  =THERE!          ;
krdio_l4 LDMD R20,X36,DNAME
         CMM  R20,R66          ;
         IFNE
           JSB  =SKPCHK          ;
           JNZ  krdio_l4
NOT.US     JSB  =HANDI           ;
           VAL  V.ADDR
           DATA 63D
           JSB  =ANYER?          ;
           RTN                   ;
         ENDIF
         LDBD R20,X36,RM.PAR    ;
         RTN                   ;

GET#1    DRP  R26              ;
         JSB  =GETAD#          ;
         ARP  !12
         POMD R24,-R12         ;
GET#2+   JSB  =GETSTR
         REN
         JSB  =GETPAD          ;
         IFEZ
           TSM  R36              ;
           RNZ
         ENDIF
         ICE                   ;
         RTN                   ;

         DATA 241
LSTIO.   JSB  =THERE!          ;
         LDM  R20,=(BLNK).2        ;
         JSB  =NUMIN
krdio_l5 LDM  R20,=(DEVIC+).2      ;
         JSB  =MOVEIT          ;
         LDBD R20,X36,DADDR
         LDM  R22,=((TMPMM2)+9D).2
         JSB  =NUMOUT          ;
         DRP  !20
         LDMD R20,X36,DNAME
         STMD R20,=((TMPMM2)+14D).2
         JSB  =FINMSG          ;
         JSB  =SKPCHK          ;
         JNZ  krdio_l5
         RTN                   ;

         DATA 241
REST.    JSB  =THERE!          ;
         LDMD R66,=DEVCNT      ;
         JSB  =MELJSB          ;
         DEF  WAKEUP
         LDMD R2,=DEVCNT       ;
         ANM  R3,=BIT#0
         ORB  R67,R3           ;
         STMD R66,=DEVCNT      ;
         REN
         CMB  R2,R66           ;
         IFNG
           JSBN  =ERROR+          ;
           DATA  59D
         ENDIF
         JSB  =CLROFF          ;
         GTO DONE              ;

         DATA 241
OFFIO.   JSB  =THERE!          ;
OFFUNL   JSB  =CLROFF          ;
         JSB  =UNLSND          ;
         RZR
OFFIO+
SETOFF   LDB  R2,=(BIT#5)|(BIT#0)
         JMP  krdio_l6
CLROFF   CLB  R2               ;
krdio_l6 LDMD R3,=PLSTAT       ;
         ANM  R3,=(NOT#5)
         JMP  SETIT            ;

LPOFF    JSB  =CL.ACT          ;
         LDB  R2,=1            ;
         JMP  krdio_l7

LOPN     CLB  R2               ;
krdio_l7 LDMD R3,=PLSTAT       ;
         ANM  R3,=NOT#0
SETIT    ORB  R3,R2            ;
STORIT   STBD R3,=PLSTAT       ;
         RTN                   ;

CLRTMT   LDBD R2,=PLSTAT       ;
         STB  R2,R3            ;
         ANM  R2,=
           VAL (BIT#5)|(BIT#0)
           VAL NOT#0
         TSB  R2               ;
         JLZ  STORIT
         RTN                   ;

         DATA 241
CLOOP.   BIN                   ;
         LDB  R57,=DCL_
         JSB  =CMDREP          ;
         RTN                   ;
         
         DATA 241
CLDEV.   BIN                   ;
         JSB  =GET#1           ;
OK?      REN
         JSB  =UNLREP          ;
         REN
         LDB  R57,=LAD_
         ORB  R57,R20          ;
         JSB  =CMDREP          ;
         IFEZ
           LDB  R57,=SDC_
           JSB  =CMDREP          ;
         ENDIF
         JSB  =UNLREP          ;
         REN
         JSB  =GET#2+          ;
         JMP  OK?

THERE?   BIN                   ;
         LDMD R40,=TAB         ;
         JSB  =FLOPEN          ;
         RTN                   ;

THERE!   JSB  =THERE?          ;
         REZ
         JSB  =ERR1            ;
         DATA 55D
         DCM  R6               ;
         DCM  R6               ;
         RTN                   ;

SKPCHK   JSB  =SKPLN           ;
CHKEND   LDMD R2,R36           ;
         CMM  R2,=ENDLIN       ;
         RTN                   ;

NUMIN    JSB  =MOVEIT          ;
         LDM  R22,=((TMPMM2)+1).2
         LDBD R20,=DEVCNT      ;
         JSB  =NUMOUT          ;
         JSB  =FINMSG          ;
         RTN                   ;

MOVEIT   LDM  R22,=TMPMM2      ;
         JSB  =MVBYTS          ;
         RTN                   ;

BLNK     DATA 26
         DATA  25               ;
         DATA  "   Device(s) assigned" ;
DEVIC+   DATA  21               ;
DEVICE   DATA  20               ;
         DATA  "Device #  "     ;
         DATA  "=':  '"         ;
ONLP     DATA  25               ;
         DATA  24               ;
         DATA  "   Device(s) on loop" ;

SHIELD_DIO
         DATA  (0-1-2).1              ;
         DATA  11111111B,11111001B              ;
       TITLE 'krreg'
*
*  __________________________________________________________________
* |IVREG 449 05/10/82 - 5/13/1982 4:06PM                             |
* |==================================================================|
* ||                                                                ||
* ||   @@@@@@@@@@  @@      @@  @@@@@@@@    @@@@@@@@@@     @@@@      ||
* ||   @@@@@@@@@@  @@      @@  @@@@@@@@@   @@@@@@@@@@   @@@@@@@@    ||
* ||       @@      @@      @@  @@     @@@  @@          @@@    @@@   ||
* ||       @@      @@      @@  @@      @@  @@          @@      @@   ||
* ||       @@       @@    @@   @@     @@   @@          @@           ||
* ||       @@       @@    @@   @@@@@@@     @@@@@@@@@   @@           ||
* ||       @@       @@    @@   @@@@@@@     @@@@@@@@@   @@   @@@@@   ||
* ||       @@        @@  @@    @@    @@@   @@          @@   @@@@@   ||
* ||       @@         @@@@     @@     @@@  @@          @@      @@   ||
* ||       @@         @@@@     @@      @@  @@          @@@    @@@   ||
* ||   @@@@@@@@@@      @@      @@      @@  @@@@@@@@@@   @@@@@@@@    ||
* ||   @@@@@@@@@@      @@      @@      @@  @@@@@@@@@@     @@@@      ||
* ||                                                                ||
* ||                  Last editon on: 820908.1333                   ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
EVIL     POMD R2,-R6           ;
         POMD R0,+R2           ;
         STMD R0,=PROTEM       ;
         BIN                   ;
         ARP  R6
         LOOP
           ARP  !6
           PUBD R*,+R6           ;
           ADM  R0,=1,1
         WHNG
         LDMD R0,=PROTEM       ;
         PUMD R0,+R6           ;
         JSB  X2,ZRO           ;
         POMD R2,-R6           ;
         BIN                   ;
         SBB  R2,R3            ;
         DCB  R2               ;
         STM  R2,R0            ;
         ARP  R6
         LOOP
           POBD R*,-R#           ;
           ADM  R0,=377,0
         WHNG
         RTN                   ;
       TITLE 'krpun'
*
*  __________________________________________________________________
* |IVPUN 445 06/09/82 - 6/16/1982 10:55AM                            |
* |==================================================================|
* ||                                                                ||
* ||   @@@@@@@@@@  @@      @@  @@@@@@@@    @@      @@  @@      @@   ||
* ||   @@@@@@@@@@  @@      @@  @@@@@@@@@   @@      @@  @@      @@   ||
* ||       @@      @@      @@  @@     @@@  @@      @@  @@@     @@   ||
* ||       @@      @@      @@  @@      @@  @@      @@  @@@@    @@   ||
* ||       @@       @@    @@   @@     @@@  @@      @@  @@ @@   @@   ||
* ||       @@       @@    @@   @@@@@@@@@   @@      @@  @@  @@  @@   ||
* ||       @@       @@    @@   @@@@@@@@    @@      @@  @@  @@  @@   ||
* ||       @@        @@  @@    @@          @@      @@  @@   @@ @@   ||
* ||       @@         @@@@     @@          @@      @@  @@    @@@@   ||
* ||       @@         @@@@     @@          @@@    @@@  @@     @@@   ||
* ||   @@@@@@@@@@      @@      @@           @@@@@@@@   @@      @@   ||
* ||   @@@@@@@@@@      @@      @@            @@@@@@    @@      @@   ||
* ||                                                                ||
* ||                  Last editon on: 820908.1354                   ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
         DATA  36               ;
PRSTR.   JSB  =GETSTS
         DRP  R46              ;
         JSB  =GETAD#          ;
         ARP  !12
         POMD R2,-R12           ;
         STM  R2,R44           ;
         JSB  =CALSCN
         JNG  P$RTN
         BIN                   ;
         TSM  R54              ;
         IFZR
           LDM  R54,R44          ;
           CLM  R56              ;
           TSM  R54              ;
           JZR  COMRTN
           DCB  R73              ;
         ENDIF
         TSB  R73              ;
         JPS  FMTER1
         JSB  =RESFIL          ;
         JEN  P$RTN
         LDM  R34,R46          ;
         LDM  R32,R44          ;
         CMM  R32,R54          ;
         IFCY
           LDM  R32,R54          ;
           STM  R32,R44          ;
         ENDIF
         LDM  R30,R26          ;
         JSB  =COPY            ;

COMRTN   LDM  R36,R54          ;
         JSB  =PRNFMT          ;
P$RTN    CLB  R22              ;
         STBI R22,=P_FLAG      ;
         RTN                   ;

PRNUM.   JSB  =GETSTS
         JSB  =ONER            ;
OUTNUM   STMD R40,=RESULT      ;
         JSB  =CALSCN
         JNG  P$RTN
         TSM  R54              ;
         IFZR
           JSB  =ARITH           ;
           BIN                   ;
           TSB  R70              ;
           IFPS
             ICM  R54              ;
           ENDIF
           CLM  R66              ;
         ENDIF
         TSB  R73              ;
         JNG  FMTER1
         JSB  =RESFIL          ;
         JEN  P$RTN
         JSB  =FORMN           ;
         JMP  COMRTN

FMTER1   JSBN  =ERROR+          ;
         DATA 53D
GETSTS
         BIN                   ;
         LDBD R20,=TOKEN       ;
         IFEV
           LDBD R20,=USING?      ;
           IFNZ
             LDB  R20,=1           ;
           ENDIF
         ENDIF
         RTN                   ;

RESFIL   LDM  R56,R54          ;
         JSB  =RSMEM-          ;
         REN

BLKFIL   LDM  R36,R26          ;
         LDB  R23,=3           ;
         BIN                   ;
         PUMD R66,+R6          ;
         PUMD R70,+R6          ;
         JSB  =ZROMEM          ;
         POMD R70,-R6          ;
         POMD R66,-R6          ;
         RTN                   ;

CALSCN   PUMD R40,+R6          ;
         PUMD R10,+R6          ;
         PUMD R20,+R6          ;
         JSB  =SCANN           ;
         POMD R20,-R6          ;
         POMD R10,-R6          ;
         POMD R40,-R6          ;
         TSB  R17              ;
         RTN                   ;
       TITLE 'kron'
*
*  __________________________________________________________________
* |IVON 310 05/10/82 - 5/13/1982 3:55PM                              |
* |==================================================================|
* ||                                                                ||
* ||         @@@@@@@@@@  @@      @@    @@@@@@    @@      @@         ||
* ||         @@@@@@@@@@  @@      @@   @@@@@@@@   @@      @@         ||
* ||             @@      @@      @@  @@@    @@@  @@@     @@         ||
* ||             @@      @@      @@  @@      @@  @@@@    @@         ||
* ||             @@       @@    @@   @@      @@  @@ @@   @@         ||
* ||             @@       @@    @@   @@      @@  @@  @@  @@         ||
* ||             @@       @@    @@   @@      @@  @@  @@  @@         ||
* ||             @@        @@  @@    @@      @@  @@   @@ @@         ||
* ||             @@         @@@@     @@      @@  @@    @@@@         ||
* ||             @@         @@@@     @@@    @@@  @@     @@@         ||
* ||         @@@@@@@@@@      @@       @@@@@@@@   @@      @@         ||
* ||         @@@@@@@@@@      @@        @@@@@@    @@      @@         ||
* ||                                                                ||
* ||                  Last editon on: 820908.1333                   ||
* |==================================================================|
* |__________________________________________________________________|
*
* ********************************************************************
* ********************************************************************
ON/OFF   STB  R14,R36          ;
         JSB  =SCAN            ;
ONOFF2   CMB  R14,=(OFFTOK).2
         JZR  FOUND_ON            ;
         CMB  R14,=(ONTOK).2
         JNZ  ERR91_ON         ;
         LDB  R14,=(ONGUY).2
FOUND_ON
         DRP  !14
         PUBD R14,+R12          ;
         PUBD R36,+R12         ;
         JSB  =SCAN            ;
         RTN                   ;
ERR91_ON JSBN  =ERROR+          ;
         DATA 91D              ;
         DATA  0,46             ;
ONTOK.   LDB  R#,=1            ;
         JMP  PUBD             ;
*
         DATA  0,46             ;
OFTOK.   CLB  R#               ;
PUBD     PUBD R#,+R12          ;
         RTN                   ;
       END
