     0          ABS ROM 60000
     1 GETTYP   DAD 61716
     2 STRB-    DAD 62661
     3 DIRSCN   DAD 63143             ! Scan the directory in MSROM
     4 MSLDB.   DAD 63604             ! LOADBIN runtime entry in MSROM
     5 LOADBR   DAD 63770
     6 TYPOK2   DAD 64157
     7 MSCRE.   DAD 65256
     8 ASSIG.   DAD 65571
     9 MSPRT.   DAD 66312
    10 PR#$     DAD 66762
    11 RD#$     DAD 67457
    12 CKMSUS   DAD 70235
    13 MSIN     DAD 70253
    14 TAPDS-   DAD 70740
    15 ASTAR    DAD 25016             ! addr in sytem ROM of a '*' (byte 052)
    16 BEGWRI   DAD 100710            ! first byte of what to write to a file
    17 ENDWRI   DAD 100712            ! last byte of what to write to a file
    18 AIFFLG   DAD 100714            ! conditional-asm flg, non-0 to assemble
    19 ASTLIN   DAD 100716            ! ptr to start of line we're assembling
    20 ALBTBL   DAD 100720            ! ptr to beginning of label table
    21 ACODBA   DAD 100722            ! ptr to end of LblTbl, start of code
    22 ACODEN   DAD 100724            ! ptr to end of code being assembled
    23 ALAVAI   DAD 100726            ! ptr to end of avail space for assemble
    24 ABNLEN   DAD 100730            ! length of ABPNAM (see below)
    25 GNMLEN   DAD 100732            ! len of GLOFNM
    26 CURARP   DAD 100736            ! curr ARP during assembly (377 if undef)
    27 CURDRP   DAD 100737            ! curr DRP during assembly (377 if undef)
    28 ALODBP   DAD 100740            ! dont-load-bpgm flag after ASSEMBLE
    29 ABPNAM   DAD 100746            ! targ filename for bpgm being assembled
    30 GLOFNM   DAD 100767            ! filename for included global file
    31 ILNMAB   DAD 101201            ! if set, illegal (MSbit=NAM LSbit=ABS)
    32 ISGLO    DAD 101202            ! =0 if this is a global file, else non-0
    33 ISAROM   DAD 101203            ! ABS ROM or not
    34 GOODLI   DAD 101204            ! non-0 at end of line ASSM line parse
    35 LSTFLG   DAD 101205            ! whether LST is on or off
    36 AERCNT   DAD 101206            ! error count during ASSEMBLE
    37 ORGBAS   DAD 101212            ! ORG base address
    38 ABSBAS   DAD 101214            ! base address for absolute code
    39 RRSTK    DAD 101306            ! stack for returning from ROMJSB to EXEC
    40 END16K   DAD 140000            ! end of RAM on 16K machine
    41 SVCIO    DAD 100143            ! 8-byte block ends with SVCWRD and IOSW
    42 OUTBUF   EQU 0                 ! scratch buf for ASM ROM input/output
    43 ROMPEK   EQU 40                ! buf for code to read byte from ROMs
    44 MEMADR   EQU 50                ! mem dump addr (8-byte REAL/INT number)
    45 MEMROM   EQU 60                ! ROM# from which to do a MEM dump
    46 MEMLEN   EQU 61                ! length of a MEM dump
    47 MEMPTR   EQU 63                ! address we're currently dumping from
    48 MEMR6    EQU 65                ! place to save R6 during MEM statement
    49 DBSAV1   EQU 67                ! system RAM save during bkp interrupt
    50 DBSAV2   EQU 77                ! ditto
    51 DBSAV3   EQU 107               ! ditto
    52 DBSAV4   EQU 117               ! ditto
    53 DBSAV5   EQU 127               ! ditto
    54 DBSAV6   EQU 137               ! ditto
    55 DB?1     EQU 147               ! don't think this is ever used!
    56 DBS.C.   EQU 150               ! output select code for debugging output
    57 TRCCNT   EQU 160               ! count from Trace command at breakpoint
    58 DBBKP2   EQU 162               ! address BREAKPOINT #2 is set to
    59 DBGWRS   EQU 164               ! last state written to DEBSTS
    60 DBBKP1   EQU 165               ! address BREAKPOINT #1 is set to
    61 EOLREM   EQU 167               ! 0 hides EOL remarks, non-0 shows them
    62 ASMMOD   EQU 170               ! 0 if in BASIC, non-0 if in ASSEMBLER
    63 BKPSAV   EQU 171               ! BREAKPOINT save during single-step
    64 ASMSIZ   EQU 174               ! how many bytes to reserve for ASM RAM
    65 P.TYPE   EQU 6                 ! Pgm type in Program Control Block (PCB)
    66 P.LEN    EQU 7                 ! Program LENGTH in PCB
    67 P.SFLG   EQU 25                ! Program security flags in PCB
    68 P.BASE   EQU 30                ! Abs addr at which BPGM was last loaded
    69 F.TYPE   EQU 7                 ! offset into LIF dir of file TYPE
    70 !
    71 ! HP-85 ASSEMBLER ROM
    72 !
    73 ! **********************************************************************
    74 ! NOTE: Because, while in ASSEMBLER mode, the key label area isn't used
    75 ! and gets re-initialized when returning to BASIC mode, the Assembler
    76 ! ROM sometimes uses that area (100710-101007) for temporary storage.
    77 ! See the DADs above for examples.
    78 ! **********************************************************************
    79 !
    80          BYT  50,327           ! ROM# and complement
    81          DEF  RUNTIM           ! runtime routines addresses
    82          DEF  TOKENS           ! TOKENS (ASCII keywords)
    83          DEF  PARSE            ! parse routine addresses
    84          DEF  ERMSGS           ! warning and error messages
    85 RUNTIM   DEF  INIT             ! ROM initialization routine
    86          DEF  ASMLR.           ! 01 ASSEMBLER
    87          DEF  BASIC.           ! 02 BASIC
    88          DEF  FREFS.           ! 03 FREFS
    89          DEF  MEMD.            ! 04 MEMD
    90          DEF  DEL.             ! 05 DELETE
    91          DEF  PLST.            ! 06 PLIST
    92          DEF  LST.             ! 07 LIST
    93          DEF  MEM.             ! 10 MEM
    94          DEF  ASMBL.           ! 11 ASSEMBLE
    95          DEF  ALOAD.           ! 12 ALOAD
    96          DEF  ASTOR.           ! 13 ASTORE
    97          DEF  SCRTB.           ! 14 SCRATCHBIN
    98          DEF  FLBL.            ! 15 FLABEL
    99          DEF  BKP.             ! 16 BKP
   100          DEF  CLR.             ! 17 CLR
   101          DEF  TREM.            ! 20 TREM
   102          DEF  REL.             ! 21 REL
   103          DEF  OCT.             ! 22 OCT
   104          DEF  DEC.             ! 23 DEC
   105          DEF  DEC.             ! 24 377 End of findable keywords
   106          DEF  ACOLN.           ! 25 :
   107          DEF  AEQUL.           ! 26 =
   108          DEF  ACOMA.           ! 27 ,
   109 PARSE    DEF  DMPMEM           ! 'hidden' dump memory token
   110          DEF  ASMLR            ! 01 ASSEMBLER
   111          DEF  BASIC            ! 02 BASIC
   112          DEF  FREFS            ! 03 FREFS
   113          DEF  MEMD             ! 04 MEMD
   114          DEF  ALIST            ! 05 DELETE
   115          DEF  ALIST            ! 06 PLIST
   116          DEF  ALIST            ! 07 LIST
   117          DEF  MEMD             ! 10 MEM
   118          DEF  ASSEMB           ! 11 ASSEMBLE
   119          DEF  FREFS            ! 12 ALOAD
   120          DEF  FREFS            ! 13 ASTORE
   121          DEF  ABCOM            ! 14 SCRATCHBIN
   122          DEF  FREFS            ! 15 FLABEL
   123          DEF  BKP              ! 16 BKP
   124          DEF  CLR              ! 17 CLR
   125          DEF  BASIC            ! 20 TREM
   126 TOKENS   ASP  "ASSEMBLER"      ! 01
   127 BASSTR   ASP  "BASIC"          ! 02
   128 FRESTR   ASP  "FREFS"          ! 03
   129          ASP  "MEMD"           ! 04
   130          ASP  "DELETE"         ! 05
   131          ASP  "PLIST"          ! 06
   132          ASP  "LIST"           ! 07
   133 MEMASP   ASP  "MEM"            ! 10
   134 ASSSTR   ASP  "ASSEMBLE"       ! 11
   135 ALDSTR   ASP  "ALOAD"          ! 12
   136 ASTSTR   ASP  "ASTORE"         ! 13
   137          ASP  "SCRATCHBIN"     ! 14
   138 FLASTR   ASP  "FLABEL"         ! 15
   139 BKPASP   ASP  "BKP"            ! 16
   140 CLRASP   ASP  "CLR"            ! 17
   141          ASP  "TREM"           ! 20
   142          ASP  "REL"            ! 21
   143          ASP  "OCT"            ! 22
   144          ASP  "DEC"            ! 23
   145          BYT  377              ! 24 End of searchable/findable keywords
   146          ASP  ":"              ! 25
   147          ASP  "="              ! 26
   148          ASP  ","              ! 27
   149 ERMSGS   JSB  =ROMJSB
   150          DEF  SCRAT.           ! do a SCRATCH command
   151          BYT  0
   152          RTN
   153 DODISP   JSB  =ROMJSB
   154          DEF  DISP.            ! set output to DISPLAY
   155          BYT  0
   156          RTN
   157 DOPRNT   JSB  =ROMJSB
   158          DEF  PRINT.           ! set output to PRINTER
   159          BYT  0
   160          RTN
   161 !
   162          ASP  "ILL MODE"       ! 11
   163          ASP  "LBL"            ! 12
   164 OPCOER   ASP  "OPCO"           ! 13
   165          ASP  "ARP-DRP"        ! 14
   166          ASP  "OPER"           ! 15
   167          ASP  "FIN-LNK"        ! 16
   168 MASMRM   ASP  "ASSM ROM"       ! 17
   169          BYT  377              ! End of ERROR MESSAGES table
   170 STBAS1   JSB  =GTABAS          ! Get ptr to ASM RAM in R14, leave ARP=14
   171          CLM  R40              ! clear R40-47
   172          STBD R40,X#,ASMMOD    ! Set ASMMOD to 0 (means "in BASIC mode")
   173          RTN
   174 ! ***************************************************************
   175 ! * ROM INITIALIZATION
   176 ! * ROMFL
   177 ! *   0	after system initialization at PWO (Power-On)
   178 ! *   1	after System RESET
   179 ! *   2	before SCRATCH
   180 ! *   3	after LOADBIN
   181 ! *   4	before RUN execution begins, after INIT allocation done
   182 ! *   5	before LOAD
   183 ! *   6	during STOP, PAUSE
   184 ! *   7	after CHAIN
   185 ! *  10	during allocation of class > 56
   186 ! *  11	during de-allocation of class > 56
   187 ! *  12	during decompile of class > 56
   188 ! *  13	during program halt on error
   189 ! ***************************************************************
   190 INIT     BIN
   191          LDBD R34,=ROMFL       ! Get reason for INIT call
   192          JNZ  NOTPWO           ! jif not PWO (power-on)
   193          LDMD R34,=FWUSER      ! it's PWO, steal RAM for ASMROM's use
   194          STMD R34,=ASMBAS      ! save the address in the ROM's RAM table
   195          ADM  R34,=ASMSIZ      ! move FWUSER (we use 174 = 124D bytes)
   196          STMD R34,=FWUSER      ! update ptr
   197          JSB  =ROMJSB
   198          DEF  SCRAT+           ! re-init to adjust for stolen RAM
   199          BYT  0
   200          JSB  =STBAS1          ! get ASM RAM in R14, DRP=40, ARP=14
   201          STMD R#,X#,MEMADR     ! zero 8 bytes
   202          STMD R#,X#,MEMROM     ! zero 8 more
   203          STMD R#,X#,DBGWRS     ! and another 8
   204          ICB  R#               ! set R40 = 1
   205          STMD R#,X#,TRCCNT     ! TRCCNT=1, seven more zeroed
   206          CLB  R#               ! set R40 back to 0
   207          LDB  R47,=20          ! make R40-R47 = REAL 1
   208          STMD R40,X#,DBS.C.    ! set DEBUG output Select Code to 1
   209          LDM  R32,=100,0
   210          STMD R32,X#,MEMLEN    ! set ASMBAS+61 = 100 (64D)
   211          LDM  R32,=R60K        ! base address of our ROM
   212          JSB  =RSUM8K          ! checksum it to make sure we're okay
   213          JZR  OKSUM            ! jif okay
   214          JSB  =AROMER          ! conditionally set ERRROM to ASMROM
   215          JSB  =ERROR           ! report error
   216          BYT  17               ! "ASSM ROM"
   217          JMP  OKSUM            ! continue
   218 BARST?   DCB  R#               ! BASIC mode, after reset?
   219          JZR  OKSUM            ! jif yes, nothing special to do
   220          RTN
   221 NOTPWO   JSB  =GETMOD          ! get ASM/BASIC mode -> R56
   222          DRP  R34              ! set DRP back to ROMFL reg
   223          JZR  BARST?           ! jif BASIC mode
   224          DCB  R34              ! ASM mode, after RESET?
   225          JNZ  NOTRST           ! jif no
   226          JSB  =ASMRST          ! do ASSEMBLER MODE reset
   227 OKSUM    JSB  =GTABAS          ! load ASM ROM base
   228          JSB  =RSTBK1          ! restore BKP1 if saved
   229          CLM  R76
   230          ICM  R76
   231          STMD R76,X14,TRCCNT   ! set TRCCNT to 1 (ie, NO trace)
   232 !
   233 ! When the System Monitor interrupts because a BREAKPOINT has been hit
   234 ! the CPU gets vectored to SPAR0, a RAM hook.  The Assembler ROM takes
   235 ! over SPAR0 so that it gets control, but SPAR0 isn't long enough to
   236 ! preserve everything it needs to preserve, jump to the ASM ROM, then
   237 ! restore everything on the return trip.  So, the ASM ROM takes over
   238 ! SPAR0 and points it to SAVR2 (in the CPU register save area), then
   239 ! copies the necessary code to SAVR2 to do all the dirty work of saving
   240 ! calling and restoring.
   241 !
   242 ! The following code is what copies the INTSVC routine code to SAVR2
   243 ! by loading a 45 (byte count) into R75 and the address of INTSVC into
   244 ! R76-77.  45 is actually more bytes than we need, but it doesn't hurt.
   245 !
   246 CPYHOK   BYT  175,251,45       ! DRP 75 - LDM R75,=45,INTSVC
   247          DEF  INTSVC
   248          LDM  R0,=SAVR2        ! destination address to R0
   249 CISLP    POBD R74,+R76         ! get next byte of INTSVC to r74
   250          PUBD R74,+R0          ! push it out to the SAVR2 buffer
   251          DCB  R75              ! dec byte count
   252          JNZ  CISLP            ! jif not done
   253 !
   254 ! This is the code that takes over SPAR0 and points it at SAVR2
   255 !
   256          BYT  174,251          ! DRP 74 -- LDM R74,= "JSB =SAVR2, RTN"
   257          JSB  =SAVR2           ! this is loaded into R74-77 along with
   258          RTN                   !   this, too
   259          STMD R#,=SPAR0        ! Take over SPAR0 with JSB=SAVR2 and RTN
   260 !
   261          LDMD R#,=ASMBAS       ! R74-75=ASMBAS, R76-77=junk, saves a DRP
   262          LDBD R#,X74,DBGWRS    ! get last command written to SysMon
   263          STBD R#,=DEBSTS       ! write it out (MSBit is clear)
   264          ADB  R#,=200          ! set MSbit
   265          STBD R#,=DEBSTS       ! write it again to set the MSbit
   266          STBD R#,=INTRSC       ! write any byte to INTRSC
   267 ARTN98   RTN
   268 !
   269 ! Don't allow LOADIN, RUN, LOAD, or STOP or PAUSE in ASSEMBLER MODE
   270 ! as those are BASIC mode things.
   271 !
   272 NOTRST   CMB  R#,=3            ! LOADBIN, RUN, LOAD, STOP/PAUSE?
   273          JNC  ARTN98           ! jif no, <3
   274          CMB  R#,=7            ! well?
   275          JCY  ARTN98           ! jif no, >=7
   276          CMB  R#,=6            ! STOP/PAUSE?
   277          JNZ  NOTSP            ! jif no
   278          JSB  =ERMSGS          ! Do Basic SCRATCH if STOP/PAUSE
   279 NOTSP    JSB  =AROMER          ! Set ERROR ROM# to ASSEMBLER
   280          JSB  =ERROR+          ! report ERROR
   281          BYT  11               ! "ILL MODE"
   282 !
   283 INTSVC   SAD                   ! save CPU flags
   284          STMD R74,=SAVR74      ! save r74-r77 in CPU register save area
   285          LDMD R74,=ERTEMP      ! save 4 bytes of ERTEMP on stack
   286          PUMD R74,+R6
   287          STMD R0,=SAVR0        ! save R0-1 in CPU register save area
   288          JSB  =ROMJSB          ! call ASM ROM's breakpoint svc routine
   289          DEF  BKPSVC
   290          BYT  50
   291          POMD R74,-R6          ! restore 4 bytes
   292          STMD R74,=ERTEMP      !  of ERTEMP
   293          LDMD R74,=SAVR74      ! restore r74-r77
   294          PAD                   ! restore CPU flags
   295          RTN                   ! return from the breakpoint
   296 !
   297 ASMSAV   BYT  143,200          ! save junk, PRALLM, PENUPF, SVCWRD, IOSW
   298          DEF  KEYHIT
   299          DEF  SCTEMP
   300          DEF  ERSV50
   301          DEF  DATLEN
   302          DEF  ERLIN#
   303 !
   304 ! Servce routine when a BREAKPOINT is encountered by the System Monitor
   305 ! We arrive here via SPAR0 -> SAVR2 -> here
   306 ! First, save all CPU registers.  R0-1 and R74-77 were already saved by
   307 ! code that was in SAVR2.  That code is about to be overwritten by the
   308 ! register save, but will be restored again on the way out after most
   309 ! of the registers are restored.
   310 !
   311 BKPSVC   LDM  R76,=SAVR2       ! address of register save area
   312          LDB  R0,=2            ! start reg to save, 0-1 were done before
   313          BIN                   ! make sure we're in BIN mode
   314 SREGLP   PUBD R*,+R76          ! save a CPU register in SAV*** area
   315          ICB  R0               ! bump register-indirect register
   316          CMB  R0,=74           ! Done? (R74-77 were already saved)
   317          JNZ  SREGLP           ! jif no, loop
   318 !
   319          BCD                   ! BCD shift 4-bit E register into R0
   320          CLB  R0
   321          ELB  R0               ! get E
   322          BIN                   ! back to BIN
   323          PUBD R0,+R6           ! save E on stack
   324 !
   325 ! When the System Monitor generates an interrupt because a breakpoint
   326 ! was hit, the current CPU address gets pushed on the stack and
   327 ! execution jumps to SPAR0. SPAR0 has been taken over and has a
   328 ! JSB=SAVR2 followed by a RTN, so execution quickly jumps to the
   329 ! SAVR2 RAM area, which has a copy of INTSVC (above) in it. That
   330 ! saves a few things that would otherwise get trashed by ROMJSB, and
   331 ! then calls ROMJSB to get here (BKPSVC).  So, at this point, the
   332 ! R6 stack looks like:
   333 !
   334 !  2 BYTES return from SPAR0 to wherever interrupted from
   335 !  2 BYTES return from INTSVC to SPAR0
   336 !  3 BYTES SAD (Save Arp/Drp and flags) in INTSVC
   337 !  4 BYTES ERTEMP save in INTSVC
   338 !  2 BYTES return from ROMJSB to INTSVC
   339 !  2 BYTES R0 in ROMJSB
   340 !  1 BYTE  current ROM# in ROMJSB
   341 !  2 BYTES return from BKPSVC to ROMJSB
   342 !  1 BYTE  E save in BKPSVC
   343 ! R6--->
   344 !
   345 ! So, the following copy of R6 and adding 17 (octal) to it points R20
   346 ! at the "return from INTSVC to SPAR0", and the POMD r44,-r20 gets the
   347 ! addr of the code about to be executed when the breakpoint occurred.
   348 !
   349          LDM  R20,R6           ! copy ptr to top of stack
   350          SBM  R20,=17,0        ! move back to breakpoint execution addr
   351          POMD R44,-R20         ! get addr where the breakpoint occurred
   352          STMD R44,=SAVR4       ! save it in SAVR4 (which is the PC)
   353          STMD R20,=SAVR6       ! save R20 in SAVR6
   354          JSB  =GTABAS          ! get the ASM ROM's RAM ptr into R14
   355 !
   356          ADM  R#,=67,0         ! point R14 at DBSAV1
   357 !
   358 ! NOTE: We're in a hardware interrupt routine, so we have to be VERY
   359 ! careful not to destroy ANYTHING ANYWHERE.  But we want to (have to)
   360 ! call SOME system routines which WILL destroy/change SOME things.
   361 ! So we have to carefully save EVERYTHING that might get changed.  The
   362 ! only place we can save those things, without destroying something
   363 ! ELSE, is in the ASM ROM's stolen RAM. Not everything that's saved
   364 ! NEEDS to be saved (it doesn't get destroyed) but it's cheaper (in
   365 ! bytes of ROM code) to save/restore a list of blocks of 8 bytes than
   366 ! to have a longer list with variable number of bytes. RAM was cheaper
   367 ! than ROM. Slightly.
   368 !
   369          BYT  145,251,6        ! LDM  r45,=06,0320,0141
   370          DEF  ASMSAV           ! table of 6 System RAM locations to save
   371 SAVLOP   POMI R60,+R46         ! get 8 bytes from next entry in table
   372          PUMD R60,+R14         ! save it in ASM ROM's RAM
   373          CLB  R60              ! clear SVCWRD (for future interrupts)
   374          STBD R60,=SVCWRD      ! silly to be inside loop, but oh well
   375          DCB  R45              ! decrement loop counter
   376          JNZ  SAVLOP           ! jif not done, go save more
   377 !
   378          CLM  R16              ! set CSTAT (Capricorn STATus) to IDLE
   379          ICM  R16
   380 BKREDO   JSB  =GTABAS          ! reload ASM ROM's RAM ptr
   381          LDMD R40,X#,DBS.C.    ! get DBG output select code
   382          STMD R40,=SCTEMP      ! set Select Code for doing the BKP dump
   383          LDM  R30,R#           ! point to ASM RAM output buffer
   384 !
   385          LDMD R46,X#,TRCCNT    ! get trace count from ASM RAM
   386          DCM  R46              ! is it 1?
   387          JNZ  TRCIT            ! jif no
   388 !
   389          JSB  =RSTBK1          ! restore BKP1 (in case single-stepping)
   390          JSB  =FRMMEM          ! format and disp/print "MEM addr" line
   391          JSB  =DMPME-          ! Do the memory dump
   392          JSB  =DMPFLG          ! Dump the flags
   393          JSB  =SPCDMP          ! blank line
   394          JSB  =DMPREG          ! dump the CPU registers
   395 CHKERR   TSB  R17              ! Error?
   396          JPS  BRKIDL           ! jif no
   397 ! The following does LDM R4,=61627 (AERR-1)
   398          GTO AERR              ! else report error
   399 !
   400 RSTBK1   LDMD R65,X#,BKPSAV    ! Get saved BKP1 from ASM ROM RAM
   401          JZR  ARTN99           ! jif 0, none saved
   402          STMD R65,X#,DBGWRS    ! save in SysMonStat & BKP 1 in ASM RAM
   403          STM  R65,R45          ! also copy it to R45-47
   404          CLM  R65              ! clear BKP1 save
   405          STMD R65,X14,BKPSAV   ! zero BKPSAV, nothing saved there now
   406          CLM  R26              ! clear MSbit
   407          JSB  =STBKP1          ! write it to System Monitor
   408 ARTN99   RTN
   409 !
   410 BRKIDL   JSB  =KEYLOP          ! wait for key
   411          LDBD R20,=KEYHIT      ! get the keycode
   412          LDM  R36,=AKYTAB      ! table of our keys and actions
   413 KTABLP   POMD R43,+R36         ! get next entry
   414 !
   415          CMB  R43,R20          ! key match the current key?
   416          JZR  GOTKEY           ! jif yes
   417 !
   418          CMB  R43,=316         ! ?
   419          JNZ  KTABLP           ! jif no
   420 !
   421          CMB  R20,=220         ! STEP?
   422          JZR  SNGSTP           ! jif yes
   423 !
   424          CMB  R20,=236         ! SCROLL UP?
   425          JNZ  NOT236           ! jif no
   426          JSB  =ALPHA.          ! force ALPHA crt mode
   427          JSB  =SCRUP           ! scroll screen up one line
   428 RPTCHK   JSB  =COUNTK          ! wait for key up, repeat it
   429          JMP  CURSON
   430 !
   431 NOT236   CMB  R#,=237          ! SCROLL DOWN?
   432          JNZ  NOT226           ! jif no
   433          JSB  =ALPHA.          ! force ALPHA mode
   434          JSB  =SCRDN           ! scroll down a line
   435          JMP  RPTCHK
   436 NOT226   CMB  R#,=215          ! RUN?
   437          JZR  ASMRUN           ! jif yes
   438          CMB  R#,=211          ! COPY?
   439          JNZ  NOT211           ! jif no
   440          JSB  =ROMJSB
   441          DEF  COPY.            ! do COPY
   442          BYT  0
   443 NORPET   JSB  =EOJ2            ! no repeat, end keystroke
   444 CURSON   JSB  =CURS            ! force ALPHA cursor ON
   445          JMP  CHKERR
   446 !
   447 TRCIT    STMD R#,X#,TRCCNT     ! save trace count in ASM ROM RAM
   448          PUMD R#,+R6           ! save on stack
   449          JSB  =PRTPC           ! print PC, DRP, ARP, BKP1, BKP2 values
   450          POMD R#,-R6           ! recover from stack
   451          JMP  TRCSTP
   452 !
   453 NOT211   CMB  R#,=212          ! PAPER ADVANCE?
   454          JNZ  NOT212           ! jif no
   455          JSB  =ROMJSB
   456          DEF  PAPER.           ! advance the paper
   457          BYT  0
   458          JMP  RPTCHK
   459 !
   460 GOTKEY   PUMD R44,+R6          ! save ptrs
   461          JSB  =BKPCMD          ! enter arguments and CR
   462          POMD R44,-R6          ! recover ptrs
   463          DRP  R76
   464          JSB  X44,ZRO          ! call function in R44-45 (from AKYTAB)
   465          JMP  NORPET
   466 !
   467 NOT212   CMB  R#,=223          ! GRAPH?
   468          JNZ  NORPET           ! jif no
   469          JSB  =GRAPH.          ! force GRAPHICS mode
   470          JMP  NORPET
   471 !
   472 SNGSTP   LDMD R55,X14,DBGWRS   ! get last SysMon bits and BKP1
   473          STMD R55,X14,BKPSAV   ! save (we're using BKP1 for single-step)
   474 TRCSTP   CLM  R26
   475          LDMD R46,=SAVR4       ! get PC address we're returning to
   476          JSB  =STBKP1          ! set BKP1 to it (for single stepping)
   477 !
   478 ! This is BREAKPOINT end, restore everything and resume normal execution
   479 !
   480 ASMRUN   ADM  R14,=147,0       ! point 1 above ASM ROM save area
   481 !
   482 ! FALL THROUGH INTO "END BREAKPOINT" CODE and RESTORE EVERYTHING
   483 !
   484 ! the following two lines do: LDM  r45,=06,0334,0141
   485 ! ie, R45=6, and R46-47=address of BKPSVC
   486 !
   487          BYT  145,251,6
   488          DEF  BKPSVC
   489 !
   490 ! BKPSVC is the address JUST after the ASMSAV table of 6 addresses from
   491 ! each of which 8 bytes are saved. The following code pops (decrementing
   492 ! ptr) 8 bytes of saved memory from ASM RAM and then pushes INDIRECTLY
   493 ! through the addresses in the table to restore the contents of RAM
   494 !
   495 RSTLOP   POMD R60,-R14         ! get 8 bytes of saved stuff
   496          PUMI R60,-R46         ! restore original memory contents
   497          DCB  R45              ! decrement table entry counter
   498          JNZ  RSTLOP           ! jif not done
   499 !
   500          POBD R0,-R6           ! recover E from stack
   501          BCD
   502          ERB  R0               ! shift it from R0 into E
   503          BIN
   504          LDM  R76,=SAVR74      ! where to restore CPU registers from
   505          LDB  R0,=73           ! # of bytes of CPU registers to restore
   506 RSTRLP   POBD R*,-R76          ! restore next register from SAVR area
   507          DCB  R0               ! dec counter
   508          CMB  R0,=7            ! reached R6?
   509          JNZ  RSTRLP           ! jif no, loop
   510          LDMD R2,=SAVR2        ! restore R2-3
   511          JSB  =CPYHOK          ! re-copy the INTSVC code to SAVR2
   512 ARTN97   RTN
   513 !
   514 ! BKP runtime for TRACE command
   515 !
   516 BKPT     JEZ  AERR             ! jif no count, ERROR
   517          CMB  R20,=16          ! jif anything BUT a count?
   518          JNZ  AERR             ! jif yes, error
   519          TSM  R76              ! zero?
   520          JZR  ARTN97           ! jif yes, ignore
   521          STMD R76,X14,TRCCNT   ! save TRACE cnt
   522          POMD R76,-R6          ! throw away return address
   523          JMP  SNGSTP           ! single-step and trace until TRCCNT=0
   524 !
   525 ! Table of keycodes, runtimes, and ASCII name string for BKP commands
   526 !
   527 AKYTAB   BYT  102              ! B
   528          DEF  BKPB             ! execute BKP command in breakpoint
   529          DEF  BKPASP           ! "BKP"
   530 !
   531          BYT  103              ! C
   532          DEF  BKPC             ! execute CLR command in breakpoint
   533          DEF  CLRASP           ! "CLR"
   534 !
   535          BYT  115              ! M
   536          DEF  BKPM             ! execute MEM command in breakpoint
   537          DEF  MEMASP           ! "MEM"
   538 !
   539          BYT  120              ! P
   540          DEF  BKPP             ! execute PC= command in breakpoint
   541          DEF  TYPPC            ! "PC="
   542 !
   543          BYT  122              ! R
   544          DEF  BKPR             ! execute REG command in breakpoint
   545          DEF  HDRREG           ! "REG "
   546 !
   547          BYT  124              ! T
   548          DEF  BKPT             ! execute TRACE command in breakpoint
   549          DEF  TYPT             ! "TRACE"
   550 !
   551 ! NOTE: The code in KTABLP (061162) EXPECTS the above table to be
   552 ! followed by a byte of 316 (JSB at the start of the routine below)!
   553 ! Saves a byte by not dedicating a byte to terminating the table.
   554 !
   555 BKPB     JSB  =CONREL          ! get the addr, make it absolute if REL
   556          JEZ  AERR             ! jif error
   557          PUMD R#,+R6           ! save it on stack
   558          CMB  R20,=54          ! COMMA next?
   559          JNZ  BKPBGO           ! jif no, no output select code
   560          JSB  =AGTVAL          ! get select code for breakpoint dump
   561          JEZ  AERR+            ! jif error, clean stack and report
   562          STM  R#,R36           ! move it
   563          JSB  =CONBIN          ! convert it to REAL
   564          BIN
   565          STMD R40,X14,DBS.C.   ! save the debug output SELECT CODE
   566          ICM  R10              ! skip EOL(016) byte (DCM r10 at BKPFIN)
   567 BKPBGO   POMD R46,-R6
   568          CLB  R26              ! clear MSbit
   569          JSB  =BKPSET          ! set it to SysMon
   570          JMP  BKPFIN
   571 !
   572 BKPC     CLM  R22
   573          CLB  R26              ! disable all BKPs
   574          LDBD R25,X14,DBGWRS   ! get last SysMon command
   575          JEN  BCONE            ! jif got number
   576          JSB  =CLRBTH          ! else clear both
   577 BKPFIN   DCM  R10              ! put last char back
   578          POBD R20,+R10         ! get next char
   579          CMB  R20,=16          ! EOL?
   580          JNZ  AERR             ! jif no, error
   581          RTN                   ! else done
   582 !
   583 BCONE    DRP  R76
   584          JSB  =BKPCLR          ! clear just the one
   585          JMP  BKPFIN
   586 !
   587 AERR+    POMD R46,-R6
   588 !
   589 AERR     LDM  R46,=MASMRM      ! address of ASSM ROM error message
   590          CLB  R17              ! clear XCOM
   591          JSB  =CPYSTR          ! copy it
   592          JSB  =DUMPIT          ! dump it
   593          CLM  R40
   594          STMD R40,=ERLIN#      ! clear all the ERROR stuff
   595 ARTN96   RTN
   596 !
   597 BKPM     JSB  =CONREL          ! get the addr, make it absolute if REL
   598          JEZ  AERR             ! jif error
   599          STM  R#,R36           ! copy it
   600          DCM  R10              ! put last char back
   601          JSB  =BKPMEM          ! set up the address in ASM ROM RAM
   602          POBD R20,+R10         ! get next char
   603          CMB  R20,=72          ! ':'?
   604          JNZ  BNOCLN           ! jif no
   605          JSB  =AGTVAL          ! get ROM#
   606          JEZ  AERR             ! jif error
   607          STBD R#,X14,MEMROM    ! save in ASM RAM
   608          POBD R20,+R10         ! get next char
   609 BNOCLN   CMB  R#,=54           ! COMMA?
   610          JNZ  MNOCMA           ! jif no
   611          JSB  =GET#            ! else get the # of bytes
   612          JEZ  AERR             ! jif error
   613          JSB  =SMLEN           ! save it in ASM RAM
   614 MNOCMA   CMB  R20,=75          ! '='?
   615          JNZ  BNOTEQ           ! jif no
   616          LDMD R26,X14,MEMPTR   ! get MEM ptr
   617 BMLOOP   JSB  =GET#            ! get number to store there
   618          JEZ  TSTERR           ! jif error
   619          PUBD R#,+R26          ! else write the byte to memory
   620          CMB  R20,=54          ! COMMA?
   621          JZR  BMLOOP           ! jif yes, loop
   622 BNOTEQ   CMB  R20,=16          ! end of line?
   623          JZR  TSTERR           ! jif yes
   624 AERJMP   JMP  AERR             ! else error
   625 !
   626 BKPP     JEZ  AERR             ! jif error
   627          CMB  R20,=16          ! end of line?
   628 JNZAER   JNZ  AERR             ! jif no
   629          LDM  R#,R6            ! copy R6 stack pointer
   630          SBM  R#,=25           ! adjust to where return addr is on stack
   631          ARP  R0
   632          STMD R76,R20          ! store new value (for eventual return)
   633          STMD R76,=SAVR4       ! also save in saved regs area for disp
   634 TSTERR   TSB  R17              ! any error?
   635          JNG  ARTN96           ! jif yes
   636          POMD R22,-R6          ! else pop a return address
   637          GTO BKREDO            ! redo the breakpoint dump
   638 !
   639 BKPR     JEZ  BKPP             ! jif error
   640          CMM  R#,=100          ! reg# from 0 to 77?
   641          ARP  R0
   642          JCY  AERJMP           ! jif no, too big
   643          CMB  R20,=75          ! "="?
   644          JNZ  JNZAER           ! jif no, error
   645          PUMD R76,+R6          ! save register #
   646          JSB  =AGTVAL          ! get value to store in register
   647          POMD R46,-R#          ! recover register #
   648          JEZ  BKPP             ! jif error
   649          STBD R76,X46,SAVR0    ! change the value in the register
   650          JMP  TSTERR           ! redisplay the breakpoint dump
   651 !
   652 DMPFLG   JSB  =SPCDMP          ! blank line after memory dmp
   653          LDM  R46,=HDR1        ! PC     DR AR BKPS
   654          JSB  =CPYDMP          ! output HDR1
   655          JSB  =PRTPC           ! dump PC, DRP, ARP, and BKPs
   656          LDM  R46,=HDR2        ! "OV CY NG LZ ZR RZ OD DC E"
   657          JSB  =CPYDMP          ! output HDR2
   658          LDB  R44,=106         ! invert NOT-LDZ, NOT-Z, and NOT-RDZ flgs
   659          XRB  R77,R44          ! invert flags so they are LZ, ZR, and RZ
   660          STB  R75,R54          ! get OVF and CY flags
   661          JSB  =FRM2FL          ! format them to the output buffer
   662          STB  R77,R54          ! get NG (MSbit), LZ, ZR, RZ, OD (LSbit)
   663          JSB  =FRM2FL          ! format NG and LZ to output buffer
   664          LLB  R54              ! throw away 3 unused bits in the middle
   665          LLB  R54
   666          LLB  R54
   667          JSB  =FRMFLG          ! format ZR to output buffer
   668          JSB  =FRM2FL          ! format RZ and OD to output buffer
   669          LLB  R76              ! get DCM (BIN/BCD) to MSbit of R76
   670          STB  R76,R54          ! copy it to R54
   671          JSB  =FRMFLG          ! format DCM to output buffer
   672          POMD R#,-R6           ! get rtn addr & E register from R6 stack
   673          PUMD R#,+R6           ! put them back
   674          CLM  R36
   675          LDB  R36,R55          ! get E
   676          LDB  R20,=2           ! format 2 digits
   677          JMP  FRMDMP           ! format them, then dump to DISP or PRINT
   678 !
   679 PRTDRP   ANM  R#,=77           ! keep just the DRP/ARP value
   680          ARP  R0
   681          LDB  R20,=2           ! print 2 digits
   682          JSB  =FRMDGS          ! format them
   683          DRP  R36              ! return DRP=36 (saves code bytes)
   684          RTN
   685 !
   686 FRM2FL   JSB  =FRMFLG          ! format 1st flag, fall through to do 2nd
   687 FRMFLG   LDM  R55,=30,20,20    ! when shifted left once, will be "0  "
   688          LLM  R54              ! next stat bit from R54 into LSbit R55
   689          PUMD R55,+R30         ! turning R55 to either "0  " or "1  "
   690          RTN                   ! push and return
   691 !
   692 PRTPC    LDMD R36,=SAVR4       ! get PC where breakpoint occurred
   693 PRT36    JSB  =FRM6DG          ! Format # in R36 as 6 octal digits
   694          LDM  R76,R6           ! get stack ptr
   695 !
   696 ! R6 stack, at this point, looks like:
   697 !  2 BYTES rtn from SPAR0 to interrupted code
   698 !  2 BYTES return from INTSVC to SPAR0
   699 !  3 BYTES SAD (Save Arp/Drp and flags) in INTSVC
   700 !  4 BYTES ERTEMP save in INTSVC
   701 !  2 BYTES return from ROMJSB to INTSVC
   702 !  2 BYTES R0 in ROMJSB
   703 !  1 BYTE  current ROM# in ROMJSB
   704 !  2 BYTES return from BKPSVC to ROMJSB
   705 !  1 BYTE  E save in BKPSVC
   706 !  2 BYTES ASM ROM's RAM 160
   707 !  2 BYTES return from PRTPC
   708 ! R6--->
   709 !
   710          POMD R50,-R76         ! move address back 8 into R6 stack
   711          POMD R50,-R76         ! move address back 16 into R6 stack
   712          POMD R75,-R76         ! grab 3-bytes of SAD (interrupt flags)
   713          LDB  R36,R76          ! OVF, DCM, DRP
   714          JSB  =PRTDRP          ! format out the DRP value
   715          LDB  R#,R75           ! OVF, CY, ARP
   716          JSB  =PRTDRP          ! format out the ARP value
   717          LDMD R#,X14,DBBKP1    ! get BKP1 address
   718          JSB  =FRM6DG          ! print it
   719          LDMD R36,X14,DBBKP2   ! get BKP2 address
   720          LDB  R20,=6           ! 6 digits
   721 FRMDMP   JSB  =FRMDGS          ! print it
   722          JSB  =DMPBUF          ! dump the buffer
   723          RTN
   724 !
   725 HDR1     ASP  "PC     DR AR BKPS" ! breakpoint strings
   726 HDR2     ASP  "OV CY NG LZ ZR RZ OD DC E"
   727 HDRREG   ASP  "REG "
   728 TYPPC    ASP  "PC="
   729 TYPT     ASP  "TRACE"
   730 !
   731 BKPCMD   JSB  =CPYSTR          ! copy R46-47 str into ASM output buf
   732          LDB  R46,=40          ! SPACE char
   733          PUBD R46,+R30         ! put a SPACE on the end
   734          ICM  R36              ! bump the length
   735          JSB  =HLFLIN          ! dump to DISP
   736          JSB  =CLREOL          ! clear the rest of the line
   737          LDM  R10,R14
   738          LDM  R26,R14          ! point to start of buffer
   739 EOKEY    JSB  =EOJ2            ! end the key (no repeat)
   740          JSB  =CURS            ! force the cursor ON
   741          JSB  =KEYLOP          ! wait for a key
   742          LDBD R32,=KEYHIT      ! get the keycode
   743          CMB  R32,=200         ! alphanumeric key?
   744          JNC  ALNU             ! jif yes
   745          CMB  R32,=232         ! ENTER? CR?
   746          JZR  RETKEY           ! jif yes
   747          CMB  R32,=231         ! BACKSPACE?
   748          JNZ  EOKEY            ! jif no
   749          CMM  R26,R14          ! anywhere to back up to?
   750          JZR  BAKEND           ! jif no, clear the command, too
   751          JSB  =BKSPC           ! back up one on DISP
   752          DCM  R26              ! throw away last char in buffer
   753          JMP  EOKEY
   754 !
   755 ALNU     LDM  R34,R26          ! copy end of buffer
   756          SBM  R34,=36,0        ! minus 36 octal = 30 decimal
   757          CMM  R34,R14          ! past beginning of buffer?
   758          JCY  EOKEY            ! jif no, ignore key
   759          PUBD R32,+R26         ! add char to buffer
   760          JSB  =OUTCHR          ! output it to DISP
   761          JMP  EOKEY
   762 !
   763 RETKEY   JSB  =OUTST-          ! DO CR ACTION ON DISP
   764          LDB  R#,=16           ! Add a 16 to end of buffer
   765          PUBD R#,+R26
   766          JSB  =EOJ2            ! terminate the keystroke
   767 GET#     JSB  =AGTVAL          ! try to get number
   768          ARP  R10
   769          JEZ  SDRP76           ! jif failed
   770          POBD R20,+R10         ! get first byte from buffer (command?)
   771 SDRP76   DRP  R76
   772          RTN
   773 !
   774 BAKEND   POMD R42,-R6          ! throw away some stuff
   775          JSB  =FASTBS          ! back up to the start of the line
   776          GTO NORPET            ! GOTO NORPET (61244-1)
   777 !
   778 STKBIN   LDB  R31,R37          ! copy upper byte
   779          ANM  R31,=200         ! save MSbit (positive or negative?)
   780          JSB  =CONBIN          ! convert binary # to REAL
   781          PUMD R40,+R12         ! push on stack
   782          TSB  R31              ! was it negative?
   783          JZR  ARTN60           ! jif no
   784          LDM  R54,=377,66,125,6 ! load 65536 as INTEGER
   785          PUMD R50,+R12         ! push on stack
   786          JSB  =ADDROI          ! neg val + 64K = pos unsigned val
   787 ARTN60   RTN                   ! leave result on R12 stack
   788 !
   789 KEYLOP   LDBD R32,=SVCWRD      ! wait for keyboard interrupt
   790          JEV  KEYLOP
   791          JSB  =DECUR2          ! remove cursors from screen
   792          RTN
   793 !
   794 ! This looks for REL(addr) in a BKP or MEM command and converts
   795 ! it to an absolute address by adding BINTAB to it
   796 !
   797 CONREL   JEN  CMDEXT           ! jif argument error
   798          POMD R65,+R10         ! get 3 chars of input after current one
   799          LDB  R64,R20          ! copy the current char, too
   800          CMM  R64,=122,105,114,50 ! is it "REL("?
   801          JNZ  CMDEXT           ! jif no
   802          JSB  =GET#            ! get the number
   803          ADMD R#,=BINTAB       ! add BINTAB value to it
   804          CMB  R20,=51          ! is next char ")"?
   805          JZR  GOT)             ! jif yes, okay
   806          CLE                   ! flag error
   807 GOT)     POBD R#,+R#           ! throw away ")", get next char
   808 CMDEXT   DRP  R76
   809          RTN
   810 !
   811 ! Set a BREAKPOINT
   812 !
   813          BYT  241
   814 BKP.     JSB  =ONER            ! get breakpoint address
   815          JSB  =GTABAS          ! get ASMBAS into R14
   816          CMMD R12,=TOS         ! any optional arguments?
   817          JZR  GTADR1           ! jif no optional arguments, just address
   818          STMD R40,X#,DBS.C.    ! else save BKP# (huh?  in DBS.C.????)
   819          JMP  BCONV            ! go get address and convert it
   820 GTADR1   PUMD R40,+R12         ! put address back
   821 BCONV    JSB  =OCTBIN          ! get & convert OCT to BINARY in R46-47
   822          LDB  R26,=200         ! Master breakpoint enable bit=ON
   823 BKPSET   LDBD R25,X14,DBGWRS   ! get BKP 1 status from ASM ROM RAM
   824          ANM  R25,=20          ! is BKP 1 enabled (ie, is it set)?
   825          DRP  R46              ! set DRP to address
   826          JNZ  STBKP2           ! jif BKP 1 enabled
   827 !
   828 STBKP1   STMD R46,X14,DBBKP1   ! save BKP 1 address
   829          LDB  R25,=20          ! load "set BKP 1" command (and enable 1)
   830          JMP  SETBKP
   831 !
   832 STBKP2   STMD R#,X#,DBBKP2     ! save BKP 2 address
   833          LDB  R25,=62          ! load "set BKP 2" cmd (enable 1 and 2)
   834 !
   835 ! R25 = DEBSTS command
   836 ! R46-47 = BKP address
   837 !
   838 SETBKP   STBD R#,=DEBSTS       ! write the low byte command
   839          STBD R46,=DEBBKP      ! store the low byte of the breakpoint
   840          ICB  R25              ! change the cmd to write the high byte
   841          STBD R25,=DEBSTS      ! write the hi byte command
   842          STBD R47,=DEBBKP      ! store the hi byte of the breakpoint
   843          LDBD R24,X#,DBGWRS    ! get the breakpoint status from ASM RAM
   844          ANM  R25,=60          ! keep only bkp# enabled bits
   845          ORB  R25,R24          ! or the other status info in
   846 !
   847 UPSTS    STBD R#,X14,DBGWRS    ! save new bkp status
   848          ADB  R#,R26           ! add in MS bit (0 or 200)
   849          STBD R#,=DEBSTS       ! write to SysMon command
   850          RTN
   851 !
   852 ! RUNTIME for CLR breakpoint command
   853 !
   854          BYT  241
   855 CLR.     JSB  =GTABAS          ! get ASMBAS
   856          LDBD R25,X#,DBGWRS    ! get BKP status
   857          CLM  R22              ! zero breakpoint
   858          LDB  R26,=200
   859          CMMD R12,=TOS         ! any bkp# ?
   860          JZR  CLRBTH           ! jif no, clear both
   861          JSB  =ONEB            ! get BKP#
   862 BKPCLR   DCM  R#               ! was it 1?
   863          JZR  CLR1             ! jif yes
   864          DCM  R#               ! was it 2?
   865          JZR  CLR2             ! jif yes
   866 ! anything but 1 or 2 clears both
   867 CLRBTH   STMD R22,X#,DBBKP1    ! write 0 to ASM RAM bkp#1 address
   868          CLB  R25              ! clear all bits (disable both bkps)
   869 CLR2     STMD R22,X14,DBBKP2   ! write 0 to ASM RAM bkp#2 address
   870          ANM  R25,=337         ! clear bit 040 (disable bkp 2)
   871          JMP  UPSTS            ! write to the System Monitor
   872 !
   873 CLR1     STMD R22,X14,DBBKP1   ! write 0 to ASM RAM bkp#1 address
   874          ANM  R25,=357         ! clear bit 020 (disable bkp 1)
   875          JMP  UPSTS            ! write to the System Monitor
   876 !
   877 ! **********************************************************
   878 ! Entry from CHIDLE
   879 ! A key has been pressed, maybe handle it.
   880 CHRHOK   LDBD R32,=KEYHIT      ! get keycode
   881          LDM  R34,=KTABLE      ! address of our table
   882 KLOOP5   POMD R45,+R34         ! get next key from table
   883          CMB  R45,R32          ! match?
   884          JZR  TYPAID           ! jif yes, output the typing aid
   885          CMB  R45,=316         ! end of table?
   886          JNZ  KLOOP5           ! jif no
   887          CMB  R32,=213         ! RESET?
   888          JNC  ARTN90           ! jif lower
   889          CMB  R32,=221         ! TEST?
   890          JNC  KFINI            ! jif lower
   891          CMB  R32,=224         ! LIST?
   892          JNZ  NOTLST           ! jif no
   893          JSB  =PREPTK          ! set up stacked token
   894          LDB  R#,=7            ! ASSEMBLER ROM LIST token
   895 TOKSTK   PUMD R74,+R12         ! push it on the stack
   896 KFINI    ICE
   897          JSB  =EOJ2            ! end keyhit
   898          POMD R63,-R6          ! pop RTN to ROMJSB, prev ROM#, saved R0
   899          POMD R42,-R6          ! toss returns to CHIDLE, CHEDIT & XCBITS
   900          PUMD R63,+R6          ! push RTN to ROMJSB, prev ROM#, saved R0
   901 ARTN90   RTN                   ! rtn to ROMJSB & then to the EXEC loop
   902 !
   903 KTABLE   BYT  252              ! LOAD
   904          DEF  ALDSTR           ! ALOAD
   905          BYT  251              ! STORE
   906          DEF  ASTSTR           ! ASTORE
   907          BYT  200              ! K1
   908          DEF  BASSTR           ! BASIC
   909          BYT  201              ! K2
   910          DEF  FLASTR           ! FLABEL
   911          BYT  202              ! K3
   912          DEF  FRESTR           ! FREFS
   913          BYT  215              ! RUN
   914          DEF  ASSSTR           ! ASSEMBLE
   915 ! The table is terminated by the 316 opcode of the following JSB
   916 TYPAID   JSB  =CPYSTR          ! copy the string to the buffer
   917          JSB  =HLFLIN          ! write it to the disply
   918          JSB  =CURS            ! turn the cursor on
   919          JMP  KFINI            ! finish up
   920 NOTLST   CMB  R#,=225          ! PLIST?
   921          JNZ  ARTN90           ! jif no
   922          JSB  =PREPTK          ! prepare for the token on the stack
   923          LDB  R#,=6            ! ASSEMBLER ROM PLIST token
   924          JMP  TOKSTK
   925 !
   926 PREPTK   STMD R12,=STSIZE      ! set bottom of stack
   927          LDB  R16,=1           ! set CSTAT to CALC mode
   928          CLM  R74
   929          STMD R74,=AUTO#
   930          STBD R74,=EDMOD2      ! stop insert mode
   931          LDM  R74,=370,50,0,16 ! 370=OPTROM 050=ASM ROM# 00=tmp 016=EOL
   932          DRP  R76              ! set DRP to the 00 tmp-TOKEN#
   933          RTN
   934 !
   935 AROMER   LDBD R36,=ERRORS      ! already an error?
   936          JNZ  ARTN93           ! jif yes
   937          LDB  R36,=50          ! ASM ROM#
   938          STBD R36,=ERRROM      ! claim the error as ours
   939 ARTN93   RTN
   940 !
   941 RSTR10   STMD R10,=SAVR10      ! save it
   942 RSTR6    LDM  R6,=RRSTK        ! TRASH RETURN STACK
   943          STBD R6,=GINTEN       ! Enable interrupts
   944 GOROMR   GTO ROMRTN            ! GOTO ROMRTN (4762-1)
   945 !
   946 GETMOD   LDMD R56,=ASMBAS      ! base of ASM ROM RAM
   947          LDBD R56,X56,ASMMOD   ! get ASMMOD (BASIC mode=0 ASM mode=1)
   948          RTN
   949 !
   950 ONLYBA   JSB  =GETMOD          ! which mode are we in?
   951          JZR  ARTN61           ! jif BASIC, okay
   952 ERMODE   JSB  =AROMER          ! set ASM ROM as error
   953          JSB  =ERROR
   954          BYT  11               ! ILL MODE
   955 RRJMP2   JMP  RSTR10
   956 !
   957 ONLYAS   JSB  =GETMOD          ! which mode are we in?
   958          JZR  ERMODE           ! jif BASIC, not okay
   959          RTN
   960 !
   961 ! parse BASIC
   962 !
   963 BASIC    JSB  =ONLYAS          ! error if not in ASM mode
   964          JMP  ABCOM            ! finish common BASIC/ASSEMBLER parsing
   965 !
   966 ! parse ASSEMBLER
   967 !
   968 ASMLR    JSB  =ONLYBA          ! error if not in BASIC mode
   969 ABCOM    LDB  R47,R43          ! copy token
   970          JSB  =ROMTOK          ! push 370 50 r47 tokens
   971          JSB  =ROMJSB
   972          DEF  SCAN             ! scan for next token
   973          BYT  0
   974          JSB  =DMNDCR          ! error if it's not CR
   975 RRJMP    JMP  GOROMR           ! ROMRTN (end of parsing)
   976 !
   977 ASM$     JSB  =ONLYAS          ! error if BASIC mode
   978          PUBD R43,+R6          ! save incoming token
   979          JSB  =ROMJSB
   980          DEF  GETSTP           ! parse a string expression
   981          BYT  0
   982          POBD R47,-R6          ! restore incoming token to r47
   983 ARTN61   RTN
   984 !
   985 FREFS    JSB  =ASM$            ! get a string (or error)
   986 ASMTOK   JSB  =ROMTOK          ! push the ASM ROM token
   987          JMP  RRJMP            ! ROMRTN
   988 !
   989 ALIST    PUBD R43,+R6          ! save 5=DELETE, 6=PLIST, 7=LIST
   990          JSB  =ROMJSB
   991          DEF  G012N            ! get 0, 1, or 2 numbers
   992          BYT  0
   993          POBD R47,-R12         ! trash token on stack
   994          POBD R47,-R6          ! recover incoming token (5,6,7)
   995          JSB  =GETMOD          ! ASM MODE?
   996          JNZ  ASMTOK           ! jif yes
   997 !
   998 ! in BASIC mode, so we need to parse (push) the system tokens rather
   999 ! than the ASSEMBLER ROM's tokens
  1000 !
  1001          LDM  R55,=201,236,113 ! system DELETE, PLIST, LIST tokens
  1002          LDB  R0,=50
  1003          ADB  R0,R47           ! R0 = 55, 56, or 57
  1004          PUBD R*,+R12          ! push the appropriate system token
  1005 RRJMP3   JMP  RRJMP
  1006 !
  1007 ASSEMB   JSB  =ASM$            ! error if NOT in ASSEMBLER mode
  1008          PUBD R47,+R6          ! save incoming token
  1009          CMB  R14,=54          ! comma coming up next?
  1010          JNZ  ASSNCO           ! jif no, push default of 0
  1011          JSB  =PARNE2          ! get numeric expression
  1012          JEN  AGOTCO           ! jif got it
  1013 BADEXP   JSB  =ERROR
  1014          BYT  121              ! Bad expression
  1015          JMP  RRJMP2
  1016 !
  1017 ASSNCO   LDB  R40,=4           ! system REAL CONSTANT token
  1018          PUBD R40,+R12         ! push it
  1019          CLM  R40              ! real# 0
  1020          PUMD R40,+R12         ! push it
  1021 AGOTCO   POBD R47,-R6          ! recover incoming token
  1022          JMP  ASMTOK           ! go push it
  1023 MEMD     PUBD R43,+R6          ! save token
  1024          JSB  =PARNE+          ! scan and get a numeric expression
  1025          JEZ  BADEXP           ! jif failed
  1026          POBD R47,-R6          ! recover keyword token
  1027          JSB  =ROMTOK          ! push it
  1028          CMB  R14,=45          ! colon : token next?
  1029          JNZ  NOCOLN           ! jif no
  1030          JSB  =PARNE+          ! scan & get ROM# for "MEMD addr:rom#"
  1031          JEZ  BADEXP           ! jif failed
  1032          LDB  R47,=25          ! ASM ROM 'colon' token
  1033          JSB  =ROMTOK          ! push it
  1034 NOCOLN   CMB  R14,=54          ! comma token?
  1035          JNZ  NOCMMA           ! jif no
  1036          JSB  =PARNE+          ! else scan and get numeric expression
  1037          JEZ  BADEXP           ! jif failed
  1038          LDB  R47,=27          ! ASM ROM 'comma' token
  1039          JSB  =ROMTOK          ! push it
  1040 NOCMMA   CMB  R14,=65          ! = token?
  1041          JNZ  MNOT=T           ! jif no
  1042 MEMVAL   JSB  =PARNE2          ! scan & get numeric expression
  1043          JEZ  BADEXP           ! jif failed
  1044          CMB  R14,=54          ! comma?
  1045          JZR  MEMVAL           ! jif yes, loop
  1046          LDB  R47,=26          ! ASM ROM = token
  1047          JMP  MEMPSH           ! push it
  1048 !
  1049 MNOT=T   LDB  R47,=30          ! ASM token - indicating no '='????
  1050 MEMPSH   JSB  =ROMTOK          ! push ASM ROM token
  1051          JMP  RRJMP3           ! ROMRTN
  1052 !
  1053 ROMTOK   LDB  R46,=50          ! ASM ROM#
  1054          LDB  R45,=370         ! system opt-rom-call token
  1055          PUMD R45,+R12         ! push 370 050 token#
  1056 ARTN91   RTN
  1057 !
  1058 ! parse BKP command
  1059 BKP      PUBD R43,+R6          ! save BKP token
  1060          JSB  =PARNE2          ! SCAN and get NUMEXP
  1061          JEZ  BADEXP           ! jif failed
  1062          CMB  R14,=54          ! COMMA?
  1063          JNZ  BCFIN            ! jif no, done, finish up
  1064          JSB  =PARNE2          ! else get second#
  1065          JEZ  BADEXP           ! jif failed
  1066 !
  1067 BCFIN    POBD R47,-R6          ! recover keyword token
  1068          JMP  MEMPSH           ! go push it and finish
  1069 !
  1070 ! parse CLR command
  1071 !
  1072 CLR      PUBD R43,+R6          ! save CLR token
  1073          JSB  =PARNE2          ! SCAN and get NUMEXP if one's there
  1074          JMP  BCFIN            ! go push the token
  1075 !
  1076 ! ***************************************************************
  1077 ! PRSIDL comes here for parsing during ASSEMBLER mode
  1078 ! A line is awaiting us in the INPBUF
  1079 ! ***************************************************************
  1080 PRSHOK   LDM  R10,=INPBUF      ! point R10 to input
  1081          JSB  =GCHAR           ! get next char
  1082          JSB  =INTEGR          ! get line# into R40-R47
  1083          BIN
  1084          JEZ  ARTN91           ! jif not found
  1085          LDMD R73,=ERLIN#      ! save error stuff
  1086          PUMD R73,+R6
  1087          LDM  R36,R40          ! get the line#
  1088          STMD R36,=AUTO#       ! save it for auto-numbering
  1089          PUMD R36,+R12         ! push it out
  1090          STMD R12,=STSIZE      ! save stack size
  1091          ICM  R12              ! reserve byte at start for line LEN
  1092          TSM  R36              ! line# 0?
  1093          JZR  LINERR           ! jif yes
  1094          TSM  R42              ! too big (>9999)?
  1095          JNZ  LINERR           ! jif yes
  1096 !
  1097 ! we're in ASSEMBLER mode, so the ON KEY table at 101200 isn't used,
  1098 ! so we use it for temp storage
  1099 !
  1100          STBD R42,=GOODLI      ! write a 0
  1101          LDMD R34,=LAVAIL      ! end of available RAM
  1102          SBM  R34,=0,2         ! minus 512 bytes
  1103          CMM  R34,R12          ! is there at least 512 free bytes?
  1104          JNC  MEMERR           ! jif no, memory overflow
  1105          CMB  R20,=15          ! CR?
  1106          JZR  MTLINE           ! jif yes, delete line
  1107          LDM  R24,R10          ! copy input ptr
  1108          DCM  R24              ! "put back" the char alread fetched
  1109          POMD R24,-R24         ! get the last two chars
  1110          CMM  R24,=40,40       ! SPACE SPACE ? (ie, no label?)
  1111          JZR  NOLABL           ! jif yes
  1112          JSB  =GT!LBL          ! get comment or label
  1113          TSB  R17              ! error?
  1114          JNG  PRSEOL           ! jif yes
  1115          JEZ  PSHEOL           ! jif line done
  1116          JSB  =DUPLB?          ! check for duplicate label
  1117          CMB  R20,=15          ! CR?
  1118          JZR  OPCERR           ! jif yes
  1119 NOLABL   CLM  R24              ! indicate we're parsing a line
  1120          LDM  R26,=OPPRST      ! address of opcode parsing table
  1121          JSB  =FINDOP          ! see if it's a valid opcode
  1122          JEN  PRSEOL           ! jif no, maybe expression
  1123          PUMD R65,+R12         ! else push opcode as simple ASCII text
  1124          JSB  X26,ZRO          ! call routine to "parse" the rest of it
  1125          CMB  R20,=40          ! space after the arguments?
  1126          JNZ  NOSPAC           ! jif no
  1127          JSB  =GCHAR           ! skip space
  1128 NOSPAC   CMB  R#,=41           ! BANG?
  1129          JNZ  NOBANG           ! jif no, no eol comment
  1130          JSB  =PSHCOM          ! push out eol comment
  1131 NOBANG   CMB  R20,=15          ! CR?
  1132          JZR  PRSEOL           ! jif yes
  1133          JSB  =ERREXP          ! else report bad expression
  1134 !
  1135 ! fall through the following error call, which is a nop since there's
  1136 ! already a reported error
  1137 !
  1138 LINERR   JSB  =ERROR
  1139          BYT  132              ! LINE >9999
  1140 !
  1141 ! Once one ERROR is set, successive calls to ERROR are ignored, so
  1142 ! we can save a byte or two by simply falling from the above ERROR call
  1143 ! through the following.
  1144 !
  1145 MEMERR   JSB  =ERROR
  1146          BYT  23               ! MEM OVF
  1147 !
  1148 ! Once one ERROR is set, successive calls to ERROR are ignored, so
  1149 ! we can save a byte or two by simply falling from the above ERROR call
  1150 ! through the following.
  1151 !
  1152 OPCERR   JSB  =AROMER          ! set ERROM# to Assembler ROM
  1153          JSB  =ERROR           ! report error
  1154          BYT  13               ! OPCO
  1155 !
  1156 ! Once one ERROR is set, successive calls to ERROR are ignored, so
  1157 ! we can save a byte or two by simply falling from the above ERROR call
  1158 ! through the following.
  1159 !
  1160          JSB  =AROMER
  1161          JSB  =ERROR
  1162          BYT  12               ! LBL
  1163 !
  1164 PRSEOL   TSB  R17              ! error reported?
  1165          JNG  AEXPP            ! jif yes, try expression parsing
  1166 PSHEOL   LDB  R20,=16          ! EOL token
  1167          PUBD R20,+R12         ! push it out
  1168          STBD R20,=GOODLI      ! EOL token to what WAS 0????
  1169 MTLINE   BIN
  1170          LDMD R36,=STSIZE      ! get bottom of stack
  1171          SBM  R36,R12          ! how many bytes on stack?
  1172          NCM  R36              ! subtracted wrong way, so have to negate
  1173          STBI R36,=STSIZE      ! store len into 1st byte of our parsing
  1174          CLB  R16              ! set IDLE mode
  1175          JSB  =CLRPGM          ! set PCB 'type' to MAIN and 0 LENGTH
  1176 !
  1177 ! Assembler source uses the same "file type" in the PCB as MAIN BASIC.
  1178 !
  1179          JSB  =ROMJSB
  1180          DEF  LINEDR           ! EDIT the line in (or delete it)
  1181          BYT  0
  1182          JSB  =ALOCUS          ! set pgm len & alloc'd to avoid trouble
  1183          LDBD R#,=GOODLI       ! successfully 'parsed' source line?
  1184          JZR  ANOERR           ! jif yes
  1185          JSB  =DECUR2          ! turn off cursors
  1186 ! The CRT cursor is currently at the left side of the screen on the line
  1187 ! BELOW the lines containing the just entered source code.  The CRT RAM
  1188 ! has only a 4-bit nybble at each address, so it takes TWO addresses for
  1189 ! each character byte.  Therefore, to calculate the address of the line,
  1190 ! we have to do CRTBYT - 2*(R10 - INPBUF) or CRTBYT - 2*R10 + 2*INPBUF
  1191          LDMD R#,=CRTBYT       ! get cursor address
  1192          SBM  R#,R10
  1193          SBM  R#,R10           ! subtract 2 x end-of-buffer
  1194          ADM  R#,=INPBUF
  1195          ADM  R#,=INPBUF       ! add 2 x start-of-buffer
  1196          ANM  R#,=300,17       ! AND with 7700 to wrap within alpha RAM
  1197          JSB  =BYTCRT          ! move cursor there
  1198          LDM  R24,R76          ! address of start of 'new' line
  1199          POMD R45,+R24         ! get line# and len
  1200          JSB  =LIST1           ! decompile line & prep for displaying
  1201          JSB  =OUTSTR          ! redisplay the reformatted line
  1202 ANOERR   JSB  =UPAUTO          ! update the AUTO#, maybe spitting it out
  1203          TSB  R17              ! error?
  1204          JPS  POK              ! jif no
  1205 AEXPP    ICB  R16              ! set CALCULATOR mode
  1206          LDMD R12,=STSIZE      ! get bottom of stack
  1207          DCM  R12
  1208          DCM  R12
  1209          STMD R10,=SAVR10      ! save r10
  1210          JSB  =ROMJSB
  1211          DEF  E.PARS           ! try to get an expression
  1212          BYT  0
  1213 POK      POMD R73,-R6          ! recover error values
  1214          TSB  R17              ! error getting expression?
  1215          JNG  SKPERR           ! jif yes
  1216          STMD R73,=ERLIN#      ! restore error values
  1217 SKPERR   POMD R63,-R6          ! pop RTN to ROMJSB, prev ROM#, saved R0
  1218          POMD R44,-R6          ! toss rtn to PRSIDL & rtn to PARSER
  1219          PUMD R63,+R6          ! push RTN to ROMJSB, prev ROM#, saved R0
  1220          RTN                   ! rtn to ROMJSB and whoever called PARSER
  1221 !
  1222 ! FIND AN OPCODE
  1223 ! Input: R20 = next char (first char of opcode)
  1224 !        R10 points to 2nd and 3rd chars of opcode
  1225 !        R26 = addr of table to do parsing or assembling of the opcode
  1226 !        R24 = 0 if PARSING, #0 if ASSEMBLING
  1227 ! Output:
  1228 ! if unsuccessful E#0
  1229 ! else
  1230 ! 	E=0
  1231 ! 	R26-27 = opcode 'execution' address from R26 table
  1232 !
  1233 FINDOP   STB  R20,R65          ! copy first char of opcode
  1234          LDMD R66,R10          ! get next two chars
  1235          ANM  R65,=337,337,337 ! force uppercase on all three
  1236 FNDOP-   LDM  R20,=OPTABL      ! address of opcode table
  1237          CLM  R22              ! opcode counter
  1238 OPCLOP   CLE                   ! clear error flag
  1239          CMMD R65,R20          ! match?
  1240          JZR  GOTOPC           ! jif yes
  1241          ADM  R20,=3,0         ! bump table ptr
  1242          ICB  R22              ! increment opcode counter
  1243          CMB  R22,=127         ! end of table?
  1244          JNZ  OPCLOP           ! jif no, loop
  1245          TSM  R24              ! parsing a line?
  1246          JNZ  NLP              ! jif no
  1247          JSB  =AROMER          ! set Assembler ROM error
  1248          JSB  =ERROR           ! report error
  1249          BYT  13               ! OPCO
  1250 NLP      ICE                   ! indicate error happened
  1251          RTN
  1252 !
  1253 GOTOPC   TSM  R24              ! parsing a line?
  1254          JNZ  NOADV            ! jif no
  1255          ICM  R10              ! skip the last two bytes of the opcode
  1256          ICM  R10
  1257 NOADV    LLM  R22              ! double the opcode# for address indexing
  1258          ADM  R26,R22          ! add to base of opcode 'execution' table
  1259          LDMD R26,R26          ! get the address of the routine
  1260          JSB  =GCHAR           ! get next char after the 3-char opcode
  1261          RTN
  1262 !
  1263 OPTABL   ASC  "ARPDRPELBELMERBERMLLBLLM" ! 0
  1264          ASC  "LRBLRMICBICMICEDCBDCMDCE" ! 10
  1265          ASC  "TCBTCMNCBNCMTSBTSMCLBCLM" ! 20
  1266          ASC  "CLEORBORMXRBXRMBINBCDSAD" ! 30
  1267          ASC  "RTNPADLDBLDMSTBSTMCMBCMM" ! 40
  1268          ASC  "ADBADMSBBSBMANMPOBPOMPUB" ! 50
  1269          ASC  "PUMJCYJEVJENJEZJLZJLNJMP" ! 60
  1270          ASC  "JNOJNGJNZJNCJODJPSJRZJRN" ! 70
  1271          ASC  "JSBJZRBSZABSASPBYTGTOASC" ! 100
  1272          ASC  "DEF"            ! 110
  1273          ASC  "NAM"
  1274          ASC  "VAL"
  1275 GLONAM   ASC  "GLO"
  1276          ASC  "FIN"
  1277          ASC  "LST"
  1278          ASC  "UNL"
  1279          ASC  "LNK"
  1280 ORGNAM   ASC  "ORG"
  1281 SETNAM   ASC  "SET"
  1282 CLRNAM   ASC  "CLR"
  1283 AIFNAM   ASC  "AIF"
  1284 EIFNAM   ASC  "EIF"
  1285 DADNAM   ASC  "DAD"
  1286 EQUNAM   ASC  "EQU"
  1287 !
  1288 ! TABLE OF OPCODE PARSING ROUTINES
  1289 !
  1290 OPPRST   DEF  P1REG            ! ARP
  1291          DEF  P1REG            ! DRP
  1292          DEF  P1REG            ! ELB
  1293          DEF  P1REG            ! ELM
  1294          DEF  P1REG            ! ERB
  1295          DEF  P1REG            ! ERM
  1296          DEF  P1REG            ! LLB
  1297          DEF  P1REG            ! LLM
  1298          DEF  P1REG            ! LRB
  1299          DEF  P1REG            ! LRM
  1300          DEF  P1REG            ! ICB
  1301          DEF  P1REG            ! ICM
  1302          DEF  ARTN88           ! ICE
  1303          DEF  P1REG            ! DCB
  1304          DEF  P1REG            ! DCM
  1305          DEF  ARTN88           ! DCE
  1306          DEF  P1REG            ! TCB
  1307          DEF  P1REG            ! TCM
  1308          DEF  P1REG            ! NCB
  1309          DEF  P1REG            ! NCM
  1310          DEF  P1REG            ! TSB
  1311          DEF  P1REG            ! TSM
  1312          DEF  P1REG            ! CLB
  1313          DEF  P1REG            ! CLM
  1314          DEF  ARTN88           ! CLE
  1315          DEF  PORXR            ! ORB
  1316          DEF  PORXR            ! ORM
  1317          DEF  PORXR            ! XRB
  1318          DEF  PORXR            ! XRM
  1319          DEF  ARTN88           ! BIN
  1320          DEF  ARTN88           ! BCD
  1321          DEF  ARTN88           ! SAD
  1322          DEF  ARTN88           ! RTN
  1323          DEF  ARTN88           ! PAD
  1324          DEF  PLDST            ! LDB
  1325          DEF  PLDST            ! LDM
  1326          DEF  PLDST            ! STB
  1327          DEF  PLDST            ! STM
  1328          DEF  PADSB            ! CMB
  1329          DEF  PADSB            ! CMM
  1330          DEF  PADSB            ! ADB
  1331          DEF  PADSB            ! ADM
  1332          DEF  PADSB            ! SBB
  1333          DEF  PADSB            ! SBM
  1334          DEF  PADSB            ! ANM
  1335          DEF  PPUPO            ! POB
  1336          DEF  PPUPO            ! POM
  1337          DEF  PPUPO            ! PUB
  1338          DEF  PPUPO            ! PUM
  1339          DEF  PLBREF           ! JCY
  1340          DEF  PLBREF           ! JEV
  1341          DEF  PLBREF           ! JEN
  1342          DEF  PLBREF           ! JEZ
  1343          DEF  PLBREF           ! JLZ
  1344          DEF  PLBREF           ! JLN
  1345          DEF  PLBREF           ! JMP
  1346          DEF  PLBREF           ! JNO
  1347          DEF  PLBREF           ! JNG
  1348          DEF  PLBREF           ! JNZ
  1349          DEF  PLBREF           ! JNC
  1350          DEF  PLBREF           ! JOD
  1351          DEF  PLBREF           ! JPS
  1352          DEF  PLBREF           ! JRZ
  1353          DEF  PLBREF           ! JRN
  1354          DEF  PJSB             ! JSB
  1355          DEF  PLBREF           ! JZR
  1356          DEF  BSZORG           ! BSZ
  1357          DEF  PABS             ! ABS
  1358          DEF  PASP             ! ASP
  1359          DEF  PNXTO            ! BYT
  1360          DEF  PLBREF           ! GTO
  1361          DEF  PASP             ! ASC
  1362          DEF  PLBREF           ! DEF
  1363          DEF  PLBREF           ! NAM
  1364          DEF  PLBREF           ! VAL
  1365          DEF  PGLO             ! GLO
  1366          DEF  ARTN88           ! FIN
  1367          DEF  ARTN88           ! LST
  1368          DEF  ARTN88           ! UNL
  1369          DEF  PLNK             ! LNK
  1370          DEF  BSZORG           ! ORG
  1371          DEF  PLBREF           ! SET
  1372          DEF  PLBREF           ! CLR
  1373          DEF  PLBREF           ! AIF
  1374          DEF  ARTN88           ! EIF
  1375          DEF  PDADEQ           ! DAD
  1376          DEF  PDADEQ           ! EQU
  1377 !
  1378 GT!LBL   CMB  R20,=41          ! BANG?
  1379          JNZ  NOBNG            ! jif no
  1380 PSHCOM   LDB  R#,=376          ! REM token
  1381 REMCHR   PUBD R#,+R12          ! push it out
  1382          POBD R#,+R10          ! get next char
  1383          CMB  R#,=15           ! CR?
  1384          JNZ  REMCHR           ! jif no
  1385 TRIMSP   POBD R22,-R12         ! get last char pushed
  1386          CMB  R22,=40          ! space?
  1387          JZR  TRIMSP           ! jif yes, trim trailing spaces
  1388          PUBD R22,+R12         ! put last char back
  1389          CLE                   ! flag successful
  1390          RTN
  1391 !
  1392 NOBNG    CLE
  1393          ICE                   ! flag failed to get REM
  1394          LDMD R41,=BLANKS      ! load 7 SPACE characters
  1395          LDB  R41,=377         ! LABEL token
  1396          LDB  R0,=42           ! where to start copying the label (R42)
  1397 LBLLOP   STB  R20,R*           ! copy a char
  1398          ICB  R0               ! move to next reg
  1399          CMB  R0,=51           ! done? (label plus space in R50)
  1400          JNZ  LBLOK            ! jif no
  1401          JSB  =LBLERR          ! label too long, error
  1402          RTN
  1403 !
  1404 LBLOK    POBD R20,+R10         ! get next char from input
  1405          CMB  R20,=15          ! CR?
  1406          JZR  PSHLBL           ! jif yes
  1407          CMB  R20,=40          ! space (end of label)?
  1408          JNZ  LBLLOP           ! jif no, get more
  1409          JSB  =GCHAR           ! get next char into R20
  1410 PSHLBL   PUMD R41,+R12         ! push line leng & the blank-filled label
  1411          RTN
  1412 !
  1413 DUPLB?   BIN
  1414          JSB  =GTSTRT          ! get start of 'pgm' src, just after PCB
  1415 FLBLOP   POMD R32,+R30         ! get first line#
  1416          CMM  R32,=231,251     ! 'permanent' END line# A999?
  1417          JZR  ARTN92           ! jif yes
  1418          CLM  R34
  1419          POBD R34,+R30         ! get line length as WORD
  1420          CMMD R41,R30          ! see if label is at start of line
  1421          JZR  FNDLBL           ! jif found matching label
  1422 NXTLIN   ADM  R30,R34          ! else skip line
  1423          JMP  FLBLOP
  1424 !
  1425 FNDLBL   CMMD R32,=AUTO#       ! matching label on same line#?
  1426          JZR  NXTLIN           ! jif yes, not a dupe, keep searching
  1427          ICE                   ! flag problem
  1428          TSB  R0               ! called from FLABEL?
  1429          JZR  ARTN92           ! jif yes, else called from PRSHOK
  1430 !
  1431          PUMD R40,+R6          ! save R40-47 on stack
  1432          STMD R32,=SAVER6      ! save line# in SAVER6
  1433          STMD R32,=FLDCOM      ! set FirstLineDeCOMpile to that line
  1434          LDM  R46,=WDUPLB      ! R46-47 = addr of "DUPE LABEL" message
  1435          JSB  =PRTERR          ! print it
  1436          POMD R40,-R6          ! recover R40-47
  1437          ICE
  1438 ARTN92   RTN
  1439 ! ****************************************************************
  1440 ! BASIC
  1441 ! ****************************************************************
  1442          BYT  141
  1443 BASIC.   JSB  =STBAS1          ! load ASM RAM ptr & set us to BASIC mode
  1444          LDB  R#,=236          ! load RTN instruction into R40
  1445          LDM  R41,R40          ! ripple-copy it through R41-47
  1446          STMD R41,=CHIDLE      ! store 7 RTNs to CHIDLE (release hook)
  1447          STMD R41,=PRSIDL      ! and release PRSIDL, too
  1448 ASMSUB   JSB  =ERMSGS          ! do a SCRATCH
  1449 SPITRD   LDM  R46,=MREADY      ! READY message
  1450 SPITR-   JSB  =CPYSTR          ! copy it out
  1451          JSB  =DODISP          ! set the CRT as the output device
  1452          JSB  =DUMPIT          ! dump the message
  1453          RTN
  1454 !
  1455 ! **************************************************************
  1456 ! ASSEMBLER
  1457 ! **************************************************************
  1458          BYT  141
  1459 ASMLR.   JSB  =ASMSUB          ! SCRATCH and spit READY message
  1460          JSB  =ALOCUS          ! look like it's ALLOCATED BASIC program
  1461 ! INIPGM at end of ALOCUS leaves R34=FWCURR and DRP=67
  1462          LDB  R#,=200          ! SECURITY protects against STORE in ASM
  1463          STBD R#,X34,P.SFLG    ! save it in the PCB
  1464 !
  1465 ! The following does LDM R41,= "JSB=ROMJSB  DEF CHRHOK  BYT 50  RTN"
  1466 ASMRST   DRP  R41
  1467          BYT  251              ! load code for CHIDLE
  1468          JSB  =ROMJSB
  1469          DEF  CHRHOK
  1470          BYT  50
  1471          RTN
  1472 !
  1473 !
  1474          STMD R#,=CHIDLE       ! take over CHIDLE keyboard hook
  1475          LDM  R36,=PRSHOK      ! modify the code for taking PRSIDL
  1476          STM  R36,R44          ! change CHRHOK addr in R44-45 to PRSIDL
  1477          STMD R41,=PRSIDL      ! take over PRSIDL parsing hook
  1478          JSB  =GTABAS          ! get ASM RAM ptr
  1479          STBD R15,X#,ASMMOD    ! set flag (non-zero) we're in ASM mode
  1480          RTN
  1481 !
  1482 MREADY   ASP  "READY"
  1483 !
  1484 ! ***********************************************
  1485 ! FLABEL
  1486 ! ***********************************************
  1487          BYT  141
  1488 FLBL.    JSB  =POPLBL          ! label in R42-47, R30=ptr start of src
  1489          JZR  FDONE            ! jif no/empty label
  1490          CLM  R0               ! clear auto-numbering
  1491          STMD R0,=AUTO#
  1492          JSB  =DUPLB?          ! find the label
  1493          JEZ  FDONE            ! jif not found
  1494 FLBLLP   JSB  =DSPLIN          ! display the found line
  1495          CLE
  1496          JSB  =NXTLIN          ! again, in case label's on more lines
  1497          JEN  FLBLLP           ! jif found again, loop
  1498 FDONE    JMP  SPITRD           ! else done
  1499 !
  1500 DSPLIN   JSB  =PSHRGS          ! save registers
  1501          STMD R32,=FLDCOM      ! save line# of label
  1502          STM  R32,R45          ! copy to R45-46
  1503          STB  R34,R47          ! line len in R47
  1504          STM  R30,R24          ! address of line for LIST
  1505          JSB  =LIST1           ! decompile the line
  1506          JSB  =DUMPIT          ! display it
  1507          JSB  =POPRGS          ! restore registers
  1508          RTN
  1509 !
  1510 ! *******************************************
  1511 ! FREFS
  1512 ! *******************************************
  1513          BYT  141
  1514 FREFS.   JSB  =POPLBL          ! get the label and setup
  1515          JZR  FDONE            ! jif no label
  1516 FROLOP   POMD R32,+R30         ! get line#
  1517          CMM  R32,=231,251     ! A999? (final hidden END line?)
  1518          JZR  FDONE            ! jif yes
  1519          CLM  R34
  1520          POBD R34,+R30         ! line len
  1521          LDM  R36,R30          ! copy line ptr
  1522          LDM  R26,R30
  1523          ADM  R26,R34          ! end of line ptr
  1524 FRILOP   POBD R40,+R36         ! get next byte of line
  1525          CMB  R40,=377         ! label?
  1526          JZR  FRGOTIT          ! jif yes
  1527 FREND?   CMM  R36,R26          ! end of line?
  1528          JNZ  FRILOP           ! jif no
  1529 FRNEXT   LDM  R30,R26          ! point overall search ptr to end of line
  1530          JMP  FROLOP           ! go search next line
  1531 !
  1532 FRGOTIT  POMD R52,+R36         ! get the label
  1533          CMM  R52,R42          ! match the one we're looking for?
  1534          JNZ  FREND?           ! jif no
  1535          JSB  =DSPLIN          ! display the line
  1536          JMP  FRNEXT           ! go to next line and continue searching
  1537 !
  1538 POPLBL   BIN
  1539          JSB  =DODISP          ! set CRT as output device
  1540          POMD R22,-R12         ! get string address
  1541          POMD R24,-R12         ! get string len
  1542          JZR  ARTN83           ! jif 0 len, nothing to do
  1543          CMB  R24,=7           ! too long?
  1544          JNC  LLENOK           ! jif no, okay
  1545          LDB  R24,=6           ! limit len
  1546 LLENOK   LDB  R0,=42           ! point at R42
  1547          ADB  R0,R24           ! plus len of string
  1548          LDMD R42,R22          ! get the label string
  1549 ! fall through and fill the label with trailing blanks
  1550 !
  1551 ! The following code loads blanks into the register pointed to by R0,
  1552 ! up to 8 of them.  The rest (that don't get loaded) are processed
  1553 ! as ARP 40 instructions.
  1554 !
  1555          DRP  R*
  1556          BYT  251
  1557 BLANKS   BYT  40
  1558          BYT  40
  1559          BYT  40
  1560          BYT  40
  1561          BYT  40
  1562          BYT  40
  1563          BYT  40
  1564          BYT  40
  1565 !
  1566          LDB  R41,=377         ! put a LABEL 'token' in front of it
  1567 GTSTRT   CLE
  1568          LDMD R30,=FWCURR      ! point at source code PCB
  1569          ADM  R30,=30,0        ! point at first line of source code
  1570 ARTN83   RTN
  1571 !
  1572 ! SCRATCHBIN
  1573 !
  1574 ! ********************************************************
  1575 ! SCRATCHBIN
  1576 ! ********************************************************
  1577          BYT  241              ! attribs: BASIC stmt legal after THEN
  1578 SCRTB.   LDB  R22,=2           ! ROMFL=2 means SCRATCH
  1579          STBD R22,=ROMFL
  1580 !
  1581          JSB  =ROMJSB
  1582          DEF  BPINI            ! call the binary program's INIT routine
  1583          BYT  0
  1584 !
  1585          BIN
  1586          LDMD R24,=BINTAB      ! get base address of BPGM
  1587          JZR  ARTN82           ! jif 0, none loaded
  1588          STBD R24,=GINTDS      ! disable global interrupts
  1589          STM  R24,R22          ! copy BINTAB
  1590          DCM  R24              ! -1 = last byte of what to copy/move
  1591          SBMD R22,=LAVAIL      ! BINTAB-LAVAIL = how much to move
  1592          LDMD R26,=LWAMEM      ! highest memory address
  1593          JSB  =MOVDN           ! move CALCVRBs, tmpmem, for/next stk,etc
  1594          LDMD R30,=LWAMEM      ! highest memory address
  1595          SBMD R30,=BINTAB      ! -BINTAB = offset of movement - 1
  1596          ICM  R30              ! offset of movement
  1597          LDB  R22,=5           ! # (LAVAIL,CALVRB,RTNSTK,NXTRTN,FWBIN)
  1598          LDM  R26,=LAVAIL      ! address of first ptr
  1599 ADJLOP   LDM  R36,R30          ! get next ptr
  1600          ADMD R36,R26          ! add offset to it
  1601          PUMD R36,+R26         ! store back out
  1602          DCB  R22              ! dec loop counter
  1603          JNZ  ADJLOP           ! jif not done
  1604          CLM  R22
  1605          STMD R22,=BINTAB      ! zero BINTAB (no binary loaded)
  1606          STBD R22,=GINTEN      ! enable global interrupts
  1607 ARTN82   RTN
  1608 !
  1609 CLRPGM   JSB  =GTFWCU          ! get ptr to FWCURR
  1610          CLM  R65
  1611          STMD R65,X#,P.TYPE    ! set BASIC MAIN program and 0 len
  1612          RTN
  1613 !
  1614 ! ************************************************************
  1615 ! DELETE
  1616 ! ************************************************************
  1617          BYT  141
  1618 DEL.     JSB  =CLRPGM          ! set P.TYPE, P.LEN to 0 (de-allocated)
  1619          JSB  =ROMJSB
  1620          DEF  DELET.           ! delete the assembler source lines
  1621          BYT  0
  1622 !
  1623 ! now (fake) re-allocate us, so system doesn't mess with source code
  1624 !
  1625 ALOCUS   JSB  =GTFWCU          ! get ptr to FWCURR in R56
  1626          LDB  R66,=40          ! allocated bit for P.TYPE
  1627          LDBD R67,X#,P.TYPE    ! get PCB type byte
  1628          ORB  R67,R66          ! set the allocated bit
  1629          STBD R67,X56,P.TYPE   ! save it
  1630          JSB  =ROMJSB
  1631          DEF  INIPGM           ! calc 'program' length and set it in PCB
  1632          BYT  0
  1633          RTN
  1634 !
  1635 ! **********************************************************
  1636 ! TREM
  1637 ! **********************************************************
  1638          BYT  141              ! attribs: non-programmable BASIC stmt
  1639 TREM.    JSB  =GTABAS          ! get ASM RAM ptr
  1640          LDBD R20,X#,EOLREM    ! get hide/show remarks flag
  1641          DCB  R20              ! 0->377, 1->0
  1642          JZR  TREMST           ! jif 1->0
  1643          LDB  R20,=1           ! 0->377, change to 1
  1644 TREMST   STBD R#,X#,EOLREM     ! save toggled flag
  1645          RTN
  1646 !
  1647 ! *************************************************************
  1648 ! PLIST
  1649 ! *************************************************************
  1650          BYT  241              ! attribs: programmable BASIC statement
  1651 PLST.    JSB  =DOPRNT          ! set output device to PRINTER IS
  1652          JMP  LST-             ! do rest of LIST
  1653 !
  1654 ! *************************************************************
  1655 ! LIST
  1656 ! *************************************************************
  1657          BYT  241              ! attribs: programmable BASIC statement
  1658 LST.     JSB  =DODISP          ! set output device to CRT IS
  1659 LST-     BIN
  1660          LDMD R46,=LDFLTR      ! list break line count
  1661          STMD R46,=MTFLAG      ! save temp copy of it
  1662          JSB  =LIST1P          ! set LLDCOM to list one page
  1663          JSB  =COPSUB          ! get SCTEMP (real) to R46-47 (bin)
  1664          CMB  R#,=4            ! =4? (internal printer?)
  1665          JNZ  LNOT4            ! jif no
  1666          JSB  =CRTPOF          ! turn off the CRT
  1667 LNOT4    CMB  R46,=2
  1668          JZR  L2               ! jif yes
  1669 !
  1670          LDM  R74,=231,231,0,0 ! first line=0, last line==9999
  1671          STMD R74,=LLDCOM      ! set last line decompile
  1672 L2       LDB  R0,=1            ! secure against LISTING
  1673          JSB  =SECUR?          ! check security, gen error if so
  1674 !
  1675          JSB  =ROMJSB
  1676          DEF  TO?I             ! get 0, 1, or 2 args from stk as INTs
  1677          BYT  0
  1678 !
  1679          JEZ  LNOARG           ! jif none
  1680          LDM  R26,R45          ! get first line argument
  1681          STMD R26,=FLDCOM      ! save as FirstLineDeCOMpile
  1682          DCE                   ! two arguments?
  1683          JEZ  LNOARG           ! jif no, only first line#
  1684          LDM  R26,R55          ! copy ending line#
  1685          STMD R26,=LLDCOM      ! save as LastLineDeCOMpile
  1686 LNOARG   LDMD R76,=FLDCOM      ! get first line to list
  1687 !
  1688          JSB  =ROMJSB
  1689          DEF  FNDLIN           ! find the line
  1690          BYT  0
  1691 !
  1692          LDM  R24,R36          ! copy the ptr
  1693 LSTNLI   CMB  R17,=300         ! error finding the line?
  1694          JCY  LSTEND           ! jif yes, bail
  1695          LDBD R15,=SVCWRD      ! check if a key has been hit
  1696          JOD  LSTEND           ! jif yes, abort the list
  1697          LDMD R46,R24          ! get the line#
  1698          STMD R46,=FLDCOM      ! save it as the new first line to list
  1699          JSB  =ADCOML          ! list the line
  1700          JEZ  LSTMEM           ! jif error, abort
  1701          LDMD R76,=LLDCOM      ! get last line to list
  1702          CMB  R77,=252         ! AA (page mode)? (if so r76 = line cnt)
  1703          JNZ  LSTPRT           ! jif no, not page mode
  1704 DLNCNT   DCB  R76              ! dec line counter
  1705          SBM  R66,=40,0        ! longer than 32 characters?
  1706          JZR  LSVLLD           ! jif no, EXACTLY 32!
  1707          JPS  DLNCNT           ! jif MORE than 32
  1708 LSVLLD   STBD R76,=LLDCOM      ! save new last line info
  1709          JNG  LSTEND           ! jif reached end
  1710 LSTPRT   JSB  =COPSUB          ! get the select code of output device
  1711          STB  R46,R45          ! save it in 45
  1712          LDMD R46,X46,LISTBL   ! get address of output routine
  1713 !
  1714          JSB  =ROMJSB
  1715          DEF  DRV12+           ! output it
  1716          BYT  0
  1717 !
  1718          JMP  LSTNLI           ! go list the next line
  1719 !
  1720 LSTMEM   JSB  =ROMJSB
  1721          DEF  LSRTN+           ! setup for freemem at end of list
  1722          BYT  0
  1723 !
  1724 LSTEND   JSB  =ROMJSB
  1725          DEF  CRTPUP           ! power up the CRT if it was powered-down
  1726          BYT  0
  1727          RTN                   ! done
  1728 !
  1729 ADCOML   POMD R45,+R24         ! get next line# and len
  1730          BIN
  1731          CMM  R45,=231,251,2   ! is it FINAL (hidden END) line?
  1732          JZR  DCNFND           ! jif yes
  1733          LDMD R36,=LLDCOM      ! get LastLineDeCOMpile
  1734          BCD
  1735          CMM  R36,R45          ! are we less than the last line to list?
  1736          BIN
  1737          JNC  DC1ERR           ! jif no, we're past it
  1738 !
  1739 ! R45-46 = line#
  1740 ! R47 = line len
  1741 ! R24 = ptr to next byte AFTER line len
  1742 !
  1743 LIST1    CLB  R30
  1744          STBD R30,=LSTFLG      ! turn off listing
  1745          LDM  R30,=INPBUF      ! address of output buffer
  1746          JSB  =DCOM1L          ! decompile line# R45/R24
  1747          CMB  R17,=300         ! errors?
  1748          JCY  DC1ERR           ! jif yes
  1749          LDM  R26,=INPBUF      ! address of what to display
  1750          LDB  R36,=15          ! CR character
  1751          PUBD R36,+R#          ! add it to the end of the buffer
  1752          LDM  R36,R#           ! copy the end of the buffer ptr
  1753          SBM  R36,R26          ! minus the start = len
  1754          STM  R36,R66          ! copy len
  1755          CLE
  1756          ICE                   ! flag successful
  1757          RTN
  1758 !
  1759 DC1ERR   CLB  R47
  1760 DCNFND   CLE                   ! flag error
  1761          RTN
  1762 !
  1763 ! Decompile one line
  1764 ! R45-46 = line#
  1765 ! R47 = line len
  1766 ! R24 = ptr to next byte AFTER line len
  1767 !
  1768 DCOM1L   CLB  R36
  1769          STBD R36,=PRECNT      ! clear so system won't do...
  1770          STBD R36,=ONFLG       ! ... decompile of src code
  1771          STBD R36,=COMFLG      ! set not common vars
  1772          LDM  R36,R45          ! copy line# from R45-46
  1773          JSB  =DCLIN#          ! decompile it to R30 buffer
  1774 DCLST    LDMD R50,=BLANKS      ! get 8 blanks
  1775          LDBD R20,R24          ! get next byte of line
  1776          CMB  R20,=376         ! is it a REMARK?
  1777          JZR  DCREM            ! jif yes
  1778          JCY  DCLABL           ! jif there's a LABEL
  1779          PUMD R51,+R30         ! if no label, push SEVEN SPACES
  1780 DCOPC    POMD R55,+R24         ! get the OPC
  1781          PUMD R55,+R30         ! push it to output buffer
  1782          POBD R20,+R24         ! get next byte after 3-char opcode
  1783          CMB  R20,=111         ! 'I'?
  1784          JZR  DCOPC4           ! jif yes
  1785          CMB  R20,=104         ! 'D'?
  1786          JZR  DCOPC4           ! jif yes
  1787 DCNXT+   PUBD R50,+R30         ! else push it out
  1788 DCNEXT   CMB  R20,=376         ! eol remark?
  1789          JZR  DCEOLR           ! jif yes
  1790          JCY  DCGCH            ! jif LABEL
  1791          CMB  R20,=16          ! is it EOL?
  1792          JZR  RTNA30           ! jif yes
  1793          CMM  R30,=ERBEND      ! output buffer full?
  1794          JZR  DCFULL           ! jif yes
  1795 DCCHAR   PUBD R20,+R30         ! push next char out
  1796          POBD R20,+R24         ! get next byte of input
  1797          JMP  DCNEXT
  1798 !
  1799 DCREM    POBD R20,+R24         ! skip the 376 label token
  1800 DCBANG   LDB  R20,=41          ! ASCII '!' character
  1801          JMP  DCCHAR
  1802 !
  1803 DCLABL   POMD R51,+R24         ! get 0377 label token & 6 chars of label
  1804          PUMD R52,+R30         ! push 6 chars of label to output buffer
  1805          PUBD R50,+R30         ! push trailing SPACE
  1806          JMP  DCOPC
  1807 !
  1808 DCOPC4   PUBD R20,+R30         ! push 4th char of opcode
  1809          POBD R20,+R24         ! get next char
  1810          JMP  DCNXT+
  1811 !
  1812 DCEOLR   JSB  =GTABAS          ! get base of ASM RAM
  1813          LDBD R#,X#,EOLREM     ! hide EOL remark?
  1814          JNZ  DCSHOW           ! jif no
  1815 DCHIDE   POBD R#,+R24          ! get next char of line
  1816          CMB  R#,=16           ! EOL token?
  1817          JNZ  DCHIDE           ! jif no, skip entire comment
  1818          JMP  RTNA30
  1819 !
  1820 DCSHOW   LDM  R76,=INPBUF      ! address of output buffer
  1821          ADM  R76,=40,0        ! skip to column 32 dec
  1822          LDBD R75,=LSTFLG      ! display or printer?
  1823          JZR  DCCRT            ! jif display
  1824          ADM  R76,=12,0        ! bump comment over another 10 dec cols
  1825 DCCRT    PUBD R50,+R30         ! push out space
  1826          CMM  R30,R76
  1827          JNC  DCCRT            ! until we reach the desired column
  1828          JMP  DCBANG
  1829 !
  1830 DCGCH    POBD R20,+R24         ! get next char
  1831          JMP  DCNEXT
  1832 !
  1833 DCFULL   DCM  R#               ! move output buffer ptr back from end
  1834 DCSKPE   POBD R20,+R24         ! get next byte
  1835          CMB  R20,=16          ! EOL token?
  1836          JNZ  DCSKPE           ! jif no, skip to end of line
  1837 RTNA30   ARP  R30
  1838          RTN
  1839 !
  1840 ! Collect all the available space together, with all the code and
  1841 ! the label table moved down to the end of available memory.
  1842 !
  1843 DATDN    LDMD R24,=ACODEN      ! end of src to move
  1844          LDMD R26,=ALAVAI      ! dest (end of memory)
  1845          STMD R26,=ACODEN      ! set new location for 'src'
  1846          STM  R26,R36          ! copy dest
  1847          LDM  R22,R24          ! copy src
  1848          SBMD R22,=ALBTBL      ! len of src-1
  1849          ICM  R22              ! len of src
  1850          SBM  R36,R24          ! offset being moved by
  1851          LDMD R34,=ACODBA      ! another ptr
  1852          ADM  R34,R36          ! adjust that ptr by distance moved
  1853          STMD R34,=ACODBA      ! resave it
  1854          LDMD R34,=ALBTBL      ! beginning of what we're moving
  1855          ADM  R34,R36          ! adjust it
  1856          STMD R34,=ALBTBL      ! resave it
  1857          JSB  =MOVDN           ! move them down (to end of avail memory)
  1858          RTN
  1859 !
  1860 ! recenter the code and the label table, splitting the available space
  1861 ! above and below.
  1862 !
  1863 RECNTR   JSB  =DATDN           ! mov it all down
  1864 RECNT-   LDMD R26,=ALBTBL      ! address of end of hole (start of data)
  1865          STM  R26,R24          ! set as source
  1866          STM  R26,R36          ! copy
  1867          SBM  R26,R12          !  -start of hole = available space
  1868          LRM  R27              ! find center of available space
  1869          ADM  R26,R12          ! add it to base to get new center
  1870 DATUP-   STMD R#,=ALBTBL       ! save as new location
  1871          LDMD R22,=ACODEN      ! get end of data
  1872          STM  R22,R34          ! copy
  1873          SBM  R22,R24          ! len of data to move
  1874          SBM  R36,R26          ! offset of how far we're moving
  1875          SBM  R34,R36          ! adjust end-address
  1876          STMD R34,=ACODEN      ! resave it
  1877          LDMD R34,=ACODBA      ! get mid-address
  1878          SBM  R34,R36          ! ajdust it
  1879          STMD R34,=ACODBA      ! resave it
  1880          JSB  =MOVUP           ! move em back up
  1881          RTN
  1882 !
  1883 ! Collect all the available space together with all the code and
  1884 ! the label table moved up to the beginning of available memory.
  1885 !
  1886 DATUP    LDMD R24,=ALBTBL      ! get the beginning of the data
  1887          STM  R24,R36          ! copy
  1888          LDM  R26,R12          ! get destination (start of avail memory)
  1889          ADM  R26,=100,0       ! leave 64 bytes available
  1890          JMP  DATUP-           ! go move it
  1891 !
  1892 CMEMBT   LDMD R22,=ALAVAI      ! end of available memory
  1893          SBM  R22,=ACODEN      ! minu end of data
  1894 CKMEM-   CMM  R#,=200          ! at least 128 bytes left?
  1895          ARP  R0
  1896          RTN
  1897 !
  1898 CMEMTP   LDMD R22,=ALBTBL      ! get start of data
  1899          SBM  R22,R12          ! minus start of top space
  1900          JMP  CKMEM-           ! 128 bytes left at top?
  1901 !
  1902 FNMERR   JSB  =ERROR+
  1903          BYT  103              ! ERROR: File name
  1904 !
  1905 ! **********************************************************************
  1906 ! * ASSEMBLE "filename" [,dont-load-bpgm]
  1907 ! **********************************************************************
  1908 ! NOTE: At Assemble-time, the ASM ROM uses storage
  1909 ! for the LEGEND (key labels) and KEYTAB (ON GOSUB
  1910 ! table) for variables, since they're not used while
  1911 ! in Assembler mode and get reloaded going back to
  1912 ! BASIC. See the DAD's at the top of the file for a
  1913 ! list of the various variable-to-memory assignments.
  1914 !
  1915 ! The Assembler uses all of memory between NXTMEM and
  1916 ! LAVAIL to store references to so-far-undefined labels,
  1917 ! the label table (defined and undefined), and the code
  1918 ! as it's assembled.  The references to so-far-undefined
  1919 ! labels is a table (or heap) of pairs of 2-byte entries
  1920 ! between NXTMEM and R12.  Each pair contain an offset
  1921 ! into the label table to the label that was referenced
  1922 ! but not yet defined, and an offset into the code where
  1923 ! the reference was made.  Every time a new label is
  1924 ! encountered (DEFINED!), the ASM ROM searches through
  1925 ! the list of references to see if there were any
  1926 ! forward-references to it (because the label table offset
  1927 ! matches) then the code offset from the table is used
  1928 ! to insert the appropriate address or offset (depending
  1929 ! upon the type of reference.
  1930 !
  1931 ! The label table and code are kept together in the
  1932 ! middle of available memory, with the label table growing
  1933 ! upward towards R12/NXTMEM, and the code growing downward
  1934 ! toward LAVAIL.  A minimum of 128 dec bytes is maintained
  1935 ! between the end of the label table and R12 and between
  1936 ! the end of the code and the end of available memory.
  1937 ! When it gets too small on one end or the other, the label
  1938 ! table and code gets re-centered.  So, memory looks like this:
  1939 !
  1940 !  lower addresses
  1941 !   |						|
  1942 !   +-----------------------+
  1943 !   |	Forward references	| <-- NXTMEM
  1944 !   ...						...
  1945 !   |		list			|
  1946 !   |						|
  1947 !   +-----------------------+
  1948 !   |						| <-- R12 (may be same as NXTMEM if
  1949 !   ...	free memory		   ...       forward-references list is empty)
  1950 !   |						|
  1951 !   +-----------------------+
  1952 !   |						| <-- ALBTBL (100720) growing-end of lbl tbl
  1953 !   |		Label			|
  1954 !   ...					   ...
  1955 !   |		table			|
  1956 !   |						|
  1957 !   +-----------------------+
  1958 !   |						| <-- ACODBA (100722) start of output code
  1959 !   |		output			|
  1960 !   ...	   assembled	   ...
  1961 !   |		 code			|
  1962 !   |						|
  1963 !   +-----------------------+
  1964 !   |						| <-- ACODEN (100724) end of output code
  1965 !   |						|
  1966 !   ...	free memory		   ...
  1967 !   |						|
  1968 !   |						| <-- ALAVAI (end of Assembler's avail mem
  1969 !   +-----------------------+
  1970 !   |	512 'safety' bytes	|
  1971 !   | for CALC MODE stuff	| <-- LAVAIL
  1972 !   +-----------------------+
  1973 ! 	|						|
  1974 !  higher addresses
  1975 !
  1976 !  So, the ASM ROM makes a single pass through the source code,
  1977 !  building the output code at ACODEN, and keeping a table of
  1978 !  labels and a table of label forward-references.  (If the label
  1979 !  is already defined when it's referenced, then of course the
  1980 !  actual value can be used right then and there, removing any
  1981 !  need for adding to the forward-reference table. When forward
  1982 !  references are resolved, they are removed from the forward
  1983 !  reference table.
  1984 !
  1985 !  The entries on the "forward references list" (or table) consist
  1986 !  of pairs of 16-bit offsets.  The first (at the lower address)
  1987 !  contains the offset from ACODBA to the label in the label table.
  1988 !  The second (at the higher address) is the offset from ACODBA
  1989 !  into the code being assembled of where the label was referenced.
  1990 !
  1991 !  When the FIN is encountered at the end of the assembly, then
  1992 !  if there are any unresolved forward references and a global
  1993 !  file was specified, then the label table gets replaced with the
  1994 !  pre-assembled GLO file and another pass is done to try to satisfy
  1995 !  the unresolved forward references.
  1996 !
  1997 ! **********************************************************************
  1998          BYT  141              ! attrib: non-programmable BASIC stmt
  1999 ASMBL.   JSB  =ONEB            ! get dont-load-bpgm flag
  2000 ! (0 was pushed during parse if none provided)
  2001          ORB  R#,R47           ! OR two bytes together
  2002          STBD R#,=ALODBP       ! save as a single byte flag
  2003          CLM  R36
  2004          STMD R36,=GNMLEN      ! ...in LEGEND area
  2005          LDM  R56,=LAST+1      ! load addr of ERRBUF (same as LAST+1)
  2006          STM  R56,R46          ! copy it
  2007          POMD R24,-R12         ! get address of target BPGM file name
  2008          POMD R26,-R12         ! get len of file name
  2009          JZR  FNMERR           ! jif 0 len, error
  2010          CMM  R26,=140,0       ! len > 96 dec
  2011          JNC  AFNLOK           ! jif no
  2012          LDM  R26,=140,0       ! limit to 96 dec
  2013 AFNLOK   POBD R30,+R24         ! copy the input filename
  2014          PUBD R30,+R56         !   to ERRBUF
  2015          DCM  R26              ! dec len
  2016          JNZ  AFNLOK           ! loop til copied
  2017          LDB  R26,=16          ! put an EOL token on the end of it
  2018          PUBD R26,+R56
  2019          LDM  R56,=ABPNAM      ! where to put the cleaned-up BPGM name
  2020          JSB  =GFNAME          ! 'parse' filename to <=10 chars & MSUS
  2021          STMD R#,=ABNLEN       ! DRP 46, save len of filename
  2022          LDMD R12,=NXTMEM      ! R12 stack is empty, we start at NXTMEM
  2023          STMD R12,=AIFFLG      ! set conditional-assembly flag ON
  2024          CLM  R40
  2025          STMD R40,=KEYTAB      ! zeroes to all 16 bytes of KEYTAB
  2026          STMD R40,=KYTB+8      ! first 8 and second 8
  2027          LDMD R22,=LAVAIL      ! LAVAIL
  2028          SBM  R22,=0,2         !   -512 bytes
  2029          STMD R22,=ALAVAI      ! =safe end of what we'll use
  2030          LRM  R23              ! divide by 2
  2031          LDM  R24,R12          ! get R12 ptr (NXTMEM)
  2032          LRM  R25              ! divide by 2
  2033          ADM  R22,R24          ! midway twixt start & end of avail mem
  2034          STMD R22,=ACODBA      ! save start of output code in LEGEND
  2035          STMD R22,=ACODEN      ! save end of output code in LEGEND
  2036          STMD R22,=ALBTBL      ! save end, grows 'upward' to lower addrs
  2037 ASMLNK   JSB  =GTSTRT          ! set R30 pointing to first line of prgm
  2038          STM  R#,R10           ! copy R30 to R10
  2039 FIXMEM   JSB  =CMEMBT          ! at least 128 bytes left?
  2040          JCY  MOK1             ! jif yes
  2041          JSB  =RECNTR          ! else recenter it
  2042          JSB  =CMEMBT          ! now >= 128 bytes left?
  2043          JCY  MOK1             ! jif yes
  2044 !
  2045 MNOTOK   JSB  =ERROR+          ! else terminal error
  2046          BYT  23               ! MEM OVF
  2047 !
  2048 MOK1     JSB  =CMEMTP          ! at least 128 bytes at top?
  2049          JCY  MOK2             ! jif yes
  2050          JSB  =RECNTR          ! else recenter it
  2051          JSB  =CMEMTP          ! now at least 128 bytes at top?
  2052          JNC  MNOTOK           ! jif no, terminal error
  2053 MOK2     LDMD R24,=ACODEN      ! get end of new code
  2054          STMD R10,=PCR         ! save current line ptr
  2055          POMD R2,+R10          ! get line#
  2056          CMM  R2,=231,251      ! final END line# A999?
  2057          JNZ  LNOK             ! jif no
  2058 !
  2059          JSB  =AROMER          ! Assembler ROM error
  2060          JSB  =ERROR+
  2061          BYT  16               ! FIN-LNK
  2062 !
  2063 LNOK     STMD R#,=SAVER6       ! save the line# in SAVER6
  2064          CLM  R#
  2065          POBD R#,+R#           ! get line len in R2
  2066          STMD R10,=ASTLIN      ! save ptr to start of line in LEGEND
  2067          LDB  R20,=376         ! comment 'token'
  2068          CMBD R20,R#           ! comment?
  2069          JZR  SKPLIN           ! jif yes, skip it
  2070          JCY  OPJM             ! jif not label
  2071 !
  2072 ! there's a label on the current line.  Check for dupes and fwd refs
  2073 !
  2074          POMD R41,+R#          ! else get the label
  2075          LDMD R20,=AIFFLG      ! is assembly conditionally on?
  2076          JNZ  AIFON            ! jif yes
  2077          LDMD R65,R#           ! assembly is off, get opcode
  2078          CMMD R65,=EIFNAM      ! EIF?
  2079          JNZ  DJMP1            ! jif no, just list it
  2080 AIFON    JSB  =SLBLTB          ! search the label table for the label
  2081          JEN  DUP?             ! jif found, error if already defined
  2082          PUMD R42,-R20         ! add it to the start of the label table
  2083          LDM  R36,R20          ! get ptr
  2084          SBM  R36,=3,0         ! reserve 3 bytes, line# or addr and flag
  2085          STMD R36,=ALBTBL      ! update end-of-label-table ptr
  2086 IGNLBL   POMD R65,+R10         ! get the 3-char opcode
  2087          CMMD R65,=EQUNAM      ! EQU?
  2088          JZR  DODAEQ           ! jif yes
  2089          CMMD R65,=DADNAM      ! DAD?
  2090          JZR  DODAEQ           ! jif yes
  2091          JSB  =INVARP          ! invalidate CURARP & CURDRP to 377
  2092          LDM  R56,R24          ! end of code (addr where label exists)
  2093          SBMD R56,=ACODBA      ! -code start = rel addr in code of label
  2094          PUMD R56,-R20         ! push address into label table
  2095          CLB  R56              ! clear flags byte
  2096          PUBD R56,-R20         ! push 0 flags into label table
  2097          JSB  =SATREF          ! label is defined, satisfy fwd-refs
  2098          JMP  ITSOP-
  2099 !
  2100 SKPLIN   ADM  R10,R2           ! add len of line to current line ptr
  2101          DCM  R10              ! -1 to adjust for already moved R10
  2102          JMP  DJMP1            ! go spit the line to the output listing
  2103 !
  2104 DUP?     LDM  R36,R50          ! get line# for first label
  2105          JZR  IGNLBL           ! jif not yet seen
  2106          LDM  R46,=EDUPLB      ! else spit out DUPE LAB err
  2107          JSB  =PRTERR
  2108          JMP  DJMP1
  2109 !
  2110 OPJM     JMP  ITSOP
  2111 !
  2112 DODAEQ   PUMD R20,+R6          ! save label table ptr
  2113          PUMD R65,+R6          ! save opcode
  2114          JSB  =AGTVAL          ! get value for the DAD or EQU
  2115          POMD R65,-R#          ! recover the opcode
  2116          POMD R20,-R#          ! recover the label table ptr
  2117          CMB  R65,=105         ! EQU?
  2118          DRP  R76
  2119          JZR  DDE              ! jif yes
  2120          ADMD R76,=ORGBAS      ! add ORGBAS to DAD value
  2121 DDE      PUMD R#,-R20          ! add value to table
  2122          LDB  R#,=377          ! and label 'token'
  2123          PUBD R#,-R20
  2124          JSB  =SATREF
  2125          POBD R20,+R10         ! get next char
  2126 DJMP1    JMP  ALSTIT           ! finish by listing line (if LST is on)
  2127 !
  2128 GOEOL    POBD R20,+R10         ! get next char
  2129 ATEOL?   CMB  R20,=16          ! at EOL?
  2130          JNZ  GOEOL            ! jif no, find end
  2131          GTO FIXMEM            ! go check/fix mem and attack next line
  2132 !
  2133 ASOPER   LDM  R46,=OPCOER      ! OPCO error
  2134          JSB  =PRTERR          ! print it
  2135          JMP  ATEOL?           ! skip rest of line
  2136 !
  2137 ITSOP    POMD R65,+R10         ! get 3-char opcode
  2138 ITSOP-   BIN
  2139          LDMD R20,=AIFFLG      ! conditionally assembling
  2140          JNZ  ASMIT            ! jif we're assembling (AIF is NOT false)
  2141          CMMD R65,=EIFNAM      ! else see if opcode is EIF
  2142          JNZ  ALSTIT           ! jif no, just list the line
  2143 !
  2144 ASMIT    LDM  R26,=ASMTBL      ! address of table for assembling opcodes
  2145          LDBD R22,=ISGLO       ! is this a global file?
  2146          JZR  NOTGLO           ! jif no
  2147          LDM  R20,=GLONAM      ! address of "GLO" for "table search"
  2148          LDM  R22,=113,0       ! opcode counter for GLO
  2149          JSB  =OPCLOP          ! handle get the assembly address for it
  2150          JMP  NOTGL-
  2151 !
  2152 NOTGLO   JSB  =FNDOP-          ! find and get assembly routine for it
  2153 NOTGL-   JEN  ASOPER           ! jif unsuccessful
  2154          LDMD R24,=ACODEN      ! get ptr where to put new code
  2155          CLM  R70
  2156          LRM  R23              ! R22=2*OPCODE, halve to get table index
  2157          LDBD R73,X22,MACHCO   ! load machine code byte for this opcode
  2158          JSB  X26,ZRO          ! call the assembly-time function
  2159 ALSTIT   BIN
  2160          LDBD R66,=LSTFLG      ! get LST flag
  2161          JZR  NOLST            ! jif LST is OFF
  2162          JSB  =DOPRNT          ! set printer is output
  2163          CLB  R26              ! flag 1st printed line for this src line
  2164          PUBD R20,+R6          ! save R20
  2165 MOROBJ   LDM  R30,=INPBUF      ! where to format the line
  2166          LDMD R22,=ACODEN      ! where new code for this line went
  2167          LDM  R36,R22
  2168          SBMD R36,=ACODBA      ! code offset for this line
  2169          JSB  =FRM6DG          ! format the line address
  2170          LDB  R34,=2           ! 2 bytes of obj code output
  2171 OBJLOP   CMM  R22,R24          ! any obj code bytes output on this line?
  2172          JZR  OBJDON           ! jif no
  2173          CLM  R36
  2174          POBD R36,+R22         ! get byte of obj code
  2175          LDB  R20,=3           ! 3 digits
  2176          JSB  =FRMDGS          ! format them
  2177          JMP  OBJSPC           ! go put another space after address
  2178 !
  2179 NOLST    STMD R24,=ACODEN      ! update end-of-code ptr
  2180 EOLJMP   GTO ATEOL?            ! and keep going with the next line
  2181 !
  2182 OBJDON   LDMD R44,=BLANKS      ! get 4 blanks
  2183          PUMD R44,+R30         ! push 4 of them (3 obj digits & space)
  2184 OBJSPC   DCB  R34              ! dec obj code byte counter
  2185          JNZ  OBJLOP           ! jif not done, do next obj byte
  2186          CLM  R64
  2187          LDBD R64,=PRNTLN      ! printer line length
  2188          TSB  R26              ! 1st printed line for this line of SRC?
  2189          JNZ  NOSRC            ! jif no, already shown the SRC
  2190          JSB  =PSHRGS          ! save registers
  2191          LDMD R24,=ASTLIN      ! ptr to start of curr line
  2192          JSB  =DCLST           ! decompile the source into LST buffer
  2193          LDM  R56,R#           ! copy R30 output ptr
  2194          JSB  =POPRGS          ! restore registers
  2195          LDM  R30,R56          ! put output ptr back in R30
  2196 NOSRC    LDM  R56,=INPBUF      ! start of buffer
  2197          STM  R56,R66          ! address for DMPBU-
  2198          ADM  R56,R64          ! line length for printer
  2199          CMM  R56,R30          ! printer width < formatted length?
  2200          JCY  PLENOK           ! jif no
  2201          STM  R56,R30          ! clip formatted text to printer width
  2202 PLENOK   JSB  =DMPBU-          ! dump the line to the printer device
  2203          ICM  R26              ! flag we're on non-src format line
  2204          STMD R22,=ACODEN      ! set new code end ptr
  2205          CMM  R22,R24          ! any more obj bytes to dump?
  2206          JNZ  MOROBJ           ! jif yes
  2207          POBD R20,-R6          ! restore R20
  2208          JMP  EOLJMP           ! go do the next line
  2209 ! ***********************************************
  2210 ! Search label table for a label
  2211 ! INPUT:
  2212 !   R42-47 = label
  2213 ! OUTPUT:
  2214 !   E=0 failed, E=1 if found in table
  2215 !   R20 ptr to end of label table
  2216 !
  2217 SLBLTB   LDMD R20,=ACODBA      ! get end of label table
  2218          CLE                   ! pre-set to NOT found in table
  2219 SLTLOP   CMMD R20,=ALBTBL      ! reached beginning of table?
  2220          JZR  ARTN81           ! jif yes, didn't find it
  2221          POMD R50,-R20         ! get next label and address/value
  2222          DCM  R20              ! skip one more byte of flags
  2223          CMM  R42,R52          ! labels match?
  2224          JNZ  SLTLOP           ! jif no, loop
  2225          ADM  R20,=3,0         ! move back up to label
  2226          ICE                   ! flag found
  2227 ARTN81   RTN
  2228 !
  2229 ! copies an ASP string from R46 to the ASM ROM output buffer
  2230 ! returns length of string buffer in R36-37
  2231 !
  2232 CPYSTR   LDMD R30,=ASMBAS      ! get ptr to ASM ROM output buffer
  2233          STM  R30,R26          ! save a copy of it
  2234          POBD R36,+R46         ! get the first byte of the buffer
  2235 CPY$LP   PUBD R#,+R30          ! push the byte to the output buffer
  2236          POBD R#,+R46          ! get the next byte of the input buffer
  2237          JPS  CPY$LP           ! jif not end, loop til buffer is copied
  2238          SBB  R#,=200          ! strip the MSbit off the last character
  2239          PUBD R#,+R30          ! and push it
  2240          LDM  R#,R30           ! get the end of the buffer
  2241          SBM  R#,R26           ! minus the beginning = the buffer len
  2242          RTN
  2243 !
  2244 AGTVAL   JSB  =GCHAR           ! get next NON-blank char from R10 buffer
  2245 AGTVA-   JSB  =PSHRGS          ! save registers
  2246          JSB  =INTEGR          ! try to get a number
  2247          JEZ  NMFAIL           ! jif none found
  2248          LDM  R65,R40          ! get the int
  2249          LDB  R64,=377         ! format it as a series 80 INTEGER
  2250          JSB  =INTORL          ! convert it to a REAL format
  2251          BIN
  2252          CMB  R20,=104         ! D suffix (decimal value)?
  2253          JZR  DECVAL           ! jif yes
  2254          CMB  R20,=103         ! C suffix (BCD value)?
  2255          JNZ  OCTVAL           ! jif no
  2256 !
  2257 BCDVAL   TSB  R60              ! non-0 EXPONENT?
  2258          DRP  R67
  2259          JNZ  CPYBCD           ! jif yes, two digits
  2260          BCD
  2261          LRB  R67              ! else shift single digit to LSnibble
  2262          JMP  CPYBCD
  2263 !
  2264 OCTVAL   DCM  R10              ! no suffix, put last char back
  2265          PUMD R60,+R12         ! push number to stack
  2266          JSB  =DEC.            ! convert from OCT to DEC
  2267          CLE                   ! pre-set E flag to FAILED
  2268          CMB  R17,=300         ! error in conversion?
  2269          JCY  NMFAIL           ! jif yes
  2270          JSB  =GTBIN#          ! get # off stk as binary in R46 (DRP=46)
  2271 CPYBCD   STM  R#,R76           ! copy the value
  2272 NMGOT    CLE
  2273          ICE                   ! flag successful
  2274 NMFAIL   JSB  =POPRGS          ! restore registers
  2275          BIN
  2276          DRP  R76
  2277          RTN
  2278 !
  2279 DECVAL   JSB  =CONINT          ! convert REAL in R60 to BIN in R76
  2280          JMP  NMGOT
  2281 !
  2282 ! *********************************
  2283 ! DEC()
  2284 ! *********************************
  2285 !
  2286 ! NOTE: In REAL math routines, the 8-byte REAL number gets
  2287 ! split into a 6-byte (12-digit) Mantissa, a 2-byte (3-digit)
  2288 ! signed exponent, and a mantissa sign.  If dealing with a
  2289 ! single number, it's usually in R40-47 (mantissa), R36-37
  2290 ! (exponent), and R32 (sign of mantissa).  If a second number
  2291 ! is being used, it's usually in R50-57 (mantissa), R34-35
  2292 ! (exponent), and R33 (sign of mantissa).
  2293 !
  2294 ! I inherited this OCT/DEC code, probably from Homer Russell,
  2295 ! the author of the math routines in the Series 80, and I have
  2296 ! a hard time entirely grokking the whole thing... as I do most of the
  2297 ! Series 80 math routines.  Homer was crazy awesome with math!
  2298 !
  2299          BYT  20,55            ! attribs: numeric func, 1 numeric arg
  2300 DEC.     JSB  =SPLITI          ! get #, split it, handle non-0 frac part
  2301          LDM  R36,R20          ! get the exponent count (21 oct)
  2302          CMM  R36,R34          ! 21 oct (17 dec) >= original exponent?
  2303          JCY  DECOK            ! jif yes
  2304 OORERR   JSB  =ERROR
  2305          BYT  13               ! ARG OUT OF RANGE
  2306          RTN
  2307 !
  2308 DECOK    LLM  R52              ! get MSdigit from argument -> E
  2309          CLM  R62              ! R62-67 = 0
  2310          ELB  R62              ! shift digit from E into R62
  2311          CMB  R62,=10          ! >=8?
  2312          JCY  INVPER           ! jif yes, inv parameter, must be oct#
  2313          ADM  R42,R62          ! add into result (R40 was 0 from SPLITI)
  2314          TSB  R34              ! done all digits?
  2315          JZR  ODFIN            ! jif yes, done
  2316          DCB  R34              ! else dec exponent (digit count)
  2317          ADM  R42,R42          ! x2
  2318          ADM  R42,R42          ! x4
  2319          ADM  R42,R42          ! x8 move cnt, ready for next 0-7 val
  2320          JMP  DECOK            ! loop
  2321 !
  2322 INVPER   JSB  =ERROR
  2323          BYT  131              ! INVALID PARAM
  2324          RTN
  2325 !
  2326 ! *********************************
  2327 ! REL()
  2328 ! *********************************
  2329          BYT  20,55            ! attribs: numeric func, 1 numeric arg
  2330 REL.     JSB  =OCTBIN          ! get OCT argument as binary
  2331          ADMD R46,=BINTAB      ! add base address of BPGM
  2332          STM  R46,R36          ! copy
  2333 I2BIN    JSB  =STKBIN          ! convert to INTEGER on R12 Stack
  2334 !
  2335 ! The above code FALLS THROUGH to the OCT code, executing OCT's
  2336 ! attributes as ARP instructions. Doesn't hurt anything, and saves
  2337 ! 2 bytes of code.
  2338 !
  2339 ! *********************************
  2340 ! OCT()
  2341 ! *********************************
  2342 !
  2343 ! NOTE: In REAL math routines, the 8-byte REAL number gets
  2344 ! split into a 6-byte (12-digit) Mantissa, a 2-byte (3-digit)
  2345 ! signed exponent, and a mantissa sign.  If dealing with a
  2346 ! single number, it's usually in R40-47 (mantissa), R36-37
  2347 ! (exponent), and R32 (sign of mantissa).  If a second number
  2348 ! is being used, it's usually in R50-57 (mantissa), R34-35
  2349 ! (exponent), and R33 (sign of mantissa).
  2350 !
  2351 ! I inherited this code from someone else (probably Homer Russell,
  2352 ! the author of the math routines in the Series 80), and I have
  2353 ! a hard time entirely grokking the whole thing...
  2354 !
  2355          BYT  20,55            ! attribs: numeric func, 1 numeric arg
  2356 OCT.     JSB  =SPLITI          ! get #, split it, handle non-0 frac part
  2357          LDM  R36,R34          ! copy original exponent
  2358          CMM  R36,=20,0        ! <16?
  2359          JNC  OCTOK            ! jif yes
  2360          JNZ  OORERR           ! jif not ==16
  2361          CMMD R52,=MAXDEC      ! > limit?
  2362          JZR  OCTOK            ! jif =limit
  2363          JCY  OORERR           ! jif too big
  2364 OCTOK    TCM  R36              ! negate exp for BRTS40 which incs til 0
  2365          LDB  R47,=3           ! R40-R47 = 0, so put 3 in MSdigit
  2366 !
  2367          JSB  =ROMJSB
  2368          DEF  BRTS40           ! shift 3 over until orig exponent is 0
  2369          BYT  0
  2370 !
  2371          ADM  R50,R40          ! add 3 to the orig int at that location
  2372          LDM  R36,=11,0        ! load an exponent of 9
  2373          LDM  R42,=0,222,105,223,211,205 ! BCD = 00, 92, 45, 93, 89, 85
  2374 ! mantissa of 8589934592 is exactly (MAXDEC + 1)/8
  2375          CLB  R33              ! clear R50 sign (positive)
  2376          JSB  =DIV20           ! R40 = R40/R50, SHRONF-
  2377          CLM  R50              ! preclear result
  2378          ARP  R40              ! loop's all ARP 40 so take out of loop
  2379 OCVTLP   CLE                   ! preclear E (shifted digit) to 0
  2380          TSB  R37              ! exponent negative?
  2381          JLN  OJD              ! jif yes, just shift in 0's
  2382          LLM  R40              ! get another digit
  2383 OJD      ELM  R52              ! shift the new digit into R52-57
  2384          LRM  R47              ! shift 47 over
  2385          ICM  R36              ! increment exponent
  2386          ADM  R40,R#           ! x2
  2387          ADM  R40,R#           ! x4
  2388          ADM  R40,R#           ! R40 = R40x8
  2389          DCB  R20              ! started at 21 (17 decimal)
  2390          JCY  OCVTLP           ! jif >=0 (loop 18 times)
  2391 !
  2392          STM  R50,R#           ! copy R50 into R40
  2393          LDM  R36,=21,0        ! exponent
  2394 ODFIN    JSB  =SHF10           ! normalize R40
  2395          JSB  =NFR             ! pack R40 & exponent & sign, push it
  2396          RTN
  2397 !
  2398 SPLITI   JSB  =INTFRA          ! get int R50 & frac R40 exponent R34
  2399          TSM  R40              ! any fractional part?
  2400          JZR  ISINT            ! jif no
  2401          POMD R36,-R6          ! else toss rtn address
  2402          JMP  INVPER           ! report invalid parameter
  2403 !
  2404 ISINT    TSM  R50              ! integer part =0?
  2405          JNZ  LFJUS-           ! jif no
  2406          GTO FTR73             ! push r40 (0) 0=0 whether dec or oct
  2407 !
  2408 LFJUST   LLM  R#               ! shift a digit left
  2409 LFJUS-   JLZ  LFJUST           ! shift left until MSnibble is not 0
  2410          LDM  R20,=21,0        ! 17 decimal (exponent?)
  2411          RTN
  2412 !
  2413 MAXDEC   BYT  120              ! 50 BCD max value for OCT()=68719476735
  2414          BYT  163              ! 73
  2415          BYT  166              ! 76
  2416          BYT  224              ! 94
  2417          BYT  161              ! 71
  2418          BYT  150              ! 68
  2419 !
  2420 ! ************************************************************
  2421          BYT  241
  2422 MEM.     JSB  =GTABAS          ! get ASM ROM RAMbase
  2423          POMD R40,-R12         ! get address off stack
  2424          PUMD R40,+R12         ! put it back
  2425          JSB  =SVMADR          ! save it in ASM ROM's RAM
  2426          JSB  =OCTBIN          ! convert the octal address to binary
  2427          STMD R46,X#,MEMPTR    ! save in ASM ROM's RAM
  2428          RTN
  2429 !
  2430 ! ************************************************************
  2431          BYT  241
  2432 MEMD.    JSB  =MEM.            ! do mem stuff
  2433          LDMD R36,R46          ! get the indirect address
  2434 BKPMEM   STMD R36,X14,MEMPTR   ! save in ASM ROM's RAM
  2435          JSB  =I2BIN           ! convert to OCTAL value on stack
  2436          POMD R40,-R12         ! get if from the stack
  2437 SVMADR   STMD R#,X14,MEMADR    ! save in ASM ROM's RAM
  2438          RTN
  2439 !
  2440 ! **********************************************************
  2441 ! ':' token for MEM statements
  2442 ! **********************************************************
  2443          BYT  1,51             ! attribs=numeric binary op, precedence 1
  2444 ACOLN.   JSB  =GTBIN+          ! get the ROM#
  2445          STBD R46,X#,MEMROM    ! save it in ASM RAM
  2446          RTN
  2447 !
  2448 ! **********************************************************
  2449 ! ',' token for MEM statements
  2450 ! **********************************************************
  2451          BYT  1,51             ! attribs=numeric binary op, precedence 1
  2452 ACOMA.   JSB  =OCTBIN          ! get LEN oct#, convert to dec binary#
  2453          DRP  R46              ! where it's at
  2454 SMLEN    STMD R#,X14,MEMLEN    ! save it to ASM RAM
  2455          RTN
  2456 !
  2457 ! ******************************************************
  2458 ! '=' token for MEM statements
  2459 ! ******************************************************
  2460          BYT  1,51             ! attribs=numeric binary op, precedence 1
  2461 AEQUL.   JSB  =GTABAS          ! get ASM RAM ptr
  2462          STMD R6,X#,MEMR6      ! save R6 in ASM RAM
  2463 AEQULP   JSB  =OCTBIN          ! get octal value as decimal binary#
  2464          PUBD R46,+R6          ! save on the return stack
  2465          CMMD R12,=TOS         ! op stack empty? (multiple '=' values?)
  2466          JNZ  AEQULP           ! jif no, loop
  2467          LDMD R20,X14,MEMPTR   ! get address we're storing to
  2468 !
  2469 ! NOTE: during execution, the numbers to store into memory
  2470 ! get pushed onto the operating stack, so when we pop them
  2471 ! off, convert them and push them on the R6 stack, the
  2472 ! 1st number the user specified is the LAST one OFF the
  2473 ! operating stack (R12) and the FIRST one OFF the R6 stack.
  2474 !
  2475 AEQUL2   POBD R46,-R6          ! get a value off rtn stack
  2476          PUBD R46,+R20         ! push it out to memory
  2477          LDMD R46,X14,MEMR6    ! get starting point of R6 stack
  2478          CMM  R46,R6           ! have we emptied all the args?
  2479          JNZ  AEQUL2           ! jif no, pop and store some more
  2480          RTN                   ! done
  2481 !
  2482 DMPREG   LDMD R54,=HDRREG      ! load "REG "
  2483          STMD R54,R14          ! store to output buffer
  2484          LDM  R26,R14          ! copy output buffer
  2485          LDM  R36,=3,0         ! len of output (3 chars REG)
  2486          JSB  =DUMPIT          ! dump to the DISP or PRINT
  2487          LDM  R30,R#           ! get ouput buffer at start of ASM RAM
  2488          LDM  R26,=SAVR0       ! memory to dump is 256 bytes of CPU regs
  2489          LDM  R34,=100,0       ! len = 256
  2490 !
  2491 ! Fall through into the "memory dump" routine to dump the CPU registers
  2492 !
  2493 ! The following line loads r50-r57 with this CODE:
  2494 ! DRP is R20 coming in, R24 points to RSELEC
  2495 !  024 246        :       STBD r#,r24    ! so select the other ROM
  2496 !  026 340        :       POBD r#,+r26   ! get byte into R20, +ptr
  2497 !  121 024 246    :       STBD r21,r24   ! R21=050 ASM ROM#, reselect it
  2498 !  236            :       RTN            ! return to ASM ROM
  2499 ! When stored into RAM, it can be called to read a byte from another ROM
  2500 !
  2501 DMPSOM   LDM  R50,=24,246,26,340,121,24,246,236 ! load above func
  2502          STMD R50,X#,ROMPEK    ! store above function into ASM RAM
  2503 DMLOOP   SBM  R34,=10,0        ! -8 from remaining bytes to MEM dump
  2504          JNC  LESS8            ! jif less than 8
  2505          JSB  =DMEM8           ! dump a line of 8 bytes
  2506          JMP  DMLOOP           ! go back for more
  2507 !
  2508 LESS8    ADM  R#,=10,0         ! restore the count
  2509          JZR  SPCDMP           ! jif none, all done
  2510          STB  R34,R41          ! copy the # of bytes to dump
  2511          JSB  =DMEMX           ! dump them
  2512 SPCDMP   LDB  R34,=40          ! load an ASCII ' ' char
  2513          PUBD R34,+R30         ! push it to output buffer
  2514          JMP  DMPJM2           ! dump the buffer
  2515 !
  2516          BYT  44
  2517 DMPMEM   JSB  =DODISP          ! set DISP as print output
  2518 DMPME-   JSB  =GTABAS          ! get ASM RAM ptr
  2519          STM  R#,R30           ! setup ptr to ASM RAM output buffer
  2520          LDMD R26,X14,MEMPTR   ! get address of memory to dump
  2521          LDMD R34,X14,MEMLEN   ! get MEM dump length from ASM RAM
  2522          JZR  SPCDMP           ! jif 0, dump blank line
  2523          JSB  =DMPSOM          ! dump them
  2524          LDMD R34,X14,MEMLEN   ! get # to dump
  2525          LDMD R26,X14,MEMPTR   ! get where to dump from
  2526 DASLOP   SBM  R34,=20,0        ! 16 bytes left?
  2527          JNC  DASCEN           ! jif no
  2528          JSB  =DMPASC          ! dump another 16
  2529          JMP  DASLOP
  2530 !
  2531 DMEM8    LDB  R41,=10          ! # bytes to dump
  2532 DMEMX    JSB  =PEEK1           ! read a byte from memory into R20
  2533          CLM  R36              ! clear R37
  2534          LDB  R36,R20          ! copy byte into R36
  2535          LDB  R20,=3           ! # digits to format out
  2536          JSB  =FRMDGS          ! output digits with a SPACE on the end
  2537          DCB  R41              ! dec byte counter
  2538          JNZ  DMEMX            ! jif not done
  2539 DMPJM2   JMP  DMPJMP           ! dump the line
  2540 !
  2541 DASCEN   ADM  R34,=20,0        ! restore remaining count
  2542          JZR  FRMMEM           ! jif none, done, dump buffer
  2543          STB  R34,R51          ! else copy the byte counter
  2544          JSB  =DASCLP          ! format them, fall thru to dump buffer
  2545 !
  2546 FRMMEM   LDMD R60,X14,MEMADR   ! get addr of memory dump
  2547          PUMD R60,+R12         ! push # on R12 stack
  2548          LDM  R44,=115,105,115,40 ! load ASCII "MEM "
  2549          PUMD R44,+R30         ! push "MEM " to output buff
  2550          JSB  =ONER            ! get number as REAL off R12 stack
  2551          JSB  =ROMJSB
  2552          DEF  CVNUM            ! format it out to R30 buffer
  2553          BYT  0
  2554 DMPJMP   JMP  DMPBUF           ! display/print it
  2555 !
  2556 FRM6DG   LDB  R20,=6           ! number of digits to output
  2557 FRMDGS   CLM  R50              ! clear working regs
  2558          LLM  R36              ! get bit 15 (MSbit) all by itself
  2559          ELB  R57              ! get that MSbit into LSbit of 57
  2560          ADB  R57,=60          ! add ASCII '0' (convert to '0' or '1')
  2561          JSB  =FRMDIG          ! Format a second digit
  2562          JSB  =FRM4DG          ! Format 4 more digits
  2563          LDB  R0,=60           ! pointing register-indirect at R60
  2564          SBB  R0,R20           ! minus # digits being output
  2565 ! R0 pointing at R5x registers to push to the format buffer
  2566          PUMD R*,+R30          ! push formatted chars into the buffer
  2567          LDB  R*,=40           ! load a space
  2568          PUBD R*,+R30          ! push it out to buffer after the digits
  2569          RTN
  2570 !
  2571 FRM4DG   JSB  =FRM2DG          ! format 2 digits, fall thru & do 2 more
  2572 FRM2DG   JSB  =FRMDIG          ! format 1 digit, fall thru & do 1 more
  2573 !
  2574 ! Get next three bits from R36-37 into an ASCII digit in R50-R57
  2575 !
  2576 FRMDIG   LRM  R37              ! shift rt 1 so when we get next 4 bits
  2577          BCD                   !  MSbit is 0 & next 3 bits in lower bits
  2578          LRM  R57              ! shift already formatted output chars
  2579          LRM  R57              !   down one register
  2580          LLM  R36              ! get the next 4 bits (really 3 bits)
  2581          ELM  R57              ! put them in the bottom of R57
  2582          BIN
  2583          ADB  R57,=60          ! add a '0' char to convert to '0' to '7'
  2584          RTN
  2585 !
  2586 CPYDMP   JSB  =CPYSTR          ! copy the string to the output buffer
  2587 DMPBUF   LDMD R66,=ASMBAS      ! address of buffer to disp/print
  2588 DMPBU-   JSB  =PSHRGS          ! save R20-R47
  2589          PUMD R56,+R6          ! and R56-7
  2590          PUMD R70,+R6          ! and R70-77
  2591          PUMD R66,+R6          ! and R66-67
  2592          LDM  R36,R30          ! copy output buffer ptr
  2593          SBM  R36,R66          ! get curr length of buffer
  2594          LDM  R26,R66          ! ptr to beginning of buffer (ASMBAS)
  2595          JSB  =DUMPIT          ! DISPLAY or PRINT the buffer
  2596          CMB  R17,=300         ! any errors?
  2597          JNC  NOUTER           ! jif no
  2598          GTO RSTR6             ! GOTO 63254 (RSTR6-1), bail out, ROMRTN
  2599 !
  2600 NOUTER   POMD R66,-R6          ! restore R66-67
  2601          POMD R70,-R6          ! and R70-77
  2602          POMD R56,-R6          ! and R56-57
  2603          JSB  =POPRGS          ! restore R20-R47
  2604          LDM  R30,R66          ! reset output buffer ptr
  2605          RTN
  2606 !
  2607 PEEK1    LDB  R21,=50          ! ASM ROM#
  2608          LDM  R24,=RSELEC      ! ptr to RSELEC
  2609          LDBD R20,X14,MEMROM   ! ROM# to read from
  2610 ! call PEEK code stored in ROMPEK @ 71105 in the ASM ROM
  2611 ! to get a byte from MEMROM (or RAM or SYSTEM ROM) into R20
  2612          JSB  X14,ROMPEK       ! get byte from ROM
  2613          RTN
  2614 !
  2615 DMPASC   LDB  R51,=20          ! dump 16 bytes as CHARS
  2616 DASCLP   JSB  =PEEK1           ! get a byte
  2617          LLB  R20              ! throw away the upper MSbit
  2618          LRB  R20              ! shift-left/shift-right cheaper than ANM
  2619          CMB  R20,=40          ! CTL character?  (less than a SPACE)
  2620          JCY  NOTCTL           ! jif no
  2621          LDB  R20,=40          ! replace with a SPACE
  2622 NOTCTL   PUBD R#,+R30          ! push the char to the output buffer
  2623          DCB  R51              ! decrement the byte counter
  2624          JNZ  DASCLP           ! jif not done
  2625          JMP  DMPBUF
  2626 !
  2627 ! Save CPU registers R20-R47 on R6 stack
  2628 !
  2629 PSHRGS   POMD R2,-R6           ! pop return address
  2630          PUMD R40,+R6          ! save R40-47
  2631          LDM  R40,R20          ! get R20-27
  2632          PUMD R40,+R6          ! save them
  2633          LDM  R40,R30          ! get R30-37
  2634          PUMD R40,+R6          ! save them
  2635          PUMD R2,+R6           ! push return address back on
  2636          RTN
  2637 !
  2638 ! Restore CPU registers R20-R47 from R6 stack
  2639 !
  2640 POPRGS   POMD R2,-R6           ! pop return address
  2641          POMD R40,-R6          ! recover R30-37
  2642          STM  R40,R30          ! copy them
  2643          POMD R40,-R6          ! recover R20-27
  2644          STM  R40,R20          ! copy them
  2645          POMD R40,-R6          ! recover R40-47
  2646          PUMD R2,+R6           ! push return address back
  2647          RTN
  2648 !
  2649 ! GTBIN# has to go through shenanigans to convert a BCD integer to a
  2650 ! binary# because ONEB returns a SIGNED value (BCD INTEGERS are signed
  2651 ! values). We want an UNsigned binary value, so we have to check the
  2652 ! size first, save a flag, modify addresses >= 32768 to be <32768, do
  2653 ! the conversion, then OR the MSbit back in (if necessary).
  2654 !
  2655 GTBIN#   PUMD R70,+R6          ! save R70-77
  2656          JSB  =ONEI            ! get an INT off R12 stack into R45-R47
  2657          POMD R70,-R6          ! restore R70-77
  2658          LDM  R32,=FWUSER      ! get FWUSER
  2659          BCD                   ! we're doing BCD math
  2660          CMM  R45,=66,125,6    ! BCD 36,55,6 = INT 65536
  2661          JCY  OORER2           ! jif greater, error, address too big
  2662          SBM  R45,=150,47,3    ! BCD 68,27,3 = INT 32768
  2663          JCY  GOTADR           ! jif address in RAM
  2664          ADM  R45,=150,47,3    ! ADD 32768 back in (restore ROM address)
  2665          CLM  R32              ! set MSbit to 0 for ROM address
  2666 !
  2667 GOTADR   PUMD R40,+R12         ! push address back on stack
  2668          JSB  =ONEB            ! get it off as a binary number in R46-47
  2669          ORM  R46,R32          ! OR-in MSbit of address
  2670          ARP  R14              ! leave ARP at r14 (ASMBAS)
  2671          RTN
  2672 !
  2673 OORER2   JSB  =ERROR+
  2674          BYT  13               ! ARG OUT OF RANGE
  2675 !
  2676 ! This is the table of routines to assemble particular opcodes
  2677 ! (same sequence as opcodes in OPTABL)
  2678 !
  2679 ASMTBL   DEF  AARP.            ! 0
  2680          DEF  ADRP.
  2681          DEF  OPC1R
  2682          DEF  OPC1R
  2683          DEF  OPC1R
  2684          DEF  OPC1R
  2685          DEF  OPC1R
  2686          DEF  OPC1R
  2687          DEF  OPC1R            ! 10
  2688          DEF  OPC1R
  2689          DEF  OPC1R
  2690          DEF  OPC1R
  2691          DEF  PSHC.
  2692          DEF  OPC1R
  2693          DEF  OPC1R
  2694          DEF  PSHC.
  2695          DEF  OPC1R            ! 20
  2696          DEF  OPC1R
  2697          DEF  OPC1R
  2698          DEF  OPC1R
  2699          DEF  OPC1R
  2700          DEF  OPC1R
  2701          DEF  OPC1R
  2702          DEF  OPC1R
  2703          DEF  PSHC.            ! 30
  2704          DEF  BRCI.
  2705          DEF  MRCI.
  2706          DEF  BRCI.
  2707          DEF  MRCI.
  2708          DEF  PSHC.
  2709          DEF  PSHC.
  2710          DEF  PSHC.
  2711          DEF  PSHC.            ! 40
  2712          DEF  APAD.
  2713          DEF  ALDSTB
  2714          DEF  ALDSTM
  2715          DEF  ALDSTB
  2716          DEF  ALDSTM
  2717          DEF  AMATHB
  2718          DEF  AMATHM
  2719          DEF  AMATHB           ! 50
  2720          DEF  AMATHM
  2721          DEF  AMATHB
  2722          DEF  AMATHM
  2723          DEF  AMATHM
  2724          DEF  APUPO.
  2725          DEF  APUPO.
  2726          DEF  APUPO.
  2727          DEF  APUPO.           ! 60
  2728          DEF  ARJMP.
  2729          DEF  ARJMP.
  2730          DEF  ARJMP.
  2731          DEF  ARJMP.
  2732          DEF  ARJMP.
  2733          DEF  ARJMP.
  2734          DEF  ARJMP.
  2735          DEF  ARJMP.           ! 70
  2736          DEF  ARJMP.
  2737          DEF  ARJMP.
  2738          DEF  ARJMP.
  2739          DEF  ARJMP.
  2740          DEF  ARJMP.
  2741          DEF  ARJMP.
  2742          DEF  ARJMP.
  2743          DEF  AJSB.            ! 100
  2744          DEF  ARJMP.
  2745          DEF  ABSZ.
  2746          DEF  AABS.
  2747          DEF  AASP.
  2748          DEF  ABYT.
  2749          DEF  AGTO.
  2750          DEF  AASC.
  2751          DEF  ADR16            ! 110
  2752          DEF  ANAM.
  2753          DEF  AVAL.
  2754          DEF  AGLO.            ! 113 GLO
  2755          DEF  AFIN.
  2756          DEF  ALST.            ! LST
  2757          DEF  AUNL.
  2758          DEF  ALNK.            ! LNK
  2759          DEF  AORG.            ! 120 ORG
  2760          DEF  ASET.            ! SET
  2761          DEF  ACLR.            ! CLR
  2762          DEF  AAIF.            ! AIF
  2763 !
  2764 ! This is the table of actual OPCODES
  2765 ! (same sequence as opcodes in OPTABL)
  2766 !
  2767 MACHCO   BYT  6,165,200,201,202,203,204,205 ! ARPDRPELBELMERBERMLLBLLM
  2768          BYT  206,207,210,211,234,212,213,233 ! LRBLRMICBICMICEDCBDCMDCE
  2769          BYT  214,215,216,217,220,221,222,223 ! TCBTCMNCBNCMTSBTSMCLBCLM
  2770          BYT  235,224,225,226,227,230,231,232 ! CLEORBORMXRBXRMBINBCDSAD
  2771          BYT  236,237,240,241,242,243,300,301 ! RTNPADLDBLDMSTBSTMCMBCMM
  2772          BYT  302,303,304,305,307,340,341,344 ! ADBADMSBBSBMANMPOBPOMPUB
  2773          BYT  345,373,363,370,371,374,375,360 ! PUMJCYJEVJENJEZJLZJLNJMP
  2774          BYT  361,364,366,372,362,365,376,377 ! JNOJNGJNZJNCJODJPSJRZJRN
  2775          BYT  306,367          ! JSBJZR
  2776 !
  2777 MILNAM   ASP  "ILL NAM"
  2778 !
  2779 ANAM.    DRP  R45              ! these 3 lines do "LDM R45,=200,MILNAM"
  2780          BYT  251,200
  2781          DEF  MILNAM
  2782 !
  2783          LDBD R21,=ISAROM      ! ABS ROM?
  2784          JNZ  APRTER           ! jif yes, NAM is illegal
  2785          LDBD R21,=ILNMAB      ! set MSbit of ILNMAB
  2786          ORB  R21,R45          ! or in 0200
  2787          STBD R21,=ILNMAB      ! save MSbit of ILNMAB = NAMs are illegal
  2788          STBD R21,=ISAROM      ! not ABS ROM
  2789          POMD R42,+R10         ! get NAM string
  2790          PUMD R42,+R24         ! push it out
  2791          LDB  R42,=2           ! BPGM type
  2792          PUBD R42,+R24         ! push it out
  2793          CLM  R42              ! a BUNCH of zeroes
  2794          PUMD R42,+R24         ! push 19 more zeroes
  2795          PUMD R42,+R24
  2796          PUMD R42,+R24
  2797          PUBD R42,+R24
  2798          RTN
  2799 !
  2800 MAIFUN   ASP  "AIF UND"
  2801 !
  2802 APRTER   JSB  =PRTERR
  2803          RTN
  2804 !
  2805 AAIF.    CLM  R26              ! preclear in case label not defined
  2806          JSB  =GETLBL          ! get label, add to table if not defined
  2807          LDM  R46,=MAIFUN      ! address of error message
  2808          JEZ  APRTER           ! jif flag wasn't previously defined
  2809 SETGAT   STMD R56,=AIFFLG      ! store flg val to conditional gate
  2810          JMP  POPCHR           ! finish
  2811 !
  2812 AABS.    LDM  R46,=MILABS      ! preload ILL ABS error message address
  2813          LDBD R22,=ILNMAB      ! ABS illegal?
  2814          JNZ  APRTER           ! jif yes, print the error
  2815          LDB  R22,=201         ! ABS illegal flag
  2816          STBD R22,=ILNMAB      ! set flags
  2817          CMB  R20,=122         ! 'R' ? (ABS ROM)
  2818          JNZ  GETBAS           ! jif no, must be ABS 16 or ABS 32
  2819          STBD R20,=ISAROM      ! set ABS ROM flag
  2820          POMD R20,+R10         ! get "OM"
  2821          POBD R20,+R10         ! get SPACE
  2822          POBD R20,+R10         ! get next char
  2823 DRP20    DRP  R20
  2824 GETBAS   JSB  =AGTVA-          ! get base address
  2825          STMD R#,=ABSBAS       ! save it
  2826          RTN
  2827 !
  2828 MILABS   ASP  "ILL ABS"
  2829 !
  2830 ! ***********************************************
  2831 ! The following little snipped, so far, seems to
  2832 ! be "dead code" that is never called or referenced
  2833 ! from anywhere. "You can always find 100 bytes!"
  2834 ! ***********************************************
  2835          CLM  R56
  2836          ICM  R56
  2837          DCM  R10
  2838          JMP  SETGAT
  2839 !
  2840 ! ***********************************************
  2841 !
  2842 ACLR.    CLM  R26              ! value for flag
  2843          JMP  ASTCLR           ! common finish
  2844 !
  2845 ASET.    CLM  R26
  2846          ICM  R26              ! value for flag
  2847 ASTCLR   JSB  =GETLBL          ! get label, set to 1 if not defined
  2848          JEZ  POPCHR           ! jif new label (so GETLBL set it to 1)
  2849          ICM  R20
  2850          PUMD R26,+R#          ! store the 1 into the value
  2851 POPCHR   POBD R20,+R10         ! get next char
  2852          RTN                   ! done
  2853 !
  2854 ! Get a label from the source and find (or add it) in the label table
  2855 ! Return R56=address, R55=flags
  2856 !
  2857 GETLBL   POMD R42,+R10         ! get 6-byte label from src
  2858 GETLB-   JSB  =SLBLTB          ! search the label table for it
  2859          JEN  LBFND            ! jif found it in the table
  2860          PUMD R42,-R20         ! push label onto the end of the table
  2861          PUMD R26,-R20         ! push the (possibly 0) address
  2862          PUBD R27,-R20         ! push the (likely 0) flag
  2863          STMD R20,=ALBTBL      ! save label table ptr
  2864          ADM  R20,=3,0         ! +3 to get back above the address/flags
  2865 LBFND    POMD R56,-R20         ! get the address
  2866          POBD R55,-R20         ! get the flags
  2867          RTN
  2868 !
  2869 ! Handle a label reference, pushing label value OR adding to placeholder
  2870 ! to label table and pushing a reference on the forward-reference stack.
  2871 !
  2872 ADR16    POMD R42,+R10         ! get 6-byte label from src
  2873 ADR16-   CLM  R26              ! 0 addr if not already in table (fwd-ref
  2874          JSB  =GETLB-          ! find or add the label
  2875          JZR  FWDREF           ! jif added it, forward reference
  2876          TSM  R56              ! address 0?
  2877          JNZ  PSHADR           ! jif no, it's defined, just push addr
  2878 FWDREF   ICM  R20              ! skip back to the label
  2879          ICM  R20
  2880          ICM  R20
  2881          LDMD R56,=ACODBA      ! get highest address of label table
  2882          SBM  R56,R20          ! offset of label in the label table
  2883          PUMD R56,+R12         ! add it to the forward-reference table
  2884          LDM  R56,R24          ! copy the code output ptr
  2885          SBMD R56,=ACODBA      ! get offset into code for the reference
  2886          PUMD R56,+R12         ! add it to the forward-reference table
  2887          LDM  R56,=326,326     ! put 326,326 in for temp address markers
  2888 PSHADR   PUMD R#,+R24          ! push the address
  2889          JMP  POPCHR
  2890 !
  2891 ABYT.    DCM  R10              ! put last char back
  2892 ABYT-    JSB  =GET#            ! get a value
  2893          PUBD R#,+R24          ! push it out
  2894          CMB  R20,=54          ! comma?
  2895          JZR  ABYT-            ! jif yes, keep going
  2896          RTN
  2897 !
  2898 APAD.    JSB  =INVARP          ! invalidate CURARP & CURDRP
  2899          DRP  R73              !  (since PAD will change them)
  2900 PSHC.    PUBD R#,+R24          ! push the opcode out
  2901          RTN
  2902 !
  2903 DRAR.    JSB  =A1DRP           ! handle DRP reference
  2904 AARP.    JSB  =A1ARP           ! handle ARP reference or immediate value
  2905          RTN
  2906 !
  2907 ADRP.    JSB  =A1DRP           ! handle DRP reference
  2908          RTN
  2909 !
  2910 OPC1R    JSB  =A1DRP           ! get possible DRP register
  2911          JMP  PSHC.            ! push opcode
  2912 !
  2913 ! for the following couple of routines:
  2914 !  R70=what arguments are found
  2915 ! 0 = R,R
  2916 ! 1 = R,=label or number
  2917 ! 2 = R,R,=label
  2918 !  R71=what instruction opcode addressing was specified
  2919 ! 0 = immediate (LDB)
  2920 ! 1 = Direct (LDBD)
  2921 ! 2 = Indirect (LDBI)
  2922 !  R72=Byte (LDBx) or Multi-byte (LDMx)
  2923 !  R73=base machine code to be pushed out after possible modification
  2924 !  R75=0 (R,R) or 1 (R,R,label  OR  R,label)
  2925 !
  2926 ALDSTM   ICB  R72              ! flag that it's a Multi-byte operation
  2927 ALDSTB   CMB  R20,=122         ! 'R'? (immed, not Direct or Indirect)
  2928          JZR  AGOTR            ! jif yes
  2929          ICB  R71              ! move to DIRECT addressing mode
  2930          CMB  R20,=104         ! 'D' ?
  2931          JZR  ALDSTN           ! jif yes
  2932          ICB  R71              ! move to INDIRECT addressing mode
  2933 ALDSTN   POBD R20,+R10         ! get next char
  2934 AGOTR    JSB  =DRAR.           ! get DRP and possible ARP registers
  2935          CLM  R26
  2936          LDB  R26,R70          ! 0 for R,R  1 for R,=  2 for R,R,=
  2937          BIN
  2938          LLB  R26              ! double (to 0, 2, 4) for indexing
  2939          ADB  R26,R70          ! triple (to 0, 3, 6)
  2940          ADB  R26,R71          ! +address mode (0=LDB, 1=LDBD, 2=LDBI)
  2941          LDBD R26,X26,LDSTCO   ! get opcode modification
  2942          ADB  R26,R73          ! add the base opcode into it
  2943 AFINAL   PUBD R26,+R24         ! push the completed opcode out
  2944          TSB  R75              ! R,R addressing? (another literal arg?)
  2945          JZR  ARTN79           ! jif yes, no more addressing
  2946          JSB  =PSHIMM          ! else push the label/numeric argument
  2947 ARTN79   RTN
  2948 !
  2949 ! Opcode modifications for various addressing modes of LD, ST
  2950 !
  2951 LDSTCO   BYT  0,4,14,10,20,30,0,24,34
  2952 !
  2953 AMATHM   ICB  R72              ! flag Multi-byte operation
  2954 AMATHB   CMB  R20,=122         ! 'R' ? (immed addressing, not Direct)
  2955          JZR  AGOTR2           ! jif yes
  2956          ICB  R71              ! move to Direct
  2957          POBD R20,+R10         ! get next char
  2958 AGOTR2   JSB  =DRAR.           ! get DRP and possible ARP registers
  2959          LDB  R26,R71          ! copy addressing mode (0=R,R  1=Direct)
  2960          BCD                   ! 4 opcodes handled (CM, AD, SB, ANM)
  2961          LLB  R26              !   left-shift 4 bits (0 or 16 dec)
  2962          BIN
  2963          ADB  R26,R73          ! plus the base opcode
  2964          CMB  R70,R71          ! instruction and argument modes match?
  2965          JZR  AFINAL           ! jif yes, do common finish
  2966          ADB  R26,=10          ! else tweak
  2967          JMP  AFINAL           ! and finish
  2968 !
  2969 MRCI.    ICB  R72              ! multibyte
  2970 BRCI.    JSB  =DRAR.           ! handle DRP and possible ARP
  2971 PSHCJM   JMP  PSHC.            ! go push the opcode
  2972 !
  2973 ! PUBD, PUMD, PUBI, PUMI, POBD, POMD, POBI, POMI  +/-
  2974 !
  2975 APUPO.   CMB  R20,=104         ! 'D' ?
  2976          JZR  APUPOD           ! jif yes, Direct mode
  2977          ADB  R73,=10          ! else modify opcode to Indirect mode
  2978 APUPOD   POBD R20,+R10         ! get next char
  2979          JSB  =A1DRP           ! handle the DRP register
  2980          CMB  R20,=53          ! '+' ?
  2981          JZR  APUPO+           ! jif yes
  2982          ADB  R73,=2           ! else modify opcode to pu/po -R
  2983 APUPO+   POBD R20,+R10         ! get next char
  2984          JSB  =A1ARP           ! handle ARP register
  2985          JMP  PSHCJM           ! push the opcode
  2986 !
  2987 JMPERR   ASP  "JMP FROM"
  2988 !
  2989 ! Assemble relative jmp instructions
  2990 !
  2991 ARJMP.   PUBD R#,+R24          ! push the opcode
  2992          JSB  =ADR16           ! process label, push 16 bits of addr
  2993          POMD R56,-R24         ! get those 16 bits of address back
  2994          JEZ  PSH336           ! jif label was freshly added
  2995          LDM  R56,R50          ! get the address
  2996          JNZ  REALAD           ! jif REAL address (not 0)
  2997 PSH336   LDB  R#,=336          ! change marker from 326 to 336
  2998 PSHCJ2   JMP  PSHCJM           !     for undefined 1-byte rel-jmp
  2999 !
  3000 REALAD   ADMD R56,=ACODBA      ! code offset + code base = curr abs addr
  3001          SBM  R56,R24          ! - curr end-of-code addr
  3002          DCM  R56              ! -1 for proper adjustment
  3003          CMB  R56,=200         ! too large of a jump?
  3004          JCY  RJOK?            ! jif no
  3005 JERRIT   LDM  R46,=JMPERR      ! JMP FROM error
  3006          JSB  =PRTERR          ! print it
  3007 PSHOFF   DRP  R56
  3008          JMP  PSHCJM
  3009 !
  3010 RJOK?    CMB  R57,=377         ! =377 if not too large a jmp
  3011          JNZ  JERRIT           ! jif no, it's too large
  3012          POMD R44,-R12         ! pop fwd-ref?  This seems WRONG!
  3013          JMP  PSHOFF
  3014 !
  3015 AJSB.    LDB  R71,=1           ! for ASM, JSB is always Direct mode
  3016          LDB  R21,=316         ! load simple JSB= opcode
  3017          CMB  R20,=130         ! 'X' ?
  3018          JNZ  AJSB=            ! jif no
  3019          JSB  =A1ARP           ! else handle ARP index register
  3020          LDB  R21,=306         ! change opcode to JSB X,=
  3021 AJSB=    PUBD R21,+R24         ! push out the opcode
  3022          JSB  =PSHIMM          ! get and push the address
  3023 !
  3024 INVARP   CLM  R0
  3025          DCM  R0               ! r0=377,377
  3026          STMD R0,=CURARP       ! invalidate both CURARP and CURDRP
  3027          RTN
  3028 !
  3029 ABSZ.    JSB  =AGTVA-          ! get number
  3030          JSB  =CMEMBT          ! calc available space at end of code
  3031          CMM  R#,R76           ! as much as we need for BSZ?
  3032          JCY  GOBSZ            ! jif yes
  3033          JSB  =DATUP           ! else move code and label table up
  3034          LDMD R24,=ACODEN      ! get new end-of-code ptr
  3035          JSB  =CMEMBT          ! recalc available space at end of code
  3036          CMM  R#,R76           ! as much as we need now?
  3037          JCY  GOBSZ            ! jif yes
  3038          POMD R22,-R6          ! throw away return address
  3039          GTO MNOTOK            ! go report the memory overflow error
  3040 !
  3041 GOBSZ    CLM  R40              ! overkill, we only need 1 zero
  3042          TSM  R76              ! was it BSZ 0?
  3043          JZR  ARTN62           ! jif yes, nothing to do, all done
  3044 BSZLOP   PUBD R40,+R24         ! else push a 0
  3045          DCM  R76              ! dec count
  3046          JNZ  BSZLOP           ! loop til done
  3047 ARTN62   RTN
  3048 !
  3049 AASP.    JSB  =AASC.           ! handle just like ASC
  3050          LDB  R21,=200         ! get a MSBit set
  3051          POBD R20,-R24         ! get the last char pushed
  3052          ORB  R20,R21          ! set the MSbit
  3053 PSHCJ3   JMP  PSHCJ2           ! push it back
  3054 !
  3055 AGTO.    LDM  R22,=104,251     ! load R22-3 with "LDM R4,="
  3056          PUMD R22,+R24         ! push them out
  3057          JSB  =ADR16           ! get a two-byte address
  3058          POMD R56,-R24         ! pop it back off
  3059          CMM  R56,=326,326     ! undefined address?
  3060          JZR  UNDGTO           ! jif yes
  3061          DCM  R56              ! -1, R4 gets inc'd after the load
  3062          PUMD R56,+R24         ! push it back out
  3063          RTN
  3064 !
  3065 UNDGTO   CLM  R#
  3066          DCM  R#               ! create a 377,377
  3067          PUMD R#,+R#           ! push them instead of 326,326
  3068          RTN                   !   (ie, GTO ref that needs a -1 address)
  3069 !
  3070 AVAL.    JSB  =ADR16           ! get the value
  3071          POMD R56,-R24         ! pop the 2-byte value back
  3072          JEZ  AVAL1B           ! jif label was not defined in the table
  3073          LDM  R76,R50          ! copy the label addr/value
  3074          JNZ  AVAL1B           ! jif not 0
  3075          DRP  R56              ! use the value in R56
  3076 AVAL1B   JMP  PSHCJ3           ! push the single byte value back out
  3077 !
  3078 MUNDLB   ASP  "UND LAB"
  3079 !
  3080 AASC.    JSB  =AGTVA-          ! get number
  3081          JEN  PSTR             ! jif got it
  3082 QUOTLP   POBD R20,+R10         ! get next char
  3083          CMB  R20,=42          ! " ?
  3084          JZR  ARTN77           ! jif yes, end of quoted string
  3085          PUBD R20,+R24         ! else push the unquoted char out
  3086          JMP  QUOTLP
  3087 !
  3088 PSTR     TSM  R#               ! zero len?
  3089          JZR  ARTN77           ! jif yes
  3090          POBD R20,+R10         ! skip comma
  3091 STRLOP   POBD R20,+R10         ! get next char
  3092          PUBD R20,+R24         ! push out to code
  3093          DCM  R76              ! dec len
  3094          JNZ  STRLOP           ! jif not done
  3095 ARTN77   RTN
  3096 !
  3097 AORG.    JSB  =AGTVA-          ! get ORG address
  3098          STMD R#,=ORGBAS       ! save it
  3099          RTN
  3100 !
  3101 ALNK.    LDM  R20,R10          ! copy ptr to LNK file name
  3102          CLM  R2               ! len counter
  3103 LNKLEN   ICM  R2               ! bump len
  3104          POBD R14,+R10         ! get next char from input
  3105          CMB  R14,=16          ! EOL?
  3106          JNZ  LNKLEN           ! jif no
  3107          DCM  R2               ! one too many bumps
  3108          PUMD R2,+R12          ! push len of filename
  3109          PUMD R20,+R12         ! push adr of filename
  3110          JSB  =DATDN           ! move code & LblTbl down to higher addr
  3111          JSB  =PREPO-          ! prep file
  3112          JEN  LNKTAP           ! jif no MS ROM
  3113          JSB  =LNKRDN          ! move fwd-ref stk down & setup for load
  3114          JSB  =ALODD           ! load ASM SRC from disk
  3115          JMP  LNKCOM           ! go do common finish
  3116 !
  3117 LNKTAP   JSB  =PARGNM          ! set up file name
  3118          JSB  =LNKRDN          ! move fwd-refs down, set up for ALOAD
  3119          JSB  =ALODT           ! load ASM SRC from tape
  3120 LNKCOM   ICB  R16              ! set system to calculator mode
  3121          POMD R24,-R6          ! pop address of low end of fwd-ref table
  3122          ICM  R24              ! to get to first byte SRC
  3123          LDMD R26,=NXTMEM      ! where to move it to DST
  3124          STMD R26,=STSIZE      ! set stack bottom
  3125          POMD R22,-R6          ! get len of fwd-ref table
  3126          JSB  =MOVUP           ! move fwd-refs back up to lowest place
  3127          STM  R26,R12          ! adjust R12 to the end of it
  3128          JSB  =RECNT-          ! move code & label table back to center
  3129          POMD R10,-R6          ! pop rtn addr (stop assemble at old loc)
  3130          CMB  R17,=300         ! errors?
  3131          JCY  ARTN73           ! jif yes
  3132          GTO ASMLNK            ! jmp back to start with fresh SRC code
  3133 !
  3134 ! move the fwd-ref stack down against the end of the label table
  3135 ! to allow as much room as possible for loading the next file of
  3136 ! ASSM source code.
  3137 !
  3138 LNKRDN   POMD R36,-R6          ! get return address off rtn stack
  3139          LDM  R24,R12          ! end of fwd-ref stack
  3140          DCM  R24              ! ptr to last byte
  3141          LDM  R22,R12          ! copy as HIGH ptr
  3142          SBMD R22,=NXTMEM      ! minus LOW ptr = len of fwd-ref stack
  3143          PUMD R22,+R6          ! save len on rtn stack
  3144          LDMD R26,=ALBTBL      ! DST ptr +1
  3145          DCM  R26              ! adjust to actual DST ptr
  3146          JSB  =MOVDN           ! move fwd-ref stk down against LblTbl
  3147          PUMD R26,+R6          ! save addr of end (low) of fwd-ref stk
  3148          JSB  =SETLDA          ! set file type and start/end ptrs
  3149          PUMD R36,+R6          ! push return address back on rtn stack
  3150 ARTN73   RTN                   ! done
  3151 !
  3152 ! push the output filename onto the R12 operating stack as a string-ref
  3153 !
  3154 GETONM   LDMD R56,=ABNLEN      ! get length of output filename
  3155          PUMD R56,+R12         ! push on op stack
  3156          LDM  R56,=ABPNAM      ! load address of output filename
  3157          PUMD R56,+R12         ! push it
  3158          RTN
  3159 !
  3160 AFIN.    POMD R30,-R6          ! toss rtn addr, we're done assembling
  3161          LDBD R30,=ISGLO       ! is this a GLO file?
  3162          JNZ  FINGLO           ! jif yes
  3163 !
  3164 ! We had to add SOMLBL on the next line, because there's an extra
  3165 ! (unneeded) DRP 30 in the ROM code, so the original ROM src
  3166 ! must have had a label here to cause the CURDRP to be invalidated.
  3167 ! So, to make this source assemble to the exact same bytes, we
  3168 ! add a label to force an extra DRP
  3169 !
  3170 ! bytes, we add a label to force an extra DRP
  3171 !
  3172 SOMLBL   LDMD R30,=ABSBAS      ! get output code base address (ABS)
  3173          LDMD R36,=ACODBA      ! get ptr to start of output code
  3174          LDMD R34,=ACODEN      ! get ptr to end of output code
  3175          SBM  R34,R36          ! =len of output code
  3176          LDBD R32,=ISAROM      ! get ABS flag
  3177          CMB  R32,=201         ! ABS?
  3178          JNZ  NOTABS           ! jif no
  3179          LDM  R32,=END16K      ! end-of-RAM on a 16K HP-85
  3180          CMB  R30,=16          ! ABS 16?
  3181          JZR  ABS16            ! jif yes
  3182          LDM  R32,=GINTEN      ! (177400) end-of-RAM on a 32K HP-85
  3183 ABS16    SBM  R32,R34          ! minus len of output code
  3184          STM  R32,R30          ! = ABS base address of ABS BPGM
  3185          STMD R32,X36,P.BASE   ! store it into the BPGM header
  3186 NOTABS   LDMD R32,=NXTMEM      ! bottom of forward-reference stack
  3187 NXTREF   CMM  R32,R12          ! anything on the forward-ref stack?
  3188          JZR  REFSOK           ! jif no, okay
  3189 !
  3190          POMD R22,+R32         ! get label table offset from ref-stack
  3191          LDMD R24,=ACODBA      ! get code base address
  3192          POMD R26,+R32         ! get code offset from ref-stack
  3193          ADM  R26,R24          ! base+offset=ptr into code of ref loc
  3194          SBM  R24,R22          ! end of LblTbl - offset =ptr into LblTbl
  3195          POMD R22,-R24         ! get addr from label table
  3196          POBD R20,-R24         ! get flag from label table
  3197          JNZ  LBLDEF           ! jif flag is non-0
  3198 !
  3199          TSM  R22              ! flag=0 and address=0 means undefined
  3200          JZR  NXTREF           ! jif undefined, try next one
  3201          ADM  R22,R30          ! add ABS base addr (or 0) to label addr
  3202 LBLDEF   LDMD R20,R26          ! get 2 bytes from code at ref location
  3203          CMB  R20,=377         ! GTO ?
  3204          JNZ  NOTGTO           ! jif no
  3205          DCM  R22              ! -1 for LDM R4 post-inc
  3206          PUMD R22,+R26         ! push out the real address
  3207 DREF     JSB  =DELREF          ! delete the reference from the fwd-refs
  3208          JMP  NXTREF           ! go try the next one
  3209 !
  3210 NOTGTO   PUBD R22,+R26         ! push LSbyte back out
  3211          CMB  R21,=326         ! 2-byte reference?
  3212          JNZ  DREF             ! jif no
  3213          PUBD R23,+R26         ! push MSbyte back out
  3214          JMP  DREF             ! finish this ref
  3215 !
  3216 FINGLO   JSB  =FGLO            ! write LblTbl as a GLOBAL data file
  3217          JMP  FINFIN           ! finish
  3218 !
  3219 NOREFS   LDMD R32,=AERCNT      ! get error count
  3220          JNZ  FFJMP            ! jif had some errors
  3221          LDBD R32,=ISAROM      ! get "is a ROM?" flag
  3222          CMB  R32,=122         ! 'R' ABS ROM?
  3223          JZR  FINROM           ! jif yes
  3224          JSB  =PREPON          ! setup Output Name
  3225          LDB  R56,=10          ! BPGM file type
  3226          STBD R56,=FILTYP      ! store it
  3227          LDMD R56,=ACODBA      ! get start of code
  3228          LDMD R76,=ACODEN      ! get end of code
  3229          JSB  =SETSR6          ! get spare memory on R6
  3230          DRP  R20
  3231          JEN  TAPSTB           ! jif TAPE
  3232 !
  3233          JSB  =ROMJSB
  3234          DEF  STRB-            ! STOREBIN in MSROM
  3235          BYT  320
  3236 !
  3237          LDBD R30,=ALODBP      ! get "reload BPGM" flag
  3238          JNZ  FINFIN           ! jif don't
  3239          JSB  =SCRTB.          ! else scratch the current BPGM
  3240          JSB  =GETONM          ! get the name of the just-assembled one
  3241 !
  3242          JSB  =ROMJSB
  3243          DEF  MSLDB.           ! LOADBIN it via MS ROM
  3244          BYT  320
  3245 !
  3246 FFJMP    JMP  FINFIN           ! finish up
  3247 !
  3248 REFSOK   LDMD R32,=NXTMEM      ! get beginning of fwd-ref stack
  3249          CMM  R32,R12          ! anything left undefinded on it?
  3250          JZR  NOREFS           ! jif no, all okay
  3251          JMP  UNDFWD           ! spit out undefined labels
  3252 !
  3253 FINROM   JSB  =FROM            ! write ROM as DATA file of 125-byte strs
  3254          JMP  FINFIN           ! finish up
  3255 !
  3256 TAPSTB   JSB  =PARGNM          ! set up output name
  3257 !
  3258          JSB  =ROMJSB
  3259          DEF  STORB-           ! STOREBIN it
  3260          BYT  0
  3261 !
  3262          LDBD R30,=ALODBP      ! get "reload BPGM" flag
  3263          JNZ  FINFIN           ! jif no load
  3264          JSB  =SCRTB.          ! SCRATCHBIN
  3265          JSB  =PREPON          ! set up output name
  3266 !
  3267          JSB  =ROMJSB
  3268          DEF  LOADB.           ! LOADBIN via TAPE
  3269          BYT  0
  3270 !
  3271 FINFIN   LDM  R46,=MREADY      ! READY msg
  3272          JSB  =SPITR-          ! spit the message
  3273          LDMD R36,=AERCNT      ! get error count
  3274          JSB  =CONBIN          ! convert to REAL#
  3275          LDMD R30,=ASMBAS      ! point to ASM ROM work buff
  3276 !
  3277          JSB  =ROMJSB
  3278          DEF  CVNUM            ! format the error count to R30
  3279          BYT  0
  3280 !
  3281 ! The following does LDM R51,=" ERRORS"
  3282          DRP  R51
  3283          BYT  251
  3284          ASC  " ERRORS"
  3285 !
  3286          PUMD R51,+R30         ! push " ERRORS" to R30
  3287          JSB  =DMPBUF          ! dump it out
  3288          JSB  =ST240+          ! set IMMEDIATE mode, IDLE, reset R12 stk
  3289          RTN                   ! done
  3290 !
  3291 UNDFWD   LDMD R46,=GNMLEN      ! get len of GLOBAL name
  3292          JNZ  NOTMT            ! jif non-empty, there's a GLOBALs file
  3293 UFWDLP   POMD R22,+R32         ! label table offset of next undef label
  3294          LDMD R24,=ACODBA      ! end ('base') of label table
  3295          POMD R26,+R32         ! get address in code of reference
  3296          ADM  R26,R24          ! make it a pointer into the output code
  3297          SBM  R24,R22          ! make R24 a pointer into the label table
  3298          POMD R62,+R24         ! get label from the table into R62-67
  3299          CLE
  3300          ICE                   ! preset flag
  3301          LDM  R46,=MUNDLB      ! address of UND LABEL
  3302          JSB  =PRTER-          ! print out the UND LABEL message
  3303          JSB  =DELREF          ! delete that ref from the fwd-ref stack
  3304          CMM  R#,R#            ! CMM R32,R12 empty fwd-ref stack?
  3305          JNZ  UFWDLP           ! jif no, loop
  3306          JMP  FINFIN           ! finish up
  3307 !
  3308 ! GLO file was included, read it in to satisfy undefined fwd-refs
  3309 !
  3310 NOTMT    JSB  =DATDN           ! move code & LblTbl down to highest RAM
  3311          LDMD R34,=NXTMEM      ! get start of fwd-ref stack
  3312 CREFLP   LDM  R24,R12          ! get end of fwd-ref stack
  3313          DCM  R24              ! actual last byte (SRC of what to move)
  3314          LDM  R26,R12
  3315          ADM  R26,=3,0         ! R26 = R12 + 3 (DST of where to move it)
  3316          LDM  R22,R12
  3317          SBM  R22,R34          ! R22 = len of fwd-refs (LEN to move)
  3318          JSB  =MOVDN           ! MOVE THE FWD-REF STACK DOWN 4 BYTES
  3319 ! we're in the process of changing a 4-byte fwd-ref
  3320 ! into an eight byte entry containing the 6-byte label
  3321 ! and the 2-byte offset into the code where the label
  3322 ! was referenced.
  3323          ADM  R12,=4,0         ! adjust R12
  3324          LDMD R32,R34          ! get LblTbl offset of top item
  3325          LDMD R36,=ACODBA      ! 'base' of label table
  3326          SBM  R36,R32          ! abs mem ptr to label in table
  3327          POMD R52,+R36         ! get label
  3328          PUMD R52,+R34         ! push to fwd-ref stk in place of fwd-ref
  3329          ICM  R34              ! skip two bytes of "code offset"
  3330          ICM  R34
  3331          CMM  R34,R12          ! done?
  3332          JNZ  CREFLP           ! jif no, convert the rest
  3333 !
  3334          LDMD R44,=GNMLEN      ! get len of GLO file name
  3335          LDM  R46,=GLOFNM      ! address of GLO file name
  3336          JSB  =ASGN1           ! ASSIGN# 1 TO "glo name"
  3337 !
  3338 ! we're going to read in the GLOBALS file, leaving 256 bytes of
  3339 ! space for the R12 stack to operate in, and potentially overwriting
  3340 ! the just assembled label table (since we've already copied the
  3341 ! undefined labels into the fwd-ref table.
  3342 !
  3343          LDM  R36,R12          ! get end of R12 stack
  3344          ADM  R36,=0,1         ! add 256 to get a buffer space
  3345          PUMD R36,+R12         ! push the address twice on the op stack
  3346          PUMD R36,+R12
  3347          LDM  R34,=212,1       ! put oct-612/dec-394 into temp buffer
  3348          PUMD R34,+R36         ! 1st WORD of global buffer=612=212,001
  3349          LDMD R34,=ACODBA      ! get end of avail mem for global file
  3350          SBM  R34,R36          ! length of available memory
  3351          SBM  R34,=10,0        ! minus another 8 (for safety?)
  3352          PUMD R34,+R36         ! push glo-avail-mem-len into buf 3 times
  3353          PUMD R34,+R36
  3354          PUMD R34,+R36
  3355 !
  3356 ! so at this point, the global buffer starts with:
  3357 !  WORD 0612
  3358 !  WORD len-of-buffer
  3359 !  WORD len-of-buffer
  3360 !  WORD len-of-buffer
  3361 ! <---R36
  3362 !
  3363          PUMD R36,+R6          ! save global buf twice on rtn stk
  3364 RGLOLP   PUMD R36,+R6
  3365          STMD R12,=TOS         ! set top of operating stack
  3366          LDM  R34,=175,0       ! decimal-125
  3367          PUMD R34,+R12         ! push 125 (len of str to read) to op stk
  3368          PUMD R36,+R12         ! push buf addr (len/addr = string ref)
  3369 !
  3370 ! assembled global files are DATA files containing 'strings'
  3371 ! of 125 bytes each.  So, we have to read them in as chunks
  3372 ! of 125 bytes.
  3373 !
  3374          JSB  =REED$           ! read 125 bytes from the global file
  3375 !
  3376          POMD R36,-R6          ! get address of where we just read to
  3377          LDMD R40,R36          ! get 8 bytes from it
  3378          CMMD R40,=BLANKS      ! 8 blanks?
  3379          JZR  ENDGLO           ! jif yes, end of glob table
  3380          ADM  R36,=372,0       ! +250 (125 for THIS read, 125 next)
  3381          CMMD R36,=ACODBA      ! room for another read?
  3382          JNC  GRDOK            ! jif yes
  3383 !
  3384          JSB  =ERROR+
  3385          BYT  23               ! MEM OVF
  3386 !
  3387 GRDOK    SBM  R#,=175,0        ! move R36 back 125 to read next block
  3388          POMD R34,-R12         ! get buffer address from stack
  3389          PUMD R34,+R12         ! push it back
  3390          PUMD R34,+R12         ! push it again
  3391          JMP  RGLOLP
  3392 !
  3393 ENDGLO   POMD R34,-R12         ! get address of glo buffer
  3394 DELBLN   POBD R34,-R36         ! get last char of glo buffer
  3395          CMB  R34,=40          ! space?
  3396          JZR  DELBLN           ! jif yes, throw-away last spaces
  3397          STM  R36,R24          ! copy glo end ptr
  3398          POMD R22,-R6          ! get ptr to beginning of glo buffer
  3399          SBM  R36,R22          ! len of glo buffer
  3400          STM  R36,R22          ! set as LEN for move
  3401          DCM  R24              ! adjust ptr to SRC to 1st (highest) byte
  3402          LDMD R26,=ACODBA      ! code base
  3403          DCM  R26              ! -1 for DST ptr for move
  3404          JSB  =MOVDN           ! move the global table down to the code
  3405          ICM  R26              ! DST ptr=last (lowest) byte of glo table
  3406          STMD R26,=ALBTBL      ! save as end of 'new' label table
  3407          CLM  R34
  3408          STMD R34,=GNMLEN      ! GLOBALS name len=0 to not process again
  3409          LDMD R34,=NXTMEM      ! beginning of fwd-ref undefined table
  3410 GLBLLP   POMD R42,+R34         ! get label
  3411          JSB  =SLBLTB          ! search the global label table for it
  3412          JEN  GGLBL            ! jif found label in table
  3413          PUMD R42,-R20         ! add label to the end of the label table
  3414          CLM  R45              ! flags and address = 0
  3415          PUMD R45,-R20         ! push into new entry in label table
  3416          STMD R20,=ALBTBL      ! ajust end of table ptr
  3417          ADM  R20,=3,0         ! move back to addr in table
  3418 GGLBL    LDMD R22,=ACODBA      ! beginning (high end) of label table
  3419          SBM  R22,R20          ! minus ref = offset of label in table
  3420          PUMD R22,-R34         ! push offset to LblTbl over last 2 bytes
  3421          LDM  R32,R34          ! copy ptr to first 4 bytes of label
  3422          JSB  =DELREF          ! del 1st 4 bytes of label as if fwd-ref
  3423          CMM  R34,R#           ! R34==R12 = done processing fwd-ref stk
  3424          JNZ  GLBLLP           ! jif not done, loop to do next one
  3425          JSB  =ASGN*           ! close the globals file
  3426          GTO NOTABS            ! now go finish normal processing
  3427 !
  3428 ! ***************************************************
  3429 ! NOTE: the following 4 bytes of ZERO don't appear to
  3430 ! be called or referenced from anywhere.  No clue.
  3431 ! ***************************************************
  3432 !
  3433          BYT  0,0,0,0
  3434 !
  3435 ! ***************************************************
  3436 !
  3437 ALST.    LDB  R#,=377          ! turn LISTING on
  3438 SLST     STBD R#,=LSTFLG       ! save LST state
  3439          RTN
  3440 !
  3441 AUNL.    CLB  R#               ! turn LISTING off
  3442          JMP  SLST
  3443 !
  3444 AGLO.    LDMD R45,=ILNMAB      ! already seen NAM or ABS?
  3445          JZR  GGLONM           ! jif no, GLO is okay
  3446          LDM  R46,=MILGLO      ! else ILL GLO error
  3447 !
  3448 PRTERR   CLE
  3449 PRTER-   STM  R46,R60
  3450          JSB  =PSHRGS          ! save R20-R47
  3451          LDM  R46,R60
  3452          JSB  =CPYSTR          ! copy string to output buf
  3453          JSB  =DOPRNT          ! output = PRINTER IS device
  3454          LDMD R36,=SAVER6      ! get line# of problem
  3455          ARP  R30
  3456          JEN  PELBL            ! jif show label
  3457 !
  3458          DRP  R40              ! load " ON LINE" into R40-R47
  3459          BYT  251
  3460          ASC  " ON LINE"
  3461 !
  3462          PUMD R40,+R30         ! push to output buffer
  3463          PUBD R40,+R30         ! and space after " ON LINE"
  3464          JSB  =DCLIN#          ! and the line#
  3465 PEDMP    JSB  =DMPBUF          ! print the buffer
  3466          LDMD R2,=AERCNT       ! get the error counter
  3467          ICM  R2               ! bump it up one
  3468          STMD R2,=AERCNT       ! save it again
  3469          JSB  =POPRGS          ! restore R20-R47
  3470          RTN
  3471 !
  3472 WDUPLB   ASC  "WARN:"
  3473 EDUPLB   ASP  "DUP LAB"
  3474 !
  3475 PELBL    LDB  R61,=40          ! put space in front
  3476          PUMD R61,+R#          ! push out the space-label
  3477          JMP  PEDMP
  3478 !
  3479 GGLONM   CMB  R20,=16          ! EOL token?
  3480          JZR  ST16             ! jif yes, this IS a global file
  3481          LDM  R46,R10          ! copy input name ptr
  3482          LDM  R56,=GLOFNM      ! global name buffer ptr
  3483          JSB  =GFNAME          ! get a clean file name
  3484          STMD R#,=GNMLEN       ! save len of GLOFNM
  3485          RTN
  3486 !
  3487 ST16     STBD R#,=ISGLO        ! set flag that we're IN a global file
  3488          RTN
  3489 !
  3490 MILGLO   ASP  "ILL GLO"
  3491 !
  3492 ! INPUT:
  3493 ! R46 = ptr to input (expected to be filename with EOL (16) tok on end)
  3494 ! R56 = ptr to output
  3495 ! OUTPUT:
  3496 ! R10 = pointing to next byte after the EOL token
  3497 ! R46 = len of filename that was processed
  3498 ! filename in R56 has been limited to 10 chars and optionally a 6 char
  3499 ! MSUS or volume label
  3500 GFNAME   LDB  R40,=12          ! maximum length of filename (10 dec)
  3501          STM  R46,R44          ! copy starting ptr
  3502 FNAMLP   POBD R20,+R46         ! get byte of name
  3503          CMB  R20,=16          ! EOL token?
  3504          JZR  FEOL             ! jif yes
  3505          CMB  R20,=72          ! ':' ?
  3506          JZR  FCOLON           ! jif yes
  3507          CMB  R20,=56          ! '.' ?
  3508          JZR  FCOLON           ! jif yes
  3509          TSB  R40              ! got all 10 chars?
  3510          JZR  FNAMLP           ! jif yes (toss everything after 10)
  3511          DCB  R40              ! decrement len counter
  3512          PUBD R20,+R56         ! put the byte to the output
  3513          JMP  FNAMLP           ! go get more
  3514 !
  3515 ! got MSUS or VOLUME LABEL
  3516 FCOLON   PUBD R#,+R56          ! push the ':' or '.'
  3517          LDB  R40,=6           ! allow 6 more chars
  3518 CODOLP   POBD R20,+R46         ! get next char
  3519          CMB  R20,=16          ! EOL?
  3520          JZR  FEOL             ! jif yes
  3521          PUBD R20,+R56         ! else push the char out
  3522          DCB  R40              ! decrement len counter
  3523          JNZ  CODOLP           ! jif not exhausted
  3524 FEOL     STM  R46,R10          ! update R10 to what we've used up
  3525          SBM  R46,R44          ! get len of what we pushed
  3526          DCM  R46              ! minus 1 for the EOL token
  3527          RTN
  3528 !
  3529 FROM     LDMD R24,=ACODBA      ! beginning of code
  3530          STMD R24,=LEGEND      ! save address of what to write
  3531          LDMD R26,=ACODEN      ! end of code
  3532          DCM  R26              ! minus one = last byte to write
  3533          STMD R26,=ENDWRI      ! save it
  3534          JMP  WCOM
  3535 !
  3536 FGLO     LDMD R24,=ALBTBL      ! beginning of label table
  3537          STMD R24,=LEGEND      ! save it
  3538          LDMD R26,=ACODBA      ! end of label table
  3539          STMD R26,=ENDWRI      ! save it
  3540          STMD R27,R26          ! store byte with MSbit set
  3541 ! I'm guessing the above line of code puts a byte with the MSbit set
  3542 ! into the next byte after the 'last' label, which would be the FLAG
  3543 ! byte of the 'next' label, if there were a next label.  The FLAG byte
  3544 ! normally seems to have a 0 in the MSbyte, so this would flag "end of
  3545 ! global table" in the GLO file.  Maybe.
  3546 !
  3547 WCOM     BIN
  3548          SBM  R26,R24          ! len of what to write
  3549 !
  3550 ! we're converting len of what to write into number of sectors
  3551 ! sectors are 256 bytes, so adding 7 to the upper byte of the len
  3552 ! and ignoring the LSbyte essentially rounds up the length to
  3553 ! 6 more sectors than what's really needed.  This is done so that,
  3554 ! as the ROM or BPGM is developed and continues to grow, it doesn't
  3555 ! create an on-going series of ever-larger NULL file holes in the
  3556 ! directory.  Rather, an extra-large "file hole" is created up front,
  3557 ! and will remain in use through subsequent assemblies until the file
  3558 ! grows larger than than (ie, by at least 1.5 Kbyte), at which point
  3559 ! we'll then create a new "file hole" that is 6 sectors larger than
  3560 ! what is needed at that point.  You'll still end up with ongoing
  3561 ! disk/tape-fragmentation, but it will happen at a much slower rate.
  3562 !
  3563          ADB  R27,=7           ! round up the file len by ~6 sectors
  3564          STB  R27,R26          ! copy to the lower byte
  3565          CLB  R27              ! 0 upper, now have rounded-up #sectors
  3566          STM  R26,R36          ! copy to CONBIN's desired register
  3567          JSB  =CONBIN          ! convert R36-37 to a REAL number
  3568          STMD R12,=TOS         ! set top of stack
  3569          PUMD R40,+R6          ! save the REAL value
  3570          JSB  =PREPON          ! prepare output file name
  3571          JSB  =SETSR6          ! set SAVER6 to space on the R6 stack
  3572          JEN  FINTAP           ! jif MS ROM not present
  3573 !
  3574          JSB  =ROMJSB
  3575          DEF  DIRSCN           ! scan directory for our output name
  3576          BYT  320
  3577 !
  3578          JEN  DNOFIL           ! jif not found
  3579 !
  3580          JSB  =ROMJSB
  3581          DEF  GETTYP           ! get the file type
  3582          BYT  320
  3583 !
  3584          CMB  R30,=20          ! DATA file type?
  3585          JZR  DATFIL           ! jif yes
  3586 TAPBAD   POMD R40,-R6          ! trash the record count on the stack
  3587 !
  3588          JSB  =ROMJSB
  3589          DEF  TAPEXT           ! exit clean up stuff
  3590          BYT  0
  3591 !
  3592          JSB  =ERROR
  3593          BYT  104              ! File type
  3594 !
  3595          RTN
  3596 !
  3597 DATFIL   JSB  =ROMJSB
  3598          DEF  TYPOK2           ! seek to the file
  3599          BYT  320
  3600 !
  3601          JMP  WRIFI            ! go finish writing the file
  3602 !
  3603 DNOFIL   JSB  =GETONM          ! get the output file name
  3604          POMD R40,-R6          ! get # of records
  3605          PUMD R40,+R12         ! push on op stack
  3606 !
  3607          JSB  =ROMJSB
  3608          DEF  MSCRE.           ! CREATE "filename", #_recs
  3609          BYT  320
  3610 !
  3611          JMP  WRIFI-           ! now go write everything to it
  3612 !
  3613 TAPGO    LDBD R47,X36,F.TYPE   ! get file type
  3614          ANM  R47,=374         ! strip 2 lower bits
  3615          CMB  R47,=20          ! DATA file?
  3616          JZR  WRIFI            ! jif yes, write to it
  3617          JMP  TAPBAD           ! else BAD.  BAD BOY!
  3618 !
  3619 FINTAP   JSB  =PARGNM          ! push the output name
  3620 !
  3621          JSB  =ROMJSB
  3622          DEF  TAPINT           ! init the tape software
  3623          BYT  0
  3624 !
  3625          BIN
  3626          CMB  R17,=300         ! errors?
  3627          JCY  TAPBAD           ! jif yes
  3628 !
  3629          JSB  =ROMJSB
  3630          DEF  DSCAN            ! scan the tape directory
  3631          BYT  0
  3632 !
  3633          JEZ  TAPGO            ! jif file found
  3634 !
  3635          JSB  =PREPON          ! push the output file name
  3636          POMD R40,-R6          ! get the number of records
  3637          PUMD R40,+R6          ! save again
  3638          PUMD R40,+R12         ! push on op stack
  3639 !
  3640          JSB  =ROMJSB
  3641          DEF  CREAT.           ! do tape CREATE "filename", #_records
  3642          BYT  0
  3643 !
  3644 WRIFI    POMD R40,-R6          ! get # records off stack
  3645 WRIFI-   LDMD R44,=ABNLEN      ! get len of output file name
  3646          LDM  R46,=ABPNAM      ! get address of output file name
  3647          JSB  =ASGN1           ! open the data file
  3648          LDMD R46,=LEGEND      ! get addr of what to write
  3649 WRIDAT   LDM  R36,=175,0       ! # bytes to write at a time (125 dec)
  3650          STM  R36,R44          ! store in R44-R45
  3651          ADM  R46,R36          ! plus len = ptr to end of what to write
  3652          CMMD R46,=ENDWRI      ! past end of what to write?
  3653          JCY  ENDBLK           ! jif yes
  3654          PUMD R46,+R6          ! else save end address
  3655          SBM  R46,R36          ! get start address
  3656          JSB  =PRT$            ! print this chunk to file (125 bytes)
  3657          POMD R46,-R6          ! recover next address to write from
  3658          JMP  WRIDAT           ! loop
  3659 !
  3660 ENDBLK   SBM  R#,R#            ! minus len = addr of start of last block
  3661          LDMD R36,=ENDWRI      ! get address of last byte to write
  3662          SBM  R36,R46          ! last ptr - start ptr =len-1
  3663          ICM  R36              ! # bytes in last block
  3664          STM  R36,R44          ! put in R44-45
  3665          JSB  =PRT$            ! print the last block
  3666          CLM  R44
  3667          JSB  =PRT$            ! flush the buffer
  3668 ASGN*    JSB  =P12_1           ! push a REAL 1 on the op stack
  3669          CLM  R44
  3670          ICM  R44              ! len of 1
  3671          LDM  R46,=ASTAR       ! addr of a '*' value in tape software
  3672          JMP  ASGN             ! do ASSIGN# 1 TO * to close the file
  3673 !
  3674 P12_1    CLM  R50
  3675          LDB  R57,=20          ! R50-57 = REAL# 1.000
  3676          PUMD R50,+R12         ! push it on the op stack
  3677          RTN
  3678 !
  3679 ASGN1    STMD R12,=TOS         ! set top of stack
  3680          JSB  =P12_1           ! push REAL 1 on op stack
  3681          JSB  =ASGN            ! do ASSIGN
  3682          JSB  =P12_1           ! push REAL 1 on op stack
  3683          JSB  =PRTNUM          ! start PRINT# 1
  3684 ARTN76   RTN
  3685 !
  3686 ASGN     PUMD R44,+R12         ! push file name and len on op stack
  3687          PUMD R44,+R6          ! also save for later
  3688          JSB  =PREPO-          ! prepare output file name
  3689          POMD R44,-R6          ! recover the file name ptr and len
  3690          JEN  TAPASG           ! jif no MS ROM
  3691          PUMD R44,+R12         ! else push the file name again
  3692 !
  3693          JSB  =ROMJSB
  3694          DEF  ASSIG.           ! do MSROM ASSIGN# 1 TO "filename"
  3695          BYT  320
  3696 !
  3697          JMP  ERCHK9
  3698 !
  3699 TAPASG   POMD R64,-R12         ! pop MS ROM name
  3700          PUMD R44,+R12         ! push TAPE name
  3701          JSB  =ROMJSB
  3702          DEF  ASIGN.           ! do TAP ASSIGN# 1 TO "filename"
  3703          BYT  0
  3704 !
  3705 ERCHK9   CMB  R17,=300         ! errors?
  3706          JNC  ARTN76           ! jif no
  3707          JSB  =BAIL            ! else bail out, don't come back
  3708 !
  3709 A1DRP    LDM  R26,=CURDRP      ! address of CURDRP
  3710          JSB  =AGTVAL          ! chew up R number
  3711          JEZ  BDRPNU           ! jif failed
  3712          LDB  R21,=100
  3713          ORB  R76,R21          ! change reg# into DRP instruction
  3714 DRPCMP   CMBD R#,R26           ! same as previous DRP?
  3715          JZR  SAMDRP           ! jif yes
  3716          STBD R#,R26           ! else save new CURDRP
  3717          PUBD R#,+R24          ! push out DRP instruction
  3718 SAMDRP   POBD R20,+R10         ! get next char
  3719          CMB  R20,=54          ! comma?
  3720          JNZ  DRP73R           ! jif no
  3721          POBD R20,+R10         ! get next char
  3722 DRP73R   DRP  R73
  3723          RTN
  3724 !
  3725 BDRPNU   CMB  R20,=43          ! '#' ?
  3726          JZR  SAMDRP           ! jif yes
  3727          LDB  R76,=101         ! else DRP 1 for R*
  3728          JMP  DRPCMP
  3729 !
  3730 A1ARP    CMB  R20,=75          ! '=' ?
  3731          JZR  AGOT=            ! jif yes
  3732 !
  3733          LDM  R26,=CURARP      ! addres of CURARP
  3734          JSB  =AGTVAL          ! get # from input asm line
  3735          JEZ  BARPNU           ! jif failed
  3736 ARPCMP   CMBD R#,R26           ! same as previous value was?
  3737          JZR  SAMARP           ! jif yes,
  3738          STBD R#,R26           ! else save new ARP reg#
  3739          PUBD R#,+R24          ! push out ARP instruction
  3740 SAMARP   POBD R20,+R10         ! get next char
  3741          CMB  R20,=54          ! comma?
  3742          JNZ  DRP73R           ! jif no
  3743          ICB  R70
  3744 AGOT=    ICB  R70              ! R70=0 (R,R) =1 (R,=) =2 (R,R,=)
  3745          ICB  R75              ! R75=0 (R,R) =1 (R,R,ADDR or ADDR)
  3746          RTN
  3747 !
  3748 BARPNU   CMB  R20,=43          ! '#'?
  3749          JZR  SAMARP           ! jif yes, was R#
  3750          LDB  R76,=1           ! else ARP 1 for R*
  3751          JMP  ARPCMP
  3752 !
  3753 PSHIMM   LDBD R20,R10          ! peek at next char
  3754          JSB  =DIGIT           ! literal number?
  3755          JEN  GETLIT           ! jif yes
  3756          POMD R41,+R10         ! else should be a label, get it
  3757          JSB  =ADR16-          ! push the label value or a fwd-ref
  3758          TSB  R71              ! immediate addressing mode?
  3759          JNZ  ARTN78           ! jif no
  3760          TSB  R72              ! multi-byte immediate?
  3761          JNZ  IMMULT           ! jif yes, leave as is
  3762 IMM-1    POMD R56,-R24         ! else pop two byte value
  3763          PUBD R56,+R24         ! push back just one byte value
  3764 ARTN78   RTN
  3765 !
  3766 GETLIT   JSB  =GET#            ! get the numeric value
  3767          PUBD R#,+R24          ! push it out
  3768          CMB  R20,=54          ! comma?  (more?)
  3769          JZR  GETLIT           ! jif yes
  3770          RTN
  3771 !
  3772 IMMULT   LDBD R77,=CURDRP      ! get current DRP value
  3773          CMB  R77,=40          ! less than 40?
  3774          JCY  IMM8             ! jif no
  3775          TSB  R77              ! if DRP is odd, only 1 byte
  3776          JOD  IMM-1            ! jif yes, trash the second byte
  3777          RTN
  3778 !
  3779 IMM8     ANM  R77,=7           ! get DRP offset in 8-byte register
  3780          CMB  R77,=7           ! last byte of 8-byte reg so only 1 byte
  3781          JZR  IMM-1            ! jif yes, trash the second byte
  3782          RTN
  3783 !
  3784 MJMPTO   ASP  "JMP TO"
  3785 !
  3786 ! **********************************************************************
  3787 ! A previously referenced label has now been defined.
  3788 ! Search through the forward reference list, find any references
  3789 ! to the new label, and go back and patch their address.
  3790 ! ENTRY:
  3791 ! ARP=20
  3792 ! R24 = ACODEN (end of new code ptr)
  3793 !
  3794 SATREF   POMD R55,+R#          ! get line#/addr and flags from LblTbl
  3795          LDMD R46,=ACODBA      ! get end of label table ptr
  3796          SBM  R46,R20          ! offset of label from end of table
  3797          LDMD R32,=NXTMEM      ! get beginning of fwd-ref table
  3798 REFLOP   CMM  R32,R12          ! reached end of reference table?
  3799          JCY  ARTN80           ! jif yes, done
  3800          CMMD R46,R32          ! offset of label match offset from ref?
  3801          JZR  GOTREF           ! jif yes
  3802          ADM  R32,=4,0         ! skip to next entry in reference table
  3803          JMP  REFLOP           ! try next one
  3804 !
  3805 GOTREF   POMD R30,+R#          ! throw away offset
  3806          POMD R30,+R#          ! get offset into code where ref occurred
  3807          ADMD R30,=ACODBA      ! add offset to base of code
  3808          LDMD R34,R30          ! get bytes from where label ref occurred
  3809 !
  3810          CMB  R34,=326         ! abs value ref (JSB, LD, ST, etc)?
  3811          JZR  ABSREF           ! jif yes
  3812 !
  3813          CMB  R34,=377         ! is it a GTO reference?
  3814          JZR  GTOREF           ! jif yes
  3815 !
  3816 ! must be a relative JMP instruction then
  3817 !
  3818          LDM  R36,R24          ! address of label we're de-referencing
  3819          SBM  R36,R30          ! minus location of ref
  3820          DCM  R36
  3821          CMB  R36,=200         ! > 128 bytes (rel jmp distance limit)
  3822          JNC  RELJOK           ! jif less
  3823 RELJER   PUMD R65,+R6          ! save registers
  3824          PUMD R32,+R6
  3825          LDM  R46,=MJMPTO      ! JMP TO error
  3826          JSB  =PRTERR          ! output the error
  3827          POMD R32,-R6          ! restore registers
  3828          POMD R65,-R6
  3829          JMP  DELIT
  3830 !
  3831 RELJOK   CMB  R37,=0           ! make sure upper byte of distance is 0
  3832          JNZ  RELJER           ! jif not, error
  3833          STBD R36,R30          ! else set rel jmp offset at label ref
  3834 DELIT    JSB  =DELREF          ! delete used up reference
  3835          JMP  REFLOP
  3836 !
  3837 DELREF   JSB  =PSHRGS          ! save regs
  3838          LDM  R22,R12          ! end of forward-reference table
  3839          SBM  R22,R32          ! - curr (finished) ref = len to move
  3840          LDM  R24,R32          ! source (first byte) to move
  3841          LDM  R26,R32          ! copy
  3842          SBM  R26,=4,0         ! minus 4 = dest where to move to
  3843          JSB  =MOVUP           ! deleting the finished ref
  3844          SBM  R12,=4,0         ! adjust end-of-table ptr
  3845          JSB  =POPRGS          ! restore regs
  3846          SBM  R32,=4,0         ! adjust curr ref ptr for more looping
  3847          ARP  R12
  3848 ARTN80   RTN
  3849 !
  3850 ABSREF   TSB  R55              ! addr known or is it a fwd-ref'd label?
  3851          JZR  REFLOP           ! jif unknown, skip it
  3852          PUBD R56,+R30         ! push byte of label value into code
  3853          CMB  R35,=326         ! two bytes of abs value in code?
  3854          JNZ  DELIT            ! jif no, done
  3855          PUBD R57,+R30         ! push secont byte of label value
  3856          JMP  DELIT            ! done
  3857 !
  3858 GTOREF   TSB  R55              ! addr known or is it a fwd-ref'd label?
  3859          JZR  REFLOP           ! jif unknown, skip it
  3860          DCM  R56              ! adjust addr by 1 required by LDM R4,=
  3861          PUMD R56,+R30         ! push the address into the code
  3862          JMP  DELIT            ! done
  3863 !
  3864 ! *****************************************************
  3865          BYT  141
  3866 ALOAD.   JSB  =PREPO-          ! prep file name
  3867          JEN  ALODTP           ! jif no MS ROM
  3868          JSB  =SCRUS           ! SCRATCH and set up for load
  3869 !
  3870 ALODD    JSB  =ROMJSB
  3871          DEF  LOADBR           ! do modified load of ASM SRC file
  3872          BYT  320
  3873 !
  3874          JMP  ALDFIN           ! finish up
  3875 !
  3876 ALODTP   JSB  =PARGNM          ! set up tape name
  3877          JSB  =SCRUS           ! SCRATCH and set up for load
  3878 !
  3879 ALODT    JSB  =ROMJSB
  3880          DEF  LOADB&           ! do modified load of ASM SRC file
  3881          BYT  0
  3882 !
  3883 ALDFIN   CLB  R16              ! set system idle mode
  3884 !
  3885          JSB  =ROMJSB
  3886          DEF  LDCOMN           ! enable interrupts, end the tape load
  3887          BYT  0
  3888 !
  3889          RTN
  3890 !
  3891 SCRUS    JSB  =ERMSGS          ! do SCRATCH
  3892          LDMD R14,=MSBASE      ! MS ROM RAM
  3893          LDMD R56,=LAVAIL      ! end of RAM
  3894 SETLDA   STMD R#,=LSTDAT       ! set last end of space to read into
  3895          ICB  R16              ! set system calculator mode
  3896          JSB  =STATYP          ! set ASSM file type and load FWCURR
  3897          STMD R#,=NXTDAT       ! set start of where to read to
  3898          RTN
  3899 !
  3900 STATYP   LDB  R56,=4           ! extended file type (ASSM SRC)
  3901          STBD R56,=FILTYP      ! set it
  3902 GTFWCU   LDMD R56,=FWCURR      ! where to read in to
  3903          ARP  R56
  3904          RTN
  3905 !
  3906 ! An OCTAL value has been passed on the R12 stack.  Convert it to a
  3907 ! DECIMAL so we can get it off the stack and convert it to a BINARY
  3908 ! value in R46-47.  Reload R14 with ASMBAS on the way out.
  3909 !
  3910 !
  3911 OCTBIN   JSB  =DEC.            ! convert octal# on stk to dec# on stk
  3912          CMB  R17,=300         ! any errors?
  3913          JCY  BAIL             ! jif yes
  3914 GTBIN+   JSB  =GTBIN#          ! get address as a binary value in R46-47
  3915 GTABAS   LDMD R14,=ASMBAS      ! load R14 with ASM ROM RAM address
  3916          BIN                   ! make sure CPU is in BINARY mode
  3917          ARP  R14              ! leave DRP and ARP both pointing at R14
  3918          RTN
  3919 !
  3920 REED$    JSB  =STUPD
  3921          JSB  =SETSR6          ! set SAVER6
  3922          JEN  TREED$
  3923 !
  3924          JSB  =ROMJSB
  3925          DEF  RD#$             ! MSROM READ# string
  3926          BYT  320
  3927 !
  3928          JMP  CHKER8           ! check if errors
  3929 !
  3930 TREED$   JSB  =ROMJSB
  3931          DEF  READ#$           ! TAPE READ# string
  3932          BYT  0
  3933 !
  3934 CHKER8   CMB  R17,=300         ! any error?
  3935          JNC  ARTN75           ! jif no
  3936          LDMD R26,=CURLOC      ! get CURLOC
  3937          JSB  =CLOSE+          ! close the file
  3938 !
  3939 ! terminal error has occurred
  3940 ! BAIL OUT!!!!
  3941 !
  3942 BAIL     LDM  R6,=STACK        ! reset R6 stack
  3943          LDM  R34,=EXEC        ! to executive loop
  3944          PUMD R34,+R6          ! push it on the stack
  3945 ARTN75   RTN                   ! return to the EXEC loop
  3946 !
  3947 PRT$     JSB  =STUPD           ! setup disk and get ready
  3948          JSB  =SETSR6          ! save ptr to R6 stack area
  3949          JEN  TAPPRT           ! jif no MS ROM
  3950 !
  3951          JSB  =ROMJSB
  3952          DEF  PR#$             ! print to file
  3953          BYT  320
  3954 !
  3955          JMP  CHKER8           ! check for errors
  3956 !
  3957 TAPPRT   JSB  =ROMJSB
  3958          DEF  PRNT#$           ! call TAPE print$ routine
  3959          BYT  0
  3960 !
  3961          JMP  CHKER8           ! check for errors
  3962 !
  3963 STUPD    JSB  =INIMS           ! init MS ROM for access
  3964          JEN  ARTN74           ! jif not there
  3965 !
  3966          JSB  =ROMJSB
  3967          DEF  CKMSUS           ! make sure MSUS and disk are okay
  3968          BYT  320
  3969 !
  3970 ARTN74   RTN
  3971 !
  3972 PRTNUM   JSB  =MSIN?           ! MS ROM here?
  3973          JEN  TAPNUM           ! jif no
  3974 !
  3975          JSB  =ROMJSB
  3976          DEF  MSPRT.           ! print DISK
  3977          BYT  320
  3978 !
  3979          JMP  CHKER8           ! see if errors
  3980 !
  3981 TAPNUM   JSB  =ROMJSB
  3982          DEF  PRNT#.           ! print TAPE
  3983          BYT  0
  3984 !
  3985          JMP  CHKER8           ! see if error
  3986 !
  3987 ! Send the buffer to the DISPLAY or PRINTER
  3988 DUMPIT   JSB  =ROMJSB
  3989          DEF  DRV12.           ! DISP or PRINT the buffer
  3990          BYT  0
  3991          JSB  =GTABAS          ! reload R14 with ASM RAM
  3992          RTN
  3993 !
  3994 PARNE+   JSB  =ROMJSB
  3995          DEF  NUMEX+           ! parse a numeric expression
  3996          BYT  0
  3997          RTN
  3998 !
  3999 ! who WROTE this code?  there are TWO identical subroutines!!!
  4000 ! I hope one of them got removed in the HP-87 version!!!
  4001 !
  4002 PARNE2   JSB  =ROMJSB
  4003          DEF  NUMEX+           ! scan and get numeric expression
  4004          BYT  0
  4005          RTN
  4006 !
  4007 PARGNM   JSB  =ROMJSB
  4008          DEF  GETNAM           ! get the TAPE file name
  4009          BYT  0
  4010          RTN
  4011 !
  4012 ! Prepare the output file name
  4013 !
  4014 PREPON   JSB  =GETONM          ! set up the output file name
  4015 PREPO-   JSB  =INIMS           ! init the MS ROM for access (if present)
  4016          JEN  ARTN63           ! jif no MS ROM
  4017 !
  4018          JSB  =ROMJSB
  4019          DEF  TAPDS-           ! decode the file specifier
  4020          BYT  320
  4021 !
  4022          CMB  R17,=300         ! error?
  4023          JCY  BAIL             ! jif yes
  4024 ARTN63   RTN                   ! else done
  4025 !
  4026 SETSR6   LDM  R20,R6           ! get ptr to top of R6 stack
  4027          ADM  R20,=5,0         ! +5 (allow a little extra space?)
  4028          STMD R20,=SAVER6      ! save the ptr to SAVER6
  4029          RTN
  4030 !
  4031 ! *********************************************
  4032 ! ASTORE
  4033 ! *********************************************
  4034          BYT  141              ! attrib: non-programmable BASIC stmt
  4035 ASTOR.   JSB  =PREPO-          ! prepare the file name
  4036          JSB  =SETSR6          ! set SAVER6
  4037          JEN  ASTORT           ! jif no MSROM
  4038          JSB  =STSEC?          ! check security, setup for store
  4039 !
  4040          JSB  =ROMJSB
  4041          DEF  STRB-            ! MS ROM store ASSM code as an ASSM file
  4042          BYT  320
  4043 !
  4044          RTN                   ! done
  4045 !
  4046 ASTORT   JSB  =PARGNM          ! set up file name
  4047          JSB  =STSEC?          ! check security, setup for store
  4048 !
  4049          JSB  =ROMJSB
  4050          DEF  STORB-           ! TAPE store src code as an ASSM file
  4051          BYT  0
  4052 !
  4053          RTN                   ! done
  4054 !
  4055 STSEC?   LDB  R0,=1            ! store security
  4056          JSB  =SECUR?          ! is it secured against storing?
  4057          JEZ  STOK             ! jif no
  4058          POMD R20,-R6          ! else trash return, don't continue
  4059          RTN                   ! done
  4060 !
  4061 STOK     JSB  =STATYP          ! set ASSM file type and load FWCURR
  4062          JSB  =ST240+          ! set IMMEDIATE mode, IDLE, reset R12 stk
  4063          LDMD R76,X56,P.LEN    ! get source code "program" length
  4064          BIN
  4065          ADM  R76,R56          ! add to base = end of source code
  4066          STMD R12,=STSIZE      ! set bottom of stack
  4067          RTN
  4068 !
  4069 ! Initialize the MS ROM for access
  4070 !
  4071 INIMS    BIN
  4072          JSB  =MSIN?           ! is the MS ROM here?
  4073          JEN  MSEX             ! jif no
  4074 !
  4075          JSB  =ROMJSB
  4076          DEF  MSIN             ! initialize the MS ROM for calls
  4077          BYT  320
  4078 !
  4079          JSB  =SETSR6          ! point SAVER6 into unused R6 stack
  4080 !
  4081 ! return E=0 if MS ROM IS present, else E#0 if NOT present
  4082 !
  4083 MSIN?    CLE
  4084          ICE                   ! preflag is NOT present
  4085          LDM  R20,=ROMTAB      ! address of table of present ROMs
  4086 MSINLP   POMD R24,+R20         ! get next one
  4087          CMB  R24,=377         ! end of table?
  4088          JZR  MSEX             ! jif yes
  4089          CMB  R24,=320         ! MS ROM?
  4090          JNZ  MSINLP           ! jif no, keep looking
  4091          CLE                   ! flag it IS here
  4092 MSEX     RTN
  4093 !
  4094 PABS     CLB  R30              ! clear ROM flag
  4095          CMB  R20,=122         ! 'R' ?
  4096          JNZ  ABSNOR           ! jif no
  4097          PUBD R20,+R12         ! push 'R'
  4098          JSB  =GCHAR           ! get next char
  4099          CMB  R#,=117          ! 'O' ?
  4100          JNZ  PABSER           ! jif no
  4101          PUBD R#,+R12          ! push 'O'
  4102          JSB  =GCHAR           ! get next char
  4103          CMB  R#,=115          ! 'M' ?
  4104          JNZ  PABSER           ! jif no
  4105          PUBD R#,+R12          ! push 'M'
  4106          LDB  R#,=40           ! SPACE
  4107          PUBD R#,+R12          ! push SPACE
  4108          ICB  R30              ! set ROM flag
  4109          JSB  =GCHAR           ! get next char
  4110          JSB  =PRGNUM          ! get address
  4111          TSB  R23              ! get something?
  4112          JZR  PABSER           ! jif no
  4113          TSB  R22              ! digits > 7 ?
  4114          JZR  ARTN88           ! jif no
  4115 PABSER   JSB  =ERREXP
  4116 ARTN88   RTN
  4117 !
  4118 ABSNOR   CMB  R#,=61           ! '1' ?
  4119          JNZ  ABSNO1           ! jif no
  4120          PUBD R#,+R12          ! push it
  4121          JSB  =GCHAR           ! get next char
  4122          CMB  R#,=66           ! '6' ?
  4123 ABSFIN   JNZ  PABSER           ! jif no
  4124          GTO P#*               ! push it and finish
  4125 !
  4126 ABSNO1   CMB  R#,=63           ! '3' ?
  4127          JNZ  PABSER           ! jif no
  4128          PUBD R#,+R12          ! push it
  4129          JSB  =GCHAR           ! get next char
  4130          CMB  R#,=62           ! '2' ?
  4131          JMP  ABSFIN           ! finish
  4132 !
  4133 PORXR    JSB  =PRGCMA          ! get a register reference and a comma
  4134          JEZ  ERCMA            ! jif failed
  4135 !
  4136 !  else fall through and get the second register reference
  4137 !
  4138 P1REG    JSB  =PR              ! process/push the 'R'
  4139 P1REGN   JSB  =PREG#*          ! see if # or * is there
  4140          JEN  ARTN88           ! jif yes, done
  4141          JSB  =PRGNUM          ! else demand an actual register number
  4142          TSB  R#               ! get digits <'7'?
  4143          JNZ  ADERR            ! jif no
  4144          CMB  R23,=3           ! too many digits?
  4145          JCY  ADERR            ! jif yes
  4146          TSB  R23              ! get ANY digits?
  4147          JZR  ADERR            ! jif no
  4148          CMB  R23,=1           ! just one digit?
  4149          JNZ  ARTN88           ! jif no
  4150          POBD R23,-R12         ! get last char
  4151          PUBD R23,+R12         ! put it back
  4152          CMB  R23,=61          ! '1'?  (Direct reference to R1 illegal)
  4153          JNZ  ARTN88           ! jif no
  4154 ADERR    JSB  =AROMER          ! set Assembler ROM error
  4155          JSB  =ERROR           ! report the error
  4156          BYT  14               ! ARP-DRP
  4157          RTN
  4158 !
  4159 PLDST    JSB  =P_IORD          ! see if I or D follows the 3-char opcode
  4160          JEN  PID              ! jif yes
  4161 PIMMED   JSB  =PRGCMA          ! else immediate, get register and comma
  4162          JEZ  ERCMA            ! jif no comma
  4163          JSB  =PTRYEQ          ! parse '=' if there
  4164          JEZ  P1REG            ! jif not, get a register ref
  4165          JSB  =DIGIT           ! is a digit next?
  4166          JEZ  PLBREF           ! jif no
  4167 PNXTO    JSB  =PRGNUM          ! get immediate arg value
  4168          CMB  R23,=4           ! > three digits? (more than a byte?)
  4169          JCY  OPERER           ! jif yes, operand error
  4170          TSB  R23              ! no digits?
  4171          JZR  OPERER           ! jif no, operand error
  4172          JSB  =TSTCMA          ! is there a comma (list of operands)
  4173          JEN  PNXTO            ! jif yes, get next operand
  4174 ARTN86   RTN
  4175 !
  4176 BSZORG   JSB  =PRGNUM          ! get number
  4177          JNZ  ARTN86           ! jif got it
  4178 OPERER   JSB  =AROMER          ! set ASM ROM# into ERROM#
  4179          JSB  =ERROR
  4180          BYT  15               ! OPER error
  4181          RTN
  4182 !
  4183 PID      JSB  =PRGCMA          ! get register and comma
  4184          JEZ  ERCMA            ! jif failed
  4185          JSB  =PTRYEQ          ! '=' ?
  4186          JEN  PLBREF           ! jif yes, get the label
  4187          JSB  =PX              ! 'X' ?
  4188 P1RJEZ   JEZ  P1REG            ! jif no
  4189 PCMALB   JSB  =TSTCMA          ! get comma
  4190          JEN  PLBREF           ! jif yes, get label
  4191 !
  4192 ERCMA    JSB  =ERROR
  4193          BYT  123              ! "," MISSING
  4194          RTN
  4195 !
  4196 ! parse CM, AD, SB, AN
  4197 PADSB    JSB  =CHK_D           ! 'D' ? (direct addressing?)
  4198          JEZ  PIMMED           ! jif no, do immediate mode
  4199          JSB  =PRGCMA          ! else get the register and comma
  4200          JEZ  LBLERR           ! jif no comma
  4201          JSB  =PTRYEQ          ! see if =
  4202          JEZ  P1RJEZ           ! jif no, do register
  4203 PLBREF   CMB  R20,=15          ! CR next?
  4204          JZR  LBLERR           ! jif yes, expected a label
  4205          JSB  =NOBNG           ! get the label
  4206          RTN
  4207 !
  4208 LBLERR   JSB  =AROMER          ! set Assembler ROM as error source
  4209          JSB  =ERROR           ! report error
  4210          BYT  12               ! LBL
  4211          RTN                   ! done
  4212 !
  4213 ! parse PU and PO
  4214 PPUPO    JSB  =P_IORD          ! see if 'I' or 'D'
  4215          JEZ  ERREXP           ! jif no, PU/PO is direct or indirect
  4216          JSB  =PRGCMA          ! get register reference and comma
  4217          JEZ  ERCMA            ! jif no comma
  4218          CMB  R#,=53           ! '+' ?
  4219          JZR  PUSHID           ! jif yes
  4220          CMB  R#,=55           ! '-' ?
  4221          JZR  PUSHID           ! jif yes
  4222 !
  4223 ERREXP   JSB  =ERROR           ! report error
  4224          BYT  121              ! Bad exression
  4225          RTN
  4226 !
  4227 PUSHID   JSB  =P#*             ! push the I or D and GCHAR
  4228          CLE                   ! clear E so P1RJEZ will jmp
  4229          JMP  P1RJEZ           ! go get the second register reference
  4230 !
  4231 PJSB     JSB  =PTRYEQ          ! '=' ?
  4232          JEN  PLBREF           ! jif yes, get label
  4233          JSB  =PX              ! try to get index ('X' register)
  4234          JEN  PCMALB           ! jif found, get comma and label
  4235 OEJMP    JMP  OPERER           ! else operand error
  4236 !
  4237 TSTCMA   CMB  R20,=54          ! comma?
  4238          JMP  PTST             ! go push and/or set flags
  4239 !
  4240 PTRYEQ   CMB  R20,=75          ! '=' ?
  4241          JMP  PTST             ! test and push
  4242 !
  4243 P_IORD   CLE                   ! clear successful flag
  4244          CMB  R20,=111         ! 'I' ?
  4245          JZR  P#*              ! jif yes
  4246 CHK_D    CMB  R20,=104         ! 'D'?
  4247          JMP  PTST             ! finish test
  4248 !
  4249 ! Parse the 'R' of a REGISTER reference
  4250 PR       LDB  R21,=122         ! load an 'R' character
  4251          PUBD R21,+R12         ! push it
  4252          CMB  R21,R20          ! did they TYPE the 'R' character?
  4253          JNZ  ARTN87           ! jif no
  4254          JSB  =GCHAR           ! else toss it and get the next char
  4255 ARTN87   RTN
  4256 !
  4257 PX       CLE                   ! preclear to failure
  4258          CMB  R20,=130         ! 'X' ?
  4259          JNZ  ARTN87           ! jif no, failed
  4260          PUBD R20,+R12         ! push X
  4261          JSB  =GCHAR           ! get next char
  4262          JSB  =P1REGN          ! get the register number
  4263          ICE
  4264          RTN
  4265 !
  4266 PDADEQ   TSB  R41              ! was there a label on this line?
  4267          JZR  LBLERR           ! jif no, need one for a DAD or EQU
  4268          JSB  =PRGNUM          ! get the address or value
  4269          JZR  OEJMP            ! jif not found, op error
  4270          RTN
  4271 !
  4272 ! Parse the '#' or '*' in a REGISTER reference
  4273 PREG#*   CLE                   ! clear success flag
  4274          CMB  R20,=43          ! '#' character?
  4275          JNZ  P*?              ! jif no
  4276 P#*      PUBD R20,+R12         ! else push it out
  4277          JSB  =GCHAR           ! get the next char
  4278          ICE                   ! flag success
  4279          RTN
  4280 !
  4281 P*?      CMB  R#,=52           ! '*' character?
  4282 PTST     CLE                   ! clear successful flag
  4283          JZR  P#*              ! jif yes
  4284          RTN
  4285 !
  4286 TSTSIZ   CMB  R23,=3           ! too many digits?
  4287          JCY  OEJMP            ! jif yes
  4288 TSTDIG   TSM  R22              ! did we get at least ONE digit?
  4289          RTN
  4290 !
  4291 REGDON   JSB  =CHK_D           ! see if 'D' after number
  4292          JEN  TSTDIG           ! jif yes, see if any register numbers
  4293          JSB  =TST_C           ! else see if 'C' after num
  4294          JEN  TSTSIZ           ! jif yes, see if too many digits
  4295          TSB  R22              ! get digits >7 ?
  4296          JZR  TSTDIG           ! jif no, make sure we got SOME digit
  4297 OEJMP2   JMP  OEJMP            ! no C, no D, digit>7 = OPER error
  4298 !
  4299 PRGNUM   DCM  R10              ! put the last char back
  4300          CLM  R22              ! clear flags
  4301 PGETDG   JSB  =GCDIG           ! get next char, then try for a digit
  4302          JEZ  REGDON           ! jif no number
  4303          PUBD R20,+R12         ! else push it out
  4304          CMB  R20,=70          ! < '8' ?
  4305          JNC  PDIGOK           ! jif less
  4306          ICB  R22              ! increment count of digits > 7
  4307 PDIGOK   ICB  R23              ! increment count of digits seen
  4308          JMP  PGETDG           ! try for a second one
  4309 !
  4310 TST_C    CMB  R20,=103         ! 'C' ?
  4311          JMP  PTST
  4312 !
  4313 PASPQU   CMB  R20,=42          ! '"' ?
  4314          JNZ  OEJMP2           ! jif no, operand error
  4315          PUMD R12,+R6          ! save r12 output
  4316          JSB  =PSHSTR          ! push everything from here to EOL
  4317 FENDQU   DCM  R10              ! put EOL back
  4318          POBD R20,-R12         ! pop char from output
  4319          CMB  R20,=42          ! '"' ? (find end/closing quote)
  4320          JNZ  FENDQU           ! jif no
  4321          POMD R22,-R6          ! recover starting R12 ptr
  4322          CMM  R22,R12          ! different quote?
  4323          JZR  OEJMP2           ! jif no, operand error
  4324          JMP  P#*              ! else finish up
  4325 !
  4326 PASP     JSB  =PRGNUM          ! see if # for len of unquoted string
  4327          JZR  PASPQU           ! jif no
  4328          CMB  R20,=54          ! comma?
  4329          JZR  PSHST-           ! jif yes
  4330          GTO ERCMA             ! else error, comma expected
  4331 !
  4332 PSHSTR   CMB  R20,=15          ! CR?
  4333          JZR  ARTN85           ! jif yes, eol
  4334 PSHST-   PUBD R#,+R12          ! push out char
  4335          POBD R#,+R10          ! get next char
  4336          JMP  PSHSTR           ! do rest of line
  4337 !
  4338 PGLO     CMB  R20,=15          ! CR?
  4339          JZR  ARTN84           ! jif yes, declaring this a GLOBAL file
  4340 PLNK     LDB  R20,=377         ! label marker? (for file name)
  4341          PUBD R20,+R12         ! push out
  4342          LDM  R56,R12
  4343          DCM  R10              ! put fetched char back
  4344          STM  R10,R46          ! copy input ptr
  4345          STM  R10,R66          ! and again
  4346 GLOEOL   POBD R76,+R#          ! get byte from copy of input ptr
  4347          CMB  R76,=15          ! CR?
  4348          JNZ  GLOEOL           ! jif no, find EOL
  4349          DCM  R66              ! put the CR back
  4350          ICB  R76              ! turns the 15 CR into 16 EOL token
  4351          STBD R76,R#           ! put it on the end
  4352          JSB  =GFNAME          ! get the filename
  4353          STM  R56,R12          ! update output ptr to end of filename
  4354          DCM  R76              ! change the EOL token back to a CR
  4355          STBD R76,R66          !    in the input buffer
  4356 GLOTOS   POBD R20,+R10         ! get the next char
  4357          CMB  R20,=15          ! CR?
  4358          JNZ  GLOTOS           ! jif no, throw everything else away
  4359 ARTN84   RTN
  4360 !
  4361 PRGCMA   JSB  =P1REG           ! get a register reference
  4362          JSB  =TSTCMA          ! get comma
  4363 ARTN85   RTN
  4364 !
  4365 !        BSZ  12               ! unused bytes at ROM's end
  4366 !
  4367 !        BYT  113,304,155,143  ! ROM checksums
  4368          FIN
