         ABS 0
CLOSE    EQU 51
THIRT2   EQU 32
THIRT4   EQU 34
THIRT6   EQU 36
LETTOK   EQU 142
EQUALS   EQU 65
LBRACK   EQU 336
RBRAKT   EQU 337
THENTO   EQU 314
JPSTOK   EQU 33
FNSYM    EQU 241
ELSTOK   EQU 327
JMPTOK   EQU 34
COMMA    EQU 54
BLANK    EQU 40

!
         DEF  START            ! CPU reset (power on) vector
         DEF  SPAR0            ! SPARE INTERRUPT VECTOR
         DEF  KEYSRV           ! KEYBOARD INTERRUPT VECTOR
         DEF  SPAR0            ! SPARE INTERRUPT VECTOR
         DEF  CLKSR0           ! REAL TIME CLOCK 0
         DEF  CLKSR1           ! REAL TIME CLOCK 1
         DEF  CLKSR2           ! REAL TIME CLOCK 2
         DEF  CLKSR3           ! REAL TIME CLOCK 3
         DEF  IRQ20            ! I-O INTERRUPT VECTOR
         DEF  SPAR1            ! FIRST SPARE
         DEF  SPAR1            ! SECOND SPARE
!
! CONTROL WILL BE VECTORED THRU LOCATION 0 WHENEVER CAPRICORN IS PUT IN RUN MODE.
! CONTROL WILL BE VECTORED THRU LOCATIONS 2,4,6,10,12,14,16,20,22,24 AT VARIOUS INTERRUPTS.
!
! CPU RESET (POWER-ON) ENTRY POINT
START    LDM  R6,=STACK        ! initialize stack ptr
         BIN                   ! for comparisons
         STBD R36,=GINTDS      ! disable interrupts
         LDM  R36,=340,37      ! get test ROM number
         STBD R36,=RSELEC      ! select TEST ROM
         CMMD R36,=R60K        ! is TEST ROM there?
         JNZ  START1           ! jif no, START1
         STBD R36,=ROMFL       ! 340 for TEST ROM
         LDMD R36,=R60+14      ! get TEST init address
         JSB  X36,ZRO          ! go there
START1   JSB  =SYSINI          ! Initialize system
! ------------ EXEC LOOP ------------------------------
! -- Description of XCOM and CSTAT                   --
! --  R17 = XCOM (why interpreter halted)            --
! --       (XCOM is examined bit by bit)             --
! --      BIT 7  Break (=bit 6 + bit 5)              --
! --      BIT 6  Error set                           --
! --      BIT 5  Immediate set                       --
! --      BIT 4  Service request                     --
! --      BIT 3  Trace                               --
! --      BIT 2  Step (only useful in INTERP)        --
! --      BIT 1  Input complete                      --
! --      BIT 0  End of calc mode (INTERP)           --
! -----------------------------------------------------
! --  R16 = CSTAT   Capricorn STATus                 --
! --     (CSTAT is examined as a whole byte,         --
! --       it can only be 0-7 octal)                 --
! --   CSTAT = 0  Idle                               --
! --           1  Calculator mode                    --
! --           2  Run mode                           --
! --           3  Live keyboard calc mode (NOT USED) --
! --           4  Idle in input statement            --
! --           5  Calc for input statement           --
! --           6  Live keyboard GOSUB (NOT USED)     --
! --           7  FUN in middle of line              --
! -----------------------------------------------------
DOCUR.   JSB  =CURS            ! spit out cursor
! THE EXEC IS THE MAIN IDLE LOOP WHERE THE CPU CIRCLES, WAITING TO DO SOMETHING
EXEC     BIN                   ! for shifts, increments
         JSB  =RMIDLE          ! let ROMs intercept
         TSB  R17              ! XCOM all zeroes?
         JZR  EXECC            ! jif yes
         JSB  =XCBITS          ! Check XCOM bits
! After checking XCOM, check CSTAT
EXECC    TSB  R16              ! Check CSTAT
         JZR  EXEC             ! jif idle
         JOD  CALCRU           ! jif CALC mode
         CMB  R16,=4           ! idle in input?
         JZR  EXEC             ! jif yes
! Run a program with CSTAT = 2 or 6
RUNRUN   JSB  =INTERP          ! call interpreter
INTJM1   LDMD R32,=LAVAIL      ! save LAVAIL and
         STMD R32,=CALVRB      !   clobber CALC variables
INTJMP   CMB  R16,=2           ! skip this if RUN mode
         JZR  EXEC             !
         JSB  =SPITCR          ! force line of CR's
         JMP  EXEC             !
! Interpret a CALC mode statement or resume RUN mode in mid-statement
CALCRU   CMB  R16,=7           ! RUN mode in mid-stmt?
         JNZ  CALCR1           ! jif no
         LDB  R16,=2           !
         JSB  =INTERC          ! call CALC mode interpreter
         JMP  INTJM1           !
CALCR1   JSB  =RELMEM          ! do this before alloc
         JSB  =ALLOC           !
         LDB  R15,=1           !
         ORB  R17,R15          ! set END CALC mode
         JEZ  CALCR2           !
         LDMD R12,=STSIZE      ! reset BASIC stack ptr
         JMP  EXEC             !
CALCR2   LDMD R10,=STSIZE      ! load Basic pgm counter with start of CALC statement
CALINC   JSB  =INTERC          ! call CALC interpreter
         CMB  R16,=5           ! EXEC in input?
         JNZ  CALINR           ! jif no
         TSB  R17              ! compl?
         JEV  CALINR           ! jif no
         LDB  R16,=2           ! set RUN mode
         LDMD R34,=INPCOM      ! get compile address
         JSB  X34,ZRO          ! go finish up
         ANM  R17,=376         ! clear END OF CALC
         JMP  INTJM1           ! go update CALVRB
CALINR   ANM  R17,=376         ! clear end of CALC
         JMP  INTJMP           ! back to EXEC
! XCOM #0, WHAT BITS ARE SET?
XCBITS   BIN                   ! XCOM # 0, what bits are set?
         LDB  R37,R17          ! get destructible copy
         LLB  R37              ! thrown away break bit
! Bit 7 is duplicated in bit 6 or bit 5
         LLB  R37              ! get error bit to CY
         JCY  ERRPT            ! jif error set
         ANM  R17,=37          ! clear errors
! These are of no value in EXEC and must be cleared
         LLB  R37              ! skip bit 5 - IMMEDIATE
         LLB  R37              ! check bit 4 - SVCREQ
         JNC  XCBIT3           ! JIF not set
! Before calling SVCGRA, see if calc mode pending
         TSB  R16              ! CALC mode pending
         JEV  SVCGRA           ! JIF NO
XCBIT3   LLB  R37              ! skip bit 3 - TRACE
         LLB  R37              ! skip bit 2 - STEP
         LLB  R37              ! Check bit 1 - INPUT COMPLETE
         JNC  XCBIT0           ! JIF not set
         LDB  R16,=7           ! Middle of line
         ANM  R17,=375         ! clear input complete
XCBIT0   RTN                   ! DONE
! PROCESS AN ERROR
ERRPT    TSB  R16              ! Process an error
         JEV  CALRPR           ! JIF PGM
         JSB  =STOTOS          ! Clean R12 stack
CALRPR   JSB  =REPORT          ! SEND ERROR MESSAGE
         CMB  R16,=7           ! ON ERROR?
         JZR  EXECRN           ! YES SO DON'T CHANGE ANYTHING
         LDB  R32,=13          !
         STBD R32,=ROMFL       ! STOPPING WITH ERROR
         JSB  =ROMINI          ! TELL EVERYONE
! THE ABOVE USED FOR ON ERROR
ERRDUN   ANM  R16,=0,20        ! CLEAR ALL BUT SVCREQ
         RTN                   ! BACK TO EXEC
STOTOS   LDMD R12,=STSIZE      ! RE-INIT BASIC STACK
         STMD R12,=TOS         ! AND TOP OF STACK
         RTN                   ! DONE
! FOR NOW ONLY RESPOND TO KEYBOARD
SVCGRA   LDBD R32,=SVCWRD      ! WHO INTERRUPTED?
         JEV  IO?              ! LSB=0, CHECK I-0
         JSB  =CHEDIT          ! CALL CHAR EDITOR
! JEZ TO SVCGRA WILL CONTINUE EXECUTING KEY IF LEANING ON KEY
         JEZ  SVCGRA           !
         JSB  =EOJ2            ! NO REPEAT CR'S
         LDM  R26,=INPBUF      !
         STMD R26,=INPTR       ! SET FOR GRAPHICS INPUT
         LDBD R36,=PRALLM      ! PRINT ALL ON?
         JZR  PROFF2           ! 0 IS NO
         LDM  R36,R56          ! COMPUTER COUNT
         SBM  R36,R26          !
         JSB  =PRDVR1          ! CALL DRIVER
! ******************************************************
! LINE FROM EDITOR IS COMPLETE.
! IF R16=4, THIS IS A COMPLETED INPUT.
! OTHERWISE IT IS A COMMAND OR PROGRAM LINE, SO PARSE IT
! ******************************************************
PROFF2   CMB  R16,=4           ! INPUT COMPLETE?
         JNZ  LINPRS           ! JIF NO
         LDB  R36,=2           ! INPUT COMPLETE BIT
         ORB  R17,R36          ! IN R17
         LDMD R12,=TOS         ! RESET R12
         LDMD R10,=INPR10      ! RESTORE R10
         CLE                   ! CLEAR END OF LINE
         RTN                   ! BACK TO EXEC
!
LINPRS   PUMD R56,+R6          ! SAVE END OF LINE
         JSB  =PARSER          ! PARSE THE STATEMENT
         POMD R26,-R6          ! RESTORE END OF LINE
! R26 IS PRESERVED FOR REPORP
         CMB  R17,=300         ! ANY PARSE ERRORS?
         JNC  EXECRN           ! JIF NO, RTN TO EXECC
! REPORT PARSE ERRORS
         TSB  R16              !
         JEV  CALRPP           !
         LDMD R12,=STSIZE      ! FIX R12 (CALC ONLY?)
CALRPP   JSB  =REPORP          ! REPORT ERROR
         JMP  ERRDUN           ! CLR R16, RETURN
!
IO?      LRB  R#               ! SHIFT FOR I-O CHECK
         JEV  CLKHIT           ! IF EVEN, CHECK CLOCKS
         JSB  =IOSP            ! I-O SERVICE POINTER
EXECRN   RTN                   ! IOSP WILL RESET BITS
CLKHIT   LRB  R#               ! CLOCKS ACTIVE?
         JEV  CLOCK2           ! TO CLOCK2 IF EVEN
         JSB  =ONCLK1          ! DO CLOCK SERVICE
         LDB  R32,=373         !
         JMP  CLRBIT           ! CLEAR CLOCK BIT
CLOCK2   LRB  R#               ! CLOCK 2 BIT IN LSB
         JEV  CLOCK3           ! CHECK CLOCK3
         JSB  =ONCLK2          !
         LDB  R32,=367         !
         JMP  CLRBIT           !
CLOCK3   LRB  R#               ! ISOLATE CLOCK 3 BIT
         JEV  UDDER            !
         JSB  =ONCLK3          !
         LDB  R32,=357         !
CLRBIT   STBD R33,=GINTDS      ! DISABLE INTERRUPTS
         LDBD R33,=SVCWRD      !
         ANM  R33,R32          !
         STBD R33,=SVCWRD      !
         JNZ  NCLR17           !
         ANM  R17,=357         ! CLEAR BIT IN R17
NCLR17   STBD R#,=GINTEN       ! GLOBAL ENABLE
         RTN                   !
UDDER    LRB  R#               !
         JEV  EXECRN           !
         JSB  =SPAR0           !
         RTN                   !
! ---SVCWRD ORGANIZATION ----------------------
!     BIT 0 = KEYBOARD INTERRUPT
!     BIT 1 = I/O INTERRUPT
!     BIT 2 = TIMER 1 INTERRUPT
!     BIT 3 = TIMER 2 INTERRUPT
!     BIT 4 = TIMER 3 INTERRUPT
!     BIT 5 = "OTHER"
!
! ***************************************************
! * INTERPRETER 11-11-76
! ***************************************************
! RUNTIME OUTER LOOP
INTERP   LDMD R10,=PCR         ! set address of program
SAVPCR   STMD R#,=PCR          ! new PCR, for skpd lines
         BIN                   ! ADD NEEDS BINARY
         ADM  R10,=3,0         ! SKIP LINE NUMBER
INTERC   STMD R12,=TOS         ! SAVE TOS
         LDMD R34,=FWCURR      ! RELEASE TEMP MEMORY
         LDMD R56,X34,P.RMEM   !
         JZR  INTERL           ! JIF NONE TO RELEASE
         JSB  =RLMEM-          ! ELSE GO RELEASE IT
! *************** RUNTIME INNER LOOP **********************
INTERL   BIN                   ! BREAK AT 55
         CLM  R20              ! TO BE SAFE
         POBD R20,+R10         ! FETCH NEXT INSTRUCTION (TOKEN)
         LLM  R20              ! double it for indexing
         BCD                   ! math runtime routines assume BCD at entry
         LDMD R20,X20,BTAB.R   ! get address for token
         JSB  X20,ZRO          ! call the runtime routine to execute token
         TSB  R17              ! XCOM bit 7 (break) set?
         JPS  INTERL           ! jif no, keep going, do next token
         RTN                   ! BACK TO EXEC
! *************** END OF RUNTIME INNER LOOP ***************
!
! =========================================================
! RUNTIME ROUTINE FOR EOL (TOKEN 16)
! =========================================================
         BYT  0                ! EOL TOKEN 16 ATTRIBUTES
GORTN    POMD R36,-R6          ! trash return address to interpreter
EXIT1    TSB  R17              ! XCOM clear?
         DRP  R10              ! (FOR SAVPCR)
         JZR  SAVPCR           ! JIF yes, go to next line
         JNG  INTRTN           ! JIF ERROR OR IMMEDIATE
         TSB  R16              ! check CSTAT
         JOD  CALXIT           ! jif CALC mode, exit
! dO WE REALLY WANT TO EXIT? SEE BELOW
         STMD R10,=PCR         ! save PC (MIGHT NOT GET DONE)
         CMB  R17,=20          ! check SVCREQ, IMMEDIATE, and ERROR
         JCY  INTRTN           ! bail out if any of them set
! NO HIGHER ORDER BITS SHOULD BE SET NOW BECAUSE BIT 7 CATCHES BITS 6 AND 5
         CMB  R17,=10          ! tracing?
         JNC  BIT012           ! jif no
         JSB  =TRA?            ! Do TRACE
! THE TRACE BIT CAN STAY SET
BIT012   LDB  R37,R17          ! check bits 0,1,2
         ANM  R37,=7           ! DON'T KILL BIT 4
         JZR  INTERP           ! jif no STOP,END,STEP
         ANM  R17,=370         ! clear bits 0,1,2
         CMB  R37,=4           ! bit 2 set?
         JNC  STPLP-           ! jif not STEP
         JSB  =RELMEM          ! free temp memory
         LDMD R32,=LAVAIL      !
         STMD R32,=CALVRB      ! update CALVRB
         JMP  STPLP            !
STPLP-   TSB  R37              ! INPUT COMPLETE?
         JEV  INTRTN           ! jif yes
STPLP    CLB  R16              ! STOP, END, PAUSE
         JMP  INTRTN           !
CALXIT   CMB  R16,=5           ! ENTER in INPUT?
         JZR  INTRT1           !
         ANM  R16,=0,376       ! change CSTAT and end CALC flag
         JSB  =DISPIT          ! display TOS
INTRTN   JSB  =RELMEM          ! release temp mem
INTRT1   RTN                   ! done
! =========================================================
! RUNTIME ROUTINE FOR 'RUN' STATEMENT
! =========================================================
         BYT  141              ! attribute
RUN.     LDB  R16,=2           ! start BASIC programming running
         JSB  =ON?I            ! RUN WITH PARAMETER?
         LDM  R32,R45          ! MOVE BCD TWO BYTES
INITR.   STMD R#,=FLDCOM       ! SAVE AWAY
         JSB  =ST240-          ! SET IMMED
         CLM  R42              ! CLEAR 8 BYTES
         STBD R42,=CONTOK      ! SET CONTINUE LEGAL FLAG
         STMD R42,=AUTO#       ! CLEAR AUTO#,AUTOI,ERGOTO
         JSB  =INIPGM          ! LENGTH, LINE 10000
         JSB  =ALLOC           !
         JEN  STOP.+           ! JIF ALLOCATION ERROR
         JSB  =INIVAR          ! INITIALIZE VARIABLES
         LDMD R36,=FWUSER      ! FWA COMMON
         LDMD R32,=FWPRGM      ! LWA+1 COMM
         STMD R32,=FWCURR      ! RESET FWCURR
         CMM  R32,R36          ! COMM?
         JZR  INITR1           ! JIF NO
         JSB  =INIVLP          ! GO INITIALIZE COMMON
INITR1   LDB  R36,=4           !
         STBD R36,=ROMFL       ! SET ROM FLAG
         JSB  =RSETG+          ! INIT CALC VRB/RTN STACK AND ROMINI
! R40 = 0 FROM RSETGO
! R36 = FWCURR
         STMD R44,=DISPTR      ! DISP AND PRINT POINTER
         JSB  =CUROPT          ! OPTION BASE
         LDMD R76,=FLDCOM      ! GET START ADDR
         JSB  =FNDLIN          ! GET LINE# TO 36
         STMD R36,=PCR         ! STORE IN PCR
         STMD R36,=OLDPCR      ! AND OLDPCR
         JSB  =LIST1P          ! RE-INIT LIST PARAMS
         CLE                   ! FOR INIT KEY
         RTN                   ! EXIT
! =========================================================
! RUNTIME ROUTINE FOR 'INIT' STATEMENT
! =========================================================
         DRP  R41              ! ATTRIBUTES
INIT.    ANM  R16,=0,30        ! DON'T CLEAR SVC OR TRACE
         CLM  R32              ! SET FLDCOM
         JMP  INITR.           ! DO REST OF INIT
!
STOP.+   LDB  R16,=1           ! MAKE IT CALC
         JMP  STOP2            ! AND DON'T RESET PCR
! =========================================================
! RUNTIME ROUTINE FOR 'STOP' STATEMENT
! =========================================================
         BYT  241              ! ATTRIBUTES
STOP.    BIN                   ! FOR THE ADD
         LDMD R36,=FWCURR      ! RESET PROGRAM
         ADM  R36,=30,0        ! ADD OFFSET FOR START
         STMD R36,=PCR         ! SET PCR TO START OF PGM
STOP2    LDB  R15,=240         ! SET IMMED SO PCR WON'T GET CLOBBERED
         JMP  PAUS1            !
PAUS.+   TSB  R16              ! ALREADY IN IDLE?
         JZR  PAURTN           ! JIF YES
         JSB  =STBEEP          ! MAKE SOME NOISE
         CLB  R15              ! DON'T SET END CALC
         JMP  PAUS1            !
! =========================================================
! RUNTIME ROUTINE FOR 'PAUSE' STATEMENT
! =========================================================
         BYT  241              ! ATTRIBUTES
PAUSE.   LDB  R15,=1           ! ASSUME RUN MODE
PAUS1    TSB  R16              !
         JEV  STOP1            ! JIF NOT CALC
         JSB  =STOTOS          ! TOS ::= STSIZE
         LDB  R15,=240         ! DON'T EXECUTE EOL
STOP1    ORB  R17,R15          ! OR IN R15 BITS
         JSB  =SAVREG          ! FOR CHEDIT
         JEN  ARGHH            !
         LDB  R36,=6           ! ROMINI #6
         STBD R36,=ROMFL       !
         JSB  =ROMINI          ! TELL THE ROMS
! THAT IS THE ROM HOOK FOR STOP, PAUSE
! ROM MUST ASK IF THERE WERE ERRORS TO
! DISTINGUISH FROM ABORTED 'RUN'
         JSB  =BUFDMP          ! DUMP ASSIGN BUFFS
         JSB  =SPITCR          ! FORCE LINE OF CR'S
         JSB  =RSTREG          ! RESTORE REG'S
ARGHH    ANM  R16,=0,373       ! IDLE, KILL STEP
PAURTN   CLE                   ! FOR CHEDIT
         RTN                   !
!
SPITCR   LDBD R0,=CRTWRS       ! SKIP THIS CRAP IF GRAPH
         JNG  SPITEX           !
         LDMD R0,=CRTBYT       ! CHECK FOR UPPER LEFT
         CMMD R0,=CRTRAM       !
         JZR  DOCURS           ! JIF YES
         ANM  R0,=77,0         ! AT LEFT SIDE SCREEN?
         JNZ  DOCURS           ! JIF NO, DON'T FIDDLE
         JSB  =LTCUR.          ! CHECK CHAR TO LEFT
         JSB  =INCHR           ! FETCH IT
         JSB  =RTCUR.          ! RESTORE POSITION
         CMB  R32,=15          ! IS IT CR?
         JZR  DOCURS           ! JIF YES
         JSB  =BLK&SC          ! BLKLIN, CHECK SCROLL
DOCURS   JSB  =CURS            ! OUTPUT CURSOR
SPITEX   RTN                   !
! =========================================================
! RUNTIME ROUTINE FOR 'CONT' STATEMENT
! =========================================================
         DRP  R41              ! ATTRIBUTES
CONTI.   JSB  =SET240          ! SET IMMEDIATE FLAG
         LDB  R16,=2           ! SET RUN MODE
         JSB  =ON?I            ! GET SEQ NO, IF ANY
         JEZ  STEPIT           ! USE OLD PCR IF NO
         LDM  R76,R45          ! MOVE FOR FNDLIN
         JSB  =FNDLIN          ! GET THAT (OR FIRST) LINE
         STMD R36,=PCR         ! STORE IT
STEPIT   BIN                   !
         LDMD R10,=PCR         ! R10 MUST BE VALID
         ADM  R10,=3,0         ! SKIP LINE# AND LENGTH
         JSB  =STOTOS          ! TOS ::= STSIZE
         LDMD R36,=CALVRB      ! INITIALIZE
         STMD R36,=LAVAIL      ! CALC VARIABLES
         LDBD R36,=CONTOK      ! IS CONTINUE OK?
         JZR  PAURTN           ! JIF YES, DONE
         DCB  R16              ! CHANGE TO CALC MODE
!
ER16     JSB  =ERROR+          ! CONT WITHOUT INIT
         BYT  16D              ! 16D
!
! =========================================================
! RUNTIME ROUTINE FOR 'STEP KEY' STATEMENT
! =========================================================
         BYT  241              ! ATTRIBUTES
STEPK.   LDB  R16,=2           ! SET RUN MODE
         LDB  R36,=4           ! SET XCOM BIT 2 FOR END-STEP
         ORB  R17,R36          !
         JMP  STEPIT           ! JUMP INTO CONTINUE
! DISPLAY TOP OF STACK
DISPIT   BIN                   !
         CMMD R10,=NXTMEM      ! WHAT'S ON TOP OF STACK?
         JNC  NODISP           ! JIF NOT CALC MODE
         LDM  R36,R12          ! size = (R12-NXTMEM)
         SBM  R36,R10          !
         JZR  LDR12            ! JIF nothing there
         CMM  R36,=10,0        ! 8-byte numeric data?
         JZR  DISPN            ! jif yes, PRINT
         CMM  R36,=4,0         ! IS IT AN INTEGER OR STRING?
         JNZ  ER15             ! jif NO
         JSB  =DISP.           ! setup display device
         JSB  =COMMA$          ! print it
         JMP  ENDISP           ! finish up
DISPN    LDMD R40,R10          ! load value from stack
         STMD R40,=RESULT      ! and save in RESULT
         JSB  =DISP.           ! setup display device
         JSB  =COMMA.          ! print it
ENDISP   JSB  =PRLINE          ! end print line
LDR12    LDMD R12,=STSIZE      ! reset stack ptr
NODISP   RTN                   ! done
!
ER15     JSB  =ERROR+          ! "SYSTEM" garbage on stack
         BYT  15D              ! 15D
!
! TRACE MODE IS SET, CHECK TO SEE IF FLAGS 1 AND 2 ARE SET.
! FLAG 1 IS NONZERO IF A JUMP HAS BEEN TAKEN, AND FLAG 2 IS
! NONZERO IF A VARIABLE HAD BEEN CHANGED.
!
TRA?     LDMD R76,=TRCFL1      ! GET FLAG
         JZR  TRARTN           ! JIF CLEAR
         JSB  =TRCLN           !
         LDM  R45,=164,157,40  ! "to "
         PUMD R45,+R30         ! PUSH TO OUTPUT BUFFER
         LDMD R36,R10          ! GET 'TO' LINE#
         STMD R10,=OLDPCR      ! UPDATE OLDPCR
         JSB  =DCLIN#          ! DECOMPILE THE LINE# TO OUTPUT
         JSB  =OUTRC           !
         CLB  R36              !
         STBD R36,=TRCFL1      ! CLEAR TRACE
TRARTN   RTN                   !
!
TRCLN    LDM  R30,=LAST+1      ! GET ADR OF PRINT BUFFER
         LDM  R41,=40,124,162,141,143,145,40 ! " Trace "
         PUMD R41,+R30         ! PUSH TO OUTPUT BUFFER
         LDM  R43,=154,151,156,145,40 ! "line "
         PUMD R43,+R30         ! TO OUTPUT
         LDMI R36,=OLDPCR      ! GET OLD LINE NUMBER
         JSB  =DCLIN#          ! DECOMPILE IT TO OUTPUT
TRCLNR   RTN                   !
!
TRCVBL   PUMD R60,+R6          ! SAVE VALUE
         PUBD R46,+R6          ! SAVE ARRAY FLAG
         JSB  =TRCFP           !
         POBD R46,-R6          ! RESTORE ARRAY FLAG
         JPS  NOARRA           ! JIF NOT ARRAY
         LDM  R36,R74          ! ROW
         JSB  =BINCH           ! CONST TO STAK
         DCB  R23              ! MAKE 23 ODD
         TSB  R20              !
         JOD  ONEDIM           ! JIF ONE DIMENSION
         LDM  R36,R76          ! COL
         JSB  =BINCH           ! CONST TO STAK
ONEDIM   BIN                   !
!        CAPASM: here is the global symbol called which is a mix up with a LCL
         JSB  =SUBSCR          !
NOARRA   POMD R50,-R6          ! RESTORE VALUE
         PUMD R50,+R12         ! CONVERT NUMBER
         JSB  =ONER            !   TO REAL
         LDM  R22,=16,4        !
         PUMD R22,+R12         ! PUSH REAL FLAGS
         PUMD R40,+R12         ! PUSH VALUE
         BIN                   !
         JSB  =PU=             ! PUSH AND UNSTAK
TRCLP    POMD R36,-R12         ! TOS
         STMD R36,=TOS         !
OUTRC    LDM  R26,=LAST+1      ! RESET BUFFER ADDR
         SBM  R30,R26          ! GET LENGTH
         STM  R30,R36          ! SET R36 FOR OUTSTR
OUTRC-   LDMD R40,=PS.C.       ! GET PRINTER S.C.
         JSB  =COPSB+          ! SELECT CODE IN 46
         JNZ  OUTRC+           ! JIF NO I/O
         LDB  R#,=4            ! SET INDEX TO PRINTER
OUTRC+   JSB  =DRV12-          !
         RTN                   !
!
TRCFP    CLB  R0               !
         STBD R0,=PRECNT       ! DON'T CONFUSE ANYONE
         PUMD R36,+R6          ! SAVE NAME
         JSB  =SAVOLP          ! OLDPCR ::= PCR
         JSB  =TRCLN           ! TRACE LINE #
         POMD R36,-R6          ! RESTORE NAME
         LDMD R32,=TOS         !
         PUMD R32,+R12         ! SAVE TOS
         STMD R12,=TOS         ! SAVE R12
         LDB  R33,R37          ! FUNC FLAG
         ANM  R33,=40          ! ISOLATE FUNC FLAG
         JZR  TRCFP1           ! JIF NOT FN
         LDM  R32,=106,116     ! FN
         PUMD R32,+R12         ! PUSH IT
         JMP  TRCFP2           ! AND JUMP
!
TRCFP1   LDM  R22,=16,1        !
         PUMD R22,+R12         ! PUSH TOKEN AND NAME
TRCFP2   JSB  =ASCNM1          !
         PUMD R36,+R12         !
         RTN                   !
! =========================================================
! RUNTIME ROUTINE FOR 'TRACE' STATEMENT
! =========================================================
         BYT  241              ! ATTRIBUTES
TRACE.   CLB  R22              ! SET TRACE FLAG
         STBD R22,=TRCFL1      ! STORE IN TRACEFLAG
         LDB  R22,=10          ! SET TRACE FLAG
         ORB  R17,R22          !  FOR SYSTEM
         RTN                   !
! =========================================================
! RUNTIME ROUTINE FOR 'TRACE VAR' STATEMENT
! =========================================================
         BYT  241              ! ATTRIBUTES
TRCVB.   LDB  R57,=100         ! TRACE BIT
TRCVB1   BIN                   !
         LDBD R65,R10          ! NEXT TOKEN
         JSB  =TSTEND          ! CR,@,!
         JEZ  TRCVB2           ! JIF YES
         POMD R65,+R10         ! VRBL TOKEN AND NAME
         JSB  =FETSVA          ! ADDRESS TO 34
         CMM  R12,R34          !
         JNC  ERR89            ! ERROR IF CALC VAR
         ORB  R47,R57          ! SET TRACE
         PUBD R47,-R34         ! PUSH IT BACK
         JMP  TRCVB1           ! LOOP
!
BINCH    JPS  BINCN1           ! JIF NOT A() OR A(,)
         LDM  R24,=LOADAD      ! TEMP LOCATION FOR ZERO LEN STRING
         LDM  R22,=0,6         ! TOKEN AND LEN
         STBD R22,R24          ! SET IT
         JSB  =SCNST           !
         RTN                   !
!
BINCN1   JSB  =CONBIN          ! CONV TO FLOAT
         LDM  R22,=16,4        ! MARKER AND TOKEN
         PUMD R22,+R12         !
         PUMD R40,+R12         ! PUSH VAL
TRCVB2   RTN                   !
!
ERR89    JSB  =ERROR+          !
         BYT  89D              ! 89D
!
! =========================================================
! RUNTIME ROUTINE FOR 'TRACE ALL' STATEMENT
! =========================================================
         BYT  241              ! ATTRIBUTES
TRCAL.   JSB  =TRACE.          ! SET SYSTEM FLAGS
         TSB  R16              !
         JEV  TRCAL1           ! JIF RUN
         CLB  R16              ! SET PROG
         JSB  =INIPGM          ! INITIALIZE PROGRAM
         JSB  =ALLOC           ! GO ALLOC
         JSB  =ST240-          ! SET IMMEDIATE FLAG
TRCAL1   LDB  R22,=100         ! TRACE VRBL BIT
         STBD R22,=TRCFL2      ! SET TRACE ALL FLAG
         JMP  TRVRBL           ! SET ALL BITS
! =========================================================
! RUNTIME ROUTINE FOR 'NORMAL' STATEMENT
! =========================================================
         BYT  241              ! ATTRIBUTES
NORMA.   CLM  R22              ! CLEAR VARIABLE BIT
         STBD R22,=PRALLM      ! CLEAR PRINT ALL MODE
! ENTER HERE FROM RESET
NORMA-   CLM  R22              !
         STMD R22,=TRCFL1      ! CLEAR TRACE FLAGS
         ANM  R17,=367         ! CLEAR SYSTEM FLAG
TRVRBL   BIN                   ! ENTRY FROM TRACE ALL
         LDMD R24,=FWCURR      ! FWA PRGM
         LDBD R26,X24,P.TYPE   ! ALLOC BIT
         ANM  R26,=40,0        ! ISOLATE IT
         JZR  NORMEX           ! EXIT IF NOT ALLOC
         LDMD R26,X24,P.LEN    ! PRGM LEN
         ADM  R26,R24          ! FWA VAR
         POMD R30,+R26         ! LEN VAR
         ADM  R30,R26          ! LWA VAR +2
         DCM  R30              !
         DCM  R30              !
         LDM  R32,R26          ! CURRENT POINTER
NORMLP   CMM  R32,R30          ! DONE?
         JCY  NORMEX           ! JIF YES
         POMD R66,+R32         ! NAME
         ANM  R67,=277         ! CLEAR TRACE
         ORB  R67,R22          ! SET IT IF R22 = 100
         JPS  NORML1           ! JIF NOT REMOTE
         LDMD R2,R32           ! REMOTE ADDR
         POBD R77,-R2          ! REMOTE NAME
         ANM  R77,=277         ! CLEAR TRACE
         ORB  R77,R22          ! SET IF R22=100
         PUBD R77,+R2          ! STORE IT BACK
NORML1   PUMD R66,-R32         ! STORE IT BACK
         JSB  =SKPVR           ! GET NEXT VARIABLE
         JMP  NORMLP           ! LOOP
NORMEX   RTN                   ! DONE
SETTR1   LDB  R36,=377         ! SET FLAG TO 1 (??? set trace for FUNCTION KEY press)
         STBD R36,=TRCFL1      !   AND STORE IN FLAG LOC
SAVOLP   LDMD R36,=PCR         ! SAVE OLD PCR
         STMD R36,=OLDPCR      ! SAVAS "FROM" ADDRESS
         RTN                   !
!
! THESE JUMPS MUST POSITION R10 AT THE LINE NUMBER,
! THEN JUMP TO EXIT1 (PART OF INTERP) IF SUCCESSFUL.
!
! =========================================================
! RUNTIME ROUTINE FOR 'JUMP TRUE' STATEMENT
! =========================================================
         BYT  7                ! ATTRIBUTES
JTRUE#   JSB  =ONEROI          ! GET TOP OF STACK
         TSM  R45              ! CHECK NUMBER
         JEN  JTBOTH           ! JIF INTEGER
         TSM  R40              ! TEST FLOATING
JTBOTH   JNZ  JMPLN#           ! JIF TRUE
         POMD R36,+R10         ! NO, SKIP OVER SEQ#
         RTN                   !
! =========================================================
! RUNTIME ROUTINE FOR 'DEF FN' STATEMENT
! =========================================================
         BYT  312              ! ATTRIBUTES
SKPDEF   BIN                   ! DEF FN
         ICM  R10              ! INC OVER DEF NAME
         ICM  R10              !
         JMP  JMPLN#           ! THEN DO 'GOTO'
! =========================================================
! RUNTIME ROUTINE FOR 'ELSE JUMP#' STATEMENT
! =========================================================
         BYT  25               ! ATTRIBUTES
EJMP#    JMP  JMPLN#           ! ELSE JMP #
! =========================================================
! RUNTIME ROUTINE FOR 'JUMP RELATIVE' STATEMENT
! =========================================================
         BYT  26               ! ATTRIBUTES
JMPREL   BIN                   ! JMP REL
         ADMD R10,R10          ! PCR + OFFSET
         RTN                   !
! =========================================================
! RUNTIME ROUTINE FOR 'GOTO' STATEMENT
! =========================================================
         BYT  210              ! ATTRIBUTES
JMPLN#   CLM  R36              ! GOTO
         STMD R36,=ONFLAG      ! CLEAR ON FLAG
         POMD R36,+R10         ! GET LINE# ADDRESS
         LDMD R10,=FWCURR      !   AS OFFSET INTO FWCURR
         BIN                   !
         ADM  R10,R36          ! POINT TO NEW SEQUENCE
         JSB  =SETTR1          ! SET TRACE "JUMP" FLAG
         STMD R36,=PCR         ! "TO"
         GTO GORTN             ! END THE LINE
! =========================================================
! RUNTIME ROUTINE FOR 'JUMP FALSE' STATEMENT
! =========================================================
         BYT  11               ! ATTRIBUTES
JFALSR   JSB  =ONEROI          ! GET TOP OF STACK
         TSM  R45              ! TEST NUMBER
         JEN  JFBOTH           ! JIF INTEGER
         TSM  R40              !
JFBOTH   JZR  JMPREL           ! JIF FALSE (R40=0)
         POMD R36,+R10         ! WIPE OUT OFFSET
         RTN                   ! DO NO MORE
! =========================================================
! RUNTIME ROUTINE FOR 'GOSUB' STATEMENT
! =========================================================
         BYT  210              ! ATTRIBUTES
JMPSUB   BIN                   ! GOSUB
         LDMD R36,=ONFLAG      ! GET ON FLAG
         JNZ  ONSUB            ! JIF ACTIVE
         LDM  R36,R10          !
         ICM  R36              !
         ICM  R36              ! RETURN ADDRESS
ONSUB    LDMD R30,=PCR         ! FOR LATER
         LDMD R32,=FWCURR      ! BASE ADDRESS
         LDBD R22,X32,P.GCNT   ! GOSUB COUNT
         ICB  R22              !
         JCY  ERGSB            ! GOSUB STAK OVERFLOW
         STBD R22,X32,P.GCNT   !
         LDMD R22,=NXTRTN      ! NEXT RETURN
         CMMD R22,=RTNSTK      ! ROOM?
         JNZ  STKRTN           ! JIF YES
         SBMD R22,=LAVAIL      ! AMOUNT TO MOVE
         LDM  R56,=62,0        ! BYTES TO RESERVE
         JSB  =GETMEM          !
         JEN  ERGSB-           ! JIF MEM OVFLO
         STM  R24,R22          ! RESTORE R22
         STMD R26,=RTNSTK      ! NEW TOS
STKRTN   PUMD R36,-R22         ! ADDR TO RTN STAK
         PUMD R30,-R22         ! PCR TO STAK
         PUBD R16,-R22         ! CSTAT TO STAK
         STMD R22,=NXTRTN      !
         JMP  JMPLN#           !
!
ERGSB    JSB  =ERROR           ! GOSUB NESTING
         BYT  18D              ! 18D
!
ERGSB-   CLM  R32              ! NESTING TOO DEEP
         STMD R32,=ONFLAG      ! CLEAR FLAG
         LDM  R32,R36          ! RETURN ADDRESS
! R30 CONTAINS PCR
         JMP  RTNEX            ! DO PSEUDO RETURN
!
GETMEM   CLE                   !
         LDM  R32,=40,0        ! SAFETY MARGIN
         LDMD R26,=LAVAIL      ! FWA SOURCE
         STM  R26,R24          !
         SBM  R26,R56          ! FWA SINK
         SBM  R26,R32          ! LESS 40
         CMM  R26,R12          ! CHECK ROOM
         JCY  GETM1            ! JIF OK
!
         JSB  =ERROR           ! MEM OVF
         BYT  19D              ! 19D
!
         CLE                   !
         ICE                   !
         RTN                   !
!
GETM1    ADM  R#,R32           ! RESTORE FWA SINK
         STMD R#,=LAVAIL       ! RESET
         LDMD R32,=CALVRB      !
         SBM  R32,R56          !
         STMD R32,=CALVRB      !
         JSB  =MOVUP           ! GO MOVE
         RTN                   !
! =========================================================
! RUNTIME ROUTINE FOR 'RETURN' STATEMENT
! =========================================================
         BYT  241              ! ATTRIBUTES
RETRN.   BIN                   ! RETURN
         LDMD R36,=FWCURR      !
         LDBD R32,X36,P.GCNT   ! GOSUB COUNT
         DCB  R32              !
         JNC  RTNERR           ! JIF TOO MANY RETURNS
         STBD R32,X36,P.GCNT   ! SAVE NEW GOSUB COUNT
         LDMD R36,=NXTRTN      !
         POBD R16,+R36         ! STATUS
         POMD R30,+R36         ! PCR
         POMD R32,+R36         ! RETURN ADDRESS
         STMD R36,=NXTRTN      ! UPDATE PTR
RTNEX    GTO FNDRTN            !
!
RTNERR   JSB  =ERROR+          ! RETURN W/O GOSUB
         BYT  51D              ! 51D
!
! *************************************
! STRING COMPARE SUBROUTINES
! *************************************
! REGISTERS:
! R30(34)    X(Y) ADDRESS
! R32(36)    X(Y) ACUTAL SIZE
! R50(51)    X(Y) CHARACTER
! R60-67     COPY OF 30-37
!
! COMMON SETUP ROUTINE
SETUP$   BIN                   !
         POMD R34,-R12         ! GET Y ADDRESS
         POMD R36,-R12         ! GET Y SIZE
         POMD R30,-R12         ! GET X ADDRESS
         POMD R32,-R12         ! GET X SIZE
         LDM  R60,R30          ! SAVE 30-37
         CLM  R40              ! SET UP FOR OUTPUT
         RTN                   ! DONE
!
! C1BYTE CALLED BY SETCOM AND POS
C1BYTE   POBD R50,+R30         ! COMPARE ONE BYTE
         POBD R51,+R34         !   OF THE STRINGS
         CMB  R51,R50          ! SET FLAGS
         RTN                   ! DONE
!
SETCOM   JSB  =SETUP$          ! SET UP REGISTERS
         CLE                   ! SET UP OUTPUT FLAG
         CMM  R32,R36          ! COMPARE SIZES
         JNZ  DIFSIZ           ! E=0 IF SIZE =
         STM  R32,R56          ! COPY LEN FOR COUNTER
CLOOP    DCM  R56              ! DEC LEN COUNTER
         JNC  X$=Y$            ! JIF DONE
         JSB  =C1BYTE          ! GO COMPARE THE TWO BYTES
         JZR  CLOOP            ! JIF MATCH SO FAR
         JMP  DIFBYT           !
DIFSIZ   ICE                   ! E=2 IF LENGTHS DIFFERENT
DIFBYT   ICE                   ! E=1 IF BYTES DIFFERENT
X$=Y$    RTN                   !
! =========================================================
! RUNTIME ROUTINE FOR 'STRINGS EQUAL' STATEMENT
! =========================================================
         BYT  6,53             ! ATTRIBUTES
EQ$.     JSB  =SETCOM          ! COMPARE
         JEN  FALSE$           ! JIF X#Y
TRUE$    LDB  R47,=20          ! MAKE OUTPUT TRUE (1)
FALSE$   PUMD R40,+R12         ! PUSH 1 OR 0
         BCD                   ! RESTORE MODE
         RTN                   !
! =========================================================
! RUNTIME ROUTINE FOR 'STRINGS UNEQUAL' STATEMENT
! =========================================================
         BYT  6,53             ! ATTRIBUTES
UNEQ$.   JSB  =SETCOM          ! COMPARE
         JEZ  FALSE$           ! X=Y IS FALSE
         JMP  TRUE$            ! OTHERWISE TRUE
! =========================================================
! RUNTIME ROUTINE FOR 'STRING > STRING' STATEMENT
! =========================================================
         BYT  6,53             ! ATTRIBUTES
GR$.     JSB  =SETCOM          ! COMPARE
         JEZ  FALSE$           ! EQUAL ISN'T >
GRGE$    DCE                   ! COMPARE?
         JEZ  WHICH>           ! JIF NO
         CMM  R66,R62          ! MATCH, SO COMPARE SIZE
WHICH>   JCY  FALSE$           ! X<Y
         JMP  TRUE$            ! X>Y
! =========================================================
! RUNTIME ROUTINE FOR 'STRING < STRING' STATEMENT
! =========================================================
         BYT  6,53             ! ATTRIBUTES
LT$.     JSB  =SETCOM          ! COMPARE
         JEZ  FALSE$           ! EQUAL ISN'T <
LTLE$    DCE                   ! COMPARE?
         JEZ  WHICH<           ! JIF NO
         CMM  R66,R62          ! NO, COMPARE LENGTHS
WHICH<   JCY  TRUE$            ! X<Y
         JMP  FALSE$           ! X>Y
! =========================================================
! RUNTIME ROUTINE FOR 'STRING <= STRING' STATEMENT
! =========================================================
         BYT  6,53             ! ATTRIBUTES
LEQ$.    JSB  =SETCOM          ! COMPARE
         JEZ  TRUE$            ! JIF EQUAL
         JMP  LTLE$            ! DO LESS THAN TEST
! =========================================================
! RUNTIME ROUTINE FOR 'STRING >= STRING' STATEMENT
! =========================================================
         BYT  6,53             ! ATTRIBUTES
GEQ$.    JSB  =SETCOM          ! COMPARE
         JEZ  TRUE$            ! JIF EQUAL
         JMP  GRGE$            ! DO GREATER THAN TEST
! =========================================================
! RUNTIME ROUTINE FOR 'CHR$'
! =========================================================
         BYT  20,56            ! ATTRIBUTES
CHR$.    JSB  =ONEB            ! GET ONE INTEGER
! FOLLOWING CODE RESERVES TEMPORARY MEMORY
! AND CREATES POINTER TO IT AS A STRING.
         CLM  R56              ! RESERVE 3 BYTES WITH RESMEM
         ICM  R56              !
         JSB  =RSMEM-          ! ADDRESS RETURNED IN 26
         PUMD R56,+R12         ! PUSH LENGTH (1)
         PUMD R26,+R12         ! PUSH ADDRESS
         STBD R46,R26          ! STORE BYTE IN TEMP MEMORY
         RTN                   !
! =========================================================
! RUNTIME ROUTINE FOR 'LEN'
! =========================================================
         BYT  30,55            ! ATTRIBUTES
LEN.     POMD R46,-R12         ! GET RID OF ADDRESS
         POMD R36,-R12         ! GET STRING LENGTH
         JMP  PUINTG           ! CONVERT, PUSH
! =========================================================
! RUNTIME ROUTINE FOR 'NUM'
! =========================================================
         BYT  30,55            ! ATTRIBUTES
NUM.     POMD R74,-R12         ! GET LENGTH AND ADDRESS
         CLM  R36              !
         LDBD R36,R76          ! GET THE BYTE
         CLM  R76              ! FOR TEST
         CLM  R40              !
         TSM  R74              ! IS LENGTH ZERO?
         JZR  PUNUM            ! JIF ZERO, DONE (R40=0)
PUINTG   JSB  =CONBIN          ! CONVERT TO INT/REAL IN R40
PUNUM    PUMD R40,+R12         ! PUSH RESULT
         RTN                   !
! =========================================================
! RUNTIME ROUTINE FOR 'VAL$'
! =========================================================
         BYT  20,56            ! ATTRIBUTES
VAL$.    JSB  =ONER            ! GET ONE REAL
         BIN                   ! FOR ALL ADDS
         CLM  R54              ! SET R54 TO # BYTES
         LDB  R54,=40          !  OF THE STRING
         JSB  =RESMEM          ! RESERVE 32 BYTES
         PUMD R26,+R6          ! SAVE STARTING ADDRESS
         STM  R26,R30          ! MOVE FOR CVNUM
         JSB  =CVNUM           ! FORMAT THE NUMBER
         BIN                   ! MAKE BINARY ADD
         POMD R26,-R6          ! RESTORE START ADDRESS
         SBM  R30,R26          ! GET LENGTH
         PUMD R30,+R12         ! PUSH LENGTH
         PUMD R26,+R12         ! PUSH ADDRESS
         RTN                   ! DONE
! =========================================================
! RUNTIME ROUTINE FOR 'VAL'
! =========================================================
         BYT  30,55            ! ATTRIBUTES
VAL.     BIN                   ! FOR ADDS
         POMD R24,-R12         ! GET ADDR OF STRING
         POMD R22,-R12         ! GET LENGTH OF STRING
         LDM  R30,R22          ! COPY LEN
         ADM  R30,R24          ! GET END OF STRING
         LDBD R32,R30          ! GET (SAVE) CURRENT CHAR AT END
         LDB  R33,=15          ! CHANGE TO CR
         STBD R33,R30          !   FOR SCANNER
         LDM  R34,R10          ! SAVE R10
         LDM  R10,R24          ! SET R10 FOR SCANNER
         CLM  R36              ! CLEAR SIGN FLAG
         JSB  =GCHAR           ! GET FIRST CHAR
SCANVL   JSB  =SCAN            ! GET TOKEN
         CMB  R14,=53          ! PLUS SIGN?
         JZR  SCANVL           ! JIF YES, IGNORE
         CMB  R14,=55          ! MINUS SIGN?
         JNZ  GETVAL           ! JIF NO
         ICB  R36              ! ADD ONE SIGN
         JMP  SCANVL           ! GET MORE
GETVAL   CMB  R14,=32          ! INTEGER?
         JZR  INTVAL           ! JIF YES
         CMB  R14,=4           ! FLOATING PT NUMBER?
         JZR  VALDUN           ! JIF YES, DONE
! THE SCANNER LEAVES THE F.P. NUMBER ON R12 STACK
         JSB  =WARN            ! BAD PARAMETER (NON NUMERIC)
         BYT  131              ! 89D
         CLM  R44              ! CLEAR RESULT
INTVAL   LDM  R75,R44          ! MOVE RESULT FOR I#PUSH
         JSB  =I#PUSH          ! PUSH FLAG AND NUMBER
VALDUN   TSB  R36              ! ODD NUMBER OF SIGNS?
         JEV  RESTOV           ! JIF NO
         BCD                   ! FOR HOMER!!!!! (MATH ROUTINES WRITTEN BY HOMER RUSSELL)
         JSB  =CHSROI          ! DO MONADIC MINUS
RESTOV   STM  R34,R10          ! RESTORE R10
         STBD R32,R30          ! RESTORE CHAR
         RTN                   ! DONE
! =========================================================
! RUNTIME ROUTINE FOR 'UPC$'
! =========================================================
         BYT  30,56            ! ATTRIBUTES
UPC$.    POMD R36,-R12         ! GET ADDRESS
         POMD R30,-R12         ! GET LENGTH
         BIN                   ! DO THIS IN BINARY
         STM  R30,R56          ! RESERVE LENGTH
         JSB  =RSMEM-          ! ADDRESS OF MEM IN R26
         PUMD R30,+R12         ! PUSH BACK LENGTH
         PUMD R26,+R12         ! PUSH NEW ADDRESS
! NOW CONVERT ALL LOWER CASE TO UPPER CASE
UPLOOP   DCM  R30              ! DONE?
         JNC  UPDONE           ! JIF DONE
         POBD R20,+R36         ! GET NEXT CHAR
         JSB  =ALFA            ! CONVERT TO UPPER CASE
         PUBD R20,+R26         ! STORE AND MOVE
         JMP  UPLOOP           ! GET NEXT
UPDONE   RTN                   ! DONE
! =========================================================
! RUNTIME ROUTINE FOR 'POS'
! =========================================================
         BYT  52,55            ! ATTRIBUTES
POS.     JSB  =SETUP$          ! SETUP REGISTERS
POS-.    CLM  R24              ! R25=N_0
         CLM  R26              ! R27=FOUND_FALSE, R26=DONE_FALSE
         POBD R52,+R34         ! GET S2(1)
POSLOP   TSM  R26              ! FOUND YET?
         JNZ  EXIT             ! JIF FOUND OR DONE
         ICM  R24              ! N_N+1 COMPARE SUBS.
         CMM  R32,R24          !  TO LEN(S1)
         JNC  DON+             ! JIF DONE (NEXT TOO HIGH
         POBD R50,+R30         ! GET S1(N)
         CMB  R50,R52          ! SAME AS S2(1)?
         JNZ  POSLOP           ! JIF NOT EQUAL
         JSB  =CKREST          ! CHECK REST OF S2
         JMP  POSLOP           ! DO NEXT
DON+     ICB  R26              ! DONE_TRUE
EXIT     TSB  R27              ! FOUND?
         JNZ  SAVN             ! YES, DON'T CHANGE N
         CLM  R36              ! ANSWER IS 0
         JMP  PUSHN            ! PUSH 0
SAVN     LDM  R36,R24          ! GET ANSWER
PUSHN    JSB  =PUINTG          ! PUSH ANSWER
         RTN                   ! DONE
!
CKREST   CLB  R26              ! DONE_FALSE
         PUMD R30,+R6          ! SAVE POINTER FOR S1
         PUMD R34,+R6          ! SAVE POINTER FOR S2
         LDM  R56,R24          ! K_N
         ADM  R56,R36          ! ADD L(2)
         DCM  R56              ! IF L(2)+N>L(1)
         CMM  R56,R32          !   THEN DONE
         JZR  FITS$            ! JIF SIZE OK
         JPS  EXITR            ! JIF > BUT NOT =
! THIS BRANCHING IS PRETTY SLOPPY
FITS$    LDM  R56,R36          ! FOR K_1 TO L(2)-1
CKLOOP   DCM  R56              ! J_J-1
         JNZ  CKIT             ! JIF MORE TO DO
         ICB  R26              ! DONE_TRUE
         ICB  R27              ! FOUND_TRUE
         JMP  EXITR            ! DONE
CKIT     JSB  =C1BYTE          ! CHECK 1 BYTE
         JZR  CKLOOP           ! JIF SAME
EXITR    POMD R34,-R6          ! RESTORE POINTERS
         POMD R30,-R6          !   TO S1, S2
         RTN                   !
!
CONBIN   BIN                   ! CONVERT A 16-BIT # TO A REAL #
         CLE                   !
         CLM  R40              ! clear output
         TSM  R36              ! check input
         JZR  CONRTN           ! jif done (zero)
         JPS  POSITV           ! CHECK FOR NEGATIVE
         TCM  R36              ! MAKE IT POSITIVE
         LDB  R41,=11          ! SET SIGN (9C)
         TSM  R36              ! TRAP 32768
         JPS  POSITV           ! JIF NOT 32768
         LDM  R45,=200,166,62  ! CREATE ANSWER (80C,76C,32C)
         LDB  R40,=4           ! ADD EXPONENT
         JMP  CONRTN           ! DONE
! THE FOLLOWING 3 LINES SAVE 170 CYCLES IF N<100
POSITV   LDM  R32,=DIV10       ! get address of DIVISORS
         CMMD R36,=DIV100      ! is R36 < 100
         JNG  CONLOP           ! jif yes
         LDM  R32,=DIV10K      ! use big divisor
CONLOP   POMD R34,+R32         ! get next DIVISOR
         JZR  ONES             ! jif done
         BIN                   !
         DCE                   ! preset E=-1 (ELM makes E=0)
         DRP  R36              ! DRP 36
         ARP  R34              ! ARP 34 (TO SAVE CYCLES IN LOOP)
SUB      SBM  R#,R#            ! subtract out 10^N
         ICE                   ! count up
         JPS  SUB              ! jif not done
         ADM  R#,R#            ! restore, add last one back in
         BCD                   ! need for E shifts
         ELM  R45              ! rotate E into R45-7
         JMP  CONLOP           ! GET NEXT
!
ONES     ERB  R36              ! get remainder to E
! MUST BE BCD - SO WE NEED >=1 PASS THRU DIVIDE
         ELM  R45              ! shift into result
         LDB  R40,=5           ! max exponent +1
NLOOP    DCB  R40              ! dcr exp for each LZ
         LLM  R45              ! shift out leading zeroes
         JLZ  NLOOP            ! jif more leading zeroes
CONRTN   RTN                   !
! BINARY VALUES FOR DECIMAL 10000, 1000, 100, 10
DIV10K   BYT  20               ! 10000 dec
         BYT  47               ! 047=39D, 020=16D, 39*256=9984, 9984+16=1000
DIV1K    BYT  350              ! 1000 dec
         BYT  3                !
DIV100   BYT  144              ! 100 dec
         BYT  0                !
DIV10    BYT  12               ! 10 dec
         BYT  0                !
! BCD INTEGER REPRESENTATION OF DECIMAL 32768
DIV0     BYT  0                ! 0 dec
         BYT  0                !
         BYT  150              ! BCD 68
         BYT  47               ! BCD 27
         BYT  3                ! BCD 03 = 32768
! *******************************************************
! SYSTEM INIT (POWER-ON *ONLY*)
! *******************************************************
SYSINI   BIN                   ! POWER ON INITIALIZATION
         LDM  R36,=377,376     ! Addr (64K-256) of end of 32K of RAM
         LDB  R60,=252         ! load bit pattern 10101010
         STM  R60,R61          ! ripple load into R60-67
         PUMD R60,-R36         ! write to possible RAM
         POMD R50,+R36         ! Read it back
         CMM  R50,R60          ! WRITE/READ CORRECT?
         DRP  R36              ! SAVE A BYTE
         JZR  SYSIN1           ! JIF YES
         LDM  R36,=377,277     ! Addr (48K) of end of 16K of RAM
SYSIN1   STMD R#,=LWAMEM       ! save address of end of RAM
         LDM  R#,=300,206      ! addr of first RAM past what the system uses (103300)
         STMD R#,=FWUSER       ! set ptr to first byte of "user" RAM
!
! TAKE ROM ATTENDANCE
!
         LDM  R34,=BINTAB      ! Addr of ptr to Binary Program
         CLM  R36              ! AND CLEAR BINTAB
         PUMD R36,+R34         ! NOW R34 = ROMTAB
         DCB  R36              ! =377,0
         CLM  R40              ! SET R40 FOR LATER
RMLOOP   ICB  R37              ! bump the complement of the ROM #
         DCB  R36              ! bump the ROM#
         JNC  RMSDUN           ! jif went past zero, done
         STBD R36,=RSELEC      ! try to select the ROM into 60000
         CMMD R36,=R60K        ! are 1st 2 bytes the ROM# & complement?
         JNZ  RMLOOP           ! jif no, that ROM not present
! WE HAVE FOUND A ROM, HE IS SELECTED AND HIS NUMBER IS IN R36
         CMM  R34,=ROMLST      ! Is the ROM table full?
         DRP  R36              ! SAVE A BYTE
         JNC  RMROOM           ! jif no
         CLB  R36              ! else set ROM # to 0 (skip the rest)
         STBD R36,=RSELEC      ! make sure ROM 0 is mapped in
RMROOM   PUBD R#,+R34          ! Add this ROM# to the table of expansion ROMs
         PUBD R40,+R34         ! and a zero (R40=0!!!!!!)
         JMP  RMLOOP           ! DO NEXT
RMSDUN   PUMD R#,+R34          ! FLAG END (R36=377,0)
         LDM  R36,=D2HOOK      ! load a ptr to more system RAM
         PUMD R40,+R36         ! zero out more
         PUMD R40,+R36         ! and more
         LDB  R40,=40          ! LINE LENGTH
         PUBD R40,-R36         !
         PUBD R40,-R36         !
         JSB  =SYSIN+          ! DO REST OF INIT
         CLB  R#               ! Power-on, scratch, init
         JSB  =SCRAST          !
         JSB  =PWO             ! Do the Power On Test
         JSB  =TIME0           ! start system timer
         LDB  R#,=1            ! ENABLE KEYBOARD
         STBD R#,=KEYSTS       ! enable keyboard
         CMB  R17,=300         ! any PWO errors?
         JCY  SYSRTN           ! JIF yes, no AUTOST
         LDM  R42,=101,165,164,157,163,164 ! "AUTOST"
         STMD R42,=TEMP22      ! store "AUTOST" file name in RAM
         JSB  =AUTOST          ! TRY TO LOAD AUTOST
         CMB  R17,=300         ! any errors from load of AUTOST?
         JNC  AUTORU           ! jif no, OK
         CLM  R16              ! else clear error flags
         STMD R16,=ERRORS      !
SYSRTN   RTN                   ! SYSIN+ ENABLES INTS
AUTORU   JSB  =SETTOS          ! SET TOS, STSIZE
         JSB  =RUN.            ! RUN AUTOST
         RTN                   ! DONE
! POWER ON AND RESET (USES R34, R36, R40, R12, R50)
SYSIN+   BIN                   ! POWER ON & RESET INITIALIZATION
         STBD R36,=GINTDS      ! DISABLE INTERRUPTS
         LDM  R36,=PLOTSY      ! ADDRESS OF PLOTSY
         LDM  R40,=377,377,40,40,3,74,0,0 !
         PUMD R40,+R36         !
         CLM  R40              !
         PUMD R40,+R36         ! ZERO 10
         PUMD R40,+R36         ! ZERO 20
         PUMD R40,+R36         ! ZERO 30
         LDM  R36,=CRXMAX      !
         LDB  R47,=20          !
         ICB  R40              !
         ICB  R40              ! R40 = 100 (decimal real number) I think
         PUMD R40,+R36         ! CRXMAX
         PUMD R40,+R36         ! CRYMAX (CRT SCALING)
         CLM  R40              !
         PUMD R40,+R36         ! CRXMIN=0
         PUMD R40,+R36         ! CRYMIN=0
         LDM  R40,=231,231,45,47,206,126,41,71 !
         PUMD R40,+R36         ! XFACT
         LDM  R40,=231,231,44,224,40,140,65,122 !
         PUMD R40,+R36         ! YFACT
         CLM  R40              !
         LDM  R34,=0,277       ! load R34 with 0,191D
         PUMD R34,+R36         ! init XMAP=0, YMAP=191D
         LDB  R47,=20          ! CRT SELECT CODE = 1
         PUMD R40,+R36         ! store 1 (FLOATING POINT) into CS.C
         LLM  R40              ! MAKE IT A 2
         PUMD R40,+R36         ! store 2 (FLOATING POINT) into PS.C
         LDB  R40,=236         ! load a RTN opcode
         LDM  R36,=IOTRFC      ! INTERRUPT AND ROM HOOKS
         LDB  R44,=25          ! ERROR# 21D
         LDM  R34,=ERROR+      ! FOR ERROR CALL
         STM  R34,R42          ! JUST PAST THE JSB (316)
         LDB  R41,=316         ! R4-R44: JSB=ERROR+ BYT 25 (err 21 dec: ROM MISSING)
         PUMD R41,+R36         ! init IOTRFC
         PUMD R41,+R36         ! init IOSP
         LDM  R41,R40          ! fill 40's with 8 RTN opcodes
         PUMD R40,+R36         ! CHIDLE
         PUMD R40,+R36         ! KYIDLE+1
         PUMD R40,+R36         ! RMIDLE+2
         PUMD R40,+R36         ! STRANG+3
         PUMD R40,+R36         ! IMERR+4
         PUMD R40,+R36         ! PRSIDL+5
         PUMD R40,+R36         ! IRQ20+6
         PUMD R40,+R36         ! IRQRTN
         PUMD R40,+R36         ! SPAR0+4
         PUMD R40,+R36         ! SPAR1+3 through 102535 (inclusive), PART OF ROM BASE TABLE
         JSB  =CRTINT          ! INITIALIZE CRT
         JSB  =RNDINI          ! SET RANDOM SEED
         STBD R30,=GINTEN      ! ENABLE INTERRUPTS
         RTN                   ! ALL DONE
! =========================================================
! RUNTIME ROUTINE FOR 'RESET'
! =========================================================
         BYT  141              ! ATTRIBUTES
RESET.   JSB  =CRTWPO          ! blank CRT SO UGLY FLASH GOES AWAY
         JSB  =SYSIN+          ! do partial SCRATCH, MODIFIED POWER-ON
         LDB  R#,=1            ! ROMINI FLAG (DRP=30)
         STBD R#,=ROMFL        ! set ROMFL to mean RESET
         JMP  RESET+           ! PART OF SCRATCH
! SCRATCH AND POWER ON AND LOAD
SCRAT+   JSB  =BPINI           ! BPGM DEINITIALIZE
         LDM  R36,=FWPRGM      ! SET FOR 5 LINES DOWN
         LDMD R12,=LWAMEM      ! CLOBERR BPGM
         STMD R12,=FWBIN       ! SCRATCH BIN PROG
         CLM  R12              ! CLEAR BINTAB
         STMD R12,=BINTAB      !
         LDMD R12,=FWUSER      ! INITIALIZE MEM POINTERS
         PUMD R12,+R36         ! FWPRGM
         PUMD R12,+R36         ! FWCURR
! INITIALIZE "MAIN 0 0 100"
         LDM  R40,=115,101,111,116,0,0,100,0 !
         PUMD R40,+R12         ! TO PROGRAM AREA
SCR+++   CLM  R#               ! PLUS 20 BYTES OF ZERO
         PUMD R#,+R#           ! AFTER MAIN
         PUMD R#,+R#           ! FINISH INITIALIZE OF BASIC PGM HEADER
! ADD LAST LINE 10000 STOP 16
         LDM  R43,=231,251,2,31,16 ! LINE# 10000, LEN=2, STOP, EOL
         PUMD R43,+R#          ! ADD IT
SETTOS   STMD R12,=NXTMEM      ! R12 IS NOW SET, SET END OF PGM PTR
         STMD R12,=TOS         ! SET TOP OF STAK PTR
         STMD R12,=STSIZE      ! AND STAK SIZE
         RTN                   ! DONE
! =========================================================
! RUNTIME ROUTINE FOR 'SCRATCH'
! =========================================================
         BYT  141              ! ATTRIBUTES
SCRAT.   LDB  R36,=2           ! ROMINI 2, SCRATCH
SCRAST   STBD R#,=ROMFL        ! SAVE REASON FOR ROMINIT
SCRA.-   JSB  =SCRAT+          ! ENTRY FROM SYSINI
! SCRATCH AND RESET AND POWER ON
RESET+   CLM  R16              ! SET SYSTEM QUIET
         JSB  =SET240          ! SET IMMEDIATE
         LDMD R12,=NXTMEM      ! RESET OP STACK
! THE ABOVE ASSURES WE DON'T LOSE SERVICE REQUEST BIT
         BIN                   !
         LDM  R36,=CONTOK      ! ADDRESS TO START INITIALIZING
         LDM  R45,=377,17,252  ! INIT CONTOK AND LLDCOM
         PUMD R45,+R36         !
         CLM  R40              !
         PUMD R40,+R36         ! FLDCOM,TRCFL1,TRCFL2,DISPTR,PTRPTR
         PUMD R40,+R36         ! USING?, ONFLAG, RESULT
         PUMD R40,+R36         ! THENFL,AUTO#,AUTOI
         PUMD R40,+R36         ! ERGOTO,ERLIN#,ERNUM#,ERRROM,ERROM#
         PUMD R40,+R36         ! EDMOD2,ERRORS,ERRTYP,ASNTBL
         STMD R40,=SCTEMP      ! SCTEMP=0
         LDMD R40,=BLANKS      ! BLANKS FOR PRINTER LISTING
         STMD R40,=INPB-3      ! ONLY THE FIRST 3 COUNT
         JSB  =NORMA-          !
RSETG+   JSB  =ROMINI          !
RSETGO   LDM  R36,=ASNTBL      !
         CLM  R40              !
         PUMD R40,+R36         ! CLEAR ASNTABL
         PUMD R40,+R36         !
         PUMD R44,+R36         ! LAST 4 OF 24
         LDM  R2,=FWBIN        ! HIGH MEMORY PTR ADDRESS
         LDMD R34,R2           ! GET HIGH MEMORY PTR
         PUMD R34,-R2          ! GOSUB RTN STAK PTR
         SBM  R34,=62,0        ! LEAVE 50 BYTES FOR 10 GOSUB/RTN ADDRESSES
         PUMD R34,-R2          ! RTNSTK
         PUMD R34,-R2          ! CALVRB
         PUMD R34,-R2          ! LAVAIL
RSETG-   BIN                   ! CLEAR LEGEND BUFFER
         LDM  R36,=LEGEND      ! ADDRESS OF SOFTKEY LEGEND BUFFER
         LDB  R23,=3           ! FILL IT WITH BLANKS
         LDM  R56,=100,0       ! ALL 64 BYTES OF IT (8X8)
         JSB  =ZROMEM          ! GO BLANK
         LDM  R36,=KEYTAB      ! ON KEY TABLE
         CLM  R40              !
         PUMD R40,+R36         ! ZERO 4 KEY ENTRIES
         PUMD R40,+R36         ! 4 MORE
         STMD R42,=TIMTAB      ! ON TIMER TABLE
         LDB  R55,=145         ! turn OFF timers
         JSB  =TIMWST          ! TURN OFF TIMER 1
         LDB  R55,=245         !
         JSB  =TIMWST          ! TURN OFF TIMER 2
         LDB  R55,=345         !
         JSB  =TIMWST          ! TURN OFF TIMER 3
         LDMD R36,=FWCURR      ! PTR TO START OF CURRENT BASIC PGM
         STMD R40,X36,P.DATL   ! clear RESMEM, etc in program header
         STMD R46,=ERGOTO      ! clear ON ERROR
         RTN                   !
!
! CALL INIT ROUTINE IN ALL ROMS
!
ROMINI   LDM  R34,=ROMTAB      ! GET PTR TO TABLE OF ROMS
ROMIN+   POMD R36,+R34         ! GET ROM#
         JZR  RIDUN            ! JIF ALL DONE
         STBD R36,=RSELEC      ! SELECT THAT ROM
         LDMD R36,=R60+12      ! GET INIT ADDRESS
         PUMD R34,+R6          ! SAVE POINTER TO ROM TABLE
         JSB  X36,ZRO          ! CALL THIS ROM'S INIT ROUTINE
         POMD R34,-R6          ! RECOVER PTR TO ROM TABLE
         JMP  ROMIN+           ! DO NEXT ONE
RIDUN    STBD R#,=RSELEC       ! SELECT ROM 0
!
! CALL INIT ROUTINE IN BINARY PROGRAM
!
BPINI    LDMD R36,=BINTAB      ! GET PTR TO BINARY PROGRAM
         JZR  BPIDUN           ! JIF NONE LOADED
         LDMD R36,X36,B.INIT   ! GET ADDRESS OF BINARY PGM'S INIT ROUTINE
         JSB  X36,ZRO          ! call the Binary PGM's init routine
BPIDUN   RTN                   ! DONE
! =========================================================
! RUNTIME ROUTINE FOR TOKEN 370 (PLUG-IN ROM TOKEN RUNTIME CALL)
! =========================================================
         BYT  214              ! ATTRIBUTES
ROM.GO   CLM  R20              ! MAKE R20 MULTI
         POBD R20,+R10         ! GET ROM#
         STBD R20,=RSELEC      ! SELECT THAT ROM
         BIN                   ! FOR COMPARE, SHIFT
         CMBD R20,=R60K        ! IS THE ROM THERE?
         JNZ  ERR21            ! JIF NO, ERROR
         POBD R20,+R10         ! GET TOKEN
         LLM  R20              ! DOUBLE LIKE INTERP
         LDMD R36,=R60+2       ! GET RUNTIME TABLE ADDR
         ADM  R36,R20          ! ADD OFFSET
         BCD                   ! FOR HOMER (HOMER RUSSELL WROTE THE MATH ROUTINES)
         LDMD R20,R36          ! GET TOKEN RUN ADDR
         JSB  X20,ZRO          ! GOT THERE
ROMRTN   CLB  R0               ! RE-SELECT SYSTEM ROM
         STBD R0,=RSELEC       ! ROM 0
         RTN                   ! DONE
!
ERR21    JSB  =ERROR           !
         BYT  21D              ! 21D MISSING ROM
!
         JMP  ROMRTN           !
! *******************************************************
! ROM SWITCHING GOSUB
! *******************************************************
ROMJSB   STMD R65,=ERTEMP      ! SAVE REGS
         POMD R66,-R6          ! GET RETURN ADDRESS FROM STAK
         SAD                   ! SAVE BIN/BCD
         BIN                   ! FOR ADDRESS MATH
         ICM  R66              ! SKIP RTN ADDR OVER THE ROM ADDR & ROM#
         ICM  R66              !
         ICM  R66              !
         PAD                   ! RESTORE BIN/BCD
         PUMD R#,+R#           ! PUSH MODIFIED RTN ADDR TO STAK
         PUMD R0,+R#           ! SAVE R0 SCRATCH REG
         LDBD R0,=R60K         ! GET CURRENT ROM#
         PUBD R0,+R#           ! SAVE IT
         POBD R65,-R66         ! GET NEW ROM#
         POMD R0,-R66          ! GET JSB ADDRESS
         STBD R65,=RSELEC      ! SELECT THE NEW ROM
         SAD                   ! SAVE BIN/BCD
         BIN                   ! FOR COMPARE
         CMBD R65,=R60K        ! IS THE NEW ROM THERE?
         JZR  ROMJS+           ! JIF YES
         LDM  R0,=ERR21        ! ADDRESS OF ERROR ROUTINE TO CALL INSTEAD
ROMJS+   LDMD R65,=ERTEMP      ! RESTORE R65
         PAD                   ! RESTORE BIN/BCD
!
         JSB  X0,ZRO           ! CALL THE ROM ROUTINE
!
         SAD                   ! SAVE RETURN STATUS FLAGS
         STMD R64,=ERTEMP      ! SAVE R64-7
         POMD R65,-R6          ! GET 3 SAD BYTES OFF STACK
         POBD R64,-R6          ! GET ORIGINAL (CALLING) ROM# OFF STACK
         STBD R64,=RSELEC      ! RE-SELECT ORIGINAL ROM
         POMD R0,-R6           ! RESTORE R0-1
         PUMD R65,+R6          ! STORE STATUS (FOR PAD)
         LDMD R64,=ERTEMP      ! RESTORE R64-7
         PAD                   ! RESTORE STATUS FROM ROMJSB
         RTN                   ! RETURN TO OLD (CALLING) ROM
!
! ************************************************************
! LIST & PLIST CODE
! ************************************************************
LIST1P   LDM  R76,=17,252      ! LIST 0,END OF PAGE
         STMD R76,=LLDCOM      ! STORE IN LLDCOM
         RTN                   ! DONE
! =========================================================
! RUNTIME ROUTINE FOR "PLIST"
! =========================================================
         BYT  241              ! ATTRIBUTES
PLIST.   JSB  =PRINT.          ! SEND TO "PRINTER IS" DEVICE
         JMP  LISTGO           ! DO COMMON LIST
! =========================================================
! RUNTIME ROUTINE FOR "LIST"
! =========================================================
         BYT  241              ! ATTRIBUTES
LIST.    JSB  =DISP.           ! SEND TO "CRT IS" DEVICE
LISTGO   BIN                   ! COMMON LIST ENTRY POINT
         LDMD R46,=LDFLTR      ! SET LISTCT TO DEFAULT VAL
         STMD R46,=LISTCT      !
         JSB  =LIST1P          ! DEFAULT FOR CRT
         JSB  =COPSUB          ! GET SELECT CODE
         CMB  R#,=4            ! CHECK FOR PRINTER
         JNZ  NOTPRN           ! JIF NO
         JSB  =CRTPOF          ! TURN OFF CRT
NOTPRN   CMB  R46,=2           ! CRT?
         JZR  LIST1            ! JIF YES
! NEXT TWO LINES WERE "LISTAL"
         LDM  R74,=231,231,0,0 ! LIST 0,9999
         STMD R74,=LLDCOM      ! STORE IN LAST-LINE-DECOMPILE AND FIRST-LINE-DECOMPILE
! BEGIN FORMER LISTSB
LIST1    LDB  R0,=1            ! MASK FOR SECURITY CHECK
         JSB  =SECUR?          ! CHECK IF SECURED AGAINST PRINTING
         JSB  =TO?I            ! GET LAST LINE
         JEZ  LSSET            ! JIF DEFAULT LINES
         LDM  R26,R45          ! SAVE FIRST PARAM
         STMD R26,=FLDCOM      ! SET 1ST LINE
         DCE                   ! GET SECOND PARAM?
         JEZ  LSSET            ! JIF NOT FOUND
         LDM  R26,R55          !
         STMD R26,=LLDCOM      ! STORE LAST LINE
LSSET    LDMD R76,=FLDCOM      ! MOVE FOR FNDLIN
         JSB  =FNDLIN          ! GET CLOSEST LINE
         LDM  R24,R36          !
NXTDCM   CMB  R17,=300         ! CHECK ERROR FLAG
         JCY  LSRTN            ! JIF ERROR
         LDBD R15,=SVCWRD      ! CHECK IF KEY PRESSED
         JOD  LSRTN            ! JIF YES
         LDMD R46,R24          ! GET LINE#
         STMD R46,=FLDCOM      !  AND SAVE
         JSB  =DECOML          ! DECOMPILE NEXT LINE
         JEZ  LSRTN+           ! JIF NO MORE TO DO, SET FLDCOM AND EXIT
         LDMD R76,=LLDCOM      ! GET LAST LINE# DECOMPILED
         CMB  R77,=252         ! AA?
         JNZ  NTPAGE           ! JIF NOT PAGE MODE
SUBLIN   DCB  R76              !
         SBM  R66,=40,0        !
         JZR  OVERSB           ! JIF EXACTLY 32 CHARS
         JPS  SUBLIN           ! JIF MORE
OVERSB   STBD R76,=LLDCOM      !
         JNG  LSRTN            ! JIF WILL RUN OFF PAGE
NTPAGE   JSB  =COPSUB          ! COMPUTE VECTOR ADDR.
         STB  R46,R45          ! SAVE IT
         LDMD R46,X46,LISTBL   ! FROM LIST TABLE
         JSB  =DRV12+          ! PRINT IT WHEREVER
         JMP  NXTDCM           ! DO NEXT LINE
!
LSRTN+   TSB  R47              !
         JZR  LSRTN            ! DON'T SPIT LENGTH
         CMB  R16,=2           ! RUN MODE
         JZR  LSRTN-           ! NO LENGTH IF RUN
         LDMD R36,=LAVAIL      ! END OF AVAILABLE MEMORY
         SBMD R36,=NXTMEM      !  MINUS END OF PROGRAM = FREE MEMORY
         JSB  =CONBIN          ! CONVERT IT TO REAL OR INTEGER
         PUMD R40,+R12         ! PUSH IT ON THE OPERATING STACK FOR DISPIT
LSRTN-   CLM  R36              ! 0 -> FIRST LINE DECOMPILE
         STMD R36,=FLDCOM      !
LSRTN    JSB  =CRTPUP          ! POWER UP THE CRT IF NEEDED
         RTN                   ! DONE
! *************************************************************************
! THIS ROUTINE DECOMPILES A LINE AND RETURNS E=0 WHEN THERE'S NO MORE TO DO
! IT EXPECTS R24 TO BE SET TO THE LINE# ON ENTRY
! *************************************************************************
DECOML   POMD R45,+R24         ! DECOMPILE ONE LINE
         BIN                   !
         CMM  R45,=231,251,2   ! LINE A999 (END OF PROGRAM)?
         JZR  DECRT+           ! JIF YES, SPIT LENGTH
         LDMD R36,=LLDCOM      ! GET LAST LINE TO DECOMPILE
         BCD                   ! LINE# IS STORED IN BCD
         CMM  R36,R45          ! ARE WE DONE?
         BIN                   !
         JNC  DECRTN           ! JIF YES
         LDM  R30,=INPBUF      ! OUTPUT BUFFER ADDRESS
         JSB  =DECOM           ! DECOMPILE IT
         CMB  R17,=300         ! ERRORS?
         JCY  DECRTN           ! JIF YES
CATENT   LDB  R36,=15          ! CR
         PUBD R36,+R30         ! AT CR TO END OF LINE FOR EDITR
         LDM  R26,=INPBUF      ! START OF LINE
NO.BLK   LDM  R36,R30          ! COPY END OF LINE
         SBM  R36,R26          ! MINUS START OF LINE = LENGTH
         STM  R36,R66          ! COPY
         CLE                   !
         ICE                   ! FLAG TO COME BACK AGAIN, NOT DONE
         RTN                   !
!
DECRTN   CLB  R47              ! FLAG FOR LENGTH OUTPUT
DECRT+   CLE                   ! FLAG DONE, DON'T COME BACK NOW, YA HEAR?
         RTN                   !
!
! ***************************************************************
! PRINT, LIST, DISP VECTOR STUFF
! ***************************************************************
DRV12.   JSB  =COPSUB          ! VECTOR TO SOMEONE
DRV12-   STB  R46,R45          ! SAVE IT
         LDMD R46,X46,SCTBL    ! SET ADDRESS
DRV12+   PUBD R45,+R6          ! SAVE VECTOR
         PUMD R36,+R6          ! SAVE COUNT
         PUMD R26,+R6          ! SAVE POINTER
!
         JSB  =VECTR.          !
!
         POMD R26,-R6          ! RESTORE POINTER
         POMD R36,-R6          !  AND COUNT
         POBD R46,-R6          !    AND VECTOR
         TSB  R17              ! ERRORS?
         JNG  PROFF            ! EXIT IF ERRORS IN VECTOR
         LDBD R47,=PRALLM      ! PRINT ALL ON?
         JZR  PROFF            ! JIF NO
         CMB  R46,=4           ! WAS SELECT CODE 2 (4 FOR ADDRESSING)?
         JZR  PROFF            ! JIF YES, ALREADY PRINTED IT
         JSB  =PRDVR1          ! SEND STUFF TO THE PRINTER
         TSB  R17              ! ANY ERRORS?
         JPS  PROFF            ! JIF NO ERRORS PRINTING
         CLB  R47              !
         STBD R47,=PRALLM      ! ELSE CLEAR PRINT ALL MODE
PROFF    RTN                   !
! ***************************************************************
! THIS ROUTINE CONVERTS SCTEMP IN R40 TO 2-BYTE BINARY
! IN R46 TO VECTOR THROUGH THE JUMP TABLE
! ***************************************************************
! IF SCTEMP=0, THEN HERE VIA I-O STATEMENT WITH <SC> FROM 3 TO 9,
!  OR 2ND LINE OF LIST, PLIST, OR CAT.
! IF SCTEMP=1, THEN FROM DISP. OR OUTPUT 1,...
! IF SCTEMP=2, THEN FROM PRINT. OR OUTPUT 2,...
! IF SCTEMP>2, THEN HERE VIA 'PRINTER IS 702' TYPE STATEMENT
!
COPSUB   LDMD R40,=SCTEMP      ! GET SELECT CODE
COPSB+   PUMD R#,+R12          ! SCTEMP --> BINARY
         PUMD R50,+R6          ! PROTECT R50 FOR PRNFMT
         PUMD R70,+R6          ! SAVE R70 FOR IMAGE
         JSB  =SAVREG          ! SAVE 21-37,R60
         JSB  =ONEB            ! GET # FROM STACK AS BINARY
         JSB  =RSTREG          ! RESTORE 21-37,60
         POMD R70,-R6          ! RESTORE R70
         POMD R50,-R6          ! RESTORE R50
         CMM  R46,=1,0         ! CRT?
         JZR  DOUBLE           ! JIF YES, PASS AS IS
         CMM  R46,=2,0         ! PRT?
         JZR  DOUBLE           ! JIF YES, PASS AS IS
         CLM  R46              ! ELSE I/O, FORCE 0
DOUBLE   LLB  R#               ! DOUBLE FOR ADDRESS INDEXING
         RTN                   !
! ***************************************************************
! TRAFIC VECTORS TO PRINT FORMAT ROUTINES FOR SETUP
! WHICH SUBSEQUENTLY CALL DRV12 TO DO THE ACTUAL
! PRINTS. FOR HPIL THE DATA IS SENT IMMEDIATELY
! TO THE DRIVER WITH NO INTERMDEIATE FORMAT.
! ***************************************************************
TRAFIC   LDM  R36,R54          ! GET AMT IN R36
         JSB  =COPSUB          ! GET S.C. (SELECT CODE)
         LDMD R46,X46,PRNTBL   ! GET PRINT SUB ADDR
VECTR.   PUMD R24,+R6          ! SAVE R24
!
         JSB  X46,ZRO          ! CALL ROUTINE
!
         POMD R24,-R6          ! RESTORE R24
         RTN                   !
! *** PRINT FORMAT VECTOR TABLE
PRNTBL   DEF  IOTRFC           ! SEND IMMED TO HPIL                                 WHY IS THIS NOT IOTRFC?????????????????????????????????????
         DEF  PRNFMT           ! FORMAT FOR CRT
         DEF  PRNFMT           ! FORMAT FOR PRINTER
! *** DISP, PRINT VECTOR TABLE
SCTBL    DEF  IOTRFC           !
         DEF  OUTSTR           ! CRT IS OK
         DEF  PRDVR1           ! PRINTER DRIVER
! *** LIST VECTOR TABLE
LISTBL   DEF  IOTRFC           !
         DEF  OUTSTR           ! CRT
         DEF  LISTPR           ! LIST PRINT DRIVER
!
! ***********************************************************
! REPORP: REPORT PARSE ERRORS
! ***********************************************************
REPORP   BIN                   ! NEED THIS
         ANM  R17,=77          ! KILL TOP TWO BITS
         LDMD R36,=CRTBYT      ! GET LOC OF CURSOR
! NOTE: CURSOR IS AT BOTTOM LEFT OF NEXT LINE
! R26 CONTAINS POINTER TO THE CARRIAGE RETURN
         SBM  R26,=INPBUF      ! GET LENGTH OF LINE
         CMB  R26,=141         ! (97D) THAT NASTY 96 CHARS
         JNZ  MUPONE           ! JIF NOT 96 CHARS
         DCB  R26              ! LIMIT MOVUP TO 3 LINES
MUPONE   SBM  R36,=100,0       ! MOVE CURSOR UP 1 LINE
         ANM  R36,=377,17      ! MODULO TO AVOID GRAPHICS
! MAX LENGTH OF LINE IS LESS THAN 377
         SBB  R26,=40          ! BACK UP LENGTH
         JZR  MOVDUN           ! JIF 32 CHARS
         JCY  MUPONE           ! JIF NOT DONE
! NO ERROR CHECKING FOR SCREEN SIZE SINCE THE
! ORIGINAL LINE FIT WITHIN THE SCREEN
MOVDUN   LDM  R30,=LAST+1      ! FOR REPRT1
         LDMD R34,=SAVR10      ! GET R10 WHEN IT DIED
         SBM  R34,=INPBUF      ! GET LENGTH
         JZR  DBLIT            ! SKIP IF NULL
         DCM  R34              ! COMP FOR GCHAR
DBLIT    LLM  R#               ! DOUBLE IT (CRT RAM IS ADDRESSED BY 4-BIT NYBBLES)
         ADM  R#,R36           ! GET OFFSET INTO SCREEN
         PUMD R#,+R6           ! SAVE IT
! THIS DOUBLED OFFSET WILL BE USED TO CALCULATE CRTBYT LATER
         JSB  =REPRT1          ! REPORT ERROR
         JSB  =DECUR2          ! ADDED 11-28
         POMD R36,-R6          ! RESTORE CURSOR PLACE
         JSB  =BYTCRT          ! SET CRT BYT/BAD
         JSB  =INCHR           ! GET CURRENT CHAR
         DRP  R36              ! AGAIN SET BYT/BAD
         JSB  =BYTCRT          !
         JSB  =CURS            ! SPIT OUT CURSOR
         RTN                   ! DONE
! ***********************************************************
! REPORT: REPORT ERROR MESSAGES. IN TROUBLE IF ERRTYP=0 AND R16=2.
! ***********************************************************
REPORT   LDBD R34,=ERRTYP      ! A RUNING PROGRAM?
         JZR  REP.1            ! JIF NO
         CMB  R16,=2           ! RUN MODE?
         JNZ  REP.1            ! JIF NO
         LDMD R12,=TOS         ! RESTORE R12
         LDMD R34,=ERGOTO      ! IS "ON ERROR" SET?
         JZR  REP.1            ! JIF NO
! ON ERROR GOTO/GOSUB ROUTINE
! SET RETURN TO END OF CURRENT LINE
         LDMD R36,=PCR         ! POINTER TO CURRENT LINE
         LDMD R74,R36          ! GET LINE#, LEN, AND 1ST TOKEN
         JSB  =SKPLN           ! MOVE PTR TO START OF NEXT LINE
         CMB  R77,=207         ! DEF?
         JNZ  REP.1A           ! JIF NO
         SBM  R36,=3,0         ! BACK UP 3 EXTRA
REP.1A   DCM  R36              ! NOW BACK ONE
         STMD R36,=ONFLAG      ! STORE RETURN
         CLM  R10              ! CLEAR ERRORS
         STMD R10,=ERRORS      !   AND ERRTYP
         STBD R10,=ERRROM      !   AND ERROR ROM#
         LDM  R10,R34          ! GET ADDRESS
         JSB  =SETTR1          ! SET TRACE FLAG
         ANM  R17,=37          ! CLEAR IMMED AND ERROR
         LDB  R16,=7           ! RUN AT MIDDLE OF LINE
         RTN                   !
!
REP.1    LDM  R30,=LAST+1      ! INIT OUTPUT BUFFER PTR
! ***********************************************************
! REPRT1 IS CALLED BY BOTH REPORT AND REPORP TO REPORT THE ERROR
! ***********************************************************
REPRT1   LDM  R42,=105,162,162,157,162,40 ! "Error "
         PUMD R42,+R30         ! TO OUTPUT
! ***********************************************************
! REPRT- ENTRY FROM "WARN"
! ***********************************************************
! NOW PUSH OUT ERROR NUMBER IN DECIMAL
REPRT-   JSB  =ERNUM.          ! FLOATING POINT TO STACK
         JSB  =ONEI            ! BCD TO R40
         LDM  R36,R45          ! GET 2-BYTE NUMBER
         JSB  =DCLIN#          ! DECOMPILE AS LINE#
         ANM  R17,=77          ! CLEAR ERROR FLAG
         LDM  R40,=157,156,40,154,151,156,145,40 ! "on line "
         LDBD R36,=ERRTYP      ! RUN OR GET?
         JZR  GETMSG           ! JIF NO
         LDMI R36,=PCR         ! FIND LINE#
         PUMD R40,+R30         ! PUSH "on line "
         JSB  =DCLIN#          ! AND OUTPUT LINE#
GETMSG   SAD                   ! SAVE STATUS
         LDBD R36,=R60K        ! GET ROM#
         PUBD R36,+R6          !   AND SAVE IT
         BIN                   ! FOR ADDS
         LDM  R36,=72,40       ! ": "
         PUMD R36,+R30         ! PUSH TO OUTPUT
         CLM  R36              ! CLEAR 37 FOR POSLP
         LDBD R36,=ERRROM      ! ROM#
         STBD R36,=RSELEC      ! SELECT IT
         LDBD R36,=ERRORS      ! GET ERROR#
         CLM  R26              ! CLEAR ERRORS AND ERRTYP
         STMD R26,=ERRORS      !
         STBD R26,=ERRROM      !   AND ERROR ROM#
         LDMD R26,=R60+10      ! GET ADDRESS OF ROM ERROR MESSAGE TABLE
         TSB  R36              ! MESSAGE FROM ROM?
         JPS  DOERM            ! JIF YES
! MESSAGE CAME FROM BPGM IN ONE'S COMPLEMENT
         NCB  R36              ! BACK TO POSITIVE
         LDMD R26,=BINTAB      ! GET BPGM BASE ADDR
         JZR  DOERM            ! SAFETY VALVE IF NOT THERE
         LDMD R26,X26,B.ERRM   ! GET BPGM ERRMSG TABLE ADDRESS
DOERM    JSB  =POSLP           ! PUSH ERROR MESSAGE TO OUTPUT BUFFER
         LDM  R26,=ERRBUF      ! LOC OF OUTPUT FOR OUTSTR
         CLB  R36              !
         STBD R36,=RSELEC      ! SELECT ROM# 0 FOR DISP.
         LDB  R36,=15          ! ADD CARRIAGE RETURN
         PUBD R36,+R30         !   TO OUTPUT
         SBM  R30,R26          ! CALCULATE LENGTH
         STM  R30,R36          ! MOVE FOR OUTSTR
BACKUP   LDMD R40,=SCTEMP      ! SAVE SCTEMP
         PUMD R40,+R6          !
         LDMD R40,=CS.C.       ! GET CRT SELECT CODE
         STMD R40,=SCTEMP      !
         JSB  =DRV12.          ! PRINT IT
         POMD R40,-R6          ! RESTORE SCTEMP
         STMD R40,=SCTEMP      !
         CMB  R17,=300         ! ANY DRIVER ERRORS?
         JCY  DRVERS           ! JIF YES
         JSB  =STBEEP          ! BEEP AT THE TURKEY
         POBD R36,-R6          ! GET BACK ROM#
         STBD R36,=RSELEC      !   AND SELECT IT
         PAD                   ! RESTORE BIN/BCD
         RTN                   ! DONE
!
DRVERS   CLM  R40              ! RESET CRT TO CRT
         STMD R46,=ERRORS      ! CLEAR ERRORS, TOO!!
         LDB  R47,=20          ! SELECT CODE 1
         STMD R40,=CS.C.       !   TO "CRT IS" SELECT CODE
         ANM  R17,=77          ! DUMP ERRORS
         JMP  BACKUP           ! FINISH
! ***********************************************************
! PRINT WARNING ERROR
! ***********************************************************
WARN     STMD R36,=ERRTMP      ! SAVE R36
         POMD R36,-R6          ! GET RETURN ADDR
         SAD                   ! SAVE STATE
         BIN                   ! DO BINARY INC
         ICM  R36              ! BUMP PAST ERROR#
         PAD                   ! RESTORE STATUS SO WE CAN PUSH ADDR
         PUMD R#,+R#           ! PUSH MODIFIED RTN ADDR BACK
         SAD                   ! SAVE STATUS AGAIN
         PUMD R2,+R#           ! SAVE R2
         JSB  =SAVREG          ! SAVE REGISTERS
         PUMD R50,+R#          ! SAVE R50
         PUMD R70,+R#          ! SAVE R70
         CLM  R30              ! ZERO R31
         POBD R30,-R36         ! GET ERROR#
WARN+N   CMBD R31,=ERRORS      ! SEE IF FATAL ERRORS SET
         JNZ  WRNRTN           ! RETURN - FATAL OVERRIDE
         TSB  R16              ! CALC MODE?
         JOD  NOTCLC           ! JIF YES
         JZR  NOTCLC           ! JIF PARSE ERR (OVF)
         DCB  R31              ! SET ERRTYP "ON LINE:"
NOTCLC   STMD R30,=ERRORS      !  OR JUST "ERROR:"
         JSB  =SETERN          ! SET ERNUM#, ERLIN#, ERROM
         LDM  R30,=ERRBUF      !
         PUMD R0,+R6           ! EVERYBODY SURVIVES WARN
         PUMD R14,+R6          ! SAVE
         PUMD R40,+R6          ! SAVE
         LDM  R40,=127,141,162,156,151,156,147,40 ! "WARNING "
         PUMD R40,+R30         !   TO ERRBUF
         JSB  =REPRT-          ! REPORT THE ERROR
         POMD R40,-R6          ! RESTORE
         POMD R14,-R6          ! RESTORE
         POMD R0,-R6           ! RESTORE
WRNRTN   POMD R70,-R6          ! RESTORE
         POMD R50,-R6          ! RESTORE
         JSB  =RSTREG          ! RESTORE
         POMD R2,-R#           ! RESTORE
         LDMD R36,=ERRTMP      ! RESTORE
         PAD                   ! RESTORE STATUS
         RTN                   ! DONE
! ***********************************************************
! PRINT DEFAULT ERROR MESSAGE
! ***********************************************************
DFWARN   ICE                   ! SET FOR HOMER
         LDM  R36,R20          ! MOVE ERROR NUMBER
         POMD R20,-R6          ! RESTORE R20
         SAD                   ! SAVE STATUS
         PUMD R2,+R6           ! SAVE R2
         JSB  =SAVREG          ! SAVE REGISTERS
         PUMD R50,+R#          ! SAVE R50
         PUMD R70,+R#          ! SAVE R70
         LDM  R30,R36          ! MOVE FOR WARN
         JMP  WARN+N           ! DO IT
!
SETERN   STB  R#,R37           ! SAVE ERRN
         LDBD R36,=ERRROM      ! ERROR ROM#
         STBD R36,=ERROM#      !
         JZR  STERN            ! JIF ROM 0
         BIN                   !
         ADB  R37,=144         ! 100D
STERN    STBD R37,=ERNUM#      ! SET DEFAULT ERROR#
         CMB  R16,=2           ! RUN?
         JNZ  SETRTN           ! JIF NO
         LDMI R36,=PCR         ! GET CURRENT LINE#
         STMD R36,=ERLIN#      ! SAVE IT
SETRTN   RTN                   ! DONE
! ***********************************************************
! ERROR ROUTINE (REPORT ERROR AND THROW AWAY ONE RETURN)
! TEST ERROR FLAG "ERRORS"
! IF IT IS ALREADY SET, LEAVE IT ALONE
! IF NOT, STORE ERROR NUMBER THERE
! ***********************************************************
ERROR+   CLE                   ! FLAG ERROR+
         ICE                   ! WITH E=1
         JMP  ERR+1            !
!
ERROR    CLE                   ! FLAG NORMAL RETURN (E=0)
ERR+1    STMD R36,=ERRTMP      ! SAVE R36
         POMD R36,-R6          ! GET RETURN ADDRESS
         SAD                   ! SAVE STATUS FOR BIN
         BIN                   ! WHAT A PAIN!
         ICM  R36              ! STEP PAST ERROR NUMBER
         PAD                   ! DON'T CARE ANY MORE
         JEN  ERRTN+           ! JIF RETURN TO BE IGNORED
         PUMD R#,+R#           ! PUSH BACK ONTO STACK
ERRTN+   PUMD R20,+R#          ! SAVE R20
         CLE                   ! PRESET FOR HOMER
         POBD R20,-R36         ! GET ERROR NUMBER
         LDBD R21,=ERRORS      ! SEE IF ERRORS SET
         JNZ  ERROTN           ! IF NONZERO, DO NOTHING
         CLB  R21              !
         CMB  R16,=2           ! ARE WE IN RUN STATE?
         JNZ  DEFAU?           ! JIF NOT, NO "ON ERROR"
! "ON ERROR" HAS HIGHER PRIORITY THAN "DEFAULT"
         LDMD R36,=ERGOTO      ! SEE IF "ON ERROR SET
         JNZ  NODEFA           ! JIF YES, NO DEFAULT CHK
! THIS TEST STOPS "DEFAULT" FROM NULLIFYING ERROR
! "DEFAULT" MEANS NO REAL ERROR, JUST RETURN E#0
DEFAU?   CMBD R21,=DEFAUL      ! IS DEFAULT SET?(R21=0)
         JZR  NODEFA           ! JIF NO
         CMB  R20,=11          ! <11, OK FOR DEFAULT?
         JNC  DFWARN           ! JIF YES, DO WARNING
         CMB  R20,=367         ! BPGM DEFAULT?
         JCY  DFWARN           ! JIF YES, DO WARNING
! IF R16 IS ODD, CLEAR ERRTYP (NO LINE NUMBER)
! IF R16 IS EVEN, SET ERRTYP (LINE NUMBER)
! REPORT WILL LOOK AT ERRTYP TO DECIDE WHETHER
! OR NOT TO REPORT "ON LINE NUMBER"
NODEFA   TSB  R16              ! FLAG "ON LINE"?
         JOD  STOR20           ! JIF CALC MODE (NO)
         JZR  STOR20           ! JIF PARSING (NO)
         DCB  R21              ! FLAG "ON LINE"
STOR20   STMD R20,=ERRORS      ! PUT ERROR NUMBER THERE
         JSB  =SETERN          ! SET ERNUM#,ERLIN#,ERROM
         LDB  R20,=300         ! FLAG ERRORS
         ORB  R17,R20          !   INTO R17
ERROTN   POMD R20,-R6          ! RESTORE
         LDMD R36,=ERRTMP      ! RESTORE
         RTN                   ! DONE
! =========================================================
! RUNTIME ROUTINE FOR 'BEEP'
! =========================================================
! *********************************************************
! THE RELATION BETWEEN BEEP PARAMETERS AND REAL LIFE
! FREQUENCY (F) AND DURATION (T) ARE:
!   P1 = 613062.5 / (11*F) - 134/11
!   P2 = T * 613062.5 / (11*P1 + 134)
! WHERE F = FREQ IN HERTZ, T = DURATION IN SECONDS
! *********************************************************
         BYT  241              ! ATTRIBUTES
BEEP.    JSB  =TO?I            ! GET OPTIONAL INTEGERS
         LDM  R30,=40,0        ! SET ON, OFF BYTES
! R45 IS FREQUENCY, R55 IS DURATION
         JEZ  STBEEP           ! JIF NO PARAMETERS
         LDM  R32,R45          ! TRUNCATE FREQUENCY
         ARP  R32              ! FOR LATER
         CLB  R34              ! PRESET 0
! BEGIN OUTER TIMING LOOP - 123*P1 CYCLES
HORN     STBD R31,=KEYSTS      ! TURN OFF HORN 2+6
         LDM  R34,R#           ! GET FREQ FROM R32 2+6
! BEGIN INNER TIMING LOOP - 11 CYCLES
TIME1    DCM  R#               ! COUNT DOWN R34 6*(P1+1)
         JCY  TIME1            ! JIF NOT DONE 5*(P+1)
! END OF INNER TIMING LOOP
         STBD R30,=KEYSTS      ! TURN ON HORN -1+2+6
         LDBD R34,=SVCWRD      ! KEY? 2+6
         JOD  ABORT            ! JIF YES 4
         LDB  R34,=6           ! KILL 60 CYCLES 5
KILTIM   DCB  R#               ! COUNT DOWN 5*7
! SET POSITIVE PULSE AT 107 CYCLES (174 MICROSECS)
         JCY  KILTIM           ! JIF MORE 5*7
         DCM  R55              ! COUNT DOWN DURATION 2+7
         JCY  HORN             ! JIF MORE 5
! END OF OUTER TIMING LOOP
ABORT    STBD R31,=KEYSTS      ! TURN OFF HORN
         RTN                   ! DONE WITH BEEP
!
! STBEEP FOR BEEP WITH NO PARAMETERS OR STANDARD BEEP (AS IN ERRORS)
!
STBEEP   LDB  R31,=6           ! 6 RETRACES APPROX. 100
         LDB  R36,=100         ! STANDARD TONE
         STBD R36,=KEYSTS      ! TO KEYBOARD CONTROLLER
         JSB  =CNTRTR          ! COUNT RETRACES ON CRT
         JMP  ABORT            ! TURN OFF BEEPER
! **************************************************************
! CHARACTER EDITOR
! **************************************************************
CHEDIT   CLE                   ! E not 0 indicates CR seen
         BIN                   !
         JSB  =CHIDLE          ! call keyboard hook in RAM
         JSB  =DECUR2          ! turn off both cursor
         LDMD R22,=CRTBYT      ! get cursor address
         CLM  R32              ! 0 IN R33
         LDBD R32,=KEYHIT      ! get keycode pressed
         CMB  R32,=236         ! is it ROLL UP?
         JZR  ROLLEM           ! JIF YES
         CMB  R32,=237         ! is it ROLL DOWN?
         JZR  ROLLEM           ! JIF YES
         CMB  R32,=222         ! is it CLEAR SCREEN?
         JNZ  TSPPAP           ! JIF NO
         JSB  =CLEAR.          !
         JMP  COLTST           !
TSPPAP   CMB  R#,=212          ! is it PAPER ADVANCE?
         JNZ  TSCOPY           ! JIF NO
         JSB  =PAPER.          ! ELSE ADVANCE PAPER
         JMP  COLTST           !
TSCOPY   CMB  R#,=211          ! is it COPY?
         JNZ  TSPAUS           ! JIF NO
         JSB  =COPY.           ! ELSE DO COPY
         JMP  COLTST           !
TSPAUS   CMB  R#,=216          ! is it PAUSE?
         JNZ  TSGRA            ! JIF NO
         JSB  =PAUS.+          ! DO PAUSE
         JMP  COLTST           !
TSGRA    CMB  R#,=223          ! is it GRAPH?
         JNZ  TSKLBL           ! JIF NO
         JSB  =GRAPH.          ! DO GRAPH
         JMP  COLTST           !
TSKLBL   CMB  R#,=226          ! is it KEY LABEL?
         JNZ  TSINPT           ! JIF NO
         JSB  =KEYLA.          ! DO KEY LABEL
         JMP  COLTST           !
TSINPT   CMB  R16,=4           ! are we idling in INPUT statement?
         JNZ  TSRUN            ! JIF NO
         CMBD R33,=CRTWRS      ! INPUT IN GRAPHICS?
         JZR  NOINPG           ! JIF NO, ALPHA mode INPUT
         LDMD R56,=INPTR       ! GET INPUT PTR
         CMB  R32,=231         ! is it BACKSPACE? (in GRAPHICS INPUT)
         JNZ  NOTBS.           ! JIF NO
         CMM  R56,=INPBUF      ! AT START OF BUFFER?
         JZR  COLTST           ! JIF YES
         POBD R32,-R56         ! POP CHARACTER FROM BUFFER
         STMD R56,=INPTR       ! UPDATE INPTR
         LDMD R76,=XMAP        ! BS IN GRAPHICS
         SBM  R76,=10,0        !
         STMD R76,=XMAP        ! BACK 8 DOTS
         JSB  =COMPLI          ! COMP. FOR REMOVAL
         JSB  =IMGSUB          ! ADDRESS, SEND CHAR.
         JSB  =COMPLI          ! RESTORE PEN SENSE
COLTST   CLE                   ! "LIVE KEYS" MAKING SURE E IS CLEAR (NO CR)
         JMP  TSTREP           !
ROLLEM   JMP  SPEDIT           ! RELAY JUMP
TSRUN    CMB  R#,=2            ! are we in RUN mode?
         DRP  R32              !
         JNZ  CHED1            ! JIF no
         CMB  R32,=215         ! is it RUN key?
         JNZ  CHED1            ! JIF no
         LDB  R32,=253         ! RUN TYPING AID
         JMP  CHED1            !
NOTBS.   CMB  R#,=232          ! is it END LINE (enter, return)?
         JNZ  NOTCR.           ! JIF no
         LDB  R#,=15           ! get a CR character
         ICE                   ! flag that CR seen
NOTCR.   JEN  PUBDCR           ! JIF CR SEEN, PUSH IT
         CMM  R56,=LAST+1      ! at end of INPBUF?
         JZR  COOLIT           ! JIF yes
PUBDCR   PUBD R32,+R56         ! else add char to end of INPUT string
         STMD R56,=INPTR       ! save new pointer
         JEN  COOLEX           ! JIF it was CR, EXIT
         JSB  =INGRAF          ! SPIT OUT CHAR
         JMP  COOLIT           !
NOINPG   CMB  R32,=231         ! EDITING KEY (>=231)?
         JNC  NORMCH           ! JIF NO
         CMB  R32,=247         ! EDITING KEY (<=246)? (DEL, STORE, LOAD, AUTO, SCRATCH type aids)
         JCY  NORMCH           ! JIF yes, it's a typing aid
CHED1    CMB  R#,=200          ! SEE IF SPECIAL CHAR
         JCY  SPEC             ! JIF yes
         JSB  =PAUS.+          ! GO PAUSE IF NOT IDLE
NORMCH   JSB  =NO.CRS          ! CLEAN OUT CR'S
         JSB  =OUTCHR          ! DUMP CHAR TO CRT
         LDBD R57,=EDMOD2      ! INSERT MODE?
         JNZ  INSRT+           ! JIF YES
TSTREP   JSB  =CURS            ! ADD NORMAL CURSOR
         LDBD R0,=EDMOD2       ! INSERT MODE?
         JZR  COOLIT           ! JIF REPLACE, 1 CURSOR
         JSB  =LTCUR.          ! MOVE BACK 1
         JSB  =CURS            ! EXTRA CURSOR
         JSB  =RTCUR.          ! MOVE FWD 1
COOLIT   JEN  COOLEX           ! JIF CR SEEN, SKIP COUNTK
         JSB  =COUNTK          ! CHECK REPEATING KEY
COOLEX   RTN                   ! GO BACK
!
SPEC     CMB  R#,=210          ! FUNCTION KEYS
         JNC  FNKEY            ! JIF yes
         CMB  R16,=4           ! idling in INPUT statement?
         JZR  SPEC1            ! JIF yes
         JSB  =PAUS.+          ! GO PAUSE IF NOT IDLE
SPEC1    CMB  R32,=250         ! typing aid key?
         JCY  TYPADS           ! jif yes
         CMB  R32,=227         ! immediate EXECUTE keys?
         JNC  IMMEDJ           ! jif yes
SPEDIT   PUMD R#,+R6           ! SAVE R32
         JSB  =ALPHA.          ! SET TO ALPHYA IF NOT THERE
         JSB  =DECUR2          ! REMOVE CURSORS
         POMD R32,-R6          ! RESTORE R32
         SBB  R32,=231         ! KEYCODE OFFSET OF 210
         LLM  R32              ! DOUBLE
         LDMD R32,X32,KEYDEF   ! GET ROUTINE ADDRESS
!
         JSB  X32,ZRO          ! CALL THE CODE FOR THE KEY
!
         JMP  TSTREP           ! CURS AND COUNTK
!
IMMEDJ   JMP  IMMEDK           ! JUMP TO IMMEDIATE
!
! INSERT CHARACTER IN LINE
!
INSRT+   JSB  =LTCUR.          ! COUNTERACT FTCHLN
         LDM  R56,=INPBUF      ! SET UP FOR FTCHLN
         POBD R32,+R56         ! POP ORIGINAL CHARACTER
         CMB  R32,=15          ! WAS IT CR?
         JZR  CRONLY           ! JIF YES
         JSB  =FT+CUR          ! FTCHLN & RECURS
CRONLY   JSB  =RTCUR.          ! MOVE RIGHT BEFORE SENDING BACK
         JSB  =DELECR          ! SPIT OUT CR ONLY
         JSB  =RTCUR.          ! STEP RIGHT, NEXT INSERT
TSTJMP   JMP  TSTREP           ! CURS AND COUNTK
!
! USER KEYS 200-207. SHIFT OUT THE "2" FOR INDEX
!
FNKEY    JSB  =SETTR1          ! FUNCTION KEYS
         BIN                   ! SET TRACE FLAG
         TSB  R16              !
         JOD  KOUT             ! JIF in CALC mode
         JZR  KOUT             ! JIF in IDLE mode
         LLB  R32              ! get rid of upper bit and double the key# (200-207 >> 000-160)
         LDMD R32,X32,KEYTAB   ! get jump address
         JZR  KOUT             ! JIF no ON KEY jump address
         LDMD R36,=ONFLAG      ! ON GOSUB active?
         JNZ  KOUT             ! JIF yes, can't do it now
         STMD R10,=ONFLAG      ! else save BASIC PC there (STORE RETURN)
         LDM  R10,R32          ! jump BASIC program to that address
         LDB  R16,=7           ! change mode to RUN MODE IN MID STATEMENT
KOUT     CLE                   ! no CR
         JSB  =EOJ2            ! NO REPEAT FN KEYS
         JSB  =CURS            ! RESTORE CURSOR
         RTN                   ! DONE
!
! TYPING AIDS
!
TYPADS   JSB  =NO.CRS          ! CLEAN OUT CR'S
         LDM  R30,=INPBUF      ! SET DESTINATION
         LDM  R26,=ASCIIS      ! TOKEN TABLE ADDRESS
         ADB  R32,=130         ! SAME AS SBB R32,=250 (GET OFFSET OF 0,1,2,3,4,5)
         CLM  R36              ! FOR MULTI
         LDBD R36,X32,TYPTOK   ! TRANSLATE INDEX INTO TOKEN-45
         JSB  =POSLP           ! COPY THE TOKEN NAME INTO INPBUF
         LDM  R26,=INPBUF      ! START OF DATA
         LDM  R36,R30          ! GET LENGTH OF NAME
         SBM  R36,R26          !
         JSB  =HLFLIN          ! OUTPUT THE KEY/TOKEN NAME TO SCREEN WITH NO CR
         JMP  TSTJMP           ! CLEAN UP THE KEY
!
IMMEDK   CLM  R74              ! CLEAR AUTO & INSERT MODE
         STMD R74,=AUTO#       !   AND LINE NUMBER
         STBD R74,=EDMOD2      ! CLEAR INSERT MODE
         LDB  R16,=1           ! SET CALC MODE
         SBB  R32,=210         ! SUB BASE KEYCODE OF IMM KEYS (MAKE INDEX)
         LDBD R32,X32,KEYLST   ! CONVERT KEY TO TOKEN NUMBER
         LDB  R33,=16          ! END OF LINE TOKEN FOR ALLOCATE
         STMD R12,=STSIZE      ! SAVE STACK PTR
         PUMD R32,+R12         ! PUSH TOKEN AND EOL
         JMP  KOUT             ! THROW AWAY REPEATED KEY
!
! CARRIAGE RETURN KEY
!
CRCHAR   JSB  =CLEDM2          ! CLEAR INSERT MODE
         LDM  R36,=76,0        ! FOR RIGHT SIDE SCREEN
         ORM  R36,R22          ! POINT TO END LINE
MOVUP1   SBM  R36,=100,0       ! MOVE UP A LINE
         ANM  R36,=377,17      ! KEEP IT IN ALFA IN CASE OF ADDR WRAP
         JSB  =BYTCRT          ! SET CRTBYT,BAD
         JSB  =INCHR           ! GET THE CHAR THERE
         CMB  R#,=15           ! CR?
         JZR  GOFTCH           ! JIF YES
         JSB  =RTCURS          ! ELSE MOVE TO NEXT LINE
! RTCURS LEAVES CRTBYT IN R34
         CMMD R#,=CRTRAM       ! AT TOP OF SCREEN?
         JZR  GOFTCH           ! JIF YES
         ICB  R0               ! INC LINE COUNT
         CMB  R0,=3            ! 3 LINES?
         JNZ  MOVUP1           ! JIF NO
GOFTCH   LDM  R56,=INPBUF      ! WHERE TO PUT THE LINE
         JSB  =FTCHLN          ! GET INTO INPBUF
! INPBUF IS NOW LOADED - SET UP CURSOR POSITION
! ON FIRST CHAR OF NEXT LINE
         LDB  R76,=76          ! FOR OR TO FOLLOW
         LDMD R66,=CRTBYT      ! LAST BYTE FETCHED
         ORB  R66,R76          ! MOVE TO END OF LINE
         JSB  =BYTCRT          ! TELL CRT
         JSB  =INCHR           ! DON'T DESTROY THIS CHAR
         JSB  =RECURS          ! RESTORE POSITION
         JSB  =OUTCHR          ! SPIT AND MOVE TO NEXT LINE
         ICE                   ! FLAG LINE DONE
         RTN                   ! DONE
! FTCHLN IS USED BY INSERT, DELETE, AND C.R.
! IT FILLS INPBUF WITH CHARACTERS FROM CRT
FTCHLN   DRP  R36              ! FOR BYTCRT
         JSB  =BYTCRT          ! ALIGN BYTE TO BEG.
CRLOOP   JSB  =RTCURS          ! MOVE CURSOR RIGHT
         JSB  =BOTMR?          ! TEST FOR BOTTOM
         JNZ  DOINCH           ! JIF NO
         JSB  =SCRBLK          ! SCROLL BLANK LINE
         JMP  LODCR            ! PUSH CR
DOINCH   JSB  =INCHR           ! FETCH THIS CHAR
PUCR     PUBD R#,+R56          ! STORE IT
         CMB  R#,=15           ! DONE?
         JZR  FTRTN            ! JIF YES
         CMM  R56,=LAST+1      ! CHECK FOR 96
         JNZ  CRLOOP           ! ALLOW ONLY 96
LODCR    LDB  R32,=15          ! FOR CR TO BUFFER
         JMP  PUCR             ! GO PUSH IT
!
RECURS   DRP  R66              ! RESTORE CURSOR POSITION
         JSB  =BYTCRT          ! AS CRT ADDR
FTRTN    RTN                   ! DONE
!
BKSPC    JSB  =CLEDM2          ! CLEAR INSERT MODE
         JSB  =INCHR           ! FETCH CURRENT CHAR
         JSB  =LTCUR.          ! MOVE CURSOR LEFT
         ANM  R#,=76,377       ! GET COLUMN NUMBER (2 NIBBLES PER CHAR)
         CMB  R#,=76           ! END OF LINE?
         JNZ  NOTEND           ! JIF NO
         JSB  =INCHR           ! LOOK FOR CR
         LDMD R34,=CRTBYT      ! RESTORE POSITION
         JSB  =BYTCRT          !   IN CRT CONTROLLER
NOTEND   CMB  R32,=15          ! IS IT A CR?
         JZR  PUTBS            ! JIF YES, WRITE IT OUT
         LDB  R32,=40          ! ELSE WRITE A BLANK
PUTBS    JSB  =OUTCH1          ! OUTPUT CR OR BLANK
         JSB  =LTCUR.          ! MOVE LEFT
         RTN                   !
!
FASTBS   JSB  =BKSPC           ! DO A BACKSPACE
         LLB  R#               !
         LLB  R#               ! DONE?
         JNZ  FASTBS           ! LOOP TIL DONE
         RTN                   !
!
NO.CRS   STB  R32,R51          ! SAVE INPUT CHAR
         JSB  =INCHR           ! FETCH IN CASE OF INSERT
         STBD R#,=INPBUF       ! PUT IN RAM BUFFER
         LDMD R66,=CRTBYT      ! GET CURSOR ADDRESS
         STM  R66,R22          ! COPY OF BYT POINTER
         ANM  R66,=300,377     ! KEEP ONLY "ROW ADDRESS" (64 NIBBLES PER ROW)
         CMM  R66,R22          ! AT START OF ROW?
         JZR  CR40DN           ! JIF YES
         LDM  R36,R22          ! INIT PTR
         JSB  =BYTCRT          ! RESTORE POSITION
CR40LP   JSB  =INCHR           ! GET CUR CHAR
         CMB  R#,=15           ! IS IT CR?
         JNZ  CR40DN           ! JIF NO
         LDB  R#,=40           ! MAKE IT A BLANK
         DRP  R36              ! SEND ADDR IN R36
         JSB  =BYTCRT          ! SET HARDWARE ADDRESS
         JSB  =OUTCHR          ! WRITE BLANK BACK OUT
         CMM  R36,R66          ! DONE?
         JZR  CR40DN           ! JIF DONE
         DCB  R36              ! MOVE LEFT
         DCB  R36              ! (TWICE, BECAUSE CRT IS NYBBLE ADDRESSES)
         JSB  =BYTCRT          ! IN HARDWARE
         JMP  CR40LP           ! LOOP BACK
CR40DN   DRP  R22              ! RESET ORIG CURSOR POSITION
         JSB  =BYTCRT          !
         LDB  R32,R51          ! RESTORE THE CHAR
         RTN                   !
!
INSRPL   LDBD R57,=EDMOD2      ! GET OLD MODE
         NCB  R57              ! FLIP IT
STO57    STBD R#,=EDMOD2       ! STORE BACK
         RTN                   !
!
CLEDM2   CLB  R0               ! CLEAR INSERT MODE
         JMP  STO57            !
!
DELETC   JSB  =CLEDM2          ! CLEAR INSERT MODE
DELET+   LDM  R56,=INPBUF      ! SET FOR FTCHLN
         JSB  =FT+CUR          ! FETCHLN & RECURS
DELECR   LDM  R26,=INPBUF      ! DELETE CALLS THIS TOO
         LDM  R36,R56          ! GET ORIGINAL PTR
         SBM  R36,R26          ! FIND LENGTH
         JSB  =OUTST+          ! SPIT OUT LINE, NO CURSOR
         DRP  R22              ! RESTORE CURSOR
         JSB  =BYTCRT          ! IN CRTBAD, CRTBYT
         RTN                   !
!
COMPLI   LDBD R0,=PLOTSY       ! TOGGLE PLOTSY
         NCB  R0               !
         STBD R0,=PLOTSY       !
         RTN                   !
!
FT+CUR   LDM  R36,R22          ! FOR FTCHLN
         STM  R36,R66          ! FOR RECURS
         JSB  =FTCHLN          ! FETCH LINE
         JSB  =RECURS          ! RESTORE POSITION
         RTN                   !
!
KEYLST   BYT  225              ! 210 REWIND
         BYT  174              ! 211 COPY
         BYT  361              ! 212 ERRORX (PAPER ADV IS IMMEDIATE)
         BYT  324              ! 213 RESET
         BYT  112              ! 214 INIT
         BYT  124              ! 215 RUN
         BYT  227              ! 216 PAUSE
         BYT  110              ! 217 CONTINUE
         BYT  362              ! 220 STEP KEY
         BYT  365              ! 221 TEST KEY
         BYT  107              ! 222 CLEAR
         BYT  136              ! 223 GRAPH
         BYT  113              ! 224 LIST
         BYT  236              ! 225 PLIST
         BYT  211              ! 226 KEY LABEL
! KEYS 227, 230 NOT USED
KEYDEF   DEF  BKSPC            ! 231 BACKSPACE
         DEF  CRCHAR           ! 232 CARRIAGE RETURN
         DEF  FASTBS           ! 233 FAST BACKSPACE
         DEF  LTCUR.           ! 234 CURSOR LEFT
         DEF  RTCUR.           ! 235 CURSOR RIGHT
         DEF  SCRUP            ! 236 SCROLL UP
         DEF  SCRDN            ! 237 SCROLL DOWN
         DEF  CLREOL           ! 240 -LINE
         DEF  UPCUR.           ! 241 UP ARROW
         DEF  DNCUR.           ! 242 DOWN ARROW
         DEF  INSRPL           ! 243 INS/RPL
         DEF  DELETC           ! 244 DEL
         DEF  HMCURS           ! 245 UP-LEFT ARROW
         DEF  RESUL.           ! 246 RESULT
! 247 UNUSED
TYPTOK   BYT  134              ! 250 DELETE
         BYT  121              ! 251 STORE
         BYT  163              ! 252 LOAD
         BYT  57               ! 253 RUN
         BYT  40               ! 254 AUTO
         BYT  63               ! 255 SCRATCH
!
! ************************************************
! * THIS IS THE MAIN PARSER CALLED BY EXEC.
! * IT WILL BE HAPPY WITH EITHER PROGRAM
! * MODE STATEMENTS, CALCULATOR MODE STATMENTS,
! * OR CALCULATOR MODE EXPRESSIONS.
! * NOTE: IF IT REALLY IS THIS SIMPLE, IT
! * SHOULD PROBABLY USE JUMPS, NOT JSB'S.
! ************************************************
PARSER   JSB  =PRSIDL          ! TRY ROM IDLE
         LDM  R10,=INPBUF      ! RESET INPUT POINTER
         STMD R10,=SAVR10      ! SAVE FOR ERROR MESSAGES
         JSB  =GCHAR           ! GET FIRST CHAR TO R20
         JSB  =INTEGR          ! GET LINE# IF ANY
         BIN                   ! RETURN TO BINARY
         LDMD R75,=ERLIN#      ! GET ERRL AND ERRN
         PUMD R75,+R6          ! ONTO STACK
         JEN  PROGRM           ! JIF LEADING DIGIT, PROGRAM OR EXPRESSION
         JSB  =C.PARS          ! DO CALC MODE STMT
         JMP  RSTORE           ! RESTORE ERRL, ERRN?
!
PROGRM   JSB  =P.PARS          ! DO PROGRAM MODE
         TSB  R17              ! ANY ERRORS?
         JPS  RSTORE           ! JIF NO
         ICB  R16              ! SET CALC
         LDMD R12,=STSIZE      ! RESET R12 TO
         DCM  R12              !   STSIZE - 2 TO MAKE
         DCM  R12              !   UP FOR LINE NUMBER
         JSB  =E.PARS          ! DO EXPRESSION PARS
RSTORE   POMD R75,-R6          ! RESTORE STACK
         TSB  R17              ! ANY ERRORS NOW?
         JNG  PSRTN            ! JIF YES, DONT RESTORE
         STMD R75,=ERLIN#      ! NOW ERRN WILL WORK
PSRTN    RTN                   ! DONE
!
! **************************************************
! PARSIT - MAIN PARSER INNER LOOP, CALLED
!   BY P.PARS, C.PARS, AND PARSTP
! **************************************************
PARSE@   PUBD R#,+R12          ! FOR LINE CONTIN
PARSIT   JSB  =SCAN            ! GET A BASIC STATEMENT
PARSE!   CMB  R14,=4           ! IS IT A VARIABLE?
         JCY  NOT123           ! JIF NO
         LDB  R14,=221         ! IMPLIED LET TOKEN
         LDB  R47,=200         ! BASIC STMT
         JMP  BASIC?           ! DONT LOAD 14 WITH 43
NOT123   LDB  R#,R43           ! KILL 370 AND 371!
! WE KNOW THE CORRECT ROM IS NOW SELECTED
BASIC?   LDMD R36,=THENFL      ! NEED TO CHECK THEN?
         DRP  R47              ! SAVE A DARP
         JZR  NOTHEN           ! JIF NOT IF-THEN
         CMB  R47,=300         ! LEGAL AFTER THEN?
         JCY  THENER           ! JIF NO
NOTHEN   CMB  R#,=200          ! SEE IF SYSTEM TOKEN
         JCY  TYPEOK           ! JIF NO, DONT CHECK 16
         CMB  R#,=100          ! BASIC SYSTEM CALL?
         JNC  PRSERR           ! JIF NO, NOT BASIC
         TSB  R16              ! SYS MUST BE CALC MODE
         JEV  PRSERR           ! JIF NOT, ERROR
TYPEOK   LDMD R36,=R60+6       ! GET ROM PARSE ADDR
         TSB  R42              ! BUT IS IT A BINARY?
         JZR  PRSADR           ! JIF NO
         LDMD R36,X41,THIRT6   ! REPLACE WITH BINARY
PRSADR   ADM  R36,R14          ! ADD THE OFFSET
         ADM  R36,R14          !  *2
         LDMD R36,R36          ! GET PARSE ADDRESS
         JSB  X36,ZRO          ! JSB TO THE ROUTINE
         TSB  R17              ! SEE IF ERROR FOUND
         JNG  PRSRTN           ! JIF ERROR FOUND
         CMB  R14,=233         ! IN LINE COMMENT?
         JZR  PARSE!           ! JIF YES
         CMB  R14,=100         ! LINE CONTINUATION?
         JZR  PARSE@           ! JIF YES, CONTINUE
PRSRTN   RTN                   ! DONE
!
EOL      BIN                   ! FOR REPEAT PARSES
         CMB  R14,=15          ! ARE WE DONE?
         JZR  EOLOK            ! JIF YES, OK
!
         JSB  =ERROR           ! CR NOT FOUND
         BYT  84D              ! (ERROR 84d) FALL THRU TO EOL
!
EOLOK    LDB  R36,=16          ! PUSH LINE TERMINATOR
         PUBD R36,+R12         ! TO OUTPUT
         RTN                   ! DONE
!
PRSERR   JSB  =ERROR+          ! BAD BASIC STMT
         BYT  88D              ! 88d
!
THENER   JSB  =ERROR+          ! ILLEGAL AFTER THEN
         BYT  86D              ! 86d
!
! ****************************************************
! P.PARS - PROGRAM MODE PARSE.
!          A LEADING INTEGER (POSSIBLE LINE#)
!          HAS BEEN SEEN
! ****************************************************
P.PARS   LDM  R36,R40          ! VERIFY LINE NUM
         STMD R36,=AUTO#       ! FOR TAPE ERRORS, AUTO
         PUMD R36,+R12         ! PUSH TO OUTPUT
         STMD R12,=STSIZE      ! SAVE POSITION
         ICM  R12              ! SAVE SPACE FOR SIZE
         TSM  R36              ! IS LINE # ZERO?
         JZR  ERR90            ! JIF YES, ERROR
         TSM  R42              ! LN > 5 DIGITS?
         JNZ  ERR90            ! JIF YES
         CMB  R20,=15          ! NULL LINE?
         JZR  NULEOL           ! JIF YES (DONE)
! AFTER CHECKING NULL AN DVALID LINENO, CHECK
! TO SEE IF THERE ARE 256 BYTES AVAILABLE FOR PARSER
         LDMD R34,=LAVAIL      ! IS THERE ROOM?
         SBM  R34,=0,2         ! LAVAIL - R12 > 512?
         CMM  R34,R12          ! (LAVAIL - 512 > R12?)
         JCY  ROOMOK           ! JIF YES
!
ERR19Z   JSB  =ERROR+          ! MEMORY OVERFLOW
         BYT  19D              ! 19d
!
ROOMOK   JSB  =PARSIT          ! PARSE THE STATEMENT
NULEO-   JSB  =EOL             ! DO END OF LINE
NULEOL   BIN                   ! FOR ADDITION
         LDMD R36,=STSIZE      ! CALCULATE (-) SIZE
         SBM  R36,R12          !  OF STATEMENT
         NCM  R36              ! MAKE IT POSITIVE
         TSB  R37              ! MORE THAN 256 BYTES?
         JZR  LINSIZ           ! JIF OK
!
         JSB  =ERROR           !
         BYT  85D              ! 85d EXPR TOO BIG
!
LINSIZ   STBI R36,=STSIZE      ! INSERT INTO STMT
         CLB  R16              ! MUST BE IN IDLE!!!!
         JSB  =LINEDR          ! EDIT IN THE LINE
! ---------------------------------------------------
! UPDATE AUTO LINE NUMBER IF APPLICABLE.  NOT
! THAT PROGRAM MODE PARSE IS THE ONLY TIME
! WHEN AUTO NUMBERING CAN BE ACTIVE.
! IF THE LINE HAD ERRORS, JUST LEAVE AUTO#
! ALONE, IT CAN RESUME WHEN LINE CORRECT (?)
! ---------------------------------------------------
         LDM  R30,=INPBUF      ! FOR DCLIN#
         TSB  R17              ! ANY ERRORS?
         JNG  P.PRTN           ! JIF YES, DONT MESS
         LDMD R36,=AUTOI       ! IN AUTO MODE?
         JZR  P.PRTN           ! JIF NO
         BCD                   ! FOR BCD LINE NUMBERS
         ADMD R36,=AUTO#       ! ADD CURRENT LINE#
         JNC  PUTAUT           ! JIF <= 9999
         CLM  R36              ! ELSE MAKE IT ZERO
PUTAUT   JSB  =DCLIN#          ! DECOMPILE LINE#
         LDM  R26,=INPBUF      ! START FOR HLFLIN
         SBM  R30,R26          ! GET LENGTH OF LINE#
         STM  R30,R36          ! MOVE FOR HLFLIN
         JSB  =HLFLIN          ! SPIT OUT STRING
         JSB  =CURS            ! SPIT OUT CURSOR
P.PRTN   RTN                   ! PROGRAM PARSE DONE
!
ERR90    JSB  =ERROR+          !
         BYT  90D              ! 90d ILLEGAL LINE#
!
! *****************************************************
! C.PARS - CALCULATOR MODE PARSE
! *****************************************************
C.PARS   LDMD R36,=LAVAIL      ! IS THERE ROOM?
         SBM  R36,=0,1         ! LAVAIL - R12 > 256?
         CMM  R36,R12          ! (LAVAIL - 256 > R12?)
         JNC  ERR19Z           ! JIF NO
         CLM  R54              ! CLEAR AUTO#
         STMD R54,=AUTO#       ! FOR ALL CALC MODE
         STMD R12,=STSIZE      ! SAVE START LOC
         TSB  R16              ! STATE ACCEPTABLE?
         JOD  ERR88            ! JIF NO
         ICB  R16              ! MAKE R16 ODD
         JSB  =PARSIT          ! TRY BASIC STATEMENT PARSE
         TSB  R17              ! SUCCESSFUL?
         JPS  C.PDUN           ! JIF YES, DUN
         LDMD R12,=STSIZE      ! RESET R12
! *****************************************************
! E.PARS IS EXPRESSION PARSE, FOR USE AFTER
! NORMAL PARSE HAS FAILED IN CLAC MODE,
! OR NORMAL SYSTEM PARSE HAS FAILED ON A
! STATEMENT OF THE TYPE 10 * 3 (THE 10 LOOKED
! LIKE A LINE NUMBER.
! *****************************************************
E.PARS   STMD R12,=STSIZE      ! SET IT
         ANM  R17,=77          ! CLEAR ERROR BITS
         LDMD R36,=ERRORS      ! SAVE PARSE ERROR
         PUMD R36,+R6          !   ON STACK
         LDMD R45,=ERLIN#      ! SAVE OLD ERLIN,NUM
         PUMD R45,+R6          !   ON STACK
         LDMD R36,=SAVR10      ! PARSER POINTER
         PUMD R36,+R6          !   ON STACK
         CLM  R36              ! ZERO ERRORS
         STMD R36,=ERRORS      !   AND TRY FRESH
         LDM  R10,=INPBUF      ! RESET INPUT BUFFER
         JSB  =SCAN+           ! DO INITIAL SCAN
         JSB  =NUMVAL          ! TRY NUMERIC VALUE
         JEN  EXPFND           ! JIF FOUND
         JSB  =STREXP          ! ELSE TRY STRING EXPRESSION
EXPFND   POMD R34,-R6          ! RESTORE SAVR10
         POMD R75,-R6          ! RESTORE ERLIN,NUM
         POMD R36,-R6          ! POP ERROR NUMBER
         JEZ  ERRSTR           ! JIF EXPRESSION NOT FOUND
         TSB  R17              ! ANY PROBLEMS?
         JNG  ERRSTR           ! JIF YES, RESTORE
         CMB  R14,=15          ! CARRIAGE RETURN?
         JNZ  ERRSTR           ! JIF NO, REPORT ERROR
C.PDUN   JSB  =EOL             ! GET END OF LINE
         RTN                   ! DONE
!
ERRSTR   LDMD R12,=STSIZE      ! RESET R12
         STMD R36,=ERRORS      ! YES, RESTORE OLD ERROR
         STMD R75,=ERLIN#      ! RESTORE OLD ERLIN,NUM
         STMD R34,=SAVR10      ! AND OLD SAVR10
         LDM  R34,=0,300       ! SET ERROR FLAG
         STBD R34,=RSELEC      ! SELECT ROM 0
         ORM  R16,R34          ! IN R17
         ANM  R16,=376,377     ! KILL CALC MODE?
         RTN                   ! DONE (WITH ERRORS)
!
ERR88    JSB  =ERROR+          ! BAD STATEMENT
         BYT  88D              ! 88d
!
ST240+   CLB  R16              ! SET TO IDLE
ST240-   JSB  =STOTOS          ! RESET R12 STACK TO EMPTY (TOS = STSIZE)
SET240   PUBD R36,+R6          ! SAVE REGISTER
         LDB  R36,=240         ! IMMEDIATE BREAK BITS
         ORB  R17,R36          ! SET IN R17
         POBD R36,-R6          ! RESTORE REG
         RTN                   ! DONE
! ***************************************************************
! THE SCANNER SAVES R21-37 AND R50-57
! IT USES REGISTERS 50-57
! IF THE INPUT IS:         SCANNER DOES THIS:
!   DIGIT                    FORMS INTEGER OR F.P. #
!   PERIOD                   FORMS INTEGER OR F.P. #
!   QUOTE                    RETURNS 42, NO GCHAR
!   ANYTINHG IN TABLES       RETURNS TOKEN
!   ALPHA NOT IN TABLES      RETURNS VARIABLE TYPE
!   OTHER NOT IN TABLES      RETURNS THE CHARACTER
!
! SCANNER RETURNS:
!   R40            FIRST CHAR SEARCHED
!   R41,42         ROM # (R42=0)
!       OR...      BINARY PROG ADDR (R42#0)
!       OR...      SYSTEM "ROM" (R42=R43=0)
!   R43            ROM TOKEN # (IF R14=370)
!       OR...      TYPE IF VARIABLE
!   R44,45,46      NAME IF VARIABLE (R46=UNDEF)
!       OR...      INTEGER
!       OR...      SECONDARY ATTRIBS FOR FUNCS
!   R47            CLASS (PRIMARY ATTRIB.)
!
! TOKEN RETURNS IN R14, R15=0 FOR ADDS MULTI
! FLOATING POINT NUMBERS LEAVE RESULTS ON R12 STACK
! ***************************************************************
SCAN+    JSB  =GCHAR           ! GCHAR AND SCAN
SCAN     JSB  =SAVREG          ! SAVE 21-37 AND 50-77
         JEN  SCABRT           ! JIF NO ROOM
         JSB  =SCAN++          ! DO THE SCAN
         JSB  =RSTREG          ! RESTORE THE REGS
SCABRT   BIN                   ! RESTORE STATUS
         CLB  R15              ! FOR ADM'S
         DRP  R14              ! FOR MOST PARSING
         ARP  R36              !  "      "
         CLE                   !  "      "
         RTN                   ! DONE
!
SCAN++   TSB  R17              ! ANY ERRORS?
         JNG  SCAN+3           ! DONT SAVE R10 IF SO
         STMD R10,=SAVR10      ! SAVE LAST GOOD R10
SCAN+3   CLM  R40              ! INITIALIZE FOR EVERYBODY
         STBD R40,=RSELEC      ! ASSURE ROM 0
! ********************************************
! CHECK FOR NUMBERS OF THE FORM
!    NNN.FF E +/- NN
! OR    .FF E +/- NN
! ********************************************
         JSB  =NUMBER          ! IS IT A NUMBER?
         JEN  SCRTN1           ! JIF YES (DONE)
! ********************************************
! NUMBER NOT FOUND, CALL TABLE SEARCH
! WHICH WILL FIND ANY LEGAL WORD OR CHAR
! EXCEPT VARIABLES.
! ********************************************
         STB  R20,R40          ! SAVE UNSHIFTED INPUT
         CMB  R20,=15          ! SAVE TIME IF CR
         JZR  QUOTCR           ! JIF YES
! FOR QUOTES AND CR, JUST PUSH THAT CHAR.
! FOR ALL OTHER "SPECIAL CHARACTERS" JUST BOMB
         CMB  R20,=42          ! IS IT A QUOTE?
         JZR  QUOTCR           ! JIF YES
         JSB  =ALFA            ! IS IT A VARIABLE?
         JEZ  GOSALT           ! JIF NO
         LDB  R21,=40          ! <LETTER> <BLANK> ?
         CMBD R21,R10          ! CHECK THE <BLANK>
         JZR  GETVAR           ! JIF YES, SKIP SALT
GOSALT   JSB  =SALT            ! Search ALl Tables
         JEN  SCRTN1           ! JIF FOUND, DONE
! NOTE THAT ALL SPEC CHARS ASSUME R41-R47=0
! AND THAT C.R. AND QUOTE MUST DO THIS TOO.
         JSB  =ALFA            ! A VARIABLE?
         JEZ  BADSCN           ! JIF NO
! ********************************************
! IF THE BYTE IS A SPECIAL CHARACTER, AND WAS
! NOT FOUND IN THE TABLES, IT MUST BE GARBAGE.
! THIS USED TO SET R14 TO R20, AND CAUSED A
! PROBLEM WITH APOSTROHPE LOOKING LIKE SEMICOLON.
! CHANGED AUGUST 18, 1978
! ********************************************
! FORM A VARIABLE OUT OF A SINGLE ALPHA CHAR
! AND OPTIONAL NUMBER, $, AND (
! ********************************************
GETVAR   STB  R20,R45          ! MOVE SHIFTED CHAR
         CLB  R14              ! FOR <LETTER> <BLANK>
         ICB  R14              ! SET SIMPLE VARIABLE
         LDB  R44,=40          ! BLANK TO R44
         ICB  R47              ! CLASS=1 (R47 WAS 0!)
         JSB  =GCDIG           ! DOES IT HAVE A DIGIT?
         JEZ  NODIG            ! LETTER-BLANK (A=...)
         STB  R20,R44          ! MOVE DIGIT TO CHAR2 (R44)
         JSB  =GCHAR           ! GET NEXT CHAR
NODIG    CMB  R20,=50          ! LEFT PAREN (ARRAY)?
         JZR  ICB1             ! YES, TOKEN=2
         CMB  R20,=44          ! STRING VARIABLE
         JNZ  FNDVBL           ! NO, ARITH SIMPLE VRBL
         ICB  R14              ! STRING, INCREMENT TWICE
ICB1     ICB  R14              ! AAV, INCREMENT ONCE
         JSB  =GCHAR           ! STEP OVER THE GARBAGE
FNDVBL   LDB  R43,R14          ! TYPE TO R43
SCRTN1   RTN                   ! ALL DONE
! ********************************************
! DONT WANT GCHAR FOR QUOTES, DONT NEED FOR CR
! ********************************************
BADSCN   LDB  R14,=17          ! ILLEGAL TOKEN
QUOTCR   STB  R#,R14           ! NO GCHAR AFTER "
         RTN                   ! DONE
! CLASS = 0 FOR CR AND QUOTES
!
! ********************************************
! INTEGER ROUTINE, ON RETURN R40 CONTAINS
! RIGHT JUSTIFIED INTEGER IF(!!) R36 = 15C
! - OTHERWISE IT CONTAINS INTEGER WITH AN
! EXPONENT OF (R36)-15C.
! INTEGR IS INTENDED TO BE USED BY PARSER
! AND ANY OTHER PARTIES WANTING TO IGNORE
! DECIMAL POINTS AND EXPONENTS, SUCH AS
! SEQUENCE NUMBERS.
! ********************************************
INTEGR   LDM  R36,=25,0        ! SET UP EXPONENT (15, 0 DEC)
         CLM  R40              ! FOR NON-SCAN CALLS
         BCD                   ! FOR SHIFTS AND INCR
         CLB  R22              ! INIT COUNT
! R22 IS USED TO TELL IF ANY DIGITS SEEN
MLOOP    JSB  =DIGIT           ! WE HAVE A DIGIT?
         JEZ  INTFND           ! JIF NO
         ICB  R22              ! COUNT UP
         TSB  R47              ! HAVE 16 ALREADY?
         JLN  M>16             ! JIF YES
         ERB  R20              ! PUT DIGIT INTO E
         ELM  R40              ! SHIFT INTO RESULT
MGCHAR   JSB  =GCHAR           ! GET NEXT CHAR
         JMP  MLOOP            ! GET MORE
!
INTFND   TSB  R22              ! ANY FOUND?
         JZR  INTRET           ! JIF NO
         ICE                   ! FLAG FOUND
INTRET   RTN                   ! DONE
!
M>16     ICM  R36              ! STEP EXPONENT
         JMP  MGCHAR           ! GCHAR, LOOP
! *************************************************
! NUMBER CREATES A FULL FLOATING POINT
! NUMBER IN R40, WITH EXPONENT IN R36.
! BY CALLING SHRONF, THIS NUMBER IS
! PACKED, NORMALIZED, AND ROUNDED.
! *************************************************
NUMBER   CLB  R0               ! SET INTEGER FLAG
         JSB  =INTEGR          ! DO WE HAVE A NUMBER?
         CMB  R20,=56          ! A DECIMAL POINT?
         JZR  DP1ST            ! JIF YES
         JEN  EXPON            ! JIF DIGITS AND NO
         RTN                   ! NO DIGITS AND NO
! *************************************************
! DECIMAL POINT HAS BEEN SEEN, SHOVE
! REMAINING NUMBERS INTO R40, COUNTING
! DOWN THE EXPONENT.  WE ARE SHIFTING THE
! NUMBER LEFT SO THE EXPONENT MUST BE
! COMPENSATED FOR POSITIONAL CHANGE.
! IF R40 FILLS UP, JUST THROW AWAY DIGITS.
! *************************************************
DP1ST    ICB  R0               ! KILL INTEGER FLAG
FLOOP    JSB  =GCDIG           ! THROW AWAY D.P.
         JEZ  EXPON+           ! JIF NO MORE DIGITS
         ICB  R22              ! ICR COUNT
         TSB  R47              ! WE HAVE 16 NOW?
         JLN  FLOOP            ! JIF YES
         DCM  R36              ! COUNT DOWN EXP
         ERB  R20              ! PUT DIGIT INTO E
         ELM  R40              ! SHIFT INTO RESULT
         JMP  FLOOP            ! LOOP IT
! *************************************************
! GET EXPONENT, IF ANY.
! ONE PROBLEM WITH EXPONENTS IS THAT
! THE CALCULATOR MODE STATEMENT:
!   100E3 = 100000 (BOOLEAN EXPRESSION WITH A VLUE OF TRUE)
! IS INDISTINGUISHABLE FROM THE PROGRAM MOD STATEMENT:
!   100 E3 = 100000
! THE SOLUTION IS TO DECIDE ARBITRARILY IN FAVOR
! OF PROGRAM MODE.  tHE LOGIC TO ACCOMPLISH THIS IS
! IN THE TEST FOR EXPONENTS.  AN EXPONENT IS AN 'E'
! FOLLOWED BY + OR - OR DIGIT.  ANYTHING ELSE
! TERMINATES THE SCAN.
! *************************************************
EXPON+   TSB  R22              ! TEST DIGITS
         JNZ  EXPON            ! JIF ANY
         LDB  R14,=56          ! WE SKIPPED A DECIMAL
         ICE                   !
         RTN                   ! DONE
!
EXPON    JSB  =ALFA            ! SET UPPER CASE
         CMB  R20,=105         ! WE HAVE AN "E"?
         JNZ  COMBINE          ! JIF NO
! SAVE STATE IN CASE E IS RESERVED WORD
         LDM  R30,R10          ! SAVE R10 POINTER
         LDB  R26,R20          ! SAVE INPUT CHAR
         JSB  =GCHAR           ! GET PAST E
         CLB  R34              ! RESET SIGN FLAG
         CLM  R22              ! CLEAR EXPONENT
         CMB  R20,=53          ! PLUS SEEN?
         JZR  FNDE+            ! JIF + SEEN
         CMB  R20,=55          ! SEE -?
         JZR  FNDE-            ! JIF YES
         JSB  =DIGIT           ! A DIGIT MAYBE?
         JEN  FNDE             !
! THIS IS A CASE OF 234.5 ELSE (FALSE E)
FALSEE   LDM  R10,R30          ! RESTORE R10
         LDB  R20,R26          ! RESTORE R20
         JMP  COMBINE          ! NOW ITS AN INTEGER
!
FNDE-    DCB  R34              ! SET SIGN FLAG
FNDE+    JSB  =GCDIG           ! GET PAST + OR -
! IF WE DON'T SEE + OR -, IT ISN'T AN EXPONENT.
! THIS ALLOWS SCAN NOT TO FLAG ERRORS.
         JEZ  FALSEE           ! IT AIN'T AN EXP
FNDE     ICB  R0               ! KILL INTEGER FLAG
         BCD                   ! SHIFTS ARE BCD
EXLOOP   TSB  R23              ! HAVE 3 DIGITS NOW?
         JZR  SHFEXP           ! JIF NO
         LDB  R23,=1           ! SET OVER (UNDER) FLOW
! LET SHRONF, NOT SCAN, FIND OVER OR UNDERFLOW
SHFEXP   ERB  R20              ! PUT DIGIT INTO E
         ELM  R22              ! SHIFT DIGITS TO 22
         JSB  =GCDIG           ! GET NEXT CHAR
         JEN  EXLOOP           ! JIF DIGIT
         TSB  R34              ! IS SIGN -?
         JZR  ADMR36           ! JIF POSITIVE
         TCM  R22              ! COMPLEMENT EXP
ADMR36   ADM  R36,R22          ! COMBINE EXPONENTS
COMBINE  BCD                   ! FOR EXP CASE
         CLE                   !
         ICE                   ! FLAG NUMBER FOUND
         TSB  R0               ! POSSIBLE INTEGER?
         JNZ  FIXFP#           ! JIF NO, . OR EXP
         TSM  R43              ! ENOUGH ZEROES?
         JNZ  FIXFP#           ! JIF NO
         TSB  R42              ! ONLY 5 DIGITS?
         JLZ  INTEG!           ! JIF YES, OK INTEGER
FIXFP#   CLB  R32              ! SET SIGN TO POS
         JSB  =SHRONF          ! SHIFT OUT 0'S, RND, PUSH
! LEAVE THE ANSWER ON R12 STACK
         LDB  R14,=4           ! FLOATING CONSTANT TOKEN
         JMP  SETCL4           ! SET CLASS 4
!
INTEG!   LDM  R55,R40          ! MOVE UP
         STM  R55,R44          ! SAVE IN R44,45,46
         LDB  R14,=32          ! INTEGER TOKEN
SETCL4   LDB  R47,=4           ! CLASS = 4
         CLE                   !
         ICE                   ! FLAG NUMBER FOUND
         RTN                   ! DONE
!
! *************************************************
! GET THE NEXT CHAR TO R20
GCHAR    SAD                   ! MUST RESPECT BIN/BCD
         BIN                   ! NEED TO BE BINARY
GCH1     LDBD R20,R10          ! GET NEXT BYTE
         CMB  R20,=15          ! CARRIAGE RETURN?
         JZR  GCHRTN           ! JIF YES
         POBD R20,+R10         ! INCREMENT R10
         CMB  R20,=40          ! SKIP BLANKS
         JZR  GCH1             ! BY STARTING OVER
GCHRTN   PAD                   ! RESTORE STATUS
         RTN                   ! OTHERWISE RETURN
!
! *************************************************
! CHECK FOR ALPHA CHAR. & UPC IF SO
ALFA     BIN                   ! IF YOU CALL ALFA YOU WA
         CLE                   ! PRESET "NOT FOUND"
         CMB  R20,=101         ! >A?
         JNC  NAW              ! NO
         CMB  R20,=133         ! <[?
         JNC  YEP              ! JIF YES
NAW      CMB  R#,=141          ! >SMALL A?
         JNC  NOPE             ! NO
         CMB  R#,=173          ! <SMALL Z+1?
         JCY  NOPE             ! NOPE
         SBB  R#,=40           ! CHANGE TO CAPITAL
YEP      ICE                   ! FOUND IT
NOPE     RTN                   ! DONE
!
! *************************************************
GCDIG    JSB  =GCHAR           !
DIGIT    SAD                   ! SAVE STATUS
         BIN                   ! MUST BE BINARY
         CLE                   ! PRESET "NOT FOUND"
         CMB  R20,=60          ! > "0" ?
         JNC  NO               ! NOPE
         CMB  R20,=72          ! <"9"+1?
         JCY  NO               ! NOPE
         ICE                   ! FOUND
NO       PAD                   ! RETURN IN EITHER CASE
         RTN                   ! DONE
!
! *************************************************
! ENTRY:
! R20 IS FIRST CHARACTER OF INPUT
! R10 POINTS TO THE NEXT CHARACTER
! SAVR10 CONTAINS SAME R10 VALUE
! SALT SEARCHES THE BASIC STATEMENT ASCII TABLE FOR
! BASIC STATEMENT TYPE.  IF NOT FOUND, IT RETURNS W
! ON ENTRY R41-R47=0, E=0, R40=R20
! *************************************************
SALT     STM  R10,R30          ! SAVE INPUT R10
         LDM  R34,=BINTAB      ! CHECK BINARY
         POMD R22,+R34         ! IS IT THERE?
         JZR  NXTROM           ! JIF NO
         STM  R22,R41          ! MOVE IT
         LDMD R22,X22,THIRT4   ! GET ADDR OF TOKENS
         JMP  BPENT            ! SKIP THE POP
!
NXTROM   POMD R22,+R34         ! GET NEXT TABLE POINTER
         STM  R22,R41          ! SAVE ROM/BP NUMBER
BPENT    CMM  R#,=377,0        ! IS THIS END OF LIST?
         JNZ  ROMAOK           ! JIF NO
         CLM  R41              ! RESET TO SYSTEM
         JSB  =RS1020          ! RESET INPUT POINTERS
         CLE                   ! NOT FOUND
         RTN                   ! DONE
!
ROMAOK   CLM  R14              ! RESET TOKEN REGISTER
         TSB  R23              ! A ROM?
         DRP  R22              ! SAVE A BYTE
         JNZ  OUTERL           ! JIF BINARY
         STBD R22,=RSELEC      ! SELECT THAT ROM
         LDMD R22,=R60+4       ! GET PARSE ADDRESS
         JMP  OUTERL           ! DO SEARCH
!
! READY TO START SEARCH - SMALLEST ORDINAL IS 100
SKIP     POBD R46,+R22         ! SKIP TO END OF
         JPS  SKIP             !   THIS ENTRY
OUTERL   ICB  R14              ! BUMP ORDINAL
         JSB  =RS1020          ! INITIALIZE INPUT
INNERL   LDB  R47,R20          ! GET NEXT CHARACTER
         CMB  R47,=141         ! IS IT LOWER CASE?
         JNC  SKBLNK           ! JIF NO
         CMB  R47,=173         ! > SMALL Z?
         JCY  SKBLNK           ! JIF YES
         ANM  R47,=337         ! SET UPPER CASE
SKBLNK   POBD R46,+R22         ! GET NEXT CHAR FROM TABLE
         JNG  LASTCH           ! JIF LAST CHAR OF WORD
         CMB  R46,=40          ! WAS IT A BLANK?
         JZR  SKBLNK           ! JIF YES, SKIP IN TABLE
         CMB  R46,R47          ! IS THIS A MATCH?
         JNZ  SKIP             ! JIF NO
! IF NO MATCH FOUND, SKIP UP TO LAST CHARACTER OF T
         JSB  =GCHAR           ! GET NEXT NONBLANK TO R20
         JMP  INNERL           ! DO INNER LOOP
! THE LAST CHARACTER IS SPECIAL BECAUSE IT HAS A PARITY
! BIT STUCK ON, AND BECAUSE SUCCESS WITH IT MEANS A MATCH.
! REGISTER R# IS R46 (TABLE ENTRY WITH PARITY)
LASTCH   CMB  R#,=377          ! IS CHAR END OF TABLE?
         JCY  NXTROM           ! JIF YES, TRY NEXT TABLE
         LLB  R#               ! CHOP OFF PARITY
         LRB  R#               ! RESTORE WITH 0
         CMB  R#,R47           ! COMPARE WITH INPUT
         JZR  GOTVRB           ! JIF FOUND
         CMB  R#,=40           ! IF = 240 DONE
         JNZ  OUTERL           ! JIF NO GOOD
         CMB  R20,=15          ! NEED TO DCR R10? CR?
         JZR  GOTVRB           ! JIF NO (GCHAR DIDNT INR
         DCM  R10              ! MAKE THAT GCHAR WORK
! MATCH HAS BEEN FOUND
! ZRO SET, ROM# IN R41
GOTVRB   CLE                   !
         ICE                   ! FLAG FOUND
         LDM  R22,R41          ! SYSTEM?
         JZR  SYSTOK           ! JIF YES
! NOTE: R15 = 0 FROM BEGINNING OF SALT
         STM  R14,R43          ! ROM'S TOKEN RO R43
         LDB  R14,=370         ! SET ROM TOKEN
         TSB  R23              ! BINARY PROG?
         JZR  ROMTOK           ! JIF ROM
         ICB  R14              ! BINARY PROG = 371
         LDMD R36,X41,THIRT2   ! GET OFFSET FOR ROUTINE
         JMP  TOK.OK           ! CONTINUE
!
SYSTOK   ADB  R14,=44          ! ADD SYSTEM OFFSET
         STM  R14,R43          ! SAVE 2ND COPY
ROMTOK   LDMD R36,=R60+2       ! ROM TABLE
TOK.OK   ADM  R#,R43           ! ADD OFFSET
         ADM  R#,R43           !  *2
         LDMD R#,R36           ! GET START OF RUNTIME CODE
         POMD R46,-R36         ! BACK UP TO ATTRIBS
         JSB  =GCHAR           ! GET NEXT CHAR
         RTN                   ! DONE
!
RS1020   LDB  R20,R40          ! RESTORE INPUT CHAR
         LDM  R10,R30          ! RESET INPUT POINTER
         RTN                   ! DONE
! *********************************************
! THIS ROUTINE SAVES REGISTERS R21-37
! REGISTER 70 NOT SAVED
! *********************************************
SAVREG   CMM  R6,=R6LIM1       ! ARE THERE 30 BYTES LEFT?
         JCY  ERR85            ! JIF OK
         POMD R2,-R6           ! GET RETURN ADDR
         STMD R50,=ERSV50      ! SAVE R50
         LDM  R50,R21          ! SAVE 21-30
         PUMD R50,+R6          !
         LDM  R50,R30          ! SAVE 30-37
         PUMD R50,+R6          !
         LDMD R50,=ERSV50      ! RESTORE R50
         PUMD R60,+R6          ! SAVE R60 TOO
         PUMD R2,+R6           ! RESTORE RETURN ADDR
         CLE                   ! FLAG SAVE OK
         RTN                   ! DONE
! *********************************************
!
RSTREG   POMD R2,-R6           ! GET RETURN ADDR
         POMD R60,-R6          ! RESTORE R60
         STMD R50,=ERSV50      ! SAVE R50
         POMD R50,-R6          ! RESTORE 30-37
         STM  R50,R30          !
         POMD R50,-R6          ! RESTORE 21-30
         STM  R50,R21          !
         PUMD R2,+R6           ! PUT RETURN ADDR BACK
         LDMD R50,=ERSV50      ! RESTORE R50
         RTN                   ! DONE
! *********************************************
ERR85    JSB  =ERR85X          ! EXPRESSION TOO BIG
         ICE                   ! FLAG NOT FOUND
         RTN                   ! DONE
! WILL DO RETURN FROM CALLER'S ROUTINE
!
! *********************************************
! NUMERIC VALUE
! RULES FOR PARSING EXPRESSIONS:
!  1. If you will accept either a numeric value
!     or a string, call NUMVAL first.  You are
!     guaranteed that:
!      A.  If a NUMVAL found, E#0
!      B.  If a NUMVAL not found, and some partial
!          numeric value found which is an obvious
!          error (e.g. SIN(X) AND nothing), an
!          error will be flagged and E=0.
!      C.  If a NUMVAL is not found, and nothing
!          has been chewed up, the state will be
!          restored and E=0, no errors flagged.
!          R10,12,14,20,32-47 are restored.
!          You are then free to call STREXP.
!  2. When you call STREXP, no backup is done
!     on the assumption that you will not accept
!     the "not found" condition.
!  + NUMVAL RESOURCES
!  +   R15 TEMP
! <NUMERIC-VALUE> ::= <LOGICAL-EXP>
! <LOG-EXP> = <LOG-FACTOR> (OR <LOG-FACTOR>)
! *********************************************
NUMVA+   JSB  =SCAN            ! ADDS SCAN TO NUMVAL
NUMVAL   JSB  =LOGFAC          ! GET <LOG-FACTOR>
         JEZ  PRIRTN           ! NONE FOUND
LOGEX-   CMM  R46,=2,51        ! COMPARE PRECEDENCE TO 2,51 (BIN PREC 2?)
         JNZ  PRIRTN           ! JIF NO, DONE
         PUBD R14,+R6          ! SAVE TOKEN
         JSB  =SCAN            ! SCAN OVER OR
         JSB  =LOGFAC          ! GET 2ND <LOG-FAC>
         POBD R15,-R6          ! GET TOKEN
         PUBD R15,+R12         ! OR TO OUTPUT
         JEN  LOGEX-           ! ITERATE
         JMP  ERR81            ! MUST FIND SECOND ONE
! <LOG-FACTOR>=<LOG-PRIM> (AND <LOG-PRIM>)*
LOGFAC   JSB  =LOGPRIM         ! GET <LOG-PRIM>
         JEZ  PRIRTN           ! NONE FOUND
LOGFA-   CMM  R46,=4,51        ! BINARY PREC 4?
         JNZ  PRIRTN           ! NO, DONE
         PUBD R14,+R6          ! SAVE TOKEN
         JSB  =SCAN            ! YES, SCAN OVER AND
         JSB  =LOGPRIM         !  GET 2ND <LOG-PRIMARY>
         POBD R15,-R6          ! RESTORE TOKEN
         PUBD R15,+R12         ! TO OUTPUT
         JEN  LOGFA-           ! ITERATE
         JMP  ERR81            ! BAD EXPRESSION
!
! *********************************************
! LOGICAL PRIMARY
! <LOGICAL-PRIM> = <NUMEXP>
!           OR <NUMEXP><REL-OP><NUMEXP>
!           OR <STRING-RELATION>
! <STRING-RELATION> ::= <STR-EXP><RELOP><STR-EXP>
! + LOGPRIM RESOURCES:
! +    R36   TEMP
! This is another place where backup is required if
! this string expression is not followed by a relo
! *********************************************
LOGPRIM  CMM  R6,=R6LIM1       ! ENOUGH ROOM AVAILABLE?
         JCY  ERR85X           ! JIF NO
! THE FOLLOWING ALLOWS SAVING 2 BYTES LATER - P24
         PUMD R10,+R6          ! SAVE R10
         PUMD R12,+R6          ! SAVE R12
         PUBD R14,+R6          ! SAVE R14
         PUBD R20,+R6          ! SAVE INPUT CHAR
         PUMD R40,+R6          ! SAVE TOKEN REGISTER
! END OF AJUSTMENT FOR P24
         JSB  =STREXP          ! GOOD STRING EXPRESSION?
         JEZ  NUMREL           ! NONE FOUND, TRY NUMERIC
         CMM  R46,=6,53        ! BINARY STRING RELOP?
         JNZ  NUMREL           ! JIF NO, RESTORE AND TRY NUM
         PUBD R14,+R6          ! SAVE OPERATOR
         JSB  =STREX+          ! GET SECOND EXPRESSION
         POBD R0,-R6           ! RECOVER OPERATOR TOKEN
         PUBD R0,+R12          ! SEND IT OUT POSTFIX
         JEZ  NUMREL           ! GUESSED WRONG, NUM
         POMD R71,-R6          ! REMOVE 7 BYTES FROM STACK
         POMD R71,-R6          ! "      "
PRIRTN   RTN                   ! DONE
!
ERR85X   JSB  =ERROR           ! EXPR TOO BIG
! NOTE: ERR85X IS CALLED BY ERR85
         BYT  85D              ! 85d
!
         CLE                   ! FLAG NOT FOUND
         RTN                   !
!
! NOW DO NUMERIC RELATION
! NOTE THAT NUMEX IS CALLED, TO AVOID CONFUSION WITH
! STRING RELATION.  (NUMVAL ALLOW STRINGS)
! NUMREL IS A PECIAL PURPOSE ROUTINE WHICH BACKS
! UP OVER CHARACTERS CLOBBERED BY STREXP IF NECESSARY
NUMREL   POMD R40,-R6          ! RESTORE TOKEN REGISTER
         POBD R20,-R6          ! RESTORE INPUT CHARACTER
         POMD R53,-R6          ! RESTORE 10-15
         STM  R53,R10          ! NOTE: NUMEXP KILLS R52
! END OF CODE SAVINGS FOR P24
         JSB  =ROMFX           ! GO SEL ROM
         JSB  =NUMEXP          ! GET FIRST COMPARAND
         JEZ  PRIRTN           ! RTN E=0 (BOMB LATER)
         CMM  R46,=6,53        ! BINARY REL OPERATOR?
         JNZ  PRIRTN           ! JIF NO OPS
         ADB  R14,=10          ! CHANGE TO NUMERIC OP
         PUBD R14,+R6          ! SAVE THE OPERATOR
         JSB  =NUMEX+          ! SCAN, GET NEXT <NUM-EXPRESSION>
         POBD R0,-R6           ! RESTORE OPERATOR TOKEN
         PUBD R0,+R12          ! PUSH IT
         JEN  PRIRTN           ! JIF FOUND
!
ERR81    JSB  =ERROR+          ! BAD EXPRESSION
         BYT  81D              ! 81d
!
! ALL RELATIONAL OPERATORS RETURN
!   TRUE   E=1
!   FALSE  E=0
!
! *********************************************
! NUMERIC EXPRESSION
! <NUMERIC-EXPR> ::= <SIGN>?<TERMS>
! NOTE: If <SIGN> found, <TERMS> is mandatory
!       If <SIGN> not found, <TERMS> is optional
!       This is to solve backup problem in the
!       case of PRINT -"HI".  This MUST be an error.
! + NUMEXP, NUMVAL RESOURCES: NONE (RESTORED)
! +   IN SUBROUTINES:
! +        R35 NUMEXP, R34 TERMS, R33 TERM, R32 FACTOR
! *********************************************
!
NUMEX+   JSB  =SCAN            ! ADDS SCAN TO NUMEX
NUMEXP   LDM  R52,R32          ! SAVE R32-R37
         PUMD R52,+R6          ! ON STACK
         CLB  R35              ! PRESET "NO SIGN"
         CMM  R46,=10,50       ! MONADIC OP?
         JZR  MONTRM           ! JIF FOUND
         CMB  R14,=55          ! MONADIC MINUS?
         JZR  MONAD-           ! JIF YES
! <TERMS> ::= <TERM> (+/- <TERMS>)
         CMB  R14,=53          ! MONADIC PLUS?
         JZR  MONAD+           ! JIF YES
TERMS    JSB  =TERM            ! GET <TERM>
         JEZ  NUMRST           ! NOT FOUND, DONE
TERMS-   CMM  R46,=7,51        ! BINARY OP PREC 10?
         JNZ  NUMRST           ! JIF NO
MONTRM   STB  R14,R34          ! SAVE OPERATOR
         JSB  =SCAN            ! GET NEXT TOKEN
         JSB  =TERM            ! GET <TERM>
         TSB  R34              ! MONADIC PLUS?
         JZR  MONTR1           ! JIF YES
         PUBD R34,+R12         ! PUSH TOKEN TO OUTPUT
MONTR1   JEN  TERMS-           ! JIF FOUND
!
ERR81P   JSB  =ERROR           ! BAD EXPRESSION
         BYT  81D              ! 81d
!
NUMRST   POMD R52,-R6          ! RESTORE R32-R37
         STM  R52,R32          ! FOR RECURSION
RET.NU   RTN                   ! DONE
!
MONAD+   LDB  R#,=365          ! THEN 365+13=400 (0)
MONAD-   ADB  R#,=13           ! CHANGE TO MONADIC -
         JMP  MONTRM           ! GET MONADIC TERM
! *********************************************
! TERM = <FACTOR> (<MULTIPLIER> <FACTOR>)
! *********************************************
TERM     JSB  =FACTOR          !
         JEZ  RET.NU           !
TERM-    CMM  R46,=11,51       ! BINARY OPERATOR PRECEDENCE 11?
         JNZ  RET.NU           ! NO, RETURN
         STB  R14,R33          ! SAVE OPERATOR
         JSB  =SCAN            ! GET NEXT
         JSB  =FACTOR          ! GET FACTOR
         PUBD R33,+R12         ! PUSH TO OUTPUT
         JEN  TERM-            ! JIF FOUND
ERR81J   JMP  ERR81            ! MUST FIND
! *********************************************
! <FACTOR> ::= <PRIMARY> (<INVOLUTION> <FACTOR>)
! *********************************************
FACTOR   JSB  =PRIMARY         !
         JEZ  RET.NU           !
FACTO-   CMM  R46,=14,51       ! POWER OR SIMILAR OPERATOR?
         JNZ  RET.NU           ! NO, RETURN
         STB  R14,R32          ! SAVE THE OP
         JSB  =SCAN            ! GET NEXT
         JSB  =PRIMARY         ! GET NEXT PRIMARY
         PUBD R32,+R12         !   ONTO OUTPUT
         JEN  FACTO-           ! ITERATE IF FOUND
         JMP  ERR81J           ! MUST FIND
! *********************************************
! <NUMERIC-PRIM> ::= <NUMERIC-VARIABLE>/<NUMERIC-RE
!  /<NUMERIC-FUNCTION-REF>/<OPEN> <NUMERIC-EXP> <CLOSE>
! + PRIMARY RESOURCES:
! +    R36  TEMP
! *********************************************
PRIMARY  CMB  R14,=3           ! NUMERIC SAV OR SNV?
         JNC  NUMVRB           ! JIF YES
! *********************************************
! NOW CHECK FOR NUMERIC REPRESENTATION
! *********************************************
         JSB  =NUMREP          ! NUMERIC-REP?
! NOW CHECK FOR NUMERIC REPRESENTATION
         JEN  FNDPRI           ! JIF YES
! *********************************************
! <NUMERIC-FUNCTION-REF> ::= <NUM-DEF-FUNC>
!                        ::= <NUM-SUPPLIED-FUNC>
! *********************************************
         CMB  R14,=FNSYM       ! FN?
         JZR  JFNCAL           ! JIF YES
         CMB  R47,=55          ! <NUMERIC-SUPPLIED-FUNC>?
         JZR  FUN1             ! JIF YES
         CMB  R14,=50          ! OPEN PARENTHESIS? (NUM-EXP)?
         JNZ  FNDPRI           ! NOPE, NONE FOUND, E=0
         JSB  =NUMVA+          ! SCAN, GET VALUE
         JEZ  ERR81J           ! JIF BAD OPEN/CLOSE
         JSB  =GET)            ! GET CLOSE
FNDPRI   RTN                   !
!
JFNCAL   JSB  =FNCALL          ! GET THE CALL
         RTN                   !
!
NUMVRB   PUBD R#,+R6           ! SAVE THAT TOKEN
         JSB  =PUSH45          ! PUSH TOK, NAM
         POBD R36,-R6          ! WAS IT SAV OR SNV?
         JOD  FNDPRI           ! JIF SNV
! CAPASM: renamed LCL SUBSCR to SBSCR
         JSB  =SBSCR           ! GET SUBSCRIPTS
         PUBD R36,+R12         ! PUT TO OUPUT
         RTN                   ! DONE
! *********************************************
! GET STANDARD FUNCTION PARAMETER
! *********************************************
FUN1     TSB  R46              ! ANY PARAMETERS?
         JNZ  GETPRM           ! JIF YES, GET THEM!
         PUBD R14,+R12         ! PUSH INCOMING TOKEN
         CMB  R14,=370         ! ROM OR BINARY FUNCTION?
         JNC  NOTRBF           ! JIF NO
! IT IS BINARY OR ROM
         PUBD R41,+R12         ! PUSH ROM# OR GARBAGE
         PUBD R43,+R12         ! PUSH TOKEN WITHIN
NOTRBF   JSB  =SCAN            ! GET NEXT
         ICE                   ! FLAG FOUND
         RTN                   ! DONE WITH NO PARMS
!
GETPRM   BIN                   ! FOR ADDS
         PUMD R32,+R6          ! SAVE R32
         PUMD R34,+R6          ! SVAE R34
         PUMD R40,+R6          ! SAVE COPY OF R40
! R40 CONTAINS ROM#, AMONG OTHER THINGS
         LDB  R32,R14          ! SVE INCOMING TOKEN
! R44 CONTAINS THE DOUBLED TOKEN
         LDMD R36,=R60+2       ! GET ROM RUNTIME
         TSB  R42              ! BINARY PROG?
         JZR  ROMTK.           ! JIF NO
         LDMD R36,=BINTAB      ! GET TO RUNTIME
         LDMD R36,X36,THIRT2   ! GET RUNTIME DDR
ROMTK.   ADM  R36,R43          ! ADD OFFSET
         ADM  R36,R43          !  *2
         LDMD R36,R36          ! GET ADDR OF ROUTINE
         DCM  R36              ! SKIP CLASS (ONLY 1 ICM)
         POMD R50,-R36         ! GET ATTRIBUTES
         BCD                   ! FOR SHIFTING BYTE
         LLM  R50              ! GET COUNT INTO E
         CLB  R33              ! GET COUNT INTO R33
         ELB  R33              ! R40-47 NOW THE TYPES
         BIN                   ! BACK TO BINARY
         PUMD R50,+R6          ! SAVE THE FLAGS
         JSB  =SCAN            ! BET OPENING REMARKS
         CMB  R#,=50           ! (?
         JNZ  POPFUN           ! JIF NO
         JSB  =SCAN            ! GET PAST IT
! ---------------- NOW COMES THE MAIN LOOP
PRMLOP   POMD R50,-R6          ! RESTORE FLAGS
         PUMD R50,+R6          ! SHOVE THEM BACK
         CLM  R34              ! CLEAR R35
         LDB  R34,R57          ! GET PARAM TYPE
         LLM  R34              ! MOVE TWO BITS
         LLM  R34              !   INTO R35
         LDB  R34,R35          ! MOVE BACK TO R34
         LLB  R34              ! DOUBLE FOR TABLE OFFSET
         CLB  R35              ! AND CLEAR R35
         LDMD R34,X34,PTYPES   ! GET ROUTINE ADDR
         JSB  X34,ZRO          ! GET THE PARAMETER
         JEZ  POPFUN           ! JIF NOT FOUND
         POMD R50,-R6          ! GET BACK PARAMETERS
         LLM  R50              ! SHIFT OUT 2 BITS
         LLM  R50              !    BIT 2
         PUMD R50,+R6          ! SHOVE THEM BACK
         DCB  R33              ! COUNT DOWN
         JZR  NMPARS           ! JIF NO MORE PARAMS
         JSB  =GETCMA          ! GET COMMA
         JMP  PRMLOP           ! CONTINUE
!
PTYPES   DEF  NUMVAL           ! NUMERIC PARAMETER
         DEF  ARRAY            ! ARRAY PARAMETER
         DEF  STREXP           ! STRING PARAMETER
         DEF  STRANG           ! STRANGE PARAMETER
!
! --------------- END OF MAIN LOOP
!
NMPARS   LDB  R36,R32          ! MOVE TOKEN
         POMD R50,-R6          ! RESTORE R6, KILL R50
         POMD R50,-R6          ! RCL OLD R40
! REMEMBER THAT OLD R40 CONTAINS ROM#
         POMD R34,-R6          ! RESTORE R34
         POMD R32,-R6          ! RESTORE R32
         PUBD R36,+R12         ! PUSH THE FUNC NAME
         CMB  R36,=370         ! A ROM FUNCTION?
         JNC  GET)             ! JIF NO
! IT IS BINARY PROG (371) OR ROM (370)
         PUBD R51,+R12         ! ROM# OR GARBAGE (B.P.)
         PUBD R53,+R12         ! ROM OR B.P. TOKEN
         JMP  GET)             ! DONE
!
POPFUN   POMD R50,-R6          ! RESTORE R50
         POMD R40,-R6          ! RESTORE R40
         POMD R34,-R6          ! RESTORE R34
         POMD R32,-R6          ! RESTORE R32
ERR89A   CLE                   ! CLEAR FOUND FLAG
!
         JSB  =ERROR+          ! BAD PARAMETERS
         BYT  89D              ! 89d
!
! *********************************************
! NARREF, GETCMA, GET>, SBSCR
! *********************************************
GET)     CMB  R14,=CLOSE       ! END ) FOUND?
         JZR  FNDCM?           ! JIF YES
!
ERR80    JSB  =ERROR+          !
         BYT  80D              ! 80d
!
! *********************************************
! SCAN & PARSE ARRAY REF WITHOUT PARENS
! *********************************************
NARRE+   JSB  =SCAN            ! FOR SOME FOLKS
ARRAY    CLE                   ! ENTRY FOR FUN1 LOOP
NARREF   CMB  R14,=1           ! SIMPLE NUMERIC VARIABLE TOKEN?
         JNZ  ERR89A           ! LOG ERROR AND CLEAR E
         ICB  R14              ! MAKE IT AN ARRAY
         JSB  =PUSH45          !
         RTN                   !
!
! *********************************************
GETCMA   CMB  R14,=COMMA       ! FIND ,?
         JZR  FNDCM?           ! JIF YES
!
ERR83X   JSB  =ERROR+          ! "," MISSING
         BYT  83D              ! 83d
!
GETCM?   CLE                   ! RESET FLAG
         CMB  R14,=COMMA       ! FIND ,?
         JNZ  NOCMA            ! JIF NO
FNDCM?   JSB  =SCAN            ! SCAN PAST IT
         ICE                   !
NOCMA    RTN                   ! RETURN WITH FOUND=E
! *********************************************
! + SBSCR RESOURCES
! +    R36  TEMP
! *********************************************
! CAPASM renamed LCL SUBSCR to SBSCR
SBSCR    JSB  =NUMVAL          ! ( WAS CHEWED UP
         JEZ  ERR89A           ! JIF NOT FOUND
         LDB  R36,=13          ! SET UP 1 SUBS
         CMB  R14,=COMMA       ! TWO?
         JNZ  GET)             ! GET CLOSE, RTN
TWOSUB   JSB  =NUMVA+          ! SCAN, GET EXPR
         JEZ  ERR91            ! JIF NOT FOUND
         ICB  R36              ! TOKEN DOUBLE INDEX
         JMP  GET)             ! GET CLOSE
! RETURN INDEX1 OR 2 IN 36
!
! *********************************************
! NUMERIC REPRESENTATION
! <NUMERIC-REP> = <SIGN> <SMALL-INTEGER>
! <NUMERIC-CONST> = <SIGNIF> E <SIGN>? <INTEGER>
! <SIGNIF> = <INTEGER> . / <INTEGER>? . <INTEGER>
! + NUMREP RESOURCES: R36 TEMP
! *********************************************
NUMCON   CLE                   ! FOR EXTERNAL CALLS
         CMB  R14,=4           ! INTEGER?
         JZR  FLTGPT           ! JIF FLOATING CONST FOUND
SMLINT   CLE                   ! FOR SMLINT CALLS
         CMB  R14,=32          ! INTEGER?
         JNZ  NUMRET           ! JIF NONE FOUND, E=0
         JSB  =PUSH32          ! PUSH R14, R44, R45, R46
         RTN                   !
!
FLTGPT   POMD R40,-R12         ! THE NUMBER IS ON R12
         PUBD R14,+R12         ! PUSH OUT TOKEN
         JSB  =PUSH40          ! PUSH NUMBER AND SCAN
NUMRET   RTN                   ! RETURN BYE BYE
! *********************************************
! NUMREP CHEWS UP LEADING + OR - AND PRODUCE
! A SIGNED NUMERIC CONSTANT
! *********************************************
NUMREP   CLM  R36              !
         CMM  R46,=7,51        ! SIGN?
         JZR  GETSGN           ! JIF YES, DEMAND NUMNUM
         JSB  =NUMCON          ! GET OPTIONAL NUM
         JEN  GETNMM           ! JIF FOUND
         RTN                   ! OTHERWISE DONE
!
GETSGN   CMB  R14,=53          ! +?
         JZR  SGN?1            ! JIF YES
         CMB  R14,=55          ! -?
         JNZ  SGNNU1           ! JIF NO
         ICB  R37              ! INCR NEG COUNT
SGN?1    JSB  =SCAN            ! NEXT TOKEN
         JMP  GETSGN           ! LOOP TO CHECK NEXT
!
SGNNU1   STB  R14,R36          ! SAVE TOKEN
         JSB  =NUMCON          ! GO PROCESS NUMBER
! CHEWED UP +/-'S WILL BE CHUCKED BY LOGPRI IF NECESSARY
         JEN  GETNMM           ! JIF FOUND
!
ERR91    JSB  =ERROR+          ! MISSING PARAMETER
         BYT  91D              ! 91d
!
GETNMM   TSB  R37              ! NEG?
         JEV  SGNEX            ! JIF NO
         CMB  R36,=32          ! BCD INT?
         JNZ  SGNFLT           ! JIF NOT
         POMD R55,-R12         ! POP VALUE
         BCD                   !
         TCM  R55              ! MAKE IT NEG
         BIN                   !
         PUMD R55,+R12         ! PUSH IT BACK
         RTN                   ! DONE
!
SGNFLT   POMD R50,-R12         ! POP VALUE
         ADB  R51,=11          ! 9c MAKE IT NEG
         PUMD R50,+R12         ! PUSH IT BACK
SGNEX    RTN                   ! DONE
!
! *********************************************
! STRING EXPRESSION
! <STRING-EXPR> ::= <SOURCE-STRING>
!               ::= <STRING-EXPR> <BINOP$> <SOURCE-STRING>
! + STREXP RESOURCES: R34, R36
! THERE ARE THREE POSSIBLE RETURN CONDITIONS FOR ST
!   SUCCESSFUL RETURN - E # 0
!   ERROR RETURN      - E = 0, ERRORS SET
!   NO STRING FOUND   - E = 0, INPUT RESTORED
! *********************************************
STREX+   JSB  =SCAN            ! FOR SOME FOLKS
STREXP   JSB  =SAVREG          ! SAVE REGISTERS
         JEZ  DOSTR            ! JIF THERE WAS ROOM
         CLE                   ! BAG IT, NO ROOM
         RTN                   ! DONE
!
DOSTR    PUMD R10,+R6          ! SAVE INPTR
         PUBD R20,+R6          ! SAVE INPUT CHAR
         JSB  =SOURCE          ! GET 1ST <SOURCE-STRING>
         JEN  GET&             ! JIF FOUND
         POBD R20,-R6          ! REESTORE INPUT CHAR
         POMD R10,-R6          ! RESTORE INPTR
         JMP  STR.R+           ! FINISH UP
! !!!!!! IS THAT NECESSARY AND/OR SUFFICIENT?????????
! SEE RULES FOR BACKUP IN FRONT OF NUMVAL
GET&     CMM  R46,=10,53       ! BINARY STRING OP?
         JNZ  STR.RN           ! JIF NO, STILL OK
         PUBD R14,+R6          ! SAVE OP
         JSB  =SCAN            ! SKIP OVER OP
         JSB  =SOURCE          ! GET NEXT SOURCE
         POBD R36,-R6          ! RESTORE OP
         PUBD R36,+R12         ! PUSH TOKEN
         JEN  GET&             ! 2ND OP MUST BE FOUND
! THIS IS ONLY REFERENCE TO THIS ERROR
!
ERR82-   JSB  =ERROR           ! BAD STRING EXPRESSION
         BYT  82D              ! 82d
!
STR.RN   POMD R75,-R6          ! THROW AWAY R10, R20
STR.R+   JSB  =RSTREG          ! RESTORE REGS
         RTN                   ! DONE
! *********************************************
!
! <SOURCE-STRING> ::= <STRING-CONST>
!                 ::= <STRING-FUNCTION>
!                 ::= <STRING-REFERENCE>
!
! *********************************************
SOURCE   CLE                   ! PRESET NOT FOUND
         CMB  R14,=QUOTE       ! STRING CONST?
         JZR  STRCON           ! JIF YES
         CMB  R14,=3           ! STRING VRBL?
         JZR  STVRBL           ! JIF YES
         CMB  R47,=56          ! STRING FUNCTION?
         JNZ  USER$?           ! JIF NO
         GTO FUN1              ! DO FUNCTION
!
USER$?   CMB  R14,=FNSYM       ! USER STRING FUNCTION?
         JNZ  STXRTN           ! JIF NO, E=0
         JSB  =FN$CAL          ! TRY FN CALL, IF NUMERIC
STXRTN   RTN                   !    FN$CAL WIL RESTORE
!
! *********************************************
! STRING REFERENCE
! <STRING-VARIABLE> = <STR-VRBL-REP>
!              OR <STR-VRBL-REP>[<NUMVAL>]
!              OR <STR-VRBL-REP>[<NUMVAL>,<NUMVAL>]
! *********************************************
STRREF   CLE                   ! PRESET FLAG
         CMB  R14,=3           ! STRING VARIABLE?
         JNZ  STXRTN           ! JIF NO
         ADB  R14,=20          ! CHANGE TO REFERENCE
STVRBL   JSB  =PUSH45          ! PUSH NAME
         CLE                   ! NOT FOUND
         CMB  R14,=LBRACK      ! [<NUMVAL>?
         JNZ  NOSTR            ! JIF NONE
         JSB  =NUMVA+          ! GET <NUM-EXP>
         JEZ  ERR82Z           ! JIF NONE FOUND
         LDB  R36,=35          ! SET SINGLE SUBS TOKEN
         CMB  R14,=RBRAKT      ! END OF LIST ]?
         JZR  SUBDUN           ! JIF DONE - R36 ALL SET
         JSB  =GETCMA          ! NOW WE NEED ,<NUM-EXP>]
         JSB  =NUMVAL          ! GET <NUM-EXP>
         JEZ  ERR82Z           ! JIF NONE FOUND
         CMB  R14,=RBRAKT      ! CHECK OF ]
         JNZ  ERR82Z           ! JIF NO ]
         LDB  R36,=36          ! LOAD DOUBLE SUBS TOKEN
! ONE OR TWO PARAMETERS FOUND,
! PUSH APPROPRIATE SUBSTRING TOKEN
SUBDUN   JSB  =PU36SC          ! PUSH 35 (1) OR 36 (2)
NOSTR    ICE                   ! E::=1 OR 2
         RTN                   ! DONE
!
! *********************************************
! REMARK AND STRING CONSTANT
! The same routine is used for in-line remarks
! and normal REM's.  The appropriate token is
! in R14.  Any char but CR is allowed in remark.
!
! GUIDE TO ENTRY POINTS AND CALLS:
!   STRCON called by STREXP <SOURCE> and DATA
!   REMS- called by DATA
!   REM called by REM, IMAGE, and ! parses
!   UNQUOT is called by INPU$.
!   All others used on this page only
! *********************************************
!
STRCON   CLE                   ! CLEAR FOUND FLAG
         CMB  R14,=QUOTE       ! A QUOTED STRING?
         JNZ  NOCON$           ! JIF NO
         LDB  R2,=QUOTE        ! SET UP FOR QUOTED
         LDB  R36,=5           !   STRING (TOKEN 5)
         JMP  STRCN2           ! DO GENERAL STRING
!
REM      PUBD R14,+R12         ! PUSH REM OR IMAGE
         LDB  R2,=15           ! STOP ON CR
         CMB  R2,R20           ! CR NOW?
         JZR  CRTO14           ! JIF YES, QUIT, MAKE 14 CR
         DCM  R10              ! COMPENSATE FOR GCHAR
         CMB  R14,=216         ! IMAGE?
         JZR  UNQUO-           ! JIF YES
! PUT BACK LEADING BLANKS THAT GCHAR CHUCKED
         DRP  R20              ! SAVE LOOP TIME
         ARP  R10              ! SAVE MOVE
LEADBL   POBD R#,-R#           ! CHECK PREVIOUS CHAR
         CMB  R#,=BLANK        ! IS IT A BLANK?
         JZR  LEADBL           ! JIF YES
         POBD R#,+R#           ! NOW GO FORWARD 1
         POBD R#,+R#           ! CHECK IF THERE IS
         CMB  R#,=BLANK        !     A LEADING BLANK
! REM DECOMPILE WILL ADD A BLANK, SO KILL ONE
         JZR  STRCN1           ! JIF YES, ITS GONE
         POBD R#,-R#           ! UNDO THE DAMAGE
! IF THERE IS NO LEADING BLANK, DCOMP WILL ADD ONE
STRCN1   LDB  R36,=6           ! UNQUOTED STR
STRCN2   CLE                   ! RESET FLAG
! IS THIS CLE NECESSARY?
         PUBD R#,+R12          ! TOKEN (R36) TO OUTPUT
         LDM  R34,R12          ! SAVE THIS PLACE
         PUBD R12,+R12         ! RESERVE BYTE FOR LENGTH
CHLOOP   POBD R20,+R10         ! GET NEXT CHAR
         CMB  R20,R2           ! DONE?
         JZR  FNDCR-           ! YES
         CMB  R20,=15          ! LINE DONE?
         JZR  FNDCR            ! JIF YES, KILL IT
         PUBD R20,+R12         ! STORE CHAR
         JMP  CHLOOP           ! GET MORE
!
FNDCR-   CMB  R#,=42           ! STOPPING ON QUOTE?
         JZR  ENDQUO           ! JIF YES
FNDCR    DCM  R10              ! BACK UP TO CR
         CMB  R2,=42           ! LOOING FOR QUOTE?
         JNZ  ENDQUO           ! JIF NO, ITS OK
ERR82S   STMD R10,=SAVR10      ! FOR ERROR MESSAGE
!
ERR82Z   JSB  =ERROR+          ! BAD STRING EXPR
         BYT  82D              ! 82d
!
ENDQUO   LDM  R36,R12          ! GET CURRENT 12 - OLD
         SBM  R36,R34          ! FOR SIZE OF CONST
         DCM  R36              ! SIZE IS 1 TOO BIG
         STBD R36,R34          ! SAVE SIZE
CRTO14   JSB  =SCAN+           ! GET NEXT TOKEN (E::=0)
         ICE                   ! SUCCESS FLAG!
NOCON$   RTN                   ! AND RETURN
!
! *********************************************
! PARSE AN UNQUOTED STRING
! *********************************************
REMS-    CMB  R20,=15          ! NULL LINE?
         JZR  CRTO14           ! JIF YES, SET INTO R14
         DCM  R10              ! BACK UP INPUT (BIN?)
UNQUOT   LDB  R2,=54           ! STOP ON COMMAS
UNQUO-   JSB  =STRCN1          ! DO NORMAL STRING
! NOW TRASH TRAILING BLANKS
! R36 = STR LEN
! R34 = STR LEN POINTER
         TSB  R36              ! STR LEN = 0?
UNQUOL   JZR  UNQUO2           ! JIF YES, LEN = 0
         POBD R32,-R12         ! POP LAST
         CMB  R32,=40          ! IS IT BLANK?
         JNZ  UNQUO1           ! JIF NOT
         DCB  R36              ! DEC COUNT
         JMP  UNQUOL           ! AND LOOP
!
UNQUO1   PUBD R#,+R#           ! RESTORE LAST
UNQUO2   STBD R36,R34          ! STORE COUNT
         RTN                   !
!
! *********************************************
! PARSE TIME COMMON ROUTINES
! *********************************************
!
PUSH1A   DRP  R14              ! MOST USUAL CASE
PUSH1#   PUBD R#,+R12          ! PUSH OUT TOKEN
SCANNN   JSB  =SCAN            ! GET NEXT
         ICE                   ! SCAN DOES R14, R36, CLE
         RTN                   ! DONE!!
!
PU363?   DRP  R36              ! PUSH 36,37 + 12
         JMP  PUSH##           ! LIKE OTHERS
!
PUSH46   DRP  R46              ! PUSH 46 + 12
PUSH##   PUMD R#,+R12          ! PUSH IT
         JMP  SCANNN           ! FINISH UP LIKE REST
FNEND    CLM  R44              ! SEND FNEND, 2 ZEROES
PUSH45   PUBD R14,+R12         ! PUSH TOKEN IN R14 & R44-5 & SCAN
PUSH44   PUBD R44,+R12         !
         DRP  R45              !
         JMP  PUSH1#           ! SET SCANN DO THE PUSH
!
! PUSH32 IS FOR PUSHING INTEGERS (TOKEN 32)
! PUSH OUT R14, R44, R45, AND R46, NOT R47
!
PUSH32   PUBD R14,+R12         ! PUSH TOKEN IN R14
         PUMD R44,+R12         ! PUSH 44,45,46,47
         POBD R44,-R12         ! GET RID OF 47
         JMP  SCANNN           ! FINISH UP
!
PU36SC   DRP  R36              ! DO IT WITH 36
         JMP  PUSH1#           ! THAS ALL
!
PUSH40   DRP  R40              ! DO WITH 40
         JMP  PUSH##           ! PUSH 40, +12
!
SECURE   JSB  =GETSTP          ! GET STRING EXPRESSION
         JNZ  ERR83Y           ! JIF COMMA NOT FOUND
         LDB  R#,R#            ! RESTORE R14 FROM R36
G$N      LDB  R35,=1           ! 1 STRING, 1 NUMBER
GETPA$   JSB  =GETSTP          ! GET STRING EXPRESSION
         JZR  GETPA-           ! JIF COMMA FOUND
!
ERR83Y   JSB  =ERROR+          ! "," MISSING
         BYT  83D              ! 83d
!
GET1N    LDB  R35,=1           ! GET 1 PARAM
!
! GETPAR GETS AS MANY PARAMS AS IT CAN,
! RETURNS WITH COUNT IN 34 (DRP=34),
! IF R35=0, ANY NUMBER OF PARAMS WILL BE OK
! IF R35#0, NUMBER OF PARAMS MUST =R35
!
GETPAR   STB  R14,R36          ! SAVE INPUT TOKEN
GETPA-   CLB  R34              ! CLEAR COUNT
         JSB  =NUMVA+          ! SCAN, GET NUM VAL
         JEZ  P.DONE           ! JIF NOT FOUND
GETCNT   ICB  R34              ! COUNT UP
         CMB  R14,=54          ! FIND COMMA SEPARATOR?
         JNZ  P.DONE           ! JIF NO
         JSB  =NUMVA+          ! GET NEXT VALUE
         JEZ  ERR91Y           ! THIS ONE MANDATORY
         JMP  GETCNT           ! GET MORE
! PUSH TOKEN
P.DONE   PUBD R36,+R12         ! PUSH TOKEN
         TSB  R35              ! REQUIRED NUMBER?
         JZR  OKPAR            ! JIF NO REQUIRED
         CMB  R35,R34          ! RIGHT NUMBER?
         JNZ  ERR89Y           ! JIF UNEQUAL
OKPAR    DRP  R34              ! SET FOR CALLER
         RTN                   ! DONE
!
GET2N    LDB  R35,=2           ! GET 2 NUMERIC
         JMP  GETPAR           ! CALL GETPAR
!
GET4N    LDB  R35,=4           ! GET 4 NUMERIC
         JMP  GETPAR           ! CALL GETPAR
!
G$N+NN   CLB  R35              ! SET OPTIONAL PARAMETERS
         JSB  =GETPA$          ! GET STRING, NUMERICS
         JMP  G1.2++           ! NOW DID WE GET 1 OR 2?
!
GXX3     CMB  R#,=3            ! 2-3NC, 3-3CY
JCYE89   JCY  ERR89Y           ! JIF TOO MANY
GERTN    RTN                   ! DONE
!
! GETSTP IS FIRST PART OF MOST STRING "GETS"
! REPORTS ERROR IF NO STRING EXPR FOUND, AND
! RETURNS WITH DRP 14 FOR ALL AND "=COMMA" FOR SOME
!
GETSTP   STB  R14,R36          ! SAVE INPUT TOKEN
GETST-   JSB  =STREX+          ! GET STRING EXPR
         CMB  R14,=54          ! SATISFY MOST
         ARP  R36              ! FOR SOME CALLERS
         JEN  GERTN            ! JIF STRING FOUND
!
ERR82Y   JSB  =ERROR+          ! BAD STRING EXPR
         BYT  82D              ! 82d
!
GET1$    JSB  =GETSTP          ! GET STRING EXP
G01NR    PUBD R36,+R12         ! SHOVE TOKEN
         DRP  R14              !
G1$RTN   RTN                   ! DONE
!
! G012N AND G01N GET LINE #'S, NOT <NUMERIC-VALUES>
!
G012N    JSB  =SEQ#+           ! PUSH, SCAN, SEQ# ?
         JEZ  G01NR            ! JIF NO
         JSB  =PUSH32          ! PUSH #
         CMB  R14,=54          ! DEMAND COMMA
         JNZ  G01NR            ! JIF NOT COMMA
         LDB  R14,R36          ! RESTORE TOKEN
G01N     JSB  =SEQ#+           ! PUSH, SCAN, GET SEQ #
         JEZ  G01NR            ! JIF NONE
         JSB  =PUSH32          ! PUSH #
         JMP  G01NR            ! DONE
!
GETPA?   CLB  R35              ! SET OPTIONAL PARAMETERS
         JMP  GETPAR           ! DO GETPAR
!
G0OR2N   JSB  =GETPA?          ! OPTIONAL PARAMS
         JEZ  GERTN            ! JIF NONE FOUND - OK
         CMB  R#,=2            ! FIND 2?
         JZR  GERTN            ! JIF YES
!
ERR89Y   JSB  =ERROR+          ! BAD PARAMS
         BYT  89D              ! 89d
!
G1OR2N   JSB  =GETPA?          ! OPTIONAL PARAMETERS
G1.2++   JEN  GXX3             ! JIF FOUND
!
ERR91Y   JSB  =ERROR+          ! MISSING PARAM
         BYT  91D              ! 91d
!
G12OR4   JSB  =GETPA?          ! OPTIONAL PARAMETERS
         CMB  R#,=4            ! ARE THERE 4?
         JNZ  G1.2++           ! JIF NO, MNUST BE 1 OR 2
         RTN                   ! DONE IF 4
!
GET$N?   JSB  =GETSTP          ! GET STRING EXPR
         JNZ  G01NR            ! JIF NO COMMA
         LDB  R#,R#            ! RESTORE R14
TRY1N    JSB  =GETPA?          ! OPTIONAL PARAMS
         CMB  R#,=2            ! 2-1=NC, 2-2=CY
         JMP  JCYE89           ! DO JCY ERR89Y
!
! *********************************************
! ASSIGN, RENAME
! *********************************************
ASSIGN   STB  R14,R37          ! SAVE INPUT TOKEN
         JSB  =NUMVA+          ! GET NUMERIC
         JEZ  ERR91Y           ! JIF NOT FOUND
         CMB  R14,=244         ! ASSIGN - TO -? ("TO" TOKEN?)
         JNZ  ERR89Y           ! JIF NO
         CMB  R20,=52          ! ASSIGN TO * ? ('*' CHAR?)
         JZR  CLOSF            ! JIF YES
RENASN   JSB  =STREX+          ! SCAN, GET DEST
JEZF82   JEZ  ERR82Y           ! JIF NONE FOUND
PUSHTO   LDB  R36,=333         ! GET 'TO' OPERATOR
         PUMD R36,+R12         ! PUSH TO OUTPUT
         RTN                   ! DONE
!
CLOSF    LDM  R45,=6,1,52      ! UNQUOTED STRING (6) LEN=1 STRING="*"
         PUMD R45,+R12         ! PUSH IT
         JSB  =SCAN+           ! GCHAR, SCAN
         JMP  PUSHTO           ! PUSH "TO"
!
RENAME   STB  R14,R37          ! MOVE RENAME
         LDB  R36,=333         ! "TO" TOKEN, GET1$ WILL PUSH
         JSB  =GET1$           ! GET FROM NAME
         DCM  R12              ! MUST BE BINARY!
         CMB  R14,=244         ! FIND "TO"?
         JNZ  ERR89Z           ! JIF NO
         JMP  RENASN           ! SHARED CODE
!
! *********************************************
! OPTION BASE AND ON KEY #
! *********************************************
OPTION   JSB  =PUSH1A          ! PUSH OPTION TOKEN
         CMB  R#,=32           ! INTEGER FOUND?
         JNZ  ERR51            ! JIF NO
         CLB  R47              !
         TSM  R45              ! CHECK IF 0 OR 1
         JNZ  ERR51            ! JIF NO
         CMB  R44,=2           ! >1?
         JNC  PUPU32           ! JIF NO
!
ERR51    JSB  =ERROR+          ! OPTION BASE
         BYT  30D              ! 30d
!
ERR89Z   JSB  =ERROR+          ! BAD PARAMS
         BYT  89D              ! 89d
!
! ON KEY#
!
KEYNAM   STB  R14,R34          ! SAVE ON KEY# TOKEN PART
         JSB  =SCAN            ! GET NEXT
         CMB  R#,=32           ! CONSTANT NEXT?
         JNZ  ERR89Z           ! JIF NO
         CLB  R47              ! CLEAR ATTRIBUTES
         TSM  R44              ! IS NUMBER 0?
         JZR  ERR89Z           ! JIF YES, MUST BE 1-8
         CMB  R44,=11          ! >=9?
         JCY  ERR89Z           ! JIF YES
         TSM  R45              ! UPPER BYTES 0?
         JNZ  ERR89Z           ! JIF NO
PUPU32   JSB  =PUSH32          ! PUSH TOKEN AND NUMBER
RTNOK    RTN                   ! END ON-OFF KEY#
!
OFKEY#   JSB  =KEYNAM          ! FIX UP NAME
         PUBD R34,+R12         ! PUSH OUT "OFF KEY#"
         RTN                   ! DONE
!
ONTIME   JSB  =GET2N           ! GET 2 NUMERICS
         JMP  CKGOTO           ! DO THE REST
!
ONKEY#   JSB  =KEYNAM          ! SET UP NAME
         CMB  R14,=54          ! COMMA?
         JNZ  STRFND           ! JIF NO, NO STRING
         JSB  =STREX+          ! GET STRING EXPR
         JEZ  JEZF82           ! JIF NOT FOUND
STRFND   PUBD R34,+R12         ! PUSH ON KEY# TOKEN
CKGOTO   CMB  R47,=210         ! GOTO OR GOSUB?
         JNZ  ERR89Z           ! JIF NO
TOGOTO   JSB  =GOTOSU          ! GET GOSUB OR GOTO
         RTN                   ! DONE
!
ONERRO   JSB  =PUSH1A          ! PUSH ON ERROR TOKEN
         JMP  TOGOTO           ! GET GOTO/GOSUB
!
! *********************************************
! DIMENSION AND TYPE STATEMENTS
! *********************************************
!
! <DIM-STMT>  = DIM <DIM-LIST>
! <DIM-LIST>  = <DIM-ITEM>/<DIM-ITEM>,<DIM-LIST>
! <DIM-ITEM>  = <NDIM-ITEM>/<SDIM-ITEM>
! <NDIM-ITEM> = <NUM-ARRAY><DIMENSIONS>
! <SDIM-ITEM> = <STRINGID> [ <DIMENSIONS> ]
!
DIM      LDM  R32,=DIMITEM     ! SET UP FOR JSB X32,
         JMP  DIMCOM           ! USE DIM/COM ROUTINE
!
COM      LDM  R32,=COMITEM     ! SET UP FOR JSB X32,
DIMCOM   JSB  =PUSH1A          ! GET PAST COM/DIM TOKEN
DIMCM1   JSB  X32,ZRO          ! JSB COMITEM OR DIMITEM
         JEZ  JEZU89           ! MUST FIND >=1!
DIMCOM?  JSB  =GETCM?          ! GET POSSIBLE COMMA
         JEN  DIMCM1           ! JIF FOUND, ELSE DEMAND C
!
! THE FOLLOWING ROUINTE USED BY ANYONE NEEDING
! TO DEMAND CR OR ! AFTER THE LINE.
!
DMNDCR   CMB  R14,=15          ! CR? LINE DONE?
         JZR  DIMRTN           ! JIF YES, OK
         CMB  R14,=233         ! OR "!" TOKEN? IN-LINE REM?
         JZR  DIMRTN           ! JIF YES
!
         JSB  =ERROR+          ! EXCESS CHARS
         BYT  84D              ! 84d
!
COMITEM  CMB  R14,=177         ! INTEGER TOKEN?
         JZR  COMPU            ! JIF SO
         CMB  R14,=200         ! SHORT TOKEN?
         JZR  COMPU            ! JIF SO
         CMB  R14,=231         ! REAL TOKEN?
         JNZ  COMSNV           ! JIF NOT
COMPU    JSB  =PUSH1A          !
COMSNV   CLE                   ! PRESET NOT FOUND
         CMB  R14,=1           ! SIMPLE N.V.?
         JZR  PU45CL           ! JIF YES
DIMITEM  CLE                   ! PRESET "NOT FOUND"
         CMB  R#,=3            ! <STRINGID>?
         JNZ  TYPITM           ! JIF NO
         JSB  =PUSH45          ! PUSH NAME TO OUTPUT
         CMB  R#,=336          ! [ SYMBOL?
         JNZ  ERR91Z           ! YES, OKOR
NOER92   JSB  =SCAN            ! GET NEXT TOKEN
         JSB  =SMLINT          ! GET INTEGER
         CMB  R14,=337         ! ] FOUND?
         JNZ  ERR89U           ! NOPE, ERROR
         LDB  R14,=35          ! 1-DIM SUBSTRING
         JSB  =PUSH1A          ! PUSH, SCAN, SET E
DIMRTN   RTN                   ! DONE
!
NMVREL   CMB  R#,=1            ! SIMPLE NUMERIC?
         JNZ  TYPITM           ! JIF NO
PU45CL   JSB  =PUSH45          ! PUSH IT
         RTN                   ! DONE
!
TYPITM   CLE                   ! PRESET "NOT FOUND"
         CMB  R#,=2            ! ARRAY REFERENCE?
         JNZ  DIMRTN           ! NO, MAYBE STRING
         JSB  =PUSH45          ! PUSH NAME
         JSB  =SMLINT          ! GET FIRST DIMENSION
JEZU89   JEZ  ERR89U           ! JIF NOT FOUND
!
! NOW GET DIMENSIONS (1 OR 2)
!
         LDB  R36,=13          ! PRESET FOR ONE DIM
         JSB  =GETCM?          ! FIND SEPARATOR?
         JEZ  ONEDIMX          ! JIF NO
         JSB  =SMLINT          ! GET SECOND DIM
         ICB  R36              ! CHANGE TO 2 DIM
ONEDIMX  PUBD R36,+R12         ! PUSH THE DIM FLAG
         JSB  =GET)            ! GET RIGHT PAREN
         RTN                   ! DONE
!
ERR91Z   JSB  =ERROR+          ! MISSING PARAM
         BYT  91D              !
!
! *********************************************
! <TYPE-STMT>    ::= <TYPE-SPEC>
!                ::= <TYPE-SPEC> <NUM-VAR-LIST>
! <TYPE-SPEC>    ::= REAL / INTEGER / SHORT
! <NUM-VAR-LIST> ::= <NUM-VAR-ELEM>
!                ::= <NUM-VAR-ELEM> <NUM-VAR-LIST>
! <NUM-VAR-ELEM> ::= <SNV> / <FORMAL-ARRAY>
! *********************************************
!
TYPSTM   JSB  =PUSH1A          ! PUSH THE TYPE
         JSB  =NMVREL          ! GET NUM-VAR-ELEM
         JEZ  DMNDCR           ! JIF DONE
NMORE?   JSB  =GETCM?          ! FIND SEPARATOR?
         JEZ  DMNDCR           ! JIF NO (DONE)
         JSB  =NMVREL          ! DEAMND ONE
         JEN  NMORE?           !    AFTER COMMA
         JMP  ERR91Z           !
!
! *********************************************
! TRACE VARIABLE
! *********************************************
TRCVB    JSB  =PUSH1A          ! PUSH TOKEN
TRCVB-   JSB  =TRITEM          ! GET FIRST
         JEZ  ERR89U           ! MUST BE ONE
TRLOOP   JSB  =GETCM?          ! COMMA?
         JEZ  TRCRTN           ! JIF NO
PARPRM   JSB  =TRITEM          ! GET NEXT
         JMP  TRLOOP           ! AND LOOP
TRCRTN   RTN                   ! DONE
!
ERR88U   JSB  =ERROR+          ! BAD STMT
         BYT  88D              !
!
ERR89U   JSB  =ERROR+          ! INVALID PARAM
         BYT  89D              !
!
TRITEM   CLE                   ! SET NOT FOUND
         CMB  R14,=1           ! SNV?
         JZR  PU45CL           ! JIF NO
         CMB  R14,=3           ! STRING?
         JZR  PU45CL           ! JIF YES
         CMB  R14,=2           ! ARRAY?
         JNZ  ERR89U           ! JIF NO
         LDB  R14,=363         ! 1-DIM TOKEN
         CMB  R20,=54          ! COMMA?
         JNZ  ARRY1            ! JIF NO
         ICB  R14              ! 2-DIM TOKEN
         JSB  =GCHAR           ! NEXT CHAR
ARRY1    CMB  R20,=51          ! ")"? A() OR A(,) ELSE
         JNZ  ERR89U           ! JIF NO, ERROR
         JSB  =GCHAR           ! NEXT CHAR
         JMP  PU45CL           ! GO PUSH
!
! *********************************************
! <DEF-STMT>  ::= DEF FN<NUM-FUNC-HEAD'> = <NUM-VAL
!             ::= DEF FN<NUM-FUNC-HEAD'>
!             ::= DEF FN<STR-FUNC-HEAD'> = <STR-EXP
!             ::= DEF FN<STR-FUNC-HEAD'>
! NOTE: IN PUBLISHED SYNTAX, FN IS PART OF THE HEAD
! *********************************************
DEF      TSB  R16              ! CALC?
         JOD  ERR88U           ! ERROR IF YES
         JSB  =PUSH1A          ! PUSH OUT DEF, SCAN
         JSB  =FNNAME          ! GET NAME, TYPE
!
! R30 NOW CONTAINS TYPE:
!    0 (2) NUMERIC (WITH PARAMETERS)
!    1 (3) STRING  (WITH PARAMETERS)
!
JEZE89   JEZ  ERR89U           ! JIF NOT FOUND
         CMB  R30,=2           ! DO WE HAVE PARAMETERS?
         JNC  GET=             ! JIF NO
         CMB  R14,=1           ! NUMERIC PARAM?
         JNZ  STRPAR           ! JIF NO
         JSB  =PUSHNM          ! REFORMAT & PUSH NAME
         ADM  R12,=10,0        ! ADD 8 BYTES TO OUTPUT
         JMP  ENDPAR           ! FINISH UP PARAMS
!
STRPAR   CMB  R#,=3            ! STRING VARIABLE?
         JNZ  ERR89U           ! JIF NO
         JSB  =PUSHNM          ! REFORMAT & PUSH NAME
         LDM  R32,=22,0        ! DEFAULT STRING LENGTH
         CMB  R14,=336         ! "["? LENGTH GIVEN?
         JNZ  PUSHL$           ! JIF NO, DEFAULT
         JSB  =SCAN            ! GET LENGTH
         CMB  R#,=32           ! INTEGER?
         JNZ  ERR89U           ! JIF NO
         LDM  R65,R44          ! MOVE FOR BCDINT
         CMM  R65,=34C,2C,0C   ! (234 BCD) MAX IS 234+22=255
!
! NEED LENGTH CHECK SO WE DONT OVERFLOW R12
!
         JCY  ERR89U           ! JIF TOO BIG
         JSB  =BCDINT          ! CONVERT BCD TO BIN
         LDM  R32,R76          ! REPLACE DEFAULT LENGTH
         CMB  R20,=135         ! FIND ]?
         JNZ  ERR89U           ! JIF NO
         JSB  =SCAN+           ! SCAN PAST 32 AND ]
!
! NOW R32 CONTAINS CORRECT STRING LENGTH
!
PUSHL$   PUMD R32,+R12         ! PUSH TOTAL LENGTH
         PUMD R32,+R12         ! AND MAX LENGTH
         CLM  R36              !
         PUMD R36,+R12         !
         ADM  R32,R12          ! SAVE SPACE FOR LENGTH
         STM  R32,R12          ! SMALLER THAN ADM 12,32
ENDPAR   JSB  =GET)            ! GET CLOSE
GET=     CMB  R14,=65          ! IN LINE DEF?
         JNZ  DEFRTN           ! JIF NO
         TSB  R30              ! STRING OR NUMERIC?
         JOD  RIGHT$           ! JIF STRING
         JSB  =NUMVA+          ! SCAN, GET NUM VAL
         JMP  P.TAIL           ! GET TAIL
!
RIGHT$   JSB  =STREX+          ! SCAN, GET STR EXPR
P.TAIL   JEZ  JEZE89           ! JIF EXPR NOT FOUND
         LDM  R65,=352,0,0     ! PUSH STORE FN,
         PUMD R65,+R12         !   ADDR SPACE, FNEND
DEFRTN   JSB  =DMNDCR          ! DEMAND CR OR !
         RTN                   !   TO OUTPUT - DONE
!
PUSHNM   SBB  R45,=100         ! (ALFA-100)
         CMB  R44,=40          ! IS R44 A BLANK?
         JNZ  FIXNUM           ! JIF NO
         LDB  R44,=72          ! MAKE IT 12+60
FIXNUM   SBB  R44,=60          ! SUBTRACT OFFSET
         CMB  R14,=3           ! STRING TYPE?
         JNZ  PARIS#           ! JIF PARAM IS #
         ADB  R44,=200         ! ADD STRING FLAG
PARIS#   JSB  =PUSH44          ! PUSH AND SCAN
         RTN                   ! DONE
!
! *********************************************
! FUNCTION NAME SUBROUTINE
! NOW GET THE (FN) NAME - POSSIBILITIES ARE
!   TYPE   TOKEN          TYPE     TOKEN
!   FNA3=    1            FNA3(      2
!   FNA3$=   3            FNA3$(     3
! TOKEN IS 1,2, OR 3    FN IS NOT A KEY (1-8)
!
! FNNAME PUSHES THE NAME (A3) WITH 2 ZEROES
!   FOLLOWED BY A MARKER:
!      0 IF NUMERIC, NO PARAMS
!      1 IF NUMERIC, WITH PARAMS
!      2 IF NUMERIC, NO PARAMS
!      3 IF NUMERIC, WITH PARAMS
! *********************************************
FNNAM+   JSB  =SCAN            ! FOR FN CALLS
FNNAME   CLB  R30              ! CLEAR STRING FLAG
         LDB  R35,R14          ! SAVE TOKEN
         JSB  =PUSH44          ! PUSH NAME, SCAN
         CMB  R#,=4            ! FLOATING PT NR?
         JNZ  NOFLO            ! JIF NO
         POMD R50,-R12         ! GET THAT OFF STACK!
NOFLO    CLM  R36              ! SAVE ROOM FOR 2
         PUMD R36,+R12         !    BYTES OF PARAMS
         CLE                   ! UNDO WHAT SCAN DID
         DCB  R35              ! WAS IT A SNV?
         JZR  DEF.1            ! JIF YES, NUMERIC, NO PA
         DCB  R35              ! WITH PARAMS?
         JZR  DEF.2            ! JIF YES, STILL NUMERIC
         DCB  R35              ! STRING FUNCTION?
         JNZ  FNNRTN           ! JIF YES, STRING
!
! DO A SORT OF ERROR RETURN, E=0
!
         ICB  R30              ! SET STRING FLAG
         CMB  R14,=50          ! ( FOR PARAMS?
         JZR  FPARS            ! JIF YES
DEF.1    PUBD R30,+R12         ! PUSH PARAM FLAG (0)
         ICE                   ! SET FOUND FLAG
FNNRTN   RTN                   ! DONE
!
FPARS    JSB  =SCAN            ! GET PAST (
         CMB  R#,=4            ! REAL?
         JNZ  DEF.2            ! JIF NO
         POMD R50,-R12         ! GET NUM FROM STAK
DEF.2    ICB  R30              ! ADD 2 TO FLAG
         ICB  R30              ! FOR 1 PARAM
         JMP  DEF.1            ! GO PUSH FLAG
!
! *********************************************
! FUNCTION CALLS FNA(X), FNA$(X)
! Function calls must allow backup, since a string
! function call does not satisfy a NUMERIC-EXPR
! unless followed by a relational operator.  That
! is the reason for saving so much on the stack.
! The other peculuarity of function calls is that
! the function type must first be determined, and
! all parameters must be outputted BEFORE the func
! name is pushed.  The stuff down at NOPARF is for
! functions with and without parameters, and pushes
! out the function name postifx.
!
! Some additional comments 9-12-78:
! There is no such thing as an optional <STRING-EXPR
! but in the process of finding a <PRIMARY> it is
! reasonable to task if we have here a string FN or
! a numeric FN.  I'm not quite sure that we need
! backup here, but just in case it is included.
! Also note that FN$CAL is only called by STREXP
! which does a restore on R10, R20, and a RSTREG
! if not found.
! *********************************************
FNCALL   LDB  R32,=26          ! FLAG NUMERIC
         JMP  CALFF$           ! DO COMMON FN, FN$
!
FN$CAL   LDB  R32,=27          ! FLAG STRING
CALFF$   PUMD R40,+R6          ! SAVE R40
! SAVE PARSE STATE IN CASE WRONG FN TYPE
         LDM  R63,R10          ! SAVE 10-14
         STB  R20,R62          ! SAVE INPUT CHAR
         JSB  =FNNAM+          ! SCAN, PUSH NAME
         JEZ  RESTFN           ! JIF NOT FOUND, RESTORE
!
! IF R30 IS ODD, STRING FUNCTION FOUND
! IF R32 IS ODD, STRING FUNCTION WANTED
! SO R32 XOR R30 IS EVEN IF RIGHT TYPE FOUND
!
         LDB  R2,R30           ! MAKE COPY OF R30
         XRB  R2,R32           ! DO TYPES MATCH?
         JOD  RESTFN           ! JIF NO, RESTORE
         LDB  R62,R32          ! PUT 26 OR 27 IN R62
         POMD R63,-R12         ! GET NAME + JUNK
!
! R66 WILL CONTAIN PARAMETER COUNT
! R67 WILL CONTAIN PARAMETER FLAG
!
         CLB  R66              ! NO PARAMETERS YET
         CMB  R30,=2           ! 2,3: PARAMS, 0,1: NONE
         JNC  NOPARF           ! JIF NO PARAMS
         LDB  R67,=200         ! PRESET NUMERIC TYPE
         CMB  R14,=4           ! FLTG PT MESSED UP?
         JNZ  NOPOP4           ! JIF NO
         PUMD R50,+R12         ! PUSH NUMBER BACK
NOPOP4   PUMD R60,+R6          ! SVAE R60
         JSB  =NUMVAL          ! SCAN, GET NUMERIC
         POMD R60,-R6          ! RESTORE R60
         JEN  FIND)            ! JIF PARAM FOUND
         PUMD R60,+R6          ! STSAVE R60
         JSB  =STREXP          ! GET STRING EXP
         POMD R60,-R6          ! RESTORE R60
         ICB  R67              ! CHANGE TO STRING
         JEZ  ERR91X           ! JIF NOT FOUND
FIND)    JSB  =GET)            ! GET CLOSE
         ICB  R66              ! INC PARAM COUNT
NOPARF   PUMD R62,+R12         ! ADD 26 OR 27
         POMD R65,-R12         ! TRASH LAST 3 BYTES
         PUBD R66,+R12         ! PUSH OUT PAR COUNT
         JZR  NOPAR1           ! JIF ZERO PARAMS
         PUBD R67,+R12         ! PUSH OUT PAR FLAG
NOPAR1   CLE                   ! SET FOUND FLAG
         ICE                   !
         POMD R60,-R6          ! RESTORE R12 (DONT KILL
         RTN                   ! DONE WITH FNCALLS
!
ERR91X   JSB  =ERROR           ! FN PARAM MISMATCH
         BYT  91D              ! FALL THROUGH TO RESTORE
!
RESTFN   CLE                   ! FLAG NOT FOUND
         LDB  R20,R62          ! RESTORE NEXT CHAR
         STM  R63,R10          ! RESTORE 10-14
         POMD R40,-R6          ! RESTORE R40
         RTN                   ! DONE
!
! *********************************************
! INPUT STATEMENT PARSE
! <INPUT-STATEMENT> = INPUT <VARIABLE-LIST>
! <VARIABLE-LIST> = <VARIABLE / <VARIABLE> , <VARIABLE-LIST>
! ANSII STANDARD BASIC REQUIRES THAT ALL INPUT BE
! CHECKED FOR ERRORS BEFORE STORING ANYTHING,
! SO ITEMS ARE STACKED BY USING JSB =VRFND AFTER
! EACH ITEM, THEN A SERIES OF STORE STRING AND
! STORE NUMERIC TOKENS IS OUTPUT.
! *********************************************
INPUT    JSB  =PUSH1A          ! PUSH INPUT TOKEN
VLIST    JSB  =STRREF          ! GET REF STRING VRBL IF
         JEZ  NUMRF?           ! JIF NOT FOUND
         LDM  R36,=351,7       ! INPUT STRING, STORE
         PUMD R36,+R12         !   TO OUTPUT
         JMP  VRFND            !
NUMRF?   JSB  =REFNUM          ! GET NUMERIC REF IF ANY
         JEZ  JEZF89           ! OOPS, NO VARIABLES
         LDM  R36,=350,10      ! INPUT NUMERIC, STORE
         PUMD R36,+R12         !   TO OUTPUT
VRFND    JSB  =GETCM?          ! MORE TO COME?
         JEN  VLIST            ! LOOP IF SO
! TO GET PAST THIS POINT, E MUST BE 0
         ICE                   ! FLAG FOUND
         RTN                   ! DONE
!
! *********************************************
! DATA STATEMENT PARSE
! *********************************************
DATA     PUBD R14,+R12         ! PUSH DATA TOKEN
DATLST   PUMD R10,+R6          ! SAVE CURRENT R10
         PUBD R20,+R6          ! ALSO SAVE CHAR
         JSB  =SCAN            ! SCAN
         JSB  =NUMREP          ! SEE IF +,- NUMERIC
         JEN  DATCOM           ! JIF YES
         JSB  =STRCON          ! CIF QUOTED STRING
         JEN  DATCOM           ! JIF FOUND
         CMB  R14,=15          !
         JZR  DATCOM           ! JIF CR
         POBD R20,-R6          ! RESTORE CHAR
         POMD R10,-R6          ! RESTORE R10
         JSB  =REMS-           ! GET UNQUOTED STR
         JMP  DATCM1           !
!
DATCOM   POMD R75,-R6          ! TRASH OLD R10, R20
DATCM1   CMB  R14,=54          ! FIND COMMA?
         JZR  DATLST           ! LOOP IF YES
         JSB  =DMNDCR          ! DEMAND CR OR !
         RTN                   ! DONE
!
RESTOR   PUBD R14,+R12         ! RESTORE LINE# TOKEN
         LDB  R14,=334         ! PUSH TOKEN
GETLN    JSB  =SEQNO+          ! GET SEQ NO
         JEN  RSTEX            ! JIF FOUND
         DCM  R12              ! ELSE TRASH TOKEN
RSTEX    RTN                   !
!
! *********************************************
! READ, READ# PARSE
! *********************************************
READ     JSB  =PUSH1A          ! PUSH READ TOKEN
REDLST   JSB  =REDITM          ! GET NEXT ITEM
JEZF89   JEZ  ERR89X           ! JIF YES, NULL
         JSB  =GETCM?          ! COMMA THERE?
         JEN  REDLST           ! JIF YES
         RTN                   ! DONE IF NO COMMA
!
RD#ITM   JSB  =FORMAR          ! FIND <FORMAL-ARRAY>
         LDB  R34,=44          ! PUSH READ ARRAY TOKEN
         JEN  PUSHRD           !   IF FOUND
REDITM   JSB  =STRREF          ! STRING REF? (E::=0)
         LDB  R22,=353         ! GET STRING READ TOKEN
         JEN  PUSHRD           ! JIF STRING
         JSB  =REFNUM          ! GET NUMERIC
         JEZ  REDRTN           ! JIF NOT FOUND
         LDB  R22,=346         ! GET NUMERIC READ TOKEN
PUSHRD   PUBD R#,+R12          ! PUSH TOKEN
REDRTN   RTN                   ! ALL DONE
!
READ#    JSB  =G1OR2N          ! 1 OR 2 PARAMS
         CMB  R14,=47          ! SEMI SEPARATOR?
         JZR  GOTSMI           ! JIF YES
DEMND2   CMB  R34,=2           ! NO SEMI, THEN DEMAND 2
         JNZ  ERR89X           ! WRONG NUMBER OF PARAMS
         RTN                   ! POSITION TAPE ONLY
! SEMI SEEN, GET <READ#-LIST>
GOTSMI   JSB  =PUSH1A          ! PUSH AND SCAN
RD#LST   JSB  =RD#ITM          ! GET <READ#-ITEM>
         JEZ  ERR89X           ! JIF NOT FOUND
         JSB  =GETCM?          ! MORE TO BE FOUND?
         JEN  RD#LST           ! JIF YES, GO GET IT!
         RTN                   ! DONE
!
FORMAR   CLE                   ! <FORMAL-ARRAY>
         CMB  R14,=2           ! ARRAY VARIABLE?
         JNZ  FRMRTN           ! JIF NO
         CMB  R20,=51          ! A()?
         JNZ  AWITH2           ! JIF NO
         LDB  R14,=363         ! READ# ONE DIM
PUSHR#   JSB  =GCHAR           ! GET PAST )
         JSB  =PUSH45          ! PUSH NAME, TOKEN
FRMRTN   RTN                   ! E IS NOW 1
!
AWITH2   CMB  R20,=54          ! A(,)?
         JNZ  FRMRTN           ! JIF NO, DONE
         JSB  =GCHAR           ! GET PAST COMMA
         LDB  R14,=364         ! READ# TWO DIMS TOKEN
! SCANNER SURE TO FIND COMMA, SO THROW AWAY
         CMB  R20,=51          ! FINAL )?
         JZR  PUSHR#           ! PUSH IF FOUND
!
ERR89X   JSB  =ERROR+          ! INVALID PARAM
         BYT  89D              !
!
! *********************************************
! PRINT, PRINT USING, PRINT# PARSE
! *********************************************
PRINT#   JSB  =G1OR2N          ! 1 OR 2 PARAMS
         CMB  R14,=47          ! SEMI SEPARATOR?
         JNZ  DEMND2           ! JIF NO SEMI, NEED 2
         STBD R14,=USING?      ! SET USING TO FORCE
         JSB  =PUSH1A          ! PUSH AND SCAN
         LDB  R32,=377         ! FLAG FOR PLIST
         JMP  PLIST            ! GET <PRINT#-LIST>
!
PRINT    JSB  =PUSH1A          ! PUSH TOKEN TO OUTPUT
         CLB  R32              ! FLAG PLAIN PRINT
         CMB  R14,=313         ! PRINT USING?
         JNZ  PLIST            ! JIF NO
         STB  R14,R36          ! SAVE USING TOK
         LDB  R14,=347         ! USING LINE# TOKEN
         JSB  =GETLN           ! PUSH, GET LINE NUMBER
         JEN  USEX1            ! JIF FOUND LINE#
         JSB  =STREXP          ! GET IN-LINE USING
         JEZ  ERR89X           ! JIF NOT THERE
         PUBD R36,+R12         ! PUSH USING
USEX1    ICB  R32              ! FLAG PRINT USING
         CMB  R14,=47          ! IS THERE A PLIST?
         JNZ  EOPRT+           ! JIF NO, DONE
         JSB  =PUSH1A          ! PUSH AND SCAN
!
! PRINT USING FALLS THROUGH TO <PRINT-LIST>
!
! *********************************************
! <PRINT-LIST> = <PRINT-ITEM> /
! 	/<PRINT-ITEM><PRINT-SEP><PRINT-LIST>
!
! REGISTER DEFINITIONS:
!   PRINT #      R32 = -1
!   PRINT USING  R32 =  1
!   PRINT        R32 =  0
!   STRING       R33 =  0 (MOST COMMON, SO DEFAULT)
!   NUMERIC      R33 =  1
!   FORPAR FLAG  R34
!   SEP SEEN?    R35
! *********************************************
PLIST    CLB  R35              ! NO SEPARATOR SEEN
PLIST+   CLB  R33              ! PRESET NUMERIC
         TSB  R32              ! PRINT#, PRINT USING?
         JZR  GETFUN           ! JIF PLAIN PRINT
         JPS  NOARRY           ! JIF PRINT USING
! FALL THROUGH TO PRINT# (ALLOW <FORMAL-ARRAY>)
         JSB  =FORMAR          ! GET <FORMAL-ARRAY>
         JEZ  NOARRY           ! JIF NOT FOUND
         LDB  R36,=42          ! PUSH PRINT ARRAY TOKEN
         CMB  R14,=47          ! PRINT# ; ?
         JZR  DELIM+           ! JIF YES, MAKE COMMA
         JMP  PRCOM?           ! PUSH AND MAYBE SCAN
!
GETFUN   CMB  R47,=45          ! PRINT FUNCTION?
         JZR  TABCAL           ! JIF YES
NOARRY   JSB  =NUMVAL          ! <NUMERIC-VALUE>?
         JEZ  PSTRIN           ! JIF NO
         ICB  R33              ! FLAG NUMERIC
         JMP  PRISEP           ! NOW DO SEPARATOR
!
PSTRIN   JSB  =STREXP          ! <STRING-EXP>?
! ON RETURN, IF E=0, ELEMENT WAS <EMPTY>
PRISEP   LDB  R36,=357         ! PUT "," TOKEN IN R36
         SBB  R36,R33          ! SUBTRACT 2
         SBB  R36,R33          !   IF NUMERIC
         CMB  R14,=47          ! <PRINT-SEP> = ";"?
         JZR  DELIM-           ! JIF YES
         ICB  R36              ! CHANGE R36 TO COMMA
PRCOM?   CMB  R14,=54          ! <PRINT-SEP> = ","?
         JZR  DELIM            ! JIF YES
         JEZ  EOPRT            ! JIF NO ITEM SEEN
         PUBD R36,+R12         ! PUSH COMMA TOKEN
         JMP  EOPRT+           ! NO SEP CHECKING
!
EOPRT    TSB  R32              ! USING?
         JNZ  EOPRT+           ! FORCE EOL FOR USING
         TSB  R35              ! ANY SEPARATORS SEEN?
         JNZ  PLEND            ! JIF YES, NO EOL
EOPRT+   LDB  R36,=354         ! TERMINATE LINE
         PUBD R36,+R12         ! PUSH EOL TOKEN
PLEND    RTN                   ! AND RETURN
!
DELIM-   TSB  R32              ! PRINT# ??
         JPS  DELIM            ! JIF NO
         ICB  R36              ! MAKE COMMA TOKEN
DELIM    JEN  DELIM+           ! JIF ITEM SEEN
         LDM  R30,=6,0         ! EMPTY UNQUOTED STRING
         PUMD R30,+R12         !   TO OUTPUT
DELIM+   JSB  =PU36SC          ! FOUND ONE, PUSH IT
         LDB  R35,=1           ! SET DELIMITER SEEN
         JMP  PLIST+           ! ITERATE <PRINT-LIST>
!
TABCAL   JSB  =FUN1            ! GET FUNCTION
         CLE                   ! FORCE NULL STRING
         JMP  PRISEP           ! DONE
!
! IMAGE - (SEE REM)
!
! *********************************************
! LET STATEMENT 11-1-76
! <LET-STATEMENT> =
!   LET? <STRING-REFERENCE> = <STRING-EXPRESSION>
!  /LET? <NUMERIC-VARIABLE> < , <NUMERIC-VARIABLE>
!             = <NUMERIC-VALUE>
! *********************************************
ILET     LDB  R14,R43          ! RESTORE VARIABLE TYPE
         JMP  ILET++           ! SKIP PUSH
LET      JSB  =PUSH1A          ! PUSH LET TO OUTPUT
ILET++   JSB  =STRREF          ! GET <STRING-REFERENCE>
         LDB  R34,=7           ! DEFAULT STORE STRING
         JEN  STRLET           ! FOUND, CHECK FOR MULTIL
         JSB  =REFNUM          ! TRY <NUMERIC-VARIABLE>
         LDB  R34,=10          ! DEFAULT STORE NUM
         JEZ  ERR92Z           ! JIF NOTHING FOUND
NUMLET   CMB  R14,=54          ! , <NUMVAR>?
         JNZ  RTHLF#           ! NO, GET RIGHT
         LDB  R34,=24          ! MULTI STORE NUM
         JSB  =SCAN            !
         JSB  =REFNUM          ! GET NEXT
         JEZ  ERR92Z           ! JIF NONE FOUND
         JSB  =NUMLET          ! RECURS TO KEEP TRACK
!
! NOW PUSH OUT 7 OR 10 AND RETURN TO PARSER, OR
!     PUSH OUT 24 OR 25 AND RETURN TO NUMLET
!
ENDSNV   PUBD R34,+R12         ! TO OUTPUT
         RTN                   !
!
! RETURN TO PARSER EXCEPT MULTI STORES
!
RTHLF#   CMB  R14,=65          ! EQUALS
         JNZ  ERR92Z           ! JIF NOT FOUND
         JSB  =NUMVA+          ! SCAN, GET NUMERIC VALUE
         JEN  ENDSNV           ! JIF NO FOUND
         JMP  ERR92Z           !
!
STRLET   CMB  R14,=54          ! COMMA (, <STRREF>?)
         JNZ  RTHLF$           ! NO, GET RIGHT HALF
         LDB  R34,=25          ! MULTI STORE STR
         JSB  =SCAN            !
         JSB  =STRREF          ! GET <STRING-REF>
         JEZ  ERR92Z           ! JIF NONE FOUND
         JSB  =STRLET          ! RECURS FOR MULTI
ENDSTR   PUBD R34,+R12         ! STORE STRING TO OUTPUT
         RTN                   ! DONE
!
! *********************************************
! FUNCTION LET
! *********************************************
FNLET    JSB  =PUSH1A          ! PUSH THE FNLET TOKEN
         LDB  R34,=10          ! DEFAULT TO NUMERIC
         CMB  R14,=1           ! S.N.V.?
         JZR  PUSHFN           ! JIF YES
         CMB  R14,=3           ! STRING?
         JNZ  ERR92Z           ! JIF NO
         DCB  R34              ! CHANGE FLAG TO 7
PUSHFN   JSB  =PUSH45          ! PUSH TOKEN, NAME
         TSB  R34              ! STRING OR NUMERIC FN?
         JEV  RTHLF#           ! JIF NUMERIC
RTHLF$   CMB  R14,=65          ! =?
         JNZ  ERR92Z           ! JIF NO
! TRY AND SALVAGE AN EXPRESSION
FND=S    JSB  =STREX+          ! SCAN, GET STRING EXP
         JEN  ENDSTR           ! JIF FOUND OK
!
ERR92Z   JSB  =ERROR+          ! SYNTAX
         BYT  92D              !
!
! *********************************************
! REF STRING, ARITH VRBL; GOTO, GOSUB
! *********************************************
REFNUM   CMB  R14,=3           ! (1 OR 2)-3=NC (>2)-3=CY
         JCY  NORTN            ! JIF NOT THERE
         ADB  R14,=20          ! CHANGE TO REF
         JOD  PSSH45           ! JIF NOT ARRAY
         JSB  =PUSH45          ! PUSH OUT THE VRBL
! CAPASM: renamed LCL SUBSCR to SBSCR
         JSB  =SBSCR           ! DO SUBSCRIPT
         DCB  R36              ! CHANGE TO REF
         DCB  R36              !
         PUBD R36,+R12         ! PUSH IT OUT
         RTN                   ! DONE
!
NUMVAR   CMB  R34,=3           ! SNV OR SAV?
         JCY  NORTN            ! JIF NO, DONE
         JEV  GETSAV           ! JIF ARRAY VARIABLE
PSSH45   JSB  =PUSH45          ! PUSH 14,44,45
NORTN    RTN                   ! DONE
!
GETSAV   JSB  =NUMVRB          ! DO SAME AS IN PARSER
         RTN                   ! DONE
!
! *********************************************
! IF STATEMENT 11-24-76
! <IF STATEMENT> = IF <LOGICAL-EXPRESSION>
!   THEN <THEN-PART> <ELSE <ELSE-PART>>?
! <THEN-PART> = <SEQUENCE-NUMBER>/<STATEMENT>
! <ELSE-PART> = <SEQUENCE-NUMBER>/<STATEMENT>
! *********************************************
IF       JSB  =NUMVA+          ! GET NUMERIC VALUE
         JEZ  ERR92X           ! JIF NOT FOUND
! NOW GET <THEN-PART>
         CMB  R14,=314         ! THEN?
         JNZ  ERR92X           ! NO THEN
         JSB  =DIGIT           ! IS NEXT A LINE#?
         JEN  THENSN           ! JIF YES
!
! GET LINE# IF PRESENT, DONT SCAN BECAUSE OF POSSIB
! CALL TO PARSIT.
! DO WE HAVE IF <RELEXP> THEN <SEQ-NUM>
!   OR IS IT IF <RELEXP> THEN <STATEMENT>?
! PROCESS THEN <STATEMENT>
! STATEMENT MUST BE <LEGAL-AFTER-THEN>
!
THENST   LDB  R36,=33          ! JPSREL TOKEN
         PUBD R36,+R12         !   TO OUTPUT
         STMD R12,=THENFL      ! SAVE 12, SET FLAG
! PARSER WILL NOW CHECK FOR "IMPERITIVE" STMT
         ICM  R12              ! SAVE ROOM FOR OFFSET
         ICM  R12              !   (ADD 2 TO R12)
         JSB  =PARSIT          ! PARSE THE WHOLE LINE
         CMB  R14,=327         ! ELSE?
         JZR  STELSE           ! JIF FOUND
ENDTHN   LDMD R34,=THENFL      ! GET POINTER
         JSB  =FIXUPJ          ! FIX UP POINTERS
CLTHNF   CLM  R36              ! CLEAR THEN FLAG
         STMD R36,=THENFL      !
IFRTN    JSB  =DMNDCR          ! DEMAND CR OR !
         RTN                   !
!
! IF ELSE FOUND, NEED JMP TO END
!
STELSE   LDB  R36,=34          ! JUMPREL TOKEN
         PUBD R36,+R12         !  TO OUTPUT
         LDMD R34,=THENFL      ! GET REL ADR LOCATION
         STMD R12,=THENFL      ! SET THENFL FOR ELSE
         ICM  R12              ! SAVE ROOM FOR JUMP
         ICM  R12              !   (TWO BYTES)
         JSB  =FIXUPJ          ! FIX UP THEN'S JUMP
         JSB  =DIGIT           ! SCAN OVER ELSE
         JEN  ELSESN           ! JIF LINE#
         JSB  =PARSIT          ! PARSE THE LINE
         JMP  ENDTHN           ! FIX POINTERS
!
FIXUPJ   LDM  R36,R34          ! COPY TO 36 (SAVE 34)
         SBM  R36,R12          ! GET RELATIVE JUMP
         TCM  R36              ! IN POSITIVE
         STMD R36,R34          ! PUT BACK WHERE IT BELONGS
         RTN                   ! DONE
!
! <THEN-PART> = <SEQUENCE-NUMBER>
!
THENSN   LDB  R36,=30          ! JTRUE# TOKEN
         PUBD R36,+R12         !   TO OUTPUT
         JSB  =SEQNO           ! GET SEQUENCE NUMBER
         CMB  R14,=327         ! ELSE?
         JNZ  IFRTN            ! JIF NO ELSE
         JSB  =DIGIT           ! LINE#?
         JEZ  SNELST           ! JIF NO
         LDB  R14,=37          ! ELSJM# TOKEN
         JSB  =GOTOSU          ! DO GOTO
         JMP  CLTHNF           ! FINISH UP
!
ERR92X   JSB  =ERROR+          ! MISSING RELATIONAL OP
         BYT  92D              !
!
SNELST   LDM  R75,=34,2,0      ! DUMMY JMPREL "0"
         PUMD R75,+R12         ! FOR DECOMPILER
         STMD R12,=THENFL      ! SET THEN FLAG
         JSB  =PARSIT          ! GET STATEMENT(S)
         JMP  CLTHNF           ! CLEAR THEN AND EXIT
ELSESN   LDB  R14,=37          ! ELSJM# TOKEN
         JSB  =GOTOSU          ! DO THE JMP
         JMP  ENDTHN           ! FIX UP POINTER
!
! *********************************************
! FOR NEXT STATEMENTS 03-01-77
!
! SOURCE MCOMPS OUTPUT M2
!
! *********************************************
FOR      JSB  =PUSH1A          ! PUSH TOKEN, SCAN
         CMB  R#,=1            ! SEE IF SNV
         JNZ  ERR92X           ! JIF NO
         JSB  =REFNUM          ! CHANGE TO 21, PUSH
         CMB  R#,=65           ! SEE = SIGN?
         JNZ  ERR92X           ! JIF NO
         LDB  R14,=10          ! SO GET1N PUSHES STORE
         JSB  =GET1N           ! SCAN, GET EXP, PUSH STORE
         CMB  R14,=244         ! TO TOKEN?
         JNZ  ERR92X           ! JIF NOT FOUND
         JSB  =GET1N           ! SCAN, GET EXP, PUSH TO
         CMB  R14,=316         ! STEP FOUND?
         JNZ  CALEOL           ! JIF DEFAULT 1
         JSB  =GET1N           ! SCAN, GET EXP, PUSH STEP
CALEOL   RTN                   ! EXIT
!
NEXT     STB  R14,R36          ! SAVE 'NEXT' TOKEN
         JSB  =SCAN            ! SCAN
         CMB  R#,=1            ! SEE IF SNV
         JNZ  ERR92X           ! JIF NO
         JSB  =REFNUM          ! CHANGE TO 21, PUSH
         PUBD R36,+R12         ! STORE 'NEXT' TOKEN
         RTN                   ! DONE
!
! *********************************************
! ON GOTO/GOSUB STATEMENT 01-12-77
! *********************************************
ON       STB  R14,R36          ! SAVE ON TOKEN
         JSB  =NUMVA+          ! GET EXPRESSION
         PUBD R36,+R12         ! PUSH ON TOKEN
         JEZ  ERR92X           ! JIF EXPRESSION NOT FOUND
         CMB  R14,=132         ! ON ... GO? (GOTO TOKEN?)
         JZR  ONLOOP           ! JIF GOTO
         CMB  R14,=133         ! ON ... GOSUB? (GOSUB TOKEN?)
         JNZ  ERR92X           ! JIF MISSING GO
ONLOOP   STB  R#,R36           ! SAVE GOTO/GOSUB TOKEN
ONLOP    LDB  R#,R36           ! GET GOTO/GOSUB TOKEN
         JSB  =GOTOSU          ! GET LINE# AND PUSH
         CMB  R14,=54          ! CHECK FOR COMMA
         JZR  ONLOP            ! JIF FOUND - LOOP
         RTN                   ! DONE
!
! *********************************************
! SEQUENCE NUMBERS, GOTO, GOSUB
! *********************************************
GOTOSU   CMB  R16,=1           ! CALC MODE?
         JZR  ERR88Z           ! JIF YES, ERROR
         JSB  =SEQNO+          ! PUSH, GET LINE#
         JEZ  ERR92X           ! JIF NO LINE#
         RTN                   !
!
ERR88Z   JSB  =ERROR+          ! BAD STMT
         BYT  88D              !
!
SEQNO+   PUBD R14,+R12         ! PUSH THE INCOMING TOKEN
SEQNO    JSB  =SEQ#            ! SCAN, GET VALID SEQ#
         JEZ  SEQRTN           ! JIF NONE
         JSB  =PUSH44          ! PUSH IT
SEQRTN   RTN                   !
!
SEQ#+    STB  R14,R36          ! SAVE INPUT R14
SEQ#     JSB  =SCAN            ! NEXT TOKEN
SEQ#?    ICE                   ! PRESET 'FOUND'
         CMB  R14,=32          ! INTEGER?
         JNZ  HOLN             ! JIF NO, FAIL
         TSB  R46              ! 4 DIGITS?
         JNZ  ERR90X           ! ERROR - TOO BIG
         CLM  R46              ! KILL CLASS FOR TSM
         TSM  R44              ! LINE# == 0?
         JZR  ERR89T           ! JIF YES, NOT ACCEPTABLE
         RTN                   !
!
ERR90X   JSB  =ERROR+          ! LINE# > 9999
         BYT  90D              !
!
HOLN     CLE                   ! LINE# NOT FOUND
         RTN                   !
!
! *********************************************
! AUTO LINE NUMBER AND RENUMBER
! LSB OF AUTOI IS CLEARED BY ALLOCATOR IF AN ERRO
! *********************************************
         BYT  141              !
AUTO.    JSB  =AUTOX           ! GET AND SAVE OPTIONAL/DEFAULT ARGS
         JSB  =ST240+          !
         STM  R30,R36          ! MOVE LINE# FOR PUTAUT
         LDM  R30,=INPBUF      ! START FOR PUTAUT
         JSB  =PUTAUT          ! PUSH LINE#
         RTN                   ! DONE
!
AUTOX    JSB  =TO?I            ! GET START# AND INC
         LDM  R30,=10C,0C      ! SET DEFAULTS
         STM  R30,R32          !
         JEZ  AUTOS            ! JIF NO ARGS, SAVE DEFAULTS
         LDM  R30,R45          ! GET STARTING LINE#
         JZR  AUTERR           ! JIF ==0, ERROR
         DCE                   ! ONLY 1 ARG?  NO INC VAL?
         JEZ  AUTOS            ! JIF NO INC
         LDM  R32,R55          ! GET INCREMENT VALUE
         JZR  AUTERR           ! JIF ==0, ERROR
AUTOS    LDM  R44,R30          ! COPY START AND INC VALUES
         STMD R44,=AUTO#       ! SET AUTO PARAMETERS
         RTN                   ! DONE
!
AUTERR   BIN                   !
         DCM  R6               ! TRASH 1 RETURN
         DCM  R6               !
!
ERR89T   JSB  =ERROR+          !
         BYT  89D              ! ERROR 89: INVALID PARAM
!
! *********************************************
! RENUMBER
! When a program is in the DEALLOCATED mode,
! line# references are literally stored in the code
! as LINE NUMBER VALUES.  When in ALLOCATED mode,
! line#s ONLY exist at the beginning of each line,
! and all REFERENCES to line numbers (GOTO/GOSUB, etc)
! have been converted to pointers to the line being
! referenced.  That's why RENUMBER forces the program
! to be ALLOCATED: it makes renumbering MUCH easier,
! as you only have to iterate through changing the
! line#s at the start of each line, and you don't
! have to worry about all the line# REFERENCES, which
! will automatically get set to the new line numbering
! scheme when the program is next DE-allocated.
! *********************************************
         BYT  141              !
RENUM.   JSB  =AUTOX           ! GET AND SAVE OPTIONAL/DEFAULT ARGS
         JSB  =INIPGM          ! GET LENGTH, 10000
         JSB  =ST240+          ! CLB R16, SET STSIZE, TOS
         JSB  =TSTALO          ! CIF ALLOCATED
         JEN  RAGAIN           ! JIF ALLOCATED
         JSB  =ALLOC           ! MAYBE SUBSET LATER
         JEN  FINREN           ! ALLOC ERROR, DONT REN!!!
         JSB  =INIVAR          ! INITIALIZE VARIABLES
RAGAIN   BIN                   !
         LDMD R36,=FWCURR      ! GET PROGRAM ADDR
         ADM  R36,=P.GO        ! ADD OFFSET
         CLM  R76              ! FIRST TIME AUTOI
         JMP  STOL             ! STORE FIRST LINE#
!
! *********************************************
! THIS ROUTINE RETURNS THE ALLOCATION FLAG IN E.
! NOTE: MODE IS SET TO BCD.
! *********************************************
TSTALO   LDMD R56,=FWCURR      !
         LDBD R67,X56,P.TYPE   ! GET PROGRAM TYPE
         ANM  R67,=40          ! KEEP ONLY ALLOCATION BIT
         BCD                   !
         ELB  R67              ! RETURN E==0 IF NOT ALLOCATED, ELSE E!=0
         RTN                   !
!
DONXT    JSB  =SKPLN           ! SKIP TO NEXT LINE
         LDMD R76,=AUTOI       ! INCREMENTCMM
STOL     LDMD R46,R36          ! CURRENT OLD LINE
         BCD                   !
!
! EVERY BASIC PROGRAM, EVEN AFTER A 'SCRATCH', HAS
! A LINE NUMBERED A999 (IE, THE MS BCD DIGIT IS AN
! ILLEGAL BCD VALUE, A HEX VALUE OF 'A', WHICH MAKES
! THIS LINE *ALWAYS* THE *LAST* LINE IN THE PROGRAM.
! THE LINE IS SIMPLY AN 'END' STATEMENT.  THIS LINE
! IS NEVER DECOMPILED, SO IT IS 'INVISIBLE' TO THE
! USER, BUT IT KEEPS THE PROGRAM FROM "RUNNING OFF THE END"
! WITHOUT THE SYSTEM HAVING TO HAVE CODE IN THE INTERPRETER
! LOOP TO CHECK IF IT'S REACHED THE END OF THE PROGRAM
! (IN CASE THE USER DIDN'T PUT AN 'END' STATEMENT AT
! THE END.
!
         CMM  R46,=231,251     ! DONE? BCD LINE# OF A999 (INVISIBLE "END" IN CASE NO END AT END OF PGRM)
         JCY  FINREN           ! JIF YES
         LDMD R56,=AUTO#       ! NEW LINE#
         ADM  R56,R76          ! NEXT NEW LINE#
         JCY  RENUMR           ! JIF > 9999
         STMD R56,R36          ! STORE IT
         STMD R56,=AUTO#       !
         JMP  DONXT            ! AND LOOP
!
FINREN   CLM  R76              ! KILL AUTO MODE
         STMD R76,=AUTOI       ! AUTO-ACTIVE FLAG
RENRTN   RTN                   ! DONE
!
RENUMR   CLM  R#               ! (R76)
         ICM  R#               !
         STMD R#,=AUTOI        ! RENUM WITH 1,1
         STMD R#,=AUTO#        !
!
         JSB  =WARN            ! LINE# > 9999
         BYT  132              !
!
         JSB  =SET240          !
         JMP  RAGAIN           !
!
ROMFX    TSB  R42              ! ROM?
         JNZ  GETNXP           ! JIF NO
         STBD R41,=RSELEC      ! SELECT CORRECT ROM
GETNXP   RTN                   ! DONE
!
         BYT  0                ! ONE UNUSED BYTE IN THE ROM
         BYT  61,33,133,31     ! 4 BYTES OF ROM CHECKSUM
         FIN
